/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/async","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","fs","vs/platform/telemetry/common/telemetry","os","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/base/common/errorMessage","vs/base/common/iterator","vs/base/common/json","vs/base/common/performance","vs/editor/common/core/range","vs/base/parts/ipc/common/ipc","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/contextkey/common/contextkey","vs/platform/product/common/product","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","path","net","vs/editor/common/core/position","vs/base/common/glob","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","https","http","vs/server/node/server.main"],ke=function(le){for(var e=[],i=0,A=le.length;i<A;i++)e[i]=Ee[le[i]];return e};define(Ee[95],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class i{static get(){const S=new Map,D=new Map,C=new Map,k=new Map;function v(m,d){m.has(d.detail)||m.set(d.detail,-d.timestamp)}function $(m,d){const c=m.get(d.detail);c&&(c>=0||m.set(d.detail,c+d.timestamp))}let E=[];typeof le=="function"&&typeof le.getStats=="function"&&(E=le.getStats().slice(0).sort((m,d)=>m.timestamp-d.timestamp));for(const m of E)switch(m.type){case 10:v(S,m);break;case 11:case 12:$(S,m);break;case 21:v(D,m);break;case 22:$(D,m);break;case 33:v(C,m);break;case 34:$(C,m);break;case 31:v(k,m);break;case 32:$(k,m);break}let y=0;C.forEach(m=>y+=m);function w(m){const d=[];return m.forEach((c,g)=>d.push([g,c])),d}return{amdLoad:w(S),amdInvoke:w(D),nodeRequire:w(C),nodeEval:w(k),nodeRequireTotal:y}}static toMarkdownTable(S,D){let C="";const k=[];return S.forEach((v,$)=>{k[$]=v.length}),D.forEach(v=>{v.forEach(($,E)=>{typeof $>"u"&&($=v[E]="-");const y=$.toString().length;k[E]=Math.max(y,k[E])})}),S.forEach((v,$)=>{C+=`| ${v+" ".repeat(k[$]-v.toString().length)} `}),C+=`|
`,S.forEach((v,$)=>{C+=`| ${"-".repeat(k[$])} `}),C+=`|
`,D.forEach(v=>{v.forEach(($,E)=>{typeof $<"u"&&(C+=`| ${$+" ".repeat(k[E]-$.toString().length)} `)}),C+=`|
`}),C}}e.$U=i}),define(Ee[144],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=i,e.$gb=A,e.$hb=S,e.$ib=D,e.$jb=C,e.$kb=k,e.$lb=v,e.$nb=E,e.$ob=y,e.$pb=w,e.$qb=m,e.$rb=d;function i(c,g,u){const p=A(c,g);if(p!==-1)return c[p]}function A(c,g,u=c.length-1){for(let p=u;p>=0;p--){const f=c[p];if(g(f))return p}return-1}function S(c,g){const u=D(c,g);return u===-1?void 0:c[u]}function D(c,g,u=0,p=c.length){let f=u,h=p;for(;f<h;){const l=Math.floor((f+h)/2);g(c[l])?f=l+1:h=l}return f-1}function C(c,g){const u=k(c,g);return u===c.length?void 0:c[u]}function k(c,g,u=0,p=c.length){let f=u,h=p;for(;f<h;){const l=Math.floor((f+h)/2);g(c[l])?h=l:f=l+1}return f}function v(c,g,u=0,p=c.length){const f=k(c,g,u,p);return f===c.length?-1:f}class ${static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if($.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!g(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const u=D(this.e,g,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=$;function E(c,g){if(c.length===0)return;let u=c[0];for(let p=1;p<c.length;p++){const f=c[p];g(f,u)>0&&(u=f)}return u}function y(c,g){if(c.length===0)return;let u=c[0];for(let p=1;p<c.length;p++){const f=c[p];g(f,u)>=0&&(u=f)}return u}function w(c,g){return E(c,(u,p)=>-g(u,p))}function m(c,g){if(c.length===0)return-1;let u=0;for(let p=1;p<c.length;p++){const f=c[p];g(f,c[u])>0&&(u=p)}return u}function d(c,g){for(const u of c){const p=g(u);if(p!==void 0)return p}}}),define(Ee[145],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=i,e.$L=A,e.$M=S,e.$N=D;function i(C,k){const v=Object.create(null);for(const $ of C){const E=k($);let y=v[E];y||(y=v[E]=[]),y.push($)}return v}function A(C,k){const v=[],$=[];for(const E of C)k.has(E)||v.push(E);for(const E of k)C.has(E)||$.push(E);return{removed:v,added:$}}function S(C,k){const v=[],$=[];for(const[E,y]of C)k.has(E)||v.push(y);for(const[E,y]of k)C.has(E)||$.push(y);return{removed:v,added:$}}function D(C,k){const v=new Set;for(const $ of k)C.has($)&&v.add($);return v}}),define(Ee[74],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=A,e.$Nh=S,e.$Oh=D;function i(C){return(k,v,$)=>{let E=null,y=null;if(typeof $.value=="function"?(E="value",y=$.value):typeof $.get=="function"&&(E="get",y=$.get),!y)throw new Error("not supported");$[E]=C(y,v)}}function A(C,k,v){let $=null,E=null;if(typeof v.value=="function"?($="value",E=v.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&($="get",E=v.get),!E)throw new Error("not supported");const y=`$memoize$${k}`;v[$]=function(...w){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,w)}),this[y]}}function S(C,k,v){return i(($,E)=>{const y=`$debounce$${E}`,w=`$debounce$result$${E}`;return function(...m){this[w]||(this[w]=v?v():void 0),clearTimeout(this[y]),k&&(this[w]=k(this[w],...m),m=[this[w]]),this[y]=setTimeout(()=>{$.apply(this,m),this[w]=v?v():void 0},C)}})}function D(C,k,v){return i(($,E)=>{const y=`$throttle$timer$${E}`,w=`$throttle$result$${E}`,m=`$throttle$lastRun$${E}`,d=`$throttle$pending$${E}`;return function(...c){if(this[w]||(this[w]=v?v():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),k&&(this[w]=k(this[w],...c)),this[d])return;const g=this[m]+C;g<=Date.now()?(this[m]=Date.now(),$.apply(this,[this[w]]),this[w]=v?v():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[m]=Date.now(),$.apply(this,[this[w]]),this[w]=v?v():void 0},g-Date.now()))}})}}),define(Ee[10],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=A,e.$Z=S,e.$1=D,e.$2=C,e.$3=k,e.$4=$,e.$6=y,e.$7=w,e.$8=m,e.$0=c;class i{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?f.isErrorNoTelemetry(t)?new f(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(a=>{a(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=i,e.$X=new i;function A(l){e.$X.setUnexpectedErrorHandler(l)}function S(l){if(!l||typeof l!="object")return!1;const t=l;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(l){$(l)||e.$X.onUnexpectedError(l)}function C(l){$(l)||e.$X.onUnexpectedExternalError(l)}function k(l){if(l instanceof Error){const{name:t,message:a}=l,o=l.stacktrace||l.stack;return{$isError:!0,name:t,message:a,stack:o,noTelemetry:f.isErrorNoTelemetry(l)}}return l}const v="Canceled";function $(l){return l instanceof E?!0:l instanceof Error&&l.name===v&&l.message===v}class E extends Error{constructor(){super(v),this.name=this.message}}e.$5=E;function y(){const l=new Error(v);return l.name=l.message,l}function w(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class d extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=d;function c(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=u;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=p;class f extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof f)return t;const a=new f;return a.message=t.message,a.stack=t.stack,a}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=f;class h extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype)}}e.$cb=h}),define(Ee[18],ke([1,0,10,144]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=S,e.$tb=D,e.$ub=C,e.$vb=k,e.$wb=v,e.$xb=$,e.$yb=E,e.$zb=y,e.$Ab=w,e.$Bb=m,e.$Cb=d,e.$Db=c,e.$Eb=g,e.top=u,e.$Gb=p,e.$Hb=h,e.$Ib=l,e.$Jb=t,e.$Kb=a,e.$Lb=o,e.$Mb=r,e.$Nb=s,e.$Ob=n,e.$Pb=b,e.$Qb=P,e.$Rb=I,e.$Sb=O,e.$Tb=R,e.$Ub=j,e.$Vb=B,e.$Wb=Y,e.$Xb=fe,e.$Yb=ue,e.$Zb=re,e.$1b=te,e.$2b=V,e.$3b=T,e.$4b=x,e.$5b=Z,e.$6b=G,e.$7b=ne,e.$8b=$e,e.$$b=N;function S(Q,J=0){return Q[Q.length-(1+J)]}function D(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}function C(Q,J,U=(L,H)=>L===H){if(Q===J)return!0;if(!Q||!J||Q.length!==J.length)return!1;for(let L=0,H=Q.length;L<H;L++)if(!U(Q[L],J[L]))return!1;return!0}function k(Q,J){const U=Q.length-1;J<U&&(Q[J]=Q[U]),Q.pop()}function v(Q,J,U){return $(Q.length,L=>U(Q[L],J))}function $(Q,J){let U=0,L=Q-1;for(;U<=L;){const H=(U+L)/2|0,_=J(H);if(_<0)U=H+1;else if(_>0)L=H-1;else return H}return-(U+1)}function E(Q,J,U){if(Q=Q|0,Q>=J.length)throw new TypeError("invalid index");const L=J[Math.floor(J.length*Math.random())],H=[],_=[],ee=[];for(const de of J){const ie=U(de,L);ie<0?H.push(de):ie>0?_.push(de):ee.push(de)}return Q<H.length?E(Q,H,U):Q<H.length+ee.length?ee[0]:E(Q-(H.length+ee.length),_,U)}function y(Q,J){const U=[];let L;for(const H of Q.slice(0).sort(J))!L||J(L[0],H)!==0?(L=[H],U.push(L)):L.push(H);return U}function*w(Q,J){let U,L;for(const H of Q)L!==void 0&&J(L,H)?U.push(H):(U&&(yield U),U=[H]),L=H;U&&(yield U)}function m(Q,J){for(let U=0;U<=Q.length;U++)J(U===0?void 0:Q[U-1],U===Q.length?void 0:Q[U])}function d(Q,J){for(let U=0;U<Q.length;U++)J(U===0?void 0:Q[U-1],Q[U],U+1===Q.length?void 0:Q[U+1])}function c(Q,J,U){const L=[];function H(de,ie,me){if(ie===0&&me.length===0)return;const we=L[L.length-1];we&&we.start+we.deleteCount===de?(we.deleteCount+=ie,we.toInsert.push(...me)):L.push({start:de,deleteCount:ie,toInsert:me})}let _=0,ee=0;for(;;){if(_===Q.length){H(_,0,J.slice(ee));break}if(ee===J.length){H(_,Q.length-_,[]);break}const de=Q[_],ie=J[ee],me=U(de,ie);me===0?(_+=1,ee+=1):me<0?(H(_,1,[]),_+=1):me>0&&(H(_,0,[ie]),ee+=1)}return L}function g(Q,J,U){const L=c(Q,J,U),H=[],_=[];for(const ee of L)H.push(...Q.slice(ee.start,ee.start+ee.deleteCount)),_.push(...ee.toInsert);return{removed:H,added:_}}function u(Q,J,U){if(U===0)return[];const L=Q.slice(0,U).sort(J);return f(Q,J,L,U,Q.length),L}function p(Q,J,U,L,H){return U===0?Promise.resolve([]):new Promise((_,ee)=>{(async()=>{const de=Q.length,ie=Q.slice(0,U).sort(J);for(let me=U,we=Math.min(U+L,de);me<de;me=we,we=Math.min(we+L,de)){if(me>U&&await new Promise(Ie=>setTimeout(Ie)),H&&H.isCancellationRequested)throw new i.$5;f(Q,J,ie,me,we)}return ie})().then(_,ee)})}function f(Q,J,U,L,H){for(const _=U.length;L<H;L++){const ee=Q[L];if(J(ee,U[_-1])<0){U.pop();const de=(0,A.$kb)(U,ie=>J(ee,ie)<0);U.splice(de,0,ee)}}}function h(Q){return Q.filter(J=>!!J)}function l(Q){let J=0;for(let U=0;U<Q.length;U++)Q[U]&&(Q[J]=Q[U],J+=1);Q.length=J}function t(Q,J,U){Q.splice(U,0,Q.splice(J,1)[0])}function a(Q){return!Array.isArray(Q)||Q.length===0}function o(Q){return Array.isArray(Q)&&Q.length>0}function r(Q,J=U=>U){const U=new Set;return Q.filter(L=>{const H=J(L);return U.has(H)?!1:(U.add(H),!0)})}function s(Q){const J=new Set;return U=>{const L=Q(U);return J.has(L)?!1:(J.add(L),!0)}}function n(Q,J){return Q.length>0?Q[0]:J}function b(Q,J){return Q.length>0?Q[Q.length-1]:J}function P(Q,J,U=(L,H)=>L===H){let L=0;for(let H=0,_=Math.min(Q.length,J.length);H<_&&U(Q[H],J[H]);H++)L++;return L}function I(Q){return[].concat(...Q)}function O(Q,J){let U=typeof J=="number"?Q:0;typeof J=="number"?U=Q:(U=0,J=Q);const L=[];if(U<=J)for(let H=U;H<J;H++)L.push(H);else for(let H=U;H>J;H--)L.push(H);return L}function R(Q,J,U){return Q.reduce((L,H)=>(L[J(H)]=U?U(H):H,L),Object.create(null))}function j(Q,J){return Q.push(J),()=>B(Q,J)}function B(Q,J){const U=Q.indexOf(J);if(U>-1)return Q.splice(U,1),J}function Y(Q,J,U){const L=Q.slice(0,J),H=Q.slice(J);return L.concat(U,H)}function fe(Q,J){let U;if(typeof J=="number"){let L=J;U=()=>{const H=Math.sin(L++)*179426549;return H-Math.floor(H)}}else U=Math.random;for(let L=Q.length-1;L>0;L-=1){const H=Math.floor(U()*(L+1)),_=Q[L];Q[L]=Q[H],Q[H]=_}}function ue(Q,J){const U=Q.indexOf(J);U>-1&&(Q.splice(U,1),Q.unshift(J))}function re(Q,J){const U=Q.indexOf(J);U>-1&&(Q.splice(U,1),Q.push(J))}function te(Q,J){for(const U of J)Q.push(U)}function V(Q,J){return Array.isArray(Q)?Q.map(J):J(Q)}function T(Q){return Array.isArray(Q)?Q:[Q]}function x(Q){return Q[Math.floor(Math.random()*Q.length)]}function Z(Q,J,U){const L=se(Q,J),H=Q.length,_=U.length;Q.length=H+_;for(let ee=H-1;ee>=L;ee--)Q[ee+_]=Q[ee];for(let ee=0;ee<_;ee++)Q[ee+L]=U[ee]}function G(Q,J,U,L){const H=se(Q,J);let _=Q.splice(H,U);return _===void 0&&(_=[]),Z(Q,H,L),_}function se(Q,J){return J<0?Math.max(J+Q.length,0):Math.min(J,Q.length)}var ce;(function(Q){function J(_){return _<0}Q.isLessThan=J;function U(_){return _<=0}Q.isLessThanOrEqual=U;function L(_){return _>0}Q.isGreaterThan=L;function H(_){return _===0}Q.isNeitherLessOrGreaterThan=H,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function ne(Q,J){return(U,L)=>J(Q(U),Q(L))}function $e(...Q){return(J,U)=>{for(const L of Q){const H=L(J,U);if(!ce.isNeitherLessOrGreaterThan(H))return H}return ce.neitherLessOrGreaterThan}}const K=(Q,J)=>Q-J;e.$9b=K;const q=(Q,J)=>(0,e.$9b)(Q?1:0,J?1:0);e.$0b=q;function N(Q){return(J,U)=>-Q(J,U)}class z{constructor(J){this.g=J,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(J){let U=this.c;for(;U<this.g.length&&J(this.g[U]);)U++;const L=U===this.c?null:this.g.slice(this.c,U);return this.c=U,L}takeFromEndWhile(J){let U=this.d;for(;U>=0&&J(this.g[U]);)U--;const L=U===this.d?null:this.g.slice(U+1,this.d+1);return this.d=U,L}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const J=this.g[this.c];return this.c++,J}removeLast(){const J=this.g[this.d];return this.d--,J}takeCount(J){const U=this.g.slice(this.c,this.c+J);return this.c+=J,U}}e.$_b=z;class X{static{this.empty=new X(J=>{})}constructor(J){this.iterate=J}forEach(J){this.iterate(U=>(J(U),!0))}toArray(){const J=[];return this.iterate(U=>(J.push(U),!0)),J}filter(J){return new X(U=>this.iterate(L=>J(L)?U(L):!0))}map(J){return new X(U=>this.iterate(L=>U(J(L))))}some(J){let U=!1;return this.iterate(L=>(U=J(L),!U)),U}findFirst(J){let U;return this.iterate(L=>J(L)?(U=L,!1):!0),U}findLast(J){let U;return this.iterate(L=>(J(L)&&(U=L),!0)),U}findLastMaxBy(J){let U,L=!0;return this.iterate(H=>((L||ce.isGreaterThan(J(H,U)))&&(L=!1,U=H),!0)),U}}e.$ac=X;class ae{constructor(J){this.c=J}static createSortPermutation(J,U){const L=Array.from(J.keys()).sort((H,_)=>U(J[H],J[_]));return new ae(L)}apply(J){return J.map((U,L)=>J[this.c[L]])}inverse(){const J=this.c.slice();for(let U=0;U<this.c.length;U++)J[this.c[U]]=U;return new ae(J)}}e.$bc=ae}),define(Ee[96],ke([1,0,10]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=A,e.$0c=S,e.$$c=D,e.$_c=C,e.$ad=k,e.$bd=v;function A($,E){if(!$)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function S($,E="Unreachable"){throw new Error(E)}function D($){if(!$)throw new i.$cb("Assertion Failed")}function C($){$||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function k($){if(!$()){debugger;$(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function v($,E){let y=0;for(;y<$.length-1;){const w=$[y],m=$[y+1];if(!E(w,m))return!1;y++}return!0}}),define(Ee[75],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=i;function i(A,S){const D=this;let C=!1,k;return function(){if(C)return k;if(C=!0,S)try{k=A.apply(D,arguments)}finally{S()}else k=A.apply(D,arguments);return k}}}),define(Ee[41],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(A){function S(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}A.is=S;const D=Object.freeze([]);function C(){return D}A.empty=C;function*k(t){yield t}A.single=k;function v(t){return S(t)?t:k(t)}A.wrap=v;function $(t){return t||D}A.from=$;function*E(t){for(let a=t.length-1;a>=0;a--)yield t[a]}A.reverse=E;function y(t){return!t||t[Symbol.iterator]().next().done===!0}A.isEmpty=y;function w(t){return t[Symbol.iterator]().next().value}A.first=w;function m(t,a){for(const o of t)if(a(o))return!0;return!1}A.some=m;function d(t,a){for(const o of t)if(a(o))return o}A.find=d;function*c(t,a){for(const o of t)a(o)&&(yield o)}A.filter=c;function*g(t,a){let o=0;for(const r of t)yield a(r,o++)}A.map=g;function*u(...t){for(const a of t)yield*a}A.concat=u;function p(t,a,o){let r=o;for(const s of t)r=a(r,s);return r}A.reduce=p;function*f(t,a,o=t.length){for(a<0&&(a+=t.length),o<0?o+=t.length:o>t.length&&(o=t.length);a<o;a++)yield t[a]}A.slice=f;function h(t,a=Number.POSITIVE_INFINITY){const o=[];if(a===0)return[o,t];const r=t[Symbol.iterator]();for(let s=0;s<a;s++){const n=r.next();if(n.done)return[o,A.empty()];o.push(n.value)}return[o,{[Symbol.iterator](){return r}}]}A.consume=h;async function l(t){const a=[];for await(const o of t)a.push(o);return Promise.resolve(a)}A.asyncToArray=l})(i||(e.Iterable=i={}))}),define(Ee[42],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$tn=C,e.$un=y,e.$vn=w,e.$wn=m,e.$xn=d,e.$yn=c,e.$zn=g,e.$An=u,e.$Bn=p,e.$Cn=f,e.$Dn=h,e.$En=l;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function C(t,a=!1){let o=0;const r=t.length;let s="",n=0,b=16,P=0;function I(ue){let re=0,te=0;for(;re<ue;){const V=t.charCodeAt(o);if(V>=48&&V<=57)te=te*16+V-48;else if(V>=65&&V<=70)te=te*16+V-65+10;else if(V>=97&&V<=102)te=te*16+V-97+10;else break;o++,re++}return re<ue&&(te=-1),te}function O(ue){o=ue,s="",n=0,b=16,P=0}function R(){const ue=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&$(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&$(t.charCodeAt(o)))for(o++;o<t.length&&$(t.charCodeAt(o));)o++;else return P=3,t.substring(ue,o);let re=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&$(t.charCodeAt(o))){for(o++;o<t.length&&$(t.charCodeAt(o));)o++;re=o}else P=3;return t.substring(ue,re)}function j(){let ue="",re=o;for(;;){if(o>=r){ue+=t.substring(re,o),P=2;break}const te=t.charCodeAt(o);if(te===34){ue+=t.substring(re,o),o++;break}if(te===92){if(ue+=t.substring(re,o),o++,o>=r){P=2;break}switch(t.charCodeAt(o++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const T=I(4);T>=0?ue+=String.fromCharCode(T):P=4;break}default:P=5}re=o;continue}if(te>=0&&te<=31)if(v(te)){ue+=t.substring(re,o),P=2;break}else P=6;o++}return ue}function B(){if(s="",P=0,n=o,o>=r)return n=r,b=17;let ue=t.charCodeAt(o);if(k(ue)){do o++,s+=String.fromCharCode(ue),ue=t.charCodeAt(o);while(k(ue));return b=15}if(v(ue))return o++,s+=String.fromCharCode(ue),ue===13&&t.charCodeAt(o)===10&&(o++,s+=`
`),b=14;switch(ue){case 123:return o++,b=1;case 125:return o++,b=2;case 91:return o++,b=3;case 93:return o++,b=4;case 58:return o++,b=6;case 44:return o++,b=5;case 34:return o++,s=j(),b=10;case 47:{const re=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<r&&!v(t.charCodeAt(o));)o++;return s=t.substring(re,o),b=12}if(t.charCodeAt(o+1)===42){o+=2;const te=r-1;let V=!1;for(;o<te;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,V=!0;break}o++}return V||(o++,P=1),s=t.substring(re,o),b=13}return s+=String.fromCharCode(ue),o++,b=16}case 45:if(s+=String.fromCharCode(ue),o++,o===r||!$(t.charCodeAt(o)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=R(),b=11;default:for(;o<r&&Y(ue);)o++,ue=t.charCodeAt(o);if(n!==o){switch(s=t.substring(n,o),s){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return s+=String.fromCharCode(ue),o++,b=16}}function Y(ue){if(k(ue)||v(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function fe(){let ue;do ue=B();while(ue>=12&&ue<=15);return ue}return{setPosition:O,getPosition:()=>o,scan:a?fe:B,getToken:()=>b,getTokenValue:()=>s,getTokenOffset:()=>n,getTokenLength:()=>o-n,getTokenError:()=>P}}function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function y(t,a){const o=[],r=new Object;let s;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function P(I,O,R,j){n.value=I,n.offset=O,n.length=R,n.type=j,n.colonOffset=void 0,s=n}try{f(t,{onObjectBegin:(I,O)=>{if(a<=I)throw r;s=void 0,b=a>I,o.push("")},onObjectProperty:(I,O,R)=>{if(a<O||(P(I,O,R,"property"),o[o.length-1]=I,a<=O+R))throw r},onObjectEnd:(I,O)=>{if(a<=I)throw r;s=void 0,o.pop()},onArrayBegin:(I,O)=>{if(a<=I)throw r;s=void 0,o.push(0)},onArrayEnd:(I,O)=>{if(a<=I)throw r;s=void 0,o.pop()},onLiteralValue:(I,O,R)=>{if(a<O||(P(I,O,R,l(I)),a<=O+R))throw r},onSeparator:(I,O,R)=>{if(a<=O)throw r;if(I===":"&&s&&s.type==="property")s.colonOffset=O,b=!1,s=void 0;else if(I===","){const j=o[o.length-1];typeof j=="number"?o[o.length-1]=j+1:(b=!0,o[o.length-1]=""),s=void 0}}})}catch(I){if(I!==r)throw I}return{path:o,previousNode:s,isAtPropertyKey:b,matches:I=>{let O=0;for(let R=0;O<I.length&&R<o.length;R++)if(I[O]===o[R]||I[O]==="*")O++;else if(I[O]!=="**")return!1;return O===I.length}}}function w(t,a=[],o=D.DEFAULT){let r=null,s=[];const n=[];function b(I){Array.isArray(s)?s.push(I):r!==null&&(s[r]=I)}return f(t,{onObjectBegin:()=>{const I={};b(I),n.push(s),s=I,r=null},onObjectProperty:I=>{r=I},onObjectEnd:()=>{s=n.pop()},onArrayBegin:()=>{const I=[];b(I),n.push(s),s=I,r=null},onArrayEnd:()=>{s=n.pop()},onLiteralValue:b,onError:(I,O,R)=>{a.push({error:I,offset:O,length:R})}},o),s[0]}function m(t,a=[],o=D.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){r.type==="property"&&(r.length=I-r.offset,r=r.parent)}function n(I){return r.children.push(I),I}f(t,{onObjectBegin:I=>{r=n({type:"object",offset:I,length:-1,parent:r,children:[]})},onObjectProperty:(I,O,R)=>{r=n({type:"property",offset:O,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:I,offset:O,length:R,parent:r})},onObjectEnd:(I,O)=>{r.length=I+O-r.offset,r=r.parent,s(I+O)},onArrayBegin:(I,O)=>{r=n({type:"array",offset:I,length:-1,parent:r,children:[]})},onArrayEnd:(I,O)=>{r.length=I+O-r.offset,r=r.parent,s(I+O)},onLiteralValue:(I,O,R)=>{n({type:l(I),offset:O,length:R,parent:r,value:I}),s(O+R)},onSeparator:(I,O,R)=>{r.type==="property"&&(I===":"?r.colonOffset=O:I===","&&s(O))},onError:(I,O,R)=>{a.push({error:I,offset:O,length:R})}},o);const P=r.children[0];return P&&delete P.parent,P}function d(t,a){if(!t)return;let o=t;for(const r of a)if(typeof r=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const n of o.children)if(Array.isArray(n.children)&&n.children[0].value===r){o=n.children[1],s=!0;break}if(!s)return}else{const s=r;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}function c(t){if(!t.parent||!t.parent.children)return[];const a=c(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;a.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&a.push(o)}return a}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const a=Object.create(null);for(const o of t.children){const r=o.children[1];r&&(a[o.children[0].value]=g(r))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function u(t,a,o=!1){return a>=t.offset&&a<t.offset+t.length||o&&a===t.offset+t.length}function p(t,a,o=!1){if(u(t,a,o)){const r=t.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=a;s++){const n=p(r[s],a,o);if(n)return n}return t}}function f(t,a,o=D.DEFAULT){const r=C(t,!1);function s(ne){return ne?()=>ne(r.getTokenOffset(),r.getTokenLength()):()=>!0}function n(ne){return ne?$e=>ne($e,r.getTokenOffset(),r.getTokenLength()):()=>!0}const b=s(a.onObjectBegin),P=n(a.onObjectProperty),I=s(a.onObjectEnd),O=s(a.onArrayBegin),R=s(a.onArrayEnd),j=n(a.onLiteralValue),B=n(a.onSeparator),Y=s(a.onComment),fe=n(a.onError),ue=o&&o.disallowComments,re=o&&o.allowTrailingComma;function te(){for(;;){const ne=r.scan();switch(r.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:ue||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(ne){case 12:case 13:ue?V(10):Y();break;case 16:V(1);break;case 15:case 14:break;default:return ne}}}function V(ne,$e=[],K=[]){if(fe(ne),$e.length+K.length>0){let q=r.getToken();for(;q!==17;){if($e.indexOf(q)!==-1){te();break}else if(K.indexOf(q)!==-1)break;q=te()}}}function T(ne){const $e=r.getTokenValue();return ne?j($e):P($e),te(),!0}function x(){switch(r.getToken()){case 11:{let ne=0;try{ne=JSON.parse(r.getTokenValue()),typeof ne!="number"&&(V(2),ne=0)}catch{V(2)}j(ne);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return te(),!0}function Z(){return r.getToken()!==10?(V(3,[],[2,5]),!1):(T(!1),r.getToken()===6?(B(":"),te(),ce()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function G(){b(),te();let ne=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ne||V(4,[],[]),B(","),te(),r.getToken()===2&&re)break}else ne&&V(6,[],[]);Z()||V(4,[],[2,5]),ne=!0}return I(),r.getToken()!==2?V(7,[2],[]):te(),!0}function se(){O(),te();let ne=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ne||V(4,[],[]),B(","),te(),r.getToken()===4&&re)break}else ne&&V(6,[],[]);ce()||V(4,[],[4,5]),ne=!0}return R(),r.getToken()!==4?V(8,[4],[]):te(),!0}function ce(){switch(r.getToken()){case 3:return se();case 1:return G();case 10:return T(!0);default:return x()}}return te(),r.getToken()===17?o.allowEmptyContent?!0:(V(4,[],[]),!1):ce()?(r.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}function h(t,a){const o=C(t),r=[];let s,n=0,b;do switch(b=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:n!==b&&r.push(t.substring(n,b)),a!==void 0&&r.push(o.getTokenValue().replace(/[^\r\n]/g,a)),n=o.getPosition();break}while(s!==17);return r.join("")}function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[146],ke([1,0,42]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=A,e.$Gn=S,e.$Hn=k,e.$In=v;function A($,E,y){let w,m,d,c,g;if(E){for(c=E.offset,g=c+E.length,d=c;d>0&&!v($,d-1);)d--;let b=g;for(;b<$.length&&!v($,b);)b++;m=$.substring(d,b),w=C(m,y)}else m=$,w=0,d=0,c=0,g=$.length;const u=k(y,$);let p=!1,f=0,h;y.insertSpaces?h=D(" ",y.tabSize||4):h="	";const l=(0,i.$tn)(m,!1);let t=!1;function a(){return u+D(h,w+f)}function o(){let b=l.scan();for(p=!1;b===15||b===14;)p=p||b===14,b=l.scan();return t=b===16||l.getTokenError()!==0,b}const r=[];function s(b,P,I){!t&&P<g&&I>c&&$.substring(P,I)!==b&&r.push({offset:P,length:I-P,content:b})}let n=o();if(n!==17){const b=l.getTokenOffset()+d,P=D(h,w);s(P,d,b)}for(;n!==17;){let b=l.getTokenOffset()+l.getTokenLength()+d,P=o(),I="";for(;!p&&(P===12||P===13);){const R=l.getTokenOffset()+d;s(" ",b,R),b=l.getTokenOffset()+l.getTokenLength()+d,I=P===12?a():"",P=o()}if(P===2)n!==1&&(f--,I=a());else if(P===4)n!==3&&(f--,I=a());else{switch(n){case 3:case 1:f++,I=a();break;case 5:case 12:I=a();break;case 13:p?I=a():I=" ";break;case 6:I=" ";break;case 10:if(P===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?I=" ":P!==5&&P!==17&&(t=!0);break;case 16:t=!0;break}p&&(P===12||P===13)&&(I=a())}const O=l.getTokenOffset()+d;s(I,b,O),n=P}return r}function S($,E){const y=JSON.stringify($,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?y.replace(/\r\n|\r|\n/g,E.eol):y}function D($,E){let y="";for(let w=0;w<E;w++)y+=$;return y}function C($,E){let y=0,w=0;const m=E.tabSize||4;for(;y<$.length;){const d=$.charAt(y);if(d===" ")w++;else if(d==="	")w+=m;else break;y++}return Math.floor(w/m)}function k($,E){for(let y=0;y<E.length;y++){const w=E.charAt(y);if(w==="\r")return y+1<E.length&&E.charAt(y+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return $&&$.eol||`
`}function v($,E){return`\r
`.indexOf($.charAt(E))!==-1}}),define(Ee[147],ke([1,0,42,146]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=S,e.$Kn=D,e.$Ln=C,e.$Mn=k,e.$Nn=v;function S($,E,y){return D($,E,void 0,y)}function D($,E,y,w,m){const d=E.slice(),c=[],g=(0,i.$wn)($,c);let u,p;for(;d.length>0&&(p=d.pop(),u=(0,i.$xn)(g,d),u===void 0&&y!==void 0);)typeof p=="string"?y={[p]:y}:y=[y];if(u)if(u.type==="object"&&typeof p=="string"&&Array.isArray(u.children)){const f=(0,i.$xn)(u,[p]);if(f!==void 0)if(y===void 0){if(!f.parent)throw new Error("Malformed AST");const h=u.children.indexOf(f.parent);let l,t=f.parent.offset+f.parent.length;if(h>0){const a=u.children[h-1];l=a.offset+a.length}else l=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return C($,{offset:l,length:t-l,content:""},w)}else return C($,{offset:f.offset,length:f.length,content:JSON.stringify(y)},w);else{if(y===void 0)return[];const h=`${JSON.stringify(p)}: ${JSON.stringify(y)}`,l=m?m(u.children.map(a=>a.children[0].value)):u.children.length;let t;if(l>0){const a=u.children[l-1];t={offset:a.offset+a.length,length:0,content:","+h}}else u.children.length===0?t={offset:u.offset+1,length:0,content:h}:t={offset:u.offset+1,length:0,content:h+","};return C($,t,w)}}else if(u.type==="array"&&typeof p=="number"&&Array.isArray(u.children))if(y!==void 0){const f=`${JSON.stringify(y)}`;let h;if(u.children.length===0||p===0)h={offset:u.offset+1,length:0,content:u.children.length===0?f:f+","};else{const l=p===-1||p>u.children.length?u.children.length:p,t=u.children[l-1];h={offset:t.offset+t.length,length:0,content:","+f}}return C($,h,w)}else{const f=p,h=u.children[f];let l;if(u.children.length===1)l={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===f){const t=u.children[f-1],a=t.offset+t.length,o=u.offset+u.length;l={offset:a,length:o-2-a,content:""}}else l={offset:h.offset,length:u.children[f+1].offset-h.offset,content:""};return C($,l,w)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${u.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return C($,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(y)},w)}}function C($,E,y){let w=k($,E),m=E.offset,d=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;m>0&&!(0,A.$In)(w,m-1);)m--;for(;d<w.length&&!(0,A.$In)(w,d);)d++}const c=(0,A.$Fn)(w,{offset:m,length:d-m},y);for(let u=c.length-1;u>=0;u--){const p=c[u];w=k(w,p),m=Math.min(m,p.offset),d=Math.max(d,p.offset+p.length),d+=p.content.length-p.length}const g=$.length-(w.length-d)-m;return[{offset:m,length:g,content:w.substring(m,d)}]}function k($,E){return $.substring(0,E.offset)+E.content+$.substring(E.offset+E.length)}function v($,E){const y=E.slice(0).sort((m,d)=>{const c=m.offset-d.offset;return c===0?m.length-d.length:c});let w=$.length;for(let m=y.length-1;m>=0;m--){const d=y[m];if(d.offset+d.length<=w)$=k($,d);else throw new Error("Overlapping edit");w=d.offset}return $}}),define(Ee[60],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class i{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=i}),define(Ee[97],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(D){this.element=D,this.next=i.Undefined,this.prev=i.Undefined}}class A{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let D=this.a;for(;D!==i.Undefined;){const C=D.next;D.prev=i.Undefined,D.next=i.Undefined,D=C}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,C){const k=new i(D);if(this.a===i.Undefined)this.a=k,this.b=k;else if(C){const $=this.b;this.b=k,k.prev=$,$.next=k}else{const $=this.a;this.a=k,k.next=$,$.prev=k}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(k))}}shift(){if(this.a!==i.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==i.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==i.Undefined&&D.next!==i.Undefined){const C=D.prev;C.next=D.next,D.next.prev=C}else D.prev===i.Undefined&&D.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):D.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):D.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==i.Undefined;)yield D.element,D=D.next}}e.$5c=A}),define(Ee[24],ke([1,0]),function(le,e){"use strict";var i,A,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=D,e.$zc=C,e.$Ac=k,e.$Ic=p;function D(f,h,l){let t=f.get(h);return t===void 0&&(t=l,f.set(h,t)),t}function C(f){const h=[];return f.forEach((l,t)=>{h.push(`${t} => ${l}`)}),`Map(${f.size}) {${h.join(", ")}}`}function k(f){const h=[];return f.forEach(l=>{h.push(l)}),`Set(${f.size}) {${h.join(", ")}}`}class v{constructor(h,l){this.uri=h,this.value=l}}function $(f){return Array.isArray(f)}class E{static{this.c=h=>h.toString()}constructor(h,l){if(this[i]="ResourceMap",h instanceof E)this.d=new Map(h.d),this.e=l??E.c;else if($(h)){this.d=new Map,this.e=l??E.c;for(const[t,a]of h)this.set(t,a)}else this.d=new Map,this.e=h??E.c}set(h,l){return this.d.set(this.e(h),new v(h,l)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,l){typeof l<"u"&&(h=h.bind(l));for(const[t,a]of this.d)h(a.value,a.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Bc=E;class y{constructor(h,l){this[A]="ResourceSet",!h||typeof h=="function"?this.c=new E(h):(this.c=new E(l),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,l){this.c.forEach((t,a)=>h.call(l,a,a,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var w;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class m{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,l=0){const t=this.c.get(h);if(t)return l!==0&&this.l(t,l),t.value}set(h,l,t=0){let a=this.c.get(h);if(a)a.value=l,t!==0&&this.l(a,t);else{switch(a={key:h,value:l,next:void 0,previous:void 0},t){case 0:this.j(a);break;case 1:this.i(a);break;case 2:this.j(a);break;default:this.j(a);break}this.c.set(h,a),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const l=this.c.get(h);if(l)return this.c.delete(h),this.k(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.k(h),this.f--,h.value}forEach(h,l){const t=this.g;let a=this.d;for(;a;){if(l?h.bind(l)(a.value,a.key,this):h(a.value,a.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const h=this,l=this.g;let t=this.d;const a={[Symbol.iterator](){return a},next(){if(h.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:t.key,done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return a}values(){const h=this,l=this.g;let t=this.d;const a={[Symbol.iterator](){return a},next(){if(h.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:t.value,done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return a}entries(){const h=this,l=this.g;let t=this.d;const a={[Symbol.iterator](){return a},next(){if(h.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const o={value:[t.key,t.value],done:!1};return t=t.next,o}else return{value:void 0,done:!0}}};return a}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let l=this.d,t=this.size;for(;l&&t>h;)this.c.delete(l.key),l=l.next,t--;this.d=l,this.f=t,l&&(l.previous=void 0),this.g++}i(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}j(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}k(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const l=h.next,t=h.previous;if(!l||!t)throw new Error("Invalid list");l.previous=t,t.next=l}h.next=void 0,h.previous=void 0,this.g++}l(h,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(h===this.d)return;const t=h.next,a=h.previous;h===this.e?(a.next=void 0,this.e=a):(t.previous=a,a.next=t),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(l===2){if(h===this.e)return;const t=h.next,a=h.previous;h===this.d?(t.previous=void 0,this.d=t):(t.previous=a,a.next=t),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((l,t)=>{h.push([t,l])}),h}fromJSON(h){this.clear();for(const[l,t]of h)this.set(l,t)}}e.$Dc=m;class d extends m{constructor(h,l=1){super(),this.m=h,this.n=Math.min(Math.max(0,l),1)}get limit(){return this.m}set limit(h){this.m=h,this.o()}get ratio(){return this.n}set ratio(h){this.n=Math.min(Math.max(0,h),1),this.o()}get(h,l=2){return super.get(h,l)}peek(h){return super.get(h,0)}set(h,l){return super.set(h,l,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=d;class c{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let l=this.c.get(h)||0;return l===0?!1:(l--,l===0?this.c.delete(h):this.c.set(h,l),!0)}has(h){return this.c.has(h)}}e.$Fc=c;class g{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[l,t]of h)this.set(l,t)}clear(){this.c.clear(),this.d.clear()}set(h,l){this.c.set(h,l),this.d.set(l,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const l=this.c.get(h);return l===void 0?!1:(this.c.delete(h),this.d.delete(l),!0)}forEach(h,l){this.c.forEach((t,a)=>{h.call(l,t,a,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=g;class u{constructor(){this.c=new Map}add(h,l){let t=this.c.get(h);t||(t=new Set,this.c.set(h,t)),t.add(l)}delete(h,l){const t=this.c.get(h);t&&(t.delete(l),t.size===0&&this.c.delete(h))}forEach(h,l){const t=this.c.get(h);t&&t.forEach(l)}get(h){const l=this.c.get(h);return l||new Set}}e.$Hc=u;function p(f,h){if(f===h)return!0;if(f.size!==h.size)return!1;for(const[l,t]of f)if(!h.has(l)||h.get(l)!==t)return!1;for(const[l]of h)if(!f.has(l))return!1;return!0}}),define(Ee[2],ke([1,0,18,145,24,75,41]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=E,e.$Lc=y,e.$Mc=w,e.$Nc=c,e.$Oc=g,e.$Pc=u,e.$Qc=p,e.$Rc=f,e.$Sc=h,e.$3c=I;const k=!1;let v=null;class ${constructor(){this.b=new Map}static{this.a=0}c(j){let B=this.b.get(j);return B||(B={parent:null,source:null,isSingleton:!1,value:j,idx:$.a++},this.b.set(j,B)),B}trackDisposable(j){const B=this.c(j);B.source||(B.source=new Error().stack)}setParent(j,B){const Y=this.c(j);Y.parent=B}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,B){const Y=B.get(j);if(Y)return Y;const fe=j.parent?this.f(this.c(j.parent),B):j;return B.set(j,fe),fe}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,Y])=>Y.source!==null&&!this.f(Y,j).isSingleton).flatMap(([Y])=>Y)}computeLeakingDisposables(j=10,B){let Y;if(B)Y=B;else{const V=new Map,T=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,V).isSingleton);if(T.length===0)return;const x=new Set(T.map(Z=>Z.value));if(Y=T.filter(Z=>!(Z.parent&&x.has(Z.parent))),Y.length===0)throw new Error("There are cyclic diposable chains!")}if(!Y)return;function fe(V){function T(Z,G){for(;Z.length>0&&G.some(se=>typeof se=="string"?se===Z[0]:Z[0].match(se));)Z.shift()}const x=V.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return T(x,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),x.reverse()}const ue=new S.$Hc;for(const V of Y){const T=fe(V);for(let x=0;x<=T.length;x++)ue.add(T.slice(0,x).join(`
`),V)}Y.sort((0,i.$7b)(V=>V.idx,i.$9b));let re="",te=0;for(const V of Y.slice(0,j)){te++;const T=fe(V),x=[];for(let Z=0;Z<T.length;Z++){let G=T[Z];G=`(shared with ${ue.get(T.slice(0,Z+1).join(`
`)).size}/${Y.length} leaks) at ${G}`;const ce=ue.get(T.slice(0,Z).join(`
`)),ne=(0,A.$K)([...ce].map($e=>fe($e)[Z]),$e=>$e);delete ne[T[Z]];for(const[$e,K]of Object.entries(ne))x.unshift(`    - stacktraces of ${K.length} other leaks continue with ${$e}`);x.unshift(G)}re+=`


==================== Leaking disposable ${te}/${Y.length}: ${V.value.constructor.name} ====================
${x.join(`
`)}
============================================================

`}return Y.length>j&&(re+=`


... and ${Y.length-j} more leaking disposables

`),{leaks:Y,details:re}}}e.$Jc=$;function E(R){v=R}if(k){const R="__is_disposable_tracked__";E(new class{trackDisposable(j){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[R]||console.log(B)},3e3)}setParent(j,B){if(j&&j!==t.None)try{j[R]=!0}catch{}}markAsDisposed(j){if(j&&j!==t.None)try{j[R]=!0}catch{}}markAsSingleton(j){}})}function y(R){return v?.trackDisposable(R),R}function w(R){v?.markAsDisposed(R)}function m(R,j){v?.setParent(R,j)}function d(R,j){if(v)for(const B of R)v.setParent(B,j)}function c(R){return v?.markAsSingleton(R),R}function g(R){return typeof R.dispose=="function"&&R.dispose.length===0}function u(R){if(C.Iterable.is(R)){const j=[];for(const B of R)if(B)try{B.dispose()}catch(Y){j.push(Y)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function p(R){for(const j of R)g(j)&&j.dispose();return[]}function f(...R){const j=h(()=>u(R));return d(R,j),j}function h(R){const j=y({dispose:(0,D.$db)(()=>{w(j),R()})});return j}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return m(j,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),m(j,null))}}e.$Tc=l;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,y(this),m(this.q,this)}dispose(){w(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}e.$Uc=t;class a{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&m(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&m(j,null),j}}e.$Vc=a;class o{constructor(j){this.a=new a,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=o;class r{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=r;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(j){let B=j;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,w(this))},this}}e.$Yc=s;class n{constructor(){this.a=new Map}acquire(j,...B){let Y=this.a.get(j);Y||(Y={counter:0,object:this.b(j,...B)},this.a.set(j,Y));const{object:fe}=Y,ue=(0,D.$db)(()=>{--Y.counter===0&&(this.c(j,Y.object),this.a.delete(j))});return Y.counter++,{object:fe,dispose:ue}}}e.$Zc=n;class b{constructor(j){this.a=j}async acquire(j,...B){const Y=this.a.acquire(j,...B);try{return{object:await Y.object,dispose:()=>Y.dispose()}}catch(fe){throw Y.dispose(),fe}}}e.$1c=b;class P{constructor(j){this.object=j}dispose(){}}e.$2c=P;function I(R){const j=new l;try{R(j)}finally{j.dispose()}}class O{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,B,Y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Y||this.a.get(j)?.dispose(),this.a.set(j,B)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=O}),function(le,e){typeof define=="function"&&define.amd?define(Ee[148],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(Q,J){for(var U=0;U<J.length;U++){var L=J[U];L.enumerable=L.enumerable||!1,L.configurable=!0,"value"in L&&(L.writable=!0),Object.defineProperty(Q,L.key,L)}}function i(Q,J,U){return J&&e(Q.prototype,J),U&&e(Q,U),Object.defineProperty(Q,"prototype",{writable:!1}),Q}function A(Q,J){if(Q){if(typeof Q=="string")return S(Q,J);var U=Object.prototype.toString.call(Q).slice(8,-1);if(U==="Object"&&Q.constructor&&(U=Q.constructor.name),U==="Map"||U==="Set")return Array.from(Q);if(U==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(U))return S(Q,J)}}function S(Q,J){(J==null||J>Q.length)&&(J=Q.length);for(var U=0,L=new Array(J);U<J;U++)L[U]=Q[U];return L}function D(Q,J){var U=typeof Symbol<"u"&&Q[Symbol.iterator]||Q["@@iterator"];if(U)return(U=U.call(Q)).next.bind(U);if(Array.isArray(Q)||(U=A(Q))||J&&Q&&typeof Q.length=="number"){U&&(Q=U);var L=0;return function(){return L>=Q.length?{done:!0}:{done:!1,value:Q[L++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=C();function k(Q){le.defaults=Q}var v=/[&<>"']/,$=/[&<>"']/g,E=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(J){return w[J]};function d(Q,J){if(J){if(v.test(Q))return Q.replace($,m)}else if(E.test(Q))return Q.replace(y,m);return Q}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Q){return Q.replace(c,function(J,U){return U=U.toLowerCase(),U==="colon"?":":U.charAt(0)==="#"?U.charAt(1)==="x"?String.fromCharCode(parseInt(U.substring(2),16)):String.fromCharCode(+U.substring(1)):""})}var u=/(^|[^\[])\^/g;function p(Q,J){Q=typeof Q=="string"?Q:Q.source,J=J||"";var U={replace:function(H,_){return _=_.source||_,_=_.replace(u,"$1"),Q=Q.replace(H,_),U},getRegex:function(){return new RegExp(Q,J)}};return U}var f=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(Q,J,U){if(Q){var L;try{L=decodeURIComponent(g(U)).replace(f,"").toLowerCase()}catch{return null}if(L.indexOf("javascript:")===0||L.indexOf("vbscript:")===0||L.indexOf("data:")===0)return null}J&&!h.test(U)&&(U=s(J,U));try{U=encodeURI(U).replace(/%25/g,"%")}catch{return null}return U}var t={},a=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Q,J){t[" "+Q]||(a.test(Q)?t[" "+Q]=Q+"/":t[" "+Q]=I(Q,"/",!0)),Q=t[" "+Q];var U=Q.indexOf(":")===-1;return J.substring(0,2)==="//"?U?J:Q.replace(o,"$1")+J:J.charAt(0)==="/"?U?J:Q.replace(r,"$1")+J:Q+J}var n={exec:function(){}};function b(Q){for(var J=1,U,L;J<arguments.length;J++){U=arguments[J];for(L in U)Object.prototype.hasOwnProperty.call(U,L)&&(Q[L]=U[L])}return Q}function P(Q,J){var U=Q.replace(/\|/g,function(_,ee,de){for(var ie=!1,me=ee;--me>=0&&de[me]==="\\";)ie=!ie;return ie?"|":" |"}),L=U.split(/ \|/),H=0;if(L[0].trim()||L.shift(),L.length>0&&!L[L.length-1].trim()&&L.pop(),L.length>J)L.splice(J);else for(;L.length<J;)L.push("");for(;H<L.length;H++)L[H]=L[H].trim().replace(/\\\|/g,"|");return L}function I(Q,J,U){var L=Q.length;if(L===0)return"";for(var H=0;H<L;){var _=Q.charAt(L-H-1);if(_===J&&!U)H++;else if(_!==J&&U)H++;else break}return Q.slice(0,L-H)}function O(Q,J){if(Q.indexOf(J[1])===-1)return-1;for(var U=Q.length,L=0,H=0;H<U;H++)if(Q[H]==="\\")H++;else if(Q[H]===J[0])L++;else if(Q[H]===J[1]&&(L--,L<0))return H;return-1}function R(Q){Q&&Q.sanitize&&!Q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(Q,J){if(J<1)return"";for(var U="";J>1;)J&1&&(U+=Q),J>>=1,Q+=Q;return U+Q}function B(Q,J,U,L){var H=J.href,_=J.title?d(J.title):null,ee=Q[1].replace(/\\([\[\]])/g,"$1");if(Q[0].charAt(0)!=="!"){L.state.inLink=!0;var de={type:"link",raw:U,href:H,title:_,text:ee,tokens:L.inlineTokens(ee)};return L.state.inLink=!1,de}return{type:"image",raw:U,href:H,title:_,text:d(ee)}}function Y(Q,J){var U=Q.match(/^(\s+)(?:```)/);if(U===null)return J;var L=U[1];return J.split(`
`).map(function(H){var _=H.match(/^\s+/);if(_===null)return H;var ee=_[0];return ee.length>=L.length?H.slice(L.length):H}).join(`
`)}var fe=function(){function Q(U){this.options=U||le.defaults}var J=Q.prototype;return J.space=function(L){var H=this.rules.block.newline.exec(L);if(H&&H[0].length>0)return{type:"space",raw:H[0]}},J.code=function(L){var H=this.rules.block.code.exec(L);if(H){var _=H[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:H[0],codeBlockStyle:"indented",text:this.options.pedantic?_:I(_,`
`)}}},J.fences=function(L){var H=this.rules.block.fences.exec(L);if(H){var _=H[0],ee=Y(_,H[3]||"");return{type:"code",raw:_,lang:H[2]?H[2].trim():H[2],text:ee}}},J.heading=function(L){var H=this.rules.block.heading.exec(L);if(H){var _=H[2].trim();if(/#$/.test(_)){var ee=I(_,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(_=ee.trim())}return{type:"heading",raw:H[0],depth:H[1].length,text:_,tokens:this.lexer.inline(_)}}},J.hr=function(L){var H=this.rules.block.hr.exec(L);if(H)return{type:"hr",raw:H[0]}},J.blockquote=function(L){var H=this.rules.block.blockquote.exec(L);if(H){var _=H[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:H[0],tokens:this.lexer.blockTokens(_,[]),text:_}}},J.list=function(L){var H=this.rules.block.list.exec(L);if(H){var _,ee,de,ie,me,we,Ie,Oe,ge,Se,Ce,Te,Fe=H[1].trim(),Ve=Fe.length>1,Ue={type:"list",raw:"",ordered:Ve,start:Ve?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=Ve?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=Ve?Fe:"[*+-]");for(var xe=new RegExp("^( {0,3}"+Fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");L&&(Te=!1,!(!(H=xe.exec(L))||this.rules.block.hr.test(L)));){if(_=H[0],L=L.substring(_.length),Oe=H[2].split(`
`,1)[0],ge=L.split(`
`,1)[0],this.options.pedantic?(ie=2,Ce=Oe.trimLeft()):(ie=H[2].search(/[^ ]/),ie=ie>4?1:ie,Ce=Oe.slice(ie),ie+=H[1].length),we=!1,!Oe&&/^ *$/.test(ge)&&(_+=ge+`
`,L=L.substring(ge.length+1),Te=!0),!Te)for(var Xe=new RegExp("^ {0,"+Math.min(3,ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,ie-1)+"}(?:```|~~~)"),Je=new RegExp("^ {0,"+Math.min(3,ie-1)+"}#");L&&(Se=L.split(`
`,1)[0],Oe=Se,this.options.pedantic&&(Oe=Oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(Oe)||Je.test(Oe)||Xe.test(Oe)||_e.test(L)));){if(Oe.search(/[^ ]/)>=ie||!Oe.trim())Ce+=`
`+Oe.slice(ie);else if(!we)Ce+=`
`+Oe;else break;!we&&!Oe.trim()&&(we=!0),_+=Se+`
`,L=L.substring(Se.length+1)}Ue.loose||(Ie?Ue.loose=!0:/\n *\n *$/.test(_)&&(Ie=!0)),this.options.gfm&&(ee=/^\[[ xX]\] /.exec(Ce),ee&&(de=ee[0]!=="[ ] ",Ce=Ce.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:_,task:!!ee,checked:de,loose:!1,text:Ce}),Ue.raw+=_}Ue.items[Ue.items.length-1].raw=_.trimRight(),Ue.items[Ue.items.length-1].text=Ce.trimRight(),Ue.raw=Ue.raw.trimRight();var pe=Ue.items.length;for(me=0;me<pe;me++){this.lexer.state.top=!1,Ue.items[me].tokens=this.lexer.blockTokens(Ue.items[me].text,[]);var Pe=Ue.items[me].tokens.filter(function(Ae){return Ae.type==="space"}),Ne=Pe.every(function(Ae){for(var Me=Ae.raw.split(""),He=0,We=D(Me),Qe;!(Qe=We()).done;){var it=Qe.value;if(it===`
`&&(He+=1),He>1)return!0}return!1});!Ue.loose&&Pe.length&&Ne&&(Ue.loose=!0,Ue.items[me].loose=!0)}return Ue}},J.html=function(L){var H=this.rules.block.html.exec(L);if(H){var _={type:"html",raw:H[0],pre:!this.options.sanitizer&&(H[1]==="pre"||H[1]==="script"||H[1]==="style"),text:H[0]};if(this.options.sanitize){var ee=this.options.sanitizer?this.options.sanitizer(H[0]):d(H[0]);_.type="paragraph",_.text=ee,_.tokens=this.lexer.inline(ee)}return _}},J.def=function(L){var H=this.rules.block.def.exec(L);if(H){H[3]&&(H[3]=H[3].substring(1,H[3].length-1));var _=H[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:_,raw:H[0],href:H[2],title:H[3]}}},J.table=function(L){var H=this.rules.block.table.exec(L);if(H){var _={type:"table",header:P(H[1]).map(function(Ie){return{text:Ie}}),align:H[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:H[3]&&H[3].trim()?H[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(_.header.length===_.align.length){_.raw=H[0];var ee=_.align.length,de,ie,me,we;for(de=0;de<ee;de++)/^ *-+: *$/.test(_.align[de])?_.align[de]="right":/^ *:-+: *$/.test(_.align[de])?_.align[de]="center":/^ *:-+ *$/.test(_.align[de])?_.align[de]="left":_.align[de]=null;for(ee=_.rows.length,de=0;de<ee;de++)_.rows[de]=P(_.rows[de],_.header.length).map(function(Ie){return{text:Ie}});for(ee=_.header.length,ie=0;ie<ee;ie++)_.header[ie].tokens=this.lexer.inline(_.header[ie].text);for(ee=_.rows.length,ie=0;ie<ee;ie++)for(we=_.rows[ie],me=0;me<we.length;me++)we[me].tokens=this.lexer.inline(we[me].text);return _}}},J.lheading=function(L){var H=this.rules.block.lheading.exec(L);if(H)return{type:"heading",raw:H[0],depth:H[2].charAt(0)==="="?1:2,text:H[1],tokens:this.lexer.inline(H[1])}},J.paragraph=function(L){var H=this.rules.block.paragraph.exec(L);if(H){var _=H[1].charAt(H[1].length-1)===`
`?H[1].slice(0,-1):H[1];return{type:"paragraph",raw:H[0],text:_,tokens:this.lexer.inline(_)}}},J.text=function(L){var H=this.rules.block.text.exec(L);if(H)return{type:"text",raw:H[0],text:H[0],tokens:this.lexer.inline(H[0])}},J.escape=function(L){var H=this.rules.inline.escape.exec(L);if(H)return{type:"escape",raw:H[0],text:d(H[1])}},J.tag=function(L){var H=this.rules.inline.tag.exec(L);if(H)return!this.lexer.state.inLink&&/^<a /i.test(H[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(H[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(H[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(H[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:H[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):d(H[0]):H[0]}},J.link=function(L){var H=this.rules.inline.link.exec(L);if(H){var _=H[2].trim();if(!this.options.pedantic&&/^</.test(_)){if(!/>$/.test(_))return;var ee=I(_.slice(0,-1),"\\");if((_.length-ee.length)%2===0)return}else{var de=O(H[2],"()");if(de>-1){var ie=H[0].indexOf("!")===0?5:4,me=ie+H[1].length+de;H[2]=H[2].substring(0,de),H[0]=H[0].substring(0,me).trim(),H[3]=""}}var we=H[2],Ie="";if(this.options.pedantic){var Oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(we);Oe&&(we=Oe[1],Ie=Oe[3])}else Ie=H[3]?H[3].slice(1,-1):"";return we=we.trim(),/^</.test(we)&&(this.options.pedantic&&!/>$/.test(_)?we=we.slice(1):we=we.slice(1,-1)),B(H,{href:we&&we.replace(this.rules.inline._escapes,"$1"),title:Ie&&Ie.replace(this.rules.inline._escapes,"$1")},H[0],this.lexer)}},J.reflink=function(L,H){var _;if((_=this.rules.inline.reflink.exec(L))||(_=this.rules.inline.nolink.exec(L))){var ee=(_[2]||_[1]).replace(/\s+/g," ");if(ee=H[ee.toLowerCase()],!ee||!ee.href){var de=_[0].charAt(0);return{type:"text",raw:de,text:de}}return B(_,ee,_[0],this.lexer)}},J.emStrong=function(L,H,_){_===void 0&&(_="");var ee=this.rules.inline.emStrong.lDelim.exec(L);if(ee&&!(ee[3]&&_.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=ee[1]||ee[2]||"";if(!de||de&&(_===""||this.rules.inline.punctuation.exec(_))){var ie=ee[0].length-1,me,we,Ie=ie,Oe=0,ge=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,H=H.slice(-1*L.length+ie);(ee=ge.exec(H))!=null;)if(me=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!me){if(we=me.length,ee[3]||ee[4]){Ie+=we;continue}else if((ee[5]||ee[6])&&ie%3&&!((ie+we)%3)){Oe+=we;continue}if(Ie-=we,!(Ie>0)){if(we=Math.min(we,we+Ie+Oe),Math.min(ie,we)%2){var Se=L.slice(1,ie+ee.index+we);return{type:"em",raw:L.slice(0,ie+ee.index+we+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var Ce=L.slice(2,ie+ee.index+we-1);return{type:"strong",raw:L.slice(0,ie+ee.index+we+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}}}}},J.codespan=function(L){var H=this.rules.inline.code.exec(L);if(H){var _=H[2].replace(/\n/g," "),ee=/[^ ]/.test(_),de=/^ /.test(_)&&/ $/.test(_);return ee&&de&&(_=_.substring(1,_.length-1)),_=d(_,!0),{type:"codespan",raw:H[0],text:_}}},J.br=function(L){var H=this.rules.inline.br.exec(L);if(H)return{type:"br",raw:H[0]}},J.del=function(L){var H=this.rules.inline.del.exec(L);if(H)return{type:"del",raw:H[0],text:H[2],tokens:this.lexer.inlineTokens(H[2])}},J.autolink=function(L,H){var _=this.rules.inline.autolink.exec(L);if(_){var ee,de;return _[2]==="@"?(ee=d(this.options.mangle?H(_[1]):_[1]),de="mailto:"+ee):(ee=d(_[1]),de=ee),{type:"link",raw:_[0],text:ee,href:de,tokens:[{type:"text",raw:ee,text:ee}]}}},J.url=function(L,H){var _;if(_=this.rules.inline.url.exec(L)){var ee,de;if(_[2]==="@")ee=d(this.options.mangle?H(_[0]):_[0]),de="mailto:"+ee;else{var ie;do ie=_[0],_[0]=this.rules.inline._backpedal.exec(_[0])[0];while(ie!==_[0]);ee=d(_[0]),_[1]==="www."?de="http://"+ee:de=ee}return{type:"link",raw:_[0],text:ee,href:de,tokens:[{type:"text",raw:ee,text:ee}]}}},J.inlineText=function(L,H){var _=this.rules.inline.text.exec(L);if(_){var ee;return this.lexer.state.inRawBlock?ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(_[0]):d(_[0]):_[0]:ee=d(this.options.smartypants?H(_[0]):_[0]),{type:"text",raw:_[0],text:ee}}},Q}(),ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:n,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=p(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=p(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=p(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=p(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=p(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=p(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=b({},ue),ue.gfm=b({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=p(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.paragraph=p(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ue.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=b({},ue.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:n,paragraph:p(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:n,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:n,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=p(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=p(ue._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=p(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=p(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=p(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=p(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=p(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=p(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=p(re.reflink).replace("label",re._label).replace("ref",ue._label).getRegex(),re.nolink=p(re.nolink).replace("ref",ue._label).getRegex(),re.reflinkSearch=p(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=b({},re),re.pedantic=b({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=b({},re.normal,{escape:p(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=p(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=b({},re.gfm,{br:p(re.br).replace("{2,}","*").getRegex(),text:p(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function te(Q){return Q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Q){var J="",U,L,H=Q.length;for(U=0;U<H;U++)L=Q.charCodeAt(U),Math.random()>.5&&(L="x"+L.toString(16)),J+="&#"+L+";";return J}var T=function(){function Q(U){this.tokens=[],this.tokens.links=Object.create(null),this.options=U||le.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var L={block:ue.normal,inline:re.normal};this.options.pedantic?(L.block=ue.pedantic,L.inline=re.pedantic):this.options.gfm&&(L.block=ue.gfm,this.options.breaks?L.inline=re.breaks:L.inline=re.gfm),this.tokenizer.rules=L}Q.lex=function(L,H){var _=new Q(H);return _.lex(L)},Q.lexInline=function(L,H){var _=new Q(H);return _.inlineTokens(L)};var J=Q.prototype;return J.lex=function(L){L=L.replace(/\r\n|\r/g,`
`),this.blockTokens(L,this.tokens);for(var H;H=this.inlineQueue.shift();)this.inlineTokens(H.src,H.tokens);return this.tokens},J.blockTokens=function(L,H){var _=this;H===void 0&&(H=[]),this.options.pedantic?L=L.replace(/\t/g,"    ").replace(/^ +$/gm,""):L=L.replace(/^( *)(\t+)/gm,function(Ie,Oe,ge){return Oe+"    ".repeat(ge.length)});for(var ee,de,ie,me;L;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ie){return(ee=Ie.call({lexer:_},L,H))?(L=L.substring(ee.raw.length),H.push(ee),!0):!1}))){if(ee=this.tokenizer.space(L)){L=L.substring(ee.raw.length),ee.raw.length===1&&H.length>0?H[H.length-1].raw+=`
`:H.push(ee);continue}if(ee=this.tokenizer.code(L)){L=L.substring(ee.raw.length),de=H[H.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+ee.raw,de.text+=`
`+ee.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):H.push(ee);continue}if(ee=this.tokenizer.fences(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.heading(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.hr(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.blockquote(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.list(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.html(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.def(L)){L=L.substring(ee.raw.length),de=H[H.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+ee.raw,de.text+=`
`+ee.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.lheading(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ie=L,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ie=1/0,Oe=L.slice(1),ge=void 0;_.options.extensions.startBlock.forEach(function(Se){ge=Se.call({lexer:this},Oe),typeof ge=="number"&&ge>=0&&(Ie=Math.min(Ie,ge))}),Ie<1/0&&Ie>=0&&(ie=L.substring(0,Ie+1))}(),this.state.top&&(ee=this.tokenizer.paragraph(ie))){de=H[H.length-1],me&&de.type==="paragraph"?(de.raw+=`
`+ee.raw,de.text+=`
`+ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):H.push(ee),me=ie.length!==L.length,L=L.substring(ee.raw.length);continue}if(ee=this.tokenizer.text(L)){L=L.substring(ee.raw.length),de=H[H.length-1],de&&de.type==="text"?(de.raw+=`
`+ee.raw,de.text+=`
`+ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):H.push(ee);continue}if(L){var we="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return this.state.top=!0,H},J.inline=function(L,H){return H===void 0&&(H=[]),this.inlineQueue.push({src:L,tokens:H}),H},J.inlineTokens=function(L,H){var _=this;H===void 0&&(H=[]);var ee,de,ie,me=L,we,Ie,Oe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(we=this.tokenizer.rules.inline.reflinkSearch.exec(me))!=null;)ge.includes(we[0].slice(we[0].lastIndexOf("[")+1,-1))&&(me=me.slice(0,we.index)+"["+j("a",we[0].length-2)+"]"+me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(we=this.tokenizer.rules.inline.blockSkip.exec(me))!=null;)me=me.slice(0,we.index)+"["+j("a",we[0].length-2)+"]"+me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(we=this.tokenizer.rules.inline.escapedEmSt.exec(me))!=null;)me=me.slice(0,we.index)+"++"+me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;L;)if(Ie||(Oe=""),Ie=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ce){return(ee=Ce.call({lexer:_},L,H))?(L=L.substring(ee.raw.length),H.push(ee),!0):!1}))){if(ee=this.tokenizer.escape(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.tag(L)){L=L.substring(ee.raw.length),de=H[H.length-1],de&&ee.type==="text"&&de.type==="text"?(de.raw+=ee.raw,de.text+=ee.text):H.push(ee);continue}if(ee=this.tokenizer.link(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.reflink(L,this.tokens.links)){L=L.substring(ee.raw.length),de=H[H.length-1],de&&ee.type==="text"&&de.type==="text"?(de.raw+=ee.raw,de.text+=ee.text):H.push(ee);continue}if(ee=this.tokenizer.emStrong(L,me,Oe)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.codespan(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.br(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.del(L)){L=L.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.autolink(L,V)){L=L.substring(ee.raw.length),H.push(ee);continue}if(!this.state.inLink&&(ee=this.tokenizer.url(L,V))){L=L.substring(ee.raw.length),H.push(ee);continue}if(ie=L,this.options.extensions&&this.options.extensions.startInline&&function(){var Ce=1/0,Te=L.slice(1),Fe=void 0;_.options.extensions.startInline.forEach(function(Ve){Fe=Ve.call({lexer:this},Te),typeof Fe=="number"&&Fe>=0&&(Ce=Math.min(Ce,Fe))}),Ce<1/0&&Ce>=0&&(ie=L.substring(0,Ce+1))}(),ee=this.tokenizer.inlineText(ie,te)){L=L.substring(ee.raw.length),ee.raw.slice(-1)!=="_"&&(Oe=ee.raw.slice(-1)),Ie=!0,de=H[H.length-1],de&&de.type==="text"?(de.raw+=ee.raw,de.text+=ee.text):H.push(ee);continue}if(L){var Se="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return H},i(Q,null,[{key:"rules",get:function(){return{block:ue,inline:re}}}]),Q}(),x=function(){function Q(U){this.options=U||le.defaults}var J=Q.prototype;return J.code=function(L,H,_){var ee=(H||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(L,ee);de!=null&&de!==L&&(_=!0,L=de)}return L=L.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+d(ee,!0)+'">'+(_?L:d(L,!0))+`</code></pre>
`:"<pre><code>"+(_?L:d(L,!0))+`</code></pre>
`},J.blockquote=function(L){return`<blockquote>
`+L+`</blockquote>
`},J.html=function(L){return L},J.heading=function(L,H,_,ee){if(this.options.headerIds){var de=this.options.headerPrefix+ee.slug(_);return"<h"+H+' id="'+de+'">'+L+"</h"+H+`>
`}return"<h"+H+">"+L+"</h"+H+`>
`},J.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},J.list=function(L,H,_){var ee=H?"ol":"ul",de=H&&_!==1?' start="'+_+'"':"";return"<"+ee+de+`>
`+L+"</"+ee+`>
`},J.listitem=function(L){return"<li>"+L+`</li>
`},J.checkbox=function(L){return"<input "+(L?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},J.paragraph=function(L){return"<p>"+L+`</p>
`},J.table=function(L,H){return H&&(H="<tbody>"+H+"</tbody>"),`<table>
<thead>
`+L+`</thead>
`+H+`</table>
`},J.tablerow=function(L){return`<tr>
`+L+`</tr>
`},J.tablecell=function(L,H){var _=H.header?"th":"td",ee=H.align?"<"+_+' align="'+H.align+'">':"<"+_+">";return ee+L+("</"+_+`>
`)},J.strong=function(L){return"<strong>"+L+"</strong>"},J.em=function(L){return"<em>"+L+"</em>"},J.codespan=function(L){return"<code>"+L+"</code>"},J.br=function(){return this.options.xhtml?"<br/>":"<br>"},J.del=function(L){return"<del>"+L+"</del>"},J.link=function(L,H,_){if(L=l(this.options.sanitize,this.options.baseUrl,L),L===null)return _;var ee='<a href="'+d(L)+'"';return H&&(ee+=' title="'+H+'"'),ee+=">"+_+"</a>",ee},J.image=function(L,H,_){if(L=l(this.options.sanitize,this.options.baseUrl,L),L===null)return _;var ee='<img src="'+L+'" alt="'+_+'"';return H&&(ee+=' title="'+H+'"'),ee+=this.options.xhtml?"/>":">",ee},J.text=function(L){return L},Q}(),Z=function(){function Q(){}var J=Q.prototype;return J.strong=function(L){return L},J.em=function(L){return L},J.codespan=function(L){return L},J.del=function(L){return L},J.html=function(L){return L},J.text=function(L){return L},J.link=function(L,H,_){return""+_},J.image=function(L,H,_){return""+_},J.br=function(){return""},Q}(),G=function(){function Q(){this.seen={}}var J=Q.prototype;return J.serialize=function(L){return L.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},J.getNextSafeSlug=function(L,H){var _=L,ee=0;if(this.seen.hasOwnProperty(_)){ee=this.seen[L];do ee++,_=L+"-"+ee;while(this.seen.hasOwnProperty(_))}return H||(this.seen[L]=ee,this.seen[_]=0),_},J.slug=function(L,H){H===void 0&&(H={});var _=this.serialize(L);return this.getNextSafeSlug(_,H.dryrun)},Q}(),se=function(){function Q(U){this.options=U||le.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new G}Q.parse=function(L,H){var _=new Q(H);return _.parse(L)},Q.parseInline=function(L,H){var _=new Q(H);return _.parseInline(L)};var J=Q.prototype;return J.parse=function(L,H){H===void 0&&(H=!0);var _="",ee,de,ie,me,we,Ie,Oe,ge,Se,Ce,Te,Fe,Ve,Ue,xe,Xe,_e,et,Je,pe=L.length;for(ee=0;ee<pe;ee++){if(Ce=L[ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ce.type]&&(Je=this.options.extensions.renderers[Ce.type].call({parser:this},Ce),Je!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ce.type))){_+=Je||"";continue}switch(Ce.type){case"space":continue;case"hr":{_+=this.renderer.hr();continue}case"heading":{_+=this.renderer.heading(this.parseInline(Ce.tokens),Ce.depth,g(this.parseInline(Ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{_+=this.renderer.code(Ce.text,Ce.lang,Ce.escaped);continue}case"table":{for(ge="",Oe="",me=Ce.header.length,de=0;de<me;de++)Oe+=this.renderer.tablecell(this.parseInline(Ce.header[de].tokens),{header:!0,align:Ce.align[de]});for(ge+=this.renderer.tablerow(Oe),Se="",me=Ce.rows.length,de=0;de<me;de++){for(Ie=Ce.rows[de],Oe="",we=Ie.length,ie=0;ie<we;ie++)Oe+=this.renderer.tablecell(this.parseInline(Ie[ie].tokens),{header:!1,align:Ce.align[ie]});Se+=this.renderer.tablerow(Oe)}_+=this.renderer.table(ge,Se);continue}case"blockquote":{Se=this.parse(Ce.tokens),_+=this.renderer.blockquote(Se);continue}case"list":{for(Te=Ce.ordered,Fe=Ce.start,Ve=Ce.loose,me=Ce.items.length,Se="",de=0;de<me;de++)xe=Ce.items[de],Xe=xe.checked,_e=xe.task,Ue="",xe.task&&(et=this.renderer.checkbox(Xe),Ve?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=et+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=et+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:et}):Ue+=et),Ue+=this.parse(xe.tokens,Ve),Se+=this.renderer.listitem(Ue,_e,Xe);_+=this.renderer.list(Se,Te,Fe);continue}case"html":{_+=this.renderer.html(Ce.text);continue}case"paragraph":{_+=this.renderer.paragraph(this.parseInline(Ce.tokens));continue}case"text":{for(Se=Ce.tokens?this.parseInline(Ce.tokens):Ce.text;ee+1<pe&&L[ee+1].type==="text";)Ce=L[++ee],Se+=`
`+(Ce.tokens?this.parseInline(Ce.tokens):Ce.text);_+=H?this.renderer.paragraph(Se):Se;continue}default:{var Pe='Token with "'+Ce.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return _},J.parseInline=function(L,H){H=H||this.renderer;var _="",ee,de,ie,me=L.length;for(ee=0;ee<me;ee++){if(de=L[ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(ie=this.options.extensions.renderers[de.type].call({parser:this},de),ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){_+=ie||"";continue}switch(de.type){case"escape":{_+=H.text(de.text);break}case"html":{_+=H.html(de.text);break}case"link":{_+=H.link(de.href,de.title,this.parseInline(de.tokens,H));break}case"image":{_+=H.image(de.href,de.title,de.text);break}case"strong":{_+=H.strong(this.parseInline(de.tokens,H));break}case"em":{_+=H.em(this.parseInline(de.tokens,H));break}case"codespan":{_+=H.codespan(de.text);break}case"br":{_+=H.br();break}case"del":{_+=H.del(this.parseInline(de.tokens,H));break}case"text":{_+=H.text(de.text);break}default:{var we='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}}return _},Q}();function ce(Q,J,U){if(typeof Q>"u"||Q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Q)+", string expected");if(typeof J=="function"&&(U=J,J=null),J=b({},ce.defaults,J||{}),R(J),U){var L=J.highlight,H;try{H=T.lex(Q,J)}catch(me){return U(me)}var _=function(we){var Ie;if(!we)try{J.walkTokens&&ce.walkTokens(H,J.walkTokens),Ie=se.parse(H,J)}catch(Oe){we=Oe}return J.highlight=L,we?U(we):U(null,Ie)};if(!L||L.length<3||(delete J.highlight,!H.length))return _();var ee=0;ce.walkTokens(H,function(me){me.type==="code"&&(ee++,setTimeout(function(){L(me.text,me.lang,function(we,Ie){if(we)return _(we);Ie!=null&&Ie!==me.text&&(me.text=Ie,me.escaped=!0),ee--,ee===0&&_()})},0))}),ee===0&&_();return}function de(me){if(me.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+d(me.message+"",!0)+"</pre>";throw me}try{var ie=T.lex(Q,J);if(J.walkTokens){if(J.async)return Promise.all(ce.walkTokens(ie,J.walkTokens)).then(function(){return se.parse(ie,J)}).catch(de);ce.walkTokens(ie,J.walkTokens)}return se.parse(ie,J)}catch(me){de(me)}}ce.options=ce.setOptions=function(Q){return b(ce.defaults,Q),k(ce.defaults),ce},ce.getDefaults=C,ce.defaults=le.defaults,ce.use=function(){for(var Q=arguments.length,J=new Array(Q),U=0;U<Q;U++)J[U]=arguments[U];var L=b.apply(void 0,[{}].concat(J)),H=ce.defaults.extensions||{renderers:{},childTokens:{}},_;J.forEach(function(ee){if(ee.extensions&&(_=!0,ee.extensions.forEach(function(ie){if(!ie.name)throw new Error("extension name required");if(ie.renderer){var me=H.renderers?H.renderers[ie.name]:null;me?H.renderers[ie.name]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var ge=ie.renderer.apply(this,Ie);return ge===!1&&(ge=me.apply(this,Ie)),ge}:H.renderers[ie.name]=ie.renderer}if(ie.tokenizer){if(!ie.level||ie.level!=="block"&&ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");H[ie.level]?H[ie.level].unshift(ie.tokenizer):H[ie.level]=[ie.tokenizer],ie.start&&(ie.level==="block"?H.startBlock?H.startBlock.push(ie.start):H.startBlock=[ie.start]:ie.level==="inline"&&(H.startInline?H.startInline.push(ie.start):H.startInline=[ie.start]))}ie.childTokens&&(H.childTokens[ie.name]=ie.childTokens)})),ee.renderer&&function(){var ie=ce.defaults.renderer||new x,me=function(Oe){var ge=ie[Oe];ie[Oe]=function(){for(var Se=arguments.length,Ce=new Array(Se),Te=0;Te<Se;Te++)Ce[Te]=arguments[Te];var Fe=ee.renderer[Oe].apply(ie,Ce);return Fe===!1&&(Fe=ge.apply(ie,Ce)),Fe}};for(var we in ee.renderer)me(we);L.renderer=ie}(),ee.tokenizer&&function(){var ie=ce.defaults.tokenizer||new fe,me=function(Oe){var ge=ie[Oe];ie[Oe]=function(){for(var Se=arguments.length,Ce=new Array(Se),Te=0;Te<Se;Te++)Ce[Te]=arguments[Te];var Fe=ee.tokenizer[Oe].apply(ie,Ce);return Fe===!1&&(Fe=ge.apply(ie,Ce)),Fe}};for(var we in ee.tokenizer)me(we);L.tokenizer=ie}(),ee.walkTokens){var de=ce.defaults.walkTokens;L.walkTokens=function(ie){var me=[];return me.push(ee.walkTokens.call(this,ie)),de&&(me=me.concat(de.call(this,ie))),me}}_&&(L.extensions=H),ce.setOptions(L)})},ce.walkTokens=function(Q,J){for(var U=[],L=function(){var de=_.value;switch(U=U.concat(J.call(ce,de)),de.type){case"table":{for(var ie=D(de.header),me;!(me=ie()).done;){var we=me.value;U=U.concat(ce.walkTokens(we.tokens,J))}for(var Ie=D(de.rows),Oe;!(Oe=Ie()).done;)for(var ge=Oe.value,Se=D(ge),Ce;!(Ce=Se()).done;){var Te=Ce.value;U=U.concat(ce.walkTokens(Te.tokens,J))}break}case"list":{U=U.concat(ce.walkTokens(de.items,J));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[de.type]?ce.defaults.extensions.childTokens[de.type].forEach(function(Fe){U=U.concat(ce.walkTokens(de[Fe],J))}):de.tokens&&(U=U.concat(ce.walkTokens(de.tokens,J)))}},H=D(Q),_;!(_=H()).done;)L();return U},ce.parseInline=function(Q,J){if(typeof Q>"u"||Q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Q)+", string expected");J=b({},ce.defaults,J||{}),R(J);try{var U=T.lexInline(Q,J);return J.walkTokens&&ce.walkTokens(U,J.walkTokens),se.parseInline(U,J)}catch(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+d(L.message+"",!0)+"</pre>";throw L}},ce.Parser=se,ce.parser=se.parse,ce.Renderer=x,ce.TextRenderer=Z,ce.Lexer=T,ce.lexer=T.lex,ce.Tokenizer=fe,ce.Slugger=G,ce.parse=ce;var ne=ce.options,$e=ce.setOptions,K=ce.use,q=ce.walkTokens,N=ce.parseInline,z=ce,X=se.parse,ae=T.lex;le.Lexer=T,le.Parser=se,le.Renderer=x,le.Slugger=G,le.TextRenderer=Z,le.Tokenizer=fe,le.getDefaults=C,le.lexer=ae,le.marked=ce,le.options=ne,le.parse=z,le.parseInline=N,le.parser=X,le.setOptions=$e,le.use=K,le.walkTokens=q,Object.defineProperty(le,"__esModule",{value:!0})}),define(Ee[149],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=i;function i(c){const g=D(c);if(g&&g.length>0)return new Uint32Array(g)}let A=0;const S=new Uint32Array(10);function D(c){if(A=0,C(c,y,4352),A>0||(C(c,w,4449),A>0)||(C(c,m,4520),A>0)||(C(c,d,12593),A))return S.subarray(0,A);if(c>=44032&&c<=55203){const g=c-44032,u=g%588,p=Math.floor(g/588),f=Math.floor(u/28),h=u%28-1;if(p<y.length?C(p,y,0):4352+p-12593<d.length&&C(4352+p,d,12593),f<w.length?C(f,w,0):4449+f-12593<d.length&&C(4449+f-12593,d,12593),h>=0&&(h<m.length?C(h,m,0):4520+h-12593<d.length&&C(4520+h-12593,d,12593)),A>0)return S.subarray(0,A)}}function C(c,g,u){c>=u&&c<u+g.length&&k(g[c-u])}function k(c){c!==0&&(S[A++]=c&255,c>>8&&(S[A++]=c>>8&255),c>>16&&(S[A++]=c>>16&255))}var v;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var $;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})($||($={}));var E;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(E||(E={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),w=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),m=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),d=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ee[98],ke([1,0,24]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=void 0,e.$Zl=S,e.$1l=C;const A=new i.$Ec(1e4);function S($){return v($,"NFC",A)}const D=new i.$Ec(1e4);function C($){return v($,"NFD",D)}const k=/[^\u0000-\u0080]/;function v($,E,y){if(!$)return $;const w=y.get($);if(w)return w;let m;return k.test($)?m=$.normalize(E):m=$,y.set($,m),m}e.$2l=function(){const $=/[\u0300-\u036f]/g;return function(E){return C(E).replace($,"")}}()}),define(Ee[150],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0,e.$nm=i,e.rot=A;function i(k,v,$){return Math.min(Math.max(k,v),$)}function A(k,v){return(v+k%v)%v}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$pm=S;class D{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$qm=D;class C{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const $=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$rm=C}),function(){function le(S){const D=[];typeof S=="number"&&D.push("code/timeOrigin",S);function C(v){D.push(v,Date.now())}function k(){const v=[];for(let $=0;$<D.length;$+=2)v.push({name:D[$],startTime:D[$+1]});return v}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const C of performance.getEntriesByType("mark"))D.push({name:C.name,startTime:Math.round(S+C.startTime)});return D}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function i(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=i(A))}(),define(Ee[151],ke([1,0,41]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=void 0;const A=Symbol("unset");class S{constructor(){this.a=new C,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||i.Iterable.empty()}insert(v,$,E){this.d(v,y=>y._value=$,E)}mutate(v,$){this.d(v,E=>E._value=$(E._value===A?void 0:E._value))}delete(v){const $=this.c(v);if(!$)return;let E=$.length-1;const y=$[E].node._value;if(y!==A){for(this.b--,$[E].node._value=A;E>0;E--){const{node:w,part:m}=$[E];if(w.children?.size||w._value!==A)break;$[E-1].node.children.delete(m)}return y}}*deleteRecursive(v){const $=this.c(v);if(!$)return;const E=$[$.length-1].node;for(let y=$.length-1;y>0;y--){const w=$[y-1];if(w.node.children.delete($[y].part),w.node.children.size>0||w.node._value!==A)break}for(const y of D(E))y._value!==A&&(this.b--,yield y._value)}find(v){let $=this.a;for(const E of v){const y=$.children?.get(E);if(!y)return;$=y}return $._value===A?void 0:$._value}hasKeyOrParent(v){let $=this.a;for(const E of v){const y=$.children?.get(E);if(!y)return!1;if(y._value!==A)return!0;$=y}return!1}hasKeyOrChildren(v){let $=this.a;for(const E of v){const y=$.children?.get(E);if(!y)return!1;$=y}return!0}hasKey(v){let $=this.a;for(const E of v){const y=$.children?.get(E);if(!y)return!1;$=y}return $._value!==A}c(v){const $=[{part:"",node:this.a}];let E=0;for(const y of v){const w=$[E].node.children?.get(y);if(!w)return;$.push({part:y,node:w}),E++}return $}d(v,$,E){let y=this.a;for(const d of v){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const c=new C;y.children.set(d,c),y=c}else{const c=new C;y.children=new Map([[d,c]]),y=c}E?.(y)}const w=y._value===A?0:1;$(y);const m=y._value===A?0:1;this.b+=m-w}*values(){for(const{_value:v}of D(this.a))v!==A&&(yield v)}}e.$CO=S;function*D(k){const v=[k];for(;v.length>0;){const $=v.pop();if(yield $,$.children)for(const E of $.children.values())v.push(E)}}class C{constructor(){this._value=A}get value(){return this._value===A?void 0:this._value}set value(v){this._value=v===void 0?A:v}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var A in i)(typeof exports=="object"?exports:le)[A]=i[A]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function i(A){if(e[A])return e[A].exports;var S=e[A]={i:A,l:!1,exports:{}};return le[A].call(S.exports,S,S.exports,i),S.l=!0,S.exports}return i.m=le,i.c=e,i.d=function(A,S,D){i.o(A,S)||Object.defineProperty(A,S,{enumerable:!0,get:D})},i.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},i.t=function(A,S){if(1&S&&(A=i(A)),8&S||4&S&&typeof A=="object"&&A&&A.__esModule)return A;var D=Object.create(null);if(i.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:A}),2&S&&typeof A!="string")for(var C in A)i.d(D,C,function(k){return A[k]}.bind(null,C));return D},i.n=function(A){var S=A&&A.__esModule?function(){return A.default}:function(){return A};return i.d(S,"a",S),S},i.o=function(A,S){return Object.prototype.hasOwnProperty.call(A,S)},i.p="",i(i.s=0)}([function(le,e,i){(function(A){var S;e=le.exports=K,S=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],v=e.src=[],$=0,E=$++;v[E]="0|[1-9]\\d*";var y=$++;v[y]="[0-9]+";var w=$++;v[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=$++;v[m]="("+v[E]+")\\.("+v[E]+")\\.("+v[E]+")";var d=$++;v[d]="("+v[y]+")\\.("+v[y]+")\\.("+v[y]+")";var c=$++;v[c]="(?:"+v[E]+"|"+v[w]+")";var g=$++;v[g]="(?:"+v[y]+"|"+v[w]+")";var u=$++;v[u]="(?:-("+v[c]+"(?:\\."+v[c]+")*))";var p=$++;v[p]="(?:-?("+v[g]+"(?:\\."+v[g]+")*))";var f=$++;v[f]="[0-9A-Za-z-]+";var h=$++;v[h]="(?:\\+("+v[f]+"(?:\\."+v[f]+")*))";var l=$++,t="v?"+v[m]+v[u]+"?"+v[h]+"?";v[l]="^"+t+"$";var a="[v=\\s]*"+v[d]+v[p]+"?"+v[h]+"?",o=$++;v[o]="^"+a+"$";var r=$++;v[r]="((?:<|>)?=?)";var s=$++;v[s]=v[y]+"|x|X|\\*";var n=$++;v[n]=v[E]+"|x|X|\\*";var b=$++;v[b]="[v=\\s]*("+v[n]+")(?:\\.("+v[n]+")(?:\\.("+v[n]+")(?:"+v[u]+")?"+v[h]+"?)?)?";var P=$++;v[P]="[v=\\s]*("+v[s]+")(?:\\.("+v[s]+")(?:\\.("+v[s]+")(?:"+v[p]+")?"+v[h]+"?)?)?";var I=$++;v[I]="^"+v[r]+"\\s*"+v[b]+"$";var O=$++;v[O]="^"+v[r]+"\\s*"+v[P]+"$";var R=$++;v[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=$++;v[j]="(?:~>?)";var B=$++;v[B]="(\\s*)"+v[j]+"\\s+",k[B]=new RegExp(v[B],"g");var Y=$++;v[Y]="^"+v[j]+v[b]+"$";var fe=$++;v[fe]="^"+v[j]+v[P]+"$";var ue=$++;v[ue]="(?:\\^)";var re=$++;v[re]="(\\s*)"+v[ue]+"\\s+",k[re]=new RegExp(v[re],"g");var te=$++;v[te]="^"+v[ue]+v[b]+"$";var V=$++;v[V]="^"+v[ue]+v[P]+"$";var T=$++;v[T]="^"+v[r]+"\\s*("+a+")$|^$";var x=$++;v[x]="^"+v[r]+"\\s*("+t+")$|^$";var Z=$++;v[Z]="(\\s*)"+v[r]+"\\s*("+a+"|"+v[b]+")",k[Z]=new RegExp(v[Z],"g");var G=$++;v[G]="^\\s*("+v[b]+")\\s+-\\s+("+v[b]+")\\s*$";var se=$++;v[se]="^\\s*("+v[P]+")\\s+-\\s+("+v[P]+")\\s*$";var ce=$++;v[ce]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)S(ne,v[ne]),k[ne]||(k[ne]=new RegExp(v[ne]));function $e(ge,Se){if(ge instanceof K)return ge;if(typeof ge!="string"||ge.length>D||!(Se?k[o]:k[l]).test(ge))return null;try{return new K(ge,Se)}catch{return null}}function K(ge,Se){if(ge instanceof K){if(ge.loose===Se)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof K))return new K(ge,Se);S("SemVer",ge,Se),this.loose=Se;var Ce=ge.trim().match(Se?k[o]:k[l]);if(!Ce)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+Ce[1],this.minor=+Ce[2],this.patch=+Ce[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");Ce[4]?this.prerelease=Ce[4].split(".").map(function(Te){if(/^[0-9]+$/.test(Te)){var Fe=+Te;if(Fe>=0&&Fe<C)return Fe}return Te}):this.prerelease=[],this.build=Ce[5]?Ce[5].split("."):[],this.format()}e.parse=$e,e.valid=function(ge,Se){var Ce=$e(ge,Se);return Ce?Ce.version:null},e.clean=function(ge,Se){var Ce=$e(ge.trim().replace(/^[=v]+/,""),Se);return Ce?Ce.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ge){return S("SemVer.compare",this.version,this.loose,ge),ge instanceof K||(ge=new K(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},K.prototype.compareMain=function(ge){return ge instanceof K||(ge=new K(ge,this.loose)),N(this.major,ge.major)||N(this.minor,ge.minor)||N(this.patch,ge.patch)},K.prototype.comparePre=function(ge){if(ge instanceof K||(ge=new K(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Se=0;do{var Ce=this.prerelease[Se],Te=ge.prerelease[Se];if(S("prerelease compare",Se,Ce,Te),Ce===void 0&&Te===void 0)return 0;if(Te===void 0)return 1;if(Ce===void 0)return-1;if(Ce!==Te)return N(Ce,Te)}while(++Se)},K.prototype.inc=function(ge,Se){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ce=this.prerelease.length;--Ce>=0;)typeof this.prerelease[Ce]=="number"&&(this.prerelease[Ce]++,Ce=-2);Ce===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Se,Ce,Te){typeof Ce=="string"&&(Te=Ce,Ce=void 0);try{return new K(ge,Ce).inc(Se,Te).version}catch{return null}},e.diff=function(ge,Se){if(Q(ge,Se))return null;var Ce=$e(ge),Te=$e(Se);if(Ce.prerelease.length||Te.prerelease.length){for(var Fe in Ce)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&Ce[Fe]!==Te[Fe])return"pre"+Fe;return"prerelease"}for(var Fe in Ce)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&Ce[Fe]!==Te[Fe])return Fe},e.compareIdentifiers=N;var q=/^[0-9]+$/;function N(ge,Se){var Ce=q.test(ge),Te=q.test(Se);return Ce&&Te&&(ge=+ge,Se=+Se),Ce&&!Te?-1:Te&&!Ce?1:ge<Se?-1:ge>Se?1:0}function z(ge,Se,Ce){return new K(ge,Ce).compare(new K(Se,Ce))}function X(ge,Se,Ce){return z(ge,Se,Ce)>0}function ae(ge,Se,Ce){return z(ge,Se,Ce)<0}function Q(ge,Se,Ce){return z(ge,Se,Ce)===0}function J(ge,Se,Ce){return z(ge,Se,Ce)!==0}function U(ge,Se,Ce){return z(ge,Se,Ce)>=0}function L(ge,Se,Ce){return z(ge,Se,Ce)<=0}function H(ge,Se,Ce,Te){var Fe;switch(Se){case"===":typeof ge=="object"&&(ge=ge.version),typeof Ce=="object"&&(Ce=Ce.version),Fe=ge===Ce;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof Ce=="object"&&(Ce=Ce.version),Fe=ge!==Ce;break;case"":case"=":case"==":Fe=Q(ge,Ce,Te);break;case"!=":Fe=J(ge,Ce,Te);break;case">":Fe=X(ge,Ce,Te);break;case">=":Fe=U(ge,Ce,Te);break;case"<":Fe=ae(ge,Ce,Te);break;case"<=":Fe=L(ge,Ce,Te);break;default:throw new TypeError("Invalid operator: "+Se)}return Fe}function _(ge,Se){if(ge instanceof _){if(ge.loose===Se)return ge;ge=ge.value}if(!(this instanceof _))return new _(ge,Se);S("comparator",ge,Se),this.loose=Se,this.parse(ge),this.semver===ee?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(ge,Se){return N(Se,ge)},e.major=function(ge,Se){return new K(ge,Se).major},e.minor=function(ge,Se){return new K(ge,Se).minor},e.patch=function(ge,Se){return new K(ge,Se).patch},e.compare=z,e.compareLoose=function(ge,Se){return z(ge,Se,!0)},e.rcompare=function(ge,Se,Ce){return z(Se,ge,Ce)},e.sort=function(ge,Se){return ge.sort(function(Ce,Te){return e.compare(Ce,Te,Se)})},e.rsort=function(ge,Se){return ge.sort(function(Ce,Te){return e.rcompare(Ce,Te,Se)})},e.gt=X,e.lt=ae,e.eq=Q,e.neq=J,e.gte=U,e.lte=L,e.cmp=H,e.Comparator=_;var ee={};function de(ge,Se){if(ge instanceof de)return ge.loose===Se?ge:new de(ge.raw,Se);if(ge instanceof _)return new de(ge.value,Se);if(!(this instanceof de))return new de(ge,Se);if(this.loose=Se,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(Ce){return this.parseRange(Ce.trim())},this).filter(function(Ce){return Ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function ie(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function me(ge,Se,Ce,Te,Fe,Ve,Ue,xe,Xe,_e,et,Je,pe){return((Se=ie(Ce)?"":ie(Te)?">="+Ce+".0.0":ie(Fe)?">="+Ce+"."+Te+".0":">="+Se)+" "+(xe=ie(Xe)?"":ie(_e)?"<"+(+Xe+1)+".0.0":ie(et)?"<"+Xe+"."+(+_e+1)+".0":Je?"<="+Xe+"."+_e+"."+et+"-"+Je:"<="+xe)).trim()}function we(ge,Se){for(var Ce=0;Ce<ge.length;Ce++)if(!ge[Ce].test(Se))return!1;if(Se.prerelease.length){for(Ce=0;Ce<ge.length;Ce++)if(S(ge[Ce].semver),ge[Ce].semver!==ee&&ge[Ce].semver.prerelease.length>0){var Te=ge[Ce].semver;if(Te.major===Se.major&&Te.minor===Se.minor&&Te.patch===Se.patch)return!0}return!1}return!0}function Ie(ge,Se,Ce){try{Se=new de(Se,Ce)}catch{return!1}return Se.test(ge)}function Oe(ge,Se,Ce,Te){var Fe,Ve,Ue,xe,Xe;switch(ge=new K(ge,Te),Se=new de(Se,Te),Ce){case">":Fe=X,Ve=L,Ue=ae,xe=">",Xe=">=";break;case"<":Fe=ae,Ve=U,Ue=X,xe="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ie(ge,Se,Te))return!1;for(var _e=0;_e<Se.set.length;++_e){var et=Se.set[_e],Je=null,pe=null;if(et.forEach(function(Pe){Pe.semver===ee&&(Pe=new _(">=0.0.0")),Je=Je||Pe,pe=pe||Pe,Fe(Pe.semver,Je.semver,Te)?Je=Pe:Ue(Pe.semver,pe.semver,Te)&&(pe=Pe)}),Je.operator===xe||Je.operator===Xe||(!pe.operator||pe.operator===xe)&&Ve(ge,pe.semver)||pe.operator===Xe&&Ue(ge,pe.semver))return!1}return!0}_.prototype.parse=function(ge){var Se=this.loose?k[T]:k[x],Ce=ge.match(Se);if(!Ce)throw new TypeError("Invalid comparator: "+ge);this.operator=Ce[1],this.operator==="="&&(this.operator=""),Ce[2]?this.semver=new K(Ce[2],this.loose):this.semver=ee},_.prototype.toString=function(){return this.value},_.prototype.test=function(ge){return S("Comparator.test",ge,this.loose),this.semver===ee||(typeof ge=="string"&&(ge=new K(ge,this.loose)),H(ge,this.operator,this.semver,this.loose))},_.prototype.intersects=function(ge,Se){if(!(ge instanceof _))throw new TypeError("a Comparator is required");var Ce;if(this.operator==="")return Ce=new de(ge.value,Se),Ie(this.value,Ce,Se);if(ge.operator==="")return Ce=new de(this.value,Se),Ie(ge.semver,Ce,Se);var Te=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),Fe=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),Ve=this.semver.version===ge.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),xe=H(this.semver,"<",ge.semver,Se)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),Xe=H(this.semver,">",ge.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return Te||Fe||Ve&&Ue||xe||Xe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ge){var Se=this.loose;ge=ge.trim(),S("range",ge,Se);var Ce=Se?k[se]:k[G];ge=ge.replace(Ce,me),S("hyphen replace",ge),ge=ge.replace(k[Z],"$1$2$3"),S("comparator trim",ge,k[Z]),ge=(ge=(ge=ge.replace(k[B],"$1~")).replace(k[re],"$1^")).split(/\s+/).join(" ");var Te=Se?k[T]:k[x],Fe=ge.split(" ").map(function(Ve){return function(Ue,xe){return S("comp",Ue),Ue=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(et){return function(Je,pe){S("caret",Je,pe);var Pe=pe?k[V]:k[te];return Je.replace(Pe,function(Ne,Ae,Me,He,We){var Qe;return S("caret",Je,Ne,Ae,Me,He,We),ie(Ae)?Qe="":ie(Me)?Qe=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":ie(He)?Qe=Ae==="0"?">="+Ae+"."+Me+".0 <"+Ae+"."+(+Me+1)+".0":">="+Ae+"."+Me+".0 <"+(+Ae+1)+".0.0":We?(S("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),Qe=Ae==="0"?Me==="0"?">="+Ae+"."+Me+"."+He+We+" <"+Ae+"."+Me+"."+(+He+1):">="+Ae+"."+Me+"."+He+We+" <"+Ae+"."+(+Me+1)+".0":">="+Ae+"."+Me+"."+He+We+" <"+(+Ae+1)+".0.0"):(S("no pr"),Qe=Ae==="0"?Me==="0"?">="+Ae+"."+Me+"."+He+" <"+Ae+"."+Me+"."+(+He+1):">="+Ae+"."+Me+"."+He+" <"+Ae+"."+(+Me+1)+".0":">="+Ae+"."+Me+"."+He+" <"+(+Ae+1)+".0.0"),S("caret return",Qe),Qe})}(et,_e)}).join(" ")}(Ue,xe),S("caret",Ue),Ue=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(et){return function(Je,pe){var Pe=pe?k[fe]:k[Y];return Je.replace(Pe,function(Ne,Ae,Me,He,We){var Qe;return S("tilde",Je,Ne,Ae,Me,He,We),ie(Ae)?Qe="":ie(Me)?Qe=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":ie(He)?Qe=">="+Ae+"."+Me+".0 <"+Ae+"."+(+Me+1)+".0":We?(S("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),Qe=">="+Ae+"."+Me+"."+He+We+" <"+Ae+"."+(+Me+1)+".0"):Qe=">="+Ae+"."+Me+"."+He+" <"+Ae+"."+(+Me+1)+".0",S("tilde return",Qe),Qe})}(et,_e)}).join(" ")}(Ue,xe),S("tildes",Ue),Ue=function(Xe,_e){return S("replaceXRanges",Xe,_e),Xe.split(/\s+/).map(function(et){return function(Je,pe){Je=Je.trim();var Pe=pe?k[O]:k[I];return Je.replace(Pe,function(Ne,Ae,Me,He,We,Qe){S("xRange",Je,Ne,Ae,Me,He,We,Qe);var it=ie(Me),Ye=it||ie(He),nt=Ye||ie(We);return Ae==="="&&nt&&(Ae=""),it?Ne=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&nt?(Ye&&(He=0),nt&&(We=0),Ae===">"?(Ae=">=",Ye?(Me=+Me+1,He=0,We=0):nt&&(He=+He+1,We=0)):Ae==="<="&&(Ae="<",Ye?Me=+Me+1:He=+He+1),Ne=Ae+Me+"."+He+"."+We):Ye?Ne=">="+Me+".0.0 <"+(+Me+1)+".0.0":nt&&(Ne=">="+Me+"."+He+".0 <"+Me+"."+(+He+1)+".0"),S("xRange return",Ne),Ne})}(et,_e)}).join(" ")}(Ue,xe),S("xrange",Ue),Ue=function(Xe,_e){return S("replaceStars",Xe,_e),Xe.trim().replace(k[ce],"")}(Ue,xe),S("stars",Ue),Ue}(Ve,Se)}).join(" ").split(/\s+/);return this.loose&&(Fe=Fe.filter(function(Ve){return!!Ve.match(Te)})),Fe=Fe.map(function(Ve){return new _(Ve,Se)})},de.prototype.intersects=function(ge,Se){if(!(ge instanceof de))throw new TypeError("a Range is required");return this.set.some(function(Ce){return Ce.every(function(Te){return ge.set.some(function(Fe){return Fe.every(function(Ve){return Te.intersects(Ve,Se)})})})})},e.toComparators=function(ge,Se){return new de(ge,Se).set.map(function(Ce){return Ce.map(function(Te){return Te.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new K(ge,this.loose));for(var Se=0;Se<this.set.length;Se++)if(we(this.set[Se],ge))return!0;return!1},e.satisfies=Ie,e.maxSatisfying=function(ge,Se,Ce){var Te=null,Fe=null;try{var Ve=new de(Se,Ce)}catch{return null}return ge.forEach(function(Ue){Ve.test(Ue)&&(Te&&Fe.compare(Ue)!==-1||(Fe=new K(Te=Ue,Ce)))}),Te},e.minSatisfying=function(ge,Se,Ce){var Te=null,Fe=null;try{var Ve=new de(Se,Ce)}catch{return null}return ge.forEach(function(Ue){Ve.test(Ue)&&(Te&&Fe.compare(Ue)!==1||(Fe=new K(Te=Ue,Ce)))}),Te},e.validRange=function(ge,Se){try{return new de(ge,Se).range||"*"}catch{return null}},e.ltr=function(ge,Se,Ce){return Oe(ge,Se,"<",Ce)},e.gtr=function(ge,Se,Ce){return Oe(ge,Se,">",Ce)},e.outside=Oe,e.prerelease=function(ge,Se){var Ce=$e(ge,Se);return Ce&&Ce.prerelease.length?Ce.prerelease:null},e.intersects=function(ge,Se,Ce){return ge=new de(ge,Ce),Se=new de(Se,Ce),ge.intersects(Se)},e.coerce=function(ge){if(ge instanceof K)return ge;if(typeof ge!="string")return null;var Se=ge.match(k[R]);return Se==null?null:$e((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,i(1))},function(le,e){var i,A,S=le.exports={};function D(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function k(g){if(i===setTimeout)return setTimeout(g,0);if((i===D||!i)&&setTimeout)return i=setTimeout,setTimeout(g,0);try{return i(g,0)}catch{try{return i.call(null,g,0)}catch{return i.call(this,g,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:D}catch{i=D}try{A=typeof clearTimeout=="function"?clearTimeout:C}catch{A=C}})();var v,$=[],E=!1,y=-1;function w(){E&&v&&(E=!1,v.length?$=v.concat($):y=-1,$.length&&m())}function m(){if(!E){var g=k(w);E=!0;for(var u=$.length;u;){for(v=$,$=[];++y<u;)v&&v[y].run();y=-1,u=$.length}v=null,E=!1,function(p){if(A===clearTimeout)return clearTimeout(p);if((A===C||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(p);try{A(p)}catch{try{return A.call(null,p)}catch{return A.call(this,p)}}}(g)}}function d(g,u){this.fun=g,this.array=u}function c(){}S.nextTick=function(g){var u=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)u[p-1]=arguments[p];$.push(new d(g,u)),$.length!==1||E||k(m)},d.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=c,S.addListener=c,S.once=c,S.off=c,S.removeListener=c,S.removeAllListeners=c,S.emit=c,S.prependListener=c,S.prependOnceListener=c,S.listeners=function(g){return[]},S.binding=function(g){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(g){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Ee[152],ke([1,0]),function(le,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class A{constructor(k,v,$){this.level=k,this.key=v,this.value=$,this.forward=[]}}const S=void 0;class D{constructor(k,v=2**16){this.comparator=k,this[i]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new A(this.c,S,S)}get size(){return this.f}clear(){this.e=new A(this.c,S,S),this.f=0}has(k){return!!D.g(this,k,this.comparator)}get(k){return D.g(this,k,this.comparator)?.value}set(k,v){return D.h(this,k,v,this.comparator)&&(this.f+=1),this}delete(k){const v=D.k(this,k,this.comparator);return v&&(this.f-=1),v}forEach(k,v){let $=this.e.forward[0];for(;$;)k.call(v,$.value,$.key,this),$=$.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",v=this.e.forward[0];for(;v;)k+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return k}static g(k,v,$){let E=k.e;for(let y=k.d-1;y>=0;y--)for(;E.forward[y]&&$(E.forward[y].key,v)<0;)E=E.forward[y];if(E=E.forward[0],E&&$(E.key,v)===0)return E}static h(k,v,$,E){const y=[];let w=k.e;for(let m=k.d-1;m>=0;m--){for(;w.forward[m]&&E(w.forward[m].key,v)<0;)w=w.forward[m];y[m]=w}if(w=w.forward[0],w&&E(w.key,v)===0)return w.value=$,!1;{const m=D.j(k);if(m>k.d){for(let d=k.d;d<m;d++)y[d]=k.e;k.d=m}w=new A(m,v,$);for(let d=0;d<m;d++)w.forward[d]=y[d].forward[d],y[d].forward[d]=w;return!0}}static j(k,v=.5){let $=1;for(;Math.random()<v&&$<k.c;)$+=1;return $}static k(k,v,$){const E=[];let y=k.e;for(let w=k.d-1;w>=0;w--){for(;y.forward[w]&&$(y.forward[w].key,v)<0;)y=y.forward[w];E[w]=y}if(y=y.forward[0],!y||$(y.key,v)!==0)return!1;for(let w=0;w<k.d&&E[w].forward[w]===y;w++)E[w].forward[w]=y.forward[w];for(;k.d>0&&k.e.forward[k.d-1]===S;)k.d-=1;return!0}}e.$is=D}),define(Ee[61],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(D){return new A(D)}constructor(D){this.c=i&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=A}),define(Ee[6],ke([1,0,10,75,2,97,61]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=m;const k=!1,v=!1,$=!1;var E;(function(R){R.None=()=>S.$Uc.None;function j(_){if($){const{onDidAddListener:ee}=_,de=c.create();let ie=0;_.onDidAddListener=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),ee?.()}}}function B(_,ee){return G(_,()=>{},0,void 0,!0,void 0,ee)}R.defer=B;function Y(_){return(ee,de=null,ie)=>{let me=!1,we;return we=_(Ie=>{if(!me)return we?we.dispose():me=!0,ee.call(de,Ie)},null,ie),me&&we.dispose(),we}}R.once=Y;function fe(_,ee,de){return x((ie,me=null,we)=>_(Ie=>ie.call(me,ee(Ie)),null,we),de)}R.map=fe;function ue(_,ee,de){return x((ie,me=null,we)=>_(Ie=>{ee(Ie),ie.call(me,Ie)},null,we),de)}R.forEach=ue;function re(_,ee,de){return x((ie,me=null,we)=>_(Ie=>ee(Ie)&&ie.call(me,Ie),null,we),de)}R.filter=re;function te(_){return _}R.signal=te;function V(..._){return(ee,de=null,ie)=>{const me=(0,S.$Rc)(..._.map(we=>we(Ie=>ee.call(de,Ie))));return Z(me,ie)}}R.any=V;function T(_,ee,de,ie){let me=de;return fe(_,we=>(me=ee(me,we),me),ie)}R.reduce=T;function x(_,ee){let de;const ie={onWillAddFirstListener(){de=_(me.fire,me)},onDidRemoveLastListener(){de?.dispose()}};ee||j(ie);const me=new l(ie);return ee?.add(me),me.event}function Z(_,ee){return ee instanceof Array?ee.push(_):ee&&ee.add(_),_}function G(_,ee,de=100,ie=!1,me=!1,we,Ie){let Oe,ge,Se,Ce=0,Te;const Fe={leakWarningThreshold:we,onWillAddFirstListener(){Oe=_(Ue=>{Ce++,ge=ee(ge,Ue),ie&&!Se&&(Ve.fire(ge),ge=void 0),Te=()=>{const xe=ge;ge=void 0,Se=void 0,(!ie||Ce>1)&&Ve.fire(xe),Ce=0},typeof de=="number"?(clearTimeout(Se),Se=setTimeout(Te,de)):Se===void 0&&(Se=0,queueMicrotask(Te))})},onWillRemoveListener(){me&&Ce>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,Oe.dispose()}};Ie||j(Fe);const Ve=new l(Fe);return Ie?.add(Ve),Ve.event}R.debounce=G;function se(_,ee=0,de){return R.debounce(_,(ie,me)=>ie?(ie.push(me),ie):[me],ee,void 0,!0,void 0,de)}R.accumulate=se;function ce(_,ee=(ie,me)=>ie===me,de){let ie=!0,me;return re(_,we=>{const Ie=ie||!ee(we,me);return ie=!1,me=we,Ie},de)}R.latch=ce;function ne(_,ee,de){return[R.filter(_,ee,de),R.filter(_,ie=>!ee(ie),de)]}R.split=ne;function $e(_,ee=!1,de=[],ie){let me=de.slice(),we=_(ge=>{me?me.push(ge):Oe.fire(ge)});ie&&ie.add(we);const Ie=()=>{me?.forEach(ge=>Oe.fire(ge)),me=null},Oe=new l({onWillAddFirstListener(){we||(we=_(ge=>Oe.fire(ge)),ie&&ie.add(we))},onDidAddFirstListener(){me&&(ee?setTimeout(Ie):Ie())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return ie&&ie.add(Oe),Oe.event}R.buffer=$e;function K(_,ee){return(ie,me,we)=>{const Ie=ee(new N);return _(function(Oe){const ge=Ie.evaluate(Oe);ge!==q&&ie.call(me,ge)},void 0,we)}}R.chain=K;const q=Symbol("HaltChainable");class N{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(de=>(ee(de),de)),this}filter(ee){return this.f.push(de=>ee(de)?de:q),this}reduce(ee,de){let ie=de;return this.f.push(me=>(ie=ee(ie,me),ie)),this}latch(ee=(de,ie)=>de===ie){let de=!0,ie;return this.f.push(me=>{const we=de||!ee(me,ie);return de=!1,ie=me,we?me:q}),this}evaluate(ee){for(const de of this.f)if(ee=de(ee),ee===q)break;return ee}}function z(_,ee,de=ie=>ie){const ie=(...Oe)=>Ie.fire(de(...Oe)),me=()=>_.on(ee,ie),we=()=>_.removeListener(ee,ie),Ie=new l({onWillAddFirstListener:me,onDidRemoveLastListener:we});return Ie.event}R.fromNodeEventEmitter=z;function X(_,ee,de=ie=>ie){const ie=(...Oe)=>Ie.fire(de(...Oe)),me=()=>_.addEventListener(ee,ie),we=()=>_.removeEventListener(ee,ie),Ie=new l({onWillAddFirstListener:me,onDidRemoveLastListener:we});return Ie.event}R.fromDOMEventEmitter=X;function ae(_){return new Promise(ee=>Y(_)(ee))}R.toPromise=ae;function Q(_){const ee=new l;return _.then(de=>{ee.fire(de)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}R.fromPromise=Q;function J(_,ee,de){return ee(de),_(ie=>ee(ie))}R.runAndSubscribe=J;class U{constructor(ee,de){this._observable=ee,this.f=0,this.g=!1;const ie={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};de||j(ie),this.emitter=new l(ie),de&&de.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,de){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function L(_,ee){return new U(_,ee).emitter.event}R.fromObservable=L;function H(_){return(ee,de,ie)=>{let me=0,we=!1;const Ie={beginUpdate(){me++},endUpdate(){me--,me===0&&(_.reportChanges(),we&&(we=!1,ee.call(de)))},handlePossibleChange(){},handleChange(){we=!0}};_.addObserver(Ie),_.reportChanges();const Oe={dispose(){_.removeObserver(Ie)}};return ie instanceof S.$Tc?ie.add(Oe):Array.isArray(ie)&&ie.push(Oe),Oe}}R.fromObservableLight=H})(E||(e.Event=E={}));class y{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${y.f++}`,y.all.add(this)}start(j){this.g=new C.$3d,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$5d=y;let w=-1;function m(R){const j=w;return w=R,{dispose(){w=j}}}class d{constructor(j,B=Math.random().toString(18).slice(2,5)){this.threshold=j,this.name=B,this.g=0}dispose(){this.f?.clear()}check(j,B){const Y=this.threshold;if(Y<=0||B<Y)return;this.f||(this.f=new Map);const fe=this.f.get(j.value)||0;if(this.f.set(j.value,fe+1),this.g-=1,this.g<=0){this.g=Y*.5;let ue,re=0;for(const[te,V]of this.f)(!ue||re<V)&&(ue=te,re=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${B} listeners already. MOST frequent listener (${re}):`),console.warn(ue)}return()=>{const ue=this.f.get(j.value)||0;this.f.set(j.value,ue-1)}}}class c{static create(){return new c(new Error().stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class u{constructor(j){this.value=j,this.id=g++}}const p=2,f=(R,j)=>{if(R instanceof u)j(R);else for(let B=0;B<R.length;B++){const Y=R[B];Y&&j(Y)}},h=k?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class l{constructor(j){this.w=0,this.f=j,this.g=w>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(v){const j=this.t;queueMicrotask(()=>{f(j,B=>B.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,B,Y)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),S.$Uc.None;if(this.m)return S.$Uc.None;B&&(j=j.bind(B));const fe=new u(j);let ue,re;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(fe.stack=c.create(),ue=this.g.check(fe.stack,this.w+1)),v&&(fe.stack=re??c.create()),this.t?this.t instanceof u?(this.u??=new a,this.t=[this.t,fe]):this.t.push(fe):(this.f?.onWillAddFirstListener?.(this),this.t=fe,this.f?.onDidAddFirstListener?.(this)),this.w++;const te=(0,S.$Sc)(()=>{h?.unregister(te),ue?.(),this.x(fe)});if(Y instanceof S.$Tc?Y.add(te):Array.isArray(Y)&&Y.push(te),h){const V=new Error().stack.split(`
`).slice(2).join(`
`).trim();h.register(te,V,te)}return te},this.q}x(j){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const B=this.t,Y=B.indexOf(j);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,B[Y]=void 0;const fe=this.u.current===this;if(this.w*p<=B.length){let ue=0;for(let re=0;re<B.length;re++)B[re]?B[ue++]=B[re]:fe&&(this.u.end--,ue<this.u.i&&this.u.i--);B.length=ue}}y(j,B){if(!j)return;const Y=this.f?.onListenerError||i.$1;if(!Y){j.value(B);return}try{j.value(B)}catch(fe){Y(fe)}}z(j){const B=j.current.t;for(;j.i<j.end;)this.y(B[j.i++],j.value);j.reset()}fire(j){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,j);else{const B=this.u;B.enqueue(this,j,this.t.length),this.z(B)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=l;const t=()=>new a;e.$8d=t;class a{constructor(){this.i=-1,this.end=0}enqueue(j,B,Y){this.i=0,this.end=Y,this.current=j,this.value=B}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends l{async fireAsync(j,B,Y){if(this.t)for(this.h||(this.h=new D.$5c),f(this.t,fe=>this.h.push([fe.value,j]));this.h.size>0&&!B.isCancellationRequested;){const[fe,ue]=this.h.shift(),re=[],te={...ue,token:B,waitUntil:V=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");Y&&(V=Y(V,fe)),re.push(V)}};try{fe(te)}catch(V){(0,i.$1)(V);continue}Object.freeze(re),await Promise.allSettled(re).then(V=>{for(const T of V)T.status==="rejected"&&(0,i.$1)(T.reason)})}}}e.$9d=o;class r extends l{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new D.$5c,this.A=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.A(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.w&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$0d=r;class s extends r{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$$d=s;class n extends l{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(B=>super.fire(B)),this.h=[]}))}}e.$_d=n;class b{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const B={event:j,listener:null};this.h.push(B),this.g&&this.m(B);const Y=()=>{this.g&&this.o(B);const fe=this.h.indexOf(B);this.h.splice(fe,1)};return(0,S.$Sc)((0,A.$db)(Y))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(B=>this.f.fire(B))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$ae=b;class P{constructor(j,B,Y,fe){this.f=new S.$Tc;const ue=this.f.add(new b),re=this.f.add(new S.$4c);function te(V){re.set(V,ue.add(fe(V)))}for(const V of j)te(V);this.f.add(B(V=>{te(V)})),this.f.add(Y(V=>{re.deleteAndDispose(V)})),this.event=ue.event}dispose(){this.f.dispose()}}e.$be=P;class I{constructor(){this.f=[]}wrapEvent(j){return(B,Y,fe)=>j(ue=>{const re=this.f[this.f.length-1];re?re.push(()=>B.call(Y,ue)):B.call(Y,ue)},void 0,fe)}bufferEvents(j){const B=[];this.f.push(B);const Y=j();return this.f.pop(),B.forEach(fe=>fe()),Y}}e.$ce=I;class O{constructor(){this.f=!1,this.g=E.None,this.h=S.$Uc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=O}),define(Ee[20],ke([1,0,6]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const A=Object.freeze(function(k,v){const $=setTimeout(k.bind(v),0);return{dispose(){clearTimeout($)}}});var S;(function(k){function v($){return $===k.None||$===k.Cancelled||$ instanceof D?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}k.isCancellationToken=v,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(S||(e.CancellationToken=S={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new i.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(v){this.f=void 0,this.g=void 0,this.g=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=S.Cancelled}dispose(v=!1){v&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=S.None}}e.$ee=C}),define(Ee[153],ke([1,0,20]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class A{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new i.$ee,v=this.b(k.token);return this.a={promise:v,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.$Pe=A;class S{constructor(k,v=JSON.stringify){this.c=k,this.d=v,this.a=void 0,this.b=void 0}get(k){const v=this.d(k);return this.b!==v&&(this.b=v,this.a=this.c(k)),this.a}}e.$Qe=S;class D{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const v=this.b(k);return this.a.set(k,v),v}}e.$Re=D}),define(Ee[51],ke([1,0,10,2]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=S,e.$ge=D,e.$he=C,e.$ie=k,e.$je=$,e.$ke=E,e.$le=y,e.$me=w,e.$ne=m,e.$oe=d,e.$pe=c,e.$qe=g,e.$re=u,e.$se=p,e.$te=f;function S(h){const l=h;return l?typeof l.read=="function":!1}function D(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}function C(h){const l=h;return l?D(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}function k(h,l){return new v(h,l)}class v{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,i.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let a;switch(l){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const o=a.indexOf(t);o>=0&&a.splice(o,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(h,l){const t=[];let a;for(;(a=h.read())!==null;)t.push(a);return l(t)}function E(h,l,t){const a=[];let o;for(;(o=h.read())!==null&&a.length<t;)a.push(o);return o===null&&a.length>0?l(a):{read:()=>{if(a.length>0)return a.shift();if(typeof o<"u"){const r=o;return o=void 0,r}return h.read()}}}function y(h,l){return new Promise((t,a)=>{const o=[];w(h,{onData:r=>{l&&o.push(r)},onError:r=>{l?a(r):t(void 0)},onEnd:()=>{t(l?l(o):void 0)}})})}function w(h,l,t){h.on("error",a=>{t?.isCancellationRequested||l.onError(a)}),h.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),h.on("data",a=>{t?.isCancellationRequested||l.onData(a)})}function m(h,l){return new Promise((t,a)=>{const o=new A.$Tc,r=[],s=P=>{if(r.push(P),r.length>l)return o.dispose(),h.pause(),t({stream:h,buffer:r,ended:!1})},n=P=>(o.dispose(),a(P)),b=()=>(o.dispose(),t({stream:h,buffer:r,ended:!0}));o.add((0,A.$Sc)(()=>h.removeListener("error",n))),h.on("error",n),o.add((0,A.$Sc)(()=>h.removeListener("end",b))),h.on("end",b),o.add((0,A.$Sc)(()=>h.removeListener("data",s))),h.on("data",s)})}function d(h,l){const t=k(l);return t.end(h),t}function c(){const h=k(()=>{throw new Error("not supported")});return h.end(),h}function g(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}function u(h,l,t){const a=k(t);return w(h,{onData:o=>a.write(l.data(o)),onError:o=>a.error(l.error?l.error(o):o),onEnd:()=>a.end()}),a}function p(h,l,t){let a=!1;return{read:()=>{const o=l.read();return a?o:(a=!0,o!==null?t([h,o]):h)}}}function f(h,l,t){let a=!1;const o=k(t);return w(l,{onData:r=>a?o.write(r):(a=!0,o.write(t([h,r]))),onError:r=>o.error(r),onEnd:()=>{a||(a=!0,o.write(h)),o.end()}}),o}}),define(Ee[14],ke([1,0,60,51]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=$,e.$we=E,e.$xe=y,e.$ye=w,e.$ze=m,e.$Ae=d,e.$Be=c,e.$Ce=g,e.$De=u,e.$Ee=p,e.$Fe=f,e.$Ge=h,e.$He=l,e.$Ie=t,e.$Je=a,e.$Ke=o,e.$Le=r,e.$Me=s,e.$Ne=n,e.$Oe=I;const S=typeof Buffer<"u",D=new i.$V(()=>new Uint8Array(256));let C,k;class v{static alloc(R){return S?new v(Buffer.allocUnsafe(R)):new v(new Uint8Array(R))}static wrap(R){return S&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new v(R)}static fromString(R,j){return!(j?.dontUseNodeBuffer||!1)&&S?new v(Buffer.from(R)):(C||(C=new TextEncoder),new v(C.encode(R)))}static fromByteArray(R){const j=v.alloc(R.length);for(let B=0,Y=R.length;B<Y;B++)j.buffer[B]=R[B];return j}static concat(R,j){if(typeof j>"u"){j=0;for(let fe=0,ue=R.length;fe<ue;fe++)j+=R[fe].byteLength}const B=v.alloc(j);let Y=0;for(let fe=0,ue=R.length;fe<ue;fe++){const re=R[fe];B.set(re,Y),Y+=re.byteLength}return B}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=v.alloc(this.byteLength);return R.set(this),R}toString(){return S?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(R,j){return new v(this.buffer.subarray(R,j))}set(R,j){if(R instanceof v)this.buffer.set(R.buffer,j);else if(R instanceof Uint8Array)this.buffer.set(R,j);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),j);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return w(this.buffer,R)}writeUInt32BE(R,j){m(this.buffer,R,j)}readUInt32LE(R){return d(this.buffer,R)}writeUInt32LE(R,j){c(this.buffer,R,j)}readUInt8(R){return g(this.buffer,R)}writeUInt8(R,j){u(this.buffer,R,j)}indexOf(R,j=0){return $(this.buffer,R instanceof v?R.buffer:R,j)}}e.$ue=v;function $(O,R,j=0){const B=R.byteLength,Y=O.byteLength;if(B===0)return 0;if(B===1)return O.indexOf(R[0]);if(B>Y-j)return-1;const fe=D.value;fe.fill(R.length);for(let V=0;V<R.length;V++)fe[R[V]]=R.length-V-1;let ue=j+R.length-1,re=ue,te=-1;for(;ue<Y;)if(O[ue]===R[re]){if(re===0){te=ue;break}ue--,re--}else ue+=Math.max(R.length-re,fe[O[ue]]),re=R.length-1;return te}function E(O,R){return O[R+0]<<0>>>0|O[R+1]<<8>>>0}function y(O,R,j){O[j+0]=R&255,R=R>>>8,O[j+1]=R&255}function w(O,R){return O[R]*2**24+O[R+1]*2**16+O[R+2]*2**8+O[R+3]}function m(O,R,j){O[j+3]=R,R=R>>>8,O[j+2]=R,R=R>>>8,O[j+1]=R,R=R>>>8,O[j]=R}function d(O,R){return O[R+0]<<0>>>0|O[R+1]<<8>>>0|O[R+2]<<16>>>0|O[R+3]<<24>>>0}function c(O,R,j){O[j+0]=R&255,R=R>>>8,O[j+1]=R&255,R=R>>>8,O[j+2]=R&255,R=R>>>8,O[j+3]=R&255}function g(O,R){return O[R]}function u(O,R,j){O[j]=R}function p(O){return A.$je(O,R=>v.concat(R))}function f(O){return A.$qe(O)}function h(O){return A.$le(O,R=>v.concat(R))}async function l(O){return O.ended?v.concat(O.buffer):v.concat([...O.buffer,await h(O.stream)])}function t(O){return A.$oe(O,R=>v.concat(R))}function a(O){return A.$re(O,{data:R=>typeof R=="string"?v.fromString(R):v.wrap(R)},R=>v.concat(R))}function o(O){return A.$ie(R=>v.concat(R),O)}function r(O,R){return A.$se(O,R,j=>v.concat(j))}function s(O,R){return A.$te(O,R,j=>v.concat(j))}function n(O){let R=0,j=0,B=0;const Y=new Uint8Array(Math.floor(O.length/4*3)),fe=re=>{switch(j){case 3:Y[B++]=R|re,j=0;break;case 2:Y[B++]=R|re>>>2,R=re<<6,j=3;break;case 1:Y[B++]=R|re>>>4,R=re<<4,j=2;break;default:R=re<<2,j=1}};for(let re=0;re<O.length;re++){const te=O.charCodeAt(re);if(te>=65&&te<=90)fe(te-65);else if(te>=97&&te<=122)fe(te-97+26);else if(te>=48&&te<=57)fe(te-48+52);else if(te===43||te===45)fe(62);else if(te===47||te===95)fe(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${O[re]}`)}}const ue=B;for(;j>0;)fe(0);return v.wrap(Y).slice(0,ue)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:O},R=!0,j=!1){const B=j?P:b;let Y="";const fe=O.byteLength%3;let ue=0;for(;ue<O.byteLength-fe;ue+=3){const re=O[ue+0],te=O[ue+1],V=O[ue+2];Y+=B[re>>>2],Y+=B[(re<<4|te>>>4)&63],Y+=B[(te<<2|V>>>6)&63],Y+=B[V&63]}if(fe===1){const re=O[ue+0];Y+=B[re>>>2],Y+=B[re<<4&63],R&&(Y+="==")}else if(fe===2){const re=O[ue+0],te=O[ue+1];Y+=B[re>>>2],Y+=B[(re<<4|te>>>4)&63],Y+=B[te<<2&63],R&&(Y+="=")}return Y}}),define(Ee[17],ke([1,0,153,60]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.GraphemeBreakType=e.$If=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=S,e.$Ve=C,e.$We=v,e.$Xe=$,e.$Ye=E,e.$Ze=y,e.$1e=w,e.$2e=m,e.$3e=d,e.$4e=c,e.$5e=g,e.$6e=u,e.$7e=p,e.$8e=f,e.$9e=h,e.$0e=l,e.$$e=t,e.$_e=a,e.$af=o,e.$bf=r,e.$cf=s,e.$df=n,e.$ef=b,e.$ff=P,e.$gf=I,e.$hf=O,e.$if=R,e.$jf=j,e.$kf=B,e.$lf=Y,e.$mf=fe,e.$nf=ue,e.$of=re,e.$pf=te,e.$qf=V,e.$rf=T,e.$sf=x,e.$vf=ce,e.$wf=ne,e.$xf=$e,e.$yf=K,e.$zf=z,e.$Af=ae,e.$Cf=Q,e.$Df=J,e.$Ef=U,e.$Ff=L,e.$Gf=_,e.$Hf=ee,e.$Jf=de,e.$Kf=ie,e.$Lf=me,e.$Mf=we,e.$Nf=Ie,e.$Of=Oe,e.$Pf=ge,e.$Qf=Se,e.$Rf=Ue;function S(pe){return!pe||typeof pe!="string"?!0:pe.trim().length===0}const D=/{(\d+)}/g;function C(pe,...Pe){return Pe.length===0?pe:pe.replace(D,function(Ne,Ae){const Me=parseInt(Ae,10);return isNaN(Me)||Me<0||Me>=Pe.length?Ne:Pe[Me]})}const k=/{([^}]+)}/g;function v(pe,Pe){return Object.keys(Pe).length===0?pe:pe.replace(k,(Ne,Ae)=>Pe[Ae]??Ne)}function $(pe){return pe.replace(/[<>"'&]/g,Pe=>{switch(Pe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Pe})}function E(pe){return pe.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}function y(pe){return pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(pe,Pe){let Ne=0;const Ae=Pe.charCodeAt(0);for(let Me=pe.length-1;Me>=0;Me--)pe.charCodeAt(Me)===Ae&&Ne++;return Ne}function m(pe,Pe,Ne="\u2026"){return pe.length<=Pe?pe:`${pe.substr(0,Pe)}${Ne}`}function d(pe,Pe,Ne="\u2026"){if(pe.length<=Pe)return pe;const Ae=Math.ceil(Pe/2)-Ne.length/2,Me=Math.floor(Pe/2)-Ne.length/2;return`${pe.substr(0,Ae)}${Ne}${pe.substr(pe.length-Me)}`}function c(pe,Pe=" "){const Ne=g(pe,Pe);return u(Ne,Pe)}function g(pe,Pe){if(!pe||!Pe)return pe;const Ne=Pe.length;if(Ne===0||pe.length===0)return pe;let Ae=0;for(;pe.indexOf(Pe,Ae)===Ae;)Ae=Ae+Ne;return pe.substring(Ae)}function u(pe,Pe){if(!pe||!Pe)return pe;const Ne=Pe.length,Ae=pe.length;if(Ne===0||Ae===0)return pe;let Me=Ae,He=-1;for(;He=pe.lastIndexOf(Pe,Me-1),!(He===-1||He+Ne!==Me);){if(He===0)return"";Me=He}return pe.substring(0,Me)}function p(pe){return pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function f(pe){return pe.replace(/\*/g,"")}function h(pe,Pe,Ne={}){if(!pe)throw new Error("Cannot create regex from empty string");Pe||(pe=y(pe)),Ne.wholeWord&&(/\B/.test(pe.charAt(0))||(pe="\\b"+pe),/\B/.test(pe.charAt(pe.length-1))||(pe=pe+"\\b"));let Ae="";return Ne.global&&(Ae+="g"),Ne.matchCase||(Ae+="i"),Ne.multiline&&(Ae+="m"),Ne.unicode&&(Ae+="u"),new RegExp(pe,Ae)}function l(pe){return pe.source==="^"||pe.source==="^$"||pe.source==="$"||pe.source==="^\\s*$"?!1:!!(pe.exec("")&&pe.lastIndex===0)}function t(pe){return pe.split(/\r\n|\r|\n/)}function a(pe){const Pe=[],Ne=pe.split(/(\r\n|\r|\n)/);for(let Ae=0;Ae<Math.ceil(Ne.length/2);Ae++)Pe.push(Ne[2*Ae]+(Ne[2*Ae+1]??""));return Pe}function o(pe){for(let Pe=0,Ne=pe.length;Pe<Ne;Pe++){const Ae=pe.charCodeAt(Pe);if(Ae!==32&&Ae!==9)return Pe}return-1}function r(pe,Pe=0,Ne=pe.length){for(let Ae=Pe;Ae<Ne;Ae++){const Me=pe.charCodeAt(Ae);if(Me!==32&&Me!==9)return pe.substring(Pe,Ae)}return pe.substring(Pe,Ne)}function s(pe,Pe=pe.length-1){for(let Ne=Pe;Ne>=0;Ne--){const Ae=pe.charCodeAt(Ne);if(Ae!==32&&Ae!==9)return Ne}return-1}function n(pe,Pe,Ne){const Ae=[];let Me=0;for(const He of pe.matchAll(Pe)){if(Ae.push(pe.slice(Me,He.index)),He.index===void 0)throw new Error("match.index should be defined");Me=He.index+He[0].length,Ae.push(Ne(He[0],...He.slice(1),He.index,pe,He.groups))}return Ae.push(pe.slice(Me)),Promise.all(Ae).then(He=>He.join(""))}function b(pe,Pe){return pe<Pe?-1:pe>Pe?1:0}function P(pe,Pe,Ne=0,Ae=pe.length,Me=0,He=Pe.length){for(;Ne<Ae&&Me<He;Ne++,Me++){const it=pe.charCodeAt(Ne),Ye=Pe.charCodeAt(Me);if(it<Ye)return-1;if(it>Ye)return 1}const We=Ae-Ne,Qe=He-Me;return We<Qe?-1:We>Qe?1:0}function I(pe,Pe){return O(pe,Pe,0,pe.length,0,Pe.length)}function O(pe,Pe,Ne=0,Ae=pe.length,Me=0,He=Pe.length){for(;Ne<Ae&&Me<He;Ne++,Me++){let it=pe.charCodeAt(Ne),Ye=Pe.charCodeAt(Me);if(it===Ye)continue;if(it>=128||Ye>=128)return P(pe.toLowerCase(),Pe.toLowerCase(),Ne,Ae,Me,He);j(it)&&(it-=32),j(Ye)&&(Ye-=32);const nt=it-Ye;if(nt!==0)return nt}const We=Ae-Ne,Qe=He-Me;return We<Qe?-1:We>Qe?1:0}function R(pe){return pe>=48&&pe<=57}function j(pe){return pe>=97&&pe<=122}function B(pe){return pe>=65&&pe<=90}function Y(pe,Pe){return pe.length===Pe.length&&O(pe,Pe)===0}function fe(pe,Pe){const Ne=Pe.length;return Pe.length>pe.length?!1:O(pe,Pe,0,Ne)===0}function ue(pe,Pe){const Ne=Math.min(pe.length,Pe.length);let Ae;for(Ae=0;Ae<Ne;Ae++)if(pe.charCodeAt(Ae)!==Pe.charCodeAt(Ae))return Ae;return Ne}function re(pe,Pe){const Ne=Math.min(pe.length,Pe.length);let Ae;const Me=pe.length-1,He=Pe.length-1;for(Ae=0;Ae<Ne;Ae++)if(pe.charCodeAt(Me-Ae)!==Pe.charCodeAt(He-Ae))return Ae;return Ne}function te(pe){return 55296<=pe&&pe<=56319}function V(pe){return 56320<=pe&&pe<=57343}function T(pe,Pe){return(pe-55296<<10)+(Pe-56320)+65536}function x(pe,Pe,Ne){const Ae=pe.charCodeAt(Ne);if(te(Ae)&&Ne+1<Pe){const Me=pe.charCodeAt(Ne+1);if(V(Me))return T(Ae,Me)}return Ae}function Z(pe,Pe){const Ne=pe.charCodeAt(Pe-1);if(V(Ne)&&Pe>1){const Ae=pe.charCodeAt(Pe-2);if(te(Ae))return T(Ae,Ne)}return Ne}class G{get offset(){return this.e}constructor(Pe,Ne=0){this.c=Pe,this.d=Pe.length,this.e=Ne}setOffset(Pe){this.e=Pe}prevCodePoint(){const Pe=Z(this.c,this.e);return this.e-=Pe>=65536?2:1,Pe}nextCodePoint(){const Pe=x(this.c,this.d,this.e);return this.e+=Pe>=65536?2:1,Pe}eol(){return this.e>=this.d}}e.$tf=G;class se{get offset(){return this.c.offset}constructor(Pe,Ne=0){this.c=new G(Pe,Ne)}nextGraphemeLength(){const Pe=Fe.getInstance(),Ne=this.c,Ae=Ne.offset;let Me=Pe.getGraphemeBreakType(Ne.nextCodePoint());for(;!Ne.eol();){const He=Ne.offset,We=Pe.getGraphemeBreakType(Ne.nextCodePoint());if(Ce(Me,We)){Ne.setOffset(He);break}Me=We}return Ne.offset-Ae}prevGraphemeLength(){const Pe=Fe.getInstance(),Ne=this.c,Ae=Ne.offset;let Me=Pe.getGraphemeBreakType(Ne.prevCodePoint());for(;Ne.offset>0;){const He=Ne.offset,We=Pe.getGraphemeBreakType(Ne.prevCodePoint());if(Ce(We,Me)){Ne.setOffset(He);break}Me=We}return Ae-Ne.offset}eol(){return this.c.eol()}}e.$uf=se;function ce(pe,Pe){return new se(pe,Pe).nextGraphemeLength()}function ne(pe,Pe){return new se(pe,Pe).prevGraphemeLength()}function $e(pe,Pe){Pe>0&&V(pe.charCodeAt(Pe))&&Pe--;const Ne=Pe+ce(pe,Pe);return[Ne-ne(pe,Ne),Ne]}function K(pe){const Pe=new se(pe);let Ne=0;for(;!Pe.eol();)Ne++,Pe.nextGraphemeLength();return Ne}let q;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(pe){return q||(q=N()),q.test(pe)}const X=/^[\t\n\r\x20-\x7E]*$/;function ae(pe){return X.test(pe)}e.$Bf=/[\u2028\u2029]/;function Q(pe){return e.$Bf.test(pe)}function J(pe){return pe>=11904&&pe<=55215||pe>=63744&&pe<=64255||pe>=65281&&pe<=65374}function U(pe){return pe>=127462&&pe<=127487||pe===8986||pe===8987||pe===9200||pe===9203||pe>=9728&&pe<=10175||pe===11088||pe===11093||pe>=127744&&pe<=128591||pe>=128640&&pe<=128764||pe>=128992&&pe<=129008||pe>=129280&&pe<=129535||pe>=129648&&pe<=129782}function L(pe,Pe,Ne=""){const Ae=pe.trimStart();if(Ae.length<Pe)return Ae;const Me=/\b/g;let He=0;for(;Me.test(Ae)&&!(Ae.length-Me.lastIndex<Pe);)He=Me.lastIndex,Me.lastIndex+=1;return He===0?Ae:Ne+Ae.substring(He).trimStart()}const H=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*_(pe){let Pe=0;for(const Ne of pe.matchAll(H))Pe!==Ne.index&&(yield{isCode:!1,str:pe.substring(Pe,Ne.index)}),yield{isCode:!0,str:Ne[0]},Pe=Ne.index+Ne[0].length;Pe!==pe.length&&(yield{isCode:!1,str:pe.substring(Pe)})}function ee(pe){return pe&&(pe=pe.replace(H,"")),pe}e.$If="\uFEFF";function de(pe){return!!(pe&&pe.length>0&&pe.charCodeAt(0)===65279)}function ie(pe){return de(pe)?pe.substr(1):pe}function me(pe,Pe){if(!pe||!Pe||pe.length<Pe.length)return!1;const Ne=Pe.length,Ae=pe.toLowerCase();let Me=0,He=-1;for(;Me<Ne;){const We=Ae.indexOf(Pe[Me],He+1);if(We<0)return!1;He=We,Me++}return!0}function we(pe,Pe=!1){return pe?(Pe&&(pe=pe.replace(/\\./g,"")),pe.toLowerCase()!==pe):!1}function Ie(pe){return pe.charAt(0).toUpperCase()+pe.slice(1)}function Oe(pe,Pe=1){if(Pe===0)return"";let Ne=-1;do Ne=pe.indexOf(`
`,Ne+1),Pe--;while(Pe>0&&Ne>=0);return Ne===-1?pe:(pe[Ne-1]==="\r"&&Ne--,pe.substr(0,Ne))}function ge(pe){return pe=pe%(2*26),pe<26?String.fromCharCode(97+pe):String.fromCharCode(65+pe-26)}function Se(pe){return Fe.getInstance().getGraphemeBreakType(pe)}function Ce(pe,Pe){return pe===0?Pe!==5&&Pe!==7:pe===2&&Pe===3?!1:pe===4||pe===2||pe===3||Pe===4||Pe===2||Pe===3?!0:!(pe===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(pe===11||pe===9)&&(Pe===9||Pe===10)||(pe===12||pe===10)&&Pe===10||Pe===5||Pe===13||Pe===7||pe===1||pe===13&&Pe===14||pe===6&&Pe===6)}var Te;(function(pe){pe[pe.Other=0]="Other",pe[pe.Prepend=1]="Prepend",pe[pe.CR=2]="CR",pe[pe.LF=3]="LF",pe[pe.Control=4]="Control",pe[pe.Extend=5]="Extend",pe[pe.Regional_Indicator=6]="Regional_Indicator",pe[pe.SpacingMark=7]="SpacingMark",pe[pe.L=8]="L",pe[pe.V=9]="V",pe[pe.T=10]="T",pe[pe.LV=11]="LV",pe[pe.LVT=12]="LVT",pe[pe.ZWJ=13]="ZWJ",pe[pe.Extended_Pictographic=14]="Extended_Pictographic"})(Te||(e.GraphemeBreakType=Te={}));class Fe{static{this.c=null}static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=Ve()}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const Ne=this.d,Ae=Ne.length/3;let Me=1;for(;Me<=Ae;)if(Pe<Ne[3*Me])Me=2*Me;else if(Pe>Ne[3*Me+1])Me=2*Me+1;else return Ne[3*Me+2];return 0}}function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(pe,Pe){if(pe===0)return 0;const Ne=xe(pe,Pe);if(Ne!==void 0)return Ne;const Ae=new G(Pe,pe);return Ae.prevCodePoint(),Ae.offset}function xe(pe,Pe){const Ne=new G(Pe,pe);let Ae=Ne.prevCodePoint();for(;Xe(Ae)||Ae===65039||Ae===8419;){if(Ne.offset===0)return;Ae=Ne.prevCodePoint()}if(!U(Ae))return;let Me=Ne.offset;return Me>0&&Ne.prevCodePoint()===8205&&(Me=Ne.offset),Me}function Xe(pe){return 127995<=pe&&pe<=127999}var _e;(function(pe){pe[pe.zwj=8205]="zwj",pe[pe.emojiVariantSelector=65039]="emojiVariantSelector",pe[pe.enclosingKeyCap=8419]="enclosingKeyCap"})(_e||(_e={})),e.$Sf="\xA0";class et{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Qe(Pe=>{function Ne(nt){const ot=new Map;for(let at=0;at<nt.length;at+=2)ot.set(nt[at],nt[at+1]);return ot}function Ae(nt,ot){const at=new Map(nt);for(const[ct,ht]of ot)at.set(ct,ht);return at}function Me(nt,ot){if(!nt)return ot;const at=new Map;for(const[ct,ht]of nt)ot.has(ct)&&at.set(ct,ht);return at}const He=this.c.value;let We=Pe.filter(nt=>!nt.startsWith("_")&&nt in He);We.length===0&&(We=["_default"]);let Qe;for(const nt of We){const ot=Ne(He[nt]);Qe=Me(Qe,ot)}const it=Ne(He._common),Ye=Ae(it,Qe);return new et(Ye)})}static getInstance(Pe){return et.d.get(Array.from(Pe))}static{this.e=new A.$V(()=>Object.keys(et.c.value).filter(Pe=>!Pe.startsWith("_")))}static getLocales(){return et.e.value}constructor(Pe){this.f=Pe}isAmbiguous(Pe){return this.f.has(Pe)}getPrimaryConfusable(Pe){return this.f.get(Pe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Tf=et;class Je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Je.c())),this.d}static isInvisibleCharacter(Pe){return Je.e().has(Pe)}static get codePoints(){return Je.e()}}e.$Uf=Je}),define(Ee[154],ke([1,0,24,149,17]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.FuzzyScore=e.$kk=e.$jk=void 0,e.or=D,e.$lk=k,e.$mk=v,e.$nk=y,e.$ok=n,e.$pk=b,e.$qk=B,e.$rk=Y,e.$sk=fe,e.$tk=ue,e.$uk=z,e.$wk=J,e.$xk=H,e.$yk=_;function D(...ie){return function(me,we){for(let Ie=0,Oe=ie.length;Ie<Oe;Ie++){const ge=ie[Ie](me,we);if(ge)return ge}return null}}e.$jk=C.bind(void 0,!1),e.$kk=C.bind(void 0,!0);function C(ie,me,we){if(!we||we.length<me.length)return null;let Ie;return ie?Ie=S.$mf(we,me):Ie=we.indexOf(me)===0,Ie?me.length>0?[{start:0,end:me.length}]:[]:null}function k(ie,me){const we=me.toLowerCase().indexOf(ie.toLowerCase());return we===-1?null:[{start:we,end:we+ie.length}]}function v(ie,me){return $(ie.toLowerCase(),me.toLowerCase(),0,0)}function $(ie,me,we,Ie){if(we===ie.length)return[];if(Ie===me.length)return null;if(ie[we]===me[Ie]){let Oe=null;return(Oe=$(ie,me,we+1,Ie+1))?h({start:Ie,end:Ie+1},Oe):null}return $(ie,me,we,Ie+1)}function E(ie){return 97<=ie&&ie<=122}function y(ie){return 65<=ie&&ie<=90}function w(ie){return 48<=ie&&ie<=57}function m(ie){return ie===32||ie===9||ie===10||ie===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>d.add(ie.charCodeAt(0)));function c(ie){return m(ie)||d.has(ie)}function g(ie,me){return ie===me||c(ie)&&c(me)}const u=new Map;function p(ie){if(u.has(ie))return u.get(ie);let me;const we=(0,A.$hk)(ie);return we&&(me=we),u.set(ie,me),me}function f(ie){return E(ie)||y(ie)||w(ie)}function h(ie,me){return me.length===0?me=[ie]:ie.end===me[0].start?me[0].start=ie.start:me.unshift(ie),me}function l(ie,me){for(let we=me;we<ie.length;we++){const Ie=ie.charCodeAt(we);if(y(Ie)||w(Ie)||we>0&&!f(ie.charCodeAt(we-1)))return we}return ie.length}function t(ie,me,we,Ie){if(we===ie.length)return[];if(Ie===me.length)return null;if(ie[we]!==me[Ie].toLowerCase())return null;{let Oe=null,ge=Ie+1;for(Oe=t(ie,me,we+1,Ie+1);!Oe&&(ge=l(me,ge))<me.length;)Oe=t(ie,me,we+1,ge),ge++;return Oe===null?null:h({start:Ie,end:Ie+1},Oe)}}function a(ie){let me=0,we=0,Ie=0,Oe=0,ge=0;for(let Ve=0;Ve<ie.length;Ve++)ge=ie.charCodeAt(Ve),y(ge)&&me++,E(ge)&&we++,f(ge)&&Ie++,w(ge)&&Oe++;const Se=me/ie.length,Ce=we/ie.length,Te=Ie/ie.length,Fe=Oe/ie.length;return{upperPercent:Se,lowerPercent:Ce,alphaPercent:Te,numericPercent:Fe}}function o(ie){const{upperPercent:me,lowerPercent:we}=ie;return we===0&&me>.6}function r(ie){const{upperPercent:me,lowerPercent:we,alphaPercent:Ie,numericPercent:Oe}=ie;return we>.2&&me<.8&&Ie>.6&&Oe<.2}function s(ie){let me=0,we=0,Ie=0,Oe=0;for(let ge=0;ge<ie.length;ge++)Ie=ie.charCodeAt(ge),y(Ie)&&me++,E(Ie)&&we++,m(Ie)&&Oe++;return(me===0||we===0)&&Oe===0?ie.length<=30:me<=5}function n(ie,me){if(!me||(me=me.trim(),me.length===0)||!s(ie))return null;me.length>60&&(me=me.substring(0,60));const we=a(me);if(!r(we)){if(!o(we))return null;me=me.toLowerCase()}let Ie=null,Oe=0;for(ie=ie.toLowerCase();Oe<me.length&&(Ie=t(ie,me,0,Oe))===null;)Oe=l(me,Oe+1);return Ie}function b(ie,me,we=!1){if(!me||me.length===0)return null;let Ie=null,Oe=0;for(ie=ie.toLowerCase(),me=me.toLowerCase();Oe<me.length&&(Ie=P(ie,me,0,Oe,we),Ie===null);)Oe=I(me,Oe+1);return Ie}function P(ie,me,we,Ie,Oe){let ge=0;if(we===ie.length)return[];if(Ie===me.length)return null;if(!g(ie.charCodeAt(we),me.charCodeAt(Ie))){const Te=p(ie.charCodeAt(we));if(!Te)return null;for(let Fe=0;Fe<Te.length;Fe++)if(!g(Te[Fe],me.charCodeAt(Ie+Fe)))return null;ge+=Te.length-1}let Se=null,Ce=Ie+ge+1;if(Se=P(ie,me,we+1,Ce,Oe),!Oe)for(;!Se&&(Ce=I(me,Ce))<me.length;)Se=P(ie,me,we+1,Ce,Oe),Ce++;if(!Se)return null;if(ie.charCodeAt(we)!==me.charCodeAt(Ie)){const Te=p(ie.charCodeAt(we));if(!Te)return Se;for(let Fe=0;Fe<Te.length;Fe++)if(Te[Fe]!==me.charCodeAt(Ie+Fe))return Se}return h({start:Ie,end:Ie+ge+1},Se)}function I(ie,me){for(let we=me;we<ie.length;we++)if(c(ie.charCodeAt(we))||we>0&&c(ie.charCodeAt(we-1)))return we;return ie.length}const O=D(e.$kk,n,k),R=D(e.$kk,n,v),j=new i.$Ec(1e4);function B(ie,me,we=!1){if(typeof ie!="string"||typeof me!="string")return null;let Ie=j.get(ie);Ie||(Ie=new RegExp(S.$7e(ie),"i"),j.set(ie,Ie));const Oe=Ie.exec(me);return Oe?[{start:Oe.index,end:Oe.index+Oe[0].length}]:we?R(ie,me):O(ie,me)}function Y(ie,me){const we=J(ie,ie.toLowerCase(),0,me,me.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return we?ue(we):null}function fe(ie,me,we,Ie,Oe,ge){const Se=Math.min(13,ie.length);for(;we<Se;we++){const Ce=J(ie,me,we,Ie,Oe,ge,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ce)return Ce}return[0,ge]}function ue(ie){if(typeof ie>"u")return[];const me=[],we=ie[1];for(let Ie=ie.length-1;Ie>1;Ie--){const Oe=ie[Ie]+we,ge=me[me.length-1];ge&&ge.end===Oe?ge.end=Oe+1:me.push({start:Oe,end:Oe+1})}return me}const re=128;function te(){const ie=[],me=[];for(let we=0;we<=re;we++)me[we]=0;for(let we=0;we<=re;we++)ie.push(me.slice(0));return ie}function V(ie){const me=[];for(let we=0;we<=ie;we++)me[we]=0;return me}const T=V(2*re),x=V(2*re),Z=te(),G=te(),se=te(),ce=!1;function ne(ie,me,we,Ie,Oe){function ge(Ce,Te,Fe=" "){for(;Ce.length<Te;)Ce=Fe+Ce;return Ce}let Se=` |   |${Ie.split("").map(Ce=>ge(Ce,3)).join("|")}
`;for(let Ce=0;Ce<=we;Ce++)Ce===0?Se+=" |":Se+=`${me[Ce-1]}|`,Se+=ie[Ce].slice(0,Oe+1).map(Te=>ge(Te.toString(),3)).join("|")+`
`;return Se}function $e(ie,me,we,Ie){ie=ie.substr(me),we=we.substr(Ie),console.log(ne(G,ie,ie.length,we,we.length)),console.log(ne(se,ie,ie.length,we,we.length)),console.log(ne(Z,ie,ie.length,we,we.length))}function K(ie,me){if(me<0||me>=ie.length)return!1;const we=ie.codePointAt(me);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!S.$Ef(we)}}function q(ie,me){if(me<0||me>=ie.length)return!1;switch(ie.charCodeAt(me)){case 32:case 9:return!0;default:return!1}}function N(ie,me,we){return me[ie]!==we[ie]}function z(ie,me,we,Ie,Oe,ge,Se=!1){for(;me<we&&Oe<ge;)ie[me]===Ie[Oe]&&(Se&&(T[me]=Oe),me+=1),Oe+=1;return me===we}var X;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(X||(X={}));var ae;(function(ie){ie.Default=[-100,0];function me(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}ie.isDefault=me})(ae||(e.FuzzyScore=ae={}));class Q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(me,we){this.firstMatchCanBeWeak=me,this.boostFullMatch=we}}e.$vk=Q;function J(ie,me,we,Ie,Oe,ge,Se=Q.default){const Ce=ie.length>re?re:ie.length,Te=Ie.length>re?re:Ie.length;if(we>=Ce||ge>=Te||Ce-we>Te-ge||!z(me,we,Ce,Oe,ge,Te,!0))return;U(Ce,Te,we,ge,me,Oe);let Fe=1,Ve=1,Ue=we,xe=ge;const Xe=[!1];for(Fe=1,Ue=we;Ue<Ce;Fe++,Ue++){const Pe=T[Ue],Ne=x[Ue],Ae=Ue+1<Ce?x[Ue+1]:Te;for(Ve=Pe-ge+1,xe=Pe;xe<Ae;Ve++,xe++){let Me=Number.MIN_SAFE_INTEGER,He=!1;xe<=Ne&&(Me=L(ie,me,Ue,we,Ie,Oe,xe,Te,ge,Z[Fe-1][Ve-1]===0,Xe));let We=0;Me!==Number.MAX_SAFE_INTEGER&&(He=!0,We=Me+G[Fe-1][Ve-1]);const Qe=xe>Pe,it=Qe?G[Fe][Ve-1]+(Z[Fe][Ve-1]>0?-5:0):0,Ye=xe>Pe+1&&Z[Fe][Ve-1]>0,nt=Ye?G[Fe][Ve-2]+(Z[Fe][Ve-2]>0?-5:0):0;if(Ye&&(!Qe||nt>=it)&&(!He||nt>=We))G[Fe][Ve]=nt,se[Fe][Ve]=3,Z[Fe][Ve]=0;else if(Qe&&(!He||it>=We))G[Fe][Ve]=it,se[Fe][Ve]=2,Z[Fe][Ve]=0;else if(He)G[Fe][Ve]=We,se[Fe][Ve]=1,Z[Fe][Ve]=Z[Fe-1][Ve-1]+1;else throw new Error("not possible")}}if(ce&&$e(ie,we,Ie,ge),!Xe[0]&&!Se.firstMatchCanBeWeak)return;Fe--,Ve--;const _e=[G[Fe][Ve],ge];let et=0,Je=0;for(;Fe>=1;){let Pe=Ve;do{const Ne=se[Fe][Pe];if(Ne===3)Pe=Pe-2;else if(Ne===2)Pe=Pe-1;else break}while(Pe>=1);et>1&&me[we+Fe-1]===Oe[ge+Ve-1]&&!N(Pe+ge-1,Ie,Oe)&&et+1>Z[Fe][Pe]&&(Pe=Ve),Pe===Ve?et++:et=1,Je||(Je=Pe),Fe--,Ve=Pe-1,_e.push(Ve)}Te===Ce&&Se.boostFullMatch&&(_e[0]+=2);const pe=Je-Ce;return _e[0]-=pe,_e}function U(ie,me,we,Ie,Oe,ge){let Se=ie-1,Ce=me-1;for(;Se>=we&&Ce>=Ie;)Oe[Se]===ge[Ce]&&(x[Se]=Ce,Se--),Ce--}function L(ie,me,we,Ie,Oe,ge,Se,Ce,Te,Fe,Ve){if(me[we]!==ge[Se])return Number.MIN_SAFE_INTEGER;let Ue=1,xe=!1;return Se===we-Ie?Ue=ie[we]===Oe[Se]?7:5:N(Se,Oe,ge)&&(Se===0||!N(Se-1,Oe,ge))?(Ue=ie[we]===Oe[Se]?7:5,xe=!0):K(ge,Se)&&(Se===0||!K(ge,Se-1))?Ue=5:(K(ge,Se-1)||q(ge,Se-1))&&(Ue=5,xe=!0),Ue>1&&we===Ie&&(Ve[0]=!0),xe||(xe=N(Se,Oe,ge)||K(ge,Se-1)||q(ge,Se-1)),we===Ie?Se>Te&&(Ue-=xe?3:5):Fe?Ue+=xe?2:0:Ue+=xe?0:1,Se+1===Ce&&(Ue-=xe?3:5),Ue}function H(ie,me,we,Ie,Oe,ge,Se){return ee(ie,me,we,Ie,Oe,ge,!0,Se)}function _(ie,me,we,Ie,Oe,ge,Se){return ee(ie,me,we,Ie,Oe,ge,!1,Se)}function ee(ie,me,we,Ie,Oe,ge,Se,Ce){let Te=J(ie,me,we,Ie,Oe,ge,Ce);if(Te&&!Se)return Te;if(ie.length>=3){const Fe=Math.min(7,ie.length-1);for(let Ve=we+1;Ve<Fe;Ve++){const Ue=de(ie,Ve);if(Ue){const xe=J(Ue,Ue.toLowerCase(),we,Ie,Oe,ge,Ce);xe&&(xe[0]-=3,(!Te||xe[0]>Te[0])&&(Te=xe))}}}return Te}function de(ie,me){if(me+1>=ie.length)return;const we=ie[me],Ie=ie[me+1];if(we!==Ie)return ie.slice(0,me)+Ie+we+ie.slice(me+2)}}),define(Ee[62],ke([1,0,17]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$aj=void 0,e.$9i=A,e.$0i=S,e.$$i=D,e.$_i=k,e.$bj=c;function A(u){return S(u,0)}function S(u,p){switch(typeof u){case"object":return u===null?D(349,p):Array.isArray(u)?v(u,p):$(u,p);case"string":return k(u,p);case"boolean":return C(u,p);case"number":return D(u,p);case"undefined":return D(937,p);default:return D(617,p)}}function D(u,p){return(p<<5)-p+u|0}function C(u,p){return D(u?433:863,p)}function k(u,p){p=D(149417,p);for(let f=0,h=u.length;f<h;f++)p=D(u.charCodeAt(f),p);return p}function v(u,p){return p=D(104579,p),u.reduce((f,h)=>S(h,f),p)}function $(u,p){return p=D(181387,p),Object.keys(u).sort().reduce((f,h)=>(f=k(h,f),S(u[h],f)),p)}class E{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=S(p,this.g),this.g}}e.$aj=E;var y;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function w(u,p,f=32){const h=f-p,l=~((1<<h)-1);return(u<<p|(l&u)>>>h)>>>0}function m(u,p=0,f=u.byteLength,h=0){for(let l=0;l<f;l++)u[p+l]=h}function d(u,p,f="0"){for(;u.length<p;)u=f+u;return u}function c(u,p=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(f=>f.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),p/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const f=p.length;if(f===0)return;const h=this.p;let l=this.r,t=this.u,a,o;for(t!==0?(a=t,o=-1,t=0):(a=p.charCodeAt(0),o=0);;){let r=a;if(i.$pf(a))if(o+1<f){const s=p.charCodeAt(o+1);i.$qf(s)?(o++,r=i.$rf(a,s)):r=65533}else{t=a;break}else i.$qf(a)&&(r=65533);if(l=this.w(h,l,r),o++,o<f)a=p.charCodeAt(o);else break}this.r=l,this.u=t}w(p,f,h){return h<128?p[f++]=h:h<2048?(p[f++]=192|(h&1984)>>>6,p[f++]=128|(h&63)>>>0):h<65536?(p[f++]=224|(h&61440)>>>12,p[f++]=128|(h&4032)>>>6,p[f++]=128|(h&63)>>>0):(p[f++]=240|(h&1835008)>>>18,p[f++]=128|(h&258048)>>>12,p[f++]=128|(h&4032)>>>6,p[f++]=128|(h&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,p[0]=p[64],p[1]=p[65],p[2]=p[66]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=g.g,f=this.q;for(let b=0;b<64;b+=4)p.setUint32(b,f.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)p.setUint32(b,w(p.getUint32(b-12,!1)^p.getUint32(b-32,!1)^p.getUint32(b-56,!1)^p.getUint32(b-64,!1),1),!1);let h=this.h,l=this.l,t=this.m,a=this.n,o=this.o,r,s,n;for(let b=0;b<80;b++)b<20?(r=l&t|~l&a,s=1518500249):b<40?(r=l^t^a,s=1859775393):b<60?(r=l&t|l&a|t&a,s=2400959708):(r=l^t^a,s=3395469782),n=w(h,5)+r+o+s+p.getUint32(b*4,!1)&4294967295,o=a,a=t,t=w(l,30),l=h,h=n;this.h=this.h+h&4294967295,this.l=this.l+l&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+o&4294967295}}e.$cj=g}),define(Ee[63],ke([1,0,17]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(A||(A={})),function(S){const D="error",C="warning",k="warn",v="info",$="ignore";function E(w){return w?i.$lf(D,w)?S.Error:i.$lf(C,w)||i.$lf(k,w)?S.Warning:i.$lf(v,w)?S.Info:S.Ignore:S.Ignore}S.fromValue=E;function y(w){switch(w){case S.Error:return D;case S.Warning:return C;case S.Info:return v;default:return $}}S.toString=y}(A||(A={})),e.default=A}),define(Ee[155],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Ee[64],ke([1,0,18,17]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class S{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const d=m.charCodeAt(0),c=this.b.charCodeAt(this.c);return d-c}value(){return this.b[this.c]}}e.$ki=S;class D{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,A.$ff)(m,this.b,0,m.length,this.c,this.d):(0,A.$hf)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=D;class C{constructor(m=!0,d=!0){this.f=m,this.g=d}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let d=m.length-1;d>=0;d--,this.c--){const c=this.b.charCodeAt(d);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,A.$ff)(m,this.b,0,m.length,this.d,this.e):(0,A.$hf)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=C;var k;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(k||(k={}));class v{constructor(m,d){this.f=m,this.g=d,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,A.$gf)(m,this.c.scheme);if(this.d[this.e]===2)return(0,A.$gf)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,A.$ef)(m,this.c.query);if(this.d[this.e]===5)return(0,A.$ef)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=v;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(E||(E={}));class y{static forUris(m=()=>!1,d=()=>!1){return new y(new v(m,d))}static forPaths(m=!1){return new y(new C(void 0,!m))}static forStrings(){return new y(new S)}static forConfigKeys(){return new y(new D)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,d){if(d){const c=d.slice(0);(0,i.$Xb)(c);for(const g of c)this.set(g,m)}else{const c=m.slice(0);(0,i.$Xb)(c);for(const g of c)this.set(g[0],g[1])}}set(m,d){const c=this.b.reset(m);let g;this.c||(this.c=new $,this.c.segment=c.value());const u=[];for(g=this.c;;){const f=c.cmp(g.segment);if(f>0)g.left||(g.left=new $,g.left.segment=c.value()),u.push([-1,g]),g=g.left;else if(f<0)g.right||(g.right=new $,g.right.segment=c.value()),u.push([1,g]),g=g.right;else if(c.hasNext())c.next(),g.mid||(g.mid=new $,g.mid.segment=c.value()),u.push([0,g]),g=g.mid;else break}const p=g.value;g.value=d,g.key=m;for(let f=u.length-1;f>=0;f--){const h=u[f][1];h.updateHeight();const l=h.balanceFactor();if(l<-1||l>1){const t=u[f][0],a=u[f+1][0];if(t===1&&a===1)u[f][1]=h.rotateLeft();else if(t===-1&&a===-1)u[f][1]=h.rotateRight();else if(t===1&&a===-1)h.right=u[f+1][1]=u[f+1][1].rotateRight(),u[f][1]=h.rotateLeft();else if(t===-1&&a===1)h.left=u[f+1][1]=u[f+1][1].rotateLeft(),u[f][1]=h.rotateRight();else throw new Error;if(f>0)switch(u[f-1][0]){case-1:u[f-1][1].left=u[f][1];break;case 1:u[f-1][1].right=u[f][1];break;case 0:u[f-1][1].mid=u[f][1];break}else this.c=u[0][1]}}return p}get(m){return this.d(m)?.value}d(m){const d=this.b.reset(m);let c=this.c;for(;c;){const g=d.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(d.hasNext())d.next(),c=c.mid;else break}return c}has(m){const d=this.d(m);return!(d?.value===void 0&&d?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,d){const c=this.b.reset(m),g=[];let u=this.c;for(;u;){const p=c.cmp(u.segment);if(p>0)g.push([-1,u]),u=u.left;else if(p<0)g.push([1,u]),u=u.right;else if(c.hasNext())c.next(),g.push([0,u]),u=u.mid;else break}if(u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const p=this.f(u.right);if(p.key){const{key:f,value:h,segment:l}=p;this.e(p.key,!1),u.key=f,u.value=h,u.segment=l}}else{const p=u.left??u.right;if(g.length>0){const[f,h]=g[g.length-1];switch(f){case-1:h.left=p;break;case 0:h.mid=p;break;case 1:h.right=p;break}}else this.c=p}for(let p=g.length-1;p>=0;p--){const f=g[p][1];f.updateHeight();const h=f.balanceFactor();if(h>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),g[p][1]=f.rotateLeft()):h<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),g[p][1]=f.rotateRight()),p>0)switch(g[p-1][0]){case-1:g[p-1][1].left=g[p][1];break;case 1:g[p-1][1].right=g[p][1];break;case 0:g[p-1][1].mid=g[p][1];break}else this.c=g[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const d=this.b.reset(m);let c=this.c,g;for(;c;){const u=d.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(d.hasNext())d.next(),g=c.value||g,c=c.mid;else break}return c&&c.value||g}findSuperstr(m){return this.g(m,!1)}g(m,d){const c=this.b.reset(m);let g=this.c;for(;g;){const u=c.cmp(g.segment);if(u>0)g=g.left;else if(u<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else return g.mid?this.h(g.mid):d?g.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[d,c]of this)m(c,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const d=[];return this.j(m,d),d[Symbol.iterator]()}j(m,d){m&&(m.left&&this.j(m.left,d),m.value&&d.push([m.key,m.value]),m.mid&&this.j(m.mid,d),m.right&&this.j(m.right,d))}_isBalanced(){const m=d=>{if(!d)return!0;const c=d.balanceFactor();return c<-1||c>1?!1:m(d.left)&&m(d.right)};return m(this.c)}}e.$oi=y}),define(Ee[11],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=i,e.$Wf=A,e.$Xf=S,e.$Yf=D,e.$Zf=C,e.$1f=k,e.$2f=v,e.$3f=$,e.$4f=E,e.$5f=y,e.$6f=w,e.$7f=m,e.$8f=d,e.$9f=g,e.$0f=u,e.$$f=p,e.$_f=f,e.$ag=h;function i(l){return typeof l=="string"}function A(l){return Array.isArray(l)&&l.every(t=>i(t))}function S(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function D(l){const t=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof t}function C(l){return typeof l=="number"&&!isNaN(l)}function k(l){return!!l&&typeof l[Symbol.iterator]=="function"}function v(l){return l===!0||l===!1}function $(l){return typeof l>"u"}function E(l){return!y(l)}function y(l){return $(l)||l===null}function w(l,t){if(!l)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function m(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function d(...l){const t=[];for(let a=0;a<l.length;a++){const o=l[a];if(y(o))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(o)}return t}const c=Object.prototype.hasOwnProperty;function g(l){if(!S(l))return!1;for(const t in l)if(c.call(l,t))return!1;return!0}function u(l){return typeof l=="function"}function p(...l){return l.length>0&&l.every(u)}function f(l,t){const a=Math.min(l.length,t.length);for(let o=0;o<a;o++)h(l[o],t[o])}function h(l,t){if(i(t)){if(typeof l!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(l instanceof t)return}catch{}if(!y(l)&&l.constructor===t||t.length===1&&t.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[99],ke([1,0,11]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=S,e.$Dj=D;const A=Object.create(null);function S(C,k){if((0,i.$Vf)(k)){const v=A[k];if(v===void 0)throw new Error(`${C} references an unknown codicon: ${k}`);k=v}return A[C]=k,{id:C}}function D(){return A}}),define(Ee[156],ke([1,0,99]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=void 0,e.$Ej={add:(0,i.$Cj)("add",6e4),plus:(0,i.$Cj)("plus",6e4),gistNew:(0,i.$Cj)("gist-new",6e4),repoCreate:(0,i.$Cj)("repo-create",6e4),lightbulb:(0,i.$Cj)("lightbulb",60001),lightBulb:(0,i.$Cj)("light-bulb",60001),repo:(0,i.$Cj)("repo",60002),repoDelete:(0,i.$Cj)("repo-delete",60002),gistFork:(0,i.$Cj)("gist-fork",60003),repoForked:(0,i.$Cj)("repo-forked",60003),gitPullRequest:(0,i.$Cj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Cj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Cj)("record-keys",60005),keyboard:(0,i.$Cj)("keyboard",60005),tag:(0,i.$Cj)("tag",60006),gitPullRequestLabel:(0,i.$Cj)("git-pull-request-label",60006),tagAdd:(0,i.$Cj)("tag-add",60006),tagRemove:(0,i.$Cj)("tag-remove",60006),person:(0,i.$Cj)("person",60007),personFollow:(0,i.$Cj)("person-follow",60007),personOutline:(0,i.$Cj)("person-outline",60007),personFilled:(0,i.$Cj)("person-filled",60007),gitBranch:(0,i.$Cj)("git-branch",60008),gitBranchCreate:(0,i.$Cj)("git-branch-create",60008),gitBranchDelete:(0,i.$Cj)("git-branch-delete",60008),sourceControl:(0,i.$Cj)("source-control",60008),mirror:(0,i.$Cj)("mirror",60009),mirrorPublic:(0,i.$Cj)("mirror-public",60009),star:(0,i.$Cj)("star",60010),starAdd:(0,i.$Cj)("star-add",60010),starDelete:(0,i.$Cj)("star-delete",60010),starEmpty:(0,i.$Cj)("star-empty",60010),comment:(0,i.$Cj)("comment",60011),commentAdd:(0,i.$Cj)("comment-add",60011),alert:(0,i.$Cj)("alert",60012),warning:(0,i.$Cj)("warning",60012),search:(0,i.$Cj)("search",60013),searchSave:(0,i.$Cj)("search-save",60013),logOut:(0,i.$Cj)("log-out",60014),signOut:(0,i.$Cj)("sign-out",60014),logIn:(0,i.$Cj)("log-in",60015),signIn:(0,i.$Cj)("sign-in",60015),eye:(0,i.$Cj)("eye",60016),eyeUnwatch:(0,i.$Cj)("eye-unwatch",60016),eyeWatch:(0,i.$Cj)("eye-watch",60016),circleFilled:(0,i.$Cj)("circle-filled",60017),primitiveDot:(0,i.$Cj)("primitive-dot",60017),closeDirty:(0,i.$Cj)("close-dirty",60017),debugBreakpoint:(0,i.$Cj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Cj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Cj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Cj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Cj)("primitive-square",60018),edit:(0,i.$Cj)("edit",60019),pencil:(0,i.$Cj)("pencil",60019),info:(0,i.$Cj)("info",60020),issueOpened:(0,i.$Cj)("issue-opened",60020),gistPrivate:(0,i.$Cj)("gist-private",60021),gitForkPrivate:(0,i.$Cj)("git-fork-private",60021),lock:(0,i.$Cj)("lock",60021),mirrorPrivate:(0,i.$Cj)("mirror-private",60021),close:(0,i.$Cj)("close",60022),removeClose:(0,i.$Cj)("remove-close",60022),x:(0,i.$Cj)("x",60022),repoSync:(0,i.$Cj)("repo-sync",60023),sync:(0,i.$Cj)("sync",60023),clone:(0,i.$Cj)("clone",60024),desktopDownload:(0,i.$Cj)("desktop-download",60024),beaker:(0,i.$Cj)("beaker",60025),microscope:(0,i.$Cj)("microscope",60025),vm:(0,i.$Cj)("vm",60026),deviceDesktop:(0,i.$Cj)("device-desktop",60026),file:(0,i.$Cj)("file",60027),fileText:(0,i.$Cj)("file-text",60027),more:(0,i.$Cj)("more",60028),ellipsis:(0,i.$Cj)("ellipsis",60028),kebabHorizontal:(0,i.$Cj)("kebab-horizontal",60028),mailReply:(0,i.$Cj)("mail-reply",60029),reply:(0,i.$Cj)("reply",60029),organization:(0,i.$Cj)("organization",60030),organizationFilled:(0,i.$Cj)("organization-filled",60030),organizationOutline:(0,i.$Cj)("organization-outline",60030),newFile:(0,i.$Cj)("new-file",60031),fileAdd:(0,i.$Cj)("file-add",60031),newFolder:(0,i.$Cj)("new-folder",60032),fileDirectoryCreate:(0,i.$Cj)("file-directory-create",60032),trash:(0,i.$Cj)("trash",60033),trashcan:(0,i.$Cj)("trashcan",60033),history:(0,i.$Cj)("history",60034),clock:(0,i.$Cj)("clock",60034),folder:(0,i.$Cj)("folder",60035),fileDirectory:(0,i.$Cj)("file-directory",60035),symbolFolder:(0,i.$Cj)("symbol-folder",60035),logoGithub:(0,i.$Cj)("logo-github",60036),markGithub:(0,i.$Cj)("mark-github",60036),github:(0,i.$Cj)("github",60036),terminal:(0,i.$Cj)("terminal",60037),console:(0,i.$Cj)("console",60037),repl:(0,i.$Cj)("repl",60037),zap:(0,i.$Cj)("zap",60038),symbolEvent:(0,i.$Cj)("symbol-event",60038),error:(0,i.$Cj)("error",60039),stop:(0,i.$Cj)("stop",60039),variable:(0,i.$Cj)("variable",60040),symbolVariable:(0,i.$Cj)("symbol-variable",60040),array:(0,i.$Cj)("array",60042),symbolArray:(0,i.$Cj)("symbol-array",60042),symbolModule:(0,i.$Cj)("symbol-module",60043),symbolPackage:(0,i.$Cj)("symbol-package",60043),symbolNamespace:(0,i.$Cj)("symbol-namespace",60043),symbolObject:(0,i.$Cj)("symbol-object",60043),symbolMethod:(0,i.$Cj)("symbol-method",60044),symbolFunction:(0,i.$Cj)("symbol-function",60044),symbolConstructor:(0,i.$Cj)("symbol-constructor",60044),symbolBoolean:(0,i.$Cj)("symbol-boolean",60047),symbolNull:(0,i.$Cj)("symbol-null",60047),symbolNumeric:(0,i.$Cj)("symbol-numeric",60048),symbolNumber:(0,i.$Cj)("symbol-number",60048),symbolStructure:(0,i.$Cj)("symbol-structure",60049),symbolStruct:(0,i.$Cj)("symbol-struct",60049),symbolParameter:(0,i.$Cj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Cj)("symbol-type-parameter",60050),symbolKey:(0,i.$Cj)("symbol-key",60051),symbolText:(0,i.$Cj)("symbol-text",60051),symbolReference:(0,i.$Cj)("symbol-reference",60052),goToFile:(0,i.$Cj)("go-to-file",60052),symbolEnum:(0,i.$Cj)("symbol-enum",60053),symbolValue:(0,i.$Cj)("symbol-value",60053),symbolRuler:(0,i.$Cj)("symbol-ruler",60054),symbolUnit:(0,i.$Cj)("symbol-unit",60054),activateBreakpoints:(0,i.$Cj)("activate-breakpoints",60055),archive:(0,i.$Cj)("archive",60056),arrowBoth:(0,i.$Cj)("arrow-both",60057),arrowDown:(0,i.$Cj)("arrow-down",60058),arrowLeft:(0,i.$Cj)("arrow-left",60059),arrowRight:(0,i.$Cj)("arrow-right",60060),arrowSmallDown:(0,i.$Cj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Cj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Cj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Cj)("arrow-small-up",60064),arrowUp:(0,i.$Cj)("arrow-up",60065),bell:(0,i.$Cj)("bell",60066),bold:(0,i.$Cj)("bold",60067),book:(0,i.$Cj)("book",60068),bookmark:(0,i.$Cj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Cj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Cj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Cj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Cj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Cj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Cj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Cj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Cj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Cj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Cj)("briefcase",60076),broadcast:(0,i.$Cj)("broadcast",60077),browser:(0,i.$Cj)("browser",60078),bug:(0,i.$Cj)("bug",60079),calendar:(0,i.$Cj)("calendar",60080),caseSensitive:(0,i.$Cj)("case-sensitive",60081),check:(0,i.$Cj)("check",60082),checklist:(0,i.$Cj)("checklist",60083),chevronDown:(0,i.$Cj)("chevron-down",60084),chevronLeft:(0,i.$Cj)("chevron-left",60085),chevronRight:(0,i.$Cj)("chevron-right",60086),chevronUp:(0,i.$Cj)("chevron-up",60087),chromeClose:(0,i.$Cj)("chrome-close",60088),chromeMaximize:(0,i.$Cj)("chrome-maximize",60089),chromeMinimize:(0,i.$Cj)("chrome-minimize",60090),chromeRestore:(0,i.$Cj)("chrome-restore",60091),circleOutline:(0,i.$Cj)("circle-outline",60092),circle:(0,i.$Cj)("circle",60092),debugBreakpointUnverified:(0,i.$Cj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Cj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Cj)("circle-slash",60093),circuitBoard:(0,i.$Cj)("circuit-board",60094),clearAll:(0,i.$Cj)("clear-all",60095),clippy:(0,i.$Cj)("clippy",60096),closeAll:(0,i.$Cj)("close-all",60097),cloudDownload:(0,i.$Cj)("cloud-download",60098),cloudUpload:(0,i.$Cj)("cloud-upload",60099),code:(0,i.$Cj)("code",60100),collapseAll:(0,i.$Cj)("collapse-all",60101),colorMode:(0,i.$Cj)("color-mode",60102),commentDiscussion:(0,i.$Cj)("comment-discussion",60103),creditCard:(0,i.$Cj)("credit-card",60105),dash:(0,i.$Cj)("dash",60108),dashboard:(0,i.$Cj)("dashboard",60109),database:(0,i.$Cj)("database",60110),debugContinue:(0,i.$Cj)("debug-continue",60111),debugDisconnect:(0,i.$Cj)("debug-disconnect",60112),debugPause:(0,i.$Cj)("debug-pause",60113),debugRestart:(0,i.$Cj)("debug-restart",60114),debugStart:(0,i.$Cj)("debug-start",60115),debugStepInto:(0,i.$Cj)("debug-step-into",60116),debugStepOut:(0,i.$Cj)("debug-step-out",60117),debugStepOver:(0,i.$Cj)("debug-step-over",60118),debugStop:(0,i.$Cj)("debug-stop",60119),debug:(0,i.$Cj)("debug",60120),deviceCameraVideo:(0,i.$Cj)("device-camera-video",60121),deviceCamera:(0,i.$Cj)("device-camera",60122),deviceMobile:(0,i.$Cj)("device-mobile",60123),diffAdded:(0,i.$Cj)("diff-added",60124),diffIgnored:(0,i.$Cj)("diff-ignored",60125),diffModified:(0,i.$Cj)("diff-modified",60126),diffRemoved:(0,i.$Cj)("diff-removed",60127),diffRenamed:(0,i.$Cj)("diff-renamed",60128),diff:(0,i.$Cj)("diff",60129),diffSidebyside:(0,i.$Cj)("diff-sidebyside",60129),discard:(0,i.$Cj)("discard",60130),editorLayout:(0,i.$Cj)("editor-layout",60131),emptyWindow:(0,i.$Cj)("empty-window",60132),exclude:(0,i.$Cj)("exclude",60133),extensions:(0,i.$Cj)("extensions",60134),eyeClosed:(0,i.$Cj)("eye-closed",60135),fileBinary:(0,i.$Cj)("file-binary",60136),fileCode:(0,i.$Cj)("file-code",60137),fileMedia:(0,i.$Cj)("file-media",60138),filePdf:(0,i.$Cj)("file-pdf",60139),fileSubmodule:(0,i.$Cj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Cj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Cj)("file-symlink-file",60142),fileZip:(0,i.$Cj)("file-zip",60143),files:(0,i.$Cj)("files",60144),filter:(0,i.$Cj)("filter",60145),flame:(0,i.$Cj)("flame",60146),foldDown:(0,i.$Cj)("fold-down",60147),foldUp:(0,i.$Cj)("fold-up",60148),fold:(0,i.$Cj)("fold",60149),folderActive:(0,i.$Cj)("folder-active",60150),folderOpened:(0,i.$Cj)("folder-opened",60151),gear:(0,i.$Cj)("gear",60152),gift:(0,i.$Cj)("gift",60153),gistSecret:(0,i.$Cj)("gist-secret",60154),gist:(0,i.$Cj)("gist",60155),gitCommit:(0,i.$Cj)("git-commit",60156),gitCompare:(0,i.$Cj)("git-compare",60157),compareChanges:(0,i.$Cj)("compare-changes",60157),gitMerge:(0,i.$Cj)("git-merge",60158),githubAction:(0,i.$Cj)("github-action",60159),githubAlt:(0,i.$Cj)("github-alt",60160),globe:(0,i.$Cj)("globe",60161),grabber:(0,i.$Cj)("grabber",60162),graph:(0,i.$Cj)("graph",60163),gripper:(0,i.$Cj)("gripper",60164),heart:(0,i.$Cj)("heart",60165),home:(0,i.$Cj)("home",60166),horizontalRule:(0,i.$Cj)("horizontal-rule",60167),hubot:(0,i.$Cj)("hubot",60168),inbox:(0,i.$Cj)("inbox",60169),issueReopened:(0,i.$Cj)("issue-reopened",60171),issues:(0,i.$Cj)("issues",60172),italic:(0,i.$Cj)("italic",60173),jersey:(0,i.$Cj)("jersey",60174),json:(0,i.$Cj)("json",60175),kebabVertical:(0,i.$Cj)("kebab-vertical",60176),key:(0,i.$Cj)("key",60177),law:(0,i.$Cj)("law",60178),lightbulbAutofix:(0,i.$Cj)("lightbulb-autofix",60179),linkExternal:(0,i.$Cj)("link-external",60180),link:(0,i.$Cj)("link",60181),listOrdered:(0,i.$Cj)("list-ordered",60182),listUnordered:(0,i.$Cj)("list-unordered",60183),liveShare:(0,i.$Cj)("live-share",60184),loading:(0,i.$Cj)("loading",60185),location:(0,i.$Cj)("location",60186),mailRead:(0,i.$Cj)("mail-read",60187),mail:(0,i.$Cj)("mail",60188),markdown:(0,i.$Cj)("markdown",60189),megaphone:(0,i.$Cj)("megaphone",60190),mention:(0,i.$Cj)("mention",60191),milestone:(0,i.$Cj)("milestone",60192),gitPullRequestMilestone:(0,i.$Cj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Cj)("mortar-board",60193),move:(0,i.$Cj)("move",60194),multipleWindows:(0,i.$Cj)("multiple-windows",60195),mute:(0,i.$Cj)("mute",60196),noNewline:(0,i.$Cj)("no-newline",60197),note:(0,i.$Cj)("note",60198),octoface:(0,i.$Cj)("octoface",60199),openPreview:(0,i.$Cj)("open-preview",60200),package:(0,i.$Cj)("package",60201),paintcan:(0,i.$Cj)("paintcan",60202),pin:(0,i.$Cj)("pin",60203),play:(0,i.$Cj)("play",60204),run:(0,i.$Cj)("run",60204),plug:(0,i.$Cj)("plug",60205),preserveCase:(0,i.$Cj)("preserve-case",60206),preview:(0,i.$Cj)("preview",60207),project:(0,i.$Cj)("project",60208),pulse:(0,i.$Cj)("pulse",60209),question:(0,i.$Cj)("question",60210),quote:(0,i.$Cj)("quote",60211),radioTower:(0,i.$Cj)("radio-tower",60212),reactions:(0,i.$Cj)("reactions",60213),references:(0,i.$Cj)("references",60214),refresh:(0,i.$Cj)("refresh",60215),regex:(0,i.$Cj)("regex",60216),remoteExplorer:(0,i.$Cj)("remote-explorer",60217),remote:(0,i.$Cj)("remote",60218),remove:(0,i.$Cj)("remove",60219),replaceAll:(0,i.$Cj)("replace-all",60220),replace:(0,i.$Cj)("replace",60221),repoClone:(0,i.$Cj)("repo-clone",60222),repoForcePush:(0,i.$Cj)("repo-force-push",60223),repoPull:(0,i.$Cj)("repo-pull",60224),repoPush:(0,i.$Cj)("repo-push",60225),report:(0,i.$Cj)("report",60226),requestChanges:(0,i.$Cj)("request-changes",60227),rocket:(0,i.$Cj)("rocket",60228),rootFolderOpened:(0,i.$Cj)("root-folder-opened",60229),rootFolder:(0,i.$Cj)("root-folder",60230),rss:(0,i.$Cj)("rss",60231),ruby:(0,i.$Cj)("ruby",60232),saveAll:(0,i.$Cj)("save-all",60233),saveAs:(0,i.$Cj)("save-as",60234),save:(0,i.$Cj)("save",60235),screenFull:(0,i.$Cj)("screen-full",60236),screenNormal:(0,i.$Cj)("screen-normal",60237),searchStop:(0,i.$Cj)("search-stop",60238),server:(0,i.$Cj)("server",60240),settingsGear:(0,i.$Cj)("settings-gear",60241),settings:(0,i.$Cj)("settings",60242),shield:(0,i.$Cj)("shield",60243),smiley:(0,i.$Cj)("smiley",60244),sortPrecedence:(0,i.$Cj)("sort-precedence",60245),splitHorizontal:(0,i.$Cj)("split-horizontal",60246),splitVertical:(0,i.$Cj)("split-vertical",60247),squirrel:(0,i.$Cj)("squirrel",60248),starFull:(0,i.$Cj)("star-full",60249),starHalf:(0,i.$Cj)("star-half",60250),symbolClass:(0,i.$Cj)("symbol-class",60251),symbolColor:(0,i.$Cj)("symbol-color",60252),symbolConstant:(0,i.$Cj)("symbol-constant",60253),symbolEnumMember:(0,i.$Cj)("symbol-enum-member",60254),symbolField:(0,i.$Cj)("symbol-field",60255),symbolFile:(0,i.$Cj)("symbol-file",60256),symbolInterface:(0,i.$Cj)("symbol-interface",60257),symbolKeyword:(0,i.$Cj)("symbol-keyword",60258),symbolMisc:(0,i.$Cj)("symbol-misc",60259),symbolOperator:(0,i.$Cj)("symbol-operator",60260),symbolProperty:(0,i.$Cj)("symbol-property",60261),wrench:(0,i.$Cj)("wrench",60261),wrenchSubaction:(0,i.$Cj)("wrench-subaction",60261),symbolSnippet:(0,i.$Cj)("symbol-snippet",60262),tasklist:(0,i.$Cj)("tasklist",60263),telescope:(0,i.$Cj)("telescope",60264),textSize:(0,i.$Cj)("text-size",60265),threeBars:(0,i.$Cj)("three-bars",60266),thumbsdown:(0,i.$Cj)("thumbsdown",60267),thumbsup:(0,i.$Cj)("thumbsup",60268),tools:(0,i.$Cj)("tools",60269),triangleDown:(0,i.$Cj)("triangle-down",60270),triangleLeft:(0,i.$Cj)("triangle-left",60271),triangleRight:(0,i.$Cj)("triangle-right",60272),triangleUp:(0,i.$Cj)("triangle-up",60273),twitter:(0,i.$Cj)("twitter",60274),unfold:(0,i.$Cj)("unfold",60275),unlock:(0,i.$Cj)("unlock",60276),unmute:(0,i.$Cj)("unmute",60277),unverified:(0,i.$Cj)("unverified",60278),verified:(0,i.$Cj)("verified",60279),versions:(0,i.$Cj)("versions",60280),vmActive:(0,i.$Cj)("vm-active",60281),vmOutline:(0,i.$Cj)("vm-outline",60282),vmRunning:(0,i.$Cj)("vm-running",60283),watch:(0,i.$Cj)("watch",60284),whitespace:(0,i.$Cj)("whitespace",60285),wholeWord:(0,i.$Cj)("whole-word",60286),window:(0,i.$Cj)("window",60287),wordWrap:(0,i.$Cj)("word-wrap",60288),zoomIn:(0,i.$Cj)("zoom-in",60289),zoomOut:(0,i.$Cj)("zoom-out",60290),listFilter:(0,i.$Cj)("list-filter",60291),listFlat:(0,i.$Cj)("list-flat",60292),listSelection:(0,i.$Cj)("list-selection",60293),selection:(0,i.$Cj)("selection",60293),listTree:(0,i.$Cj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Cj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Cj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Cj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Cj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Cj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Cj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Cj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Cj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Cj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Cj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Cj)("symbol-string",60301),debugReverseContinue:(0,i.$Cj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Cj)("debug-step-back",60303),debugRestartFrame:(0,i.$Cj)("debug-restart-frame",60304),debugAlt:(0,i.$Cj)("debug-alt",60305),callIncoming:(0,i.$Cj)("call-incoming",60306),callOutgoing:(0,i.$Cj)("call-outgoing",60307),menu:(0,i.$Cj)("menu",60308),expandAll:(0,i.$Cj)("expand-all",60309),feedback:(0,i.$Cj)("feedback",60310),gitPullRequestReviewer:(0,i.$Cj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Cj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Cj)("ungroup-by-ref-type",60312),account:(0,i.$Cj)("account",60313),gitPullRequestAssignee:(0,i.$Cj)("git-pull-request-assignee",60313),bellDot:(0,i.$Cj)("bell-dot",60314),debugConsole:(0,i.$Cj)("debug-console",60315),library:(0,i.$Cj)("library",60316),output:(0,i.$Cj)("output",60317),runAll:(0,i.$Cj)("run-all",60318),syncIgnored:(0,i.$Cj)("sync-ignored",60319),pinned:(0,i.$Cj)("pinned",60320),githubInverted:(0,i.$Cj)("github-inverted",60321),serverProcess:(0,i.$Cj)("server-process",60322),serverEnvironment:(0,i.$Cj)("server-environment",60323),pass:(0,i.$Cj)("pass",60324),issueClosed:(0,i.$Cj)("issue-closed",60324),stopCircle:(0,i.$Cj)("stop-circle",60325),playCircle:(0,i.$Cj)("play-circle",60326),record:(0,i.$Cj)("record",60327),debugAltSmall:(0,i.$Cj)("debug-alt-small",60328),vmConnect:(0,i.$Cj)("vm-connect",60329),cloud:(0,i.$Cj)("cloud",60330),merge:(0,i.$Cj)("merge",60331),export:(0,i.$Cj)("export",60332),graphLeft:(0,i.$Cj)("graph-left",60333),magnet:(0,i.$Cj)("magnet",60334),notebook:(0,i.$Cj)("notebook",60335),redo:(0,i.$Cj)("redo",60336),checkAll:(0,i.$Cj)("check-all",60337),pinnedDirty:(0,i.$Cj)("pinned-dirty",60338),passFilled:(0,i.$Cj)("pass-filled",60339),circleLargeFilled:(0,i.$Cj)("circle-large-filled",60340),circleLarge:(0,i.$Cj)("circle-large",60341),circleLargeOutline:(0,i.$Cj)("circle-large-outline",60341),combine:(0,i.$Cj)("combine",60342),gather:(0,i.$Cj)("gather",60342),table:(0,i.$Cj)("table",60343),variableGroup:(0,i.$Cj)("variable-group",60344),typeHierarchy:(0,i.$Cj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Cj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Cj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Cj)("git-pull-request-create",60348),runAbove:(0,i.$Cj)("run-above",60349),runBelow:(0,i.$Cj)("run-below",60350),notebookTemplate:(0,i.$Cj)("notebook-template",60351),debugRerun:(0,i.$Cj)("debug-rerun",60352),workspaceTrusted:(0,i.$Cj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Cj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Cj)("workspace-unknown",60355),terminalCmd:(0,i.$Cj)("terminal-cmd",60356),terminalDebian:(0,i.$Cj)("terminal-debian",60357),terminalLinux:(0,i.$Cj)("terminal-linux",60358),terminalPowershell:(0,i.$Cj)("terminal-powershell",60359),terminalTmux:(0,i.$Cj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Cj)("terminal-ubuntu",60361),terminalBash:(0,i.$Cj)("terminal-bash",60362),arrowSwap:(0,i.$Cj)("arrow-swap",60363),copy:(0,i.$Cj)("copy",60364),personAdd:(0,i.$Cj)("person-add",60365),filterFilled:(0,i.$Cj)("filter-filled",60366),wand:(0,i.$Cj)("wand",60367),debugLineByLine:(0,i.$Cj)("debug-line-by-line",60368),inspect:(0,i.$Cj)("inspect",60369),layers:(0,i.$Cj)("layers",60370),layersDot:(0,i.$Cj)("layers-dot",60371),layersActive:(0,i.$Cj)("layers-active",60372),compass:(0,i.$Cj)("compass",60373),compassDot:(0,i.$Cj)("compass-dot",60374),compassActive:(0,i.$Cj)("compass-active",60375),azure:(0,i.$Cj)("azure",60376),issueDraft:(0,i.$Cj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Cj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Cj)("git-pull-request-draft",60379),debugAll:(0,i.$Cj)("debug-all",60380),debugCoverage:(0,i.$Cj)("debug-coverage",60381),runErrors:(0,i.$Cj)("run-errors",60382),folderLibrary:(0,i.$Cj)("folder-library",60383),debugContinueSmall:(0,i.$Cj)("debug-continue-small",60384),beakerStop:(0,i.$Cj)("beaker-stop",60385),graphLine:(0,i.$Cj)("graph-line",60386),graphScatter:(0,i.$Cj)("graph-scatter",60387),pieChart:(0,i.$Cj)("pie-chart",60388),bracket:(0,i.$Cj)("bracket",60175),bracketDot:(0,i.$Cj)("bracket-dot",60389),bracketError:(0,i.$Cj)("bracket-error",60390),lockSmall:(0,i.$Cj)("lock-small",60391),azureDevops:(0,i.$Cj)("azure-devops",60392),verifiedFilled:(0,i.$Cj)("verified-filled",60393),newline:(0,i.$Cj)("newline",60394),layout:(0,i.$Cj)("layout",60395),layoutActivitybarLeft:(0,i.$Cj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Cj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Cj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Cj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Cj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Cj)("layout-panel-right",60401),layoutPanel:(0,i.$Cj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Cj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Cj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Cj)("layout-statusbar",60405),layoutMenubar:(0,i.$Cj)("layout-menubar",60406),layoutCentered:(0,i.$Cj)("layout-centered",60407),target:(0,i.$Cj)("target",60408),indent:(0,i.$Cj)("indent",60409),recordSmall:(0,i.$Cj)("record-small",60410),errorSmall:(0,i.$Cj)("error-small",60411),terminalDecorationError:(0,i.$Cj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Cj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Cj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Cj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Cj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Cj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Cj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Cj)("layout-sidebar-left-off",60418),blank:(0,i.$Cj)("blank",60419),heartFilled:(0,i.$Cj)("heart-filled",60420),map:(0,i.$Cj)("map",60421),mapHorizontal:(0,i.$Cj)("map-horizontal",60421),foldHorizontal:(0,i.$Cj)("fold-horizontal",60421),mapFilled:(0,i.$Cj)("map-filled",60422),mapHorizontalFilled:(0,i.$Cj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Cj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Cj)("circle-small",60423),bellSlash:(0,i.$Cj)("bell-slash",60424),bellSlashDot:(0,i.$Cj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Cj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Cj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Cj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Cj)("search-fuzzy",60429),commentDraft:(0,i.$Cj)("comment-draft",60430),send:(0,i.$Cj)("send",60431),sparkle:(0,i.$Cj)("sparkle",60432),insert:(0,i.$Cj)("insert",60433),mic:(0,i.$Cj)("mic",60434),thumbsdownFilled:(0,i.$Cj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Cj)("thumbsup-filled",60436),coffee:(0,i.$Cj)("coffee",60437),snake:(0,i.$Cj)("snake",60438),game:(0,i.$Cj)("game",60439),vr:(0,i.$Cj)("vr",60440),chip:(0,i.$Cj)("chip",60441),piano:(0,i.$Cj)("piano",60442),music:(0,i.$Cj)("music",60443),micFilled:(0,i.$Cj)("mic-filled",60444),repoFetch:(0,i.$Cj)("repo-fetch",60445),copilot:(0,i.$Cj)("copilot",60446),lightbulbSparkle:(0,i.$Cj)("lightbulb-sparkle",60447),robot:(0,i.$Cj)("robot",60448),sparkleFilled:(0,i.$Cj)("sparkle-filled",60449),diffSingle:(0,i.$Cj)("diff-single",60450),diffMultiple:(0,i.$Cj)("diff-multiple",60451),surroundWith:(0,i.$Cj)("surround-with",60452),share:(0,i.$Cj)("share",60453),gitStash:(0,i.$Cj)("git-stash",60454),gitStashApply:(0,i.$Cj)("git-stash-apply",60455),gitStashPop:(0,i.$Cj)("git-stash-pop",60456),vscode:(0,i.$Cj)("vscode",60457),vscodeInsiders:(0,i.$Cj)("vscode-insiders",60458),codeOss:(0,i.$Cj)("code-oss",60459),runCoverage:(0,i.$Cj)("run-coverage",60460),runAllCoverage:(0,i.$Cj)("run-all-coverage",60461),coverage:(0,i.$Cj)("coverage",60462),githubProject:(0,i.$Cj)("github-project",60463),mapVertical:(0,i.$Cj)("map-vertical",60464),foldVertical:(0,i.$Cj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Cj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Cj)("fold-vertical-filled",60465)}}),define(Ee[52],ke([1,0,99,156]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Fj=S;function S(){return Object.values(e.$Hj)}e.$Gj={dialogError:(0,i.$Cj)("dialog-error","error"),dialogWarning:(0,i.$Cj)("dialog-warning","warning"),dialogInfo:(0,i.$Cj)("dialog-info","info"),dialogClose:(0,i.$Cj)("dialog-close","close"),treeItemExpanded:(0,i.$Cj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Cj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Cj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Cj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Cj)("tree-item-loading","loading"),menuSelection:(0,i.$Cj)("menu-selection","check"),menuSubmenu:(0,i.$Cj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Cj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Cj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Cj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Cj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Cj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Cj)("toolbar-more","more"),quickInputBack:(0,i.$Cj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Cj)("drop-down-button",60084),symbolCustomColor:(0,i.$Cj)("symbol-customcolor",60252),exportIcon:(0,i.$Cj)("export",60332),workspaceUnspecified:(0,i.$Cj)("workspace-unspecified",60355),newLine:(0,i.$Cj)("newline",60394),thumbsDownFilled:(0,i.$Cj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Cj)("thumbsup-filled",60436),gitFetch:(0,i.$Cj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Cj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Cj)("debug-breakpoint-pending",60377)},e.$Hj={...A.$Ej,...e.$Gj}}),define(Ee[21],ke([1,0,11]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=A,e.$Pn=S,e.$Qn=C,e.$Rn=v,e.$Sn=$,e.$Tn=E,e.$Un=y,e.$Vn=w,e.$Wn=m,e.$Xn=d,e.$Yn=c,e.$Zn=g;function A(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([f,h])=>{p[f]=h&&typeof h=="object"?A(h):h}),p}function S(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const f=p.shift();Object.freeze(f);for(const h in f)if(D.call(f,h)){const l=f[h];typeof l=="object"&&!Object.isFrozen(l)&&!(0,i.$Yf)(l)&&p.push(l)}}return u}const D=Object.prototype.hasOwnProperty;function C(u,p){return k(u,p,new Set)}function k(u,p,f){if((0,i.$5f)(u))return u;const h=p(u);if(typeof h<"u")return h;if(Array.isArray(u)){const l=[];for(const t of u)l.push(k(t,p,f));return l}if((0,i.$Xf)(u)){if(f.has(u))throw new Error("Cannot clone recursive data-structure");f.add(u);const l={};for(const t in u)D.call(u,t)&&(l[t]=k(u[t],p,f));return f.delete(u),l}return u}function v(u,p,f=!0){return(0,i.$Xf)(u)?((0,i.$Xf)(p)&&Object.keys(p).forEach(h=>{h in u?f&&((0,i.$Xf)(u[h])&&(0,i.$Xf)(p[h])?v(u[h],p[h],f):u[h]=p[h]):u[h]=p[h]}),u):p}function $(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let f,h;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(f=0;f<u.length;f++)if(!$(u[f],p[f]))return!1}else{const l=[];for(h in u)l.push(h);l.sort();const t=[];for(h in p)t.push(h);if(t.sort(),!$(l,t))return!1;for(f=0;f<l.length;f++)if(!$(u[l[f]],p[l[f]]))return!1}return!0}function E(u){const p=new Set;return JSON.stringify(u,(f,h)=>{if((0,i.$Xf)(h)||Array.isArray(h)){if(p.has(h))return"[Circular]";p.add(h)}return h})}function y(u,p){const f=Object.create(null);return!u||!p||Object.keys(p).forEach(l=>{const t=u[l],a=p[l];$(t,a)||(f[l]=a)}),f}function w(u,p){const f=p.toLowerCase(),h=Object.keys(u).find(l=>l.toLowerCase()===f);return h?u[h]:u[p]}function m(u,p){const f=Object.create(null);for(const[h,l]of Object.entries(u))p(h,l)&&(f[h]=l);return f}function d(u){let p=[];for(;Object.prototype!==u;)p=p.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return p}function c(u){const p=[];for(const f of d(u))typeof u[f]=="function"&&p.push(f);return p}function g(u,p){const f=l=>function(){const t=Array.prototype.slice.call(arguments,0);return p(l,t)},h={};for(const l of u)h[l]=f(l);return h}}),define(Ee[100],ke([1,0,52]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=S;var A;(function(C){function k(v){return v&&typeof v=="object"&&typeof v.id=="string"}C.isThemeColor=k})(A||(e.ThemeColor=A={}));function S(C){return{id:C}}var D;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function v(p){const f=k.exec(p.id);if(!f)return v(i.$Hj.error);const[,h,l]=f,t=["codicon","codicon-"+h];return l&&t.push("codicon-modifier-"+l.substring(1)),t}C.asClassNameArray=v;function $(p){return v(p).join(" ")}C.asClassName=$;function E(p){return"."+v(p).join(".")}C.asCSSSelector=E;function y(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||A.isThemeColor(p.color))}C.isThemeIcon=y;const w=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function m(p){const f=w.exec(p);if(!f)return;const[,h]=f;return{id:h}}C.fromString=m;function d(p){return{id:p}}C.fromId=d;function c(p,f){let h=p.id;const l=h.lastIndexOf("~");return l!==-1&&(h=h.substring(0,l)),f&&(h=`${h}~${f}`),{id:h}}C.modify=c;function g(p){const f=p.id.lastIndexOf("~");if(f!==-1)return p.id.substring(f+1)}C.getModifier=g;function u(p,f){return p.id===f.id&&p.color?.id===f.color?.id}C.isEqual=u})(D||(e.ThemeIcon=D={}))}),define(Ee[157],ke([1,0,154,17,100]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=v,e.$Ak=E,e.$Bk=w,e.$Ck=m,e.$Dk=c,e.$Ek=g;const D="$(",C=new RegExp(`\\$\\(${S.ThemeIcon.iconNameExpression}(?:${S.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${C.source}`,"g");function v(u){return u.replace(k,(p,f)=>f?p:`\\${p}`)}const $=new RegExp(`\\\\${C.source}`,"g");function E(u){return u.replace($,p=>`\\${p}`)}const y=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function w(u){return u.indexOf(D)===-1?u:u.replace(y,(p,f,h,l)=>h?p:f||l||"")}function m(u){return u?u.replace(/\$\((.*?)\)/g,(p,f)=>` ${f} `).trim():""}const d=new RegExp(`\\$\\(${S.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(u){d.lastIndex=0;let p="";const f=[];let h=0;for(;;){const l=d.lastIndex,t=d.exec(u),a=u.substring(l,t?.index);if(a.length>0){p+=a;for(let o=0;o<a.length;o++)f.push(h)}if(!t)break;h+=t[0].length}return{text:p,iconOffsets:f}}function g(u,p,f=!1){const{text:h,iconOffsets:l}=p;if(!l||l.length===0)return(0,i.$qk)(u,h,f);const t=(0,A.$5e)(h," "),a=h.length-t.length,o=(0,i.$qk)(u,t,f);if(o)for(const r of o){const s=l[r.start+a]+a;r.start+=s,r.end+=s}return o}}),define(Ee[22],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=A;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(S){return i.test(S)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(k){for(let v=0;v<k.length;v++)k[v]=Math.floor(Math.random()*256);return k};const D=new Uint8Array(16),C=[];for(let k=0;k<256;k++)C.push(k.toString(16).padStart(2,"0"));return function(){S(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let v=0,$="";return $+=C[D[v++]],$+=C[D[v++]],$+=C[D[v++]],$+=C[D[v++]],$+="-",$+=C[D[v++]],$+=C[D[v++]],$+="-",$+=C[D[v++]],$+=C[D[v++]],$+="-",$+=C[D[v++]],$+=C[D[v++]],$+="-",$+=C[D[v++]],$+=C[D[v++]],$+=C[D[v++]],$+=C[D[v++]],$+=C[D[v++]],$+=C[D[v++]],$}}()}),define(Ee[158],ke([1,0,18,41,22]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.$Jt=void 0,e.$Ht=D,e.$It=C,e.$Kt=$;function D(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function C(y,w,m){const d={id:(0,S.$Eg)(),name:y,uri:w,data:m};return{asString:async()=>"",asFile:()=>d,value:void 0}}class k{constructor(){this.a=new Map}get size(){let w=0;for(const m of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const m=[...this.a.keys()];return A.Iterable.some(this,([d,c])=>c.asFile())&&m.push("files"),E(v(w),m)}get(w){return this.a.get(this.b(w))?.[0]}append(w,m){const d=this.a.get(w);d?d.push(m):this.a.set(this.b(w),[m])}replace(w,m){this.a.set(this.b(w),[m])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,m]of this.a)for(const d of m)yield[w,d]}b(w){return v(w)}}e.$Jt=k;function v(y){return y.toLowerCase()}function $(y,w){return E(v(y),w.map(v))}function E(y,w){if(y==="*/*")return w.length>0;if(w.includes(y))return!0;const m=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!m)return!1;const[d,c,g]=m;return g==="*"?w.some(u=>u.startsWith(c+"/")):!1}e.$Lt=Object.freeze({create:y=>(0,i.$Mb)(y.map(w=>w.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Lt.split(y).filter(w=>!w.startsWith("#"))})}),function(){"use strict";function le(e,i,A){function S(m){return new Promise(d=>i.exists(m,d))}function D(m){return new Promise((d,c)=>{const g=new Date;i.utimes(m,g,g,u=>u?c(u):d())})}function C(m){return new Promise((d,c)=>i.mkdir(m,{recursive:!0},g=>g&&g.code!=="EEXIST"?c(g):d(m)))}function k(m){return new Promise((d,c)=>i.rm(m,{recursive:!0,force:!0,maxRetries:3},g=>g?c(g):d()))}function v(m){return new Promise((d,c)=>i.readFile(m,"utf8",(g,u)=>g?c(g):d(u)))}function $(m,d){return new Promise((c,g)=>i.writeFile(m,d,"utf8",u=>u?g(u):c()))}async function E(m){const d=e.join(m,"languagepacks.json");try{return JSON.parse(await v(d))}catch{}}function y(m,d){try{for(;d;){if(m[d])return d;{const c=d.lastIndexOf("-");if(c>0)d=d.substring(0,c);else return}}}catch(c){console.error("Resolving language pack configuration failed.",c)}}function w(m,d,c,g,u){const p=function(h){return A.mark("code/didGenerateNls"),Promise.resolve({locale:h,osLocale:u,availableLanguages:{}})};if(A.mark("code/willGenerateNls"),g==="pseudo")return Promise.resolve({locale:g,osLocale:u,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:g,osLocale:u,availableLanguages:{}});if(g&&(g==="en"||g==="en-us"))return Promise.resolve({locale:g,osLocale:u,availableLanguages:{}});const f=g;try{return m?E(d).then(h=>{if(!h)return p(f);const l=y(h,g);if(!l)return p(f);g=l;const t=h[g];let a;return!t||typeof t.hash!="string"||!t.translations||typeof(a=t.translations.vscode)!="string"?p(f):S(a).then(o=>{if(!o)return p(f);const r=t.hash+"."+g,s=e.join(d,"clp",r),n=e.join(s,m),b=e.join(s,"tcf.json"),P=e.join(s,"corrupted.info"),I={locale:f,osLocale:u,availableLanguages:{"*":g},_languagePackId:r,_translationsConfigFile:b,_cacheRoot:s,_resolvedLanguagePackCoreLocation:n,_corruptedFile:P};return S(P).then(O=>{let R;return O?R=k(s):R=Promise.resolve(void 0),R.then(()=>S(n).then(j=>j?(D(n).catch(()=>{}),A.mark("code/didGenerateNls"),I):C(n).then(()=>Promise.all([v(c),v(a)])).then(B=>{const Y=JSON.parse(B[0]),fe=JSON.parse(B[1]).contents,ue=Object.keys(Y.bundles),re=[];for(const te of ue){const V=Y.bundles[te],T=Object.create(null);for(const x of V){const Z=Y.keys[x],G=Y.messages[x],se=fe[x];let ce;if(se){ce=[];for(let ne=0;ne<Z.length;ne++){const $e=Z[ne],K=typeof $e=="string"?$e:$e.key;let q=se[K];q===void 0&&(q=G[ne]),ce.push(q)}}else ce=G;T[x]=ce}re.push($(e.join(n,te.replace(/\//g,"!")+".nls.json"),JSON.stringify(T)))}return re.push($(b,JSON.stringify(t.translations))),Promise.all(re)}).then(()=>(A.mark("code/didGenerateNls"),I)).catch(B=>(console.error("Generating translation files failed.",B),p(g)))))})})}):p(f)}catch(h){return console.error("Generating translation files failed.",h),p(g)}}return{getNLSConfiguration:w}}if(typeof define=="function")define(Ee[159],ke([76,27,43]),function(e,i,A){return le(e,i,A)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("fs"),A=require("../common/performance");module.exports=le(e,i,A)}else throw new Error("Unknown context")}(),define(Ee[160],ke([1,0,29]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=D;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(C){const k=C.replace(/\-/g,":").toLowerCase();return!A.has(k)}function D(){const C=(0,i.networkInterfaces)();for(const k in C){const v=C[k];if(v){for(const{mac:$}of v)if(S($))return $}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(Ee[161],ke([1,0,77]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hg=void 0,e.$Gg=A,e.$Ig=D;function A(k,v,$,E=1){let y=!1;return new Promise(w=>{const m=setTimeout(()=>{if(!y)return y=!0,w(0)},$);S(k,v,E,d=>{if(!y)return y=!0,clearTimeout(m),w(d)})})}function S(k,v,$,E){if(v===0)return E(0);const y=new i.Socket;y.once("connect",()=>(C(y),S(k+$,v-1,$,E))),y.once("data",()=>{}),y.once("error",w=>(C(y),w.code!=="ECONNREFUSED"?S(k+$,v-1,$,E):E(k))),y.connect(k,"127.0.0.1")}e.$Hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(k,v,$,E="127.0.0.1"){let y=!1,w,m=1;const d=i.createServer({pauseOnConnect:!0});function c(g,u){y||(y=!0,d.removeAllListeners(),d.close(),w&&clearTimeout(w),u(g))}return new Promise(g=>{w=setTimeout(()=>{c(0,g)},$),d.on("listening",()=>{c(k,g)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&m<v?(k++,m++,d.listen(k,E)):c(0,g)}),d.on("close",()=>{c(0,g)}),d.listen(k,E)})}function C(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(v){console.error(v)}}}),function(){function le(){function e(){return process.uncHostAllowlist}function i(v){const $=new Set;if(Array.isArray(v))for(const E of v)typeof E=="string"&&$.add(E);return Array.from($)}function A(){const v=e();return v?Array.from(v):[]}function S(v){if(process.platform!=="win32")return;const $=e();if($)if(typeof v=="string")$.add(v.toLowerCase());else for(const E of i(v))S(E)}function D(v){if(typeof v!="string")return;const $=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let E;for(const y of $){if(v.indexOf(y)!==0)continue;const m=v.indexOf("\\",y.length);if(m===-1)continue;const d=v.substring(y.length,m);if(d){E=d;break}}return E}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function k(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:S,getUNCHost:D,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:k}}typeof define=="function"?define("vs/base/node/unc",[],function(){return le()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=le():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(Ee[78],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0;class i{constructor(S,D){this.lineNumber=S,this.column=D}with(S=this.lineNumber,D=this.column){return S===this.lineNumber&&D===this.column?this:new i(S,D)}delta(S=0,D=0){return this.with(this.lineNumber+S,this.column+D)}equals(S){return i.equals(this,S)}static equals(S,D){return!S&&!D?!0:!!S&&!!D&&S.lineNumber===D.lineNumber&&S.column===D.column}isBefore(S){return i.isBefore(this,S)}static isBefore(S,D){return S.lineNumber<D.lineNumber?!0:D.lineNumber<S.lineNumber?!1:S.column<D.column}isBeforeOrEqual(S){return i.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,D){return S.lineNumber<D.lineNumber?!0:D.lineNumber<S.lineNumber?!1:S.column<=D.column}static compare(S,D){const C=S.lineNumber|0,k=D.lineNumber|0;if(C===k){const v=S.column|0,$=D.column|0;return v-$}return C-k}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new i(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$bt=i}),define(Ee[44],ke([1,0,78]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class A{constructor(D,C,k,v){D>k||D===k&&C>v?(this.startLineNumber=k,this.startColumn=v,this.endLineNumber=D,this.endColumn=C):(this.startLineNumber=D,this.startColumn=C,this.endLineNumber=k,this.endColumn=v)}isEmpty(){return A.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return A.containsPosition(this,D)}static containsPosition(D,C){return!(C.lineNumber<D.startLineNumber||C.lineNumber>D.endLineNumber||C.lineNumber===D.startLineNumber&&C.column<D.startColumn||C.lineNumber===D.endLineNumber&&C.column>D.endColumn)}static strictContainsPosition(D,C){return!(C.lineNumber<D.startLineNumber||C.lineNumber>D.endLineNumber||C.lineNumber===D.startLineNumber&&C.column<=D.startColumn||C.lineNumber===D.endLineNumber&&C.column>=D.endColumn)}containsRange(D){return A.containsRange(this,D)}static containsRange(D,C){return!(C.startLineNumber<D.startLineNumber||C.endLineNumber<D.startLineNumber||C.startLineNumber>D.endLineNumber||C.endLineNumber>D.endLineNumber||C.startLineNumber===D.startLineNumber&&C.startColumn<D.startColumn||C.endLineNumber===D.endLineNumber&&C.endColumn>D.endColumn)}strictContainsRange(D){return A.strictContainsRange(this,D)}static strictContainsRange(D,C){return!(C.startLineNumber<D.startLineNumber||C.endLineNumber<D.startLineNumber||C.startLineNumber>D.endLineNumber||C.endLineNumber>D.endLineNumber||C.startLineNumber===D.startLineNumber&&C.startColumn<=D.startColumn||C.endLineNumber===D.endLineNumber&&C.endColumn>=D.endColumn)}plusRange(D){return A.plusRange(this,D)}static plusRange(D,C){let k,v,$,E;return C.startLineNumber<D.startLineNumber?(k=C.startLineNumber,v=C.startColumn):C.startLineNumber===D.startLineNumber?(k=C.startLineNumber,v=Math.min(C.startColumn,D.startColumn)):(k=D.startLineNumber,v=D.startColumn),C.endLineNumber>D.endLineNumber?($=C.endLineNumber,E=C.endColumn):C.endLineNumber===D.endLineNumber?($=C.endLineNumber,E=Math.max(C.endColumn,D.endColumn)):($=D.endLineNumber,E=D.endColumn),new A(k,v,$,E)}intersectRanges(D){return A.intersectRanges(this,D)}static intersectRanges(D,C){let k=D.startLineNumber,v=D.startColumn,$=D.endLineNumber,E=D.endColumn;const y=C.startLineNumber,w=C.startColumn,m=C.endLineNumber,d=C.endColumn;return k<y?(k=y,v=w):k===y&&(v=Math.max(v,w)),$>m?($=m,E=d):$===m&&(E=Math.min(E,d)),k>$||k===$&&v>E?null:new A(k,v,$,E)}equalsRange(D){return A.equalsRange(this,D)}static equalsRange(D,C){return!D&&!C?!0:!!D&&!!C&&D.startLineNumber===C.startLineNumber&&D.startColumn===C.startColumn&&D.endLineNumber===C.endLineNumber&&D.endColumn===C.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(D){return new i.$bt(D.endLineNumber,D.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(D){return new i.$bt(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,C){return new A(this.startLineNumber,this.startColumn,D,C)}setStartPosition(D,C){return new A(D,C,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(D){return new A(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(D){return new A(D.endLineNumber,D.endColumn,D.endLineNumber,D.endColumn)}delta(D){return new A(this.startLineNumber+D,this.startColumn,this.endLineNumber+D,this.endColumn)}static fromPositions(D,C=D){return new A(D.lineNumber,D.column,C.lineNumber,C.column)}static lift(D){return D?new A(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,C){return!(D.endLineNumber<C.startLineNumber||D.endLineNumber===C.startLineNumber&&D.endColumn<C.startColumn||C.endLineNumber<D.startLineNumber||C.endLineNumber===D.startLineNumber&&C.endColumn<D.startColumn)}static areIntersecting(D,C){return!(D.endLineNumber<C.startLineNumber||D.endLineNumber===C.startLineNumber&&D.endColumn<=C.startColumn||C.endLineNumber<D.startLineNumber||C.endLineNumber===D.startLineNumber&&C.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,C){if(D&&C){const $=D.startLineNumber|0,E=C.startLineNumber|0;if($===E){const y=D.startColumn|0,w=C.startColumn|0;if(y===w){const m=D.endLineNumber|0,d=C.endLineNumber|0;if(m===d){const c=D.endColumn|0,g=C.endColumn|0;return c-g}return m-d}return y-w}return $-E}return(D?1:0)-(C?1:0)}static compareRangesUsingEnds(D,C){return D.endLineNumber===C.endLineNumber?D.endColumn===C.endColumn?D.startLineNumber===C.startLineNumber?D.startColumn-C.startColumn:D.startLineNumber-C.startLineNumber:D.endColumn-C.endColumn:D.endLineNumber-C.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}toJSON(){return this}}e.$ct=A}),define(Ee[162],ke([1,0,44]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class A{static insert(D,C){return{range:new i.$ct(D.lineNumber,D.column,D.lineNumber,D.column),text:C,forceMoveMarkers:!0}}static delete(D){return{range:D,text:null}}static replace(D,C){return{range:D,text:C}}static replaceMove(D,C){return{range:D,text:C,forceMoveMarkers:!0}}}e.$dt=A}),define(Ee[163],ke([1,0,6,2]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=void 0;class S{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(k){this.c.fire({changedLanguages:k,changedColorMap:!1})}register(k,v){return this.a.set(k,v),this.handleChange([k]),(0,A.$Sc)(()=>{this.a.get(k)===v&&(this.a.delete(k),this.handleChange([k]))})}get(k){return this.a.get(k)||null}registerFactory(k,v){this.b.get(k)?.dispose();const $=new D(this,k,v);return this.b.set(k,$),(0,A.$Sc)(()=>{const E=this.b.get(k);!E||E!==$||(this.b.delete(k),E.dispose())})}async getOrCreate(k){const v=this.get(k);if(v)return v;const $=this.b.get(k);return!$||$.isResolved?null:(await $.resolve(),this.get(k))}isResolved(k){if(this.get(k))return!0;const $=this.b.get(k);return!!(!$||$.isResolved)}setColorMap(k){this.d=k,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Nt=S;class D extends A.$Uc{get isResolved(){return this.c}constructor(k,v,$){super(),this.f=k,this.g=v,this.h=$,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const k=await this.h.tokenizationSupport;this.c=!0,k&&!this.a&&this.B(this.f.register(this.g,k))}}}),define(Ee[164],ke([8,9]),function(le,e){return le.create("vs/base/common/actions",e)}),define(Ee[165],ke([1,0,6,2,164]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=void 0,e.$5i=E;class D extends A.$Uc{constructor(w,m="",d="",c=!0,g){super(),this.h=this.B(new i.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=m,this.u=d,this.w=c,this.C=g}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,m){this.C&&await this.C(w)}}e.$Zi=D;class C extends A.$Uc{constructor(){super(...arguments),this.f=this.B(new i.$7d),this.onWillRun=this.f.event,this.m=this.B(new i.$7d),this.onDidRun=this.m.event}async run(w,m){if(!w.enabled)return;this.f.fire({action:w});let d;try{await this.u(w,m)}catch(c){d=c}this.m.fire({action:w,error:d})}async u(w,m){await w.run(m)}}e.$1i=C;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let m=[];for(const d of w)d.length&&(m.length?m=[...m,new k,...d]:m=d);return m}static{this.ID="vs.actions.separator"}async run(){}}e.$2i=k;class v{get actions(){return this.a}constructor(w,m,d,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=m,this.class=c,this.a=d}async run(){}}e.$3i=v;class $ extends D{static{this.ID="vs.actions.empty"}constructor(){super($.ID,S.localize(0,null),void 0,!1)}}e.$4i=$;function E(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...w)=>y.run(...w),tooltip:y.label}}}),define(Ee[166],ke([8,9]),function(le,e){return le.create("vs/base/common/date",e)}),define(Ee[167],ke([1,0,166]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=$,e.$Om=E,e.$Pm=y;const A=60,S=A*60,D=S*24,C=D*7,k=D*30,v=D*365;function $(w,m,d,c){typeof w!="number"&&(w=w.getTime());const g=Math.round((new Date().getTime()-w)/1e3);if(g<-30)return(0,i.localize)(0,null,$(new Date().getTime()+g*1e3,!1));if(!c&&g<30)return(0,i.localize)(1,null);let u;return g<A?(u=g,m?u===1?d?(0,i.localize)(2,null,u):(0,i.localize)(3,null,u):d?(0,i.localize)(4,null,u):(0,i.localize)(5,null,u):u===1?d?(0,i.localize)(6,null,u):(0,i.localize)(7,null,u):d?(0,i.localize)(8,null,u):(0,i.localize)(9,null,u)):g<S?(u=Math.floor(g/A),m?u===1?d?(0,i.localize)(10,null,u):(0,i.localize)(11,null,u):d?(0,i.localize)(12,null,u):(0,i.localize)(13,null,u):u===1?d?(0,i.localize)(14,null,u):(0,i.localize)(15,null,u):d?(0,i.localize)(16,null,u):(0,i.localize)(17,null,u)):g<D?(u=Math.floor(g/S),m?u===1?d?(0,i.localize)(18,null,u):(0,i.localize)(19,null,u):d?(0,i.localize)(20,null,u):(0,i.localize)(21,null,u):u===1?d?(0,i.localize)(22,null,u):(0,i.localize)(23,null,u):d?(0,i.localize)(24,null,u):(0,i.localize)(25,null,u)):g<C?(u=Math.floor(g/D),m?u===1?(0,i.localize)(26,null,u):(0,i.localize)(27,null,u):u===1?(0,i.localize)(28,null,u):(0,i.localize)(29,null,u)):g<k?(u=Math.floor(g/C),m?u===1?d?(0,i.localize)(30,null,u):(0,i.localize)(31,null,u):d?(0,i.localize)(32,null,u):(0,i.localize)(33,null,u):u===1?d?(0,i.localize)(34,null,u):(0,i.localize)(35,null,u):d?(0,i.localize)(36,null,u):(0,i.localize)(37,null,u)):g<v?(u=Math.floor(g/k),m?u===1?d?(0,i.localize)(38,null,u):(0,i.localize)(39,null,u):d?(0,i.localize)(40,null,u):(0,i.localize)(41,null,u):u===1?d?(0,i.localize)(42,null,u):(0,i.localize)(43,null,u):d?(0,i.localize)(44,null,u):(0,i.localize)(45,null,u)):(u=Math.floor(g/v),m?u===1?d?(0,i.localize)(46,null,u):(0,i.localize)(47,null,u):d?(0,i.localize)(48,null,u):(0,i.localize)(49,null,u):u===1?d?(0,i.localize)(50,null,u):(0,i.localize)(51,null,u):d?(0,i.localize)(52,null,u):(0,i.localize)(53,null,u))}function E(w,m){const d=Math.abs(w/1e3);return d<1?m?(0,i.localize)(54,null,w):(0,i.localize)(55,null,w):d<A?m?(0,i.localize)(56,null,Math.round(w)/1e3):(0,i.localize)(57,null,Math.round(w)/1e3):d<S?m?(0,i.localize)(58,null,Math.round(w/(1e3*A))):(0,i.localize)(59,null,Math.round(w/(1e3*A))):d<D?m?(0,i.localize)(60,null,Math.round(w/(1e3*S))):(0,i.localize)(61,null,Math.round(w/(1e3*S))):(0,i.localize)(62,null,Math.round(w/(1e3*D)))}function y(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[168],ke([8,9]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(Ee[40],ke([1,0,18,11,168]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=v,e.$7i=$,e.$8i=E;function D(y,w){return w&&(y.stack||y.stacktrace)?S.localize(0,null,k(y),C(y.stack)||C(y.stacktrace)):k(y)}function C(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?S.localize(1,null,y.message):y.message||S.localize(2,null)}function v(y=null,w=!1){if(!y)return S.localize(3,null);if(Array.isArray(y)){const m=i.$Hb(y),d=v(m[0],w);return m.length>1?S.localize(4,null,d,m.length):d}if(A.$Vf(y))return y;if(y.detail){const m=y.detail;if(m.error)return D(m.error,w);if(m.exception)return D(m.exception,w)}return y.stack?D(y,w):y.message?y.message:S.localize(5,null)}function $(y){const w=y;return w instanceof Error&&Array.isArray(w.actions)}function E(y,w){let m;return typeof y=="string"?m=new Error(y):m=y,m.actions=w,m}}),define(Ee[169],ke([8,9]),function(le,e){return le.create("vs/base/common/jsonErrorMessages",e)}),define(Ee[170],ke([1,0,169]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=A;function A(S){switch(S){case 1:return(0,i.localize)(0,null);case 2:return(0,i.localize)(1,null);case 3:return(0,i.localize)(2,null);case 4:return(0,i.localize)(3,null);case 5:return(0,i.localize)(4,null);case 6:return(0,i.localize)(5,null);case 7:return(0,i.localize)(6,null);case 8:return(0,i.localize)(7,null);case 9:return(0,i.localize)(8,null);default:return""}}}),define(Ee[171],ke([8,9]),function(le,e){return le.create("vs/base/common/platform",e)}),define(Ee[4],ke([1,0,171]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=a,e.$D=P,e.$J=I,e.$g="en";let A=!1,S=!1,D=!1,C=!1,k=!1,v=!1,$=!1,E=!1,y=!1,w=!1,m,d=e.$g,c=e.$g,g,u;const p=globalThis;let f;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?f=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const h=typeof f?.versions?.electron=="string",l=h&&f?.type==="renderer";if(typeof f=="object"){A=f.platform==="win32",S=f.platform==="darwin",D=f.platform==="linux",C=D&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,$=h,y=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$g,d=e.$g;const O=f.env.VSCODE_NLS_CONFIG;if(O)try{const R=JSON.parse(O),j=R.availableLanguages["*"];m=R.locale,c=R.osLocale,d=j||e.$g,g=R._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!l?(u=navigator.userAgent,A=u.indexOf("Windows")>=0,S=u.indexOf("Macintosh")>=0,E=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=u.indexOf("Linux")>=0,w=u?.indexOf("Mobi")>=0,v=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||e.$g,d=m,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(t||(e.Platform=t={}));function a(O){switch(O){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let o=0;S?o=1:A?o=3:D&&(o=2),e.$i=A,e.$j=S,e.$k=D,e.$l=C,e.$m=k,e.$n=$,e.$o=v,e.$p=v&&typeof p.importScripts=="function",e.$q=e.$p?p.origin:void 0,e.$r=E,e.$s=w,e.$t=y,e.$u=o,e.$v=u,e.$w=d;var r;(function(O){function R(){return e.$w}O.value=R;function j(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}O.isDefaultVariant=j;function B(){return e.$w==="en"}O.isDefault=B})(r||(e.Language=r={})),e.$x=m,e.$y=c,e.$z=g,e.$A=typeof p.postMessage=="function"&&!p.importScripts,e.$B=(()=>{if(e.$A){const O=[];p.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let B=0,Y=O.length;B<Y;B++){const fe=O[B];if(fe.id===j.data.vscodeScheduleAsyncWork){O.splice(B,1),fe.callback();return}}});let R=0;return j=>{const B=++R;O.push({id:B,callback:j}),p.postMessage({vscodeScheduleAsyncWork:B},"*")}}return O=>setTimeout(O)})();var s;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=S||E?2:A?1:3;let n=!0,b=!1;function P(){if(!b){b=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,n=new Uint16Array(O.buffer)[0]===513}return n}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(O){return parseFloat(O)>=20}}),define(Ee[30],ke([1,0,4]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let A;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const D=S.process;A={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$ec=A.platform,e.$fc=A.arch}),define(Ee[7],ke([1,0,30]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const A=65,S=97,D=90,C=122,k=46,v=47,$=92,E=58,y=63;class w extends Error{constructor(a,o,r){let s;typeof o=="string"&&o.indexOf("not ")===0?(s="must not be",o=o.replace(/^not /,"")):s="must be";const n=a.indexOf(".")!==-1?"property":"argument";let b=`The "${a}" ${n} ${s} of type ${o}`;b+=`. Received type ${typeof r}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,a){if(t===null||typeof t!="object")throw new w(a,"Object",t)}function d(t,a){if(typeof t!="string")throw new w(a,"string",t)}const c=i.$ec==="win32";function g(t){return t===v||t===$}function u(t){return t===v}function p(t){return t>=A&&t<=D||t>=S&&t<=C}function f(t,a,o,r){let s="",n=0,b=-1,P=0,I=0;for(let O=0;O<=t.length;++O){if(O<t.length)I=t.charCodeAt(O);else{if(r(I))break;I=v}if(r(I)){if(!(b===O-1||P===1))if(P===2){if(s.length<2||n!==2||s.charCodeAt(s.length-1)!==k||s.charCodeAt(s.length-2)!==k){if(s.length>2){const R=s.lastIndexOf(o);R===-1?(s="",n=0):(s=s.slice(0,R),n=s.length-1-s.lastIndexOf(o)),b=O,P=0;continue}else if(s.length!==0){s="",n=0,b=O,P=0;continue}}a&&(s+=s.length>0?`${o}..`:"..",n=2)}else s.length>0?s+=`${o}${t.slice(b+1,O)}`:s=t.slice(b+1,O),n=O-b-1;b=O,P=0}else I===k&&P!==-1?++P:P=-1}return s}function h(t,a){m(a,"pathObject");const o=a.dir||a.root,r=a.base||`${a.name||""}${a.ext||""}`;return o?o===a.root?`${o}${r}`:`${o}${t}${r}`:r}e.$gc={resolve(...t){let a="",o="",r=!1;for(let s=t.length-1;s>=-1;s--){let n;if(s>=0){if(n=t[s],d(n,"path"),n.length===0)continue}else a.length===0?n=i.cwd():(n=i.env[`=${a}`]||i.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==a.toLowerCase()&&n.charCodeAt(2)===$)&&(n=`${a}\\`));const b=n.length;let P=0,I="",O=!1;const R=n.charCodeAt(0);if(b===1)g(R)&&(P=1,O=!0);else if(g(R))if(O=!0,g(n.charCodeAt(1))){let j=2,B=j;for(;j<b&&!g(n.charCodeAt(j));)j++;if(j<b&&j!==B){const Y=n.slice(B,j);for(B=j;j<b&&g(n.charCodeAt(j));)j++;if(j<b&&j!==B){for(B=j;j<b&&!g(n.charCodeAt(j));)j++;(j===b||j!==B)&&(I=`\\\\${Y}\\${n.slice(B,j)}`,P=j)}}}else P=1;else p(R)&&n.charCodeAt(1)===E&&(I=n.slice(0,2),P=2,b>2&&g(n.charCodeAt(2))&&(O=!0,P=3));if(I.length>0)if(a.length>0){if(I.toLowerCase()!==a.toLowerCase())continue}else a=I;if(r){if(a.length>0)break}else if(o=`${n.slice(P)}\\${o}`,r=O,O&&a.length>0)break}return o=f(o,!r,"\\",g),r?`${a}\\${o}`:`${a}${o}`||"."},normalize(t){d(t,"path");const a=t.length;if(a===0)return".";let o=0,r,s=!1;const n=t.charCodeAt(0);if(a===1)return u(n)?"\\":t;if(g(n))if(s=!0,g(t.charCodeAt(1))){let P=2,I=P;for(;P<a&&!g(t.charCodeAt(P));)P++;if(P<a&&P!==I){const O=t.slice(I,P);for(I=P;P<a&&g(t.charCodeAt(P));)P++;if(P<a&&P!==I){for(I=P;P<a&&!g(t.charCodeAt(P));)P++;if(P===a)return`\\\\${O}\\${t.slice(I)}\\`;P!==I&&(r=`\\\\${O}\\${t.slice(I,P)}`,o=P)}}}else o=1;else p(n)&&t.charCodeAt(1)===E&&(r=t.slice(0,2),o=2,a>2&&g(t.charCodeAt(2))&&(s=!0,o=3));let b=o<a?f(t.slice(o),!s,"\\",g):"";return b.length===0&&!s&&(b="."),b.length>0&&g(t.charCodeAt(a-1))&&(b+="\\"),r===void 0?s?`\\${b}`:b:s?`${r}\\${b}`:`${r}${b}`},isAbsolute(t){d(t,"path");const a=t.length;if(a===0)return!1;const o=t.charCodeAt(0);return g(o)||a>2&&p(o)&&t.charCodeAt(1)===E&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,o;for(let n=0;n<t.length;++n){const b=t[n];d(b,"path"),b.length>0&&(a===void 0?a=o=b:a+=`\\${b}`)}if(a===void 0)return".";let r=!0,s=0;if(typeof o=="string"&&g(o.charCodeAt(0))){++s;const n=o.length;n>1&&g(o.charCodeAt(1))&&(++s,n>2&&(g(o.charCodeAt(2))?++s:r=!1))}if(r){for(;s<a.length&&g(a.charCodeAt(s));)s++;s>=2&&(a=`\\${a.slice(s)}`)}return e.$gc.normalize(a)},relative(t,a){if(d(t,"from"),d(a,"to"),t===a)return"";const o=e.$gc.resolve(t),r=e.$gc.resolve(a);if(o===r||(t=o.toLowerCase(),a=r.toLowerCase(),t===a))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===$;)s++;let n=t.length;for(;n-1>s&&t.charCodeAt(n-1)===$;)n--;const b=n-s;let P=0;for(;P<a.length&&a.charCodeAt(P)===$;)P++;let I=a.length;for(;I-1>P&&a.charCodeAt(I-1)===$;)I--;const O=I-P,R=b<O?b:O;let j=-1,B=0;for(;B<R;B++){const fe=t.charCodeAt(s+B);if(fe!==a.charCodeAt(P+B))break;fe===$&&(j=B)}if(B!==R){if(j===-1)return r}else{if(O>R){if(a.charCodeAt(P+B)===$)return r.slice(P+B+1);if(B===2)return r.slice(P+B)}b>R&&(t.charCodeAt(s+B)===$?j=B:B===2&&(j=3)),j===-1&&(j=0)}let Y="";for(B=s+j+1;B<=n;++B)(B===n||t.charCodeAt(B)===$)&&(Y+=Y.length===0?"..":"\\..");return P+=j,Y.length>0?`${Y}${r.slice(P,I)}`:(r.charCodeAt(P)===$&&++P,r.slice(P,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.$gc.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===$){if(a.charCodeAt(1)===$){const o=a.charCodeAt(2);if(o!==y&&o!==k)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(p(a.charCodeAt(0))&&a.charCodeAt(1)===E&&a.charCodeAt(2)===$)return`\\\\?\\${a}`;return t},dirname(t){d(t,"path");const a=t.length;if(a===0)return".";let o=-1,r=0;const s=t.charCodeAt(0);if(a===1)return g(s)?t:".";if(g(s)){if(o=r=1,g(t.charCodeAt(1))){let P=2,I=P;for(;P<a&&!g(t.charCodeAt(P));)P++;if(P<a&&P!==I){for(I=P;P<a&&g(t.charCodeAt(P));)P++;if(P<a&&P!==I){for(I=P;P<a&&!g(t.charCodeAt(P));)P++;if(P===a)return t;P!==I&&(o=r=P+1)}}}}else p(s)&&t.charCodeAt(1)===E&&(o=a>2&&g(t.charCodeAt(2))?3:2,r=o);let n=-1,b=!0;for(let P=a-1;P>=r;--P)if(g(t.charCodeAt(P))){if(!b){n=P;break}}else b=!1;if(n===-1){if(o===-1)return".";n=o}return t.slice(0,n)},basename(t,a){a!==void 0&&d(a,"ext"),d(t,"path");let o=0,r=-1,s=!0,n;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===E&&(o=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let b=a.length-1,P=-1;for(n=t.length-1;n>=o;--n){const I=t.charCodeAt(n);if(g(I)){if(!s){o=n+1;break}}else P===-1&&(s=!1,P=n+1),b>=0&&(I===a.charCodeAt(b)?--b===-1&&(r=n):(b=-1,r=P))}return o===r?r=P:r===-1&&(r=t.length),t.slice(o,r)}for(n=t.length-1;n>=o;--n)if(g(t.charCodeAt(n))){if(!s){o=n+1;break}}else r===-1&&(s=!1,r=n+1);return r===-1?"":t.slice(o,r)},extname(t){d(t,"path");let a=0,o=-1,r=0,s=-1,n=!0,b=0;t.length>=2&&t.charCodeAt(1)===E&&p(t.charCodeAt(0))&&(a=r=2);for(let P=t.length-1;P>=a;--P){const I=t.charCodeAt(P);if(g(I)){if(!n){r=P+1;break}continue}s===-1&&(n=!1,s=P+1),I===k?o===-1?o=P:b!==1&&(b=1):o!==-1&&(b=-1)}return o===-1||s===-1||b===0||b===1&&o===s-1&&o===r+1?"":t.slice(o,s)},format:h.bind(null,"\\"),parse(t){d(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const o=t.length;let r=0,s=t.charCodeAt(0);if(o===1)return g(s)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(g(s)){if(r=1,g(t.charCodeAt(1))){let j=2,B=j;for(;j<o&&!g(t.charCodeAt(j));)j++;if(j<o&&j!==B){for(B=j;j<o&&g(t.charCodeAt(j));)j++;if(j<o&&j!==B){for(B=j;j<o&&!g(t.charCodeAt(j));)j++;j===o?r=j:j!==B&&(r=j+1)}}}}else if(p(s)&&t.charCodeAt(1)===E){if(o<=2)return a.root=a.dir=t,a;if(r=2,g(t.charCodeAt(2))){if(o===3)return a.root=a.dir=t,a;r=3}}r>0&&(a.root=t.slice(0,r));let n=-1,b=r,P=-1,I=!0,O=t.length-1,R=0;for(;O>=r;--O){if(s=t.charCodeAt(O),g(s)){if(!I){b=O+1;break}continue}P===-1&&(I=!1,P=O+1),s===k?n===-1?n=O:R!==1&&(R=1):n!==-1&&(R=-1)}return P!==-1&&(n===-1||R===0||R===1&&n===P-1&&n===b+1?a.base=a.name=t.slice(b,P):(a.name=t.slice(b,n),a.base=t.slice(b,P),a.ext=t.slice(n,P))),b>0&&b!==r?a.dir=t.slice(0,b-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(c){const t=/\\/g;return()=>{const a=i.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>i.cwd()})();e.$hc={resolve(...t){let a="",o=!1;for(let r=t.length-1;r>=-1&&!o;r--){const s=r>=0?t[r]:l();d(s,"path"),s.length!==0&&(a=`${s}/${a}`,o=s.charCodeAt(0)===v)}return a=f(a,!o,"/",u),o?`/${a}`:a.length>0?a:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===v,o=t.charCodeAt(t.length-1)===v;return t=f(t,!a,"/",u),t.length===0?a?"/":o?"./":".":(o&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let a;for(let o=0;o<t.length;++o){const r=t[o];d(r,"path"),r.length>0&&(a===void 0?a=r:a+=`/${r}`)}return a===void 0?".":e.$hc.normalize(a)},relative(t,a){if(d(t,"from"),d(a,"to"),t===a||(t=e.$hc.resolve(t),a=e.$hc.resolve(a),t===a))return"";const o=1,r=t.length,s=r-o,n=1,b=a.length-n,P=s<b?s:b;let I=-1,O=0;for(;O<P;O++){const j=t.charCodeAt(o+O);if(j!==a.charCodeAt(n+O))break;j===v&&(I=O)}if(O===P)if(b>P){if(a.charCodeAt(n+O)===v)return a.slice(n+O+1);if(O===0)return a.slice(n+O)}else s>P&&(t.charCodeAt(o+O)===v?I=O:O===0&&(I=0));let R="";for(O=o+I+1;O<=r;++O)(O===r||t.charCodeAt(O)===v)&&(R+=R.length===0?"..":"/..");return`${R}${a.slice(n+I)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===v;let o=-1,r=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===v){if(!r){o=s;break}}else r=!1;return o===-1?a?"/":".":a&&o===1?"//":t.slice(0,o)},basename(t,a){a!==void 0&&d(a,"ext"),d(t,"path");let o=0,r=-1,s=!0,n;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let b=a.length-1,P=-1;for(n=t.length-1;n>=0;--n){const I=t.charCodeAt(n);if(I===v){if(!s){o=n+1;break}}else P===-1&&(s=!1,P=n+1),b>=0&&(I===a.charCodeAt(b)?--b===-1&&(r=n):(b=-1,r=P))}return o===r?r=P:r===-1&&(r=t.length),t.slice(o,r)}for(n=t.length-1;n>=0;--n)if(t.charCodeAt(n)===v){if(!s){o=n+1;break}}else r===-1&&(s=!1,r=n+1);return r===-1?"":t.slice(o,r)},extname(t){d(t,"path");let a=-1,o=0,r=-1,s=!0,n=0;for(let b=t.length-1;b>=0;--b){const P=t.charCodeAt(b);if(P===v){if(!s){o=b+1;break}continue}r===-1&&(s=!1,r=b+1),P===k?a===-1?a=b:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||r===-1||n===0||n===1&&a===r-1&&a===o+1?"":t.slice(a,r)},format:h.bind(null,"/"),parse(t){d(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const o=t.charCodeAt(0)===v;let r;o?(a.root="/",r=1):r=0;let s=-1,n=0,b=-1,P=!0,I=t.length-1,O=0;for(;I>=r;--I){const R=t.charCodeAt(I);if(R===v){if(!P){n=I+1;break}continue}b===-1&&(P=!1,b=I+1),R===k?s===-1?s=I:O!==1&&(O=1):s!==-1&&(O=-1)}if(b!==-1){const R=n===0&&o?1:n;s===-1||O===0||O===1&&s===b-1&&s===n+1?a.base=a.name=t.slice(R,b):(a.name=t.slice(R,s),a.base=t.slice(R,b),a.ext=t.slice(s,b))}return n>0?a.dir=t.slice(0,n-1):o&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=c?e.$gc.normalize:e.$hc.normalize,e.$jc=c?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=c?e.$gc.join:e.$hc.join,e.$lc=c?e.$gc.resolve:e.$hc.resolve,e.$mc=c?e.$gc.relative:e.$hc.relative,e.$nc=c?e.$gc.dirname:e.$hc.dirname,e.$oc=c?e.$gc.basename:e.$hc.basename,e.$pc=c?e.$gc.extname:e.$hc.extname,e.$qc=c?e.$gc.format:e.$hc.format,e.$rc=c?e.$gc.parse:e.$hc.parse,e.$sc=c?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=c?e.$gc.sep:e.$hc.sep,e.$uc=c?e.$gc.delimiter:e.$hc.delimiter}),define(Ee[37],ke([1,0,7,4,17,11]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=C,e.$cg=k,e.$dg=v,e.$eg=$,e.$fg=E,e.$gg=d,e.$hg=c,e.$ig=g,e.$jg=u,e.$kg=p,e.$lg=f,e.$mg=h,e.$ng=l,e.$og=t,e.$pg=a,e.$qg=s;function C(n){return n===47||n===92}function k(n){return n.replace(/[\\/]/g,i.$hc.sep)}function v(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}function $(n,b=i.$hc.sep){if(!n)return"";const P=n.length,I=n.charCodeAt(0);if(C(I)){if(C(n.charCodeAt(1))&&!C(n.charCodeAt(2))){let R=3;const j=R;for(;R<P&&!C(n.charCodeAt(R));R++);if(j!==R&&!C(n.charCodeAt(R+1))){for(R+=1;R<P;R++)if(C(n.charCodeAt(R)))return n.slice(0,R+1).replace(/[\\/]/g,b)}}return b}else if(u(I)&&n.charCodeAt(1)===58)return C(n.charCodeAt(2))?n.slice(0,2)+b:n.slice(0,2);let O=n.indexOf("://");if(O!==-1){for(O+=3;O<P;O++)if(C(n.charCodeAt(O)))return n.slice(0,O+1)}return""}function E(n){if(!A.$i||!n||n.length<5)return!1;let b=n.charCodeAt(0);if(b!==92||(b=n.charCodeAt(1),b!==92))return!1;let P=2;const I=P;for(;P<n.length&&(b=n.charCodeAt(P),b!==92);P++);return!(I===P||(b=n.charCodeAt(P+1),isNaN(b)||b===92))}const y=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(n,b=A.$i){const P=b?y:w;return!(!n||n.length===0||/^\s+$/.test(n)||(P.lastIndex=0,P.test(n))||b&&m.test(n)||n==="."||n===".."||b&&n[n.length-1]==="."||b&&n.length!==n.trim().length||n.length>255)}function c(n,b,P){const I=n===b;return!P||I?I:!n||!b?!1:(0,S.$lf)(n,b)}function g(n,b,P,I=i.sep){if(n===b)return!0;if(!n||!b||b.length>n.length)return!1;if(P){if(!(0,S.$mf)(n,b))return!1;if(b.length===n.length)return!0;let R=b.length;return b.charAt(b.length-1)===I&&R--,n.charAt(R)===I}return b.charAt(b.length-1)!==I&&(b+=I),n.indexOf(b)===0}function u(n){return n>=65&&n<=90||n>=97&&n<=122}function p(n,b){return A.$i&&n.endsWith(":")&&(n+=i.sep),(0,i.$jc)(n)||(n=(0,i.$kc)(b,n)),n=(0,i.$ic)(n),A.$i?(n=(0,S.$6e)(n,i.sep),n.endsWith(":")&&(n+=i.sep)):(n=(0,S.$6e)(n,i.sep),n||(n=i.sep)),n}function f(n){const b=(0,i.$ic)(n);return A.$i?n.length>3?!1:h(b)&&(n.length===2||b.charCodeAt(2)===92):b===i.$hc.sep}function h(n,b=A.$i){return b?u(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}function l(n,b=A.$i){return h(n,b)?n[0]:void 0}function t(n,b,P){return b.length>n.length?-1:n===b?0:(P&&(n=n.toLowerCase(),b=b.toLowerCase()),n.indexOf(b))}function a(n){const b=n.split(":");let P,I,O;for(const R of b){const j=Number(R);(0,D.$Zf)(j)?I===void 0?I=j:O===void 0&&(O=j):P=P?[P,R].join(":"):R}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:I!==void 0?I:void 0,column:O!==void 0?O:I!==void 0?1:void 0}}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(n,b,P=8){let I="";for(let R=0;R<P;R++){let j;R===0&&A.$i&&!b&&(P===3||P===4)?j=r:j=o,I+=j.charAt(Math.floor(Math.random()*j.length))}let O;return b?O=`${b}-${I}`:O=I,n?(0,i.$kc)(n,O):O}}),define(Ee[65],ke([1,0,7]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0,e.$As=D,e.$Bs=C,e.$Cs=k,e.$Ds=$,e.$zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(E){const y=(0,i.$pc)(E),w=A[y.toLowerCase()];return w!==void 0?w:C(E)}function C(E){const y=(0,i.$pc)(E);return S[y.toLowerCase()]}function k(E){for(const y in S)if(S[y]===E)return y}const v=/^(.+)\/(.+?)(;.+)?$/;function $(E,y){const w=v.exec(E);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:y?void 0:E}}),define(Ee[66],ke([1,0,4]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$$l=D,e.$_l=C;var A;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(A||(e.Source=A={}));var S;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function D(k,...v){const $=v.reduce((w,m)=>(w[m]=!0,w),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(w=>!$[w]).forEach(w=>{for(let m=0;m<E.length;m++)if(w.search(E[m])!==-1){delete k[w];break}})}function C(k){k&&(delete k.DEBUG,i.$j&&delete k.DYLD_LIBRARY_PATH,i.$k&&delete k.LD_PRELOAD)}}),define(Ee[3],ke([1,0,7,4]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=d,e.$xc=h;const S=/^\w[\w\d+.-]*$/,D=/^\//,C=/^\/\//;function k(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!S.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!D.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(r,s){return!r&&!s?"file":r}function $(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==y&&(s=y+s):s=y;break}return s}const E="",y="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(s){return s instanceof m?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,n,b,P,I,O=!1){typeof s=="object"?(this.scheme=s.scheme||E,this.authority=s.authority||E,this.path=s.path||E,this.query=s.query||E,this.fragment=s.fragment||E):(this.scheme=v(s,O),this.authority=n||E,this.path=$(this.scheme,b||E),this.query=P||E,this.fragment=I||E,k(this,O))}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:n,authority:b,path:P,query:I,fragment:O}=s;return n===void 0?n=this.scheme:n===null&&(n=E),b===void 0?b=this.authority:b===null&&(b=E),P===void 0?P=this.path:P===null&&(P=E),I===void 0?I=this.query:I===null&&(I=E),O===void 0?O=this.fragment:O===null&&(O=E),n===this.scheme&&b===this.authority&&P===this.path&&I===this.query&&O===this.fragment?this:new g(n,b,P,I,O)}static parse(s,n=!1){const b=w.exec(s);return b?new g(b[2]||E,o(b[4]||E),o(b[5]||E),o(b[7]||E),o(b[9]||E),n):new g(E,E,E,E,E)}static file(s){let n=E;if(A.$i&&(s=s.replace(/\\/g,y)),s[0]===y&&s[1]===y){const b=s.indexOf(y,2);b===-1?(n=s.substring(2),s=y):(n=s.substring(2,b),s=s.substring(b)||y)}return new g("file",n,s,E,E)}static from(s,n){return new g(s.scheme,s.authority,s.path,s.query,s.fragment,n)}static joinPath(s,...n){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return A.$i&&s.scheme==="file"?b=m.file(i.$gc.join(h(s,!0),...n)).path:b=i.$hc.join(s.path,...n),s.with({path:b})}toString(s=!1){return l(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof m)return s;{const n=new g(s);return n._formatted=s.external??null,n._fsPath=s._sep===c?s.fsPath??null:null,n}}else return s}}e.URI=m;function d(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const c=A.$i?1:void 0;class g extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=c),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function p(r,s,n){let b,P=-1;for(let I=0;I<r.length;I++){const O=r.charCodeAt(I);if(O>=97&&O<=122||O>=65&&O<=90||O>=48&&O<=57||O===45||O===46||O===95||O===126||s&&O===47||n&&O===91||n&&O===93||n&&O===58)P!==-1&&(b+=encodeURIComponent(r.substring(P,I)),P=-1),b!==void 0&&(b+=r.charAt(I));else{b===void 0&&(b=r.substr(0,I));const R=u[O];R!==void 0?(P!==-1&&(b+=encodeURIComponent(r.substring(P,I)),P=-1),b+=R):P===-1&&(P=I)}}return P!==-1&&(b+=encodeURIComponent(r.substring(P))),b!==void 0?b:r}function f(r){let s;for(let n=0;n<r.length;n++){const b=r.charCodeAt(n);b===35||b===63?(s===void 0&&(s=r.substr(0,n)),s+=u[b]):s!==void 0&&(s+=r[n])}return s!==void 0?s:r}function h(r,s){let n;return r.authority&&r.path.length>1&&r.scheme==="file"?n=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?n=r.path.substr(1):n=r.path[1].toLowerCase()+r.path.substr(2):n=r.path,A.$i&&(n=n.replace(/\//g,"\\")),n}function l(r,s){const n=s?f:p;let b="",{scheme:P,authority:I,path:O,query:R,fragment:j}=r;if(P&&(b+=P,b+=":"),(I||P==="file")&&(b+=y,b+=y),I){let B=I.indexOf("@");if(B!==-1){const Y=I.substr(0,B);I=I.substr(B+1),B=Y.lastIndexOf(":"),B===-1?b+=n(Y,!1,!1):(b+=n(Y.substr(0,B),!1,!1),b+=":",b+=n(Y.substr(B+1),!1,!0)),b+="@"}I=I.toLowerCase(),B=I.lastIndexOf(":"),B===-1?b+=n(I,!1,!0):(b+=n(I.substr(0,B),!1,!0),b+=I.substr(B))}if(O){if(O.length>=3&&O.charCodeAt(0)===47&&O.charCodeAt(2)===58){const B=O.charCodeAt(1);B>=65&&B<=90&&(O=`/${String.fromCharCode(B+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===58){const B=O.charCodeAt(0);B>=65&&B<=90&&(O=`${String.fromCharCode(B+32)}:${O.substr(2)}`)}b+=n(O,!0,!1)}return R&&(b+="?",b+=n(R,!1,!1)),j&&(b+="#",b+=s?j:p(j,!1,!1)),b}function t(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+t(r.substr(3)):r}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(r){return r.match(a)?r.replace(a,s=>t(s)):r}}),define(Ee[172],ke([1,0,3]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=A,e.$Gq=S,e.$Hq=D,e.log=k;function A($){const E=$;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function S($){const E=[];let y;try{const w=JSON.parse($.arguments),m=w[w.length-1];m&&m.__$stack&&(w.pop(),y=m.__$stack),E.push(...w)}catch{E.push("Unable to log remote console arguments",$.arguments)}return{args:E,stack:y}}function D($){if(typeof $!="string")return D(S($).stack);const E=$;if(E){const y=C(E),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(w&&w.length===4)return{uri:i.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function C($){if(!$)return $;const E=$.indexOf(`
`);return E===-1?$:$.substring(0,E)}function k($,E){const{args:y,stack:w}=S($),m=typeof y[0]=="string"&&y.length===1;let d=C(w);d&&(d=`(${d.trim()})`);let c=[];if(typeof y[0]=="string"?d&&m?c=[`%c[${E}] %c${y[0]} %c${d}`,v("blue"),v(""),v("grey")]:c=[`%c[${E}] %c${y[0]}`,v("blue"),v(""),...y.slice(1)]:c=[`%c[${E}]%`,v("blue"),...y],d&&!m&&c.push(d),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,c)}function v($){return`color: ${$}`}}),define(Ee[53],ke([1,0,14,3]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=S,e.$Qh=D,e.$Rh=k;function S(v){return JSON.stringify(v,C)}function D(v){let $=JSON.parse(v);return $=k($),$}function C(v,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function k(v,$=0){if(!v||$>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return A.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 17:return new Date(v.source)}if(v instanceof i.$ue||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let E=0;E<v.length;++E)v[E]=k(v[E],$+1);else for(const E in v)Object.hasOwnProperty.call(v,E)&&(v[E]=k(v[E],$+1))}return v}}),define(Ee[12],ke([1,0,10,4,17,3,7]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=v,e.$sg=$,e.$wg=y;var k;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.codeSetting="code-setting"})(k||(e.Schemas=k={}));function v(d,c){return D.URI.isUri(d)?(0,S.$lf)(d.scheme,c):(0,S.$mf)(d,c+":")}function $(d,...c){return c.some(g=>v(d,g))}e.$tg="vscode-tkn",e.$ug="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,g){this.f=y(c,g)}getServerRootPath(){return this.f}get g(){return C.$hc.join(this.f,k.vscodeRemoteResource)}set(c,g,u){this.a[c]=g,this.b[c]=u}setConnectionToken(c,g){this.c[c]=g}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(l){return i.$1(l),c}const g=c.authority;let u=this.a[g];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const p=this.b[g],f=this.c[g];let h=`path=${encodeURIComponent(c.path)}`;return typeof f=="string"&&(h+=`&${e.$ug}=${encodeURIComponent(f)}`),D.URI.from({scheme:A.$o?this.d:k.vscodeRemoteResource,authority:`${u}:${p}`,path:this.g,query:h})}}e.$vg=new E;function y(d,c){return C.$hc.join(c??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class w{static{this.a=e.$Bg}asBrowserUri(c){const g=this.b(c,le);return this.uriToBrowserUri(g)}uriToBrowserUri(c){return c.scheme===k.vscodeRemote?e.$vg.rewrite(c):c.scheme===k.file&&(A.$m||A.$q===`${k.vscodeFileResource}://${w.a}`)?c.with({scheme:k.vscodeFileResource,authority:c.authority||w.a,query:null,fragment:null}):c}asFileUri(c){const g=this.b(c,le);return this.uriToFileUri(g)}uriToFileUri(c){return c.scheme===k.vscodeFileResource?c.with({scheme:k.file,authority:c.authority!==w.a?c.authority:null,query:null,fragment:null}):c}b(c,g){return D.URI.isUri(c)?c:D.URI.parse(g.toUrl(c))}}e.$Cg=new w;var m;(function(d){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(c.get("3"));const g="vscode-coi";function u(f){let h;typeof f=="string"?h=new URL(f).searchParams:f instanceof URL?h=f.searchParams:D.URI.isUri(f)&&(h=new URL(f.toString(!0)).searchParams);const l=h?.get(g);if(l)return c.get(l)}d.getHeadersFromQuery=u;function p(f,h,l){if(!globalThis.crossOriginIsolated)return;const t=h&&l?"3":l?"2":"1";f instanceof URLSearchParams?f.set(g,t):f[g]=t}d.addSearchParam=p})(m||(e.COI=m={}))}),define(Ee[173],ke([1,0,95,12,4,3]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JD=E;class C{constructor(w,m,d){this.id=w,this.dependencies=m,this.callback=d}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,m,d)=>{typeof w!="string"&&(d=m,m=w,w=null),(typeof m!="object"||!Array.isArray(m))&&(d=m,m=null),this.c.push(new C(w,m,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const m=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!m)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(w){return new Promise((m,d)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const g=()=>{c.removeEventListener("load",u),c.removeEventListener("error",p)},u=f=>{g(),m(this.c.pop())},p=f=>{g(),d(f)};c.addEventListener("load",u),c.addEventListener("error",p),this.f&&(w=this.f.createScriptURL(w)),c.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(w){return new Promise((m,d)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),m(this.c.pop())}catch(c){d(c)}})}async j(w){try{const m=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,g=D.URI.parse(w).fsPath,u=m.readFileSync(g).toString(),p=c.wrap(u.replace(/^#!.*/,""));return new d.Script(p).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}const v=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function E(y,w,m){if(i.$T){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[y]&&(y=$[y]);const d=`${y}/${w}`;if(v.has(d))return v.get(d);let c;if(/^\w[\w\d+.-]*:\/\//.test(d))c=d;else{const f=`${m&&!S.$o?A.$zg:A.$yg}/${d}`;c=A.$Cg.asBrowserUri(f).toString(!0)}const g=k.INSTANCE.load(c);return v.set(d,g),g}else return await new Promise((d,c)=>{le([y],d,c)})}}),define(Ee[19],ke([1,0,37,12,7,4,17,3]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=v,e.$5g=E,e.$6g=w;function v(m){return(0,k.$xc)(m,!0)}class ${constructor(d){this.a=d}compare(d,c,g=!1){return d===c?0:(0,C.$ef)(this.getComparisonKey(d,g),this.getComparisonKey(c,g))}isEqual(d,c,g=!1){return d===c?!0:!d||!c?!1:this.getComparisonKey(d,g)===this.getComparisonKey(c,g)}getComparisonKey(d,c=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,c,g=!1){if(d.scheme===c.scheme){if(d.scheme===A.Schemas.file)return i.$ig(v(d),v(c),this.a(d))&&d.query===c.query&&(g||d.fragment===c.fragment);if((0,e.$1g)(d.authority,c.authority))return i.$ig(d.path,c.path,this.a(d),"/")&&d.query===c.query&&(g||d.fragment===c.fragment)}return!1}joinPath(d,...c){return k.URI.joinPath(d,...c)}basenameOrAuthority(d){return(0,e.$Sg)(d)||d.authority}basename(d){return S.$hc.basename(d.path)}extname(d){return S.$hc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let c;return d.scheme===A.Schemas.file?c=k.URI.file(S.$nc(v(d))).path:(c=S.$hc.dirname(d.path),d.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),c="/")),d.with({path:c})}normalizePath(d){if(!d.path.length)return d;let c;return d.scheme===A.Schemas.file?c=k.URI.file(S.$ic(v(d))).path:c=S.$hc.normalize(d.path),d.with({path:c})}relativePath(d,c){if(d.scheme!==c.scheme||!(0,e.$1g)(d.authority,c.authority))return;if(d.scheme===A.Schemas.file){const p=S.$mc(v(d),v(c));return D.$i?i.$cg(p):p}let g=d.path||"/";const u=c.path||"/";if(this.a(d)){let p=0;for(const f=Math.min(g.length,u.length);p<f&&!(g.charCodeAt(p)!==u.charCodeAt(p)&&g.charAt(p).toLowerCase()!==u.charAt(p).toLowerCase());p++);g=u.substr(0,p)+g.substr(p)}return S.$hc.relative(g,u)}resolvePath(d,c){if(d.scheme===A.Schemas.file){const g=k.URI.file(S.$lc(v(d),c));return d.with({authority:g.authority,path:g.path})}return c=i.$dg(c),d.with({path:S.$hc.resolve(d.path,c)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,c){return d===c||d!==void 0&&c!==void 0&&(0,C.$lf)(d,c)}hasTrailingPathSeparator(d,c=S.sep){if(d.scheme===A.Schemas.file){const g=v(d);return g.length>i.$eg(g).length&&g[g.length-1]===c}else{const g=d.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,c=S.sep){return(0,e.$2g)(d,c)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,c=S.sep){let g=!1;if(d.scheme===A.Schemas.file){const u=v(d);g=u!==void 0&&u.length===i.$eg(u).length&&u[u.length-1]===c}else{c="/";const u=d.path;g=u.length===1&&u.charCodeAt(u.length-1)===47}return!g&&!(0,e.$2g)(d,c)?d.with({path:d.path+"/"}):d}}e.$Kg=$,e.$Lg=new $(()=>!1),e.$Mg=new $(m=>m.scheme===A.Schemas.file?!D.$k:!0),e.$Ng=new $(m=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function E(m,d){const c=[];for(let g=0;g<m.length;g++){const u=d(m[g]);m.some((p,f)=>f===g?!1:(0,e.$Pg)(u,d(p)))||c.push(m[g])}return c}var y;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function d(c){const g=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(f=>{const[h,l]=f.split(":");h&&l&&g.set(h,l)});const p=c.path.substring(0,c.path.indexOf(";"));return p&&g.set(m.META_DATA_MIME,p),g}m.parseMetaData=d})(y||(e.DataUri=y={}));function w(m,d,c){if(d){let g=m.path;return g&&g[0]!==S.$hc.sep&&(g=S.$hc.sep+g),m.with({scheme:c,authority:d,path:g})}return m.with({scheme:c})}}),define(Ee[15],ke([1,0,20,10,6,2,19,4,155,60]),function(le,e,i,A,S,D,C,k,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=E,e.$8g=y,e.$9g=w,e.$0g=m,e.$$g=d,e.$_g=c,e.$ah=g,e.$bh=u,e.$jh=n,e.$kh=b,e.$lh=P,e.$mh=I,e.$nh=O,e.$Ch=G,e.$Kh=Q;function E(U){return!!U&&typeof U.then=="function"}function y(U){const L=new i.$ee,H=U(L.token),_=new Promise((ee,de)=>{const ie=L.token.onCancellationRequested(()=>{ie.dispose(),de(new A.$5)});Promise.resolve(H).then(me=>{ie.dispose(),L.dispose(),ee(me)},me=>{ie.dispose(),L.dispose(),de(me)})});return new class{cancel(){L.cancel(),L.dispose()}then(ee,de){return _.then(ee,de)}catch(ee){return this.then(void 0,ee)}finally(ee){return _.finally(ee)}}}function w(U,L,H){return new Promise((_,ee)=>{const de=L.onCancellationRequested(()=>{de.dispose(),_(H)});U.then(_,ee).finally(()=>de.dispose())})}function m(U,L){return new Promise((H,_)=>{const ee=L.onCancellationRequested(()=>{ee.dispose(),_(new A.$5)});U.then(H,_).finally(()=>ee.dispose())})}async function d(U){let L=-1;const H=U.map((_,ee)=>_.then(de=>(L=ee,de)));try{return await Promise.race(H)}finally{U.forEach((_,ee)=>{ee!==L&&_.cancel()})}}function c(U,L,H){let _;const ee=setTimeout(()=>{_?.(void 0),H?.()},L);return Promise.race([U.finally(()=>clearTimeout(ee)),new Promise(de=>_=de)])}function g(U){return new Promise((L,H)=>{const _=U();E(_)?_.then(L,H):L(_)})}function u(){let U,L;return{promise:new Promise((_,ee)=>{U=_,L=ee}),resolve:U,reject:L}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(L){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=L,!this.b){const H=()=>{if(this.b=null,this.f)return;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(H,H).then(_)})}return new Promise((H,_)=>{this.b.then(H,_)})}return this.a=L(),new Promise((H,_)=>{this.a.then(ee=>{this.a=null,H(ee)},ee=>{this.a=null,_(ee)})})}dispose(){this.f=!0}}e.$ch=p;class f{constructor(){this.a=Promise.resolve(null)}queue(L){return this.a=this.a.then(()=>L(),()=>L())}}e.$dh=f;class h{constructor(){this.a=new Map}queue(L,H){const ee=(this.a.get(L)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(L)===ee&&this.a.delete(L)});return this.a.set(L,ee),ee}}e.$eh=h;const l=(U,L)=>{let H=!0;const _=setTimeout(()=>{H=!1,L()},U);return{isTriggered:()=>H,dispose:()=>{clearTimeout(_),H=!1}}},t=U=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,U())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};class a{constructor(L){this.defaultDelay=L,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(L,H=this.defaultDelay){this.g=L,this.h(),this.b||(this.b=new Promise((ee,de)=>{this.d=ee,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const ee=this.g;return this.g=null,ee()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=H===v.$4d?t(_):l(H,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=a;class o{constructor(L){this.a=new a(L),this.b=new p}trigger(L,H){return this.a.trigger(()=>this.b.queue(L),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=o;class r{constructor(){this.a=!1,this.b=new Promise((L,H)=>{this.d=L})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=r;class s extends r{constructor(L){super(),this.f=setTimeout(()=>this.open(),L)}open(){clearTimeout(this.f),super.open()}}e.$ih=s;function n(U,L){return L?new Promise((H,_)=>{const ee=setTimeout(()=>{de.dispose(),H()},U),de=L.onCancellationRequested(()=>{clearTimeout(ee),de.dispose(),_(new A.$5)})}):y(H=>n(U,H))}function b(U,L=0,H){const _=setTimeout(()=>{U(),H&&ee.dispose()},L),ee=(0,D.$Sc)(()=>{clearTimeout(_),H?.deleteAndLeak(ee)});return H?.add(ee),ee}function P(U){const L=[];let H=0;const _=U.length;function ee(){return H<_?U[H++]():null}function de(ie){ie!=null&&L.push(ie);const me=ee();return me?me.then(de):Promise.resolve(L)}return Promise.resolve(null).then(de)}function I(U,L=_=>!!_,H=null){let _=0;const ee=U.length,de=()=>{if(_>=ee)return Promise.resolve(H);const ie=U[_++];return Promise.resolve(ie()).then(we=>L(we)?Promise.resolve(we):de())};return de()}function O(U,L=_=>!!_,H=null){if(U.length===0)return Promise.resolve(H);let _=U.length;const ee=()=>{_=-1;for(const de of U)de.cancel?.()};return new Promise((de,ie)=>{for(const me of U)me.then(we=>{--_>=0&&L(we)?(ee(),de(we)):_===0&&de(H)}).catch(we=>{--_>=0&&(ee(),ie(we))})})}class R{constructor(L){this.a=0,this.b=!1,this.f=L,this.g=[],this.d=0,this.h=new S.$7d}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(L){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((H,_)=>{this.g.push({factory:L,c:H,e:_}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const L=this.g.shift();this.d++;const H=L.factory();H.then(L.c,L.e),H.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=R;class j extends R{constructor(){super(1)}}e.$ph=j;class B{constructor(){this.a=new se,this.b=0}queue(L){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,L())):this.a.run(this.b++,L())}}e.$qh=B;class Y{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const L=new $e;return this.b.add(L),L.p}g(){for(const[,L]of this.a)if(L.size>0)return!1;return!0}queueSize(L,H=C.$Lg){const _=H.getComparisonKey(L);return this.a.get(_)?.size??0}queueFor(L,H,_=C.$Lg){const ee=_.getComparisonKey(L);let de=this.a.get(ee);if(!de){de=new j;const ie=this.f++,me=S.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(ee),this.h(),this.d?.deleteAndDispose(ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$4c),this.d.set(ie,me),this.a.set(ee,de)}return de.queue(H)}h(){this.g()&&this.j()}j(){for(const L of this.b)L.complete();this.b.clear()}dispose(){for(const[,L]of this.a)L.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=Y;class fe{constructor(L,H){this.a=-1,typeof L=="function"&&typeof H=="number"&&this.setIfNotSet(L,H)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(L,H){this.cancel(),this.a=setTimeout(()=>{this.a=-1,L()},H)}setIfNotSet(L,H){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,L()},H))}}e.$sh=fe;class ue{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(L,H,_=globalThis){this.cancel();const ee=_.setInterval(()=>{L()},H);this.d=(0,D.$Sc)(()=>{_.clearInterval(ee),this.d=void 0})}dispose(){this.cancel()}}e.$th=ue;class re{constructor(L,H){this.b=-1,this.a=L,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(L=this.d){this.cancel(),this.b=setTimeout(this.f,L)}get delay(){return this.d}set delay(L){this.d=L}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=re;class te{constructor(L,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=L,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(L=this.b){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(L/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=te;class V extends re{constructor(L,H){super(L,H),this.j=[]}work(L){this.j.push(L),this.isScheduled()||this.schedule()}h(){const L=this.j;this.j=[],this.a?.(L)}dispose(){this.j=[],super.dispose()}}e.$wh=V;class T extends D.$Uc{constructor(L,H){super(),this.g=L,this.h=H,this.a=[],this.b=this.B(new D.$Vc),this.f=!1}get pending(){return this.a.length}work(L){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+L.length>this.g.maxBufferedWork)return!1}else if(this.pending+L.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of L)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new re(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=T,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(U,L)=>{(0,k.$B)(()=>{if(H)return;const _=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$zh=(U,L,H)=>{const _=U.requestIdleCallback(L,typeof H=="number"?{timeout:H}:void 0);let ee=!1;return{dispose(){ee||(ee=!0,U.cancelIdleCallback(_))}}},e.$yh=U=>(0,e.$zh)(globalThis,U)}();class x{constructor(L,H){this.g=!1,this.d=()=>{try{this.j=H()}catch(_){this.l=_}finally{this.g=!0}},this.f=(0,e.$zh)(L,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=x;class Z extends x{constructor(L){super(globalThis,L)}}e.$Bh=Z;async function G(U,L,H){let _;for(let ee=0;ee<H;ee++)try{return await U()}catch(de){_=de,await n(L)}throw _}class se{isRunning(L){return typeof L=="number"?this.a?.taskId===L:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(L,H,_){return this.a={taskId:L,cancel:()=>_?.(),promise:H},H.then(()=>this.d(L),()=>this.d(L)),H}d(L){this.a&&L===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const L=this.b;this.b=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}queue(L){if(this.b)this.b.run=L;else{const{promise:H,resolve:_,reject:ee}=u();this.b={run:L,promise:H,promiseResolve:_,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=se;class ce{constructor(L,H=()=>Date.now()){this.d=L,this.f=H,this.a=0,this.b=0}increment(){const L=this.f();return L-this.a>this.d&&(this.a=L,this.b=0),this.b++,this.b}}e.$Eh=ce;var ne;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(ne||(ne={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((L,H)=>{this.a=L,this.b=H})}complete(L){return new Promise(H=>{this.a(L),this.d={outcome:0,value:L},H()})}error(L){return new Promise(H=>{this.b(L),this.d={outcome:1,value:L},H()})}cancel(){return this.error(new A.$5)}}e.$Fh=$e;var K;(function(U){async function L(_){let ee;const de=await Promise.all(_.map(ie=>ie.then(me=>me,me=>{ee||(ee=me)})));if(typeof ee<"u")throw ee;return de}U.settled=L;function H(_){return new Promise(async(ee,de)=>{try{await _(ee,de)}catch(ie){de(ie)}})}U.withAsyncBody=H})(K||(e.Promises=K={}));class q{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(L){this.a=void 0,this.b=void 0,this.d=!1,this.promise=L.then(H=>(this.a=H,this.d=!0,H),H=>{throw this.b=H,this.d=!0,H})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=q;class N{constructor(L){this.b=L,this.a=new $.$V(()=>new q(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=N;var z;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(z||(z={}));class X{static fromArray(L){return new X(H=>{H.emitMany(L)})}static fromPromise(L){return new X(async H=>{H.emitMany(await L)})}static fromPromises(L){return new X(async H=>{await Promise.all(L.map(async _=>H.emitOne(await _)))})}static merge(L){return new X(async H=>{await Promise.all(L.map(async _=>{for await(const ee of _)H.emitOne(ee)}))})}static{this.EMPTY=X.fromArray([])}constructor(L){this.a=0,this.b=[],this.d=null,this.f=new S.$7d,queueMicrotask(async()=>{const H={emitOne:_=>this.g(_),emitMany:_=>this.h(_),reject:_=>this.k(_)};try{await Promise.resolve(L(H)),this.j()}catch(_){this.k(_)}finally{H.emitOne=void 0,H.emitMany=void 0,H.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(L<this.b.length)return{done:!1,value:this.b[L++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.f.event)}while(!0)}}}static map(L,H){return new X(async _=>{for await(const ee of L)_.emitOne(H(ee))})}map(L){return X.map(this,L)}static filter(L,H){return new X(async _=>{for await(const ee of L)H(ee)&&_.emitOne(ee)})}filter(L){return X.filter(this,L)}static coalesce(L){return X.filter(L,H=>!!H)}coalesce(){return X.coalesce(this)}static async toPromise(L){const H=[];for await(const _ of L)H.push(_);return H}toPromise(){return X.toPromise(this)}g(L){this.a===0&&(this.b.push(L),this.f.fire())}h(L){this.a===0&&(this.b=this.b.concat(L),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(L){this.a===0&&(this.a=2,this.d=L,this.f.fire())}}e.$Ih=X;class ae extends X{constructor(L,H){super(H),this.l=L}cancel(){this.l.cancel()}}e.$Jh=ae;function Q(U){const L=new i.$ee,H=U(L.token);return new ae(L,async _=>{const ee=L.token.onCancellationRequested(()=>{ee.dispose(),L.dispose(),_.reject(new A.$5)});try{for await(const de of H){if(L.token.isCancellationRequested)return;_.emitOne(de)}ee.dispose(),L.dispose()}catch(de){ee.dispose(),L.dispose(),_.reject(de)}})}class J{constructor(){this.a=new $e,this.b=new X(_=>{if(L){_.reject(L);return}return H&&_.emitMany(H),this.d=ee=>_.reject(ee),this.f=ee=>_.emitOne(ee),this.a.p});let L,H;this.f=_=>{H||(H=[]),H.push(_)},this.d=_=>{L||(L=_)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(L){this.d(L),this.a.complete()}emitOne(L){this.f(L)}}e.$Lh=J}),define(Ee[79],ke([1,0,18,15,37,24,7,4,17]),function(le,e,i,A,S,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=$,e.$ak=d,e.$bk=j,e.$ck=B,e.$dk=Y,e.$ek=fe,e.$fk=ue,e.$gk=T;function $(){return Object.create(null)}e.$$j="**",e.$_j="/";const E="[/\\\\]",y="[^/\\\\]",w=/\//g;function m(x,Z){switch(x){case 0:return"";case 1:return`${y}*?`;default:return`(?:${E}|${y}+${E}${Z?`|${E}${y}+`:""})*?`}}function d(x,Z){if(!x)return[];const G=[];let se=!1,ce=!1,ne="";for(const $e of x){switch($e){case Z:if(!se&&!ce){G.push(ne),ne="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ne+=$e}return ne&&G.push(ne),G}function c(x){if(!x)return"";let Z="";const G=d(x,e.$_j);if(G.every(se=>se===e.$$j))Z=".*";else{let se=!1;G.forEach((ce,ne)=>{if(ce===e.$$j){if(se)return;Z+=m(2,ne===G.length-1)}else{let $e=!1,K="",q=!1,N="";for(const z of ce){if(z!=="}"&&$e){K+=z;continue}if(q&&(z!=="]"||!N)){let X;z==="-"?X=z:(z==="^"||z==="!")&&!N?X="^":z===e.$_j?X="":X=(0,v.$Ze)(z),N+=X;continue}switch(z){case"{":$e=!0;continue;case"[":q=!0;continue;case"}":{const ae=`(?:${d(K,",").map(Q=>c(Q)).join("|")})`;Z+=ae,$e=!1,K="";break}case"]":{Z+="["+N+"]",q=!1,N="";break}case"?":Z+=y;continue;case"*":Z+=m(1);continue;default:Z+=(0,v.$Ze)(z)}}ne<G.length-1&&(G[ne+1]!==e.$$j||ne+2<G.length)&&(Z+=E)}se=ce===e.$$j})}return Z}const g=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.$Ec(1e4),a=function(){return!1},o=function(){return null};function r(x,Z){if(!x)return o;let G;typeof x!="string"?G=x.pattern:G=x,G=G.trim();const se=`${G}_${!!Z.trimForExclusions}`;let ce=t.get(se);if(ce)return s(ce,x);let ne;return g.test(G)?ce=b(G.substr(4),G):(ne=u.exec(n(G,Z)))?ce=P(ne[1],G):(Z.trimForExclusions?f:p).test(G)?ce=I(G,Z):(ne=h.exec(n(G,Z)))?ce=O(ne[1].substr(1),G,!0):(ne=l.exec(n(G,Z)))?ce=O(ne[1],G,!1):ce=R(G),t.set(se,ce),s(ce,x)}function s(x,Z){if(typeof Z=="string")return x;const G=function(se,ce){return(0,S.$ig)(se,Z.base,!k.$k)?x((0,v.$5e)(se.substr(Z.base.length),C.sep),ce):null};return G.allBasenames=x.allBasenames,G.allPaths=x.allPaths,G.basenames=x.basenames,G.patterns=x.patterns,G}function n(x,Z){return Z.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function b(x,Z){return function(G,se){return typeof G=="string"&&G.endsWith(x)?Z:null}}function P(x,Z){const G=`/${x}`,se=`\\${x}`,ce=function($e,K){return typeof $e!="string"?null:K?K===x?Z:null:$e===x||$e.endsWith(G)||$e.endsWith(se)?Z:null},ne=[x];return ce.basenames=ne,ce.patterns=[Z],ce.allBasenames=ne,ce}function I(x,Z){const G=V(x.slice(1,-1).split(",").map(K=>r(K,Z)).filter(K=>K!==o),x),se=G.length;if(!se)return o;if(se===1)return G[0];const ce=function(K,q){for(let N=0,z=G.length;N<z;N++)if(G[N](K,q))return x;return null},ne=G.find(K=>!!K.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const $e=G.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return $e.length&&(ce.allPaths=$e),ce}function O(x,Z,G){const se=C.sep===C.$hc.sep,ce=se?x:x.replace(w,C.sep),ne=C.sep+ce,$e=C.$hc.sep+x;let K;return G?K=function(q,N){return typeof q=="string"&&(q===ce||q.endsWith(ne)||!se&&(q===x||q.endsWith($e)))?Z:null}:K=function(q,N){return typeof q=="string"&&(q===ce||!se&&q===x)?Z:null},K.allPaths=[(G?"*/":"./")+x],K}function R(x){try{const Z=new RegExp(`^${c(x)}$`);return function(G){return Z.lastIndex=0,typeof G=="string"&&Z.test(G)?x:null}}catch{return o}}function j(x,Z,G){return!x||typeof Z!="string"?!1:B(x)(Z,void 0,G)}function B(x,Z={}){if(!x)return a;if(typeof x=="string"||Y(x)){const G=r(x,Z);if(G===o)return a;const se=function(ce,ne){return!!G(ce,ne)};return G.allBasenames&&(se.allBasenames=G.allBasenames),G.allPaths&&(se.allPaths=G.allPaths),se}return re(x,Z)}function Y(x){const Z=x;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}function fe(x){return x.allBasenames||[]}function ue(x){return x.allPaths||[]}function re(x,Z){const G=V(Object.getOwnPropertyNames(x).map(K=>te(K,x[K],Z)).filter(K=>K!==o)),se=G.length;if(!se)return o;if(!G.some(K=>!!K.requiresSiblings)){if(se===1)return G[0];const K=function(z,X){let ae;for(let Q=0,J=G.length;Q<J;Q++){const U=G[Q](z,X);if(typeof U=="string")return U;(0,A.$7g)(U)&&(ae||(ae=[]),ae.push(U))}return ae?(async()=>{for(const Q of ae){const J=await Q;if(typeof J=="string")return J}return null})():null},q=G.find(z=>!!z.allBasenames);q&&(K.allBasenames=q.allBasenames);const N=G.reduce((z,X)=>X.allPaths?z.concat(X.allPaths):z,[]);return N.length&&(K.allPaths=N),K}const ce=function(K,q,N){let z,X;for(let ae=0,Q=G.length;ae<Q;ae++){const J=G[ae];J.requiresSiblings&&N&&(q||(q=(0,C.$oc)(K)),z||(z=q.substr(0,q.length-(0,C.$pc)(K).length)));const U=J(K,q,z,N);if(typeof U=="string")return U;(0,A.$7g)(U)&&(X||(X=[]),X.push(U))}return X?(async()=>{for(const ae of X){const Q=await ae;if(typeof Q=="string")return Q}return null})():null},ne=G.find(K=>!!K.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const $e=G.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return $e.length&&(ce.allPaths=$e),ce}function te(x,Z,G){if(Z===!1)return o;const se=r(x,G);if(se===o)return o;if(typeof Z=="boolean")return se;if(Z){const ce=Z.when;if(typeof ce=="string"){const ne=($e,K,q,N)=>{if(!N||!se($e,K))return null;const z=ce.replace("$(basename)",()=>q),X=N(z);return(0,A.$7g)(X)?X.then(ae=>ae?x:null):X?x:null};return ne.requiresSiblings=!0,ne}}return se}function V(x,Z){const G=x.filter(K=>!!K.basenames);if(G.length<2)return x;const se=G.reduce((K,q)=>{const N=q.basenames;return N?K.concat(N):K},[]);let ce;if(Z){ce=[];for(let K=0,q=se.length;K<q;K++)ce.push(Z)}else ce=G.reduce((K,q)=>{const N=q.patterns;return N?K.concat(N):K},[]);const ne=function(K,q){if(typeof K!="string")return null;if(!q){let z;for(z=K.length;z>0;z--){const X=K.charCodeAt(z-1);if(X===47||X===92)break}q=K.substr(z)}const N=se.indexOf(q);return N!==-1?ce[N]:null};ne.basenames=se,ne.patterns=ce,ne.allBasenames=se;const $e=x.filter(K=>!K.basenames);return $e.push(ne),$e}function T(x,Z){return(0,i.$ub)(x,Z,(G,se)=>typeof G=="string"&&typeof se=="string"?G===se:typeof G!="string"&&typeof se!="string"?G.base===se.base&&G.pattern===se.pattern:!1)}}),define(Ee[101],ke([1,0,10,157,19,17,3]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.MarkdownStringTextNewlineStyle=void 0,e.$Gk=$,e.$Hk=E,e.$Ik=y,e.$Jk=w,e.$Kk=m,e.$Lk=d,e.$Mk=c,e.$Nk=g;var k;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(k||(e.MarkdownStringTextNewlineStyle=k={}));class v{constructor(p="",f=!1){if(this.value=p,typeof this.value!="string")throw(0,i.$7)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(p,f=0){return this.value+=w(this.supportThemeIcons?(0,A.$zk)(p):p).replace(/([ \t]+)/g,(h,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,f){return this.value+=`
${m(f,p)}
`,this}appendLink(p,f,h){return this.value+="[",this.value+=this.c(f,"]"),this.value+="](",this.value+=this.c(String(p),")"),h&&(this.value+=` "${this.c(this.c(h,'"'),")")}"`),this.value+=")",this}c(p,f){const h=new RegExp((0,D.$Ze)(f),"g");return p.replace(h,(l,t)=>p.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$Fk=v;function $(u){return E(u)?!u.value:Array.isArray(u)?u.every($):!0}function E(u){return u instanceof v?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}function y(u,p){return u===p?!0:!u||!p?!1:u.value===p.value&&u.isTrusted===p.isTrusted&&u.supportThemeIcons===p.supportThemeIcons&&u.supportHtml===p.supportHtml&&(u.baseUri===p.baseUri||!!u.baseUri&&!!p.baseUri&&(0,S.$Og)(C.URI.from(u.baseUri),C.URI.from(p.baseUri)))}function w(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(u,p){const f=u.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,h=f>=3?f+1:3;return[`${"`".repeat(h)}${p}`,u,`${"`".repeat(h)}`].join(`
`)}function d(u){return u.replace(/"/g,"&quot;")}function c(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(u){const p=[],f=u.split("|").map(l=>l.trim());u=f[0];const h=f[1];if(h){const l=/height=(\d+)/.exec(h),t=/width=(\d+)/.exec(h),a=l?l[1]:"",o=t?t[1]:"",r=isFinite(parseInt(o)),s=isFinite(parseInt(a));r&&p.push(`width="${o}"`),s&&p.push(`height="${a}"`)}return{href:u,dimensions:p}}}),define(Ee[174],ke([1,0,18,37,7,4,19,17]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=v,e.$hw=E,e.$iw=w,e.$jw=m,e.$kw=u,e.$lw=f,e.$mw=h,e.$nw=l,e.$ow=t,e.$pw=a;function v(r,s){const{os:n,tildify:b,relative:P}=s;if(P){const R=$(r,P,n);if(typeof R=="string")return R}let I=r.fsPath;if(n===1&&!D.$i?I=I.replace(/\//g,"\\"):n!==1&&D.$i&&(I=I.replace(/\\/g,"/")),n!==1&&b?.userHome){const R=b.userHome.fsPath;let j;r.scheme!==b.userHome.scheme&&r.path[0]===S.$hc.sep&&r.path[1]!==S.$hc.sep?j=b.userHome.with({path:r.path}).fsPath:j=I,I=w(j,R,n)}return(n===1?S.$gc:S.$hc).normalize(E(I,n===1))}function $(r,s,n){const b=n===1?S.$gc:S.$hc,P=n===3?C.$Lg:C.$Ng,I=s.getWorkspace(),O=(0,i.$Ob)(I.folders);if(!O)return;r.scheme!==O.uri.scheme&&r.path[0]===S.$hc.sep&&r.path[1]!==S.$hc.sep&&(r=O.uri.with({path:r.path}));const R=s.getWorkspaceFolder(r);if(!R)return;let j;if(P.isEqual(R.uri,r)?j="":j=P.relativePath(R.uri,r)??"",j&&(j=b.normalize(j)),I.folders.length>1&&!s.noPrefix){const B=R.name?R.name:P.basenameOrAuthority(R.uri);j=j?`${B} \u2022 ${j}`:B}return j}function E(r,s=D.$i){return(0,A.$mg)(r,s)?r.charAt(0).toUpperCase()+r.slice(1):r}let y=Object.create(null);function w(r,s,n=D.OS){if(n===1||!r||!s)return r;let b=y.original===s?y.normalized:void 0;b||(b=s,D.$i&&(b=(0,A.$cg)(b)),b=`${(0,k.$6e)(b,S.$hc.sep)}${S.$hc.sep}`,y={original:s,normalized:b});let P=r;return D.$i&&(P=(0,A.$cg)(P)),(n===3?P.startsWith(b):(0,k.$mf)(P,b))?`~/${P.substr(b.length)}`:r}function m(r,s){return r.replace(/^~($|\/|\\)/,`${s}$1`)}const d="\u2026",c="\\\\",g="~";function u(r,s=S.sep){const n=new Array(r.length);let b=!1;for(let P=0;P<r.length;P++){const I=r[P];if(I===""){n[P]=`.${s}`;continue}if(!I){n[P]=I;continue}b=!0;let O="",R=I;R.indexOf(c)===0?(O=R.substr(0,R.indexOf(c)+c.length),R=R.substr(R.indexOf(c)+c.length)):R.indexOf(s)===0?(O=R.substr(0,R.indexOf(s)+s.length),R=R.substr(R.indexOf(s)+s.length)):R.indexOf(g)===0&&(O=R.substr(0,R.indexOf(g)+g.length),R=R.substr(R.indexOf(g)+g.length));const j=R.split(s);for(let B=1;b&&B<=j.length;B++)for(let Y=j.length-B;b&&Y>=0;Y--){b=!1;let fe=j.slice(Y,Y+B).join(s);for(let ue=0;!b&&ue<r.length;ue++)if(ue!==P&&r[ue]&&r[ue].indexOf(fe)>-1){const re=Y+B===j.length,te=Y>0&&r[ue].indexOf(s)>-1?s+fe:fe,V=r[ue].endsWith(te);b=!re||V}if(!b){let ue="";(j[0].endsWith(":")||O!=="")&&(Y===1&&(Y=0,B++,fe=j[0]+s+fe),Y>0&&(ue=j[0]+s),ue=O+ue),Y>0&&(ue=ue+d+s),ue=ue+fe,Y+B<j.length&&(ue=ue+s+d),n[P]=ue}}b&&(n[P]=I)}return n}var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function f(r,s=Object.create(null)){const n=[];let b=!1,P="";for(const I of r)if(I==="$"||b&&I==="{")P&&n.push({value:P,type:p.TEXT}),P="",b=!0;else if(I==="}"&&b){const O=s[P];if(typeof O=="string")O.length&&n.push({value:O,type:p.VARIABLE});else if(O){const R=n[n.length-1];(!R||R.type!==p.SEPARATOR)&&n.push({value:O.label,type:p.SEPARATOR})}P="",b=!1}else P+=I;return P&&!b&&n.push({value:P,type:p.TEXT}),n.filter((I,O)=>{if(I.type===p.SEPARATOR){const R=n[O-1],j=n[O+1];return[R,j].every(B=>B&&(B.type===p.VARIABLE||B.type===p.TEXT)&&B.value.length>0)}return!0}).map(I=>I.value).join("")}function h(r,s){return D.$j||s?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$j?"&":"&&"):r.replace(/&&|&/g,n=>n==="&"?"&&":"&")}function l(r,s){return D.$j||s?r.replace(/\(&&\w\)|&&/g,""):D.$i?r.replace(/&&|&/g,n=>n==="&"?"&&":"&"):r.replace(/&&/g,"_")}function t(r){return r.replace(/&/g,"&&")}function a(r){if(r.endsWith("]")){const s=r.lastIndexOf(" [",r.length-2);if(s!==-1){const n=o(r.substring(0,s)),b=r.substring(s);return{name:n.name+b,parentPath:n.parentPath}}}return o(r)}function o(r){const s=r.indexOf("/")!==-1?S.$hc:S.$gc,n=s.basename(r),b=s.dirname(r);return n.length?{name:n,parentPath:b}:{name:b,parentPath:""}}}),define(Ee[54],ke([1,0,14,3]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=void 0,e.$mn=k,e.$nn=$,e.$on=E;function S(y){return y.toJSON()}class D{constructor(w){this.a=w}transformIncoming(w){const m=this.a.transformIncoming(w);return m===w?w:S(A.URI.from(m))}transformOutgoing(w){const m=this.a.transformOutgoing(w);return m===w?w:S(A.URI.from(m))}transformOutgoingURI(w){const m=this.a.transformOutgoing(w);return m===w?w:A.URI.from(m)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$kn=D,e.$ln=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function C(y,w,m){if(!y||m>200)return null;if(typeof y=="object"){if(y instanceof A.URI)return w.transformOutgoing(y);for(const d in y)if(Object.hasOwnProperty.call(y,d)){const c=C(y[d],w,m+1);c!==null&&(y[d]=c)}}return null}function k(y,w){const m=C(y,w,0);return m===null?y:m}function v(y,w,m,d){if(!y||d>200)return null;if(typeof y=="object"){if(y.$mid===1)return m?A.URI.revive(w.transformIncoming(y)):w.transformIncoming(y);if(y instanceof i.$ue)return null;for(const c in y)if(Object.hasOwnProperty.call(y,c)){const g=v(y[c],w,m,d+1);g!==null&&(y[c]=g)}}return null}function $(y,w){const m=v(y,w,!1,0);return m===null?y:m}function E(y,w){const m=v(y,w,!0,0);return m===null?y:m}}),define(Ee[102],ke([1,0,29,64,22,160,4]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0,e.$rn=v,e.$sn=y,e.$qn=new class{c(w){return this.a||(this.a=A.$oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,m=0;const d=(0,i.networkInterfaces)();for(const c in d){const g=d[c];if(g)for(const{mac:u,internal:p}of g)p||(m+=1,this.c(u.toUpperCase())&&(w+=1))}this.b=m>0?w/m:0}return this.b}};let k;async function v(w){return k||(k=(async()=>await $(w)||S.$Eg())()),k}async function $(w){try{const m=await new Promise((c,g)=>{le(["crypto"],c,g)}),d=(0,D.$pn)();return m.createHash("sha256").update(d,"utf8").digest("hex")}catch(m){w(m);return}}const E="Software\\Microsoft\\SQMClient";async function y(w){if(C.$i){const m=await new Promise((d,c)=>{le(["@vscode/windows-registry"],d,c)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(d){return w(d),""}}return""}}),define(Ee[175],ke([1,0,27,304,305,4]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=C;async function C(k){if(D.$j||D.$i)return;let v;for(const $ of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{v=await(0,A.open)($,i.constants.R_OK);break}catch{}if(!v){k("Unable to retrieve release information from known identifier paths.");return}try{const $=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const y of(0,S.createInterface)({input:v.createReadStream(),crlfDelay:1/0})){if(!y.includes("="))continue;const w=y.split("=")[0].toUpperCase().trim();if($.has(w)){const m=y.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?E.id=m:w==="ID_LIKE"?E.id_like=m:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(E.version_id=m)}}return E}catch($){k($)}}}),define(Ee[23],ke([1,0,27,29,306,15,37,98,7,4,19,3]),function(le,e,i,A,S,D,C,k,v,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=f,e.whenDeleted=t,e.configureFlushOnWrite=n,e.writeFileSync=P;var w;(function(te){te[te.UNLINK=0]="UNLINK",te[te.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function m(te,V=w.UNLINK,T){if((0,C.$lg)(te))throw new Error("rimraf - will refuse to recursively delete root");return V===w.UNLINK?c(te):d(te,T)}async function d(te,V=(0,C.$qg)((0,A.tmpdir)())){try{try{await i.promises.rename(te,V)}catch(T){return T.code==="ENOENT"?void 0:c(te)}c(V).catch(T=>{})}catch(T){if(T.code!=="ENOENT")throw T}}async function c(te){return(0,S.promisify)(i.rm)(te,{recursive:!0,force:!0,maxRetries:3})}function g(te){if((0,C.$lg)(te))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(te,{recursive:!0,force:!0,maxRetries:3})}async function u(te,V){return h(await(V?p(te):(0,S.promisify)(i.readdir)(te)))}async function p(te){try{return await(0,S.promisify)(i.readdir)(te,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const V=[],T=await u(te);for(const x of T){let Z=!1,G=!1,se=!1;try{const ce=await e.Promises.lstat((0,v.$kc)(te,x));Z=ce.isFile(),G=ce.isDirectory(),se=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}V.push({name:x,isFile:()=>Z,isDirectory:()=>G,isSymbolicLink:()=>se})}return V}function f(te){return h(i.readdirSync(te))}function h(te){return te.map(V=>typeof V=="string"?$.$j?(0,k.$Zl)(V):V:(V.name=$.$j?(0,k.$Zl)(V.name):V.name,V))}async function l(te){const V=await u(te),T=[];for(const x of V)await a.existsDirectory((0,v.$kc)(te,x))&&T.push(x);return T}function t(te,V=1e3){return new Promise(T=>{let x=!1;const Z=setInterval(()=>{x||(x=!0,i.access(te,G=>{x=!1,G&&(clearInterval(Z),T(void 0))}))},V)})}var a;(function(te){async function V(Z){let G;try{if(G=await e.Promises.lstat(Z),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(se){if(se.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if($.$i&&se.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ce}throw se}}te.stat=V;async function T(Z){try{const{stat:G,symbolicLink:se}=await te.stat(Z);return G.isFile()&&se?.dangling!==!0}catch{}return!1}te.existsFile=T;async function x(Z){try{const{stat:G,symbolicLink:se}=await te.stat(Z);return G.isDirectory()&&se?.dangling!==!0}catch{}return!1}te.existsDirectory=x})(a||(e.SymlinkSupport=a={}));const o=new D.$rh;function r(te,V,T){return o.queueFor(y.URI.file(te),()=>{const x=I(T);return new Promise((Z,G)=>b(te,V,x,se=>se?G(se):Z()))},E.$Mg)}let s=!0;function n(te){s=te}function b(te,V,T,x){if(!s)return i.writeFile(te,V,{mode:T.mode,flag:T.flag},x);i.open(te,T.flag,T.mode,(Z,G)=>{if(Z)return x(Z);i.writeFile(G,V,se=>{if(se)return i.close(G,()=>x(se));i.fdatasync(G,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),n(!1)),i.close(G,ne=>x(ne))))})})}function P(te,V,T){const x=I(T);if(!s)return i.writeFileSync(te,V,{mode:x.mode,flag:x.flag});const Z=i.openSync(te,x.flag,x.mode);try{i.writeFileSync(Z,V);try{i.fdatasyncSync(Z)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),n(!1)}}finally{i.closeSync(Z)}}function I(te){return te?{mode:typeof te.mode=="number"?te.mode:438,flag:typeof te.flag=="string"?te.flag:"w"}:{mode:438,flag:"w"}}async function O(te,V,T=6e4){if(te!==V)try{$.$i&&typeof T=="number"?await R(te,V,Date.now(),T):await(0,S.promisify)(i.rename)(te,V)}catch(x){if(te.toLowerCase()!==V.toLowerCase()&&x.code==="EXDEV"||te.endsWith("."))await j(te,V,{preserveSymlinks:!1}),await m(te,w.MOVE);else throw x}}async function R(te,V,T,x,Z=0){try{return await(0,S.promisify)(i.rename)(te,V)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-T>=x)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${G}`),G;if(Z===0){let se=!1;try{const{stat:ce}=await a.stat(V);ce.isFile()||(se=!0)}catch{}if(se)throw G}return await(0,D.$jh)(Math.min(100,Z*10)),R(te,V,T,x,Z+1)}}async function j(te,V,T){return Y(te,V,{root:{source:te,target:V},options:T,handledSourcePaths:new Set})}const B=511;async function Y(te,V,T){if(T.handledSourcePaths.has(te))return;T.handledSourcePaths.add(te);const{stat:x,symbolicLink:Z}=await a.stat(te);if(Z){if(T.options.preserveSymlinks)try{return await re(te,V,T)}catch{}if(Z.dangling)return}return x.isDirectory()?fe(te,V,x.mode&B,T):ue(te,V,x.mode&B)}async function fe(te,V,T,x){await e.Promises.mkdir(V,{recursive:!0,mode:T});const Z=await u(te);for(const G of Z)await Y((0,v.$kc)(te,G),(0,v.$kc)(V,G),x)}async function ue(te,V,T){await e.Promises.copyFile(te,V),await e.Promises.chmod(V,T)}async function re(te,V,T){let x=await e.Promises.readlink(te);(0,C.$ig)(x,T.root.source,!$.$k)&&(x=(0,v.$kc)(T.root.target,x.substr(T.root.source.length+1))),await e.Promises.symlink(x,V)}e.Promises=new class{get access(){return(0,S.promisify)(i.access)}get stat(){return(0,S.promisify)(i.stat)}get lstat(){return(0,S.promisify)(i.lstat)}get utimes(){return(0,S.promisify)(i.utimes)}get read(){return(te,V,T,x,Z)=>new Promise((G,se)=>{i.read(te,V,T,x,Z,(ce,ne,$e)=>ce?se(ce):G({bytesRead:ne,buffer:$e}))})}get readFile(){return(0,S.promisify)(i.readFile)}get write(){return(te,V,T,x,Z)=>new Promise((G,se)=>{i.write(te,V,T,x,Z,(ce,ne,$e)=>ce?se(ce):G({bytesWritten:ne,buffer:$e}))})}get appendFile(){return(0,S.promisify)(i.appendFile)}get fdatasync(){return(0,S.promisify)(i.fdatasync)}get truncate(){return(0,S.promisify)(i.truncate)}get copyFile(){return(0,S.promisify)(i.copyFile)}get open(){return(0,S.promisify)(i.open)}get close(){return(0,S.promisify)(i.close)}get symlink(){return(0,S.promisify)(i.symlink)}get readlink(){return(0,S.promisify)(i.readlink)}get chmod(){return(0,S.promisify)(i.chmod)}get mkdir(){return(0,S.promisify)(i.mkdir)}get unlink(){return(0,S.promisify)(i.unlink)}get rmdir(){return(0,S.promisify)(i.rmdir)}get realpath(){return(0,S.promisify)(i.realpath)}async exists(te){try{return await e.Promises.access(te),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return l}get writeFile(){return r}get rm(){return m}get rename(){return O}get copy(){return j}}}),define(Ee[176],ke([1,0,27,7,4,17,23]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=k,e.$Oq=v,e.$Pq=$,e.$Qq=E;function k(w){if(S.$k)return w;const m=(0,A.$nc)(w);if(w===m)return w;const d=((0,A.$oc)(w)||w).toLowerCase();try{const g=(0,C.readdirSync)(m).filter(u=>u.toLowerCase()===d);if(g.length===1){const u=k(m);if(u)return(0,A.$kc)(u,g[0])}else if(g.length>1){const u=g.indexOf(d);if(u>=0){const p=k(m);if(p)return(0,A.$kc)(p,g[u])}}}catch{}return null}async function v(w,m){if(S.$k)return w;const d=(0,A.$nc)(w);if(w===d)return w;const c=((0,A.$oc)(w)||w).toLowerCase();try{if(m?.isCancellationRequested)return null;const u=(await C.Promises.readdir(d)).filter(p=>p.toLowerCase()===c);if(u.length===1){const p=await v(d,m);if(p)return(0,A.$kc)(p,u[0])}else if(u.length>1){const p=u.indexOf(c);if(p>=0){const f=await v(d,m);if(f)return(0,A.$kc)(f,u[p])}}}catch{}return null}async function $(w){try{return await C.Promises.realpath(w)}catch{const d=y(w);return await C.Promises.access(d,i.constants.R_OK),d}}function E(w){try{return i.realpathSync(w)}catch{const d=y(w);return i.accessSync(d,i.constants.R_OK),d}}function y(w){return(0,D.$6e)((0,A.$ic)(w),A.sep)}}),define(Ee[103],ke([1,0,29,7,23]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=p,e.$0l=f;const D=/^\d+$/,C=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var v;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(v||(v={}));let $;switch(process.arch){case"ia32":$=1;break;case"arm":case"arm64":$=2;break;default:$=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class y{constructor(l,t,a){this.exePath=l,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:h=!1}={}){return h?$===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:h=!1,findPreview:l=!1}={}){const t=w({useAlternateBitness:h});if(!t)return null;const a=A.$kc(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(a))return null;let o=-1,r=null;for(const b of await S.Promises.readdir(a)){let P=-1;if(l){const O=b.indexOf("-");if(O<0)continue;const R=b.substring(0,O);if(!D.test(R)||b.substring(O+1)!=="preview")continue;P=parseInt(R,10)}else{if(!D.test(b))continue;P=parseInt(b,10)}if(P<=o)continue;const I=A.$kc(a,b,"pwsh.exe");await S.SymlinkSupport.existsFile(I)&&(r=I,o=P)}if(!r)return null;const s=t.includes("x86")?" (x86)":"",n=l?" Preview":"";return new y(r,`PowerShell${n}${s}`,!0)}async function d({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const l=A.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=h?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const o of await S.Promises.readdir(l))if(t.test(o)){const r=A.$kc(l,o,"pwsh.exe");return new y(r,a)}return null}function c(){const h=A.$kc(i.homedir(),".dotnet","tools","pwsh.exe");return new y(h,".NET Core PowerShell Global Tool")}function g(){const h=A.$kc(process.env.windir,$===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(h,"Windows PowerShell",!0)}async function*u(){let h=await m();h&&(yield h),h=await m({useAlternateBitness:!0}),h&&(yield h),h=await d(),h&&(yield h),h=c(),h&&(yield h),h=await m({findPreview:!0}),h&&(yield h),h=await d({findPreview:!0}),h&&(yield h),h=await m({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=g(),h&&(yield h)}async function*p(){for await(const h of u())await h.exists()&&(yield h)}async function f(){for await(const h of p())return h;return null}}),define(Ee[104],ke([1,0,7,4,30,66,11,23]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$am=v,e.$bm=$,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function v(y=S.env){return y.comspec||"cmd.exe"}function $(y){let w=[],m=!1;const d=function(c){if(m){w.push(c);return}(!y.send(c,u=>{if(u&&console.error(u),m=!1,w.length>0){const p=w.slice(0);w=[],p.forEach(f=>d(f))}})||A.$i)&&(m=!0)};return{send:d}}var E;(function(y){async function w(m,d,c){if(i.$jc(m))return m;if(d===void 0&&(d=S.cwd()),i.$nc(m)!=="."||(c===void 0&&C.$Vf(S.env.PATH)&&(c=S.env.PATH.split(i.$uc)),c===void 0||c.length===0))return i.$kc(d,m);async function u(p){if(await k.Promises.exists(p)){let f;try{f=await k.Promises.stat(p)}catch(h){h.message.startsWith("EACCES")&&(f=await k.Promises.lstat(p))}return f?!f.isDirectory():!1}return!1}for(const p of c){let f;if(i.$jc(p)?f=i.$kc(p,m):f=i.$kc(d,p,m),await u(f))return f;let h=f+".com";if(await u(h)||(h=f+".exe",await u(h)))return h}return i.$kc(d,m)}y.findExecutable=w})(E||(e.win32=E={}))}),define(Ee[105],ke([1,0,55,12]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=S;function S(C){return new Promise((k,v)=>{let $;const E=new Map;function y(m,d,c,g,u){const p=E.get(d);if(m===C||p){const f={name:w(c),cmd:c,pid:m,ppid:d,load:g,mem:u};E.set(m,f),m===C&&($=f),p&&(p.children||(p.children=[]),p.children.push(f),p.children.length>1&&(p.children=p.children.sort((h,l)=>h.pid-l.pid)))}}function w(m){const d=/--utility-sub-type=network/i,c=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(c.exec(m))return"electron-crash-reporter";if(g.exec(m))return"winpty-agent";if(u.exec(m))return"conpty-agent";let f=p.exec(m);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?d.exec(m)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const h=/[a-zA-Z-]+\.js/g;let l="";do f=h.exec(m),f&&(l+=f+" ");while(f);return l&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${l})`:m}if(process.platform==="win32"){const m=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,c)=>{le(["@vscode/windows-process-tree"],d,c)}).then(d=>{d.getProcessList(C,c=>{if(!c){v(new Error(`Root process ${C} not found`));return}d.getProcessCpuUsage(c,g=>{const u=new Map;g.forEach(p=>{const f=m(p.commandLine||"");u.set(p.pid,{name:w(f),cmd:f,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),$=u.get(C),$?(u.forEach(p=>{const f=u.get(p.ppid);f&&(f.children||(f.children=[]),f.children.push(p))}),u.forEach(p=>{p.children&&(p.children=p.children.sort((f,h)=>f.pid-h.pid))}),k($)):v(new Error(`Root process ${C} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let m=function(){let d=[$];const c=[];for(;d.length;){const u=d.shift();u&&(c.push(u.pid),u.children&&(d=d.concat(u.children)))}let g=JSON.stringify(A.$Cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+c.join(" "),(0,i.exec)(g,{},(u,p,f)=>{if(u||f)v(u||new Error(f.toString()));else{const h=p.toString().split(`
`);for(let l=0;l<c.length;l++){const t=E.get(c[l]);t.load=parseFloat(h[l])}if(!$){v(new Error(`Root process ${C} not found`));return}k($)}})};(0,i.exec)("which ps",{},(d,c,g)=>{if(d||g)if(process.platform!=="linux")v(d||new Error(g.toString()));else{const u=JSON.stringify(A.$Cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)(u,{},(p,f,h)=>{p||h?v(p||new Error(h.toString())):(D(f,y),m())})}else{const u=c.toString().trim();(0,i.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,h,l)=>{f||l&&!l.includes("screen size is bogus")?v(f||new Error(l.toString())):(D(h,y),process.platform==="linux"?m():$?k($):v(new Error(`Root process ${C} not found`)))})}})}})}function D(C,k){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,$=C.toString().split(`
`);for(const E of $){const y=v.exec(E.trim());y&&y.length===6&&k(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Ee[106],ke([1,0,29,4,103,104]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=C;async function C(y,w){return y===1?A.$i?E():D.$am(w):v(y,w)}let k=null;function v(y,w){if(A.$k&&y===2||A.$j&&y===3)return"/bin/bash";if(!k){let m;if(A.$i)m="/bin/bash";else{if(m=w.SHELL,!m)try{m=(0,i.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}k=m}return k}let $=null;async function E(){return $||($=(await(0,S.$0l)()).exePath),$}});var Le=this&&this.__decorate||function(le,e,i,A){var S=arguments.length,D=S<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,i):A,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(le,e,i,A);else for(var k=le.length-1;k>=0;k--)(C=le[k])&&(D=(S<3?C(D):S>3?C(e,i,D):C(e,i))||D);return S>3&&D&&Object.defineProperty(e,i,D),D};define(Ee[45],ke([1,0,18,15,14,20,74,10,6,2,53,17,11]),function(le,e,i,A,S,D,C,k,v,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.ProxyChannel=e.$3h=e.$Zh=e.$Yh=e.$Xh=e.RequestInitiator=e.$Wh=e.$Th=e.$Sh=void 0,e.$Uh=n,e.$Vh=b,e.$1h=B,e.$2h=Y;var m;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(m||(m={}));function d(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(c||(c={}));function g(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(u||(u={}));function p(Z){let G=0;for(let se=0;;se+=7){const ce=Z.read(1);if(G|=(ce.buffer[0]&127)<<se,!(ce.buffer[0]&128))return G}}const f=o(0);function h(Z,G){if(G===0){Z.write(f);return}let se=0;for(let ne=G;ne!==0;ne=ne>>>7)se++;const ce=S.$ue.alloc(se);for(let ne=0;G!==0;ne++)ce.buffer[ne]=G&127,G=G>>>7,G>0&&(ce.buffer[ne]|=128);Z.write(ce)}class l{constructor(G){this.b=G,this.a=0}read(G){const se=this.b.slice(this.a,this.a+G);return this.a+=se.byteLength,se}}e.$Sh=l;class t{constructor(){this.a=[]}get buffer(){return S.$ue.concat(this.a)}write(G){this.a.push(G)}}e.$Th=t;var a;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(a||(a={}));function o(Z){const G=S.$ue.alloc(1);return G.writeUInt8(Z,0),G}const r={Undefined:o(a.Undefined),String:o(a.String),Buffer:o(a.Buffer),VSBuffer:o(a.VSBuffer),Array:o(a.Array),Object:o(a.Object),Uint:o(a.Int)},s=typeof Buffer<"u";function n(Z,G){if(typeof G>"u")Z.write(r.Undefined);else if(typeof G=="string"){const se=S.$ue.fromString(G);Z.write(r.String),h(Z,se.byteLength),Z.write(se)}else if(s&&Buffer.isBuffer(G)){const se=S.$ue.wrap(G);Z.write(r.Buffer),h(Z,se.byteLength),Z.write(se)}else if(G instanceof S.$ue)Z.write(r.VSBuffer),h(Z,G.byteLength),Z.write(G);else if(Array.isArray(G)){Z.write(r.Array),h(Z,G.length);for(const se of G)n(Z,se)}else if(typeof G=="number"&&(G|0)===G)Z.write(r.Uint),h(Z,G);else{const se=S.$ue.fromString(JSON.stringify(G));Z.write(r.Object),h(Z,se.byteLength),Z.write(se)}}function b(Z){switch(Z.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return Z.read(p(Z)).toString();case a.Buffer:return Z.read(p(Z)).buffer;case a.VSBuffer:return Z.read(p(Z));case a.Array:{const se=p(Z),ce=[];for(let ne=0;ne<se;ne++)ce.push(b(Z));return ce}case a.Object:return JSON.parse(Z.read(p(Z)).toString());case a.Int:return p(Z)}}class P{constructor(G,se,ce=null,ne=1e3){this.h=G,this.j=se,this.k=ce,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($e=>this.q($e)),this.m({type:200})}registerChannel(G,se){this.b.set(G,se),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const se=this.o([G.type]);this.k?.logOutgoing(se,0,1,g(G.type));return}case 201:case 202:case 204:case 203:{const se=this.o([G.type,G.id],G.data);this.k?.logOutgoing(se,G.id,1,g(G.type),G.data);return}}}o(G,se=void 0){const ce=new t;return n(ce,G),n(ce,se),this.p(ce.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const se=new l(G),ce=b(se),ne=b(se),$e=ce[0];switch($e){case 100:return this.k?.logIncoming(G.byteLength,ce[1],1,`${d($e)}: ${ce[2]}.${ce[3]}`,ne),this.s({type:$e,id:ce[1],channelName:ce[2],name:ce[3],arg:ne});case 102:return this.k?.logIncoming(G.byteLength,ce[1],1,`${d($e)}: ${ce[2]}.${ce[3]}`,ne),this.t({type:$e,id:ce[1],channelName:ce[2],name:ce[3],arg:ne});case 101:return this.k?.logIncoming(G.byteLength,ce[1],1,`${d($e)}`),this.u({type:$e,id:ce[1]});case 103:return this.k?.logIncoming(G.byteLength,ce[1],1,`${d($e)}`),this.u({type:$e,id:ce[1]})}}s(G){const se=this.b.get(G.channelName);if(!se){this.v(G);return}const ce=new D.$ee;let ne;try{ne=se.call(this.j,G.name,G.arg,ce.token)}catch(q){ne=Promise.reject(q)}const $e=G.id;ne.then(q=>{this.m({id:$e,data:q,type:201})},q=>{q instanceof Error?this.m({id:$e,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:$e,data:q,type:203})}).finally(()=>{K.dispose(),this.d.delete(G.id)});const K=(0,$.$Sc)(()=>ce.cancel());this.d.set(G.id,K)}t(G){const se=this.b.get(G.channelName);if(!se){this.v(G);return}const ce=G.id,$e=se.listen(this.j,G.name,G.arg)(K=>this.m({id:ce,data:K,type:204}));this.d.set(G.id,$e)}u(G){const se=this.d.get(G.id);se&&(se.dispose(),this.d.delete(G.id))}v(G){let se=this.g.get(G.channelName);se||(se=[],this.g.set(G.channelName,se));const ce=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);se.push({request:G,timeoutTimer:ce})}w(G){const se=this.g.get(G);if(se){for(const ce of se)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=P;var I;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class O{constructor(G,se=null){this.l=G,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=se}getChannel(G){const se=this;return{call(ce,ne,$e){return se.a?Promise.reject(new k.$5):se.m(G,ce,ne,$e)},listen(ce,ne){return se.a?v.Event.None:se.o(G,ce,ne)}}}m(G,se,ce,ne=D.CancellationToken.None){const $e=this.g++,q={id:$e,type:100,channelName:G,name:se,arg:ce};if(ne.isCancellationRequested)return Promise.reject(new k.$5);let N;return new Promise((X,ae)=>{if(ne.isCancellationRequested)return ae(new k.$5);const Q=()=>{const H=_=>{switch(_.type){case 201:this.f.delete($e),X(_.data);break;case 202:{this.f.delete($e);const ee=new Error(_.data.message);ee.stack=Array.isArray(_.data.stack)?_.data.stack.join(`
`):_.data.stack,ee.name=_.data.name,ae(ee);break}case 203:this.f.delete($e),ae(_.data);break}};this.f.set($e,H),this.p(q)};let J=null;this.b===u.Idle?Q():(J=(0,A.$8g)(H=>this.u()),J.then(()=>{J=null,Q()}));const U=()=>{J?(J.cancel(),J=null):this.p({id:$e,type:101}),ae(new k.$5)},L=ne.onCancellationRequested(U);N=(0,$.$Rc)((0,$.$Sc)(U),L),this.d.add(N)}).finally(()=>{N.dispose(),this.d.delete(N)})}o(G,se,ce){const ne=this.g++,K={id:ne,type:102,channelName:G,name:se,arg:ce};let q=null;const N=new v.$7d({onWillAddFirstListener:()=>{q=(0,A.$8g)(X=>this.u()),q.then(()=>{q=null,this.d.add(N),this.p(K)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(N),this.p({id:ne,type:103}))}}),z=X=>N.fire(X.data);return this.f.set(ne,z),N.event}p(G){switch(G.type){case 100:case 102:{const se=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(se,G.id,0,`${d(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const se=this.q([G.type,G.id]);this.j?.logOutgoing(se,G.id,0,d(G.type));return}}}q(G,se=void 0){const ce=new t;return n(ce,G),n(ce,se),this.r(ce.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const se=new l(G),ce=b(se),ne=b(se),$e=ce[0];switch($e){case 200:return this.j?.logIncoming(G.byteLength,0,0,g($e)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,ce[1],0,g($e),ne),this.t({type:ce[0],id:ce[1],data:ne})}}t(G){if(G.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}e.$Xh=O,Le([C.$Mh],O.prototype,"onDidInitializePromise",null);class R{get connections(){const G=[];return this.f.forEach(se=>G.push(se)),G}constructor(G,se,ce){this.a=new Map,this.f=new Set,this.g=new v.$7d,this.onDidAddConnection=this.g.event,this.h=new v.$7d,this.onDidRemoveConnection=this.h.event,this.j=new $.$Tc,this.j.add(G(({protocol:ne,onDidClientDisconnect:$e})=>{const K=v.Event.once(ne.onMessage);this.j.add(K(q=>{const N=new l(q),z=b(N),X=new P(ne,z,se,ce),ae=new O(ne,se);this.a.forEach((J,U)=>X.registerChannel(U,J));const Q={channelServer:X,channelClient:ae,ctx:z};this.f.add(Q),this.g.fire(Q),this.j.add($e(()=>{X.dispose(),ae.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(G,se){const ce=this;return{call(ne,$e,K){let q;if((0,w.$0f)(se)){const z=(0,i.$4b)(ce.connections.filter(se));q=z?Promise.resolve(z):v.Event.toPromise(v.Event.filter(ce.onDidAddConnection,se))}else q=se.routeCall(ce,ne,$e);const N=q.then(z=>z.channelClient.getChannel(G));return B(N).call(ne,$e,K)},listen(ne,$e){if((0,w.$0f)(se))return ce.k(G,se,ne,$e);const K=se.routeEvent(ce,ne,$e).then(q=>q.channelClient.getChannel(G));return B(K).listen(ne,$e)}}}k(G,se,ce,ne){const $e=this;let K;const q=new v.$7d({onWillAddFirstListener:()=>{K=new $.$Tc;const N=new v.$ae,z=new Map,X=Q=>{const U=Q.channelClient.getChannel(G).listen(ce,ne),L=N.add(U);z.set(Q,L)},ae=Q=>{const J=z.get(Q);J&&(J.dispose(),z.delete(Q))};$e.connections.filter(se).forEach(X),v.Event.filter($e.onDidAddConnection,se)(X,void 0,K),$e.onDidRemoveConnection(ae,void 0,K),N.event(q.fire,q,K),K.add(N)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return q.event}registerChannel(G,se){this.a.set(G,se);for(const ce of this.f)ce.channelServer.registerChannel(G,se)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Yh=R;class j{constructor(G,se,ce=null){const ne=new t;n(ne,se),G.send(ne.buffer),this.a=new O(G,ce),this.d=new P(G,se,ce)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,se){this.d.registerChannel(G,se)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Zh=j;function B(Z){return{call(G,se,ce){return Z.then(ne=>ne.call(G,se,ce))},listen(G,se){const ce=new v.$de;return Z.then(ne=>ce.input=ne.listen(G,se)),ce.event}}}function Y(Z){let G=!1;return{call(se,ce,ne){return G?Z.call(se,ce,ne):(0,A.$jh)(0).then(()=>G=!0).then(()=>Z.call(se,ce,ne))},listen(se,ce){if(G)return Z.listen(se,ce);const ne=new v.$de;return(0,A.$jh)(0).then(()=>G=!0).then(()=>ne.input=Z.listen(se,ce)),ne.event}}}class fe{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const se of G.connections)if(await Promise.resolve(this.a(se.ctx)))return Promise.resolve(se);return await v.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$3h=fe;var ue;(function(Z){function G($e,K,q){const N=$e,z=q&&q.disableMarshalling,X=new Map;for(const ae in N)ce(ae)&&X.set(ae,v.Event.buffer(N[ae],!0,void 0,K));return new class{listen(ae,Q,J){const U=X.get(Q);if(U)return U;const L=N[Q];if(typeof L=="function"){if(ne(Q))return L.call(N,J);if(ce(Q))return X.set(Q,v.Event.buffer(N[Q],!0,void 0,K)),X.get(Q)}throw new k.$bb(`Event not found: ${Q}`)}call(ae,Q,J){const U=N[Q];if(typeof U=="function"){if(!z&&Array.isArray(J))for(let H=0;H<J.length;H++)J[H]=(0,E.$Rh)(J[H]);let L=U.apply(N,J);return L instanceof Promise||(L=Promise.resolve(L)),L}throw new k.$bb(`Method not found: ${Q}`)}}}Z.fromService=G;function se($e,K){const q=K&&K.disableMarshalling;return new Proxy({},{get(N,z){if(typeof z=="string")return K?.properties?.has(z)?K.properties.get(z):ne(z)?function(X){return $e.listen(z,X)}:ce(z)?$e.listen(z):async function(...X){let ae;K&&!(0,w.$5f)(K.context)?ae=[K.context,...X]:ae=X;const Q=await $e.call(z,ae);return q?Q:(0,E.$Rh)(Q)};throw new k.$bb(`Property not found: ${String(z)}`)}})}Z.toService=se;function ce($e){return $e[0]==="o"&&$e[1]==="n"&&y.$kf($e.charCodeAt(2))}function ne($e){return/^onDynamic/.test($e)&&y.$kf($e.charCodeAt(9))}})(ue||(e.ProxyChannel=ue={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const G=Z.toString();if(G!=="[object Object]")return G}return Z}function V(Z){return Array.isArray(Z)?Z.map(te):te(Z)}function T(Z,G,se,ce,ne,$e,K){K=V(K);const q=re[ne],N=q[ce%q.length];let z=[`%c[${Z}]%c[${String(G).padStart(7," ")}]%c[len: ${String(se).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${$e}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test($e)?(z=z.concat(K),z.push(")")):z.push(K),console.log.apply(console,z)}class x{constructor(G,se){this.d=G,this.f=se,this.a=0,this.b=0}logOutgoing(G,se,ce,ne,$e){this.b+=G,T(this.d,this.b,G,se,ce,ne,$e)}logIncoming(G,se,ce,ne,$e){this.a+=G,T(this.f,this.a,G,se,ce,ne,$e)}}e.$4h=x}),define(Ee[107],ke([1,0,14,6,2,45]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.ProtocolConstants=e.$5h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var k;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let n=0;function b(I,O){if(!s.has(I)){const R=String(++n);s.set(I,R)}return s.get(I)}function P(I,O,R,j){if(!r.enableDiagnostics)return;const B=b(I,O);if(j instanceof i.$ue||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const Y=i.$ue.alloc(j.byteLength);Y.set(j),r.records.push({timestamp:Date.now(),id:B,label:O,type:R,buff:Y})}else r.records.push({timestamp:Date.now(),id:B,label:O,type:R,data:j})}r.traceSocketEvent=P})(k||(e.SocketDiagnostics=k={}));var v;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let $=null;function E(){return $||($=i.$ue.alloc(0)),$}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,n){if(s===0)return E();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const O=this.a[0];return n&&(this.a.shift(),this.b-=s),O}if(this.a[0].byteLength>s){const O=this.a[0].slice(0,s);return n&&(this.a[0]=this.a[0].slice(s),this.b-=s),O}const b=i.$ue.alloc(s);let P=0,I=0;for(;s>0;){const O=this.a[I];if(O.byteLength>s){const R=O.slice(0,s);b.set(R,P),P+=s,n&&(this.a[I]=O.slice(s),this.b-=s),s-=s}else b.set(O,P),P+=O.byteLength,n?(this.a.shift(),this.b-=O.byteLength):I++,s-=O.byteLength}return b}}e.$5h=y;var w;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(w||(w={}));function m(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",r[r.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class c{constructor(s,n,b,P){this.type=s,this.id=n,this.ack=b,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends S.$Uc{constructor(s){super(),this.f=this.B(new A.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new y,this.B(this.a.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const n=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=n.readUInt32BE(9),this.g.messageType=n.readUInt8(0),this.g.id=n.readUInt32BE(1),this.g.ack=n.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,P=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",n),this.f.fire(new c(b,P,I,n)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=i.$ue.alloc(13);n.writeUInt8(s.type,0),n.writeUInt32BE(s.id,1),n.writeUInt32BE(s.ack,5),n.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(n,s.data)}g(s,n){const b=this.f===0;return this.d.push(s,n),this.f+=s.byteLength+n.byteLength,b}h(){const s=i.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,n){this.g(s,n)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class p extends S.$Uc{constructor(s){super(),this.f=new A.$7d,this.onMessage=this.f.event,this.g=new A.$7d,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new u(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(n=>{n.type===1&&this.f.fire(n.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new c(1,0,0,s))}}e.$6h=p;class f extends D.$Zh{static fromSocket(s,n){return new f(new p(s),n)}get onDidDispose(){return this.b.onDidDispose}constructor(s,n,b=null){super(s,n,b),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$7h=f;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$8h=h;class l{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,n=this.a;for(;n;)n=n.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let n=0,b=this.a;for(;b;)s[n++]=b.data,b=b.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const n=new l(s);if(!this.a){this.a=n,this.b=n;return}this.b.next=n,this.b=n}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const s=Date.now();for(let n=0;n<a.a;n++)this.c[n]=s-1e3*n;setInterval(()=>{for(let n=a.a;n>=1;n--)this.c[n]=this.c[n-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),n=(1+a.a)*1e3;let b=0;for(let P=0;P<a.a;P++)s-this.c[P]<=n&&b++;return 1-b/a.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new h,this.onControlMessage=this.u.event,this.v=new h,this.onMessage=this.v.event,this.w=new h,this.onDidDispose=this.w.event,this.x=new h,this.onSocketClose=this.x.event,this.y=new h,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??a.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Tc,this.o=s.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(n=>this.z(n))),this.r.add(this.o.onClose(n=>this.x.fire(n))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new c(5,0,0,E());this.p.write(s),this.p.flush()}sendPause(){const s=new c(7,0,0,E());this.p.write(s)}sendResume(){const s=new c(8,0,0,E());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,n){this.a=!0,this.r.dispose(),this.r=new S.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(n)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new c(3,0,this.h,E());this.p.write(s);const n=this.b.toArray();for(let b=0,P=n.length;b<P;b++)this.p.write(n[b]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const n=this.b.peek();if(n&&n.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const n=Date.now();n-this.m>1e4&&(this.m=n,this.p.write(new c(6,0,0,E())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const n=this.b.toArray();for(let b=0,P=n.length;b<P;b++)this.p.write(n[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const n=++this.c;this.h=this.g;const b=new c(1,n,this.h,s);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(s){const n=new c(2,0,0,s);this.p.write(n)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),n=Date.now()-s.writtenTime,b=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(n>=2e4&&b>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:n,timeSinceLastReceivedSomeData:b});return}const I=Math.max(2e4-n,2e4-b,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new c(3,0,this.h,E());this.p.write(s)}D(){this.h=this.g;const s=new c(9,0,this.h,E());this.p.write(s)}}e.$9h=o}),define(Ee[108],ke([1,0,55,15,14,20,172,10,6,2,21,104,66,45]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class d extends m.$Wh{constructor(u){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",p=>S.$ue.wrap(Buffer.from(p,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Jq=d;class c{constructor(u,p){this.i=u,this.j=p,this.c=new Set,this.g=new Map,this.h=new v.$7d,this.onDidProcessExit=this.h.event;const f=p&&p.timeout?p.timeout:6e4;this.b=new A.$fh(f),this.d=null,this.f=null}getChannel(u){const p=this;return{call(f,h,l){return p.k(u,f,h,l)},listen(f,h){return p.l(u,f,h)}}}k(u,p,f,h=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const l=this.n(u),t=(0,A.$8g)(r=>l.call(p,f,r)),a=h.onCancellationRequested(()=>t.cancel()),o=(0,$.$Sc)(()=>t.cancel());return this.c.add(o),t.finally(()=>{a.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,p,f){if(!this.b)return v.Event.None;this.b.cancel();let h;const l=new v.$7d({onWillAddFirstListener:()=>{h=this.n(u).listen(p,f)(l.fire,l),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,E.$On)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,w.$_l)(p.env),this.d=(0,i.fork)(this.i,u,p);const f=new v.$7d,l=v.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,C.$Fq)(n)){(0,C.log)(n,`IPC Library: ${this.j.serverName}`);return}f.fire(S.$ue.wrap(Buffer.from(n,"base64")))}),t=this.j.useQueue?(0,y.$bm)(this.d):this.d,a=n=>this.d&&this.d.connected&&t.send(n.buffer.toString("base64")),o=f.event,r={send:a,onMessage:o};this.f=new m.$Xh(r);const s=()=>this.o();process.once("exit",s),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,b)=>{process.removeListener("exit",s),l.dispose(),this.c.forEach(P=>(0,$.$Pc)(P)),this.c.clear(),n!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:b})})}return this.f}n(u){let p=this.g.get(u);return p||(p=this.m.getChannel(u),this.g.set(u,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Kq=c}),define(Ee[177],ke([1,0,15,6,2,53,11]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.StorageState=e.StorageHint=void 0,e.$Hp=v;var k;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function v(w){const m=w;return m?.changed instanceof Map||m?.deleted instanceof Set}var $;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})($||(e.StorageState=$={}));class E extends S.$Uc{static{this.a=100}constructor(m,d=Object.create(null)){super(),this.r=m,this.s=d,this.b=this.B(new A.$0d),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new i.$gh(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((d,c)=>this.w(c,d)),m.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(m,d){if(this.c===$.Closed)return;let c=!1;(0,C.$5f)(d)?c=this.f.delete(m):this.f.get(m)!==d&&(this.f.set(m,d),c=!0),c&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,d){const c=this.f.get(m);return(0,C.$5f)(c)?d:c}getBoolean(m,d){const c=this.get(m);return(0,C.$5f)(c)?d:c==="true"}getNumber(m,d){const c=this.get(m);return(0,C.$5f)(c)?d:parseInt(c,10)}getObject(m,d){const c=this.get(m);return(0,C.$5f)(c)?d:(0,D.$Qh)(c)}async set(m,d,c=!1){if(this.c===$.Closed)return;if((0,C.$5f)(d))return this.delete(m,c);const g=(0,C.$Xf)(d)||Array.isArray(d)?(0,D.$Ph)(d):String(d);if(this.f.get(m)!==g)return this.f.set(m,g),this.j.set(m,g),this.h.delete(m),this.b.fire({key:m,external:c}),this.D()}async delete(m,d=!1){if(!(this.c===$.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:d}),this.D()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=$.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(this.z)return this.D(m)}async D(m){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$Ip=E;class y{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((d,c)=>this.a.set(c,d)),m.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$Jp=y}),define(Ee[178],ke([8,9]),function(le,e){return le.create("vs/base/node/zip",e)}),define(Ee[80],ke([1,0,27,15,7,11,23,178]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.zip=g,e.$7p=u,e.$8p=f,e.$4p="end of central directory record signature not found";const v=new RegExp(e.$4p);class $ extends Error{constructor(l,t){let a=t.message;switch(l){case"CorruptZip":a=`Corrupt ZIP: ${a}`;break}super(a),this.type=l,this.cause=t}}e.$5p=$;function E(h){const l=h.externalFileAttributes>>16||33188;return[448,56,7].map(t=>l&t).reduce((t,a)=>t+a,l&61440)}function y(h){if(h instanceof $)return h;let l;return v.test(h.message)&&(l="CorruptZip"),new $(l,h)}function w(h,l,t,a,o,r){const s=S.$nc(l),n=S.$kc(a,s);if(!n.startsWith(a))return Promise.reject(new Error(k.localize(0,null,l)));const b=S.$kc(a,l);let P;return r.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(C.Promises.mkdir(n,{recursive:!0})).then(()=>new Promise((I,O)=>{if(!r.isCancellationRequested)try{P=(0,i.createWriteStream)(b,{mode:t}),P.once("close",()=>I()),P.once("error",O),h.once("error",O),h.pipe(P)}catch(R){O(R)}}))}function m(h,l,t,a){let o=(0,A.$8g)(()=>Promise.resolve()),r=0;const s=a.onCancellationRequested(()=>{o.cancel(),h.close()});return new Promise((n,b)=>{const P=new A.$dh,I=O=>{O.isCancellationRequested||(r++,h.readEntry())};h.once("error",b),h.once("close",()=>o.then(()=>{a.isCancellationRequested||h.entryCount===r?n():b(new $("Incomplete",new Error(k.localize(1,null,r,h.entryCount))))},b)),h.readEntry(),h.on("entry",O=>{if(a.isCancellationRequested)return;if(!t.sourcePathRegex.test(O.fileName)){I(a);return}const R=O.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(R)){const Y=S.$kc(l,R);o=(0,A.$8g)(fe=>C.Promises.mkdir(Y,{recursive:!0}).then(()=>I(fe)).then(void 0,b));return}const j=c(h,O),B=E(O);o=(0,A.$8g)(Y=>P.queue(()=>j.then(fe=>w(fe,R,B,l,t,Y).then(()=>I(Y)))).then(null,b))})}).finally(()=>s.dispose())}async function d(h,l=!1){const{open:t}=await new Promise((a,o)=>{le(["yauzl"],a,o)});return new Promise((a,o)=>{t(h,l?{lazyEntries:!0}:void 0,(r,s)=>{r?o(y(r)):a((0,D.$7f)(s))})})}function c(h,l){return new Promise((t,a)=>{h.openReadStream(l,(o,r)=>{o?a(y(o)):t((0,D.$7f)(r))})})}async function g(h,l){const{ZipFile:t}=await new Promise((a,o)=>{le(["yazl"],a,o)});return new Promise((a,o)=>{const r=new t;l.forEach(n=>{n.contents?r.addBuffer(typeof n.contents=="string"?Buffer.from(n.contents,"utf8"):n.contents,n.path):n.localPath&&r.addFile(n.localPath,n.path)}),r.end();const s=(0,i.createWriteStream)(h);r.outputStream.pipe(s),r.outputStream.once("error",o),s.once("error",o),s.once("finish",()=>a(h))})}function u(h,l,t={},a){const o=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let r=d(h,!0);return t.overwrite&&(r=r.then(s=>C.Promises.rm(l).then(()=>s))),r.then(s=>m(s,l,{sourcePathRegex:o},a))}function p(h,l){return d(h).then(t=>new Promise((a,o)=>{t.on("entry",r=>{r.fileName===l&&c(t,r).then(s=>a(s),s=>o(s))}),t.once("close",()=>o(new Error(k.localize(2,null,l))))}))}function f(h,l){return p(h,l).then(t=>new Promise((a,o)=>{const r=[];t.once("error",o),t.on("data",s=>r.push(s)),t.on("end",()=>a(Buffer.concat(r)))}))}}),define(Ee[179],ke([8,9]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(Ee[180],ke([1,0,52,3,162,44,163,179]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$9t=e.$8t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$7t=e.$6t=e.SymbolKinds=e.SymbolTag=e.$4t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$2t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$1t=e.$Zt=e.$Yt=void 0,e.$3t=a,e.$5t=r;class v{constructor(x,Z,G){this.offset=x,this.type=Z,this.language=G,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Yt=v;class ${constructor(x,Z){this.tokens=x,this.endState=Z,this._tokenizationResultBrand=void 0}}e.$Zt=$;class E{constructor(x,Z){this.tokens=x,this.endState=Z,this._encodedTokenizationResultBrand=void 0}}e.$1t=E;var y;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(y||(e.CompletionItemKind=y={}));var w;(function(T){const x=new Map;x.set(0,i.$Hj.symbolMethod),x.set(1,i.$Hj.symbolFunction),x.set(2,i.$Hj.symbolConstructor),x.set(3,i.$Hj.symbolField),x.set(4,i.$Hj.symbolVariable),x.set(5,i.$Hj.symbolClass),x.set(6,i.$Hj.symbolStruct),x.set(7,i.$Hj.symbolInterface),x.set(8,i.$Hj.symbolModule),x.set(9,i.$Hj.symbolProperty),x.set(10,i.$Hj.symbolEvent),x.set(11,i.$Hj.symbolOperator),x.set(12,i.$Hj.symbolUnit),x.set(13,i.$Hj.symbolValue),x.set(15,i.$Hj.symbolEnum),x.set(14,i.$Hj.symbolConstant),x.set(15,i.$Hj.symbolEnum),x.set(16,i.$Hj.symbolEnumMember),x.set(17,i.$Hj.symbolKeyword),x.set(27,i.$Hj.symbolSnippet),x.set(18,i.$Hj.symbolText),x.set(19,i.$Hj.symbolColor),x.set(20,i.$Hj.symbolFile),x.set(21,i.$Hj.symbolReference),x.set(22,i.$Hj.symbolCustomColor),x.set(23,i.$Hj.symbolFolder),x.set(24,i.$Hj.symbolTypeParameter),x.set(25,i.$Hj.account),x.set(26,i.$Hj.issues);function Z(ce){let ne=x.get(ce);return ne||(console.info("No codicon found for CompletionItemKind "+ce),ne=i.$Hj.symbolProperty),ne}T.toIcon=Z;const G=new Map;G.set("method",0),G.set("function",1),G.set("constructor",2),G.set("field",3),G.set("variable",4),G.set("class",5),G.set("struct",6),G.set("interface",7),G.set("module",8),G.set("property",9),G.set("event",10),G.set("operator",11),G.set("unit",12),G.set("value",13),G.set("constant",14),G.set("enum",15),G.set("enum-member",16),G.set("enumMember",16),G.set("keyword",17),G.set("snippet",27),G.set("text",18),G.set("color",19),G.set("file",20),G.set("reference",21),G.set("customcolor",22),G.set("folder",23),G.set("type-parameter",24),G.set("typeParameter",24),G.set("account",25),G.set("issue",26);function se(ce,ne){let $e=G.get(ce);return typeof $e>"u"&&!ne&&($e=9),$e}T.fromString=se})(w||(e.CompletionItemKinds=w={}));var m;(function(T){T[T.Deprecated=1]="Deprecated"})(m||(e.CompletionItemTag=m={}));var d;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(d||(e.CompletionItemInsertTextRule=d={}));var c;(function(T){T[T.Word=0]="Word",T[T.Line=1]="Line",T[T.Suggest=2]="Suggest"})(c||(e.PartialAcceptTriggerKind=c={}));var g;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(e.CompletionTriggerKind=g={}));var u;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class p{constructor(x,Z,G,se){this.range=x,this.text=Z,this.completionKind=G,this.isSnippetText=se}equals(x){return D.$ct.lift(this.range).equalsRange(x.range)&&this.text===x.text&&this.completionKind===x.completionKind&&this.isSnippetText===x.isSnippetText}}e.$2t=p;var f;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(f||(e.CodeActionTriggerType=f={}));var h;(function(T){T[T.Automatic=0]="Automatic",T[T.PasteAs=1]="PasteAs"})(h||(e.DocumentPasteTriggerKind=h={}));var l;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var t;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function a(T){return T&&A.URI.isUri(T.uri)&&D.$ct.isIRange(T.range)&&(D.$ct.isIRange(T.originSelectionRange)||D.$ct.isIRange(T.targetSelectionRange))}var o;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(o||(e.SymbolKind=o={})),e.$4t={17:(0,k.localize)(0,null),16:(0,k.localize)(1,null),4:(0,k.localize)(2,null),13:(0,k.localize)(3,null),8:(0,k.localize)(4,null),9:(0,k.localize)(5,null),21:(0,k.localize)(6,null),23:(0,k.localize)(7,null),7:(0,k.localize)(8,null),0:(0,k.localize)(9,null),11:(0,k.localize)(10,null),10:(0,k.localize)(11,null),19:(0,k.localize)(12,null),5:(0,k.localize)(13,null),1:(0,k.localize)(14,null),2:(0,k.localize)(15,null),20:(0,k.localize)(16,null),15:(0,k.localize)(17,null),18:(0,k.localize)(18,null),24:(0,k.localize)(19,null),3:(0,k.localize)(20,null),6:(0,k.localize)(21,null),14:(0,k.localize)(22,null),22:(0,k.localize)(23,null),25:(0,k.localize)(24,null),12:(0,k.localize)(25,null)};function r(T,x){return(0,k.localize)(26,null,T,e.$4t[x])}var s;(function(T){T[T.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var n;(function(T){const x=new Map;x.set(0,i.$Hj.symbolFile),x.set(1,i.$Hj.symbolModule),x.set(2,i.$Hj.symbolNamespace),x.set(3,i.$Hj.symbolPackage),x.set(4,i.$Hj.symbolClass),x.set(5,i.$Hj.symbolMethod),x.set(6,i.$Hj.symbolProperty),x.set(7,i.$Hj.symbolField),x.set(8,i.$Hj.symbolConstructor),x.set(9,i.$Hj.symbolEnum),x.set(10,i.$Hj.symbolInterface),x.set(11,i.$Hj.symbolFunction),x.set(12,i.$Hj.symbolVariable),x.set(13,i.$Hj.symbolConstant),x.set(14,i.$Hj.symbolString),x.set(15,i.$Hj.symbolNumber),x.set(16,i.$Hj.symbolBoolean),x.set(17,i.$Hj.symbolArray),x.set(18,i.$Hj.symbolObject),x.set(19,i.$Hj.symbolKey),x.set(20,i.$Hj.symbolNull),x.set(21,i.$Hj.symbolEnumMember),x.set(22,i.$Hj.symbolStruct),x.set(23,i.$Hj.symbolEvent),x.set(24,i.$Hj.symbolOperator),x.set(25,i.$Hj.symbolTypeParameter);function Z(G){let se=x.get(G);return se||(console.info("No codicon found for SymbolKind "+G),se=i.$Hj.symbolProperty),se}T.toIcon=Z})(n||(e.SymbolKinds=n={}));class b{static asEditOperation(x){return S.$dt.replace(D.$ct.lift(x.range),x.text)}}e.$6t=b;class P{static{this.Comment=new P("comment")}static{this.Imports=new P("imports")}static{this.Region=new P("region")}static fromValue(x){switch(x){case"comment":return P.Comment;case"imports":return P.Imports;case"region":return P.Region}return new P(x)}constructor(x){this.value=x}}e.$7t=P;var I;(function(T){T[T.AIGenerated=1]="AIGenerated"})(I||(e.NewSymbolNameTag=I={}));var O;(function(T){function x(Z){return!Z||typeof Z!="object"?!1:typeof Z.id=="string"&&typeof Z.title=="string"}T.is=x})(O||(e.Command=O={}));var R;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(R||(e.CommentThreadCollapsibleState=R={}));var j;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(j||(e.CommentThreadState=j={}));var B;(function(T){T[T.Current=0]="Current",T[T.Outdated=1]="Outdated"})(B||(e.CommentThreadApplicability=B={}));var Y;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(Y||(e.CommentMode=Y={}));var fe;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(fe||(e.CommentState=fe={}));var ue;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(ue||(e.InlayHintKind=ue={}));class re{constructor(x){this.b=x,this.a=null}dispose(){this.a&&this.a.then(x=>{x&&x.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$8t=re,e.$9t=new C.$Nt;var te;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(te||(e.ExternalUriOpenerPriority=te={}));var V;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(V||(e.InlineEditTriggerKind=V={}))}),define(Ee[181],ke([8,9]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[182],ke([8,9]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[183],ke([8,9]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[184],ke([8,9]),function(le,e){return le.create("vs/platform/environment/node/argv",e)}),define(Ee[185],ke([8,9]),function(le,e){return le.create("vs/platform/environment/node/argvHelper",e)}),define(Ee[186],ke([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Ee[187],ke([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[188],ke([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Ee[189],ke([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Ee[190],ke([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Ee[191],ke([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Ee[192],ke([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Ee[193],ke([8,9]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[194],ke([8,9]),function(le,e){return le.create("vs/platform/files/common/fileService",e)}),define(Ee[195],ke([8,9]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(Ee[196],ke([8,9]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(Ee[197],ke([8,9]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[198],ke([8,9]),function(le,e){return le.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Ee[199],ke([8,9]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(Ee[200],ke([8,9]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(Ee[201],ke([8,9]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(Ee[202],ke([8,9]),function(le,e){return le.create("vs/platform/shell/node/shellEnv",e)}),define(Ee[203],ke([8,9]),function(le,e){return le.create("vs/platform/telemetry/common/telemetryService",e)}),define(Ee[204],ke([8,9]),function(le,e){return le.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Ee[205],ke([8,9]),function(le,e){return le.create("vs/platform/terminal/common/terminalProfiles",e)}),define(Ee[206],ke([8,9]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[207],ke([8,9]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(Ee[208],ke([8,9]),function(le,e){return le.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(Ee[209],ke([8,9]),function(le,e){return le.create("vs/server/node/serverEnvironmentService",e)}),define(Ee[210],ke([8,9]),function(le,e){return le.create("vs/server/node/serverServices",e)}),define(Ee[211],ke([8,9]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[212],ke([8,9]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(Ee[213],ke([8,9]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[214],ke([8,9]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(Ee[215],ke([1,0,10,183]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var S;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(S||(e.TokenType=S={}));function D(...$){switch($.length){case 1:return(0,A.localize)(0,null,$[0]);case 2:return(0,A.localize)(1,null,$[0],$[1]);case 3:return(0,A.localize)(2,null,$[0],$[1],$[2]);default:return}}const C=(0,A.localize)(3,null),k=(0,A.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,i.$8)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(D("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(D("&&"));break;case 124:this.h(124)?this.k(16):this.l(D("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const y=this.d,w=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:w};this.g.push({offset:y,lexeme:w,additionalInfo:E}),this.f.push(m)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const y=this.c.substring(this.d,this.e),w=v.b.get(y);w?this.k(w):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,y=!1,w=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(k);return}const d=this.c.charCodeAt(E);if(y)y=!1;else if(d===47&&!w){E++;break}else d===91?w=!0:d===92?y=!0:d===93&&(w=!1);E++}for(;E<this.c.length&&v.a.has(this.c.charCodeAt(E));)E++;this.e=E;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=v}),define(Ee[216],ke([1,0,6,2]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=void 0;class S{constructor(){this.a=new i.$7d,this.b=new i.$7d,this.c=new i.$7d,this.d=new i.$7d}static{this.ChannelName="extensionhostdebugservice"}call(k,v,$){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:$[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:$[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:$[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:$[0],port:$[1],subId:$[2]}))}throw new Error("Method not implemented.")}listen(k,v,$){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$uo=S;class D extends A.$Uc{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,v,$){this.b.call("attach",[k,v,$])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,v){this.b.call("terminate",[k,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,v){return this.b.call("openExtensionDevelopmentHostWindow",[k,v])}}e.$vo=D}),define(Ee[217],ke([1,0,3]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=void 0;class A{constructor(C){this.a=C}listen(C,k,v){throw new Error("Invalid listen")}call(C,k,v){switch(k){case"download":return this.a.download(i.URI.revive(v[0]),i.URI.revive(v[1]))}throw new Error("Invalid call")}}e.$xo=A;class S{constructor(C,k){this.a=C,this.b=k}async download(C,k){const v=this.b();v&&(C=v.transformOutgoingURI(C),k=v.transformOutgoingURI(k)),await this.a.call("download",[C,k])}}e.$yo=S}),define(Ee[218],ke([1,0,167,74,12,7,30,19,3]),function(le,e,i,A,S,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Qm=void 0,e.$Sm=E,e.$Tm=y,e.$Qm=/^([^.]+\..+)[:=](.+)$/;class ${get appRoot(){return(0,D.$nc)(S.$Cg.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,D.$kc)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,k.$Vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$Vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,i.$Pm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$kc)(this.userDataPath,"logs",m)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$Vg)(v.URI.file((0,D.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$Vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$Vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$Vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=C.env.VSCODE_PORTABLE;return m?v.URI.file((0,D.$kc)(m,"argv.json")):(0,k.$Vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,D.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,D.$lc)(m):(0,D.$ic)((0,D.$kc)(S.$Cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?v.URI.file((0,D.$lc)(m)):v.URI.file((0,D.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,D.$lc)(m);const d=C.env.VSCODE_EXTENSIONS;if(d)return d;const c=C.env.VSCODE_PORTABLE;return c?(0,D.$kc)(c,"extensions"):(0,k.$Vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(d=>/^[^:/?#]+?:\/\//.test(d)?v.URI.parse(d):v.URI.file((0,D.$ic)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?v.URI.parse(m):v.URI.file((0,D.$ic)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$Qm.test(m))}get extensionLogLevel(){const m=[];for(const d of this.args.log||[]){const c=e.$Qm.exec(d);c&&c[1]&&c[2]&&m.push([c[1],c[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,k.$Vg)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=C.env.VSCODE_PORTABLE;return m?v.URI.file((0,D.$kc)(m,"policy.json")):(0,k.$Vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,d,c){this.a=m,this.b=d,this.c=c,this.editSessionId=this.args.editSessionId}}e.$Rm=$,Le([A.$Mh],$.prototype,"appRoot",null),Le([A.$Mh],$.prototype,"userHome",null),Le([A.$Mh],$.prototype,"userDataPath",null),Le([A.$Mh],$.prototype,"appSettingsHome",null),Le([A.$Mh],$.prototype,"tmpDir",null),Le([A.$Mh],$.prototype,"cacheHome",null),Le([A.$Mh],$.prototype,"stateResource",null),Le([A.$Mh],$.prototype,"userRoamingDataHome",null),Le([A.$Mh],$.prototype,"userDataSyncHome",null),Le([A.$Mh],$.prototype,"sync",null),Le([A.$Mh],$.prototype,"machineSettingsResource",null),Le([A.$Mh],$.prototype,"workspaceStorageHome",null),Le([A.$Mh],$.prototype,"localHistoryHome",null),Le([A.$Mh],$.prototype,"keyboardLayoutResource",null),Le([A.$Mh],$.prototype,"argvResource",null),Le([A.$Mh],$.prototype,"isExtensionDevelopment",null),Le([A.$Mh],$.prototype,"untitledWorkspacesHome",null),Le([A.$Mh],$.prototype,"builtinExtensionsPath",null),Le([A.$Mh],$.prototype,"extensionsPath",null),Le([A.$Mh],$.prototype,"extensionDevelopmentLocationURI",null),Le([A.$Mh],$.prototype,"extensionDevelopmentKind",null),Le([A.$Mh],$.prototype,"extensionTestsLocationURI",null),Le([A.$Mh],$.prototype,"debugExtensionHost",null),Le([A.$Mh],$.prototype,"logLevel",null),Le([A.$Mh],$.prototype,"extensionLogLevel",null),Le([A.$Mh],$.prototype,"serviceMachineIdResource",null),Le([A.$Mh],$.prototype,"disableTelemetry",null),Le([A.$Mh],$.prototype,"disableWorkspaceTrust",null),Le([A.$Mh],$.prototype,"useInMemorySecretStorage",null),Le([A.$Mh],$.prototype,"policyFile",null);function E(w,m){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,m,w.debugId,w.extensionEnvironment)}function y(w,m,d,c,g,u){const f=Number(m||w)||(c?null:d),h=f?!!m:!1;let l;if(u)try{l=JSON.parse(u)}catch{}return{port:f,break:h,debugId:g,env:l}}}),define(Ee[67],ke([1,0,307,4,184]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0,e.$fm=k,e.$gm=$,e.$hm=m,e.$im=d;const D={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$dm=["tunnel","serve-web"],e.$em={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(c,g,u=C){const p=c.find(n=>n.length>0&&n[0]!=="-"),f={},h=["_"],l=[],t={};let a;for(const n in g){const b=g[n];b.type==="subcommand"?n===p&&(a=b):(b.alias&&(f[n]=b.alias),b.type==="string"||b.type==="string[]"?(h.push(n),b.deprecates&&h.push(...b.deprecates)):b.type==="boolean"&&(l.push(n),b.deprecates&&l.push(...b.deprecates)),b.global&&(t[n]=b))}if(a&&p){const n=t;for(const O in a.options)n[O]=a.options[O];const b=c.filter(O=>O!==p),P=u.getSubcommandReporter?u.getSubcommandReporter(p):void 0,I=k(b,n,P);return{[p]:I,_:[]}}const o=i(c,{string:h,boolean:l,alias:f}),r={},s=o;r._=o._.map(n=>String(n)).filter(n=>n.length>0),delete s._;for(const n in g){const b=g[n];if(b.type==="subcommand")continue;b.alias&&delete s[b.alias];let P=s[n];if(b.deprecates)for(const I of b.deprecates)s.hasOwnProperty(I)&&(P||(P=s[I],P&&u.onDeprecatedOption(I,b.deprecationMessage||(0,S.localize)(38,null,n))),delete s[I]);if(typeof P<"u"){if(b.type==="string[]"){if(Array.isArray(P)||(P=[P]),!b.allowEmptyValue){const I=P.filter(O=>O.length>0);I.length!==P.length&&(u.onEmptyValue(n),P=I.length>0?I:void 0)}}else b.type==="string"&&(Array.isArray(P)?(P=P.pop(),u.onMultipleValues(n,P)):!P&&!b.allowEmptyValue&&(u.onEmptyValue(n),P=void 0));r[n]=P,b.deprecationMessage&&u.onDeprecatedOption(n,b.deprecationMessage)}delete s[n]}for(const n in s)u.onUnknownOption(n);return r}function v(c,g){let u="";return g.args&&(Array.isArray(g.args)?u=` <${g.args.join("> <")}>`:u=` <${g.args}>`),g.alias?`-${g.alias} --${c}${u}`:`--${c}${u}`}function $(c,g){const u=[];for(const p in c){const f=c[p],h=v(p,f);u.push([h,f.description])}return E(u,g)}function E(c,g){const p=c.reduce((l,t)=>Math.max(l,t[0].length),12)+2+1;if(g-p<25)return c.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=g-p-1,h=[];for(const l of c){const t=l[0],a=w(l[1],f),o=y(p-t.length-2);h.push("  "+t+o+a[0]);for(let r=1;r<a.length;r++)h.push(y(p)+a[r])}return h}function y(c){return" ".repeat(c)}function w(c,g){const u=[];for(;c.length;){const p=c.length<g?c.length:c.lastIndexOf(" ",g),f=c.slice(0,p).trim();c=c.slice(p),u.push(f)}return u}function m(c,g,u,p,f){const h=process.stdout.isTTY&&process.stdout.columns||80,l=f?.noInputFiles!==!0?`[${(0,S.localize)(39,null)}...]`:"",t=[`${c} ${u}`];t.push(""),t.push(`${(0,S.localize)(40,null)}: ${g} [${(0,S.localize)(41,null)}]${l}`),t.push(""),f?.noPipe!==!0&&(A.$i?t.push((0,S.localize)(42,null,g)):t.push((0,S.localize)(43,null,g)),t.push(""));const a={},o=[];for(const r in p){const s=p[r];if(s.type==="subcommand")s.description&&o.push({command:r,description:s.description});else if(s.description&&s.cat){let n=a[s.cat];n||(a[s.cat]=n={}),n[r]=s}}for(const r in a){const s=r,n=a[s];n&&(t.push(D[s]),t.push(...$(n,h)),t.push(""))}return o.length&&(t.push((0,S.localize)(44,null)),t.push(...E(o.map(r=>[r.command,r.description]),h)),t.push("")),t.join(`
`)}function d(c,g){return`${c||(0,S.localize)(45,null)}
${g||(0,S.localize)(46,null)}
${process.arch}`}}),define(Ee[219],ke([1,0,308,185,67]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=k,e.$km=v,e.$lm=$,e.$mm=E;function D(y,w){const m=(f,h)=>{console.warn((0,A.localize)(0,null,f,h))},d=f=>{console.warn((0,A.localize)(1,null,f))},c=(f,h)=>{console.warn((0,A.localize)(2,null,f,h))},g=f=>({onUnknownOption:h=>{S.$dm.includes(f)||console.warn((0,A.localize)(3,null,h,f))},onMultipleValues:m,onEmptyValue:d,onDeprecatedOption:c,getSubcommandReporter:S.$dm.includes(f)?g:void 0}),u={onUnknownOption:f=>{console.warn((0,A.localize)(4,null,f))},onMultipleValues:m,onEmptyValue:d,onDeprecatedOption:c,getSubcommandReporter:g},p=(0,S.$fm)(y,S.$em,w?u:void 0);return p.goto&&p._.forEach(f=>i(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(f),(0,A.localize)(5,null))),p}function C(y){const w=y.findIndex(m=>!/^-/.test(m));if(w>-1)return[...y.slice(0,w),...y.slice(w+1)]}function k(y){let[,...w]=y;process.env.VSCODE_DEV&&(w=C(w)||[]);const m=!E(process.env);return D(w,m)}function v(y){let[,,...w]=y;return process.env.VSCODE_DEV&&(w=C(w)||[]),D(w,!0)}function $(y,...w){const m=y.indexOf("--");return m===-1?y.push(...w):y.splice(m,0,...w),y}function E(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function le(e,i,A){function S(C,k){const v=D(C,k),$=[v];return e.isAbsolute(v)||$.unshift(A),e.resolve(...$)}function D(C,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let $=process.env.VSCODE_APPDATA;if($)return e.join($,k);const E=C["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if($=process.env.APPDATA,!$){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");$=e.join(y,"AppData","Roaming")}break;case"darwin":$=e.join(i.homedir(),"Library","Application Support");break;case"linux":$=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join($,k)}return{getUserDataPath:S}}if(typeof define=="function")define(Ee[220],ke([76,29,30]),function(e,i,A){return le(e,i,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=le(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Ee[109],ke([1,0,29,218,220]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0,e.$Vm=C,e.$Wm=k;class D extends A.$Rm{constructor($,E){super($,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,S.getUserDataPath)($,E.nameShort)},E)}}e.$Um=D;function C(v,$){return(0,A.$Tm)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,$,v.extensionEnvironment)}function k(v,$){return(0,A.$Tm)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,$,v.extensionEnvironment)}}),define(Ee[221],ke([1,0,11,189]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=S;function S(C,k,v,$){try{D(C,k,v,$)}catch(E){C.error(E?.message??E)}return k}function D(C,k,v,$){const E=(y,w,m)=>{const d=y[w];if((0,i.$Vf)(d)){const c=d,g=c.length;if(g>1&&c[0]==="%"&&c[g-1]==="%"){const u=c.substr(1,g-2);let p=v[u];p===void 0&&$&&(p=$[u]);const f=typeof p=="string"?p:p?.message,h=$?.[u],l=typeof h=="string"?h:h?.message;if(!f){l||C.warn(`[${k.name}]: ${(0,A.localize)(0,null,u)}`);return}if(m&&(w==="title"||w==="category")&&l&&l!==f){const t={value:f,original:l};y[w]=t}else y[w]=f}}else if((0,i.$Xf)(d))for(const c in d)d.hasOwnProperty(c)&&(c==="commands"?E(d,c,!0):E(d,c,m));else if(Array.isArray(d))for(let c=0;c<d.length;c++)E(d,c,m)};for(const y in k)k.hasOwnProperty(y)&&E(k,y)}}),define(Ee[222],ke([1,0,80,192]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=S;function S(D){return(0,i.$8p)(D,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}}),define(Ee[81],ke([1,0,19,63,193,56]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=v,e.$tp=$,e.$up=E,e.$vp=y,e.$wp=w,e.$xp=m,e.$yp=d;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function v(u){return u=u.trim(),u==="*"||C.test(u)}function $(u){if(!v(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=u.match(C);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}function E(u){if(!u)return null;const p=u.majorBase,f=u.majorMustEqual,h=u.minorBase;let l=u.minorMustEqual;const t=u.patchBase;let a=u.patchMustEqual;u.hasCaret&&(p===0||(l=!1),a=!1);let o=0;if(u.preRelease){const r=k.exec(u.preRelease);if(r){const[,s,n,b]=r;o=Date.UTC(Number(s),Number(n)-1,Number(b))}}return{majorBase:p,majorMustEqual:f,minorBase:h,minorMustEqual:l,patchBase:t,patchMustEqual:a,isMinimum:u.hasGreaterEquals,notBefore:o}}function y(u,p,f){let h;typeof u=="string"?h=E($(u)):h=u;let l;p instanceof Date?l=p.getTime():typeof p=="string"&&(l=new Date(p).getTime());let t;if(typeof f=="string"?t=E($(f)):t=f,!h||!t)return!1;const a=h.majorBase,o=h.minorBase,r=h.patchBase;let s=t.majorBase,n=t.minorBase,b=t.patchBase;const P=t.notBefore;let I=t.majorMustEqual,O=t.minorMustEqual,R=t.patchMustEqual;return t.isMinimum?a>s?!0:a<s?!1:o>n?!0:o<n||l&&l<P?!1:r>=b:(a===1&&s===0&&(!I||!O||!R)&&(s=1,n=0,b=0,I=!0,O=!1,R=!1),a<s?!1:a>s?!I:o<n?!1:o>n?!O:r<b?!1:r>b?!R:!(l&&l<P))}function w(u,p,f,h,l){const t=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return t.push([A.default.Error,S.localize(0,null)]),t;if(typeof h.name!="string")return t.push([A.default.Error,S.localize(1,null,"name")]),t;if(typeof h.version!="string")return t.push([A.default.Error,S.localize(2,null,"version")]),t;if(!h.engines)return t.push([A.default.Error,S.localize(3,null,"engines")]),t;if(typeof h.engines.vscode!="string")return t.push([A.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof h.extensionDependencies<"u"&&!g(h.extensionDependencies))return t.push([A.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof h.activationEvents<"u"){if(!g(h.activationEvents))return t.push([A.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof h.main>"u"&&typeof h.browser>"u")return t.push([A.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&t.push([A.default.Warning,S.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return t.push([A.default.Error,S.localize(9,null,"main")]),t;{const r=(0,i.$Vg)(f,h.main);(0,i.$Pg)(r,f)||t.push([A.default.Warning,S.localize(10,null,r.path,f.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return t.push([A.default.Error,S.localize(11,null,"browser")]),t;{const r=(0,i.$Vg)(f,h.browser);(0,i.$Pg)(r,f)||t.push([A.default.Warning,S.localize(12,null,r.path,f.path)])}}if(!D.valid(h.version))return t.push([A.default.Error,S.localize(13,null)]),t;const a=[];if(!m(u,p,h,l,a))for(const r of a)t.push([A.default.Error,r]);return t}function m(u,p,f,h,l){return h||typeof f.main>"u"&&typeof f.browser>"u"?!0:c(u,p,f.engines.vscode,l)}function d(u,p,f){return u==="*"||c(p,f,u)}function c(u,p,f,h=[]){const l=E($(f));if(!l)return h.push(S.localize(14,null,f)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return h.push(S.localize(15,null,f)),!1}else if(!l.majorMustEqual)return h.push(S.localize(16,null,f)),!1;return y(u,p,l)?!0:(h.push(S.localize(17,null,u,f)),!1)}function g(u){if(!Array.isArray(u))return!1;for(let p=0,f=u.length;p<f;p++)if(typeof u[p]!="string")return!1;return!0}}),define(Ee[223],ke([1,0,14,22]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=S;async function S(D,C,k){let v=k&&k.get("storage.serviceMachineId",-1)||null;if(v)return v;try{const E=(await C.readFile(D.serviceMachineIdResource)).value.toString();v=(0,A.$Dg)(E)?E:null}catch{v=null}if(!v){v=(0,A.$Eg)();try{await C.writeFile(D.serviceMachineIdResource,i.$ue.fromString(v))}catch{}}return k?.store("storage.serviceMachineId",v,-1,1),v}}),define(Ee[68],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class i{constructor(S,D=[],C=!1){this.ctor=S,this.staticArguments=D,this.supportsDelayedInstantiation=C}}e.$fi=i}),define(Ee[110],ke([1,0,68]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$gs=D,e.$hs=C;const A=[];var S;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function D(k,v,$){v instanceof i.$fi||(v=new i.$fi(v,[],!!$)),A.push([k,v])}function C(){return A}}),define(Ee[224],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class i{constructor(D,C){this.key=D,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$Wq=i;class A{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const C of this.a.values())C.outgoing.size===0&&D.push(C);return D}insertEdge(D,C){const k=this.lookupOrInsertNode(D),v=this.lookupOrInsertNode(C);k.outgoing.set(v.key,v),v.incoming.set(k.key,k)}removeNode(D){const C=this.b(D);this.a.delete(C);for(const k of this.a.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(D){const C=this.b(D);let k=this.a.get(C);return k||(k=new i(C,D),this.a.set(C,k)),k}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[C,k]of this.a)D.push(`${C}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,C]of this.a){const k=new Set([D]),v=this.c(C,k);if(v)return v}}c(D,C){for(const[k,v]of D.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const $=this.c(v,C);if($)return $;C.delete(k)}}}e.$Xq=A}),define(Ee[5],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=S,e.$ji=D;var i;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(v){return v[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(i||(e._util=i={})),e.$hi=S("instantiationService");function A(C,k,v){k[i.DI_TARGET]===k?k[i.DI_DEPENDENCIES].push({id:C,index:v}):(k[i.DI_DEPENDENCIES]=[{id:C,index:v}],k[i.DI_TARGET]=k)}function S(C){if(i.serviceIds.has(C))return i.serviceIds.get(C);const k=function(v,$,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(k,v,E)};return k.toString=()=>C,i.serviceIds.set(C,k),k}function D(C){return C}}),define(Ee[25],ke([1,0,11,3,5]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=D,e.$Qi=C,e.$Ri=v,e.$Si=$,e.$Ti=E,e.$Ui=y,e.$Vi=w,e.$Wi=d,e.$Xi=c,e.$Yi=g,e.$Oi=(0,S.$ii)("configurationService");function D(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof A.URI)}function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof A.URI)}var k;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function v(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function $(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}function E(u,p){const f=Object.create(null);for(const h in u)y(f,h,u[h],p);return f}function y(u,p,f,h){const l=p.split("."),t=l.pop();let a=u;for(let o=0;o<l.length;o++){const r=l[o];let s=a[r];switch(typeof s){case"undefined":s=a[r]=Object.create(null);break;case"object":break;default:h(`Ignoring ${p} as ${l.slice(0,o+1).join(".")} is ${JSON.stringify(s)}`);return}a=s}if(typeof a=="object"&&a!==null)try{a[t]=f}catch{h(`Ignoring ${p} as ${l.join(".")} is ${JSON.stringify(a)}`)}else h(`Ignoring ${p} as ${l.join(".")} is ${JSON.stringify(a)}`)}function w(u,p){const f=p.split(".");m(u,f)}function m(u,p){const f=p.shift();if(p.length===0){delete u[f];return}if(Object.keys(u).indexOf(f)!==-1){const h=u[f];typeof h=="object"&&!Array.isArray(h)&&(m(h,p),Object.keys(h).length===0&&delete u[f])}}function d(u,p,f){function h(a,o){let r=a;for(const s of o){if(typeof r!="object"||r===null)return;r=r[s]}return r}const l=p.split("."),t=h(u,l);return typeof t>"u"?f:t}function c(u,p,f){Object.keys(p).forEach(h=>{h!=="__proto__"&&(h in u?i.$Xf(u[h])&&i.$Xf(p[h])?c(u[h],p[h],f):f&&(u[h]=p[h]):u[h]=p[h])})}function g(u){return u.replace(/[\[\]]/g,"")}}),define(Ee[57],ke([1,0,4,17,215,5,182,10]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=$,e.$hj=a,e.$ij=o,e.$Bj=ne;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",i.$j),v.set("isLinux",i.$k),v.set("isWindows",i.$i),v.set("isWeb",i.$o),v.set("isMacNative",i.$j&&!i.$o),v.set("isEdge",i.$H),v.set("isFirefox",i.$F),v.set("isChrome",i.$E),v.set("isSafari",i.$G);function $(q,N){if(v.get(q)!==void 0)throw(0,k.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(q,N)}const E=Object.prototype.hasOwnProperty;var y;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const w={regexParsingWithErrorRecovery:!0},m=(0,C.localize)(0,null),d=(0,C.localize)(1,null),c=(0,C.localize)(2,null),g=(0,C.localize)(3,null),u=(0,C.localize)(4,null),p=(0,C.localize)(5,null),f=(0,C.localize)(6,null),h=(0,C.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(N=w){this.k=N,this.d=new S.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(N){if(N===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(N).scan(),this.g=0,this.h=[];try{const z=this.l();if(!this.E()){const X=this.D(),ae=X.type===17?p:void 0;throw this.h.push({message:u,offset:X.offset,lexeme:S.$dj.getLexeme(X),additionalInfo:ae}),l.c}return z}catch(z){if(z!==l.c)throw z;return}}l(){return this.m()}m(){const N=[this.o()];for(;this.y(16);){const z=this.o();N.push(z)}return N.length===1?N[0]:t.or(...N)}o(){const N=[this.s()];for(;this.y(15);){const z=this.s();N.push(z)}return N.length===1?N[0]:t.and(...N)}s(){if(this.y(2)){const N=this.D();switch(N.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),n.INSTANCE;case 0:{this.z();const z=this.l();return this.A(1,g),z?.negate()}case 17:return this.z(),j.create(N.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",N)}}return this.t()}t(){const N=this.D();switch(N.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const z=this.l();return this.A(1,g),z}case 17:{const z=N.lexeme;if(this.z(),this.y(9)){const ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ae.type!==10)throw this.B("REGEX",ae);const Q=ae.lexeme,J=Q.lastIndexOf("/"),U=J===Q.length-1?void 0:this.w(Q.substring(J+1));let L;try{L=new RegExp(Q.substring(1,J),U)}catch{throw this.B("REGEX",ae)}return te.create(z,L)}switch(ae.type){case 10:case 19:{const Q=[ae.lexeme];this.z();let J=this.D(),U=0;for(let de=0;de<ae.lexeme.length;de++)ae.lexeme.charCodeAt(de)===40?U++:ae.lexeme.charCodeAt(de)===41&&U--;for(;!this.E()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:U++;break;case 1:U--;break;case 10:case 18:for(let de=0;de<J.lexeme.length;de++)J.lexeme.charCodeAt(de)===40?U++:ae.lexeme.charCodeAt(de)===41&&U--}if(U<0)break;Q.push(S.$dj.getLexeme(J)),this.z(),J=this.D()}const L=Q.join(""),H=L.lastIndexOf("/"),_=H===L.length-1?void 0:this.w(L.substring(H+1));let ee;try{ee=new RegExp(L.substring(1,H),_)}catch{throw this.B("REGEX",ae)}return t.regex(z,ee)}case 18:{const Q=ae.lexeme;this.z();let J=null;if(!(0,A.$Ue)(Q)){const U=Q.indexOf("/"),L=Q.lastIndexOf("/");if(U!==L&&U>=0){const H=Q.slice(U+1,L),_=Q[L+1]==="i"?"i":"";try{J=new RegExp(H,_)}catch{throw this.B("REGEX",ae)}}}if(J===null)throw this.B("REGEX",ae);return te.create(z,J)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const ae=this.u();return t.notIn(z,ae)}switch(this.D().type){case 3:{this.z();const ae=this.u();if(this.x().type===18)return t.equals(z,ae);switch(ae){case"true":return t.has(z);case"false":return t.not(z);default:return t.equals(z,ae)}}case 4:{this.z();const ae=this.u();if(this.x().type===18)return t.notEquals(z,ae);switch(ae){case"true":return t.not(z);case"false":return t.has(z);default:return t.notEquals(z,ae)}}case 5:return this.z(),ue.create(z,this.u());case 6:return this.z(),re.create(z,this.u());case 7:return this.z(),Y.create(z,this.u());case 8:return this.z(),fe.create(z,this.u());case 13:return this.z(),t.in(z,this.u());default:return t.has(z)}}case 20:throw this.h.push({message:f,offset:N.offset,lexeme:"",additionalInfo:h}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const N=this.D();switch(N.type){case 17:case 18:return this.z(),N.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(N){return N.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(N){return this.C(N)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(N,z){if(this.C(N))return this.z();throw this.B(z,this.D())}B(N,z,X){const ae=(0,C.localize)(8,null,N,S.$dj.getLexeme(z)),Q=z.offset,J=S.$dj.getLexeme(z);return this.h.push({message:ae,offset:Q,lexeme:J,additionalInfo:X}),l.c}C(N){return this.D().type===N}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=l;class t{static false(){return s.INSTANCE}static true(){return n.INSTANCE}static has(N){return b.create(N)}static equals(N,z){return P.create(N,z)}static notEquals(N,z){return R.create(N,z)}static regex(N,z){return te.create(N,z)}static in(N,z){return I.create(N,z)}static notIn(N,z){return O.create(N,z)}static not(N){return j.create(N)}static and(...N){return x.create(N,null,!0)}static or(...N){return Z.create(N,null,!0)}static greater(N,z){return Y.create(N,z)}static greaterEquals(N,z){return fe.create(N,z)}static smaller(N,z){return ue.create(N,z)}static smallerEquals(N,z){return re.create(N,z)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this.c.parse(N)}}e.$gj=t;function a(q){const N=new l({regexParsingWithErrorRecovery:!1});return q.map(z=>(N.parse(z),N.lexingErrors.length>0?N.lexingErrors.map(X=>({errorMessage:X.additionalInfo?(0,C.localize)(9,null,X.additionalInfo):(0,C.localize)(10,null),offset:X.offset,length:X.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(X=>({errorMessage:X.additionalInfo?`${X.message}. ${X.additionalInfo}`:X.message,offset:X.offset,length:X.lexeme.length})):[]))}function o(q,N){const z=q?q.substituteConstants():void 0,X=N?N.substituteConstants():void 0;return!z&&!X?!0:!z||!X?!1:z.equals(X)}function r(q,N){return q.cmp(N)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return n.INSTANCE}}e.$jj=s;class n{static{this.INSTANCE=new n}constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return s.INSTANCE}}e.$kj=n;class b{static create(N,z=null){const X=v.get(N);return typeof X=="boolean"?X?n.INSTANCE:s.INSTANCE:new b(N,z)}constructor(N,z){this.key=N,this.c=z,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:se(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=v.get(this.key);return typeof N=="boolean"?N?n.INSTANCE:s.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$lj=b;class P{static create(N,z,X=null){if(typeof z=="boolean")return z?b.create(N,X):j.create(N,X);const ae=v.get(N);return typeof ae=="boolean"?z===(ae?"true":"false")?n.INSTANCE:s.INSTANCE:new P(N,z,X)}constructor(N,z,X){this.c=N,this.d=z,this.f=X,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=v.get(this.c);if(typeof N=="boolean"){const z=N?"true":"false";return this.d===z?n.INSTANCE:s.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$mj=P;class I{static create(N,z){return new I(N,z)}constructor(N,z){this.d=N,this.f=z,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const z=N.getValue(this.f),X=N.getValue(this.d);return Array.isArray(z)?z.includes(X):typeof X=="string"&&typeof z=="object"&&z!==null?E.call(z,X):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=O.create(this.d,this.f)),this.c}}e.$nj=I;class O{static create(N,z){return new O(N,z)}constructor(N,z){this.d=N,this.f=z,this.type=11,this.c=I.create(N,z)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=O;class R{static create(N,z,X=null){if(typeof z=="boolean")return z?j.create(N,X):b.create(N,X);const ae=v.get(N);return typeof ae=="boolean"?z===(ae?"true":"false")?s.INSTANCE:n.INSTANCE:new R(N,z,X)}constructor(N,z,X){this.c=N,this.d=z,this.f=X,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=v.get(this.c);if(typeof N=="boolean"){const z=N?"true":"false";return this.d===z?s.INSTANCE:n.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$pj=R;class j{static create(N,z=null){const X=v.get(N);return typeof X=="boolean"?X?s.INSTANCE:n.INSTANCE:new j(N,z)}constructor(N,z){this.c=N,this.d=z,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:se(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=v.get(this.c);return typeof N=="boolean"?N?s.INSTANCE:n.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$qj=j;function B(q,N){if(typeof q=="string"){const z=parseFloat(q);isNaN(z)||(q=z)}return typeof q=="string"||typeof q=="number"?N(q):s.INSTANCE}class Y{static create(N,z,X=null){return B(z,ae=>new Y(N,ae,X))}constructor(N,z,X){this.c=N,this.d=z,this.f=X,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$rj=Y;class fe{static create(N,z,X=null){return B(z,ae=>new fe(N,ae,X))}constructor(N,z,X){this.c=N,this.d=z,this.f=X,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$sj=fe;class ue{static create(N,z,X=null){return B(z,ae=>new ue(N,ae,X))}constructor(N,z,X){this.c=N,this.d=z,this.f=X,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=fe.create(this.c,this.d,this)),this.f}}e.$tj=ue;class re{static create(N,z,X=null){return B(z,ae=>new re(N,ae,X))}constructor(N,z,X){this.c=N,this.d=z,this.f=X,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$uj=re;class te{static create(N,z){return new te(N,z)}constructor(N,z){this.d=N,this.f=z,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const z=this.f?this.f.source:"",X=N.f?N.f.source:"";return z<X?-1:z>X?1:0}equals(N){if(N.type===this.type){const z=this.f?this.f.source:"",X=N.f?N.f.source:"";return this.d===N.d&&z===X}return!1}substituteConstants(){return this}evaluate(N){const z=N.getValue(this.d);return this.f?this.f.test(z):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$vj=te;class V{static create(N){return new V(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(N){return new V(this.c.map(N))}negate(){return this.c}}e.$wj=V;function T(q){let N=null;for(let z=0,X=q.length;z<X;z++){const ae=q[z].substituteConstants();if(q[z]!==ae&&N===null){N=[];for(let Q=0;Q<z;Q++)N[Q]=q[Q]}N!==null&&(N[z]=ae)}return N===null?q:N}class x{static create(N,z,X){return x.d(N,z,X)}constructor(N,z){this.expr=N,this.c=z,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let z=0,X=this.expr.length;z<X;z++){const ae=r(this.expr[z],N.expr[z]);if(ae!==0)return ae}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let z=0,X=this.expr.length;z<X;z++)if(!this.expr[z].equals(N.expr[z]))return!1;return!0}return!1}substituteConstants(){const N=T(this.expr);return N===this.expr?this:x.create(N,this.c,!1)}evaluate(N){for(let z=0,X=this.expr.length;z<X;z++)if(!this.expr[z].evaluate(N))return!1;return!0}static d(N,z,X){const ae=[];let Q=!1;for(const J of N)if(J){if(J.type===1){Q=!0;continue}if(J.type===0)return s.INSTANCE;if(J.type===6){ae.push(...J.expr);continue}ae.push(J)}if(ae.length===0&&Q)return n.INSTANCE;if(ae.length!==0){if(ae.length===1)return ae[0];ae.sort(r);for(let J=1;J<ae.length;J++)ae[J-1].equals(ae[J])&&(ae.splice(J,1),J--);if(ae.length===1)return ae[0];for(;ae.length>1;){const J=ae[ae.length-1];if(J.type!==9)break;ae.pop();const U=ae.pop(),L=ae.length===0,H=Z.create(J.expr.map(_=>x.create([_,U],null,X)),null,L);H&&(ae.push(H),ae.sort(r))}if(ae.length===1)return ae[0];if(X){for(let J=0;J<ae.length;J++)for(let U=J+1;U<ae.length;U++)if(ae[J].negate().equals(ae[U]))return s.INSTANCE;if(ae.length===1)return ae[0]}return new x(ae,z)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const z of this.expr)N.push(...z.keys());return N}map(N){return new x(this.expr.map(z=>z.map(N)),null)}negate(){if(!this.c){const N=[];for(const z of this.expr)N.push(z.negate());this.c=Z.create(N,this,!0)}return this.c}}e.$xj=x;class Z{static create(N,z,X){return Z.d(N,z,X)}constructor(N,z){this.expr=N,this.c=z,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let z=0,X=this.expr.length;z<X;z++){const ae=r(this.expr[z],N.expr[z]);if(ae!==0)return ae}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let z=0,X=this.expr.length;z<X;z++)if(!this.expr[z].equals(N.expr[z]))return!1;return!0}return!1}substituteConstants(){const N=T(this.expr);return N===this.expr?this:Z.create(N,this.c,!1)}evaluate(N){for(let z=0,X=this.expr.length;z<X;z++)if(this.expr[z].evaluate(N))return!0;return!1}static d(N,z,X){let ae=[],Q=!1;if(N){for(let J=0,U=N.length;J<U;J++){const L=N[J];if(L){if(L.type===0){Q=!0;continue}if(L.type===1)return n.INSTANCE;if(L.type===9){ae=ae.concat(L.expr);continue}ae.push(L)}}if(ae.length===0&&Q)return s.INSTANCE;ae.sort(r)}if(ae.length!==0){if(ae.length===1)return ae[0];for(let J=1;J<ae.length;J++)ae[J-1].equals(ae[J])&&(ae.splice(J,1),J--);if(ae.length===1)return ae[0];if(X){for(let J=0;J<ae.length;J++)for(let U=J+1;U<ae.length;U++)if(ae[J].negate().equals(ae[U]))return n.INSTANCE;if(ae.length===1)return ae[0]}return new Z(ae,z)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const z of this.expr)N.push(...z.keys());return N}map(N){return new Z(this.expr.map(z=>z.map(N)),null)}negate(){if(!this.c){const N=[];for(const z of this.expr)N.push(z.negate());for(;N.length>1;){const z=N.shift(),X=N.shift(),ae=[];for(const Q of K(z))for(const J of K(X))ae.push(x.create([Q,J],null,!1));N.unshift(Z.create(ae,null,!1))}this.c=Z.create(N,this,!0)}return this.c}}e.$yj=Z;class G extends b{static{this.d=[]}static all(){return G.d.values()}constructor(N,z,X){super(N,null),this.f=z,typeof X=="object"?G.d.push({...X,key:N}):X!==!0&&G.d.push({key:N,description:X,type:z!=null?typeof z:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return P.create(this.key,N)}notEqualsTo(N){return R.create(this.key,N)}}e.$zj=G,e.$Aj=(0,D.$ii)("contextKeyService");function se(q,N){return q<N?-1:q>N?1:0}function ce(q,N,z,X){return q<z?-1:q>z?1:N<X?-1:N>X?1:0}function ne(q,N){if(q.type===0||N.type===1)return!0;if(q.type===9)return N.type===9?$e(q.expr,N.expr):!1;if(N.type===9){for(const z of N.expr)if(ne(q,z))return!0;return!1}if(q.type===6){if(N.type===6)return $e(N.expr,q.expr);for(const z of q.expr)if(ne(z,N))return!0;return!1}return q.equals(N)}function $e(q,N){let z=0,X=0;for(;z<q.length&&X<N.length;){const ae=q[z].cmp(N[X]);if(ae<0)return!1;ae===0&&z++,X++}return z===q.length}function K(q){return q.type===9?q.expr:[q]}}),define(Ee[225],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$2m=e.ID=void 0,e.$3m=A,e.ID="diagnosticsService",e.$2m=(0,i.$ii)(e.ID);function A(D){return!!D.hostName&&!!D.errorMessage}class S{async getPerformanceInfo(C,k){return{}}async getSystemInfo(C,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,k){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$4m=S}),define(Ee[82],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=void 0,e.$wo=(0,i.$ii)("downloadService")}),define(Ee[26],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,i.$ii)("environmentService"),e.$qi=(0,i.$ji)(e.$pi)}),define(Ee[31],ke([1,0,187,5]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.ExtensionGalleryErrorCode=e.$So=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ro=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Lo=S,e.$Mo=D,e.$No=C,e.$Oo=k,e.$Po=v,e.$Qo=$,e.$Fo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Go=new RegExp(e.$Fo),e.$Ho="__web_extension",e.$Io="skipWalkthrough",e.$Jo="extensionsSync",e.$Ko="dependecyOrPackExtensionInstall";function S(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function D(f){switch(f){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function C(f,h){switch(f){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function k(f,h){return h==="web"&&!f.includes("web")}function v(f,h,l){return k(h,l)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===l}function $(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var y;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var w;(function(f){f.Install="install",f.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var m;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$Ro=(0,A.$ii)("extensionGalleryService");var d;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.DownloadSignature="DownloadSignature",f.UpdateMetadata="UpdateMetadata",f.Extract="Extract",f.Scanning="Scanning",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.NotAllowed="NotAllowed",f.Gallery="Gallery",f.Unknown="Unknown",f.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var c;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class g extends Error{constructor(h,l){super(h),this.code=l,this.name=l}}e.$So=g;var u;(function(f){f.Timeout="Timeout",f.Cancelled="Cancelled",f.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class p extends Error{constructor(h,l){super(h),this.code=l,this.name=l}}e.$To=p,e.$Uo=(0,A.$ii)("extensionManagementService"),e.$Vo="extensionsIdentifiers/disabled",e.$Wo="extensionsIdentifiers/enabled",e.$Xo=(0,A.$ii)("IGlobalExtensionEnablementService"),e.$Yo=(0,A.$ii)("IExtensionTipsService"),e.$Zo=(0,i.localize2)(0,"Extensions"),e.$1o=(0,i.localize2)(1,"Preferences")}),define(Ee[226],ke([1,0,6,2,21,3,54,31]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=e.$1p=void 0;function v(g,u){return g?D.URI.revive(u?u.transformIncoming(g):g):void 0}function $(g,u){return u?u.transformOutgoingURI(g):g}function E(g,u){u=u||C.$ln;const p=g.manifest;return{...(0,C.$on)({...g,manifest:void 0},u),manifest:p}}function y(g,u){return g?.profileLocation?(0,C.$on)(g,u??C.$ln):g}function w(g,u){return u?(0,S.$Qn)(g,p=>p instanceof D.URI?u.transformOutgoingURI(p):void 0):g}class m{constructor(u,p){this.a=u,this.b=p,this.onInstallExtension=i.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=i.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=i.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=i.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=i.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,p){const f=this.b(u);switch(p){case"onInstallExtension":return i.Event.map(this.onInstallExtension,h=>({...h,profileLocation:h.profileLocation?$(h.profileLocation,f):h.profileLocation}));case"onDidInstallExtensions":return i.Event.map(this.onDidInstallExtensions,h=>h.map(l=>({...l,local:l.local?w(l.local,f):l.local,profileLocation:l.profileLocation?$(l.profileLocation,f):l.profileLocation})));case"onUninstallExtension":return i.Event.map(this.onUninstallExtension,h=>({...h,profileLocation:h.profileLocation?$(h.profileLocation,f):h.profileLocation}));case"onDidUninstallExtension":return i.Event.map(this.onDidUninstallExtension,h=>({...h,profileLocation:h.profileLocation?$(h.profileLocation,f):h.profileLocation}));case"onDidUpdateExtensionMetadata":return i.Event.map(this.onDidUpdateExtensionMetadata,h=>w(h,f))}throw new Error("Invalid listen")}async call(u,p,f){const h=this.b(u);switch(p){case"zip":{const l=E(f[0],h),t=await this.a.zip(l);return $(t,h)}case"unzip":return this.a.unzip(v(f[0],h));case"install":return this.a.install(v(f[0],h),y(f[1],h));case"installFromLocation":return this.a.installFromLocation(v(f[0],h),v(f[1],h));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],v(f[1],h),v(f[2],h));case"getManifest":return this.a.getManifest(v(f[0],h));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],y(f[1],h));case"installGalleryExtensions":{const l=f[0];return this.a.installGalleryExtensions(l.map(({extension:t,options:a})=>({extension:t,options:y(a,h)??{}})))}case"uninstall":return this.a.uninstall(E(f[0],h),y(f[1],h));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(f[0],h));case"getInstalled":return(await this.a.getInstalled(f[0],v(f[1],h),f[2])).map(t=>w(t,h));case"toggleAppliationScope":{const l=await this.a.toggleAppliationScope(E(f[0],h),v(f[1],h));return w(l,h)}case"copyExtensions":return this.a.copyExtensions(v(f[0],h),v(f[1],h));case"updateMetadata":{const l=await this.a.updateMetadata(E(f[0],h),f[1],v(f[2],h));return w(l,h)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1],f[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$1p=m;class d extends A.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.m=u,this.c=this.B(new i.$7d),this.f=this.B(new i.$7d),this.g=this.B(new i.$7d),this.h=this.B(new i.$7d),this.j=this.B(new i.$7d),this.B(this.m.listen("onInstallExtension")(p=>this.n(this.c,{...p,source:this.r(p.source)?D.URI.revive(p.source):p.source,profileLocation:D.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(p=>this.n(this.f,p.map(f=>({...f,local:f.local?E(f.local,null):f.local,source:this.r(f.source)?D.URI.revive(f.source):f.source,profileLocation:D.URI.revive(f.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(p=>this.n(this.g,{...p,profileLocation:D.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(p=>this.n(this.h,{...p,profileLocation:D.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(p=>this.j.fire(E(p,null))))}n(u,p){u.fire(p)}r(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(u){const p=await this.getTargetPlatform();return u.allTargetPlatforms.some(f=>(0,k.$Po)(f,u.allTargetPlatforms,p))}zip(u){return Promise.resolve(this.m.call("zip",[u]).then(p=>D.URI.revive(p)))}unzip(u){return Promise.resolve(this.m.call("unzip",[u]))}install(u,p){return Promise.resolve(this.m.call("install",[u,p])).then(f=>E(f,null))}installFromLocation(u,p){return Promise.resolve(this.m.call("installFromLocation",[u,p])).then(f=>E(f,null))}async installExtensionsFromProfile(u,p,f){return(await this.m.call("installExtensionsFromProfile",[u,p,f])).map(l=>E(l,null))}getManifest(u){return Promise.resolve(this.m.call("getManifest",[u]))}installFromGallery(u,p){return Promise.resolve(this.m.call("installFromGallery",[u,p])).then(f=>E(f,null))}async installGalleryExtensions(u){return(await this.m.call("installGalleryExtensions",[u])).map(f=>({...f,local:f.local?E(f.local,null):f.local,source:this.r(f.source)?D.URI.revive(f.source):f.source,profileLocation:D.URI.revive(f.profileLocation)}))}uninstall(u,p){if(u.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[u,p]))}reinstallFromGallery(u){return Promise.resolve(this.m.call("reinstallFromGallery",[u])).then(p=>E(p,null))}getInstalled(u=null,p,f){return Promise.resolve(this.m.call("getInstalled",[u,p,f])).then(h=>h.map(l=>E(l,null)))}updateMetadata(u,p,f){return Promise.resolve(this.m.call("updateMetadata",[u,p,f])).then(h=>E(h,null))}toggleAppliationScope(u,p){return this.m.call("toggleAppliationScope",[u,p]).then(f=>E(f,null))}copyExtensions(u,p){return this.m.call("copyExtensions",[u,p])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(u,p,f){const h=await this.m.call("download",[u,p,f]);return D.URI.revive(h)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$2p=d;class c{constructor(u){this.a=u}listen(u,p){throw new Error("Invalid listen")}call(u,p,f){switch(p){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$3p=c}),define(Ee[16],ke([1,0,64,7,17,11,3,195,5,4,12,60]),function(le,e,i,A,S,D,C,k,v,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=w,e.$Qk=c,e.$Rk=u,e.$Sk=p,e.$Tk=f,e.$Uk=h,e.$Vk=l,e.$Wk=t,e.$Xk=a,e.$Yk=o,e.$Zk=r,e.$2k=b,e.$3k=P,e.$4k=I,e.$5k=O,e.$6k=R,e.$9k=ue,e.$il=Z,e.$jl=G,e.$ll=ce,e.$Ok=(0,v.$ii)("fileService");function w(ne){return ne.create===!0}var m;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var d;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function c(ne){const $e=ne;return!!$e&&typeof $e.onDidChange=="function"}var g;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function u(ne){return!!(ne.capabilities&2)}function p(ne){return!!(ne.capabilities&8)}function f(ne){return!!(ne.capabilities&131072)}function h(ne){return!!(ne.capabilities&4)}function l(ne){return!!(ne.capabilities&16)}function t(ne){return u(ne)?!!(ne.capabilities&16384):!1}function a(ne){return u(ne)?!!(ne.capabilities&32768):!1}function o(ne){return!!(ne.capabilities&65536)}function r(ne){return!!(ne.capabilities&2048)}var s;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class n extends Error{static create($e,K){const q=new n($e.toString(),K);return I(q,K),q}constructor($e,K){super($e),this.code=K}}e.$1k=n;function b(ne,$e){return n.create(ne,$e)}function P(ne){return ne||b((0,k.localize)(0,null),s.Unknown)}function I(ne,$e){return ne.name=$e?`${$e} (FileSystemError)`:"FileSystemError",ne}function O(ne){if(!ne)return s.Unknown;if(ne instanceof n)return ne.code;const $e=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!$e)return s.Unknown;switch($e[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}function R(ne){if(ne instanceof re)return ne.fileOperationResult;switch(O(ne)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}var j;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class B{constructor($e,K,q){this.resource=$e,this.operation=K,this.target=q}isOperation($e){return this.operation===$e}}e.$7k=B;var Y;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(Y||(e.FileChangeType=Y={}));class fe{static{this.a=null}constructor($e,K){this.c=K,this.b=void 0,this.d=new y.$V(()=>{const q=i.$oi.forUris(()=>this.c);return q.fill(this.rawAdded.map(N=>[N,!0])),q}),this.f=new y.$V(()=>{const q=i.$oi.forUris(()=>this.c);return q.fill(this.rawUpdated.map(N=>[N,!0])),q}),this.g=new y.$V(()=>{const q=i.$oi.forUris(()=>this.c);return q.fill(this.rawDeleted.map(N=>[N,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of $e){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==fe.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=fe.a):this.b!==void 0&&(this.b=fe.a))}}contains($e,...K){return this.h($e,{includeChildren:!1},...K)}affects($e,...K){return this.h($e,{includeChildren:!0},...K)}h($e,K,...q){if(!$e)return!1;const N=q.length>0;return!!((!N||q.includes(1))&&(this.d.value.get($e)||K.includeChildren&&this.d.value.findSuperstr($e))||(!N||q.includes(0))&&(this.f.value.get($e)||K.includeChildren&&this.f.value.findSuperstr($e))||(!N||q.includes(2))&&(this.g.value.findSubstr($e)||K.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$8k=fe;function ue(ne,$e,K){return!ne||!$e||ne===$e||$e.length>ne.length?!1:($e.charAt($e.length-1)!==A.sep&&($e+=A.sep),K?(0,S.$mf)(ne,$e):ne.indexOf($e)===0)}class re extends Error{constructor($e,K,q){super($e),this.fileOperationResult=K,this.options=q}}e.$0k=re;class te extends re{constructor($e,K,q,N){super($e,K,N),this.fileOperationResult=K,this.size=q}}e.$$k=te;class V extends re{constructor($e,K,q){super($e,2,q),this.stat=K}}e.$_k=V;var T;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(T||(e.FileOperationResult=T={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var x;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(x||(e.FileKind=x={})),e.$hl="";function Z(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function G(ne,$e){if(!$e.hasProvider(C.URI.from({scheme:ne.scheme})))return new Promise(K=>{const q=$e.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===ne.scheme&&N.added&&(q.dispose(),K())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize($e){return(0,D.$Zf)($e)||($e=0),$e<se.KB?(0,k.localize)(1,null,$e.toFixed(0)):$e<se.MB?(0,k.localize)(2,null,($e/se.KB).toFixed(2)):$e<se.GB?(0,k.localize)(3,null,($e/se.MB).toFixed(2)):$e<se.TB?(0,k.localize)(4,null,($e/se.GB).toFixed(2)):(0,k.localize)(5,null,($e/se.TB).toFixed(2))}}e.$kl=se;function ce(ne){const $e=typeof ne=="string"||ne?.scheme===E.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===E.Schemas.file?1024*se.MB:$e?10*se.MB:$.$o?50*se.MB:1024*se.MB}}),define(Ee[111],ke([1,0,14,10,196,16]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=C;async function C(E,y,w,m,d,c){let g;try{await k(E,y,w,m,d,c)}catch(u){g=u}finally{g&&d.errorTransformer&&(g=d.errorTransformer(g)),typeof g<"u"&&w.error(g),w.end()}}async function k(E,y,w,m,d,c){v(c);const g=await E.open(y,{create:!1});try{v(c);let u=0,p=0,f=d&&typeof d.length=="number"?d.length:void 0,h=i.$ue.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),l=d&&typeof d.position=="number"?d.position:0,t=0;do p=await E.read(g,l,h.buffer,t,h.byteLength-t),l+=p,t+=p,u+=p,typeof f=="number"&&(f-=p),t===h.byteLength&&(await w.write(m(h)),h=i.$ue.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),t=0);while(p>0&&(typeof f!="number"||f>0)&&v(c)&&$(u,d));if(t>0){let a=t;typeof f=="number"&&(a=Math.min(t,f)),w.write(m(h.slice(0,a)))}}catch(u){throw(0,D.$3k)(u)}finally{await E.close(g)}}function v(E){if(E.isCancellationRequested)throw(0,A.$6)();return!0}function $(E,y){if(typeof y?.limits?.size=="number"&&E>y.limits.size)throw(0,D.$2k)((0,S.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[46],ke([1,0,79,2,7,4,3,16]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=void 0,e.$vq=v,e.$wq=$,e.$Aq=m,e.$Bq=d,e.$Cq=c,e.$Dq=g;function v(p){return typeof p.correlationId=="number"}function $(p){return p.recursive===!0}class E extends A.$Uc{static{this.a=5}constructor(f,h,l,t){super(),this.h=f,this.j=h,this.m=l,this.n=t,this.c=this.B(new A.$Vc),this.f=void 0,this.g=0}s(){const f=new A.$Tc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(h=>this.h(h))),f.add(this.b.onDidLogMessage(h=>this.j(h))),f.add(this.b.onDidError(h=>this.t(h)))}t(f){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$xq=E;class y extends E{constructor(f,h,l){super(f,h,l,{type:"node.js",restartOnError:!1})}}e.$yq=y;class w extends E{constructor(f,h,l){super(f,h,l,{type:"universal",restartOnError:!0})}}e.$zq=w;function m(p){return p.map(f=>({type:f.type,resource:C.URI.revive(f.resource),cId:f.cId}))}function d(p){const f=new u;for(const h of p)f.processEvent(h);return f.coalesce()}function c(p,f){return typeof f=="string"&&!f.startsWith(i.$$j)&&!(0,S.$jc)(f)?{base:p,pattern:f}:f}function g(p,f){const h=[];for(const l of f)h.push((0,i.$ck)(c(p,l)));return h}class u{constructor(){this.a=new Set,this.b=new Map}c(f){return D.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const h=this.b.get(this.c(f));let l=!1;if(h){const t=h.type,a=f.type;h.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?l=!0:t===1&&a===2?(this.b.delete(this.c(f)),this.a.delete(h)):t===2&&a===1?h.type=0:t===1&&a===0||(h.type=a)}else l=!0;l&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],h=[];return Array.from(this.a).filter(l=>l.type!==2?(f.push(l),!1):!0).sort((l,t)=>l.resource.fsPath.length-t.resource.fsPath.length).filter(l=>h.some(t=>(0,k.$9k)(l.resource.fsPath,t,!D.$k))?!1:(h.push(l.resource.fsPath),!0)).concat(f)}}}),define(Ee[227],ke([1,0,14,40,10,6,2,51,22,16,46]),function(le,e,i,A,S,D,C,k,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=void 0,e.$TP="localFilesystem";class y extends C.$Uc{constructor(m,d){super(),this.a=m,this.b=d,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$7d),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$7d),this.onDidWatchError=this.g.event,this.h=(0,v.$Eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,d){const{buffer:c}=await this.a.call("readFile",[m,d]);return c}readFileStream(m,d,c){const g=(0,k.$ie)(p=>i.$ue.concat(p.map(f=>i.$ue.wrap(f))).buffer),u=new C.$Tc;return u.add(this.a.listen("readFileStream",[m,d])(p=>{if(p instanceof i.$ue)g.write(p.buffer);else{if(p==="end")g.end();else{let f;if(p instanceof Error)f=p;else{const h=p;f=(0,$.$2k)(h.message??(0,A.$6i)(h),h.code??$.FileSystemProviderErrorCode.Unknown)}g.error(f),g.end()}u.dispose()}})),u.add(c.onCancellationRequested(()=>{g.error((0,S.$6)()),g.end(),u.dispose()})),g}writeFile(m,d,c){return this.a.call("writeFile",[m,i.$ue.wrap(d),c])}open(m,d){return this.a.call("open",[m,d])}close(m){return this.a.call("close",[m])}async read(m,d,c,g,u){const[p,f]=await this.a.call("read",[m,d,u]);return c.set(p.buffer.slice(0,f),g),f}write(m,d,c,g,u){return this.a.call("write",[m,d,i.$ue.wrap(c),g,u])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,d){return this.a.call("delete",[m,d])}rename(m,d,c){return this.a.call("rename",[m,d,c])}copy(m,d,c){return this.a.call("copy",[m,d,c])}cloneFile(m,d){return this.a.call("cloneFile",[m,d])}j(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const d=m;this.f.fire((0,E.$Aq)(d))}else{const d=m;this.g.fire(d)}}))}watch(m,d){const c=(0,v.$Eg)();return this.a.call("watch",[this.h,c,m,d]),(0,C.$Sc)(()=>this.a.call("unwatch",[this.h,c]))}}e.$UP=y}),define(Ee[228],ke([1,0,27,2,46,6,3]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class k extends A.$Uc{constructor(){super(),this.a=this.B(new D.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new A.$4c),this.m=5007,this.B(this.f($=>this.n($)))}n($){this.r($)&&this.t($)}r($){return(0,S.$vq)($)}async watch($){this.h.clear(),this.g.clear();for(const E of $)this.r(E)?this.h.set(E.correlationId,E):this.g.add(E);for(const[E]of this.j)this.h.has(E)||this.j.deleteAndDispose(E);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter($=>!this.j.has($.correlationId))])}t($){if(this.j.has($.correlationId))return;const E=new A.$Tc;this.j.set($.correlationId,E),this.w($,E),this.s()}u($){this.j.deleteAndDispose($.correlationId),this.s()}w($,E){const y=C.URI.file($.path),w=this;let m=!1;const d=(c,g)=>{if(E.isDisposed)return;const u=this.y(c),p=this.y(g),f=m;if(m=u,!u&&(p||f)){this.F(`fs.watchFile() detected ${$.path} exists again, resuming watcher (correlationId: ${$.correlationId})`);const h={resource:y,type:1,cId:$.correlationId};w.a.fire([h]),this.z(h,$),this.u($)}};this.F(`starting fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,i.watchFile)($.path,{persistent:!1,interval:this.m},d)}catch(c){this.G(`fs.watchFile() failed with error ${c} on path ${$.path} (correlationId: ${$.correlationId})`)}E.add((0,A.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,i.unwatchFile)($.path,d)}catch(c){this.G(`fs.unwatchFile() failed with error ${c} on path ${$.path} (correlationId: ${$.correlationId})`)}}))}y($){return $.ctimeMs===0&&$.ino===0}async stop(){this.j.clearAndDisposeAll()}z($,E){const y=` >> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.resource.fsPath}`;this.F(typeof E.correlationId=="number"?`${y} (correlationId: ${E.correlationId})`:y)}C($){return`${$.path} (excludes: ${$.excludes.length>0?$.excludes:"<none>"}, includes: ${$.includes&&$.includes.length>0?JSON.stringify($.includes):"<all>"}, correlationId: ${typeof $.correlationId=="number"?$.correlationId:"<none>"})`}}e.$Mq=k}),define(Ee[229],ke([1,0,27,15,20,37,2,98,7,4,19,3,176,23,46]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,e.$Sq=g;class c extends C.$Uc{static{this.a=100}static{this.b=75}constructor(p,f,h,l,t){super(),this.m=p,this.n=f,this.r=h,this.s=l,this.t=t,this.c=this.B(new A.$xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},a=>this.n(a))),this.f=this.B(new A.$wh(a=>this.D(a),c.b)),this.g=(0,d.$Dq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,d.$Dq)(this.m.path,this.m.includes):void 0,this.j=new S.$ee,this.ready=this.u()}async u(){try{const p=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const f=await m.Promises.stat(p);if(this.j.token.isCancellationRequested)return;this.B(await this.y(p,f.isDirectory()))}catch(p){p.code!=="ENOENT"?this.G(p):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${p})`),this.r?.()}}async w(p){let f=p.path;try{f=await m.Promises.realpath(p.path),p.path===f&&(f=await(0,w.$Oq)(p.path,this.j.token)??p.path),p.path!==f&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${p.path}, real: ${f})`)}catch{}return f}async y(p,f){if($.$j&&(0,D.$ig)(p,"/Volumes/",!0))return this.G(`Refusing to watch ${p} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Uc.None;const h=new S.$ee(this.j.token),l=new C.$Tc;try{const t=y.URI.file(this.m.path),a=(0,v.$oc)(p),o=(0,i.watch)(p);l.add((0,C.$Sc)(()=>{o.removeAllListeners(),o.close()})),this.I(`Started watching: '${p}'`);const r=new Set;if(f)try{for(const n of await m.Promises.readdir(p))r.add(n)}catch(n){this.G(n)}const s=new Map;l.add((0,C.$Sc)(()=>{for(const[,n]of s)n.dispose();s.clear()})),o.on("error",(n,b)=>{this.G(`Failed to watch ${p} for changes using fs.watch() (${n}, ${b})`),this.r?.()}),o.on("change",(n,b)=>{if(h.token.isCancellationRequested)return;this.I(`[raw] ["${n}"] ${b}`);let P="";if(b&&(P=b.toString(),$.$j&&(P=(0,k.$Zl)(P))),!(!P||n!=="change"&&n!=="rename"))if(f)if(n==="rename"){s.get(P)?.dispose();const I=setTimeout(async()=>{if(s.delete(P),P===a&&!await m.Promises.exists(p)){this.z(t);return}const O=await this.F((0,v.$kc)(p,P));if(h.token.isCancellationRequested)return;let R;O?r.has(P)?R=0:(R=1,r.add(P)):(r.delete(P),R=2),this.C({resource:(0,E.$Vg)(t,P),type:R,cId:this.m.correlationId})},c.a);s.set(P,(0,C.$Sc)(()=>clearTimeout(I)))}else{let I;r.has(P)?I=0:(I=1,r.add(P)),this.C({resource:(0,E.$Vg)(t,P),type:I,cId:this.m.correlationId})}else if(n==="rename"||P!==a){const I=setTimeout(async()=>{const O=await m.Promises.exists(p);h.token.isCancellationRequested||(O?(this.C({resource:t,type:0,cId:this.m.correlationId},!0),l.add(await this.y(p,!1))):this.z(t))},c.a);l.clear(),l.add((0,C.$Sc)(()=>clearTimeout(I)))}else this.C({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){h.token.isCancellationRequested||this.G(`Failed to watch ${p} for changes using fs.watch() (${t.toString()})`),this.r?.()}return(0,C.$Sc)(()=>{h.dispose(!0),l.dispose()})}z(p){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:p,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(p,f=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.resource.fsPath}`),!f&&this.g.some(h=>h(p.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${p.resource.fsPath}`):!f&&this.h&&this.h.length>0&&!this.h.some(h=>h(p.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${p.resource.fsPath}`):this.f.work(p))}D(p){const f=(0,d.$Bq)(p);if(f.length>0){if(this.t)for(const l of f)this.I(` >> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`);this.c.work(f)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(p){if($.$k)return m.Promises.exists(p);try{const f=(0,v.$oc)(p);return(await m.Promises.readdir((0,v.$nc)(p))).some(l=>l===f)}catch(f){return this.I(f),!1}}setVerboseLogging(p){this.t=p}G(p){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${p}`})}H(p){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${p}`})}I(p){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Rq=c;async function g(u,p,f,h,l=512){const t=await m.Promises.open(u,"r"),a=Buffer.allocUnsafe(l),o=new S.$ee(h);let r,s=!1;const n={path:u,excludes:[],recursive:!1},b=new c(n,P=>{(async()=>{for(const{type:I}of P)if(I===0){if(s)return;s=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:O}=await m.Promises.read(t,a,0,l,null);if(!O||o.token.isCancellationRequested)break;p(a.slice(0,O))}}catch(O){r=new Error(O),o.dispose(!0)}finally{s=!1}}})()});return await b.ready,f(),new Promise((P,I)=>{o.token.onCancellationRequested(async()=>{b.dispose();try{await m.Promises.close(t)}catch(O){r=new Error(O)}r?I(r):P()})})}}),define(Ee[230],ke([1,0,6,79,228,4,229,37]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class v extends S.$Mq{constructor(){super(...arguments),this.onDidError=i.Event.None,this.H=new Set,this.I=!1}async D(E){E=this.O(E);const y=[],w=new Set(Array.from(this.H));for(const m of E){const d=this.L(m);d&&(0,A.$gk)(d.request.excludes,m.excludes)&&(0,A.$gk)(d.request.includes,m.includes)?w.delete(d):y.push(m)}y.length&&this.F(`Request to start watching: ${y.map(m=>this.C(m)).join(",")}`),w.size&&this.F(`Request to stop watching: ${Array.from(w).map(m=>this.C(m.request)).join(",")}`);for(const m of w)this.N(m);for(const m of y)this.M(m)}L(E){for(const y of this.H)if(typeof E.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===E.correlationId)return y}else if((0,k.$hg)(y.request.path,E.path,!D.$k))return y}M(E){const y=new C.$Rq(E,m=>this.a.fire(m),()=>this.c.fire(E),m=>this.b.fire(m),this.I),w={request:E,instance:y};this.H.add(w)}async stop(){await super.stop();for(const E of this.H)this.N(E)}N(E){this.F("stopping file watcher",E),this.H.delete(E),E.instance.dispose()}O(E){const y=new Map;for(const w of E){const m=D.$k?w.path:w.path.toLowerCase();let d=y.get(w.correlationId);d||(d=new Map,y.set(w.correlationId,d)),d.has(m)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(w)}`),d.set(m,w)}return Array.from(y.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(E){this.I=E;for(const y of this.H)y.instance.setVerboseLogging(E)}F(E,y){this.I&&this.b.fire({type:"trace",message:this.R(E,y)})}G(E){this.b.fire({type:"warn",message:this.R(E)})}R(E,y){return y?`[File Watcher (node.js)] ${E} (${this.C(y.request)})`:`[File Watcher (node.js)] ${E}`}}e.$Tq=v}),define(Ee[231],ke([1,0,46,230]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class S extends i.$yq{constructor(C,k,v){super(C,k,v),this.s()}r(C){return C.add(new A.$Tq)}}e.$Uq=S}),define(Ee[232],ke([1,0,12,45,108,46]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class C extends D.$zq{constructor(v,$,E){super(v,$,E),this.s()}r(v){const $=v.add(new S.$Kq(i.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add($.onDidProcessExit(({code:E,signal:y})=>this.t(`terminated by itself with code ${E}, signal: ${y}`))),A.ProxyChannel.toService((0,A.$2h)($.getChannel("watcher")))}}e.$Lq=C}),define(Ee[83],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class i{constructor(...S){this.a=new Map;for(const[D,C]of S)this.set(D,C)}set(S,D){const C=this.a.get(S);return this.a.set(S,D),C}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$gi=i}),define(Ee[112],ke([1,0,15,10,2,68,224,5,83,97]),function(le,e,i,A,S,D,C,k,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;const E=!1;class y extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class w{constructor(g=new v.$gi,u=!1,p,f=E){this.f=g,this.g=u,this.h=p,this.i=f,this.o=new Set,this.f.set(k.$hi,this),this._globalGraph=f?p?._globalGraph??new C.$Xq(h=>h):void 0}createChild(g){return new w(g,this.g,this,this.i)}invokeFunction(g,...u){const p=d.traceInvocation(this.i,g);let f=!1;try{return g({get:l=>{if(f)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(l,p);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...u)}finally{f=!0,p.stop()}}createInstance(g,...u){let p,f;return g instanceof D.$fi?(p=d.traceCreation(this.i,g.ctor),f=this.j(g.ctor,g.staticArguments.concat(u),p)):(p=d.traceCreation(this.i,g),f=this.j(g,u,p)),p.stop(),f}j(g,u=[],p){const f=k._util.getServiceDependencies(g).sort((t,a)=>t.index-a.index),h=[];for(const t of f){const a=this.m(t.id,p);a||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),h.push(a)}const l=f.length>0?f[0].index:u.length;if(u.length!==l){console.trace(`[createInstance] First service dependency of ${g.name} at position ${l+1} conflicts with ${u.length} static arguments`);const t=l-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,l)}return Reflect.construct(g,u.concat(h))}k(g,u){if(this.f.get(g)instanceof D.$fi)this.f.set(g,u);else if(this.h)this.h.k(g,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const u=this.f.get(g);return!u&&this.h?this.h.l(g):u}m(g,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const p=this.l(g);return p instanceof D.$fi?this.q(g,p,u.branch(g,!0)):(u.branch(g,!1),p)}q(g,u,p){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,u,p)}finally{this.o.delete(g)}}r(g,u,p){const f=new C.$Xq(t=>t.id.toString());let h=0;const l=[{id:g,desc:u,_trace:p}];for(;l.length;){const t=l.pop();if(f.lookupOrInsertNode(t),h++>1e3)throw new y(f);for(const a of k._util.getServiceDependencies(t.desc.ctor)){const o=this.l(a.id);if(o||this.u(`[createInstance] ${g} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),o instanceof D.$fi){const r={id:a.id,desc:o,_trace:t._trace.branch(a.id,!0)};f.insertEdge(t,r),l.push(r)}}}for(;;){const t=f.roots();if(t.length===0){if(!f.isEmpty())throw new y(f);break}for(const{data:a}of t){if(this.l(a.id)instanceof D.$fi){const r=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,r)}f.removeNode(a)}}return this.l(g)}s(g,u,p=[],f,h){if(this.f.get(g)instanceof D.$fi)return this.t(g,u,p,f,h);if(this.h)return this.h.s(g,u,p,f,h);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(g,u,p=[],f,h){if(f){const l=new w(void 0,this.g,this,this.i);l.c=String(g);const t=new Map,a=new i.$Bh(()=>{const o=l.j(u,p,h);for(const[r,s]of t){const n=o[r];if(typeof n=="function")for(const b of s)b.disposable=n.apply(o,b.listener)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,r){if(!a.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let b=t.get(r);return b||(b=new $.$5c,t.set(r,b)),(I,O,R)=>{if(a.isInitialized)return a.value[r](I,O,R);{const j={listener:[I,O,R],disposable:void 0},B=b.push(j);return(0,S.$Sc)(()=>{B(),j.disposable?.dispose()})}}}if(r in o)return o[r];const s=a.value;let n=s[r];return typeof n!="function"||(n=n.bind(s),o[r]=n),n},set(o,r,s){return a.value[r]=s,!0},getPrototypeOf(o){return u.prototype}})}else return this.j(u,p,h)}u(g,u){if(u&&console.warn(g),this.g)throw new Error(g)}}e.$Yq=w;var m;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(m||(m={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,u){return g?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(g,u){return g?new d(1,u.name):d.c}static{this.f=0}constructor(g,u){this.type=g,this.name=u,this.g=Date.now(),this.h=[]}branch(g,u){const p=new d(3,g.toString());return this.h.push([g,u,p]),p}stop(){const g=Date.now()-this.g;d.f+=g;let u=!1;function p(h,l){const t=[],a=new Array(h+1).join("	");for(const[o,r,s]of l.h)if(r&&s){u=!0,t.push(`${a}CREATES -> ${o}`);const n=p(h+1,s);n&&t.push(n)}else t.push(`${a}uses -> ${o}`);return t.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(g>2||u)&&d.all.add(f.join(`
`))}}e.$Zq=d}),define(Ee[233],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$Kv=void 0,e.$Kv=(0,i.$ii)("labelService");var A;(function(S){S[S.SHORT=0]="SHORT",S[S.MEDIUM=1]="MEDIUM",S[S.LONG=2]="LONG"})(A||(e.Verbosity=A={}))});var Re=this&&this.__param||function(le,e){return function(i,A){e(i,A,le)}};define(Ee[84],ke([1,0,20,2,4,198,31,5]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=void 0,e.$Ar=v;function v(E){return E.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$Br=(0,k.$ii)("languagePackService");let $=class extends A.$Uc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new i.$ee;setTimeout(()=>y.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const d=w.firstPage.filter(c=>c.properties.localizedLanguages?.length&&c.tags.some(g=>g.startsWith("lp-"))).map(c=>{const g=c.properties.localizedLanguages?.[0],u=v(c);return{...this.f(u,g,c),extensionId:c.identifier.id,galleryExtension:c}});return d.push(this.f("en","English")),d}f(y,w,m){const d=w??y;let c;if(d!==y&&(c=`(${y})`),y.toLowerCase()===S.$w.toLowerCase()&&(c??="",c+=(0,D.localize)(0,null)),m?.installCount){c??="";const g=m.installCount;let u;g>1e6?u=`${Math.floor(g/1e5)/10}M`:g>1e3?u=`${Math.floor(g/1e3)}K`:u=String(g),c+=` $(cloud-download) ${u}`}return{id:y,label:d,description:c}}};e.$Cr=$,e.$Cr=$=Le([Re(0,C.$Ro)],$)}),define(Ee[13],ke([1,0,199,40,6,62,2,24,4,19,11,3,57,5]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=c,e.log=u,e.$3j=b,e.$4j=P,e.$5j=I,e.$6j=O,e.$Oj=(0,m.$ii)("logService"),e.$Pj=(0,m.$ii)("loggerService");function d(){return new Date().toISOString()}function c(R){return(0,E.$Zf)(R)}var g;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$Rj=g.Info;function u(R,j,B){switch(j){case g.Trace:R.trace(B);break;case g.Debug:R.debug(B);break;case g.Info:R.info(B);break;case g.Warning:R.warn(B);break;case g.Error:R.error(B);break;case g.Off:break;default:throw new Error(`Invalid log level ${j}`)}}function p(R,j=!1){let B="";for(let Y=0;Y<R.length;Y++){let fe=R[Y];if(fe instanceof Error&&(fe=(0,A.$6i)(fe,j)),typeof fe=="object")try{fe=JSON.stringify(fe)}catch{}B+=(Y>0?" ":"")+fe}return B}class f extends C.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new S.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(j){this.b!==j&&(this.b=j,this.c.fire(this.b))}getLevel(){return this.b}f(j){return this.b!==g.Off&&this.b<=j}}e.$Tj=f;class h extends f{constructor(j){super(),this.h=j}f(j){return this.h||super.f(j)}trace(j,...B){this.f(g.Trace)&&this.g(g.Trace,p([j,...B],!0))}debug(j,...B){this.f(g.Debug)&&this.g(g.Debug,p([j,...B]))}info(j,...B){this.f(g.Info)&&this.g(g.Info,p([j,...B]))}warn(j,...B){this.f(g.Warning)&&this.g(g.Warning,p([j,...B]))}error(j,...B){if(this.f(g.Error))if(j instanceof Error){const Y=Array.prototype.slice.call(arguments);Y[0]=j.stack,this.g(g.Error,p(Y))}else this.g(g.Error,p([j,...B]))}flush(){}}e.$Uj=h;class l extends f{constructor(j=e.$Rj){super(),this.setLevel(j),this.g=!v.$i}trace(j,...B){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,j,...B):console.log(`[main ${d()}]`,j,...B))}debug(j,...B){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,j,...B):console.log(`[main ${d()}]`,j,...B))}info(j,...B){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,j,...B):console.log(`[main ${d()}]`,j,...B))}warn(j,...B){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,j,...B):console.warn(`[main ${d()}]`,j,...B))}error(j,...B){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,j,...B):console.error(`[main ${d()}]`,j,...B))}flush(){}}e.$Vj=l;class t extends f{constructor(j=e.$Rj,B=!0){super(),this.g=B,this.setLevel(j)}trace(j,...B){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",j,...B):console.log(j,...B))}debug(j,...B){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",j,...B):console.log(j,...B))}info(j,...B){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",j,...B):console.log(j,...B))}warn(j,...B){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",j,...B):console.log(j,...B))}error(j,...B){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",j,...B):console.error(j,...B))}flush(){}}e.$Wj=t;class a extends f{constructor(j,B=e.$Rj){super(),this.g=j,this.setLevel(B)}trace(j,...B){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(j),...B])}debug(j,...B){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(j),...B])}info(j,...B){this.f(g.Info)&&this.g.log(g.Info,[this.h(j),...B])}warn(j,...B){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(j),...B])}error(j,...B){this.f(g.Error)&&this.g.log(g.Error,[this.h(j),...B])}h(j){return typeof j=="string"?j:(0,A.$6i)(j,this.f(g.Trace))}flush(){}}e.$Xj=a;class o extends f{constructor(j){super(),this.g=j,j.length&&this.setLevel(j[0].getLevel())}setLevel(j){for(const B of this.g)B.setLevel(j);super.setLevel(j)}trace(j,...B){for(const Y of this.g)Y.trace(j,...B)}debug(j,...B){for(const Y of this.g)Y.debug(j,...B)}info(j,...B){for(const Y of this.g)Y.info(j,...B)}warn(j,...B){for(const Y of this.g)Y.warn(j,...B)}error(j,...B){for(const Y of this.g)Y.error(j,...B)}flush(){for(const j of this.g)j.flush()}dispose(){for(const j of this.g)j.dispose();super.dispose()}}e.$Yj=o;class r extends C.$Uc{constructor(j,B,Y){if(super(),this.h=j,this.j=B,this.b=new k.$Bc,this.c=this.B(new S.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$7d),this.onDidChangeVisibility=this.g.event,Y)for(const fe of Y)this.b.set(fe.resource,{logger:void 0,info:fe})}m(j){return(0,E.$Vf)(j)?[...this.b.values()].find(B=>B.info.id===j):this.b.get(j)}getLogger(j){return this.m(j)?.logger}createLogger(j,B){const Y=this.n(j),fe=(0,E.$Vf)(j)?j:B?.id??(0,D.$9i)(Y.toString()).toString(16);let ue=this.b.get(Y)?.logger;const re=B?.logLevel==="always"?g.Trace:B?.logLevel;ue||(ue=this.s(Y,re??this.getLogLevel(Y)??this.h,{...B,id:fe}));const te={logger:ue,info:{resource:Y,id:fe,logLevel:re,name:B?.name,hidden:B?.hidden,extensionId:B?.extensionId,when:B?.when}};return this.registerLogger(te.info),this.b.set(Y,te),ue}n(j){return(0,E.$Vf)(j)?(0,$.$Vg)(this.j,`${j}.log`):j}setLogLevel(j,B){if(y.URI.isUri(j)){const Y=j,fe=B,ue=this.b.get(Y);ue&&fe!==ue.info.logLevel&&(ue.info.logLevel=fe===this.h?void 0:fe,ue.logger?.setLevel(fe),this.b.set(ue.info.resource,ue),this.f.fire([Y,fe]))}else{this.h=j;for(const[Y,fe]of this.b.entries())this.b.get(Y)?.info.logLevel===void 0&&fe.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(j,B){const Y=this.m(j);Y&&B!==!Y.info.hidden&&(Y.info.hidden=!B,this.b.set(Y.info.resource,Y),this.g.fire([Y.info.resource,B]))}getLogLevel(j){let B;return j&&(B=this.b.get(j)?.info.logLevel),B??this.h}registerLogger(j){const B=this.b.get(j.resource);B?B.info.hidden!==j.hidden&&this.setVisibility(j.resource,!j.hidden):(this.b.set(j.resource,{info:j,logger:void 0}),this.c.fire({added:[j],removed:[]}))}deregisterLogger(j){const B=this.b.get(j);B&&(B.logger&&B.logger.dispose(),this.b.delete(j),this.c.fire({added:[],removed:[B.info]}))}*getRegisteredLoggers(){for(const j of this.b.values())yield j.info}getRegisteredLogger(j){return this.b.get(j)?.info}dispose(){this.b.forEach(j=>j.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=r;class s{constructor(){this.onDidChangeLogLevel=new S.$7d().event}setLevel(j){}getLevel(){return g.Info}trace(j,...B){}debug(j,...B){}info(j,...B){}warn(j,...B){}error(j,...B){}critical(j,...B){}dispose(){}flush(){}}e.$1j=s;class n extends s{}e.$2j=n;function b(R){if(R.verbose)return g.Trace;if(typeof R.logLevel=="string"){const j=O(R.logLevel.toLowerCase());if(j!==void 0)return j}return e.$Rj}function P(R){switch(R){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function I(R){switch(R){case g.Trace:return{original:"Trace",value:i.localize(0,null)};case g.Debug:return{original:"Debug",value:i.localize(1,null)};case g.Info:return{original:"Info",value:i.localize(2,null)};case g.Warning:return{original:"Warning",value:i.localize(3,null)};case g.Error:return{original:"Error",value:i.localize(4,null)};case g.Off:return{original:"Off",value:i.localize(5,null)}}}function O(R){switch(R){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$7j=new w.$zj("logLevel",P(g.Info))}),define(Ee[234],ke([1,0,18,15,10,6,2,7,46,13]),function(le,e,i,A,S,D,C,k,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class E extends C.$Uc{constructor(w,m){super(),this.a=w,this.b=m,this.c=this.B(new D.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$gh(0)),this.w=[],this.y=this.B(new A.$gh(0))}watch(w,m){return m.recursive||this.b?.watcher?.forceUniversal?this.n(w,m):this.z(w,m)}n(w,m){const d={path:this.H(w),excludes:m.excludes,includes:m.includes,recursive:m.recursive,correlationId:m.correlationId},c=(0,i.$Ub)(this.j,d);return this.r(),(0,C.$Sc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,S.$1)(w))}s(){this.h||(this.h=this.B(this.t(m=>this.c.fire((0,v.$Aq)(m)),m=>this.G(m),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const m of this.j)(0,v.$wq)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const m of this.j)(0,v.$wq)(m)&&w.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,m){const d={path:this.H(w),excludes:m.excludes,includes:m.includes,recursive:!1,correlationId:m.correlationId},c=(0,i.$Ub)(this.w,d);return this.C(),(0,C.$Sc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,S.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,v.$Aq)(w)),w=>this.G(w),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,k.$ic)(w.fsPath)}}e.$Eq=E}),define(Ee[113],ke([1,0,18,15,14,20,6,62,41,2,64,12,43,19,51,194,16,111,13,10]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;let l=class extends $.$Uc{static{h=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new C.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$7d),this.Y=this.B(new C.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$rh)}registerProvider(a,o){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${a}`);const r=new $.$Tc;return this.h.set(a,o),this.c.fire({added:!0,scheme:a,provider:o}),r.add(o.onDidChangeFile(s=>{const n=new g.$8k(s,!this.S(o));this.X.fire(n),n.hasCorrelation()||this.Y.fire(n)})),typeof o.onDidWatchError=="function"&&r.add(o.onDidWatchError(s=>this.Z.fire(new Error(s)))),r.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:a}))),(0,$.$Sc)(()=>{this.c.fire({added:!1,scheme:a,provider:o}),this.h.delete(a),(0,$.$Pc)(r)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const o=[];this.f.fire({scheme:a,join(r){o.push(r)}}),!this.h.has(a)&&await A.Promises.settled(o)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,o){const r=this.h.get(a.scheme);return!!(r&&r.capabilities&o)}listCapabilities(){return v.Iterable.map(this.h,([a,o])=>({scheme:a,capabilities:o.capabilities}))}async j(a){if(!(0,m.$Zg)(a))throw new g.$0k((0,c.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const o=this.h.get(a.scheme);if(!o){const r=new f.$bb;throw r.message=(0,c.localize)(1,null,a.toString()),r}return o}async m(a){const o=await this.j(a);if((0,g.$Uk)(o)||(0,g.$Rk)(o)||(0,g.$Vk)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const o=await this.j(a);if((0,g.$Uk)(o)||(0,g.$Rk)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,o){try{return await this.s(a,o)}catch(r){throw(0,g.$5k)(r)===g.FileSystemProviderErrorCode.FileNotFound?new g.$0k((0,c.localize)(2,null,this.sb(a)),1):(0,g.$3k)(r)}}async s(a,o){const r=await this.j(a),s=this.S(r),n=o?.resolveTo,b=o?.resolveSingleChildDescendants,P=o?.resolveMetadata,I=await r.stat(a);let O;return this.t(r,a,I,void 0,!!P,(R,j)=>(O||(O=E.$oi.forUris(()=>!s),O.set(a,!0),n&&O.fill(!0,n)),O.get(R.resource)||O.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&b?j===1:!1))}async t(a,o,r,s,n,b){const{providerExtUri:P}=this.R(a),I={resource:o,name:P.basename(o),isFile:(r.type&g.FileType.File)!==0,isDirectory:(r.type&g.FileType.Directory)!==0,isSymbolicLink:(r.type&g.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&g.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((r.permissions??0)&g.FilePermission.Locked),etag:(0,g.$il)({mtime:r.mtime,size:r.size}),children:void 0};if(I.isDirectory&&b(I,s)){try{const O=await a.readdir(o),R=await A.Promises.settled(O.map(async([j,B])=>{try{const Y=P.joinPath(o,j),fe=n?await a.stat(Y):{type:B};return await this.t(a,Y,fe,O.length,n,b)}catch(Y){return this.b.trace(Y),null}}));I.children=(0,i.$Hb)(R)}catch(O){this.b.trace(O),I.children=[]}return I}return I}async resolveAll(a){return A.Promises.settled(a.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(a){const o=await this.j(a),r=await o.stat(a);return this.t(o,a,r,void 0,!0,()=>!1)}async exists(a){const o=await this.j(a);try{return!!await o.stat(a)}catch{return!1}}async canCreateFile(a,o){try{await this.u(a,o)}catch(r){return r}return!0}async u(a,o){if(!o?.overwrite&&await this.exists(a))throw new g.$0k((0,c.localize)(3,null,this.sb(a)),3,o)}async createFile(a,o=S.$ue.fromString(""),r){await this.u(a,r);const s=await this.writeFile(a,o);return this.r.fire(new g.$7k(a,0,s)),s}async writeFile(a,o,r){const s=this.qb(await this.n(a),a),{providerExtUri:n}=this.R(s);let b=r;if((0,g.$Xk)(s)&&!b?.atomic){const P=s.enforceAtomicWriteFile?.(a);P&&(b={...r,atomic:P})}try{await this.w(s,a,b)||await this.U(s,n.dirname(a));let I;if((0,g.$Rk)(s)&&!(o instanceof S.$ue))if((0,d.$ge)(o)){const O=await(0,d.$ne)(o,3);O.ended?I=S.$ue.concat(O.buffer):I=O}else I=(0,d.$ke)(o,O=>S.$ue.concat(O),3);else I=o;!(0,g.$Uk)(s)||(0,g.$Rk)(s)&&I instanceof S.$ue||(0,g.$Rk)(s)&&(0,g.$Xk)(s)&&b?.atomic?await this.hb(s,a,b,I):await this.db(s,a,b,I instanceof S.$ue?(0,S.$Fe)(I):I),this.r.fire(new g.$7k(a,4))}catch(P){throw new g.$0k((0,c.localize)(4,null,this.sb(a),(0,g.$3k)(P).toString()),(0,g.$6k)(P),b)}return this.resolve(a,{resolveMetadata:!0})}async w(a,o,r){const s=!!r?.unlock;if(s&&!(a.capabilities&8192))throw new Error((0,c.localize)(5,null,this.sb(o)));if(!!r?.atomic){if(!(a.capabilities&32768))throw new Error((0,c.localize)(6,null,this.sb(o)));if(!(a.capabilities&2))throw new Error((0,c.localize)(7,null,this.sb(o)));if(s)throw new Error((0,c.localize)(8,null,this.sb(o)))}let b;try{b=await a.stat(o)}catch{return}if(b.type&g.FileType.Directory)throw new g.$0k((0,c.localize)(9,null,this.sb(o)),0,r);if(this.rb(o,b),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==g.$hl&&typeof b.mtime=="number"&&typeof b.size=="number"&&r.mtime<b.mtime&&r.etag!==(0,g.$il)({mtime:r.mtime,size:b.size}))throw new g.$0k((0,c.localize)(10,null),3,r);return b}async readFile(a,o,r){const s=await this.m(a);return o?.atomic?this.z(s,a,o,r):this.C(s,a,o,r)}async z(a,o,r,s){return new Promise((n,b)=>{this.cb.queueFor(o,async()=>{try{const P=await this.C(a,o,r,s);n(P)}catch(P){b(P)}},this.R(a).providerExtUri)})}async C(a,o,r,s){const n=await this.D(a,o,{...r,preferUnbuffered:!0},s);return{...n,value:await(0,S.$Ge)(n.value)}}async readFileStream(a,o,r){const s=await this.m(a);return this.D(s,a,o,r)}async D(a,o,r,s){const n=new D.$ee(s);let b=r;(0,g.$Wk)(a)&&a.enforceAtomicReadFile?.(o)&&(b={...r,atomic:!0});const P=this.J(o,b).then(O=>O,O=>{throw n.dispose(!0),O});let I;try{return typeof b?.etag=="string"&&b.etag!==g.$hl&&await P,b?.atomic&&(0,g.$Wk)(a)||!((0,g.$Uk)(a)||(0,g.$Vk)(a))||(0,g.$Rk)(a)&&b?.preferUnbuffered?I=this.I(a,o,b):(0,g.$Vk)(a)?I=this.G(a,o,n.token,b):I=this.H(a,o,n.token,b),I.on("end",()=>n.dispose()),I.on("error",()=>n.dispose()),{...await P,value:I}}catch(O){throw I&&await(0,d.$le)(I),this.F(O,o,b)}}F(a,o,r){const s=(0,c.localize)(11,null,this.sb(o),(0,g.$3k)(a).toString());return a instanceof g.$_k?new g.$_k(s,a.stat,r):a instanceof g.$$k?new g.$$k(s,a.fileOperationResult,a.size,a.options):new g.$0k(s,(0,g.$6k)(a),r)}G(a,o,r,s=Object.create(null)){const n=a.readFileStream(o,s,r);return(0,d.$re)(n,{data:b=>b instanceof S.$ue?b:S.$ue.wrap(b),error:b=>this.F(b,o,s)},b=>S.$ue.concat(b))}H(a,o,r,s=Object.create(null)){const n=(0,S.$Ke)();return(0,u.$tq)(a,o,n,b=>b,{...s,bufferSize:this.a,errorTransformer:b=>this.F(b,o,s)},r),n}I(a,o,r){const s=(0,d.$ie)(n=>S.$ue.concat(n));return(async()=>{try{let n;r?.atomic&&(0,g.$Wk)(a)?n=await a.readFile(o,{atomic:!0}):n=await a.readFile(o),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.L(o,n.byteLength,r),s.end(S.$ue.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async J(a,o){const r=await this.resolve(a,{resolveMetadata:!0});if(r.isDirectory)throw new g.$0k((0,c.localize)(12,null,this.sb(a)),0,o);if(typeof o?.etag=="string"&&o.etag!==g.$hl&&o.etag===r.etag)throw new g.$_k((0,c.localize)(13,null),r,o);return this.L(a,r.size,o),r}L(a,o,r){if(typeof r?.limits?.size=="number"&&o>r.limits.size)throw new g.$$k((0,c.localize)(14,null,this.sb(a)),7,o,r)}async canMove(a,o,r){return this.M(a,o,"move",r)}async canCopy(a,o,r){return this.M(a,o,"copy",r)}async M(a,o,r,s){if(a.toString()!==o.toString())try{const n=r==="move"?this.qb(await this.n(a),a):await this.m(a),b=this.qb(await this.n(o),o);await this.Q(n,a,b,o,r,s)}catch(n){return n}return!0}async move(a,o,r){const s=this.qb(await this.n(a),a),n=this.qb(await this.n(o),o),b=await this.N(s,a,n,o,"move",!!r),P=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new g.$7k(a,b==="move"?2:3,P)),P}async copy(a,o,r){const s=await this.m(a),n=this.qb(await this.n(o),o),b=await this.N(s,a,n,o,"copy",!!r),P=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new g.$7k(a,b==="copy"?3:2,P)),P}async N(a,o,r,s,n,b){if(o.toString()===s.toString())return n;const{exists:P,isSameResourceWithDifferentPathCase:I}=await this.Q(a,o,r,s,n,b);if(P&&!I&&b&&await this.del(s,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(s)),n==="copy"){if(a===r&&(0,g.$Sk)(a))await a.copy(o,s,{overwrite:b});else{const O=await this.resolve(o);O.isDirectory?await this.P(a,O,r,s):await this.O(a,o,r,s)}return n}else return a===r?(await a.rename(o,s,{overwrite:b}),n):(await this.N(a,o,r,s,"copy",b),await this.del(o,{recursive:!0}),"copy")}async O(a,o,r,s){if((0,g.$Uk)(a)&&(0,g.$Uk)(r))return this.jb(a,o,r,s);if((0,g.$Uk)(a)&&(0,g.$Rk)(r))return this.pb(a,o,r,s);if((0,g.$Rk)(a)&&(0,g.$Uk)(r))return this.nb(a,o,r,s);if((0,g.$Rk)(a)&&(0,g.$Rk)(r))return this.lb(a,o,r,s)}async P(a,o,r,s){await r.mkdir(s),Array.isArray(o.children)&&await A.Promises.settled(o.children.map(async n=>{const b=this.R(r).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.P(a,await this.resolve(n.resource),r,b):this.O(a,n.resource,r,b)}))}async Q(a,o,r,s,n,b){let P=!1;if(a===r){const{providerExtUri:O,isPathCaseSensitive:R}=this.R(a);if(R||(P=O.isEqual(o,s)),P&&n==="copy")throw new Error((0,c.localize)(15,null,this.sb(o),this.sb(s)));if(!P&&O.isEqualOrParent(s,o))throw new Error((0,c.localize)(16,null,this.sb(o),this.sb(s)))}const I=await this.exists(s);if(I&&!P){if(!b)throw new g.$0k((0,c.localize)(17,null,this.sb(o),this.sb(s)),4);if(a===r){const{providerExtUri:O}=this.R(a);if(O.isEqualOrParent(o,s))throw new Error((0,c.localize)(18,null,this.sb(o),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:P}}R(a){const o=this.S(a);return{providerExtUri:o?m.$Lg:m.$Ng,isPathCaseSensitive:o}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const o=this.qb(await this.j(a),a);await this.U(o,a);const r=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new g.$7k(a,0,r)),r}async U(a,o){const r=[],{providerExtUri:s}=this.R(a);for(;!s.isEqual(o,s.dirname(o));)try{if(!((await a.stat(o)).type&g.FileType.Directory))throw new Error((0,c.localize)(19,null,this.sb(o)));break}catch(n){if((0,g.$5k)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(s.basename(o)),o=s.dirname(o)}for(let n=r.length-1;n>=0;n--){o=s.joinPath(o,r[n]);try{await a.mkdir(o)}catch(b){if((0,g.$5k)(b)!==g.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(a,o){try{await this.W(a,o)}catch(r){return r}return!0}async W(a,o){const r=this.qb(await this.j(a),a),s=!!o?.useTrash;if(s&&!(r.capabilities&4096))throw new Error((0,c.localize)(20,null,this.sb(a)));const n=o?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,c.localize)(21,null,this.sb(a)));if(s&&n)throw new Error((0,c.localize)(22,null,this.sb(a)));let b;try{b=await r.stat(a)}catch{}if(b)this.rb(a,b);else throw new g.$0k((0,c.localize)(23,null,this.sb(a)),1);if(!!!o?.recursive){const I=await this.resolve(a);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,c.localize)(24,null,this.sb(a)))}return r}async del(a,o){const r=await this.W(a,o);let s=o;if((0,g.$Yk)(r)&&!s?.atomic){const I=r.enforceAtomicDelete?.(a);I&&(s={...o,atomic:I})}const n=!!s?.useTrash,b=!!s?.recursive,P=s?.atomic??!1;await r.delete(a,{recursive:b,useTrash:n,atomic:P}),this.r.fire(new g.$7k(a,1))}async cloneFile(a,o){const r=await this.j(a),s=this.qb(await this.n(o),o);if(!(r===s&&this.R(r).providerExtUri.isEqual(a,o)))return r===s&&(0,g.$Tk)(r)?r.cloneFile(a,o):(await this.U(s,this.R(s).providerExtUri.dirname(o)),r===s&&(0,g.$Sk)(r)?this.cb.queueFor(a,()=>r.copy(a,o,{overwrite:!0}),this.R(r).providerExtUri):this.cb.queueFor(a,()=>this.O(r,a,s,o),this.R(r).providerExtUri))}static{this.ab=0}createWatcher(a,o){return this.watch(a,{...o,correlationId:h.ab++})}watch(a,o={recursive:!1,excludes:[]}){const r=new $.$Tc;let s=!1,n=()=>{s=!0};r.add((0,$.$Sc)(()=>n())),(async()=>{try{const P=await this.bb(a,o);s?(0,$.$Pc)(P):n=()=>(0,$.$Pc)(P)}catch(P){this.b.error(P)}})();const b=o.correlationId;if(typeof b=="number"){const P=r.add(new C.$7d);return r.add(this.X.event(O=>{O.correlates(b)&&P.fire(O)})),{onDidChange:P.event,dispose:()=>r.dispose()}}return r}async bb(a,o){const r=await this.j(a),s=(0,k.$9i)([this.R(r).providerExtUri.getComparisonKey(a),o]);let n=this.$.get(s);return n||(n={count:0,disposable:r.watch(a,o)},this.$.set(s,n)),n.count+=1,(0,$.$Sc)(()=>{n&&(n.count--,n.count===0&&((0,$.$Pc)(n.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,$.$Pc)(a.disposable);this.$.clear()}async db(a,o,r,s){return this.cb.queueFor(o,async()=>{const n=await a.open(o,{create:!0,unlock:r?.unlock??!1});try{(0,d.$ge)(s)||(0,d.$he)(s)?await this.eb(a,n,s):await this.fb(a,n,s)}catch(b){throw(0,g.$3k)(b)}finally{await a.close(n)}},this.R(a).providerExtUri)}async eb(a,o,r){let s=0,n;if((0,d.$he)(r)){if(r.buffer.length>0){const b=S.$ue.concat(r.buffer);await this.gb(a,o,b,b.byteLength,s,0),s+=b.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((b,P)=>{(0,d.$me)(n,{onData:async I=>{n.pause();try{await this.gb(a,o,I,I.byteLength,s,0)}catch(O){return P(O)}s+=I.byteLength,setTimeout(()=>n.resume())},onError:I=>P(I),onEnd:()=>b()})})}async fb(a,o,r){let s=0,n;for(;(n=r.read())!==null;)await this.gb(a,o,n,n.byteLength,s,0),s+=n.byteLength}async gb(a,o,r,s,n,b){let P=0;for(;P<s;){const I=await a.write(o,n+P,r.buffer,b+P,s-P);P+=I}}async hb(a,o,r,s){return this.cb.queueFor(o,()=>this.ib(a,o,r,s),this.R(a).providerExtUri)}async ib(a,o,r,s){let n;s instanceof S.$ue?n=s:(0,d.$ge)(s)?n=await(0,S.$Ge)(s):(0,d.$he)(s)?n=await(0,S.$He)(s):n=(0,S.$Ee)(s),await a.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async jb(a,o,r,s){return this.cb.queueFor(s,()=>this.kb(a,o,r,s),this.R(r).providerExtUri)}async kb(a,o,r,s){let n,b;try{n=await a.open(o,{create:!1}),b=await r.open(s,{create:!0,unlock:!1});const P=S.$ue.alloc(this.a);let I=0,O=0,R=0;do R=await a.read(n,I,P.buffer,O,P.byteLength-O),await this.gb(r,b,P,R,I,O),I+=R,O+=R,O===P.byteLength&&(O=0);while(R>0)}catch(P){throw(0,g.$3k)(P)}finally{await A.Promises.settled([typeof n=="number"?a.close(n):Promise.resolve(),typeof b=="number"?r.close(b):Promise.resolve()])}}async lb(a,o,r,s){return this.cb.queueFor(s,()=>this.mb(a,o,r,s),this.R(r).providerExtUri)}async mb(a,o,r,s){return r.writeFile(s,await a.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,o,r,s){return this.cb.queueFor(s,()=>this.ob(a,o,r,s),this.R(r).providerExtUri)}async ob(a,o,r,s){const n=await r.open(s,{create:!0,unlock:!1});try{const b=await a.readFile(o);await this.gb(r,n,S.$ue.wrap(b),b.byteLength,0,0)}catch(b){throw(0,g.$3k)(b)}finally{await r.close(n)}}async pb(a,o,r,s){const n=await(0,S.$Ge)(this.H(a,o,D.CancellationToken.None));await this.hb(r,s,void 0,n)}qb(a,o){if(a.capabilities&2048)throw new g.$0k((0,c.localize)(25,null,this.sb(o)),6);return a}rb(a,o){if((o.permissions??0)&g.FilePermission.Readonly)throw new g.$0k((0,c.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===y.Schemas.file?a.fsPath:a.toString(!0)}};e.$uq=l,e.$uq=l=h=Le([Re(0,p.$Oj)],l)}),define(Ee[69],ke([1,0,27,309,15,24,14,6,37,2,7,4,19,51,23,197,16,111,234,40,232,231]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0,(()=>{try{(0,A.gracefulify)(i)}catch(a){console.error(`Error enabling graceful-fs: ${(0,f.$6i)(a)}`)}})();class t extends p.$Eq{static{this.I=!1}constructor(o,r){super(o,r),this.onDidChangeCapabilities=k.Event.None,this.N=new D.$Bc(s=>w.$Mg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,y.$k&&(this.J|=1024)),this.J}async stat(o){try{const{stat:r,symbolicLink:s}=await d.SymlinkSupport.stat(this.H(o));return{type:this.M(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:g.FilePermission.Locked}}catch(r){throw this.fb(r)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const r=await d.Promises.readdir(this.H(o),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async n=>{try{let b;n.isSymbolicLink()?b=(await this.stat((0,w.$Vg)(o,n.name))).type:b=this.M(n),s.push([n.name,b])}catch(b){this.a.trace(b)}})),s}catch(r){throw this.fb(r)}}M(o,r){let s;return r?.dangling?s=g.FileType.Unknown:o.isFile()?s=g.FileType.File:o.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,r&&(s|=g.FileType.SymbolicLink),s}async O(o){const r=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const n=new S.$hh;return this.N.set(o,n),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,$.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.N.get(o)===n&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),n.open()})}async readFile(o,r){let s;try{r?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),s=await this.O(o));const n=this.H(o);return await d.Promises.readFile(n)}catch(n){throw this.fb(n)}finally{s?.dispose()}}P(o){t.I&&this.a.trace(o)}readFileStream(o,r,s){const n=(0,m.$ie)(b=>C.$ue.concat(b.map(P=>C.$ue.wrap(P))).buffer);return(0,u.$tq)(this,o,n,b=>b.buffer,{...r,bufferSize:256*1024},s),n}async writeFile(o,r,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,w.$Vg)((0,w.$Ug)(o),`${(0,w.$Sg)(o)}${s.atomic.postfix}`),r,s):this.S(o,r,s)}async Q(o){try{const r=this.H(o),{symbolicLink:s}=await d.SymlinkSupport.stat(r);if(s)return!1}catch{}return!0}async R(o,r,s,n){const b=new $.$Tc;try{b.add(await this.O(o)),b.add(await this.O(r)),await this.S(r,s,n,!0);try{await this.rename(r,o,{overwrite:!0})}catch(P){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{b.dispose()}}async S(o,r,s,n){let b;try{const P=this.H(o);if(!s.create||!s.overwrite){if(await d.Promises.exists(P)){if(!s.overwrite)throw(0,g.$2k)((0,c.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.$2k)((0,c.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(o,{create:!0,unlock:s.unlock},n),await this.write(b,0,r,0,r.byteLength)}catch(P){throw await this.gb(o,P)}finally{typeof b=="number"&&await this.close(b)}}static{this.Y=!0}static configureFlushOnWrite(o){t.Y=o}async open(o,r,s){const n=this.H(o);let b;(0,g.$Pk)(r)&&!s&&(b=await this.O(o));let P;try{if((0,g.$Pk)(r)&&r.unlock)try{const{stat:O}=await d.SymlinkSupport.stat(n);O.mode&128||await d.Promises.chmod(n,O.mode|128)}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}let I;if((0,g.$Pk)(r)){if(y.$i)try{await d.Promises.truncate(n,0),I="r+"}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}I||(I="w")}else I="r";P=await d.Promises.open(n,I)}catch(I){throw b?.dispose(),(0,g.$Pk)(r)?await this.gb(o,I):this.fb(I)}if(this.U.set(P,0),(0,g.$Pk)(r)&&this.X.set(P,o),b){const I=this.W.get(P);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${n})`),this.W.set(P,b),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${n})`),I.dispose())}return P}async close(o){const r=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&t.Y)try{await d.Promises.fdatasync(o)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await d.Promises.close(o)}catch(s){throw this.fb(s)}finally{r&&(this.W.get(o)===r&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),r.dispose())}}async read(o,r,s,n,b){const P=this.Z(o,r);let I=null;try{I=(await d.Promises.read(o,s,n,b,P)).bytesRead}catch(O){throw this.fb(O)}finally{this.$(o,P,I)}return I}Z(o,r){return r===this.U.get(o)?null:r}$(o,r,s){const n=this.U.get(o);typeof n=="number"&&(typeof r=="number"||(typeof s=="number"?this.U.set(o,n+s):this.U.delete(o)))}async write(o,r,s,n,b){return(0,S.$Ch)(()=>this.ab(o,r,s,n,b),100,3)}async ab(o,r,s,n,b){const P=this.Z(o,r);let I=null;try{I=(await d.Promises.write(o,s,n,b,P)).bytesWritten}catch(O){throw await this.gb(this.X.get(o),O)}finally{this.$(o,P,I)}return I}async mkdir(o){try{await d.Promises.mkdir(this.H(o))}catch(r){throw this.fb(r)}}async delete(o,r){try{const s=this.H(o);if(r.recursive){let n;r?.atomic!==!1&&r.atomic.postfix&&(n=(0,E.$kc)((0,E.$nc)(s),`${(0,E.$oc)(s)}${r.atomic.postfix}`)),await d.Promises.rm(s,d.RimRafMode.MOVE,n)}else try{await d.Promises.unlink(s)}catch(n){if(n.code==="EPERM"||n.code==="EISDIR"){let b=!1;try{const{stat:P,symbolicLink:I}=await d.SymlinkSupport.stat(s);b=P.isDirectory()&&!I}catch{}if(b)await d.Promises.rmdir(s);else throw n}else throw n}}catch(s){throw this.fb(s)}}async rename(o,r,s){const n=this.H(o),b=this.H(r);if(n!==b)try{await this.bb(o,r,"move",s.overwrite),await d.Promises.rename(n,b)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,c.localize)(2,null,(0,E.$oc)(n),(0,E.$oc)((0,E.$nc)(b)),P.toString()))),this.fb(P)}}async copy(o,r,s){const n=this.H(o),b=this.H(r);if(n!==b)try{await this.bb(o,r,"copy",s.overwrite),await d.Promises.copy(n,b,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,c.localize)(3,null,(0,E.$oc)(n),(0,E.$oc)((0,E.$nc)(b)),P.toString()))),this.fb(P)}}async bb(o,r,s,n){const b=this.H(o),P=this.H(r);let I=!1;if(!!(this.capabilities&1024)||(I=(0,v.$hg)(b,P,!0)),I){if(s==="copy")throw(0,g.$2k)((0,c.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const R=await this.L(o);if(!R)throw(0,g.$2k)((0,c.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(r);if(j){if(!n)throw(0,g.$2k)((0,c.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);R.type&g.FileType.File&&j.type&g.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,r){return this.cb(o,r,!1)}async cb(o,r,s){const n=this.H(o),b=this.H(r),P=!!(this.capabilities&1024);if((0,v.$hg)(n,b,!P))return;const I=new $.$Tc;try{I.add(await this.O(o)),I.add(await this.O(r)),s&&await d.Promises.mkdir((0,E.$nc)(b),{recursive:!0}),await d.Promises.copyFile(n,b)}catch(O){if(O.code==="ENOENT"&&!s)return this.cb(o,r,!0);throw this.fb(O)}finally{I.dispose()}}t(o,r,s){return new h.$Lq(n=>o(n),n=>r(n),s)}F(o,r,s){return new l.$Uq(n=>o(n),n=>r(n),s)}fb(o){if(o instanceof g.$1k)return o;let r=o,s;switch(o.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=g.FileSystemProviderErrorCode.Unknown;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.$2k)(r,s)}async gb(o,r){let s=this.fb(r);if(o&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:n}=await d.SymlinkSupport.stat(this.H(o));n.mode&128||(s=(0,g.$2k)(r,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(n){this.a.trace(n)}return s}}e.$Vq=t}),define(Ee[235],ke([1,0,6,69,2,14,51,20]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=e.$ss=void 0;class v extends S.$Uc{constructor(y,w){super(),this.a=y,this.b=w,this.F=new Map,this.G=new Map}call(y,w,m){const d=this.c(y);switch(w){case"stat":return this.g(d,m[0]);case"readdir":return this.h(d,m[0]);case"open":return this.r(d,m[0],m[1]);case"close":return this.s(m[0]);case"read":return this.t(m[0],m[1],m[2]);case"readFile":return this.j(d,m[0],m[1]);case"write":return this.u(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.n(d,m[0],m[1],m[2]);case"rename":return this.z(d,m[0],m[1],m[2]);case"copy":return this.C(d,m[0],m[1],m[2]);case"cloneFile":return this.D(d,m[0],m[1]);case"mkdir":return this.w(d,m[0]);case"delete":return this.y(d,m[0],m[1]);case"watch":return this.I(d,m[0],m[1],m[2],m[3]);case"unwatch":return this.J(m[0],m[1])}throw new Error(`IPC Command ${w} not found`)}listen(y,w,m){const d=this.c(y);switch(w){case"fileChange":return this.H(d,m[0]);case"readFileStream":return this.m(d,m[0],m[1])}throw new Error(`Unknown event ${w}`)}g(y,w){const m=this.f(y,w,!0);return this.a.stat(m)}h(y,w){const m=this.f(y,w);return this.a.readdir(m)}async j(y,w,m){const d=this.f(y,w,!0),c=await this.a.readFile(d,m);return D.$ue.wrap(c)}m(y,w,m){const d=this.f(y,w,!0),c=new k.$ee,g=new i.$7d({onDidRemoveLastListener:()=>{c.cancel()}}),u=this.a.readFileStream(d,m,c.token);return(0,C.$me)(u,{onData:p=>g.fire(D.$ue.wrap(p)),onError:p=>g.fire(p),onEnd:()=>{g.fire("end"),g.dispose(),c.dispose()}}),g.event}n(y,w,m,d){const c=this.f(y,w);return this.a.writeFile(c,m.buffer,d)}r(y,w,m){const d=this.f(y,w,!0);return this.a.open(d,m)}s(y){return this.a.close(y)}async t(y,w,m){const d=D.$ue.alloc(m),g=await this.a.read(y,w,d.buffer,0,m);return[d,g]}u(y,w,m,d,c){return this.a.write(y,w,m.buffer,d,c)}w(y,w){const m=this.f(y,w);return this.a.mkdir(m)}y(y,w,m){const d=this.f(y,w);return this.a.delete(d,m)}z(y,w,m,d){const c=this.f(y,w),g=this.f(y,m);return this.a.rename(c,g,d)}C(y,w,m,d){const c=this.f(y,w),g=this.f(y,m);return this.a.copy(c,g,d)}D(y,w,m){const d=this.f(y,w),c=this.f(y,m);return this.a.cloneFile(d,c)}H(y,w){const m=new i.$7d({onWillAddFirstListener:()=>{this.F.set(w,this.L(y,m))},onDidRemoveLastListener:()=>{(0,S.$Pc)(this.F.get(w)),this.F.delete(w)}});return m.event}async I(y,w,m,d,c){const g=this.F.get(w);if(g){const u=this.f(y,d),p=g.watch(m,u,c);this.G.set(w+m,p)}}async J(y,w){const m=y+w,d=this.G.get(m);d&&((0,S.$Pc)(d),this.G.delete(m))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$ss=v;class $ extends S.$Uc{constructor(y,w,m,d){super(),this.c=y,this.f=m,this.g=d,this.a=new Map,this.b=this.B(new A.$Vq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(w)}h(y){const w=this.B(new i.$7d);this.B(w.event(m=>{y.fire(m.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type,cId:d.cId})))})),this.B(this.b.onDidChangeFile(m=>w.fire(m))),this.B(this.b.onDidWatchError(m=>y.fire(m)))}j(y){}m(y){}watch(y,w,m){const d=this.m(this.g);return Array.isArray(d)&&(m.excludes=[...m.excludes,...d]),this.a.set(y,this.b.watch(w,m)),(0,S.$Sc)(()=>{(0,S.$Pc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$ts=$}),define(Ee[114],ke([1,0,3,6,13,2]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=void 0;class C extends S.$Zj{constructor(y,w,m,d,c){super(w,m,d),this.r=y,this.t=c,this.B(c.listen("onDidChangeLogLevel",y)(g=>{(0,S.$Qj)(g)?super.setLogLevel(g):super.setLogLevel(i.URI.revive(g[0]),g[1])})),this.B(c.listen("onDidChangeVisibility",y)(([g,u])=>super.setVisibility(i.URI.revive(g),u))),this.B(c.listen("onDidChangeLoggers",y)(({added:g,removed:u})=>{for(const p of g)super.registerLogger({...p,resource:i.URI.revive(p.resource)});for(const p of u)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new S.$Xj({log:(y,w)=>{this.t.call("consoleLog",[y,w])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,w){super.setLogLevel(y,w),this.t.call("setLogLevel",[y,w])}setVisibility(y,w){super.setVisibility(y,w),this.t.call("setVisibility",[this.n(y),w])}s(y,w,m){return new k(this.t,y,w,m,this.r)}static setLogLevel(y,w,m){return y.call("setLogLevel",[w,m])}}e.$Ur=C;class k extends S.$Uj{constructor(y,w,m,d,c){super(d?.logLevel==="always"),this.r=y,this.s=w,this.m=!1,this.n=[],this.setLevel(m),this.r.call("createLogger",[w,d,c]).then(()=>{this.u(this.n),this.m=!0})}g(y,w){const m=[[y,w]];this.m?this.u(m):this.n.push(...m)}u(y){this.r.call("log",[this.s,y])}}class v{constructor(y,w){this.a=y,this.b=w}listen(y,w){const m=this.b(y);switch(w){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(c=>this.c(c,m)),removed:[...d.removed].map(c=>this.c(c,m))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,d=>[m.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,d=>(0,S.$Qj)(d)?d:[m.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${w}`)}async call(y,w,m){const d=this.b(y);switch(w){case"setLogLevel":return(0,S.$Qj)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(i.URI.revive(d.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,d)))}throw new Error(`Call not found: ${w}`)}c(y,w){return{...y,resource:w.transformOutgoingURI(y.resource)}}}e.$Vr=v;class $ extends D.$Uc{constructor(y,w){super(),w.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(m=>w.call("setLogLevel",[m]))),w.call("getRegisteredLoggers").then(m=>{for(const d of m)y.registerLogger({...d,resource:i.URI.revive(d.resource)})}),this.B(w.listen("onDidChangeVisibility")(([m,d])=>y.setVisibility(i.URI.revive(m),d))),this.B(w.listen("onDidChangeLoggers")(({added:m,removed:d})=>{for(const c of m)y.registerLogger({...c,resource:i.URI.revive(c.resource)});for(const c of d)y.deregisterLogger(c.resource)}))}}e.$Wr=$}),define(Ee[115],ke([1,0,2,13]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=void 0;class S extends i.$Uc{constructor(C,k=[]){super(),this.a=new A.$Yj([C,...k]),this.B(C.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...k){this.a.trace(C,...k)}debug(C,...k){this.a.debug(C,...k)}info(C,...k){this.a.info(C,...k)}warn(C,...k){this.a.warn(C,...k)}error(C,...k){this.a.error(C,...k)}flush(){this.a.flush()}}e.$_P=S}),define(Ee[236],ke([1,0,16,13]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=void 0;var S;(function($){$[$.Trace=0]="Trace",$[$.Debug=1]="Debug",$[$.Info=2]="Info",$[$.Warning=3]="Warning",$[$.Error=4]="Error",$[$.Critical=5]="Critical",$[$.Off=6]="Off"})(S||(S={}));async function D($,E,y,w,m){try{const d=await new Promise((g,u)=>{le(["@vscode/spdlog"],g,u)});d.setFlushOn(S.Trace);const c=await d.createAsyncRotatingLogger($,E,y,w);return m?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(d){console.error(d)}return null}function C($,E,y){switch(E){case A.LogLevel.Trace:$.trace(y);break;case A.LogLevel.Debug:$.debug(y);break;case A.LogLevel.Info:$.info(y);break;case A.LogLevel.Warning:$.warn(y);break;case A.LogLevel.Error:$.error(y);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function k($,E){switch(E){case A.LogLevel.Trace:$.setLevel(S.Trace);break;case A.LogLevel.Debug:$.setLevel(S.Debug);break;case A.LogLevel.Info:$.setLevel(S.Info);break;case A.LogLevel.Warning:$.setLevel(S.Warning);break;case A.LogLevel.Error:$.setLevel(S.Error);break;case A.LogLevel.Off:$.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${E}`)}}class v extends A.$Uj{constructor(E,y,w,m,d){super(),this.m=[],this.setLevel(d),this.n=this.s(E,y,w,m),this.B(this.onDidChangeLogLevel(c=>{this.r&&k(this.r,c)}))}async s(E,y,w,m){const d=w?6:1,c=30/d*i.$kl.MB,g=await D(E,y,c,d,m);if(g){this.r=g,k(this.r,this.getLevel());for(const{level:u,message:p}of this.m)C(this.r,u,p);this.m=[]}}g(E,y){this.r?C(this.r,E,y):this.getLevel()<=E&&this.m.push({level:E,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$1P=v}),define(Ee[116],ke([1,0,22,13,236]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=void 0;class D extends A.$Zj{s(k,v,$){return new S.$1P((0,i.$Eg)(),k.fsPath,!$?.donotRotate,!!$?.donotUseFormatters,v)}}e.$2P=D}),define(Ee[237],ke([1,0,63,200,5]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(D||(e.MarkerTag=D={}));var C;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(C||(e.MarkerSeverity=C={})),function(v){function $(d,c){return c-d}v.compare=$;const E=Object.create(null);E[v.Error]=(0,A.localize)(0,null),E[v.Warning]=(0,A.localize)(1,null),E[v.Info]=(0,A.localize)(2,null);function y(d){return E[d]||""}v.toString=y;function w(d){switch(d){case i.default.Error:return v.Error;case i.default.Warning:return v.Warning;case i.default.Info:return v.Info;case i.default.Ignore:return v.Hint}}v.fromSeverity=w;function m(d){switch(d){case v.Error:return i.default.Error;case v.Warning:return i.default.Warning;case v.Info:return i.default.Info;case v.Hint:return i.default.Ignore}}v.toSeverity=m}(C||(e.MarkerSeverity=C={}));var k;(function(v){const $="";function E(w){return y(w,!0)}v.makeKey=E;function y(w,m){const d=[$];return w.source?d.push(w.source.replace("\xA6","\\\xA6")):d.push($),w.code?typeof w.code=="string"?d.push(w.code.replace("\xA6","\\\xA6")):d.push(w.code.value.replace("\xA6","\\\xA6")):d.push($),w.severity!==void 0&&w.severity!==null?d.push(C.toString(w.severity)):d.push($),w.message&&m?d.push(w.message.replace("\xA6","\\\xA6")):d.push($),w.startLineNumber!==void 0&&w.startLineNumber!==null?d.push(w.startLineNumber.toString()):d.push($),w.startColumn!==void 0&&w.startColumn!==null?d.push(w.startColumn.toString()):d.push($),w.endLineNumber!==void 0&&w.endLineNumber!==null?d.push(w.endLineNumber.toString()):d.push($),w.endColumn!==void 0&&w.endColumn!==null?d.push(w.endColumn.toString()):d.push($),d.push($),d.join("\xA6")}v.makeKeyOptionalMessage=y})(k||(e.IMarkerData=k={})),e.$Ut=(0,S.$ii)("markerService")}),define(Ee[70],ke([1,0,6,41,2,5]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=void 0,e.$3n=(0,D.$ii)("policy");class C extends S.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new i.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions($){const E=Object.keys(this.f).length;return this.f={...$,...this.f},E!==Object.keys(this.f).length&&await this.j($),A.Iterable.reduce(this.g.entries(),(y,[w,m])=>({...y,[w]:m}),{})}getPolicyValue($){return this.g.get($)}serialize(){return A.Iterable.reduce(Object.entries(this.f),($,[E,y])=>({...$,[E]:{definition:y,value:this.g.get(E)}}),{})}}e.$4n=C;class k{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$5n=k}),define(Ee[58],ke([1,0,30]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const D=S.context.configuration();if(D)A=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:D.version})}}else A={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-toolsai.datawrangler":["debugFocus"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","handleIssueUri","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","contribIssueReporter"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["activeComment","commentingRangeHint","commentThreadApplicability","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","tokenInformation","codeActionRanges","commentReactor","contribShareMenu","fileComments","contribCommentPeekContext","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","treeViewMarkdownMessage","tabInputTextMerge","shareProvider","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["handleIssueUri","interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatParticipant","chatParticipantAdditions","defaultChatParticipant","chatVariableResolver","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","contribSourceControlInputBoxMenu","newSymbolNamesProvider","findFiles2","extensionsAny","authLearnMore","testObserver"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes","contribIssueReporter"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookCellExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"apidev.azure-api-center":["chatParticipant","languageModels"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:{github:["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],"github-enterprise":["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],microsoft:["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],"microsoft-sovereign-cloud":["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"]},trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})...",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},chatWelcomeView:{welcomeViewId:"copilot.welcome",welcomeViewTitle:"GitHub Copilot",welcomeViewContent:`You have access to GitHub Copilot, an AI-powered coding assistant, as a part of the Microsoft organization.
 Getting started with Copilot is easy - simply install the Copilot extension. [Learn more](https://code.visualstudio.com/docs/copilot/overview)
[Install GitHub Copilot](command:workbench.extensions.installExtension?%5B%22github.copilot%22%5D)`},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.88.0",sha256:"3a048d87c0fac116fce9190ff6042ec7691e66fc17211a058faf0db91bb6605e",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.88.1",commit:"e170252f762678dec6ca2cc69aba1570769a5d39",date:"2024-04-10T16:42:47.875Z"},Object.keys(A).length===0&&Object.assign(A,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(Ee[32],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,i.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"}),define(Ee[38],ke([1,0,96,11]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class S{constructor(){this.a=new Map}add(C,k){i.ok(A.$Vf(C)),i.ok(A.$Xf(k)),i.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,k)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$1n=new S}),define(Ee[238],ke([1,0,6,38]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n={JSONContribution:"base.contributions.json"};function S(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class D{constructor(){this.b=new i.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,$){this.a[S(v)]=$,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const C=new D;A.$1n.add(e.$2n.JSONContribution,C)}),define(Ee[47],ke([1,0,18,6,11,181,25,238,38]),function(le,e,i,A,S,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ConfigurationScope=e.$6n=e.EditPresentationTypes=void 0,e.$eo=c,e.$fo=g,e.$go=u,e.$ho=f,e.$io=h;var $;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$6n={Configuration:"base.contributions.configuration"};var E;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao="vscode://schemas/settings/resourceLanguage",e.$bo="vscode://schemas/settings/configurationDefaults";const y=v.$1n.as(k.$2n.JSONContribution);class w{constructor(){this.h=new Set,this.i=new A.$7d,this.onDidSchemaChange=this.i.event,this.j=new A.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$ao,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const o=new Set;this.n(t,a,o),y.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const a=new Set;this.o(t,a),y.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const o=new Set;this.o(a,o),this.n(t,!1,o),y.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const o=[];for(const{overrides:r,source:s}of t)for(const n in r)if(a.add(n),e.$do.test(n)){const b=this.a.get(n),P=b?.valuesSources??new Map;if(s)for(const j of Object.keys(r[n]))P.set(j,s);const I={...b?.value||{},...r[n]};this.a.set(n,{source:s,value:I,valuesSources:P});const O=(0,C.$Yi)(n),R={type:"object",default:I,description:D.localize(1,null,O),$ref:e.$ao,defaultDefaultValue:I,source:S.$Vf(s)?void 0:s,defaultValueSource:s};o.push(...c(n)),this.d[n]=R,this.b.properties[n]=R}else{this.a.set(n,{value:r[n],source:s});const b=this.d[n];b&&(this.w(n,b),this.r(n,b))}this.m(o)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:o,source:r}of t)for(const s in o){const n=this.a.get(s),b=S.$Vf(r)?r:r?.id,P=S.$Vf(n?.source)?n?.source:n?.source?.id;if(b===P)if(a.add(s),this.a.delete(s),e.$do.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(t){let a=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,o){t.forEach(r=>{this.p(r,a,r.extensionInfo,r.restrictedProperties,void 0,o),this.c.push(r),this.q(r)})}o(t,a){const o=r=>{if(r.properties)for(const s in r.properties){a.add(s);const n=this.d[s];n?.policy?.name&&this.e.delete(n.policy.name),delete this.d[s],this.s(s,r.properties[s])}r.allOf?.forEach(s=>o(s))};for(const r of t){o(r);const s=this.c.indexOf(r);s!==-1&&this.c.splice(s,1)}}p(t,a=!0,o,r,s=3,n){s=S.$5f(t.scope)?s:t.scope;const b=t.properties;if(b)for(const I in b){const O=b[I];if(a&&f(I,O)){delete b[I];continue}if(O.source=o,O.defaultDefaultValue=b[I].default,this.w(I,O),e.$do.test(I)?O.scope=void 0:(O.scope=S.$5f(O.scope)?s:O.scope,O.restricted=S.$5f(O.restricted)?!!r?.includes(I):O.restricted),b[I].hasOwnProperty("included")&&!b[I].included){this.f[I]=b[I],delete b[I];continue}else this.d[I]=b[I],b[I].policy?.name&&this.e.set(b[I].policy.name,I);!b[I].deprecationMessage&&b[I].markdownDeprecationMessage&&(b[I].deprecationMessage=b[I].markdownDeprecationMessage),n.add(I)}const P=t.allOf;if(P)for(const I of P)this.p(I,a,o,r,s,n)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=o=>{const r=o.properties;if(r)for(const n in r)this.r(n,r[n]);o.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$7n.properties[t]=a,a.scope){case 1:e.$8n.properties[t]=a;break;case 2:e.$9n.properties[t]=a;break;case 6:e.$0n.properties[t]=a;break;case 3:e.$$n.properties[t]=a;break;case 4:e.$_n.properties[t]=a;break;case 5:e.$_n.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$7n.properties[t],a.scope){case 1:delete e.$8n.properties[t];break;case 2:delete e.$9n.properties[t];break;case 6:delete e.$0n.properties[t];break;case 3:delete e.$$n.properties[t];break;case 4:case 5:delete e.$_n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,o={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.$ao};this.w(a,o),e.$7n.properties[a]=o,e.$8n.properties[a]=o,e.$9n.properties[a]=o,e.$0n.properties[a]=o,e.$$n.properties[a]=o,e.$_n.properties[a]=o}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.$ao};e.$7n.patternProperties[e.$co]=t,e.$8n.patternProperties[e.$co]=t,e.$9n.patternProperties[e.$co]=t,e.$0n.patternProperties[e.$co]=t,e.$$n.patternProperties[e.$co]=t,e.$_n.patternProperties[e.$co]=t,this.i.fire()}w(t,a){const o=this.a.get(t);let r=o?.value,s=o?.source;S.$3f(r)&&(r=a.defaultDefaultValue,s=void 0),S.$3f(r)&&(r=u(a.type)),a.default=r,a.defaultValueSource=s}}const m="\\[([^\\]]+)\\]",d=new RegExp(m,"g");e.$co=`^(${m})+$`,e.$do=new RegExp(e.$co);function c(l){const t=[];if(e.$do.test(l)){let a=d.exec(l);for(;a?.length;){const o=a[1].trim();o&&t.push(o),a=d.exec(l)}}return(0,i.$Mb)(t)}function g(l){return l.reduce((t,a)=>`${t}[${a}]`,"")}function u(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new w;v.$1n.add(e.$6n.Configuration,p);function f(l,t){return l.trim()?e.$do.test(l)?D.localize(7,null,l):p.getConfigurationProperties()[l]!==void 0?D.localize(8,null,l):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,l,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}function h(){const l=[],t=p.getConfigurationProperties();for(const a of Object.keys(t))l.push([a,t[a].scope]);return l.push(["launch",4]),l.push(["task",4]),l}}),define(Ee[117],ke([1,0,18,6,42,2,24,21,11,3,25,47,38]),function(le,e,i,A,S,D,C,k,v,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$mo=e.$lo=e.$ko=e.$jo=void 0,e.$no=f;function m(a){return Object.isFrozen(a)?a:k.$Pn(a)}class d{constructor(o={},r=[],s=[],n){this.b=o,this.c=r,this.d=s,this.raw=n,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(r=>{if(r instanceof d)return r;const s=new c("");return s.parseRaw(r),s.configurationModel});this.f=o.reduce((r,s)=>s===r?s:r.merge(s),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,E.$Wi)(this.contents,o):this.contents}inspect(o,r){const s=this;return{get value(){return m(s.rawConfiguration.getValue(o))},get override(){return r?m(s.rawConfiguration.getOverrideValue(o,r)):void 0},get merged(){return m(r?s.rawConfiguration.override(r).getValue(o):s.rawConfiguration.getValue(o))},get overrides(){const n=[];for(const{contents:b,identifiers:P,keys:I}of s.rawConfiguration.overrides){const O=new d(b,I).getValue(o);O!==void 0&&n.push({identifiers:P,value:O})}return n.length?m(n):void 0}}}getOverrideValue(o,r){const s=this.i(r);return s?o?(0,E.$Wi)(s,o):s:void 0}getKeysForOverrideIdentifier(o){const r=[];for(const s of this.overrides)s.identifiers.includes(o)&&r.push(...s.keys);return i.$Mb(r)}getAllOverrideIdentifiers(){const o=[];for(const r of this.overrides)o.push(...r.identifiers);return i.$Mb(o)}override(o){let r=this.a.get(o);return r||(r=this.g(o),this.a.set(o,r)),r}merge(...o){const r=k.$On(this.contents),s=k.$On(this.overrides),n=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const P of o)if(b.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(r,P.contents);for(const I of P.overrides){const[O]=s.filter(R=>i.$ub(R.identifiers,I.identifiers));O?(this.h(O.contents,I.contents),O.keys.push(...I.keys),O.keys=i.$Mb(O.keys)):s.push(k.$On(I))}for(const I of P.keys)n.indexOf(I)===-1&&n.push(I)}return new d(r,n,s,b.every(P=>P instanceof d)?void 0:b)}g(o){const r=this.i(o);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const s={};for(const n of i.$Mb([...Object.keys(this.contents),...Object.keys(r)])){let b=this.contents[n];const P=r[n];P&&(typeof b=="object"&&typeof P=="object"?(b=k.$On(b),this.h(b,P)):b=P),s[n]=b}return new d(s,this.keys,this.overrides)}h(o,r){for(const s of Object.keys(r)){if(s in o&&v.$Xf(o[s])&&v.$Xf(r[s])){this.h(o[s],r[s]);continue}o[s]=k.$On(r[s])}}i(o){let r=null,s=null;const n=b=>{b&&(s?this.h(s,b):s=k.$On(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===o?r=b.contents:b.identifiers.includes(o)&&n(b.contents);return n(r),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,r){this.j(o,r,!0)}setValue(o,r){this.j(o,r,!1)}removeValue(o){const r=this.keys.indexOf(o);r!==-1&&(this.keys.splice(r,1),(0,E.$Vi)(this.contents,o),y.$do.test(o)&&this.overrides.splice(this.overrides.findIndex(s=>i.$ub(s.identifiers,(0,y.$eo)(o))),1))}j(o,r,s){(0,E.$Ui)(this.contents,o,r,n=>console.error(n)),s=s||this.keys.indexOf(o)===-1,s&&this.keys.push(o),y.$do.test(o)&&this.overrides.push({identifiers:(0,y.$eo)(o),keys:Object.keys(this.contents[o]),contents:(0,E.$Ti)(this.contents[o],n=>console.error(n))})}}e.$jo=d;class c{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,r){if(!v.$5f(o)){const s=this.g(o);this.parseRaw(s,r)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,r){this.a=o;const{contents:s,keys:n,overrides:b,restricted:P,hasExcludedProperties:I}=this.h(o,r);this.b=new d(s,n,b,I?[o]:void 0),this.c=P||[]}g(o){let r={},s=null,n=[];const b=[],P=[];function I(R){Array.isArray(n)?n.push(R):s!==null&&(n[s]=R)}const O={onObjectBegin:()=>{const R={};I(R),b.push(n),n=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{n=b.pop()},onArrayBegin:()=>{const R=[];I(R),b.push(n),n=R,s=null},onArrayEnd:()=>{n=b.pop()},onLiteralValue:I,onError:(R,j,B)=>{P.push({error:R,offset:j,length:B})}};if(o)try{S.$Cn(o,O),r=n[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return r}h(o,r){const s=w.$1n.as(y.$6n.Configuration).getConfigurationProperties(),n=this.i(o,s,!0,r);o=n.raw;const b=(0,E.$Ti)(o,O=>console.error(`Conflict in settings file ${this.f}: ${O}`)),P=Object.keys(o),I=this.j(o,O=>console.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:b,keys:P,overrides:I,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}i(o,r,s,n){let b=!1;if(!n?.scopes&&!n?.skipRestricted&&!n?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:b};const P={},I=[];for(const O in o)if(y.$do.test(O)&&s){const R=this.i(o[O],r,!1,n);P[O]=R.raw,b=b||R.hasExcludedProperties,I.push(...R.restricted)}else{const R=r[O],j=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&I.push(O),!n.exclude?.includes(O)&&(n.include?.includes(O)||(j===void 0||n.scopes===void 0||n.scopes.includes(j))&&!(n.skipRestricted&&R?.restricted))?P[O]=o[O]:b=!0}return{raw:P,restricted:I,hasExcludedProperties:b}}j(o,r){const s=[];for(const n of Object.keys(o))if(y.$do.test(n)){const b={};for(const P in o[n])b[P]=o[n][P];s.push({identifiers:(0,y.$eo)(n),keys:Object.keys(b),contents:(0,E.$Ti)(b,r)})}return s}}e.$ko=c;class g extends D.$Uc{constructor(o,r,s,n){super(),this.c=o,this.f=r,this.g=n,this.b=this.B(new A.$7d),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&s.isEqual(b.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$lo=g;class u{constructor(o,r,s,n,b,P,I,O,R,j,B,Y,fe){this.a=o,this.b=r,this.c=s,this.overrideIdentifiers=n,this.d=b,this.f=P,this.g=I,this.h=O,this.i=R,this.j=j,this.k=B,this.l=Y,this.m=fe}get value(){return m(this.c)}n(o){return o?.value!==void 0||o?.override!==void 0||o?.overrides!==void 0?o:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class p{constructor(o,r,s,n,b=new d,P=new d,I=new C.$Bc,O=new d,R=new C.$Bc){this.c=o,this.d=r,this.f=s,this.g=n,this.h=b,this.i=P,this.j=I,this.l=O,this.m=R,this.a=null,this.b=new C.$Bc,this.n=null}getValue(o,r,s){return this.p(o,r,s).getValue(o)}updateValue(o,r,s={}){let n;s.resource?(n=this.m.get(s.resource),n||(n=new d,this.m.set(s.resource,n))):n=this.l,r===void 0?n.removeValue(o):n.setValue(o,r),s.resource||(this.a=null)}inspect(o,r,s){const n=this.p(o,r,s),b=this.t(r.resource,s),P=r.resource?this.m.get(r.resource)||this.l:this.l,I=new Set;for(const O of n.overrides)for(const R of O.identifiers)n.getOverrideValue(o,R)!==void 0&&I.add(R);return new u(o,r,n.getValue(o),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,b||void 0,P)}keys(o){const r=this.t(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,r){this.j.set(o,r),this.b.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,r){const s=[];if(!r){const{added:n,updated:b,removed:P}=l(this.c,o);r=[...n,...b,...P]}for(const n of r)for(const b of(0,y.$eo)(n)){const P=this.c.getKeysForOverrideIdentifier(b),I=o.getKeysForOverrideIdentifier(b),O=[...I.filter(R=>P.indexOf(R)===-1),...P.filter(R=>I.indexOf(R)===-1),...P.filter(R=>!k.$Sn(this.c.override(b).getValue(R),o.override(b).getValue(R)))];s.push([b,O])}return this.updateDefaultConfiguration(o),{keys:r,overrides:s}}compareAndUpdatePolicyConfiguration(o){const{added:r,updated:s,removed:n}=l(this.d,o),b=[...r,...s,...n];return b.length&&this.updatePolicyConfiguration(o),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:r,updated:s,removed:n,overrides:b}=l(this.applicationConfiguration,o),P=[...r,...s,...n];return P.length&&this.updateApplicationConfiguration(o),{keys:P,overrides:b}}compareAndUpdateLocalUserConfiguration(o){const{added:r,updated:s,removed:n,overrides:b}=l(this.localUserConfiguration,o),P=[...r,...s,...n];return P.length&&this.updateLocalUserConfiguration(o),{keys:P,overrides:b}}compareAndUpdateRemoteUserConfiguration(o){const{added:r,updated:s,removed:n,overrides:b}=l(this.remoteUserConfiguration,o),P=[...r,...s,...n];return P.length&&this.updateRemoteUserConfiguration(o),{keys:P,overrides:b}}compareAndUpdateWorkspaceConfiguration(o){const{added:r,updated:s,removed:n,overrides:b}=l(this.workspaceConfiguration,o),P=[...r,...s,...n];return P.length&&this.updateWorkspaceConfiguration(o),{keys:P,overrides:b}}compareAndUpdateFolderConfiguration(o,r){const s=this.folderConfigurations.get(o),{added:n,updated:b,removed:P,overrides:I}=l(s,r),O=[...n,...b,...P];return(O.length||!s)&&this.updateFolderConfiguration(o,r),{keys:O,overrides:I}}compareAndDeleteFolderConfiguration(o){const r=this.folderConfigurations.get(o);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:s,updated:n,removed:b,overrides:P}=l(r,void 0);return{keys:[...s,...n,...b],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(o,r,s){let n=this.q(r,s);return r.overrideIdentifier&&(n=n.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(n=n.merge(this.d)),n}q({resource:o},r){let s=this.r();if(r&&o){const n=r.getFolder(o);n&&(s=this.s(n.uri)||s);const b=this.m.get(o);b&&(s=s.merge(b))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(o){let r=this.b.get(o);if(!r){const s=this.r(),n=this.j.get(o);n?(r=s.merge(n),this.b.set(o,r)):r=s}return r}t(o,r){if(r&&o){const s=r.getFolder(o);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,r)=>{const{contents:s,overrides:n,keys:b}=this.j.get(r);return o.push([r,{contents:s,overrides:n,keys:b}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(r=>o.add(r)),this.userConfiguration.keys.forEach(r=>o.add(r)),this.i.keys.forEach(r=>o.add(r)),this.j.forEach(r=>r.keys.forEach(s=>o.add(s))),[...o.values()]}u(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(r=>o.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>o.add(r)),this.i.getAllOverrideIdentifiers().forEach(r=>o.add(r)),this.j.forEach(r=>r.getAllOverrideIdentifiers().forEach(s=>o.add(s))),[...o.values()]}v(o){const r=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>r.add(s)),this.i.getKeysForOverrideIdentifier(o).forEach(s=>r.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(o).forEach(n=>r.add(n))),[...r.values()]}static parse(o){const r=this.w(o.defaults),s=this.w(o.policy),n=this.w(o.application),b=this.w(o.user),P=this.w(o.workspace),I=o.folders.reduce((O,R)=>(O.set($.URI.revive(R[0]),this.w(R[1])),O),new C.$Bc);return new p(r,s,n,b,new d,P,I,new d,new C.$Bc)}static w(o){return new d(o.contents,o.keys,o.overrides)}}e.$mo=p;function f(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const o=new Set,r=new Map;for(const n of a)n.keys.forEach(b=>o.add(b)),n.overrides.forEach(([b,P])=>{const I=(0,C.$yc)(r,b,new Set);P.forEach(O=>I.add(O))});const s=[];return r.forEach((n,b)=>s.push([b,[...n.values()]])),{keys:[...o.values()],overrides:s}}class h{constructor(o,r,s,n){this.change=o,this.f=r,this.g=s,this.h=n,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of o.keys)this.affectedKeys.add(b);for(const[,b]of o.overrides)for(const P of b)this.affectedKeys.add(P);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(o,r){const s=this.a+o,n=this.d.indexOf(s);if(n<0)return!1;const b=n+s.length;if(b>=this.d.length)return!1;const P=this.d.charCodeAt(b);if(P!==this.b&&P!==this.c)return!1;if(r){const I=this.previousConfiguration?this.previousConfiguration.getValue(o,r,this.f?.workspace):void 0,O=this.g.getValue(o,r,this.h);return!k.$Sn(I,O)}return!0}}e.$oo=h;function l(a,o){const{added:r,removed:s,updated:n}=t(o?.rawConfiguration,a?.rawConfiguration),b=[],P=a?.getAllOverrideIdentifiers()||[],I=o?.getAllOverrideIdentifiers()||[];if(o){const O=I.filter(R=>!P.includes(R));for(const R of O)b.push([R,o.getKeysForOverrideIdentifier(R)])}if(a){const O=P.filter(R=>!I.includes(R));for(const R of O)b.push([R,a.getKeysForOverrideIdentifier(R)])}if(o&&a){for(const O of P)if(I.includes(O)){const R=t({contents:a.getOverrideValue(void 0,O)||{},keys:a.getKeysForOverrideIdentifier(O)},{contents:o.getOverrideValue(void 0,O)||{},keys:o.getKeysForOverrideIdentifier(O)});b.push([O,[...R.added,...R.removed,...R.updated]])}}return{added:r,removed:s,updated:n,overrides:b}}function t(a,o){const r=a?o?a.keys.filter(b=>o.keys.indexOf(b)===-1):[...a.keys]:[],s=o?a?o.keys.filter(b=>a.keys.indexOf(b)===-1):[...o.keys]:[],n=[];if(a&&o){for(const b of o.keys)if(a.keys.indexOf(b)!==-1){const P=(0,E.$Wi)(o.contents,b),I=(0,E.$Wi)(a.contents,b);k.$Sn(P,I)||n.push(b)}}return{added:r,removed:s,updated:n}}}),define(Ee[239],ke([1,0,18,6,2,21,11,117,47,13,70,38]),function(le,e,i,A,S,D,C,k,v,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=void 0;class w extends S.$Uc{constructor(){super(...arguments),this.a=this.B(new A.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new k.$jo}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.$1n.as(v.$6n.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:u})=>this.c(Array.from(g),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,u){this.h(g,y.$1n.as(v.$6n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new k.$jo;const g=y.$1n.as(v.$6n.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,u){const p=this.f();for(const f of g){const h=p[f],l=u[f];h!==void 0?this.b.addValue(f,h):l?this.b.addValue(f,l.default):this.b.removeValue(f)}}}e.$po=w;class m{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new k.$jo}async initialize(){return this.configurationModel}}e.$qo=m;let d=class extends S.$Uc{get configurationModel(){return this.b}constructor(g,u,p){super(),this.c=g,this.f=u,this.g=p,this.a=this.B(new A.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new k.$jo}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const u={},p=[],f=y.$1n.as(v.$6n.Configuration).getConfigurationProperties();for(const h of g){const l=f[h];if(!l){p.push(h);continue}if(l.policy){if(l.type!=="string"&&l.type!=="number"){this.g.warn(`Policy ${l.policy.name} has unsupported type ${l.type}`);continue}p.push(h),u[l.policy.name]={type:l.type}}}return(0,C.$9f)(u)||await this.f.updatePolicyDefinitions(u),p}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const u=y.$1n.as(v.$6n.Configuration).getPolicyConfigurations(),p=(0,i.$Hb)(g.map(f=>u.get(f)));this.m(p,!0)}m(g,u){this.g.trace("PolicyConfiguration#update",g);const p=y.$1n.as(v.$6n.Configuration).getConfigurationProperties(),f=[],h=this.b.isEmpty();for(const l of g){const t=p[l]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(h?a!==void 0:!(0,D.$Sn)(this.b.getValue(l),a))&&f.push([l,a])}else this.b.getValue(l)!==void 0&&f.push([l,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const l=this.b;this.b=new k.$jo;for(const t of l.keys)this.b.setValue(t,l.getValue(t));for(const[t,a]of f)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);u&&this.a.fire(this.b)}}};e.$ro=d,e.$ro=d=Le([Re(1,E.$3n),Re(2,$.$Oj)],d)}),define(Ee[118],ke([1,0,18,15,14,6,42,147,2,21,4,19,25,117,47,239,70]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0;class u extends v.$Uc{constructor(h,l,t,a){super(),this.m=h,this.h=this.B(new D.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new c.$po),this.c=t instanceof g.$5n?new c.$qo:this.B(new c.$ro(this.b,t,a)),this.f=this.B(new m.$lo(this.m,{},y.$Mg,l)),this.a=new m.$mo(this.b.configurationModel,this.c.configurationModel,new m.$jo,new m.$jo),this.j=new p(h,l,this),this.g=this.B(new A.$uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:o,properties:r})=>this.r(o,r))),this.B(this.c.onDidChangeConfiguration(o=>this.s(o))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,l,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new m.$mo(h,l,new m.$jo,t)}getConfigurationData(){return this.a.toData()}getValue(h,l){const t=typeof h=="string"?h:void 0,a=(0,w.$Pi)(h)?h:(0,w.$Pi)(l)?l:{};return this.a.getValue(t,a,void 0)}async updateValue(h,l,t,a,o){const r=(0,w.$Qi)(t)?t:(0,w.$Pi)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,s=r?a:t;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${h} to target ${s}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,i.$Mb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const n=this.inspect(h,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(n.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,$.$Sn)(l,n.defaultValue)&&(l=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const P=r.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(O=>(0,i.$ub)([...O.identifiers].sort(),P));I&&(r.overrideIdentifiers=I.identifiers)}const b=r?.overrideIdentifiers?.length?[(0,d.$fo)(r.overrideIdentifiers),h]:[h];await this.j.write(b,l),await this.reloadConfiguration()}inspect(h,l={}){return this.a.inspect(h,l,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const l=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(t,l,2)}r(h,l){const t=this.a.toData(),a=this.a.compareAndUpdateDefaultConfiguration(h,l);this.t(a,t,7)}s(h){const l=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(h);this.t(t,l,7)}t(h,l,t){const a=new m.$oo(h,{data:l},this.a);a.source=t,this.h.fire(a)}}e.$so=u;class p{constructor(h,l,t){this.b=h,this.c=l,this.d=t,this.a=new A.$ph}write(h,l){return this.a.queue(()=>this.e(h,l))}async e(h,l){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===1)t="{}";else throw r}const a=[];if((0,C.$vn)(t,a,{allowTrailingComma:!0,allowEmptyContent:!0}),a.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const o=this.f(t,h,l);t=(0,k.$Nn)(t,o),await this.c.writeFile(this.b,S.$ue.fromString(t))}f(h,l,t){const{tabSize:a,insertSpaces:o,eol:r}=this.h;if(!l.length){const s=JSON.stringify(t,null,o?" ".repeat(a):"	");return[{content:s,length:s.length,offset:0}]}return(0,k.$Kn)(h,l,t,{tabSize:a,insertSpaces:o,eol:r})}get h(){if(!this.g){let h=E.OS===3||E.OS===2?`
`:`\r
`;const l=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});l&&typeof l=="string"&&l!=="auto"&&(h=l),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(Ee[119],ke([1,0,10,5]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=$,e.$tl=(0,A.$ii)("remoteAuthorityResolverService");var S;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class D{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=D;class C{constructor(y,w){this.host=y,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=C;var k;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class v extends i.$bb{static isNotAvailable(y){return y instanceof v&&y._code===k.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof v&&y._code===k.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof v&&y._code===k.NoResolverFound}static isInvalidAuthority(y){return y instanceof v&&y._code===k.InvalidAuthority}static isHandled(y){return y instanceof v&&y.isHandled}constructor(y,w=k.Unknown,m){super(y),this._message=y,this._code=w,this._detail=m,this.isHandled=w===k.NotAvailable&&m===!0,Object.setPrototypeOf(this,v.prototype)}}e.$wl=v;function $(E){const y=E.indexOf("+");return y===-1?E:E.substring(0,y)}}),define(Ee[240],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cQ=e.$bQ=void 0,e.$bQ=(0,i.$ii)("IRemoteExtensionsScannerService"),e.$cQ="remoteExtensionsScanner"}),define(Ee[85],ke([1,0,12]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=A,e.$um=S,e.$vm=D,e.$wm=C;function A(v){return v.scheme===i.Schemas.vscodeRemote?v.authority:void 0}function S(v){if(!v)return;const $=v.indexOf("+");return $<0?v:v.substr(0,$)}function D(v){const{host:$,port:E}=k(v);if(typeof E>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:$,port:E}}function C(v,$){let{host:E,port:y}=k(v);return typeof y>"u"&&(y=$),{host:E,port:y}}function k(v){const $=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const E=v.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=v.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:v,port:void 0}}}),define(Ee[35],ke([1,0,17,5,85]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Fm=e.$Em=e.$Dm=e.TargetPlatform=e.ExtensionType=e.$Cm=e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$Bm=D,e.$Gm=y,e.$Hm=w,e.$Im=m,e.$Jm=d,e.$xm="extensions.user.cache",e.$ym="extensions.builtin.cache",e.$zm="undefined_publisher",e.$Am=["ui","workspace","web"];function D(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$Cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var C;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(C||(e.ExtensionType=C={}));var k;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class v{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,u){if(typeof g>"u"||g===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof g=="string"||typeof u=="string"){const p=typeof g=="string"?g:g.value,f=typeof u=="string"?u:u.value;return i.$lf(p,f)}return g._lower===u._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Dm=v;class ${get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const u of g)this.add(u)}add(g){this.c.add(v.toKey(g))}delete(g){return this.c.delete(v.toKey(g))}has(g){return this.c.has(v.toKey(g))}}e.$Em=$;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(v.toKey(g))}get(g){return this.c.get(v.toKey(g))}has(g){return this.c.has(v.toKey(g))}set(g,u){this.c.set(v.toKey(g),u)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fm=E;function y(c){return w(c)}function w(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function m(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function d(c,g){if(g){const u=`onResolveRemoteAuthority:${(0,S.$um)(g)}`;return!!c.activationEvents?.includes(u)}return!1}e.$Km=(0,A.$ii)("IBuiltinExtensionsScannerService")}),define(Ee[241],ke([1,0,10,35]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=e.$SF=void 0;class S{constructor(){this.a=new Map,this.b=new WeakMap}register(C,k){this.a.set(C,k)}readActivationEvents(C){return this.b.has(C)||this.b.set(C,this.c(C)),this.b.get(C)}createActivationEventsMap(C){const k=Object.create(null);for(const v of C){const $=this.readActivationEvents(v);$.length>0&&(k[A.$Dm.toKey(v.identifier)]=$)}return k}c(C){if(typeof C.main>"u"&&typeof C.browser>"u")return[];const k=Array.isArray(C.activationEvents)?C.activationEvents.slice(0):[];for(let v=0;v<k.length;v++)k[v]==="onUri"&&(k[v]=`onUri:${A.$Dm.toKey(C.identifier)}`);if(!C.contributes)return k;for(const v in C.contributes){const $=this.a.get(v);if(!$)continue;const E=C.contributes[v],y=Array.isArray(E)?E:[E];try{$(y,k)}catch(w){(0,i.$1)(w)}}return k}}e.$SF=S,e.$TF=new S}),define(Ee[242],ke([1,0,2,35,16]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class D extends i.$Uc{constructor(k,v,$,E,y){super(),this.a=k,this.b=v,this.c=$,this.f=y,this.B(E.onDidInstallExtensions(w=>this.g(w))),this.B(E.onDidUninstallExtension(w=>this.h(w)))}g(k){for(const v of k)v.local&&this.invalidate(v.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,k)&&await this.j(v);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,A.$xm))}catch(v){(0,S.$6k)(v)!==1&&this.f.error(v)}}}e.$nq=D}),define(Ee[48],ke([1,0,14,10,2,201,47,5,13,38]),function(le,e,i,A,S,D,C,k,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=void 0,e.$Bp=w,e.$Cp=m,e.$Dp=d,e.$Ep=c,e.$Fp=g,e.$Gp=u,e.$zp=(0,k.$ii)("requestService");class E{constructor(l){this.b=l}toJSON(){if(!this.a){const l=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?l[t]="*****":l[t]=this.b[t];this.a=l}return this.a}}class y extends S.$Uc{constructor(l){super(),this.b=0,this.a=l.createLogger("network",{name:(0,D.localize)(0,null),when:v.$7j.isEqualTo((0,v.$4j)(v.LogLevel.Trace)).serialize()})}async c(l,t,a){const o=`${l} #${++this.b}: ${t.url}`;this.a.trace(`${o} - begin`,t.type,new E(t.headers??{}));try{const r=await a();return this.a.trace(`${o} - end`,t.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.a.error(`${o} - error`,t.type,(0,A.$0)(r)),r}}}e.$Ap=y;function w(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}function m(h){return h.res.statusCode===204}async function d(h){return m(h)?null:(await(0,i.$Ge)(h.stream)).toString()}async function c(h){if(!w(h))throw new Error("Server returned "+h.res.statusCode);return d(h)}async function g(h){if(!w(h))throw new Error("Server returned "+h.res.statusCode);if(m(h))return null;const t=(await(0,i.$Ge)(h.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}function u(h){f(h)}let p;function f(h){const l=$.$1n.as(C.$6n.Configuration),t=p;p={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(12,null),restricted:!0}}},l.updateConfigurations({add:[p],remove:t?[t]:[]})}f(1)}),define(Ee[243],ke([1,0,20,12,16,48]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=void 0;let C=class{constructor(v,$){this.a=v,this.b=$}async download(v,$,E=i.CancellationToken.None){if(v.scheme===A.Schemas.file||v.scheme===A.Schemas.vscodeRemote){await this.b.copy(v,$);return}const y={type:"GET",url:v.toString(!0)},w=await this.a.request(y,E);if(w.res.statusCode===200)await this.b.writeFile($,w.stream);else{const m=await(0,D.$Ep)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${m}`)}}};e.$oQ=C,e.$oQ=C=Le([Re(0,D.$zp),Re(1,S.$Ok)],C)}),define(Ee[244],ke([1,0,14,20]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;class S{constructor(k){this.a=k}listen(k,v){throw new Error("Invalid listen")}call(k,v,$,E=A.CancellationToken.None){switch(v){case"request":return this.a.request($[0],E).then(async({res:y,stream:w})=>{const m=await(0,i.$Ge)(w);return[{statusCode:y.statusCode,headers:y.headers},m]});case"resolveProxy":return this.a.resolveProxy($[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Er=S;class D{constructor(k){this.a=k}async request(k,v){const[$,E]=await this.a.call("request",[k],v);return{res:$,stream:(0,i.$Ie)(E)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Fr=D}),define(Ee[245],ke([1,0,86,11]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=D;function S(C,k){return C.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:C.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function D(C,k,v={}){const $=(0,i.parse)(C),E=v.proxyUrl||S($,k);if(!E)return null;const y=(0,i.parse)(E);if(!/^https?:$/.test(y.protocol||""))return null;const w={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,A.$2f)(v.strictSSL)?v.strictSSL:!0};return $.protocol==="http:"?new(await new Promise((m,d)=>{le(["http-proxy-agent"],m,d)})).HttpProxyAgent(E,w):new(await new Promise((m,d)=>{le(["https-proxy-agent"],m,d)})).HttpsProxyAgent(E,w)}}),define(Ee[87],ke([1,0,55,7,202,20,40,10,4,22,106,219,15,150]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=c;let d;async function c(u,p,f,h){return f["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$mm)(h)&&!f["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$mm)(h)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=w.Promises.withAsyncBody(async(l,t)=>{const a=new D.$ee;let o=1e4;const r=u.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(o=(0,m.$nm)(r,1,120)*1e3);const s=setTimeout(()=>{a.dispose(!0),t(new Error((0,S.localize)(0,null)))},o);try{l(await g(p,a.token))}catch(n){!(0,k.$4)(n)&&!a.token.isCancellationRequested?t(new Error((0,S.localize)(1,null,(0,C.$6i)(n)))):l({})}finally{clearTimeout(s),a.dispose()}})),d)}async function g(u,p){const f=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",f);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",h);const l=(0,$.$Eg)().replace(/-/g,"").substr(0,12),t=new RegExp(l+"({.*})"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",a);const o=await(0,E.$cm)(v.OS,a);return u.trace("getUnixShellEnvironment#shell",o),new Promise((r,s)=>{if(p.isCancellationRequested)return s(new k.$5);const n=(0,A.$oc)(o);let b,P;const I="";/^pwsh(-preview)?$/.test(n)?(b=`& '${process.execPath}' ${I} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,P=["-Login","-Command"]):n==="nu"?(b=`^'${process.execPath}' ${I} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,P=["-i","-l","-c"]):n==="xonsh"?(b=`import os, json; print("${l}", json.dumps(dict(os.environ)), "${l}")`,P=["-i","-l","-c"]):(b=`'${process.execPath}' ${I} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,n==="tcsh"||n==="csh"?P=["-ic"]:P=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),b);const O=(0,i.spawn)(o,[...P,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});p.onCancellationRequested(()=>(O.kill(),s(new k.$5))),O.on("error",B=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,C.$6i)(B)),s(B)});const R=[];O.stdout.on("data",B=>R.push(B));const j=[];O.stderr.on("data",B=>j.push(B)),O.on("close",(B,Y)=>{const fe=Buffer.concat(R).toString("utf8");u.trace("getUnixShellEnvironment#raw",fe);const ue=Buffer.concat(j).toString("utf8");if(ue.trim()&&u.trace("getUnixShellEnvironment#stderr",ue),B||Y)return s(new Error((0,S.localize)(2,null,B,Y)));const re=t.exec(fe),te=re?re[1]:"{}";try{const V=JSON.parse(te);f?V.ELECTRON_RUN_AS_NODE=f:delete V.ELECTRON_RUN_AS_NODE,h?V.ELECTRON_NO_ATTACH_CONSOLE=h:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.VSCODE_RESOLVING_ENVIRONMENT,delete V.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",V),r(V)}catch(V){u.error("getUnixShellEnvironment#errorCaught",(0,C.$6i)(V)),s(V)}})})}}),define(Ee[246],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=e.$3P=void 0,e.$3P=(0,i.$ii)("stateReadService"),e.$4P=(0,i.$ii)("stateService")}),define(Ee[247],ke([1,0,15,14,2,11,26,16,13]),function(le,e,i,A,S,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=e.$5P=e.SaveStrategy=void 0;var $;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})($||(e.SaveStrategy=$={}));class E extends S.$Uc{constructor(d,c,g,u){super(),this.h=d,this.j=c,this.m=g,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new i.$gh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.m.error(d)}}getItem(d,c){const g=this.a[d];return(0,D.$5f)(g)?c:g}setItem(d,c){this.setItems([{key:d,data:c}])}setItems(d){let c=!1;for(const{key:g,data:u}of d)this.a[g]!==u&&((0,D.$5f)(u)?(0,D.$3f)(this.a[g])||(this.a[g]=void 0,c=!0):(this.a[g]=u,c=!0));c&&this.s()}removeItem(d){(0,D.$3f)(this.a[d])||(this.a[d]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.n.writeFile(this.h,A.$ue.fromString(d),{atomic:{postfix:".vsctmp"}}),this.b=d}catch(c){this.m.error(c)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$5P=E;let y=class extends S.$Uc{constructor(d,c,g,u){super(),this.a=this.B(new E(c.stateResource,d,g,u))}async init(){await this.a.init()}getItem(d,c){return this.a.getItem(d,c)}};e.$6P=y,e.$6P=y=Le([Re(1,C.$pi),Re(2,v.$Oj),Re(3,k.$Ok)],y);class w extends y{setItem(d,c){this.a.setItem(d,c)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.$7P=w}),define(Ee[120],ke([1,0,4,30,22]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=C,e.$3o=k;function D(v){if(i.$u===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function C(v,$,E,y,w,m,d,c,g){const u=Object.create(null);u["common.machineId"]=m,u["common.sqmId"]=d,u.sessionID=(0,S.$Eg)()+Date.now(),u.commitHash=y,u.version=w,u["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,i.$h)(i.$u),u["common.nodePlatform"]=A.$ec,u["common.nodeArch"]=E,u["common.product"]=g||"desktop",c&&(u["common.msftInternal"]=c);let p=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),i.$l&&(u["common.snap"]="true");const h=D($);return h&&(u["common.platformDetail"]=h),u}function k(v){const $=A.env.USERDNSDOMAIN;if(!$)return!1;const E=$.toLowerCase();return v.some(y=>E===y)}}),define(Ee[248],ke([1,0,18,10,2,21,16]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var k;(function($){function E(y,w){return y.callstack<w.callstack?-1:y.callstack>w.callstack?1:0}$.compare=E})(k||(e.ErrorEvent=k={}));class v{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(E,y=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new S.$Tc,this.c=E,this.d=y;const w=A.$X.addListener(m=>this.j(m));this.h.add((0,S.$Sc)(w)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(E){if(!E||E.code||(E.detail&&E.detail.stack&&(E=E.detail),A.$bb.isErrorNoTelemetry(E)||E instanceof C.$0k||typeof E?.message=="string"&&E.message.includes("Unable to read file")))return;const y=Array.isArray(E.stack)?E.stack.join(`
`):E.stack,w=E.message?E.message:(0,D.$Tn)(E);y&&this.k({msg:w,callstack:y})}k(E){const y=(0,i.$wb)(this.g,E,k.compare);y<0?(E.count=1,this.g.splice(~y,0,E)):(this.g[y].count||(this.g[y].count=0),this.g[y].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const E of this.g)this.c.publicLogError2("UnhandledError",E);this.g.length=0}}e.default=v}),define(Ee[249],ke([1,0,2]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class A extends i.$Uc{constructor(D,C){super(),this.a=D,this.b=C}async call(D,C,k){switch(C){case"updateTelemetryLevel":{const{telemetryLevel:v}=k;return this.a.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:$}=k;return this.b?this.b.log(v,$):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${C} not found`)}listen(D,C,k){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$ys=A}),define(Ee[28],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,i.$ii)("telemetryService"),e.$Ol=(0,i.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var A;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var S;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(Ee[250],ke([1,0,29,15,42,12,7,4,3,102,23,105,225,16,32,28]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0,e.$ns=u,e.$os=f,e.$ps=h;const g=new Map;async function u(t,a){const o=`${t}::${a.join(":")}`,r=g.get(o);if(r)return r;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],n=new Map,b=new Map,P=2e4;function I(R,j,B,Y){const fe=j.substring(R.length+1);return A.Promises.withAsyncBody(async ue=>{let re;try{re=await E.Promises.readdir(j,{withFileTypes:!0})}catch{ue();return}if(Y.count>=P){Y.count+=re.length,Y.maxReached=!0,ue();return}let te=re.length;if(te===0){ue();return}let V=re;Y.count+re.length>P&&(Y.maxReached=!0,te=P-Y.count,V=re.slice(0,te)),Y.count+=re.length;for(const T of V)if(T.isDirectory()){if(B.includes(T.name)||await I(R,(0,C.$kc)(j,T.name),B,Y),--te===0){ue();return}}else{const x=T.name.lastIndexOf(".");if(x>=0){const Z=T.name.substring(x+1);Z&&n.set(Z,(n.get(Z)??0)+1)}for(const Z of s)Z.relativePathPattern?.test(fe)!==!1&&Z.filePattern.test(T.name)&&b.set(Z.tag,(b.get(Z.tag)??0)+1);if(--te===0){ue();return}}})}const O=A.Promises.withAsyncBody(async R=>{const j={count:0,maxReached:!1};await I(t,t,a,j);const B=await h(t);R({configFiles:p(b),fileTypes:p(n),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:B})});return g.set(o,O),O}function p(t){return Array.from(t.entries(),([a,o])=>({name:a,count:o})).sort((a,o)=>o.count-a.count)}function f(){const t={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/m.$kl.GB).toFixed(2)}GB (${(i.freemem()/m.$kl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$qn.value()*100)}%`},a=i.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}async function h(t){try{const a=new Map,o=(0,C.$kc)(t,".vscode","launch.json"),r=await E.Promises.readFile(o),s=[],n=(0,S.$vn)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${o}`),[];if((0,S.$En)(n)==="object"&&n.configurations)for(const b of n.configurations){const P=b.type;P&&(a.has(P)?a.set(P,a.get(P)+1):a.set(P,1))}return p(a)}catch{return[]}}let l=class{constructor(a,o){this.c=a,this.d=o}f(a){const o=[];return o.push(`OS Version:       ${a.os}`),o.push(`CPUs:             ${a.cpus}`),o.push(`Memory (System):  ${a.memory}`),o.push(`VM:               ${a.vmHint}`),o.join(`
`)}g(a){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const r=i.cpus();return r&&r.length>0&&o.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),o.push(`Memory (System):  ${(i.totalmem()/m.$kl.GB).toFixed(2)}GB (${(i.freemem()/m.$kl.GB).toFixed(2)}GB free)`),k.$i||o.push(`Load (avg):       ${i.loadavg().map(s=>Math.round(s)).join(", ")}`),o.push(`VM:               ${Math.round($.$qn.value()*100)}%`),o.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${a.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(a,o){return Promise.all([(0,y.$ms)(a.mainPID),this.k(a)]).then(async r=>{let[s,n]=r,b=this.m(a,s);return o.forEach(P=>{if((0,w.$3m)(P))b+=`
${P.errorMessage}`,n+=`
${P.errorMessage}`;else if(b+=`

Remote: ${P.hostName}`,P.processes&&(b+=`
${this.m(a,P.processes)}`),P.workspaceMetadata){n+=`
|  Remote: ${P.hostName}`;for(const I of Object.keys(P.workspaceMetadata)){const O=P.workspaceMetadata[I];let R=`${O.fileCount} files`;O.maxFilesReached&&(R=`more than ${R}`),n+=`|    Folder (${I}): ${R}`,n+=this.h(O)}}}),{processInfo:b,workspaceInfo:n}})}async getSystemInfo(a,o){const{memory:r,vmHint:s,os:n,cpus:b}=f(),P={os:n,memory:r,cpus:b,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:o};return k.$i||(P.load=`${i.loadavg().map(I=>Math.round(I)).join(", ")}`),k.$k&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(a,o){const r=[];return(0,y.$ms)(a.mainPID).then(async s=>(r.push(""),r.push(this.g(a)),r.push(""),r.push(this.m(a,s)),a.windows.some(n=>n.folderURIs&&n.folderURIs.length>0&&!n.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(a))),o.forEach(n=>{if((0,w.$3m)(n))r.push(`
${n.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${n.hostName}`),r.push(this.f(n.machineInfo)),n.processes&&r.push(this.m(a,n.processes)),n.workspaceMetadata)for(const b of Object.keys(n.workspaceMetadata)){const P=n.workspaceMetadata[b];let I=`${P.fileCount} files`;P.maxFilesReached&&(I=`more than ${I}`),r.push(`Folder (${b}): ${I}`),r.push(this.h(P))}}),r.push(""),r.push(""),r.join(`
`)))}h(a){const o=[];let s=0;const n=(O,R)=>{const j=` ${O}(${R})`;s+j.length>60?(o.push(b),b="|                 ",s=b.length):s+=j.length,b+=j};let b="|      File types:";const P=10,I=a.fileTypes.length>P?P:a.fileTypes.length;for(let O=0;O<I;O++){const R=a.fileTypes[O];n(R.name,R.count)}if(o.push(b),a.configFiles.length>=0&&(b="|      Conf files:",s=0,a.configFiles.forEach(O=>{n(O.name,O.count)}),o.push(b)),a.launchConfigFiles.length>0){let O="|      Launch Configs:";a.launchConfigFiles.forEach(R=>{const j=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;O+=j}),o.push(O)}return o.join(`
`)}j(a){const o=Math.max(...Object.keys(a).map(r=>r.length));return Object.keys(a).map(r=>`${r}:  ${" ".repeat(o-r.length)}  ${a[r]}`).join(`
                  `)}k(a){const o=[],r=[];return a.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(o.push(`|  Window (${s.title})`),s.folderURIs.forEach(n=>{const b=v.URI.revive(n);if(b.scheme===D.Schemas.file){const P=b.fsPath;r.push(u(P,["node_modules",".git"]).then(I=>{let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),o.push(`|    Folder (${(0,C.$oc)(P)}): ${O}`),o.push(this.h(I))}).catch(I=>{o.push(`|      Error: Unable to collect workspace stats for folder ${P} (${I.toString()})`)}))}else o.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>o.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(a,o){const r=new Map;a.windows.forEach(n=>r.set(n.pid,`window [${n.id}] (${n.title})`)),a.pidToNames.forEach(({pid:n,name:b})=>r.set(n,b));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),o&&this.n(a.mainPID,r,s,o,0),s.join(`
`)}n(a,o,r,s,n){const b=n===0;let P;b?P=s.pid===a?`${this.d.applicationName} main`:"remote agent":o.has(s.pid)?P=o.get(s.pid):P=`${"  ".repeat(n)} ${s.name}`;const I=process.platform==="win32"?s.mem:i.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(I/m.$kl.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(s.children)&&s.children.forEach(O=>this.n(a,o,r,O,n+1))}async getWorkspaceFileExtensions(a){const o=new Set;for(const{uri:r}of a.folders){const s=v.URI.revive(r);if(s.scheme!==D.Schemas.file)continue;const n=s.fsPath;try{(await u(n,["node_modules",".git"])).fileTypes.forEach(P=>o.add(P.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(a){for(const{uri:o}of a.folders){const r=v.URI.revive(o);if(r.scheme!==D.Schemas.file)continue;const s=r.fsPath;try{const n=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),n.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:b.name,count:b.count})}),n.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:b.name,count:b.count})}),n.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$qs=l,e.$qs=l=Le([Re(0,c.$Nl),Re(1,d.$8j)],l)}),define(Ee[88],ke([1,0,10,5,13,28]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0,e.$Xp=(0,A.$ii)("IExtensionSignatureVerificationService");let C=class{constructor(v,$){this.b=v,this.c=$}d(){return this.a||(this.a=new Promise((v,$)=>le(["@vscode/vsce-sign"],async E=>v(E),$))),this.a}async verify(v,$,E){let y;try{y=await this.d()}catch(c){return this.b.error("Could not load vsce-sign module",(0,i.$0)(c)),!1}const w=new Date().getTime();let m,d;try{return m=await y.verify(v,$,E),m}catch(c){throw d=c,c}finally{const c=new Date().getTime()-w;this.c.publicLog2("extensionsignature:verification",{duration:c,verified:m,error:d?d.code??"unknown":void 0})}}};e.$Yp=C,e.$Yp=C=Le([Re(0,S.$Oj),Re(1,D.$Nl)],C)}),define(Ee[39],ke([1,0,21,11,85,120,28]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=E,e.$_o=y,e.$ap=w,e.$bp=m,e.$cp=c,e.$dp=u,e.$ep=p,e.$fp=l;class k{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$4o=k;class v{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5o=v,e.$6o=new v;class ${async publicLog(a,o,r){}async publicLogError(a,o,r){}}e.$7o=$,e.$8o="telemetry",e.$9o="extensionTelemetryLog",e.$0o={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!t.enableTelemetry)}function y(t,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function w(t){const a=t.getValue(C.$Vl),o=t.getValue(C.$Wl);if(t.getValue(C.$Xl)===!1||o===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function m(t){const a={},o={},r={};g(t,r);for(let s in r){s=s.length>150?s.substr(s.length-149):s;const n=r[s];typeof n=="number"?o[s]=n:typeof n=="boolean"?o[s]=n?1:0:typeof n=="string"?(n.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${n.length}`),a[s]=n.substring(0,8191)):typeof n<"u"&&n!==null&&(a[s]=n)}return{properties:a,measurements:o}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const a=(0,S.$um)(t);return d.has(a)?a:"other"}function g(t,a,o=0,r){if(t)for(const s of Object.getOwnPropertyNames(t)){const n=t[s],b=r?r+s:s;Array.isArray(n)?a[b]=(0,i.$Tn)(n):n instanceof Date?a[b]=n.toISOString():(0,A.$Xf)(n)?o<2?g(n,a,o+1,b+"."):a[b]=(0,i.$Tn)(n):a[b]=n}}function u(t,a){const o=t.msftInternalDomains||[],r=a.getValue("telemetry.internalTesting");return(0,D.$3o)(o)||r}function p(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function f(t,a){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const r=[];for(const P of a)for(;;){const I=P.exec(t);if(!I)break;r.push([I.index,P.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(o="";;){const P=n.exec(t);if(!P)break;const I=r.some(([O,R])=>P.index<R&&O<n.lastIndex);!s.test(P[0])&&!I&&(o+=t.substring(b,P.index)+"<REDACTED: user-file-path>",b=n.lastIndex)}return b<t.length&&(o+=t.substr(b)),o}function h(t){if(!t)return t;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of a)if(o.regex.test(t))return`<REDACTED: ${o.label}>`;return t}function l(t,a){return(0,i.$Qn)(t,o=>{if(o instanceof k||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let r=o.replaceAll("%20"," ");r=f(r,a);for(const s of a)r=r.replace(s,"");return r=h(r),r}})}}),define(Ee[36],ke([1,0,17,31,35,4,3,10,30,39]),function(le,e,i,A,S,D,C,k,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$hp=void 0,e.$gp=E,e.$ip=d,e.$jp=c,e.$kp=g,e.$lp=u,e.$mp=p,e.$np=f,e.$op=h,e.$qp=l,e.$rp=a;function E(o,r){return o.uuid&&r.uuid?o.uuid===r.uuid:o.id===r.id?!0:(0,i.$gf)(o.id,r.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(r){const s=r.manifest?r.manifest.version:r.version,n=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new w(r.identifier,s,n)}static parse(r){const s=y.exec(r);return s&&s[1]&&s[2]?new w({id:s[1]},s[2],s[4]||void 0):null}constructor(r,s,n="undefined"){this.version=s,this.targetPlatform=n,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof w?E(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.$hp=w;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(o){const r=m.exec(o);return r&&r[1]?[g(r[1]),r[2]]:[g(o),void 0]}function c(o,r){return`${o}.${r}`}function g(o){return o.toLowerCase()}function u(o,r){return g(c(o??S.$zm,r))}function p(o,r){const s=[],n=b=>{for(const P of s)if(P.some(I=>E(r(I),r(b))))return P;return null};for(const b of o){const P=n(b);P?P.push(b):s.push([b])}return s}function f(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function h(o){return{id:new $.$4o(o.identifier.id),name:new $.$4o(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$pp=new S.$Dm("pprice.better-merge");function l(o,r){const s=[],n=r.manifest.extensionDependencies?.slice(0)??[];for(;n.length;){const b=n.shift();if(b&&s.every(P=>!E(P.identifier,{id:b}))){const P=o.filter(I=>E(I.identifier,{id:b}));P.length===1&&(s.push(P[0]),n.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(o,r){if(!D.$k)return!1;let s;try{s=(await o.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await o.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){r.debug("Error while getting the os-release file.",(0,k.$0)(b))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(o,r){const s=await t(o,r),n=(0,A.$No)(s?"alpine":D.$u,v.$fc);return r.debug("ComputeTargetPlatform:",n),n}}),define(Ee[121],ke([1,0,20,10,12,19,56,3,188,31,36,35]),function(le,e,i,A,S,D,C,k,v,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;const w=c=>(0,v.localize)(0,null,c),m=(0,v.localize)(1,null,"ms-dotnettools.csharp");let d=class{constructor(g,u,p){this.a=g,this.b=u,this.d=p}get f(){}async listExtensions(g,u,p){let f=await this.b.getInstalled(1,p);const h=y.$Cm.map(t=>t.toLowerCase());if(u&&u!==""){if(h.indexOf(u.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}f=f.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){this.a.info("Possible Categories: "),h.forEach(t=>{this.a.info(t)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),f=f.sort((t,a)=>t.identifier.id.localeCompare(a.identifier.id));let l;for(const t of f)l!==t.identifier.id&&(l=t.identifier.id,this.a.info(g?`${l}@${t.manifest.version}`:l))}async installExtensions(g,u,p,f){const h=[];try{g.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const l=[],t=[],a=(r,s,n)=>{t.push({id:r,version:s!=="prerelease"?s:void 0,installOptions:{...p,isBuiltin:n,installPreReleaseVersion:s==="prerelease"||p.installPreReleaseVersion}})};for(const r of g)if(r instanceof k.URI)l.push({vsix:r,installOptions:p});else{const[s,n]=(0,E.$ip)(r);a(s,n,!1)}for(const r of u)if(r instanceof k.URI)l.push({vsix:r,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,n]=(0,E.$ip)(r);a(s,n,!0)}const o=await this.b.getInstalled(1,p.profileLocation);if(l.length&&await Promise.all(l.map(async({vsix:r,installOptions:s})=>{try{await this.h(r,s,f,o)}catch(n){this.a.error(n),h.push(r.toString())}})),t.length){const r=await this.g(t,o,f);h.push(...r)}}catch(l){throw this.a.error((0,v.localize)(5,null,(0,A.$0)(l))),l}if(h.length)throw new Error((0,v.localize)(6,null,h.join(", ")))}async updateExtensions(g){const u=await this.b.getInstalled(1,g),p=[];for(const t of u)t.identifier.uuid&&p.push({...t.identifier,preRelease:t.preRelease});this.a.trace((0,v.localize)(7,null,p.length));const f=await this.d.getExtensions(p,{compatible:!0},i.CancellationToken.None),h=[];for(const t of f)for(const a of u)(0,E.$gp)(a.identifier,t.identifier)&&(0,C.gt)(t.version,a.manifest.version)&&h.push({extension:t,options:{operation:3,installPreReleaseVersion:a.isPreReleaseVersion}});if(!h.length){this.a.info((0,v.localize)(8,null));return}this.a.info((0,v.localize)(9,null,h.map(t=>t.extension.identifier.id).join(", ")));const l=await this.b.installGalleryExtensions(h);for(const t of l)t.error?this.a.error((0,v.localize)(10,null,t.identifier.id,(0,A.$0)(t.error))):this.a.info((0,v.localize)(11,null,t.identifier.id,t.local?.manifest.version))}async g(g,u,p){if(g=g.filter(({id:t,version:a})=>{const o=u.find(r=>(0,E.$gp)(r.identifier,{id:t}));if(o){if(!p&&(!a||a==="prerelease"&&o.preRelease))return this.a.info((0,v.localize)(12,null,t,o.manifest.version,t)),!1;if(a&&o.manifest.version===a)return this.a.info((0,v.localize)(13,null,`${t}@${a}`)),!1}return!0}),!g.length)return[];const f=[],h=[],l=await this.j(g);if(await Promise.all(g.map(async({id:t,version:a,installOptions:o})=>{const r=l.get(t.toLowerCase());if(!r){this.a.error(`${w(a?`${t}@${a}`:t)}
${m}`),f.push(t);return}try{const n=await this.d.getManifest(r,i.CancellationToken.None);if(n&&!this.k(n))return}catch(n){this.a.error(n.message||n.stack||n),f.push(t);return}const s=u.find(n=>(0,E.$gp)(n.identifier,r.identifier));if(s){if(r.version===s.manifest.version){this.a.info((0,v.localize)(14,null,a?`${t}@${a}`:t));return}this.a.info((0,v.localize)(15,null,t,r.version))}o.isBuiltin?this.a.info(a?(0,v.localize)(16,null,t,a):(0,v.localize)(17,null,t)):this.a.info(a?(0,v.localize)(18,null,t,a):(0,v.localize)(19,null,t)),h.push({extension:r,options:{...o,installGivenVersion:!!a}})})),h.length){const t=await this.b.installGalleryExtensions(h);for(const a of t)a.error?(this.a.error((0,v.localize)(20,null,a.identifier.id,(0,A.$0)(a.error))),f.push(a.identifier.id)):this.a.info((0,v.localize)(21,null,a.identifier.id,a.local?.manifest.version))}return f}async h(g,u,p,f){const h=await this.b.getManifest(g);if(!h)throw new Error("Invalid vsix");if(await this.l(h,p,u.profileLocation,f))try{await this.b.install(g,u),this.a.info((0,v.localize)(22,null,(0,D.$Sg)(g)))}catch(t){if((0,A.$4)(t))this.a.info((0,v.localize)(23,null,(0,D.$Sg)(g)));else throw t}}async j(g){const u=new Map,p=g.some(l=>l.installOptions.installPreReleaseVersion),f=await this.b.getTargetPlatform(),h=[];for(const l of g)$.$Go.test(l.id)&&h.push({...l,preRelease:p});if(h.length){const l=await this.d.getExtensions(h,{targetPlatform:f},i.CancellationToken.None);for(const t of l)u.set(t.identifier.id.toLowerCase(),t)}return u}k(g){return!0}async l(g,u,p,f){if(!u){const h={id:(0,E.$lp)(g.publisher,g.name)},l=f.find(t=>(0,E.$gp)(h,t.identifier)&&(0,C.gt)(t.manifest.version,g.version));if(l)return this.a.info((0,v.localize)(24,null,l.identifier.id,l.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,u,p){const f=async l=>{if(l instanceof k.URI){const t=await this.b.getManifest(l);return(0,E.$jp)(t.publisher,t.name)}return l},h=[];for(const l of g){const t=await f(l),o=(await this.b.getInstalled(void 0,p)).filter(r=>(0,E.$gp)(r.identifier,{id:t}));if(!o.length)throw new Error(`${this.m(t)}
${m}`);if(o.some(r=>r.type===0)){this.a.info((0,v.localize)(25,null,t));return}if(!u&&o.some(r=>r.isBuiltin)){this.a.info((0,v.localize)(26,null,t));return}this.a.info((0,v.localize)(27,null,t));for(const r of o)await this.b.uninstall(r,{profileLocation:p}),h.push(r);this.f?this.a.info((0,v.localize)(28,null,t,this.f)):this.a.info((0,v.localize)(29,null,t))}}async locateExtension(g){const u=await this.b.getInstalled();g.forEach(p=>{u.forEach(f=>{if(f.identifier.id===p&&f.location.scheme===S.Schemas.file){this.a.info(f.location.fsPath);return}})})}m(g){return this.f?(0,v.localize)(30,null,g,this.f):(0,v.localize)(31,null,g)}};e.$Zp=d,e.$Zp=d=Le([Re(1,$.$Uo),Re(2,$.$Ro)],d)}),define(Ee[251],ke([1,0,15,10,2,12,19,56,11,22,23,80,25,26,31,36,88,16,13]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;let h=class extends S.$Uc{static{f=this}static{this.c=".sigzip"}constructor(t,a,o,r,s,n){super(),this.h=a,this.j=o,this.m=r,this.n=s,this.r=n,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,a,o){await this.g;const r=(0,C.$Vg)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,r,n=>this.j.download(t,n,a))}catch(n){throw new d.$So(n.message,d.ExtensionManagementErrorCode.Download)}let s=!1;if(o&&this.t(t)){const n=await this.u(t);try{s=await this.n.verify(r.fsPath,n.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(b){const P=b;if(s=P.code,P.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${P.output}`),s===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(r)}catch(I){this.r.error(I)}throw new d.$So(y.$4p,d.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(n)}catch(b){this.r.error(b)}}}return s===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${t.identifier.id}`),{location:r,verificationStatus:s}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const a=this.m.getValue("extensions.verifySignature");return(0,v.$2f)(a)?a:!0}async u(t){await this.g;const a=(0,C.$Vg)(this.extensionsDownloadDir,`${this.z(t)}${f.c}`);try{await this.w(t,a,o=>this.j.downloadSignatureArchive(t,o))}catch(o){throw new d.$So(o.message,d.ExtensionManagementErrorCode.DownloadSignature)}return a}async w(t,a,o){if(await this.h.exists(a))return;if(a.scheme!==D.Schemas.file){await o(a);return}const r=(0,C.$Vg)(this.extensionsDownloadDir,`.${(0,$.$Eg)()}`);await this.h.exists(r)||await o(r);try{await E.Promises.rename(r.fsPath,a.fsPath,2*60*1e3)}catch(s){try{await this.h.del(r)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,A.$0)(s)}. Deleted the file from downloaded location`,r.path),s}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],o=[],r=[];for(const b of t.children)if(b.name.endsWith(f.c))r.push(b.resource);else{const P=c.$hp.parse(b.name);P&&o.push([P,b])}const s=(0,c.$mp)(o,([b])=>b),n=[];for(const b of s)b.sort((P,I)=>k.rcompare(P[0].version,I[0].version)),a.push(...b.slice(1).map(P=>P[1].resource)),n.push(b[0][1]);n.sort((b,P)=>b.mtime-P.mtime),a.push(...n.slice(0,Math.max(0,n.length-this.f)).map(b=>b.resource)),a.push(...r),await i.Promises.settled(a.map(b=>(this.r.trace("Deleting from cache",b.path),this.h.del(b))))}}catch(t){this.r.error(t)}}z(t){return this.f?c.$hp.create(t).toString().toLowerCase():(0,$.$Eg)()}};e.$kq=h,e.$kq=h=f=Le([Re(0,m.$qi),Re(1,u.$Ok),Re(2,d.$Ro),Re(3,w.$Oi),Re(4,g.$Xp),Re(5,p.$Oj)],h)}),define(Ee[252],ke([1,0,6,2,24,36,35]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class k extends A.$Uc{constructor($,E,y,w,m,d,c){super(),this.f=$,this.g=E,this.h=y,this.j=w,this.m=m,this.n=d,this.r=c,this.a=this.B(new i.$7d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$4c),this.s().then(null,g=>c.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(E=>(this.c.set(E.id,(0,A.$Rc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w($){for(const E of $.extensions)this.I(this.L(E.identifier,E.version),$.profileLocation)}async y($){for(const E of $.extensions){const y=this.L(E.identifier,E.version);$.error?this.J(y,$.profileLocation):this.I(y,$.profileLocation)}}async z($){for(const E of $.extensions)this.J(this.L(E.identifier,E.version),$.profileLocation)}async C($){const E=[],y=[];for(const w of $.extensions){const m=this.L(w.identifier,w.version);$.error?this.I(m,$.profileLocation):(this.J(m,$.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),y.push(this.f.scanInstalledExtensionAtLocation(w.location).then(d=>{d?E.push(d):this.r.info("Extension not found at the location",w.location.toString())},d=>this.r.error(d)))))}try{await Promise.all(y),E.length&&await this.H(E)}catch(w){this.r.error(w)}}D($){for(const E of this.h.profiles)$.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F($){const E=[],y=[],w=await this.j.scanProfileExtensions($),m=new Set,d=new Set;for(const[c,g]of this.b)g.has($)&&d.add(c);for(const c of w){const g=this.L(c.identifier,c.version);m.add(g),d.has(g)||(E.push(c.identifier),this.I(g,$))}for(const c of d)if(!m.has(c)){const g=this.M(c);g&&(y.push(g.identifier),this.J(c,$))}(E.length||y.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:$}:void 0,removed:y.length?{extensions:y,profileLocation:$}:void 0})}async G($){const E=await this.j.scanProfileExtensions($);for(const y of E)this.I(this.L(y.identifier,y.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.L(y.identifier,y.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,E){let y=this.b.get($);y||this.b.set($,y=new S.$Cc(w=>this.m.extUri.getComparisonKey(w))),y.add(E)}J($,E){const y=this.b.get($);y&&y.delete(E),y?.size||this.b.delete($)}L($,E){return`${C.$Dm.toKey($.id)}@${E}`}M($){const[E,y]=(0,D.$ip)($);return y?{identifier:{id:E},version:y}:void 0}}e.$oq=k}),define(Ee[253],ke([1,0,223,39]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=S;async function S(D,C,k,v,$,E,y){const w={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${C.nameShort})`};if((0,A.$$o)(C,k)&&(0,A.$ap)(v)===3){const m=await(0,i.$Sp)(k,$,E);w["X-Market-User-Id"]=m,w["VSCode-SessionId"]=y.machineId||m}return w}}),define(Ee[122],ke([1,0,89,18,15,2,12,7,23,26,31,36,13,84,3]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;let c=class extends m.$Cr{constructor(f,h,l,t){super(l),this.h=f,this.j=t,this.g=this.B(new g(h,t)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(f,h){const t=(await this.g.getLanguagePacks())[h];if(!t){this.j.warn(`No language pack found for ${h}`);return}const a=t.translations[f];return a?d.URI.file(a):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),h=Object.keys(f).map(l=>{const t=f[l];return{...this.f(l,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((l,t)=>l.label.localeCompare(t.label)),h}async m(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",f.identifier.id),await this.update())}async n(f){const h=await this.g.getLanguagePacks();Object.keys(h).some(l=>h[l]&&h[l].extensions.some(t=>(0,y.$gp)(t.extensionIdentifier,f.identifier)))&&(this.j.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(h);return!(0,A.$ub)(Object.keys(f),Object.keys(l))}};e.$Dr=c,e.$Dr=c=Le([Re(0,E.$Uo),Re(1,$.$qi),Re(2,E.$Ro),Re(3,w.$Oj)],c);let g=class extends D.$Uc{constructor(f,h){super(),this.j=h,this.c={},this.f=(0,k.$kc)(f.userDataPath,"languagepacks.json"),this.g=new S.$ph}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.s(h=>{Object.keys(h).forEach(l=>delete h[l]),this.m(h,...f)}).then(()=>this.c)}m(f,...h){for(const l of h)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(f,l);Object.keys(f).forEach(l=>this.r(f[l]))}n(f,h){const l=h.identifier,t=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const a of t)if(h.location.scheme===C.Schemas.file&&u(a)){let o=f[a.languageId];o||(o={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},f[a.languageId]=o);const r=o.extensions.filter(s=>(0,y.$gp)(s.extensionIdentifier,l))[0];r?r.version=h.manifest.version:o.extensions.push({extensionIdentifier:l,version:h.manifest.version});for(const s of a.translations)o.translations[s.id]=(0,k.$kc)(h.location.fsPath,s.path)}}r(f){if(f){const h=(0,i.createHash)("md5");for(const l of f.extensions)h.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);f.hash=h.digest("hex")}}s(f=()=>null){return this.g.queue(()=>{let h=null;return v.Promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(h=f(l),l)).then(l=>{for(const a of Object.keys(l))l[a]||delete l[a];this.c=l,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>h,l=>this.j.error(l))})}};g=Le([Re(0,$.$qi),Re(1,w.$Oj)],g);function u(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const f of p.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(Ee[254],ke([1,0,173,10,21,39]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function v(E,y,w){const m=await(0,i.$JD)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,i.$JD)("@microsoft/1ds-post-js","dist/ms.post.js"),c=new m.AppInsightsCore,g=new d.PostChannel,u={instrumentationKey:E,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(w){u.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};u.extensionConfig[g.identifier]=p}return c.initialize(u,[]),c.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',y&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),c}class ${constructor(y,w,m,d,c){this.e=y,this.f=w,this.g=m,this.h=c,this.c=C,this.d=k,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(y){if(this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=v(this.a,this.e,this.h)),this.b.then(w=>{y(w)},w=>{(0,A.$1)(w),console.error(w)})}}log(y,w){if(!this.a)return;w=(0,S.$Rn)(w,this.g),w=(0,D.$bp)(w);const m=this.f+"/"+y;try{this.i(d=>{d.pluginVersionString=w?.properties.version??"Unknown",d.track({name:m,baseData:{name:m,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.$YP=$}),define(Ee[255],ke([1,0,2,21,4,17,203,25,47,58,32,38,28,39]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,p,f){this.k=p,this.l=f,this.d={},this.i=new i.$Tc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,D.$Ze)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$Ze)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(w.$Vl)||h.affectsConfiguration(w.$Xl)||h.affectsConfiguration(w.$Wl))&&this.m()}))}setExperimentProperty(u,p){this.d[u]=p}m(){let u=(0,m.$ap)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const f=p.usage?3:p.error?2:0;u=Math.min(u,f)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,p,f){this.g<p||(f=(0,A.$Rn)(f,this.d),f=(0,m.$fp)(f,this.j),f=(0,A.$Rn)(f,this.c),this.b.forEach(h=>h.log(u,f)))}publicLog(u,p){this.n(u,3,p)}publicLog2(u,p){this.publicLog(u,p)}publicLogError(u,p){this.h&&this.n(u,2,p)}publicLogError2(u,p){this.publicLogError(u,p)}};e.$Jr=d,e.$Jr=d=Le([Re(1,k.$Oi),Re(2,E.$8j)],d);function c(){const g=(0,C.localize)(0,null,$.default.nameLong),u=$.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",$.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=S.$o?"":(0,C.localize)(3,null),f=(0,C.localize)(4,null),h=(0,C.localize)(5,null),l=(0,C.localize)(6,null),t=(0,C.localize)(7,null),a=`
|       | ${f} | ${h} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,C.localize)(8,null);return`
${g} ${u} ${p}

&nbsp;

${t}
${a}

&nbsp;

${o}
`}y.$1n.as(v.$6n.Configuration).registerConfiguration({id:w.$Ul,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[w.$Vl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$1n.as(v.$6n.Configuration).registerConfiguration({id:w.$Ul,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[w.$Xl]:{type:"boolean",markdownDescription:$.default.privacyStatementUrl?(0,C.localize)(16,null,$.default.nameLong,$.default.privacyStatementUrl):(0,C.localize)(15,null,$.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${w.$Vl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Ee[256],ke([1,0,25,5,32,28,255,39]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=void 0;let v=class extends C.$Jr{constructor(E,y,w,m){super(E,w,m),this.o=y}publicLog(E,y){if(!(this.o<3))return super.publicLog(E,y)}publicLog2(E,y){return this.publicLog(E,y)}publicLogError(E,y){return this.o<2?Promise.resolve(void 0):super.publicLogError(E,y)}publicLogError2(E,y){return this.publicLogError(E,y)}async updateInjectedTelemetryLevel(E){if(E===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,E):E,this.o===0&&this.dispose()}};e.$vs=v,e.$vs=v=Le([Re(2,i.$Oi),Re(3,S.$8j)],v),e.$ws=new class extends k.$5o{async updateInjectedTelemetryLevel(){}},e.$xs=(0,A.$ji)(D.$Nl)}),define(Ee[257],ke([1,0,14,20,310,254]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=void 0;async function C(E,y){const w=await y.request(E,A.CancellationToken.None),m=(await(0,i.$Ge)(w.stream)).toString(),d=w.res.statusCode??200;return{headers:w.res.headers,statusCode:d,responseData:m}}async function k(E){const y={method:E.type,headers:E.headers};return new Promise((m,d)=>{const c=S.request(E.url??"",y,g=>{g.on("data",function(u){m({headers:g.headers,statusCode:g.statusCode??200,responseData:u.toString()})}),g.on("error",function(u){d(u)})});c.write(E.data,g=>{g&&d(g)}),c.end()})}async function v(E,y,w){const m=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),d={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:m};try{const c=E?await C(d,E):await k(d);w(c.statusCode,c.headers,c.responseData)}catch{w(0,{})}}class $ extends D.$YP{constructor(y,w,m,d,c){const g={sendPOST:(u,p)=>{v(y,u,p)}};super(w,m,d,c,g)}}e.$ZP=$}),define(Ee[258],ke([1,0,10,248]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class S extends A.default{i(){(0,i.setUnexpectedErrorHandler)(k=>console.error(k));const C=[];process.on("unhandledRejection",(k,v)=>{C.push(v),setTimeout(()=>{const $=C.indexOf(v);$>=0&&v.catch(E=>{C.splice($,1),(0,i.$4)(E)||(console.warn(`rejected promise not handled within 1 second: ${E}`),E.stack&&console.warn(`stack trace: ${E.stack}`),k&&(0,i.$1)(k))})},1e3)}),process.on("rejectionHandled",k=>{const v=C.indexOf(k);v>=0&&C.splice(v,1)}),process.on("uncaughtException",k=>{(0,i.$Z)(k)||(0,i.$1)(k)})}}e.default=S}),define(Ee[123],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(Ee[124],ke([1,0,4,123]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0;const S=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(E){this.collections=E,this.a=new Map,this.b=new Map,E.forEach((y,w)=>{this.d(y,w);const m=y.map.entries();let d=m.next();for(;!d.done;){const c=d.value[1],g=d.value[0];let u=this.a.get(g);if(u||(u=[],this.a.set(g,u)),u.length>0&&u[0].type===A.EnvironmentVariableMutatorType.Replace){d=m.next();continue}const p={extensionIdentifier:w,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};p.scope||delete p.scope,u.unshift(p),d=m.next()}})}async applyToProcessEnvironment(E,y,w){let m;i.$i&&(m={},Object.keys(E).forEach(d=>m[d.toLowerCase()]=d));for(const[d,c]of this.getVariableMap(y)){const g=i.$i&&m[d.toLowerCase()]||d;for(const u of c){const p=w?await w(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case A.EnvironmentVariableMutatorType.Append:E[g]=(E[g]||"")+p;break;case A.EnvironmentVariableMutatorType.Prepend:E[g]=p+(E[g]||"");break;case A.EnvironmentVariableMutatorType.Replace:E[g]=p;break}if(u.options?.applyAtShellIntegration??!1){const f=`VSCODE_ENV_${S.get(u.type)}`;E[f]=(E[f]?E[f]+":":"")+d+"="+this.c(p)}}}}c(E){return E.replaceAll(":","\\x3a")}diff(E,y){const w=new Map,m=new Map,d=new Map;if(E.getVariableMap(y).forEach((c,g)=>{const u=this.getVariableMap(y).get(g),p=k(c,u);p&&w.set(g,p)}),this.getVariableMap(y).forEach((c,g)=>{const u=E.getVariableMap(y).get(g),p=k(c,u);p&&d.set(g,p)}),this.getVariableMap(y).forEach((c,g)=>{const u=E.getVariableMap(y).get(g),p=v(c,u);p&&m.set(g,p)}),!(w.size===0&&m.size===0&&d.size===0))return{added:w,changed:m,removed:d}}getVariableMap(E){const y=new Map;for(const w of this.a.values()){const m=w.filter(d=>C(d,E));m.length>0&&y.set(m[0].variable,m)}return y}getDescriptionMap(E){const y=new Map;for(const w of this.b.values()){const m=w.filter(d=>C(d,E,!0));for(const d of m)y.set(d.extensionIdentifier,d.description)}return y}d(E,y){if(!E.descriptionMap)return;const w=E.descriptionMap.entries();let m=w.next();for(;!m.done;){const d=m.value[1],c=m.value[0];let g=this.b.get(c);g||(g=[],this.b.set(c,g));const u={extensionIdentifier:y,scope:d.scope,description:d.description};u.scope||delete u.scope,g.push(u),m=w.next()}}}e.$as=D;function C($,E,y=!1){return $.scope?!!($.scope.workspaceFolder&&E?.workspaceFolder&&$.scope.workspaceFolder.index===E.workspaceFolder.index):y?E===$.scope:!0}function k($,E){if(!E)return $;const y=new Set;E.forEach(m=>y.add(m.extensionIdentifier));const w=[];return $.forEach(m=>{y.has(m.extensionIdentifier)||w.push(m)}),w.length===0?void 0:w}function v($,E){if(!E)return;const y=new Map;E.forEach(m=>y.set(m.extensionIdentifier,m));const w=[];return $.forEach(m=>{const d=y.get(m.extensionIdentifier);d&&(m.type!==d.type||m.value!==d.value||m.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&w.push(d)}),w.length===0?void 0:w}}),define(Ee[90],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=i,e.$8r=A,e.$9r=S,e.$0r=D,e.$$r=C,e.$_r=k;function i(v){return[...v.entries()]}function A(v){return v?[...v.entries()]:[]}function S(v){return new Map(v)}function D(v){return new Map(v??[])}function C(v){return Array.from(v.entries()).map($=>[$[0],i($[1].map),A($[1].descriptionMap)])}function k(v){return new Map(v.map($=>[$[0],{map:S($[1]),descriptionMap:D($[2])}]))}}),define(Ee[259],ke([1,0,15,20,6,2,13]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0;let k=class extends D.$Uc{constructor($,E){super(),this.h=E,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$7d),this.onCreateRequest=this.g.event,this.b=$===void 0?15e3:$,this.B((0,D.$Sc)(()=>{for(const y of this.f.values())(0,D.$Pc)(y)}))}createRequest($){return new Promise((E,y)=>{const w=++this.a;this.c.set(w,E),this.g.fire({requestId:w,...$});const m=new A.$ee;(0,i.$jh)(this.b,m.token).then(()=>y(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,D.$Sc)(()=>m.cancel())])})}acceptReply($,E){const y=this.c.get($);y?(this.c.delete($),(0,D.$Pc)(this.f.get($)||[]),this.f.delete($),y(E)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${$}`)}};e.$Xr=k,e.$Xr=k=Le([Re(1,C.$Oj)],k)}),define(Ee[91],ke([1,0,5,57,38]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Qr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Pr=void 0,e.$Pr=new A.$zj("terminalTabFocusMode",!1,!0);var D;(function(l){l.AutomationProfile="terminal.integrated.automationProfile.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var C;(function(l){l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.TabStopWidth="terminal.integrated.tabStopWidth",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorStyleInactive="terminal.integrated.cursorStyleInactive",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.EnableVisualBell="terminal.integrated.enableVisualBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.TabFocusMode="terminal.integrated.tabFocusMode",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoEnabled="terminal.integrated.localEchoEnabled",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.HideOnStartup="terminal.integrated.hideOnStartup",l.CustomGlyphs="terminal.integrated.customGlyphs",l.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",l.EnableImages="terminal.integrated.enableImages",l.SmoothScrolling="terminal.integrated.smoothScrolling",l.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",l.FocusAfterRun="terminal.integrated.focusAfterRun",l.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",l.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",l.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",l.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",l.MouseWheelZoom="terminal.integrated.mouseWheelZoom",l.ExperimentalInlineChat="terminal.integrated.experimentalInlineChat",l.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",l.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",l.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var k;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh",l.Python="python"})(k||(e.PosixShellType=k={}));var v;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash",l.Python="python"})(v||(e.WindowsShellType=v={}));var $;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})($||(e.TitleEventSource=$={}));var E;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.PtyHostWindow="ptyHostWindow",l.Logger="logger",l.Heartbeat="heartbeat"})(E||(e.TerminalIpcChannels=E={}));var y;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$Qr=(0,i.$ii)("ptyService");var w;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var m;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(m||(e.TerminalLocation=m={}));var d;(function(l){l.TerminalView="view",l.Editor="editor"})(d||(e.TerminalLocationString=d={}));var c;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var g;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var u;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var p;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(p||(e.ShellIntegrationStatus=p={}));var f;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(f||(e.TerminalExitReason=f={})),e.$Rr={Backend:"workbench.contributions.terminal.processBackend"};class h{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const a=this.b(t.remoteAuthority);if(this.a.has(a))throw new Error(`A terminal backend with remote authority '${a}' was already registered.`);this.a.set(a,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}S.$1n.add(e.$Rr.Backend,new h),e.$Sr=(0,i.$ii)("localPtyService"),e.$Tr=(0,i.$ii)("terminalLogService")}),define(Ee[125],ke([1,0,4]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=A,e.$CP=S,e.$DP=D,e.$EP=C;function A(k){let v=k;v.includes("\\")&&(v=v.replace(/\\/g,"\\\\"));const $=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return v=v.replace($,""),`'${v}'`}function S(k,v,$){if(!k)return"";if(!v)return k;v.match(/[\/\\]$/)&&(v=v.slice(0,v.length-1));const E=k.replace(/\\/g,"/").toLowerCase(),y=v.replace(/\\/g,"/").toLowerCase();return E.includes(y)?`~${$}${k.slice(v.length+1)}`:k}function D(k){return k.match(/^['"].*['"]$/)&&(k=k.substring(1,k.length-1)),i.OS===1&&k&&k[1]===":"?k[0].toUpperCase()+k.substring(1):k}function C(k){return!k.strictEnv}}),define(Ee[260],ke([1,0,52,3,205,100]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=C,e.$Zr=$,e.$1r=E,e.$2r=y;function C(w,m){const d=[{name:null,description:(0,S.localize)(0,null)}];return d.push(...w.map(c=>({name:c.profileName,description:k(c)}))),m&&d.push(...m.map(c=>({name:c.title,description:v(c)}))),{values:d.map(c=>c.name),markdownDescriptions:d.map(c=>c.description)}}function k(w){let m=`$(${D.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:i.$Hj.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?m+=`
- args: "${w.args}"`:m+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(m+=`
- overrideName: ${w.overrideName}`),w.color&&(m+=`
- color: ${w.color}`),w.env&&(m+=`
- env: ${JSON.stringify(w.env)}`),m}function v(w){return`$(${D.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:i.$Hj.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function $(w,m){if(!w&&!m)return!0;if(typeof w=="string"&&typeof m=="string")return w===m;if(Array.isArray(w)&&Array.isArray(m)){if(w.length!==m.length)return!1;for(let d=0;d<w.length;d++)if(w[d]!==m[d])return!1;return!0}return!1}function E(w,m){if(!w&&!m)return!0;if(!w||!m)return!1;if(D.ThemeIcon.isThemeIcon(w)&&D.ThemeIcon.isThemeIcon(m))return w.id===m.id&&w.color===m.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof m=="object"&&"light"in m&&"dark"in m){const d=w,c=m;if((A.URI.isUri(d.light)||y(d.light))&&(A.URI.isUri(d.dark)||y(d.dark))&&(A.URI.isUri(c.light)||y(c.light))&&(A.URI.isUri(c.dark)||y(c.dark)))return d.light.path===c.light.path&&d.dark.path===c.dark.path}if(A.URI.isUri(w)&&A.URI.isUri(m)||y(w)||y(m)){const d=w,c=m;return d.path===c.path&&d.scheme===c.scheme}return!1}function y(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}}),define(Ee[261],ke([1,0,52,4,204,47,38,260]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=void 0,e.$5r=m,e.$6r=c,e.$3r={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$4r={type:"string",enum:Array.from((0,i.$Fj)(),g=>g.id),markdownEnumDescriptions:Array.from((0,i.$Fj)(),g=>`$(${g.id})`)};const v={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$4r},color:{description:(0,S.localize)(3,null),...e.$3r},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},$={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...v}},E={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...v}};function y(g){const u=g===2?"linux":g===1?"osx":"windows";return(0,S.localize)(7,null,(0,A.$h)(g),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...v}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...v}},{type:"null"},$]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...v}},{type:"null"},$]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...v}},{type:"null"},$]}},"terminal.integrated.useWslProfiles":{description:(0,S.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,S.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,S.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){C.$1n.as(D.$6n.Configuration).registerConfiguration(w),c()}let d;function c(g,u){const p=C.$1n.as(D.$6n.Configuration);let f;g&&(f=(0,k.$Yr)(g?.profiles,u));const h=d;d={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:g?.os===3?f?.values:void 0,markdownEnumDescriptions:g?.os===3?f?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:g?.os===2?f?.values:void 0,markdownEnumDescriptions:g?.os===2?f?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:g?.os===1?f?.values:void 0,markdownEnumDescriptions:g?.os===1?f?.markdownDescriptions:void 0}}},p.updateConfigurations({add:[d],remove:h?[h]:[]})}}),define(Ee[262],ke([1,0,2,12,108,26,109]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hQ=void 0;let k=class extends i.$Uc{constructor($,E){super(),this.a=$,this.b=E}start(){const $={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:A.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},E=(0,C.$Vm)(this.b.args,this.b.isBuilt);E&&(E.break&&E.port?$.debugBrk=E.port:!E.break&&E.port&&($.debug=E.port));const y=new S.$Kq(A.$Cg.asFileUri("bootstrap-fork").fsPath,$),w=new i.$Tc;return w.add(y),{client:y,store:w,onDidProcessExit:y.onDidProcessExit}}};e.$hQ=k,e.$hQ=k=Le([Re(1,D.$pi)],k)}),define(Ee[263],ke([1,0,29,12,21,7,4,30,17,11,23,123,90,124]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=d,e.$cs=c,e.$ds=g;function d(){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let s=0;return r&&r.length===4&&(s=parseInt(r[3])),s}async function c(r,s,n,b=k.env,P=E.Promises.exists){if(D.$jc(r))return await P(r)?r:void 0;if(s===void 0&&(s=k.cwd()),D.$nc(r)!=="."){const j=D.$kc(s,r);return await P(j)?j:void 0}const O=(0,S.$Vn)(b,"PATH");if(n===void 0&&(0,$.$Vf)(O)&&(n=O.split(D.$uc)),n===void 0||n.length===0){const j=D.$kc(s,r);return await P(j)?j:void 0}for(const j of n){let B;if(D.$jc(j)?B=D.$kc(j,r):B=D.$kc(s,j,r),await P(B))return B;if(C.$i){let Y=B+".com";if(await P(Y)||(Y=B+".exe",await P(Y)))return Y}}const R=D.$kc(s,r);return await P(R)?R:void 0}function g(r,s,n,b,P){const I=C.$i&&(!s.windowsEnableConpty||d()<18309);if(!s.shellIntegration.enabled||!r.executable||r.isFeatureTerminal&&!r.forceShellIntegration||r.ignoreShellIntegration||I)return;const O=r.args,R=k.$ec==="win32"?D.$oc(r.executable).toLowerCase():D.$oc(r.executable),j=D.$nc(A.$Cg.asFileUri("").fsPath);let B;const Y={VSCODE_INJECTION:"1"};if(s.shellIntegration.nonce&&(Y.VSCODE_NONCE=s.shellIntegration.nonce),C.$i){if(R==="pwsh.exe"||R==="powershell.exe")return!O||a(O)?B=f.get(p.WindowsPwsh):t(O)&&(B=f.get(p.WindowsPwshLogin)),B?(B=[...B],B[B.length-1]=(0,v.$Ve)(B[B.length-1],j,""),s.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),{newArgs:B,envMixin:Y}):void 0;b.warn(`Shell integration cannot be enabled for executable "${r.executable}" and args`,r.args);return}switch(R){case"bash":return!O||O.length===0?B=f.get(p.Bash):o(O)&&(Y.VSCODE_SHELL_LOGIN="1",u(s,Y),B=f.get(p.Bash)),B?(B=[...B],B[B.length-1]=(0,v.$Ve)(B[B.length-1],j),{newArgs:B,envMixin:Y}):void 0;case"fish":{const fe=n?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ue=D.$kc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Y.XDG_DATA_DIRS=`${fe}:${ue}`,u(s,Y),{newArgs:void 0,envMixin:Y}}case"pwsh":return!O||a(O)?B=f.get(p.Pwsh):t(O)&&(B=f.get(p.PwshLogin)),B?(s.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),B=[...B],B[B.length-1]=(0,v.$Ve)(B[B.length-1],j,""),{newArgs:B,envMixin:Y}):void 0;case"zsh":{if(!O||O.length===0?B=f.get(p.Zsh):o(O)?(B=f.get(p.ZshLogin),u(s,Y)):(O===f.get(p.Zsh)||O===f.get(p.ZshLogin))&&(B=O),!B)return;B=[...B],B[B.length-1]=(0,v.$Ve)(B[B.length-1],j);let fe;try{fe=i.userInfo().username}catch{fe="unknown"}const ue=D.$kc(i.tmpdir(),`${fe}-${P.applicationName}-zsh`);Y.ZDOTDIR=ue;const re=n?.ZDOTDIR??i.homedir()??"~";Y.USER_ZDOTDIR=re;const te=[];return te.push({source:D.$kc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$kc(ue,".zshrc")}),te.push({source:D.$kc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$kc(ue,".zprofile")}),te.push({source:D.$kc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$kc(ue,".zshenv")}),te.push({source:D.$kc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$kc(ue,".zlogin")}),{newArgs:B,envMixin:Y,filesToCopy:te}}}b.warn(`Shell integration cannot be enabled for executable "${r.executable}" and args`,r.args)}function u(r,s){if(C.$j&&r.environmentVariableCollections){const n=(0,w.$_r)(r.environmentVariableCollections),P=new m.$as(n).getVariableMap({workspaceFolder:r.workspaceFolder}).get("PATH"),I=[];if(P)for(const O of P)O.type===y.EnvironmentVariableMutatorType.Prepend&&I.push(O.value);I.length>0&&(s.VSCODE_PATH_PREFIX=I.join(""))}}var p;(function(r){r.WindowsPwsh="windows-pwsh",r.WindowsPwshLogin="windows-pwsh-login",r.Pwsh="pwsh",r.PwshLogin="pwsh-login",r.Zsh="zsh",r.ZshLogin="zsh-login",r.Bash="bash"})(p||(p={}));const f=new Map;f.set(p.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(p.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(p.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(p.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(p.Zsh,["-i"]),f.set(p.ZshLogin,["-il"]),f.set(p.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const h=["-login","-l"],l=["-nol","-nologo"];function t(r){return typeof r=="string"?h.includes(r.toLowerCase()):r.length===1&&h.includes(r[0].toLowerCase())||r.length===2&&(h.includes(r[0].toLowerCase())||h.includes(r[1].toLowerCase()))&&(l.includes(r[0].toLowerCase())||l.includes(r[1].toLowerCase()))}function a(r){return typeof r=="string"?l.includes(r.toLowerCase()):r.length===0||r?.length===1&&l.includes(r[0].toLowerCase())}function o(r){return r==="string"&&h.includes(r.toLowerCase())||typeof r!="string"&&r.length===1&&h.includes(r[0].toLowerCase())}}),define(Ee[264],ke([1,0,55,52,7,4,11,23,103,263,76]),function(le,e,i,A,S,D,C,k,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=d;var y;(function(n){n.UnixShellsPath="/etc/shells"})(y||(y={}));let w,m=!0;function d(n,b,P,I,O=process.env,R,j,B,Y){return R=R||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},D.$i?c(P,R,O,j,I.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:I.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:I.getValue("terminal.integrated.defaultProfile.windows"),Y,B):o(R,j,P,n&&typeof n=="object"?{...n}:I.getValue(D.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:I.getValue(D.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),Y,B,O)}async function c(n,b,P,I,O,R,j,B,Y){const fe=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ue=`${process.env.windir}\\${fe?"Sysnative":"System32"}`;let re=!1;(0,$.$bs)()>=16299&&(re=!0),await f(B);const te=new Map;if(n){te.set("PowerShell",{source:"PowerShell",icon:A.$Hj.terminalPowershell,isAutoDetected:!0}),te.set("Windows PowerShell",{path:`${ue}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$Hj.terminalPowershell,isAutoDetected:!0}),te.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),te.set("Command Prompt",{path:`${ue}\\cmd.exe`,icon:A.$Hj.terminalCmd,isAutoDetected:!0}),te.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),te.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:A.$Hj.terminalBash,isAutoDetected:!0});const T=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;te.set("Cmder",{path:`${ue}\\cmd.exe`,args:["/K",T],requiresPath:process.env.CMDER_ROOT?T:{path:T,isUnsafe:!0},isAutoDetected:!0})}r(R,te);const V=await g(te.entries(),j,b,P,I,Y);if(n&&O)try{const T=await t(`${ue}\\${re?"wsl":"bash"}.exe`,j);for(const x of T)(!R||!(x.profileName in R))&&V.push(x)}catch{m&&(I?.trace("WSL is not installed, so could not detect WSL profiles"),m=!1)}return V}async function g(n,b,P,I=process.env,O,R){const j=[];for(const[B,Y]of n)j.push(u(B,Y,b,P,I,O,R));return(await Promise.all(j)).filter(B=>!!B)}async function u(n,b,P,I,O=process.env,R,j){if(b===null)return;let B,Y,fe;if("source"in b&&!("path"in b)){const V=w?.get(b.source);if(!V)return;B=V.paths,Y=b.args||V.args,b.icon?fe=p(b.icon):V.icon&&(fe=V.icon)}else B=Array.isArray(b.path)?b.path:[b.path],Y=D.$i||Array.isArray(b.args)?b.args:void 0,fe=p(b.icon);let ue;if(j){const V=B.map(x=>typeof x=="string"?x:x.path),T=await j(V);ue=new Array(B.length);for(let x=0;x<B.length;x++)typeof B[x]=="string"?ue[x]=T[x]:ue[x]={path:T[x],isUnsafe:!0}}else ue=B.slice();let re;if(b.requiresPath){let V;if((0,C.$Vf)(b.requiresPath)?V=b.requiresPath:(V=b.requiresPath.path,b.requiresPath.isUnsafe&&(re=V)),!await I.existsFile(V))return}const te=await s(n,P,ue,I,O,Y,b.env,b.overrideName,b.isAutoDetected,re);if(!te){R?.debug("Terminal profile not validated",n,B);return}return te.isAutoDetected=b.isAutoDetected,te.icon=fe,te.color=b.color,te}function p(n){return typeof n=="string"?{id:n}:n}async function f(n){if(w&&!n)return;const[b,P]=await Promise.all([h(),n||l()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:P,icon:A.$Hj.terminalPowershell})}async function h(){const n=new Set,b=await(0,$.$cs)("git.exe");if(b){const O=(0,E.dirname)(b);n.add((0,E.resolve)(O,"../.."))}function P(O,R){R&&O.add(R)}P(n,process.env.ProgramW6432),P(n,process.env.ProgramFiles),P(n,process.env["ProgramFiles(X86)"]),P(n,`${process.env.LocalAppData}\\Program`);const I=[];for(const O of n)I.push(`${O}\\Git\\bin\\bash.exe`,`${O}\\Git\\usr\\bin\\bash.exe`,`${O}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function l(){const n=[];for await(const b of(0,v.$9l)())n.push(b.exePath);return n}async function t(n,b){const P=[],I=await new Promise((j,B)=>{i.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Y,fe)=>{if(Y)return B("Problem occurred when getting wsl distros");j(fe)})});if(!I)return[];const O=new RegExp(/[\r?\n]/),R=I.split(O).filter(j=>j.trim().length>0&&j!=="");for(const j of R){if(j===""||j.startsWith("docker-desktop"))continue;const B=`${j} (WSL)`,Y={profileName:B,path:n,args:["-d",`${j}`],isDefault:B===b,icon:a(j),isAutoDetected:!1};P.push(Y)}return P}function a(n){return n.includes("Ubuntu")?A.$Hj.terminalUbuntu:n.includes("Debian")?A.$Hj.terminalDebian:A.$Hj.terminalLinux}async function o(n,b,P,I,O,R,j,B){const Y=new Map;if(P&&await n.existsFile("/etc/shells")){const fe=(await n.readFile("/etc/shells")).toString(),ue=(R||fe.split(`
`)).map(te=>{const V=te.indexOf("#");return V===-1?te:te.substring(0,V)}).filter(te=>te.trim().length>0),re=new Map;for(const te of ue){let V=(0,S.$oc)(te),T=re.get(V)||0;T++,T>1&&(V=`${V} (${T})`),re.set(V,T),Y.set(V,{path:te,isAutoDetected:!0})}}return r(I,Y),await g(Y.entries(),O,n,B,b,j)}function r(n,b){if(n)for(const[P,I]of Object.entries(n))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?b.delete(P):(I.icon=I.icon||b.get(P)?.icon,b.set(P,I))}async function s(n,b,P,I,O,R,j,B,Y,fe){if(P.length===0)return Promise.resolve(void 0);const ue=P.shift();if(ue==="")return s(n,b,P,I,O,R,j,B,Y);const re=typeof ue!="string"&&ue.isUnsafe,te=typeof ue=="string"?ue:ue.path,V={profileName:n,path:te,args:R,env:j,overrideName:B,isAutoDetected:Y,isDefault:n===b,isUnsafePath:re,requiresUnsafePath:fe};if((0,S.$oc)(te)===te){const x=O.PATH?O.PATH.split(S.$uc):void 0,Z=await(0,$.$cs)(te,void 0,x,void 0,I.existsFile);return Z?(V.path=Z,V.isFromPath=!0,V):s(n,b,P,I,O,R)}return await I.existsFile((0,S.$ic)(te))?V:s(n,b,P,I,O,R,j,B,Y)}}),define(Ee[265],ke([1,0,6,2,4,45,25,13,114,87,259,91,261,264,106,61]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0;var g;(function(p){p[p.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let u=class extends A.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(f,h,l,t){super(),this.M=f,this.N=h,this.O=l,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new i.$7d),this.onPtyHostExit=this.u.event,this.w=this.B(new i.$7d),this.onPtyHostStart=this.w.event,this.y=this.B(new i.$7d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new i.$7d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new i.$7d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new i.$7d),this.onProcessData=this.D.event,this.F=this.B(new i.$7d),this.onProcessReady=this.F.event,this.G=this.B(new i.$7d),this.onProcessReplay=this.G.event,this.H=this.B(new i.$7d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new i.$7d),this.onDidRequestDetach=this.I.event,this.J=this.B(new i.$7d),this.onDidChangeProperty=this.J.event,this.L=this.B(new i.$7d),this.onProcessExit=this.L.event,(0,w.$5r)(),this.B(this.M),this.B((0,A.$Sc)(()=>this.W())),this.j=this.B(new E.$Xr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&i.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,$.$sm)(this.N,this.O,{_:[]},process.env)}catch(f){return this.O.error("ptyHost was unable to resolve shell environment",f),{}}}U(){const f=this.M.start(),h=f.client;this.O.getLevel()===k.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(h.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(f.onDidProcessExit(a=>{this.u.fire(a.code),!this.m&&!this.q.isDisposed&&(this.n<=g.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const t=D.ProxyChannel.toService(h.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(a=>this.D.fire(a))),this.B(t.onProcessReady(a=>this.F.fire(a))),this.B(t.onProcessExit(a=>this.L.fire(a))),this.B(t.onDidChangeProperty(a=>this.J.fire(a))),this.B(t.onProcessReplay(a=>this.G.fire(a))),this.B(t.onProcessOrphanQuestion(a=>this.H.fire(a))),this.B(t.onDidRequestDetach(a=>this.I.fire(a))),this.B(new v.$Wr(this.P,h.getChannel(y.TerminalIpcChannels.Logger))),this.a=f,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[f,t]}async createProcess(f,h,l,t,a,o,r,s,n,b,P){const I=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),O=await this.f.createProcess(f,h,l,t,a,o,r,s,n,b,P);return clearTimeout(I),O}updateTitle(f,h,l){return this.f.updateTitle(f,h,l)}updateIcon(f,h,l,t){return this.f.updateIcon(f,h,l,t)}attachToProcess(f){return this.f.attachToProcess(f)}detachFromProcess(f,h){return this.f.detachFromProcess(f,h)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(f){return this.f.start(f)}shutdown(f,h){return this.f.shutdown(f,h)}input(f,h){return this.f.input(f,h)}processBinary(f,h){return this.f.processBinary(f,h)}resize(f,h,l){return this.f.resize(f,h,l)}clearBuffer(f){return this.f.clearBuffer(f)}acknowledgeDataEvent(f,h){return this.f.acknowledgeDataEvent(f,h)}setUnicodeVersion(f,h){return this.f.setUnicodeVersion(f,h)}getInitialCwd(f){return this.f.getInitialCwd(f)}getCwd(f){return this.f.getCwd(f)}async getLatency(){const f=new c.$3d,h=await this.f.getLatency();return f.stop(),[{label:"ptyhostservice<->ptyhost",latency:f.elapsed()},...h]}orphanQuestionReply(f){return this.f.orphanQuestionReply(f)}installAutoReply(f,h){return this.f.installAutoReply(f,h)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(f){return this.f.uninstallAutoReply(f)}getDefaultSystemShell(f){return this.g?.getDefaultSystemShell(f)??(0,d.$cm)(f??S.OS,process.env)}async getProfiles(f,h,l,t=!1){const a=await this.S();return(0,m.$es)(h,l,t,this.N,a,void 0,this.O,this.bb.bind(this,f))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(f,h){return this.f.getWslPath(f,h)}getRevivedPtyNewId(f,h){return this.f.getRevivedPtyNewId(f,h)}setTerminalLayoutInfo(f){return this.f.setTerminalLayoutInfo(f)}async getTerminalLayoutInfo(f){return this.g?.getTerminalLayoutInfo(f)}async requestDetachInstance(f,h){return this.f.requestDetachInstance(f,h)}async acceptDetachInstanceReply(f,h){return this.f.acceptDetachInstanceReply(f,h)}async freePortKillProcess(f){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(f)}async serializeTerminalState(f){return this.f.serializeTerminalState(f)}async reviveTerminalProcesses(f,h,l){return this.f.reviveTerminalProcesses(f,h,l)}async refreshProperty(f,h){return this.f.refreshProperty(f,h)}async updateProperty(f,h,l){return this.f.updateProperty(f,h,l)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(f){this.ab(),this.s=setTimeout(()=>this.Y(),f?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(f,h){return this.j.createRequest({workspaceId:f,originalText:h})}async acceptPtyHostResolvedVariables(f,h){this.j.acceptReply(f,h)}};e.$fs=u,e.$fs=u=Le([Re(1,C.$Oi),Re(2,k.$Oj),Re(3,k.$Pj)],u)}),define(Ee[34],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=void 0,e.$ml=(0,i.$ii)("IUriIdentityService")}),define(Ee[126],ke([1,0,34,110,16,19,152,6,2]),function(le,e,i,A,S,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;class ${static{this._clock=0}constructor(w){this.uri=w,this.time=$._clock++}touch(){return this.time=$._clock++,this}}let E=class{constructor(w){this.g=w,this.c=new v.$Tc,this.f=2**16;const m=new Map,d=c=>{let g=m.get(c.scheme);return g===void 0&&(g=w.hasProvider(c)&&!this.g.hasCapability(c,1024),m.set(c.scheme,g)),g};this.c.add(k.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(c=>{m.delete(c.scheme)})),this.extUri=new D.$Kg(d),this.d=new C.$is((c,g)=>this.extUri.compare(c,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,D.$Wg)(w));const m=this.d.get(w);return m?m.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new $(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((d,c)=>d[1].time<c[1].time?1:d[1].time>c[1].time?-1:0);$._clock=0,this.d.clear();const m=this.f*.5;for(let d=0;d<m;d++)this.d.set(w[d][0],w[d][1].touch())}};e.$js=E,e.$js=E=Le([Re(0,S.$Ok)],E),(0,A.$gs)(i.$ml,E,1)}),define(Ee[92],ke([1,0,207,7,64,19,3,5,12]),function(le,e,i,A,S,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=$,e.$ti=E,e.$wi=y,e.$xi=w,e.$yi=m,e.$zi=c,e.$Ai=g,e.$Di=f,e.$Ii=h,e.$Ji=l,e.$Li=t,e.$Mi=a,e.$Ni=o,e.$ri=(0,k.$ii)("contextService");function $(r){const s=r;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}function E(r){return typeof r?.id=="string"&&!$(r)&&!w(r)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function y(r,s){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,A.$oc)(r)}:s?e.$ui:e.$vi;const n=r;return n.configuration?{id:n.id,configPath:n.configuration}:n.folders.length===1?{id:n.id,uri:n.folders[0].uri}:{id:n.id}}function w(r){const s=r;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}function m(r){const s=r;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:C.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}var d;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function c(r){const s=r;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function g(r){const s=r;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class u{constructor(s,n,b,P,I){this.h=s,this.j=b,this.k=P,this.l=I,this.c=S.$oi.forUris(this.l,()=>!0),this.folders=n}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=S.$oi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=u;class p{constructor(s,n){this.raw=n,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,D.$Vg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=p;function f(r){return new p({uri:r,index:0,name:(0,D.$Rg)(r)},{uri:r.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,i.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function h(r,s){return D.$Mg.isEqualOrParent(r,s.untitledWorkspacesHome)}function l(r){let s;return C.URI.isUri(r)?s=r:s=r.configuration,s?.scheme===v.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(r){return r.id===e.$Ki}function a(r,s){return!h(r,s)&&!l(r)}function o(r){return(typeof r=="string"?(0,A.$pc)(r):(0,D.$Tg)(r))===e.$Fi}}),define(Ee[33],ke([1,0,62,6,2,19,3,206,26,16,5,13,92,24,34,15,22,17,11]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ol=e.ProfileResourceType=void 0,e.$nl=h,e.$pl=l,e.$ql=t;var f;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(f||(e.ProfileResourceType=f={}));function h(r){const s=r;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&C.URI.isUri(s.location)&&C.URI.isUri(s.globalStorageHome)&&C.URI.isUri(s.settingsResource)&&C.URI.isUri(s.keybindingsResource)&&C.URI.isUri(s.tasksResource)&&C.URI.isUri(s.snippetsHome)&&C.URI.isUri(s.extensionsResource))}e.$ol=(0,E.$ii)("IUserDataProfilesService");function l(r,s){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:C.URI.revive(r.location).with({scheme:s}),globalStorageHome:C.URI.revive(r.globalStorageHome).with({scheme:s}),settingsResource:C.URI.revive(r.settingsResource).with({scheme:s}),keybindingsResource:C.URI.revive(r.keybindingsResource).with({scheme:s}),tasksResource:C.URI.revive(r.tasksResource).with({scheme:s}),snippetsHome:C.URI.revive(r.snippetsHome).with({scheme:s}),extensionsResource:C.URI.revive(r.extensionsResource).with({scheme:s}),cacheHome:C.URI.revive(r.cacheHome).with({scheme:s}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}function t(r,s,n,b,P,I){return{id:r,name:s,location:n,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:I&&P?.useDefaultFlags?.globalState?I.globalStorageHome:(0,D.$Vg)(n,"globalStorage"),settingsResource:I&&P?.useDefaultFlags?.settings?I.settingsResource:(0,D.$Vg)(n,"settings.json"),keybindingsResource:I&&P?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,D.$Vg)(n,"keybindings.json"),tasksResource:I&&P?.useDefaultFlags?.tasks?I.tasksResource:(0,D.$Vg)(n,"tasks.json"),snippetsHome:I&&P?.useDefaultFlags?.snippets?I.snippetsHome:(0,D.$Vg)(n,"snippets"),extensionsResource:I&&P?.useDefaultFlags?.extensions?I.extensionsResource:(0,D.$Vg)(n,"extensions.json"),cacheHome:(0,D.$Vg)(b,r),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let a=class extends S.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,n,b,P){super(),this.t=s,this.u=n,this.w=b,this.y=P,this.f=!0,this.h=this.B(new A.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Bc,emptyWindows:new Map},this.profilesHome=(0,D.$Vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$Vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),n=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,p.$Vf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}n.push(t((0,D.$Sg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const b=new m.$Bc,P=new Map;if(n.length)try{const I=this.Q();if(I.workspaces)for(const[O,R]of Object.entries(I.workspaces)){const j=C.URI.parse(O),B=n.find(Y=>Y.id===R);B&&b.set(j,B)}if(I.emptyWindows)for(const[O,R]of Object.entries(I.emptyWindows)){const j=n.find(B=>B.id===R);j&&P.set(O,j)}}catch(I){this.y.error(I)}this.z={profiles:n,workspaces:b,emptyWindows:P}}return this.z}D(){const s=t("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const n="Temp",b=new RegExp(`${(0,u.$Ze)(n)}\\s(\\d+)`);let P=0;for(const O of this.profiles){const R=b.exec(O.name),j=R?parseInt(R[1]):0;P=j>P?j:P}const I=`${n} ${P+1}`;return this.createProfile((0,i.$9i)((0,g.$Eg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,n,b){return this.createProfile((0,i.$9i)((0,g.$Eg)()).toString(16),s,n,b)}async createProfile(s,n,b,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,n,b);return P&&await this.setProfileForWorkspace(P,I),I}async F(s,n,b){if(!(0,p.$Vf)(n)||!n)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(n);return P||(P=(async()=>{try{const I=this.profiles.find(j=>j.name===n||j.id===s);if(I)return I;const O=t(s,n,(0,D.$Vg)(this.profilesHome,s),this.g,b,this.defaultProfile);await this.u.createFolder(O.location);const R=[];return this.j.fire({profile:O,join(j){R.push(j)}}),await c.Promises.settled(R),this.I([O],[],[]),O}finally{this.r.delete(n)}})(),this.r.set(n,P)),P}async updateProfile(s,n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(P=>P.id===s.id);if(!b)throw new Error(`Profile '${s.name}' does not exist`);return b=t(b.id,n.name??b.name,b.location,this.g,{shortName:n.shortName??b.shortName,icon:n.icon===null?void 0:n.icon??b.icon,transient:n.transient??b.isTransient,useDefaultFlags:n.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const n=this.profiles.find(P=>P.id===s.id);if(!n)throw new Error(`Profile '${s.name}' does not exist`);const b=[];this.m.fire({profile:n,join(P){b.push(P)}});try{await Promise.allSettled(b)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])n.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])n.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[n],[]);try{await this.u.del(n.cacheHome,{recursive:!0})}catch(P){(0,$.$6k)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(s,n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(P=>P.id===n.id);if(!b)throw new Error(`Profile '${n.name}' does not exist`);this.L(s,b)}unsetWorkspace(s,n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,n)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(n=>n.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,n.resource))).map(n=>this.u.del(n.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(n=>!this.H(n));await Promise.allSettled(s.map(n=>this.removeProfile(n)))}getProfileForWorkspace(s){const n=this.G(s);return C.URI.isUri(n)?this.s.workspaces.get(n)??this.C.workspaces.get(n):this.s.emptyWindows.get(n)??this.C.emptyWindows.get(n)}G(s){return(0,w.$si)(s)?s.uri:(0,w.$xi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(n=>this.w.extUri.isEqual(n.location,s.location))||[...this.s.workspaces.values()].some(n=>this.w.extUri.isEqual(n.location,s.location))||[...this.C.emptyWindows.values()].some(n=>this.w.extUri.isEqual(n.location,s.location))||[...this.C.workspaces.values()].some(n=>this.w.extUri.isEqual(n.location,s.location)))}I(s,n,b){const P=[...this.profiles,...s],I=[];this.s.profiles=[];for(let O of P)O.isDefault||n.some(R=>O.id===R.id)||(O=b.find(R=>O.id===R.id)??O,O.isTransient?this.s.profiles.push(O):I.push({location:O.location,name:O.name,shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,n,b)}J(s,n,b){this.h.fire({added:s,removed:n,updated:b,all:this.profiles})}L(s,n,b){b=n?.isTransient?!0:b,b||this.L(s,void 0,!0);const P=this.G(s),I=b?this.s:this.C;C.URI.isUri(P)?(I.workspaces.delete(P),n&&I.workspaces.set(P,n)):(I.emptyWindows.delete(P),n&&I.emptyWindows.set(P,n)),b||this.M()}M(){const s={};for(const[b,P]of this.C.workspaces.entries())s[b.toString()]=P.id;const n={};for(const[b,P]of this.C.emptyWindows.entries())n[b.toString()]=P.id;this.R({workspaces:s,emptyWindows:n}),this.z=void 0}N(s){const n={},b=this.D();if(s.workspaces)for(const[I,O]of Object.entries(s.workspaces)){const R=C.URI.parse(O);n[I]=this.w.extUri.isEqual(R,b.location)?b.id:this.w.extUri.basename(R)}const P={};if(s.emptyWindows)for(const[I,O]of Object.entries(s.emptyWindows)){const R=C.URI.parse(O);P[I]=this.w.extUri.isEqual(R,b.location)?b.id:this.w.extUri.basename(R)}return{workspaces:n,emptyWindows:P}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$rl=a,e.$rl=a=Le([Re(0,v.$pi),Re(1,$.$Ok),Re(2,d.$ml),Re(3,y.$Oj)],a);class o extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$sl=o}),define(Ee[266],ke([1,0,18,15,20,10,6,2,4,11,3,186,31,36,35,13,32,28,34,33]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$9p=void 0,e.$0p=l,e.$$p=t;let h=class extends k.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,n,b,P,I,O){super(),this.z=s,this.C=n,this.D=b,this.F=P,this.G=I,this.H=O,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new C.$7d),this.s=this.B(new C.$7d),this.t=this.B(new C.$7d),this.u=this.B(new C.$7d),this.w=this.B(new C.$7d),this.y=[],this.B((0,k.$Sc)(()=>{this.j.forEach(({task:R})=>R.cancel()),this.m.forEach(R=>R.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const n=await this.getTargetPlatform();return s.allTargetPlatforms.some(b=>(0,w.$Po)(b,s.allTargetPlatforms,n))}async installFromGallery(s,n={}){try{const P=(await this.installGalleryExtensions([{extension:s,options:n}])).find(({identifier:I})=>(0,m.$gp)(I,s.identifier));if(P?.local)return P?.local;throw P?.error?P.error:new w.$So(`Unknown error while installing extension ${s.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch(b){throw t(b)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new w.$So(y.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const n=[],b=[];await Promise.allSettled(s.map(async({extension:P,options:I})=>{try{const O=await this.N(P,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.G.version,date:this.G.date});b.push({...O,options:I})}catch(O){n.push({identifier:P.identifier,operation:2,source:P,error:O})}})),b.length&&n.push(...await this.I(b));for(const P of n)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!E.URI.isUri(P.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,m.$op)(P.source),error:P.error}));return n}async uninstall(s,n={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,n)}async toggleAppliationScope(s,n){if((0,d.$Gm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let b=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(b=await this.$(s,this.H.defaultProfile.extensionsResource,n));for(const P of this.H.profiles){const I=(await this.getInstalled(1,P.extensionsResource)).find(O=>(0,m.$gp)(O.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:P.extensionsResource})}return b}else{const b=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:b.identifier,operation:2,local:b,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),b}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const n=[],b=new Map,P=[],I=[],O=(j,B)=>`${m.$hp.create(j).toString()}-${B.toString()}`,R=(j,B,Y)=>{const fe=this.Y(j,B,Y),ue=E.URI.isUri(B)?B.path:`${B.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`;b.set(ue,{task:fe,manifest:j}),this.n.fire({identifier:fe.identifier,source:B,profileLocation:Y.profileLocation}),this.F.info("Installing extension:",fe.identifier.id),E.URI.isUri(B)||this.j.set(O(B,Y.profileLocation),{task:fe,waitingTasks:[]})};try{for(const{manifest:j,extension:B,options:Y}of s){const fe=Y.isApplicationScoped||Y.isBuiltin||(0,d.$Gm)(j),ue={...Y,installOnlyNewlyAddedFromExtensionPack:Y.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(B),isApplicationScoped:fe,profileLocation:fe?this.H.defaultProfile.extensionsResource:Y.profileLocation??this.X(),productVersion:Y.productVersion??{version:this.G.version,date:this.G.date}},re=E.URI.isUri(B)?void 0:this.j.get(O(B,ue.profileLocation));re?(this.F.info("Extension is already requested to install",re.task.identifier.id),P.push(re.task.waitUntilTaskIsFinished())):R(j,B,ue)}await Promise.all([...b.values()].map(async({task:j,manifest:B})=>{if(j.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",j.identifier.id);else try{const Y=await this.M(j.identifier,B,!!j.options.installOnlyNewlyAddedFromExtensionPack,!!j.options.installPreReleaseVersion,j.options.profileLocation,j.options.productVersion),fe=await this.getInstalled(void 0,j.options.profileLocation,j.options.productVersion),ue={...j.options,donotIncludePackAndDependencies:!0,context:{...j.options.context,[w.$Ko]:!0}};for(const{gallery:re,manifest:te}of(0,i.$Mb)(Y,({gallery:V})=>V.identifier.id)){if(b.has(`${re.identifier.id.toLowerCase()}-${ue.profileLocation.toString()}`))continue;const V=this.j.get(O(re,ue.profileLocation));if(V){if(this.J(j,V.task)){const T=V.task.identifier;this.F.info("Waiting for already requested installing extension",T.id,j.identifier.id),V.waitingTasks.push(j),P.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,x=>x.some(Z=>(0,m.$gp)(Z.identifier,T)))).then(x=>{if(this.F.info("Finished waiting for already requested installing extension",T.id,j.identifier.id),!x.find(G=>(0,m.$gp)(G.identifier,T))?.local)throw new Error(`Extension ${T.id} is not installed`)}))}}else fe.some(({identifier:T})=>(0,m.$gp)(T,re.identifier))||R(te,re,ue)}}catch(Y){if(E.URI.isUri(j.source))(0,i.$Lb)(B.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",j.identifier.id,Y.message),(0,i.$Lb)(B.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",j.identifier.id,Y.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",j.identifier.id),Y}})),await this.L([...b.values()].map(async({task:j})=>{const B=new Date().getTime();try{const Y=await j.run();if(await this.L(this.y.map(fe=>fe.postInstall(Y,j.source,j.options,S.CancellationToken.None))),!E.URI.isUri(j.source)){const fe=j.operation===3,ue=fe?void 0:(new Date().getTime()-j.source.lastUpdated)/1e3;if(a(this.C,fe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$op)(j.source),verificationStatus:j.verificationStatus,duration:new Date().getTime()-B,durationSinceUpdate:ue}),v.$o&&j.operation!==3)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,"install")}catch{}}I.push({local:Y,identifier:j.identifier,operation:j.operation,source:j.source,context:j.options.context,profileLocation:j.profileLocation,applicationScoped:Y.isApplicationScoped})}catch(Y){throw this.F.error("Error while installing the extension",j.identifier.id,(0,D.$0)(Y)),Y}})),P.length&&await this.L(P);for(const j of I)this.F.info("Extension installed successfully:",j.identifier.id),n.push(j);return n}catch(j){I.length&&(this.F.info("Rollback: Uninstalling installed extensions",(0,D.$0)(j)),await Promise.allSettled(I.map(async({local:B,profileLocation:Y})=>{try{await this.Z(B,{versionOnly:!0,profileLocation:Y}).run(),this.F.info("Rollback: Uninstalled extension",B.identifier.id)}catch(fe){this.F.warn("Rollback: Error while uninstalling extension",B.identifier.id,(0,D.$0)(fe))}})));for(const{task:B}of b.values())B.cancel(),n.push({identifier:B.identifier,operation:2,source:B.source,context:B.options.context,profileLocation:B.profileLocation,error:j});throw j}finally{for(const{task:j}of b.values())j.source&&!E.URI.isUri(j.source)&&this.j.delete(O(j.source,j.profileLocation));n.length&&this.s.fire(n)}}J(s,n){for(const[,{task:b,waitingTasks:P}]of this.j.entries())if(b===s&&(P.includes(n)||P.some(I=>this.J(I,n)))||b===n&&P[0]&&!this.J(s,P[0]))return!1;return!0}async L(s){const n=[],b=[],P=await Promise.allSettled(s);for(const I of P)I.status==="fulfilled"?n.push(I.value):b.push(I.reason);if(b.length)throw l(b);return n}async M(s,n,b,P,I,O){if(!this.z.isEnabled())return[];const R=await this.getInstalled(void 0,I,O),j=[],B=[],Y=async(fe,ue)=>{j.push(fe);const re=ue.extensionDependencies||[],te=[...re];if(ue.extensionPack){const V=b?R.find(T=>(0,m.$gp)(T.identifier,fe)):void 0;for(const T of ue.extensionPack)V&&V.manifest.extensionPack&&V.manifest.extensionPack.some(x=>(0,m.$gp)({id:x},{id:T}))||te.every(x=>!(0,m.$gp)({id:x},{id:T}))&&te.push(T)}if(te.length){const V=te.filter(T=>j.every(x=>!(0,m.$gp)(x,{id:T})));if(V.length){const T=await this.z.getExtensions(V.map(x=>({id:x,preRelease:P})),S.CancellationToken.None);for(const x of T){if(j.find(se=>(0,m.$gp)(se,x.identifier)))continue;const Z=re.some(se=>(0,m.$gp)({id:se},x.identifier));let G;try{G=await this.N(x,!1,P,O)}catch(se){if(Z)throw se;this.F.info("Skipping the packed extension as it cannot be installed",x.identifier.id,(0,D.$0)(se));continue}B.push({gallery:G.extension,manifest:G.manifest}),await Y(G.extension.identifier,G.manifest)}}}};return await Y(s,n),B}async N(s,n,b,P){let I;const O=await this.getExtensionsControlManifest();if(O.malicious.some(B=>(0,m.$gp)(s.identifier,B)))throw new w.$So(y.localize(1,null,s.identifier.id),w.ExtensionManagementErrorCode.Malicious);const R=O.deprecated[s.identifier.id.toLowerCase()];if(R?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${R.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:R.extension.id,preRelease:R.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:P},S.CancellationToken.None))[0],!I)throw new w.$So(y.localize(2,null,s.identifier.id,R.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const B=await this.getTargetPlatform();throw new w.$So(y.localize(3,null,s.identifier.id,this.G.nameLong,(0,w.$Lo)(B)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.O(s,n,b,P),!I)throw!b&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],S.CancellationToken.None))[0]?new w.$So(y.localize(4,null,s.displayName??s.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$So(y.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const j=await this.z.getManifest(I,S.CancellationToken.None);if(j===null)throw new w.$So(`Missing manifest for extension ${I.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(j.version!==I.version)throw new w.$So(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:j}}async O(s,n,b,P){const I=await this.getTargetPlatform();let O=null;return!n&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==b&&(O=(await this.z.getExtensions([{...s.identifier,preRelease:b}],{targetPlatform:I,compatible:!0,productVersion:P},S.CancellationToken.None))[0]||null),!O&&await this.z.isExtensionCompatible(s,b,I,P)&&(O=s),O||(n?O=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:I,compatible:!0,productVersion:P},S.CancellationToken.None))[0]||null:O=await this.z.getCompatibleExtension(s,b,I,P)),O}async P(s,n){const b={...n,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},P=Y=>`${Y.id.toLowerCase()}${b.versionOnly?`-${s.manifest.version}`:""}${b.profileLocation?`@${b.profileLocation.toString()}`:""}`,I=this.m.get(P(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const O=Y=>{const fe=this.Z(Y,b);return this.m.set(P(fe.extension.identifier),fe),b.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,b.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this.t.fire({identifier:Y.identifier,profileLocation:b.profileLocation,applicationScoped:Y.isApplicationScoped}),fe},R=(Y,fe)=>{fe?b.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,b.profileLocation.toString(),fe.message):this.F.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,fe.message):b.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,b.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$np)(Y),error:fe}),this.u.fire({identifier:Y.identifier,error:fe?.code,profileLocation:b.profileLocation,applicationScoped:Y.isApplicationScoped})},j=[],B=[];try{j.push(O(s));const Y=await this.getInstalled(1,b.profileLocation);if(b.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const fe=this.S(s,Y);for(const ue of fe)this.m.has(P(ue.identifier))?this.F.info("Extensions is already requested to uninstall",ue.identifier.id):j.push(O(ue))}b.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(j.map(fe=>fe.extension),Y,s),await this.L(j.map(async fe=>{try{if(await fe.run(),await this.L(this.y.map(ue=>ue.postUninstall(fe.extension,b,S.CancellationToken.None))),fe.extension.identifier.uuid)try{await this.z.reportStatistic(fe.extension.manifest.publisher,fe.extension.manifest.name,fe.extension.manifest.version,"uninstall")}catch{}R(fe.extension)}catch(ue){const re=ue instanceof w.$So?ue:new w.$So((0,D.$0)(ue),w.ExtensionManagementErrorCode.Internal);throw R(fe.extension,re),re}finally{B.push(fe)}}))}catch(Y){const fe=Y instanceof w.$So?Y:new w.$So((0,D.$0)(Y),w.ExtensionManagementErrorCode.Internal);for(const ue of j){try{ue.cancel()}catch{}B.includes(ue)||R(ue.extension,fe)}throw fe}finally{for(const Y of j)this.m.delete(P(Y.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}Q(s,n,b){for(const P of s){const I=this.U(P,n);if(I.length){const O=I.filter(R=>!s.some(j=>(0,m.$gp)(j.identifier,R.identifier)));if(O.length)throw new Error(this.R(P,O,b))}}}R(s,n,b){return b===s?n.length===1?y.localize(6,null,b.manifest.displayName||b.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?y.localize(7,null,b.manifest.displayName||b.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):y.localize(8,null,b.manifest.displayName||b.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?y.localize(9,null,b.manifest.displayName||b.manifest.name,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?y.localize(10,null,b.manifest.displayName||b.manifest.name,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):y.localize(11,null,b.manifest.displayName||b.manifest.name,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(s,n,b=[]){if(b.indexOf(s)!==-1)return[];b.push(s);const P=s.manifest.extensionPack?s.manifest.extensionPack:[];if(P.length){const I=n.filter(R=>!R.isBuiltin&&P.some(j=>(0,m.$gp)({id:j},R.identifier))),O=[];for(const R of I)O.push(...this.S(R,n,b));return[...I,...O]}return[]}U(s,n){return n.filter(b=>b.manifest.extensionDependencies&&b.manifest.extensionDependencies.some(P=>(0,m.$gp)({id:P},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,D.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$9p=h,e.$9p=h=Le([Re(0,w.$Ro),Re(1,u.$Nl),Re(2,p.$ml),Re(3,c.$Oj),Re(4,g.$8j),Re(5,f.$ol)],h);function l(r){const s=Array.isArray(r)?r:[r];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((n,b)=>new Error(`${n.message}${n.message?",":""}${b instanceof Error?b.message:b}`),new Error(""))}function t(r){if(r instanceof w.$So)return r;if(r instanceof w.$To){const n=new w.$So(r.message,w.ExtensionManagementErrorCode.Gallery);return n.stack=r.stack,n}const s=new w.$So(r.message,w.ExtensionManagementErrorCode.Internal);return s.stack=r.stack,s}function a(r,s,{extensionData:n,verificationStatus:b,duration:P,error:I,durationSinceUpdate:O}){let R,j;(0,$.$4f)(b)&&(b===!0?b="Verified":(b===!1||(R=w.ExtensionManagementErrorCode.Signature,j=b),b="Unverified")),I&&(I instanceof w.$So||I instanceof w.$To?(R=I.code,I.code===w.ExtensionManagementErrorCode.Signature&&(j=I.message)):R=w.ExtensionManagementErrorCode.Internal),r.publicLog(s,{...n,verificationStatus:b,success:!I,duration:P,errorcode:R,errorcodeDetail:j,durationSinceUpdate:O})}class o{constructor(){this.d=new A.$hh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$8g)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$8g)(s=>new Promise((n,b)=>{const P=s.onCancellationRequested(()=>{P.dispose(),b(new D.$5)})})),this.d.open()),this.g.cancel()}}e.$_p=o}),define(Ee[49],ke([1,0,15,14,2,6,24,3,31,36,16,5,13,33,34,11,10,28]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class f extends Error{constructor(o,r){super(o),this.code=r}}e.$aq=f,e.$bq=(0,y.$ii)("IExtensionsProfileScannerService");let h=class extends S.$Uc{constructor(o,r,s,n,b,P){super(),this.j=o,this.m=r,this.n=s,this.r=n,this.s=b,this.t=P,this.b=this.B(new D.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new D.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Bc}scanProfileExtensions(o,r){return this.u(o,void 0,r)}async addExtensionsToProfile(o,r,s){const n=[],b=[];try{return await this.u(r,P=>{const I=[];if(s)I.push(...P);else for(const O of P)o.some(([R])=>(0,$.$gp)(R.identifier,O.identifier)&&R.manifest.version!==O.version)?n.push(O):I.push(O);for(const[O,R]of o){const j=I.findIndex(Y=>(0,$.$gp)(Y.identifier,O.identifier)&&Y.version===O.manifest.version),B={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:R};j===-1?(b.push(B),I.push(B)):I.splice(j,1,B)}return b.length&&this.b.fire({extensions:b,profileLocation:r}),n.length&&this.f.fire({extensions:n,profileLocation:r}),I}),b.length&&this.c.fire({extensions:b,profileLocation:r}),n.length&&this.g.fire({extensions:n,profileLocation:r}),b}catch(P){throw b.length&&this.c.fire({extensions:b,error:P,profileLocation:r}),n.length&&this.g.fire({extensions:n,error:P,profileLocation:r}),P}}async updateMetadata(o,r){const s=[];return await this.u(r,n=>{const b=[];for(const P of n){const I=o.find(([O])=>(0,$.$gp)(O.identifier,P.identifier)&&O.manifest.version===P.version);I&&(P.metadata={...P.metadata,...I[1]},s.push(P)),b.push(P)}return b}),s}async removeExtensionFromProfile(o,r){const s=[];try{await this.u(r,n=>{const b=[];for(const P of n)(0,$.$gp)(P.identifier,o.identifier)?s.push(P):b.push(P);return s.length&&this.f.fire({extensions:s,profileLocation:r}),b}),s.length&&this.g.fire({extensions:s,profileLocation:r})}catch(n){throw s.length&&this.g.fire({extensions:s,error:n,profileLocation:r}),n}}async u(o,r,s){return this.F(o).queue(async()=>{let n=[],b;try{const P=await this.m.readFile(o);b=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,E.$6k)(P)!==1)throw P;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&s?.bailOutWhenFileNotFound)throw new f((0,g.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(o);let P=!1;for(const I of b){l(I)||this.w(o);let O;if((0,c.$Vf)(I.relativeLocation)&&I.relativeLocation)O=this.z(I.relativeLocation);else if((0,c.$Vf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{O=k.URI.revive(I.location);const R=this.y(O);R&&(P=!0,I.relativeLocation=R)}(0,c.$3f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(P=!0,I.metadata.hasPreReleaseVersion=!0),n.push({identifier:I.identifier,location:O,version:I.version,metadata:I.metadata})}P&&await this.m.writeFile(o,A.$ue.fromString(JSON.stringify(b)))}if(r){n=r(n);const P=n.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(o,A.$ue.fromString(JSON.stringify(P)))}return n})}w(o){const r=new f(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),r=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(o)).value.toString()}catch(b){if((0,E.$6k)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",o.toString());let n;try{const b=JSON.parse(s);Array.isArray(b)&&b.every(P=>l(P))?n=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(n)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ue.fromString(JSON.stringify(n)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,E.$6k)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(o)}catch(b){(0,E.$6k)(b)!==1&&this.t.error(b)}try{await this.m.del(r)}catch(b){(0,E.$6k)(b)!==1&&this.t.error(b)}return n})()),this.C}F(o){let r=this.h.get(o);return r||(r=new i.$ph,this.h.set(o,r)),r}};e.$cq=h,e.$cq=h=Le([Re(1,E.$Ok),Re(2,m.$ol),Re(3,d.$ml),Re(4,u.$Nl),Re(5,w.$Oj)],h);function l(a){return(0,c.$Xf)(a)&&(0,v.$Qo)(a.identifier)&&(t(a.location)||(0,c.$Vf)(a.location)&&a.location)&&((0,c.$3f)(a.relativeLocation)||(0,c.$Vf)(a.relativeLocation))&&a.version&&(0,c.$Vf)(a.version)}function t(a){return a?(0,c.$Vf)(a.path)&&(0,c.$Vf)(a.scheme):!1}}),define(Ee[59],ke([1,0,18,15,21,14,10,42,170,2,12,7,4,19,56,63,11,3,190,26,36,35,81,16,5,13,32,6,53,49,33,34,221]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f,h,l,t,a,o,r,s,n,b,P,I,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.$gq=e.$fq=e.Translations=void 0,e.$iq=re;var j;(function(V){function T(x,Z){if(x===Z)return!0;const G=Object.keys(x),se=new Set;for(const ce of Object.keys(Z))se.add(ce);if(G.length!==se.size)return!1;for(const ce of G){if(x[ce]!==Z[ce])return!1;se.delete(ce)}return se.size===0}V.equals=T})(j||(e.Translations=j={})),e.$fq=(0,o.$ii)("IExtensionsScannerService");let B=class extends $.$Uc{constructor(T,x,Z,G,se,ce,ne,$e,K,q,N,z){super(),this.systemExtensionsLocation=T,this.userExtensionsLocation=x,this.r=Z,this.s=G,this.t=se,this.u=ce,this.w=ne,this.y=$e,this.z=K,this.C=q,this.D=N,this.F=z,this.g=this.B(new n.$7d),this.onDidChangeCache=this.g.event,this.h=(0,m.$Vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ue,this.s,this.h)),this.m=this.B(this.F.createInstance(ue,this.s,this.h)),this.n=this.B(this.F.createInstance(fe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$rp)(this.w,this.y)),this.G}async scanAllExtensions(T,x,Z){const[G,se]=await Promise.all([this.scanSystemExtensions(T),this.scanUserExtensions(x)]),ce=Z?await this.scanExtensionsUnderDevelopment(T,[...G,...se]):[];return this.L(G,se,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(T){const x=[];x.push(this.M(!!T.useCache,T.language)),x.push(this.N(T.language,!!T.checkControlFile));const[Z,G]=await Promise.all(x);return this.J([...Z,...G],0,T,!1)}async scanUserExtensions(T){const x=T.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",x);const Z=this.D.extUri.isEqual(T.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,G=await this.P(x,!!T.profileLocation,1,!T.includeUninstalled,T.language,!0,Z,T.productVersion??this.R()),se=T.useCache&&!G.devMode&&G.excludeObsolete?this.m:this.n;let ce;try{ce=await se.scanExtensions(G)}catch(ne){if(ne instanceof P.$aq&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ce=await se.scanExtensions(G);else throw ne}return ce=await this.J(ce,1,T,!0),this.y.trace("Scanned user extensions:",ce.length),ce}async scanExtensionsUnderDevelopment(T,x){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const Z=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(G=>G.scheme===E.Schemas.file).map(async G=>{const se=await this.P(G,!1,1,!0,T.language,!1,void 0,T.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(se)).map(ne=>(ne.type=x.find($e=>(0,h.$gp)($e.identifier,ne.identifier))?.type??ne.type,this.n.validate(ne,se)))}))).flat();return this.J(Z,"development",T,!0)}return[]}async scanExistingExtension(T,x,Z){const G=await this.P(T,!1,x,!0,Z.language,!0,void 0,Z.productVersion??this.R()),se=await this.n.scanExtension(G);return!se||!Z.includeInvalid&&!se.isValid?null:se}async scanOneOrMultipleExtensions(T,x,Z){const G=await this.P(T,!1,x,!0,Z.language,!0,void 0,Z.productVersion??this.R()),se=await this.n.scanOneOrMultipleExtensions(G);return this.J(se,x,Z,!0)}async scanMultipleExtensions(T,x,Z){const G=[];return await Promise.all(T.map(async se=>{const ce=await this.scanOneOrMultipleExtensions(se,x,Z);G.push(...ce)})),this.J(G,x,Z,!0)}async scanMetadata(T){const x=(0,m.$Vg)(T,"package.json"),Z=(await this.w.readFile(x)).value.toString();return JSON.parse(Z).__metadata}async updateMetadata(T,x){const Z=(0,m.$Vg)(T,"package.json"),G=(await this.w.readFile(Z)).value.toString(),se=JSON.parse(G);x.isMachineScoped===!1&&delete x.isMachineScoped,x.isBuiltin===!1&&delete x.isBuiltin,se.__metadata={...se.__metadata,...x},await this.w.writeFile((0,m.$Vg)(T,"package.json"),D.$ue.fromString(JSON.stringify(se,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(T){if(T instanceof P.$aq&&T.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw T}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const T=await this.scanUserExtensions({includeInvalid:!0});if(T.length)await this.u.addExtensionsToProfile(T.map(x=>[x,x.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$ue.fromString(JSON.stringify([])))}catch(x){(0,a.$6k)(x)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$0)(x))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(T){this.y.error(T)}finally{this.H=void 0}})()),this.H}async J(T,x,Z,G){return Z.includeAllVersions||(T=this.L(x===0?T:void 0,x===1?T:void 0,x==="development"?T:void 0,await this.getTargetPlatform(),G)),Z.includeInvalid||(T=T.filter(se=>se.isValid)),T.sort((se,ce)=>{const ne=y.$oc(se.location.fsPath),$e=y.$oc(ce.location.fsPath);return ne<$e?-1:ne>$e?1:0})}L(T,x,Z,G,se){const ce=($e,K,q)=>{if($e.isValid&&!K.isValid)return!1;if($e.isValid===K.isValid){if(se&&d.gt($e.manifest.version,K.manifest.version))return this.y.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${$e.location.path} with version ${$e.manifest.version}`),!1;if(d.eq($e.manifest.version,K.manifest.version)){if($e.type===0)return this.y.debug(`Skipping extension ${K.location.path} in favour of system extension ${$e.location.path} with same version`),!1;if($e.targetPlatform===G)return this.y.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${$e.location.path} with ${K.location.path}.`):this.y.debug(`Overwriting user extension ${$e.location.path} with ${K.location.path}.`),!0},ne=new l.$Fm;return T?.forEach($e=>{const K=ne.get($e.identifier.id);(!K||ce(K,$e,!1))&&ne.set($e.identifier.id,$e)}),x?.forEach($e=>{const K=ne.get($e.identifier.id);if(!K&&T&&$e.type===0){this.y.debug(`Skipping obsolete system extension ${$e.location.path}.`);return}(!K||ce(K,$e,!1))&&ne.set($e.identifier.id,$e)}),Z?.forEach($e=>{const K=ne.get($e.identifier.id);(!K||ce(K,$e,!0))&&ne.set($e.identifier.id,$e),ne.set($e.identifier.id,$e)}),[...ne.values()]}async M(T,x){this.y.trace("Started scanning system extensions");const Z=await this.P(this.systemExtensionsLocation,!1,0,!0,x,!0,void 0,this.R()),se=await(T&&!Z.devMode?this.j:this.n).scanExtensions(Z);return this.y.trace("Scanned system extensions:",se.length),se}async N(T,x){const Z=this.z.isBuilt?[]:this.C.builtInExtensions;if(!Z?.length)return[];this.y.trace("Started scanning dev system extensions");const G=x?await this.O():{},se=[],ce=u.URI.file(y.$ic(y.$kc(E.$Cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const $e of Z){const K=G[$e.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":se.push((0,m.$Vg)(ce,$e.name));break;default:se.push(u.URI.file(K));break}}const ne=await Promise.all(se.map(async $e=>this.n.scanExtension(await this.P($e,!1,0,!0,T,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ne.length),(0,i.$Hb)(ne)}async O(){try{const T=await this.w.readFile(this.r);return JSON.parse(T.value.toString())}catch{return{}}}async P(T,x,Z,G,se,ce,ne,$e){const K=await this.f(se??w.$w),q=await this.Q(T),N=x&&!this.D.extUri.isEqual(T,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,z=N?await this.Q(N):void 0;return new Y(T,q,N,z,x,ne,Z,G,ce,$e.version,$e.date,this.C.commit,!this.z.isBuilt,se,K)}async Q(T){try{const x=await this.w.stat(T);if(typeof x.mtime=="number")return x.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$gq=B,e.$gq=B=Le([Re(4,I.$ol),Re(5,P.$bq),Re(6,a.$Ok),Re(7,r.$Oj),Re(8,f.$pi),Re(9,s.$8j),Re(10,O.$ml),Re(11,o.$hi)],B);class Y{constructor(T,x,Z,G,se,ce,ne,$e,K,q,N,z,X,ae,Q){this.location=T,this.mtime=x,this.applicationExtensionslocation=Z,this.applicationExtensionslocationMtime=G,this.profile=se,this.profileScanOptions=ce,this.type=ne,this.excludeObsolete=$e,this.validate=K,this.productVersion=q,this.productDate=N,this.productCommit=z,this.devMode=X,this.language=ae,this.translations=Q}static createNlsConfiguration(T){return{language:T.language,pseudo:T.language==="pseudo",devMode:T.devMode,translations:T.translations}}static equals(T,x){return(0,m.$Og)(T.location,x.location)&&T.mtime===x.mtime&&(0,m.$Og)(T.applicationExtensionslocation,x.applicationExtensionslocation)&&T.applicationExtensionslocationMtime===x.applicationExtensionslocationMtime&&T.profile===x.profile&&S.$Sn(T.profileScanOptions,x.profileScanOptions)&&T.type===x.type&&T.excludeObsolete===x.excludeObsolete&&T.validate===x.validate&&T.productVersion===x.productVersion&&T.productDate===x.productDate&&T.productCommit===x.productCommit&&T.devMode===x.devMode&&T.language===x.language&&j.equals(T.translations,x.translations)}}e.$hq=Y;let fe=class extends $.$Uc{constructor(T,x,Z,G,se){super(),this.f=T,this.g=x,this.h=Z,this.j=G,this.m=se}async scanExtensions(T){const x=T.profile?await this.r(T):await this.n(T);let Z={};if(T.excludeObsolete&&T.type===1)try{const G=(await this.j.readFile(this.f)).value.toString();Z=JSON.parse(G)}catch{}return(0,g.$9f)(Z)?x:x.filter(G=>!Z[h.$hp.create(G).toString()])}async n(T){const x=await this.j.resolve(T.location);if(!x.children?.length)return[];const Z=await Promise.all(x.children.map(async G=>{if(!G.isDirectory||T.type===1&&(0,m.$Sg)(G.resource).indexOf(".")===0)return null;const se=new Y(G.resource,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(se)}));return(0,i.$Hb)(Z).sort((G,se)=>G.location.path<se.location.path?-1:1)}async r(T){let x=await this.s(T.location,()=>!0,T);if(T.applicationExtensionslocation&&!this.h.extUri.isEqual(T.location,T.applicationExtensionslocation)){x=x.filter(G=>!G.metadata?.isApplicationScoped);const Z=await this.s(T.applicationExtensionslocation,G=>!!G.metadata?.isBuiltin||!!G.metadata?.isApplicationScoped,T);x.push(...Z)}return x}async s(T,x,Z){const G=await this.g.scanProfileExtensions(T,Z.profileScanOptions);if(!G.length)return[];const se=await Promise.all(G.map(async ce=>{if(x(ce)){const ne=new Y(ce.location,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(ne,ce.metadata)}return null}));return(0,i.$Hb)(se)}async scanOneOrMultipleExtensions(T){try{if(await this.j.exists((0,m.$Vg)(T.location,"package.json"))){const x=await this.scanExtension(T);return x?[x]:[]}else return await this.scanExtensions(T)}catch(x){return this.m.error(`Error scanning extensions at ${T.location.path}:`,(0,C.$0)(x)),[]}}async scanExtension(T,x){try{let Z=await this.scanExtensionManifest(T.location);if(Z){Z.publisher||(Z.publisher=l.$zm),x=x??Z.__metadata,delete Z.__metadata;const G=(0,h.$lp)(Z.publisher,Z.name),se=x?.id?{id:G,uuid:x.id}:{id:G},ce=x?.isSystem?0:T.type,ne=ce===0||!!x?.isBuiltin;Z=await this.t(T.location,Z,Y.createNlsConfiguration(T));const $e={type:ce,identifier:se,manifest:Z,location:T.location,isBuiltin:ne,targetPlatform:x?.targetPlatform??"undefined",metadata:x,isValid:!0,validations:[]};return T.validate?this.validate($e,T):$e}}catch(Z){T.type!==0&&this.m.error(Z)}return null}validate(T,x){let Z=!0;const G=(0,t.$wp)(x.productVersion,x.productDate,x.location,T.manifest,T.isBuiltin);for(const[se,ce]of G)se===c.default.Error&&(Z=!1,this.m.error(this.z(x.location,ce)));return T.isValid=Z,T.validations=G,T}async scanExtensionManifest(T){const x=(0,m.$Vg)(T,"package.json");let Z;try{Z=(await this.j.readFile(x)).value.toString()}catch(se){return(0,a.$6k)(se)!==1&&this.m.error(this.z(T,(0,p.localize)(0,null,x.path,se.message))),null}let G;try{G=JSON.parse(Z)}catch{const ce=[];(0,k.$vn)(Z,ce);for(const ne of ce)this.m.error(this.z(T,(0,p.localize)(1,null,x.path,ne.offset,ne.length,(0,v.$dq)(ne.error))));return null}return(0,k.$En)(G)!=="object"?(this.m.error(this.z(T,(0,p.localize)(2,null,x.path))),null):G}async t(T,x,Z){const G=await this.u(T,x,Z);if(G)try{const se=[],ce=await this.w(G.default,se);if(se.length>0)return se.forEach($e=>{this.m.error(this.z(T,(0,p.localize)(3,null,G.default?.path,(0,v.$dq)($e.error))))}),x;if((0,k.$En)(G)!=="object")return this.m.error(this.z(T,(0,p.localize)(4,null,G.default?.path))),x;const ne=G.values||Object.create(null);return(0,R.$eq)(this.m,x,ne,ce)}catch{}return x}async u(T,x,Z){const G=(0,m.$Vg)(T,"package.nls.json"),se=(K,q)=>{q.forEach(N=>{this.m.error(this.z(T,(0,p.localize)(5,null,K?.path,(0,v.$dq)(N.error))))})},ce=K=>{this.m.error(this.z(T,(0,p.localize)(6,null,K?.path)))},ne=`${x.publisher}.${x.name}`,$e=Z.translations[ne];if($e)try{const K=u.URI.file($e),q=(await this.j.readFile(K)).value.toString(),N=[],z=(0,k.$vn)(q,N);return N.length>0?(se(K,N),{values:void 0,default:G}):(0,k.$En)(z)!=="object"?(ce(K),{values:void 0,default:G}):{values:z.contents?z.contents.package:void 0,default:G}}catch{return{values:void 0,default:G}}else{if(!await this.j.exists(G))return;let q;try{q=await this.y(T,Z)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const N=(await this.j.readFile(q.localized)).value.toString(),z=[],X=(0,k.$vn)(N,z);return z.length>0?(se(q.localized,z),{values:void 0,default:q.original}):(0,k.$En)(X)!=="object"?(ce(q.localized),{values:void 0,default:q.original}):{values:X,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(T,x){if(T)try{const Z=(await this.j.readFile(T)).value.toString();return(0,k.$vn)(Z,x)}catch{}}y(T,x){return new Promise((Z,G)=>{const se=ce=>{const ne=(0,m.$Vg)(T,`package.nls.${ce}.json`);this.j.exists(ne).then($e=>{$e&&Z({localized:ne,original:(0,m.$Vg)(T,"package.nls.json")});const K=ce.lastIndexOf("-");K===-1?Z({localized:(0,m.$Vg)(T,"package.nls.json"),original:null}):(ce=ce.substring(0,K),se(ce))})};if(x.devMode||x.pseudo||!x.language)return Z({localized:(0,m.$Vg)(T,"package.nls.json"),original:null});se(x.language)})}z(T,x){return`[${T.path}]: ${x}`}};fe=Le([Re(1,P.$bq),Re(2,O.$ml),Re(3,a.$Ok),Re(4,r.$Oj)],fe);let ue=class extends fe{constructor(T,x,Z,G,se,ce,ne){super(x,G,se,ce,ne),this.G=T,this.H=Z,this.D=this.B(new A.$gh(3e3)),this.F=this.B(new n.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(T){const x=this.M(T),Z=await this.I(x);if(this.C=T,Z&&Z.input&&Y.equals(Z.input,this.C))return this.m.debug("Using cached extensions scan result",T.location.toString()),this.D.trigger(()=>this.L()),Z.result.map(se=>(se.location=u.URI.revive(se.location),se));const G=await super.scanExtensions(T);return await this.J(x,{input:T,result:G}),G}async I(T){try{const x=await this.j.readFile(T),Z=JSON.parse(x.value.toString());return{result:Z.result,input:(0,b.$Rh)(Z.input)}}catch(x){this.m.debug("Error while reading the extension cache file:",T.path,(0,C.$0)(x))}return null}async J(T,x){try{await this.j.writeFile(T,D.$ue.fromString(JSON.stringify(x)))}catch(Z){this.m.debug("Error while writing the extension cache file:",T.path,(0,C.$0)(Z))}}async L(){if(!this.C)return;const T=this.M(this.C),x=await this.I(T);if(!x)return;const Z=x.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$Sn(G,Z))try{this.m.info("Invalidating Cache",Z,G),await this.j.del(T),this.F.fire()}catch(se){this.m.error(se)}}M(T){const x=this.N(T);return this.h.extUri.joinPath(x.cacheHome,T.type===0?l.$ym:l.$xm)}N(T){return T.type===0?this.H.defaultProfile:T.profile?this.h.extUri.isEqual(T.location,this.G.extensionsResource)?this.G:this.H.profiles.find(x=>this.h.extUri.isEqual(T.location,x.extensionsResource))??this.G:this.H.defaultProfile}};ue=Le([Re(2,I.$ol),Re(3,P.$bq),Re(4,O.$ml),Re(5,a.$Ok),Re(6,r.$Oj)],ue);function re(V,T){const x=(0,h.$jp)(V.manifest.publisher,V.manifest.name);return{id:x,identifier:new l.$Dm(x),isBuiltin:V.type===0,isUserBuiltin:V.type===1&&V.isBuiltin,isUnderDevelopment:T,extensionLocation:V.location,uuid:V.identifier.uuid,targetPlatform:V.targetPlatform,...V.manifest}}class te extends B{constructor(T,x,Z,G,se,ce,ne,$e,K,q,N,z){super(T,x,(0,m.$Vg)(Z,".vscode-oss-dev","extensions","control.json"),G,se,ce,ne,$e,K,q,N,z),this.S=(async()=>{if(w.$z)try{const X=await this.w.readFile(u.URI.file(w.$z));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}f(T){return this.S}}e.$jq=te}),define(Ee[267],ke([1,0,55,15,40,6,2,12,7,23,13,33]),function(le,e,i,A,S,D,C,k,v,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;let w=class extends C.$Uc{constructor(d,c){super(),this.b=d,this.f=c,this.a=new A.$oh(5)}async postUninstall(d){const c=this.g(d,"uninstall");c&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(c.script,"uninstall",c.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(g)}}));try{await $.Promises.rm(this.m(d))}catch(g){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(g)}}g(d,c){const g=`vscode:${c}`;if(d.location.scheme===k.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[g]=="string"){const u=d.manifest.scripts[g].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${g} should be a node script`),null):{script:(0,v.$kc)(d.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(d,c,g,u,p){return new Promise((f,h)=>{const l=this.j(d,c,g,p);let t;const a=o=>{t&&(clearTimeout(t),t=null),o?h(o):f(void 0)};l.on("error",o=>{a((0,S.$6i)(o)||"Unknown")}),l.on("exit",(o,r)=>{a(o?`post-${c} process exited with code ${o}`:void 0)}),u&&(t=setTimeout(()=>{t=null,l.kill(),h("timed out")},5e3))})}j(d,c,g,u){const p={silent:!0,execArgv:void 0},f=(0,i.fork)(d,[`--type=extension-post-${c}`,...g],p);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const h=D.Event.fromNodeEventEmitter(f.stdout,"data"),l=D.Event.fromNodeEventEmitter(f.stderr,"data");h(o=>this.f.info(u.identifier.id,u.manifest.version,`post-${c}`,o)),l(o=>this.f.error(u.identifier.id,u.manifest.version,`post-${c}`,o));const t=D.Event.any(D.Event.map(h,o=>({data:`%c${o}`,format:[""]})),D.Event.map(l,o=>({data:`%c${o}`,format:["color: red"]})));return D.Event.debounce(t,(o,r)=>o?{data:o.data+r.data,format:[...o.format,...r.format]}:{data:r.data,format:r.format},100)(o=>{console.group(u.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),f}m(d){return(0,v.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$lq=w,e.$lq=w=Le([Re(0,y.$ol),Re(1,E.$Oj)],w)}),define(Ee[127],ke([1,0,15,14,20,40,10,6,62,2,24,12,7,19,56,11,3,22,23,80,191,82,26,266,31,36,49,59,251,267,222,242,252,81,16,5,13,32,28,34,33]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f,h,l,t,a,o,r,s,n,b,P,I,O,R,j,B,Y,fe,ue,re,te,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.$qq=e.$pq=void 0,e.$pq=(0,Y.$ji)(o.$Uo);const T=".vsctmp";let x=class extends a.$9p{constructor(K,q,N,z,X,ae,Q,J,U,L,H,_){super(K,q,H,N,L,_),this.eb=X,this.fb=ae,this.gb=Q,this.hb=U,this.db=new Map,this.qb=new E.$Cc;const ee=this.B(J.createInstance(P.$lq));this.ab=this.B(J.createInstance(Z,ie=>ee.postUninstall(ie))),this.bb=this.B(new O.$nq(_,U,H,this,this.F)),this.cb=this.B(J.createInstance(b.$kq));const de=this.B(new R.$oq(this,this.eb,_,ae,H,U,N));this.B(de.onDidChangeExtensionsByAnotherSource(ie=>this.pb(ie))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,r.$rp)(this.hb,this.F)),this.ib}async zip(K){this.F.trace("ExtensionManagementService#zip",K.identifier.id);const q=await this.ob(K),N=await(0,f.zip)((0,m.$Vg)(this.cb.extensionsDownloadDir,(0,u.$Eg)()).fsPath,q);return g.URI.file(N)}async unzip(K){return this.F.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:q,cleanup:N}=await this.kb(K),z=w.$lc(q.fsPath);try{return await(0,I.$mq)(z)}finally{await N()}}getInstalled(K,q=this.H.defaultProfile.extensionsResource,N={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(K??null,q,N)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.ab.scanUserExtensionAtLocation(K)}async install(K,q={}){this.F.trace("ExtensionManagementService#install",K.toString());const{location:N,cleanup:z}=await this.kb(K);try{const X=await(0,I.$mq)(w.$lc(N.fsPath)),ae=(0,r.$lp)(X.publisher,X.name);if(X.engines&&X.engines.vscode&&!(0,j.$yp)(X.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,ae,this.G.version));const J=(await this.I([{manifest:X,extension:N,options:q}])).find(({identifier:U})=>(0,r.$gp)(U,{id:ae}));if(J?.local)return J.local;throw J?.error?J.error:(0,a.$$p)(new Error(`Unknown error while installing extension ${ae}`))}finally{await z()}}async installFromLocation(K,q){this.F.trace("ExtensionManagementService#installFromLocation",K.toString());const N=await this.ab.scanUserExtensionAtLocation(K);if(!N||!N.manifest.name||!N.manifest.version)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.tb([[N,{source:"resource"}]],q),this.F.info("Successfully installed extension",N.identifier.id,q.toString()),N}async installExtensionsFromProfile(K,q,N){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",K,q.toString(),N.toString());const z=(await this.getInstalled(1,q)).filter(X=>K.some(ae=>(0,r.$gp)(ae,X.identifier)));if(z.length){const X=await Promise.all(z.map(ae=>this.ab.scanMetadata(ae,q)));await this.tb(z.map((ae,Q)=>[ae,X[Q]]),N),this.F.info("Successfully installed extensions",z.map(ae=>ae.identifier.id),N.toString())}return z}async updateMetadata(K,q,N=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",K.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0,q.hasPreReleaseVersion=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),K=await this.ab.updateMetadata(K,q,N),this.bb.invalidate(N),this.w.fire(K),K}async reinstallFromGallery(K){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const q=await this.getTargetPlatform(),[N]=await this.z.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:q,compatible:!0},S.CancellationToken.None);if(!N)throw new Error(h.localize(2,null));await this.ab.setUninstalled(K);try{await this.ab.removeUninstalledExtension(K)}catch(z){throw new Error(h.localize(3,null,(0,D.$6i)(z)))}return this.installFromGallery(N)}$(K,q,N,z){return this.ab.copyExtension(K,q,N,z)}copyExtensions(K,q){return this.ab.copyExtensions(K,q,{version:this.G.version,date:this.G.date})}markAsUninstalled(...K){return this.ab.setUninstalled(...K)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(K){this.F.error(K)}}async download(K,q,N){const{location:z}=await this.cb.download(K,q,!N);return z}async kb(K){if(K.scheme===y.Schemas.file)return{location:K,async cleanup(){}};this.F.trace("Downloading extension from",K.toString());const q=(0,m.$Vg)(this.cb.extensionsDownloadDir,(0,u.$Eg)());return await this.gb.download(K,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.hb.del(q)}catch(z){this.F.error(z)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(K,q,N){if(g.URI.isUri(q))return new ce(K,q,N,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const z=r.$hp.create(q).toString();let X=this.db.get(z);return X||(this.db.set(z,X=new se(K,q,N,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),X.waitUntilTaskIsFinished().finally(()=>this.db.delete(z))),X}Z(K,q){return new ne(K,q.profileLocation,this.fb)}async ob(K){const q=async z=>{let X=await p.Promises.readdir(z);X=X.map(J=>w.$kc(z,J));const ae=await Promise.all(X.map(J=>p.Promises.stat(J)));let Q=Promise.resolve([]);return ae.forEach((J,U)=>{const L=X[U];J.isFile()&&(Q=Q.then(H=>[...H,L])),J.isDirectory()&&(Q=Q.then(H=>q(L).then(_=>[...H,..._])))}),Q};return(await q(K.location.fsPath)).map(z=>({path:`extension/${w.$mc(K.location.fsPath,z)}`,localPath:z}))}async pb({added:K,removed:q}){if(q){const N=K&&this.D.extUri.isEqual(q.profileLocation,K.profileLocation)?q.extensions.filter(z=>K.extensions.every(X=>!(0,r.$gp)(X,z))):q.extensions;for(const z of N)this.F.info("Extensions removed from another source",z.id,q.profileLocation.toString()),this.u.fire({identifier:z,profileLocation:q.profileLocation})}if(K){const z=(await this.getInstalled(1,K.profileLocation)).filter(X=>K.extensions.some(ae=>(0,r.$gp)(ae,X.identifier)));this.s.fire(z.map(X=>(this.F.info("Extensions added from another source",X.identifier.id,K.profileLocation.toString()),{identifier:X.identifier,local:X,profileLocation:K.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(q=>this.qb.add(q)));const K=await this.hb.resolve(this.eb.userExtensionsLocation);for(const q of K.children??[])q.isDirectory&&this.qb.add(q.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(q=>this.sb(q)))}async sb(K){if(!K.affects(this.eb.userExtensionsLocation,1))return;const q=[];for(const N of K.rawAdded){if(this.qb.has(N)||!this.D.extUri.isEqual(this.D.extUri.dirname(N),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(N,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(N).startsWith(".")||!(await this.hb.stat(N)).isDirectory)continue;const z=await this.ab.scanUserExtensionAtLocation(N);z&&z.installedTimestamp===void 0&&(this.qb.add(N),q.push(z))}q.length&&(await this.tb(q.map(N=>[N,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(N=>N.identifier.id)))}async tb(K,q){const N=K.map(z=>z[0]);await this.ub(N),await this.fb.addExtensionsToProfile(K,q),this.s.fire(N.map(z=>({local:z,identifier:z.identifier,operation:1,profileLocation:q})))}async ub(K){const q=await this.ab.getUninstalledExtensions();for(const N of K){const z=r.$hp.create(N);q[z.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",z.id),await this.ab.setInstalled(z),this.F.info("Removed the extension from uninstalled list:",z.id))}}};e.$qq=x,e.$qq=x=Le([Re(0,o.$Ro),Re(1,re.$Nl),Re(2,fe.$Oj),Re(3,t.$qi),Re(4,n.$fq),Re(5,s.$bq),Re(6,l.$wo),Re(7,Y.$hi),Re(8,B.$Ok),Re(9,ue.$8j),Re(10,te.$ml),Re(11,V.$ol)],x);let Z=class extends $.$Uc{constructor(K,q,N,z,X,ae){super(),this.j=K,this.m=q,this.n=N,this.s=z,this.t=X,this.u=ae,this.h=this.B(new k.$7d),this.onExtract=this.h.event,this.c=(0,m.$Vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new i.$ph}async cleanUp(){await this.H(),await this.G()}async scanExtensions(K,q,N){const z={includeInvalid:!0,profileLocation:q,productVersion:N};let X=[];return K===null||K===0?X.push(...await this.n.scanAllExtensions({includeInvalid:!0},z,!1)):K===1&&X.push(...await this.n.scanUserExtensions(z)),X=K!==null?X.filter(ae=>ae.type===K):X,Promise.all(X.map(ae=>this.F(ae)))}async scanAllUserExtensions(K){const q=await this.n.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(q.map(N=>this.F(N)))}async scanUserExtensionAtLocation(K){try{const q=await this.n.scanExistingExtension(K,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(K,q,N,z,X){const ae=K.toString(),Q=g.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,u.$Eg)()}`)),J=g.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,ae));let U=await this.m.exists(J);if(U&&z){try{await this.y(K.id,J,"removeExisting")}catch{throw new o.$So(h.localize(4,null,J.fsPath,K.id),o.ExtensionManagementErrorCode.Delete)}U=!1}if(U)await this.n.updateMetadata(J,N);else try{try{this.u.trace(`Started extracting the extension from ${q} to ${J.fsPath}`),await(0,f.$7p)(q,Q.fsPath,{sourcePath:"extension",overwrite:!0},X),this.u.info(`Extracted extension to ${J}:`,K.id)}catch(L){let H=o.ExtensionManagementErrorCode.Extract;throw L instanceof f.$5p&&(L.type==="CorruptZip"?H=o.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(H=o.ExtensionManagementErrorCode.IncompleteZip)),new o.$So(L.message,H)}await this.n.updateMetadata(Q,N);try{this.u.trace(`Started renaming the extension from ${Q.fsPath} to ${J.fsPath}`),await this.C(Q.fsPath,J.fsPath),this.u.info("Renamed to",J.fsPath)}catch(L){if(L.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.u.info(`Rename failed because of ${(0,C.$0)(L)}. Deleted from extracted location`,Q),L}this.h.fire(J)}catch(L){try{await this.m.del(Q,{recursive:!0})}catch{}throw L}return this.D(J,1)}async scanMetadata(K,q){return q?(await this.w(K,q))?.metadata:this.n.scanMetadata(K.location)}async w(K,q){return(await this.s.scanProfileExtensions(q)).find(z=>(0,r.$gp)(z.identifier,K.identifier))}async updateMetadata(K,q,N){return N?await this.s.updateMetadata([[K,q]],N):await this.n.updateMetadata(K.location,q),this.D(K.location,K.type,N)}getUninstalledExtensions(){return this.z()}async setUninstalled(...K){const q=K.map(N=>r.$hp.create(N));await this.z(N=>q.forEach(z=>{N[z.toString()]=!0,this.u.info("Marked extension as uninstalled",z.toString())}))}async setInstalled(K){await this.z(q=>delete q[K.toString()])}async removeExtension(K,q){if(this.t.extUri.isEqualOrParent(K.location,this.n.userExtensionsLocation))return this.y(K.identifier.id,K.location,q)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.z(q=>delete q[r.$hp.create(K).toString()])}async copyExtension(K,q,N,z){const X=await this.w(K,q),ae=await this.w(K,N);if(z={...X?.metadata,...z},ae)if(this.t.extUri.isEqual(ae.location,K.location))await this.s.updateMetadata([[K,{...ae.metadata,...z}]],N);else{const Q=await this.D(ae.location,K.type,N);await this.s.removeExtensionFromProfile(Q,N),await this.s.addExtensionsToProfile([[K,{...ae.metadata,...z}]],N)}else await this.s.addExtensionsToProfile([[K,z]],N);return this.D(K.location,K.type,N)}async copyExtensions(K,q,N){const z=await this.scanExtensions(1,K,N),X=await Promise.all(z.filter(ae=>!ae.isApplicationScoped).map(async ae=>[ae,await this.scanMetadata(ae,K)]));await this.s.addExtensionsToProfile(X,q)}async y(K,q,N){this.u.trace(`Deleting ${N} extension from disk`,K,q.fsPath);const z=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,v.$9i)((0,u.$Eg)()).toString(16)}${T}`);await this.C(q.fsPath,z.fsPath),await this.m.del(z,{recursive:!0}),this.u.info(`Deleted ${N} extension from disk`,K,q.fsPath)}async z(K){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(z){if((0,B.$6k)(z)!==1)throw z}let N={};if(q)try{N=JSON.parse(q)}catch{}return K&&(K(N),Object.keys(N).length?await this.m.writeFile(this.c,A.$ue.fromString(JSON.stringify(N))):await this.m.del(this.c)),N})}async C(K,q){try{await p.Promises.rename(K,q,2*60*1e3)}catch(N){throw new o.$So(N.message||h.localize(5,null,K,q),N.code||o.ExtensionManagementErrorCode.Rename)}}async D(K,q,N){if(N){const X=(await this.n.scanUserExtensions({profileLocation:N})).find(ae=>this.t.extUri.isEqual(ae.location,K));if(X)return this.F(X)}else{const z=await this.n.scanExistingExtension(K,q,{includeInvalid:!0});if(z)return this.F(z)}throw new Error(h.localize(6,null,K.path))}async F(K){const q=await this.m.resolve(K.location);let N,z;return q.children&&(N=q.children.find(({name:X})=>/^readme(\.txt|\.md|)$/i.test(X))?.resource,z=q.children.find(({name:X})=>/^changelog(\.txt|\.md|)$/i.test(X))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:N,changelogUrl:z,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!K.metadata?.hasPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned,isWorkspaceScoped:!1,source:K.metadata?.source??(K.identifier.uuid?"gallery":"vsix")}}async G(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(K));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const X of q)K[r.$hp.create(X).toString()]||N.add(X.identifier.id.toLowerCase());try{const X=(0,r.$mp)(q,ae=>ae.identifier);await i.Promises.settled(X.map(async ae=>{const Q=ae.sort((J,U)=>d.rcompare(J.manifest.version,U.manifest.version))[0];N.has(Q.identifier.id.toLowerCase())||await this.j(await this.F(Q))}))}catch(X){this.u.error(X)}const z=q.filter(X=>X.metadata&&K[r.$hp.create(X).toString()]);await Promise.allSettled(z.map(X=>this.removeUninstalledExtension(X)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,B.$6k)(q)!==1&&this.u.error(q);return}if(K?.children)try{await Promise.allSettled(K.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(T))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(N){(0,B.$6k)(N)!==1&&this.u.error(N)}}}))}catch{}}};e.$rq=Z,e.$rq=Z=Le([Re(1,B.$Ok),Re(2,n.$fq),Re(3,s.$bq),Re(4,te.$ml),Re(5,fe.$Oj)],Z);class G extends a.$_p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,c.$3f)(this.options.operation)?this.l:this.options.operation}constructor(K,q,N,z,X,ae,Q,J,U){super(),this.identifier=K,this.source=q,this.options=N,this.m=z,this.n=X,this.o=ae,this.p=Q,this.q=J,this.s=U,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(K){const[q,N]=await this.x(K);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,N]],this.j,!q.isValid),q}async u({zipPath:K,key:q,metadata:N},z,X){let ae=await this.v(q);return ae?ae=await this.m.updateMetadata(ae,N):(this.s.trace("Extracting extension...",q.id),ae=await this.m.extractUserExtension(q,K,N,z,X),this.s.info("Extracting extension completed.",q.id)),ae}async v(K){return await this.w(K)?(this.s.trace("Removing the extension from uninstalled list:",K.id),await this.m.setInstalled(K),this.s.info("Removed the extension from uninstalled list:",K.id),(await this.m.scanAllUserExtensions(!0)).find(z=>r.$hp.create(z).equals(K))):void 0}async w(K){return!!(await this.m.getUninstalledExtensions())[K.toString()]}}class se extends G{constructor(K,q,N,z,X,ae,Q,J,U,L,H){super(q.identifier,q,N,X,ae,Q,J,U,L),this.y=q,this.z=z,this.A=H}async x(K){let q;try{q=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(X){throw new o.$So(X,o.ExtensionManagementErrorCode.Scanning)}const N=q.find(X=>(0,r.$gp)(X.identifier,this.y.identifier));N&&(this.l=3);const z={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:N?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??N?.pinned,preRelease:(0,c.$2f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||N?.preRelease,source:"gallery"};if(N?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(N,z),z]}catch(X){throw new o.$So((0,C.$0)(X),o.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(z,K)}catch(X){if(X instanceof o.$So&&(X.code===o.ExtensionManagementErrorCode.CorruptZip||X.code===o.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const ae=await this.C(z,K);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),ae}catch(ae){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),ae}}else throw X}}async C(K,q){const{location:N,verificationStatus:z}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=z,this.D(N.fsPath),[await this.u({zipPath:N.fsPath,key:r.$hp.create(this.y),metadata:K},!1,q),K]}catch(X){try{await this.z.delete(N)}catch(ae){this.s.warn("Error while deleting the downloaded file",N.toString(),(0,C.$0)(ae))}throw X}}async D(K){try{await(0,I.$mq)(K)}catch(q){throw new o.$So((0,a.$0p)(q).message,o.ExtensionManagementErrorCode.Invalid)}}}e.$sq=se;class ce extends G{constructor(K,q,N,z,X,ae,Q,J,U,L){super({id:(0,r.$lp)(K.publisher,K.name)},q,N,X,ae,Q,J,U,L),this.y=K,this.z=q,this.A=z}async h(K){const q=await super.h(K);return this.D(q,K),q}async x(K){const q=new r.$hp(this.identifier,this.y.version),z=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(Q=>(0,r.$gp)(this.identifier,Q.identifier)),X={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:"vsix"};if(z)if(this.l=3,q.equals(new r.$hp(z.identifier,z.manifest.version)))try{await this.m.removeExtension(z,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(z.manifest.version,this.y.version)&&await this.m.setUninstalled(z);else{const Q=await this.v(q);if(Q)try{await this.m.removeExtension(Q,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.$lc(this.z.fsPath),key:q,metadata:X},!0,K),X]}async D(K,q){try{let[N]=await this.A.getExtensions([{id:K.identifier.id,version:K.manifest.version}],q);if(N||([N]=await this.A.getExtensions([{id:K.identifier.id}],q)),N){const z={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,hasPreReleaseVersion:K.hasPreReleaseVersion||N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(K,z,this.options.profileLocation)}}catch{}}}class ne extends a.$_p{constructor(K,q,N){super(),this.extension=K,this.j=q,this.k=N}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Ee[128],ke([1,0,13,33,34,28,49,16,26,3]),function(le,e,i,A,S,D,C,k,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=void 0;let E=class extends C.$cq{constructor(w,m,d,c,g,u){super($.URI.file(w.extensionsPath),m,d,c,g,u)}};e.$$P=E,e.$$P=E=Le([Re(0,v.$qi),Re(1,k.$Ok),Re(2,A.$ol),Re(3,S.$ml),Re(4,D.$Nl),Re(5,i.$Oj)],E)}),define(Ee[268],ke([1,0,15,6,2,43,11,177,5,33]),function(le,e,i,A,S,D,C,k,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Op=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mp=e.$Lp=e.$Kp=void 0,e.$Np=m,e.$Pp=c,e.$Rp=u,e.$Kp="__$__isNewStorageMarker",e.$Lp="__$__targetStorageMarker",e.$Mp=(0,v.$ii)("storageService");var E;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var y;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var w;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function m(p){const f=p.get(e.$Lp);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}class d extends S.$Uc{static{this.a=60*1e3}constructor(f={flushInterval:d.a}){super(),this.m=f,this.b=this.B(new A.$0d),this.c=this.B(new A.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new i.$uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(f,h,l){return A.Event.filter(this.b.event,t=>t.scope===f&&(h===void 0||t.key===h),l)}n(){this.j.value=(0,i.$yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(f,h){const{key:l,external:t}=h;if(l===e.$Lp){switch(f){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:l,target:this.J(f)[l],external:t})}w(f){this.f.fire({reason:f})}get(f,h,l){return this.P(h)?.get(f,l)}getBoolean(f,h,l){return this.P(h)?.getBoolean(f,l)}getNumber(f,h,l){return this.P(h)?.getNumber(f,l)}getObject(f,h,l){return this.P(h)?.getObject(f,l)}storeAll(f,h){this.y(()=>{for(const l of f)this.store(l.key,l.value,l.scope,l.target,h)})}store(f,h,l,t,a=!1){if((0,C.$5f)(h)){this.remove(f,l,a);return}this.y(()=>{this.z(f,l,t),this.P(l)?.set(f,h,a)})}remove(f,h,l=!1){this.y(()=>{this.z(f,h,void 0),this.P(h)?.delete(f,l)})}y(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,h){const l=[],t=this.J(f);for(const a of Object.keys(t))t[a]===h&&l.push(a);return l}z(f,h,l,t=!1){const a=this.J(h);typeof l=="number"?a[f]!==l&&(a[f]=l,this.P(h)?.set(e.$Lp,JSON.stringify(a),t)):typeof a[f]=="number"&&(delete a[f],this.P(h)?.set(e.$Lp,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(f){switch(f){case-1:return this.I;case 0:return this.G;default:return this.D}}L(f){const h=this.P(f);return h?m(h):Object.create(null)}isNew(f){return this.getBoolean(e.$Kp,f)===!0}async flush(f=E.NONE){this.f.fire({reason:f});const h=this.P(-1),l=this.P(0),t=this.P(1);switch(f){case E.NONE:await i.Promises.settled([h?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await i.Promises.settled([h?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return u(f,h,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(f){return await this.flush(),this.P(f)?.optimize()}async switch(f,h){return this.w(E.NONE),(0,$.$nl)(f)?this.R(f,h):this.S(f,h)}M(f,h){return!(f.id===h.id||c(h)&&c(f))}N(f,h,l){this.y(()=>{const t=new Set;for(const[a,o]of f)t.add(a),h.get(a)!==o&&this.u(l,{key:a,external:!0});for(const[a]of h.items)t.has(a)||this.u(l,{key:a,external:!0})})}}e.$Op=d;function c(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class g extends d{constructor(){super(),this.U=this.B(new k.$Ip(new k.$Jp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$Ip(new k.$Jp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$Ip(new k.$Jp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(f=>this.u(1,f))),this.B(this.W.onDidChangeStorage(f=>this.u(0,f))),this.B(this.U.onDidChangeStorage(f=>this.u(-1,f)))}P(f){switch(f){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(f){return!1}}e.$Qp=g;async function u(p,f,h,l,t,a){const o=j=>{try{return JSON.parse(j)}catch{return j}},r=new Map,s=new Map;p.forEach((j,B)=>{r.set(B,j),s.set(B,o(j))});const n=new Map,b=new Map;f.forEach((j,B)=>{n.set(B,j),b.set(B,o(j))});const P=new Map,I=new Map;h.forEach((j,B)=>{P.set(B,j),I.set(B,o(j))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const O=[];if(r.forEach((j,B)=>{O.push({key:B,value:j})}),console.table(O),console.groupEnd(),console.log(s),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];n.forEach((B,Y)=>{j.push({key:Y,value:B})}),console.table(j),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${a})`);const R=[];P.forEach((j,B)=>{R.push({key:B,value:j})}),console.table(R),console.groupEnd(),console.log(I)}}),define(Ee[129],ke([1,0,18,20,10,4,30,11,3,25,26,31,36,81,16,13,32,48,253,268,28,61]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Up=ce;const t=D.$o?"web":(0,y.$No)(D.$u,C.$fc),a="X-Market-Search-Activity-Id";var o;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished",z[z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function r(...z){return String(z.reduce((X,ae)=>X|ae,0))}var s;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},b={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class O{constructor(X=I){this.d=X}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(X,ae=this.d.pageSize){return new O({...this.d,pageNumber:X,pageSize:ae})}withFilter(X,...ae){const Q=[...this.d.criteria,...ae.length?ae.map(J=>({filterType:X,value:J})):[{filterType:X}]];return new O({...this.d,criteria:Q})}withSortBy(X){return new O({...this.d,sortBy:X})}withSortOrder(X){return new O({...this.d,sortOrder:X})}withFlags(...X){return new O({...this.d,flags:X.reduce((ae,Q)=>ae|Q,0)})}withAssetTypes(...X){return new O({...this.d,assetTypes:X})}withSource(X){return new O({...this.d,source:X})}get raw(){const{criteria:X,pageNumber:ae,pageSize:Q,sortBy:J,sortOrder:U,flags:L,assetTypes:H}=this.d;return{filters:[{criteria:X,pageNumber:ae,pageSize:Q,sortBy:J,sortOrder:U}],assetTypes:H,flags:L}}get searchText(){const X=this.d.criteria.filter(ae=>ae.filterType===s.SearchText)[0];return X&&X.value?X.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(X=>String(X.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(z,X){const ae=(z||[]).filter(Q=>Q.statisticName===X)[0];return ae?ae.value:0}function j(z){const X="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(Q=>Q.assetType.indexOf(X)===0).reduce((Q,J)=>{const U=fe(z,J.assetType);return U&&Q.push([J.assetType.substring(X.length),U]),Q},[])}function B(z){if(z.properties){const X=z.properties.filter(J=>J.key===n.Repository),ae=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=X.filter(J=>ae.test(J.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return fe(z,n.Repository)}function Y(z){return{uri:`${z.fallbackAssetUri}/${n.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${n.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function fe(z,X){return z.files.filter(Q=>Q.assetType===X)[0]?{uri:`${z.assetUri}/${X}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${X}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function ue(z,X){const ae=z.properties?z.properties.filter(J=>J.key===X):[],Q=ae.length>0&&ae[0].value;return Q?Q.split(",").map(J=>(0,w.$kp)(J)):[]}function re(z){const X=z.properties?z.properties.filter(ae=>ae.key===b.Engine):[];return X.length>0&&X[0].value||""}function te(z){const X=z.properties?z.properties.filter(ae=>ae.key===b.PreRelease):[];return X.length>0&&X[0].value==="true"}function V(z){const X=z.properties?z.properties.filter(Q=>Q.key===b.LocalizedLanguages):[],ae=X.length>0&&X[0].value||"";return ae?ae.split(","):[]}function T(z){return z.properties?.find(X=>X.key===b.SponsorLink)?.value}function x(z){return z.properties?.find(X=>X.key===b.SupportLink)?.value}function Z(z){return z.indexOf("preview")!==-1}function G(z){return z.targetPlatform?(0,y.$Mo)(z.targetPlatform):"undefined"}function se(z){const X=(0,i.$Mb)(z.versions.map(G)),ae=!!z.tags?.includes(y.$Ho),Q=X.indexOf("web");return ae?Q===-1&&X.push("web"):Q!==-1&&X.splice(Q,1),X}function ce(z,X){for(let ae=0;ae<z.length;ae++){const Q=z[ae];if(Q.version===z[ae-1]?.version){let J=ae;if(G(Q)===X)for(;J>0&&z[J-1].version===Q.version;)J--;J!==ae&&(z.splice(ae,1),z.splice(J,0,Q))}}return z}function ne(z,X,ae){z.telemetryData={index:X,querySource:ae,queryActivityId:z.queryContext?.[a]}}function $e(z,X,ae,Q){const J=z.versions[0],U={manifest:fe(X,n.Manifest),readme:fe(X,n.Details),changelog:fe(X,n.Changelog),license:fe(X,n.License),repository:B(X),download:Y(X),icon:fe(X,n.Icon),signature:fe(X,n.Signature),coreTranslations:j(X)};return{identifier:{id:(0,w.$lp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:X.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,publisherSponsorLink:T(J),description:z.shortDescription??"",installCount:R(z.statistics,"install"),rating:R(z.statistics,"averagerating"),ratingCount:R(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:ae,assets:U,properties:{dependencies:ue(X,b.Dependency),extensionPack:ue(X,b.ExtensionPack),engine:re(X),localizedLanguages:V(X),targetPlatform:G(X),isPreReleaseVersion:te(X)},hasPreReleaseVersion:te(J),hasReleaseVersion:!0,preview:Z(z.flags),isSigned:!!U.signature,queryContext:Q,supportLink:x(J)}}let K=class{constructor(X,ae,Q,J,U,L,H,_){this.k=ae,this.l=Q,this.n=J,this.o=U,this.q=L,this.u=H,this.w=_;const ee=H.extensionsGallery,de=ee?.servicePPEUrl&&_.getValue("_extensionsGallery.enablePPE");this.d=de?ee.servicePPEUrl:ee?.serviceUrl,this.g=de?void 0:ee?.searchUrl,this.h=ee?.controlUrl,this.j=(0,p.$Tp)(H.version,H,this.n,this.w,this.q,X,this.o)}x(X=""){return`${this.d}${X}`}isEnabled(){return!!this.d}async getExtensions(X,ae,Q){const J=A.CancellationToken.isCancellationToken(ae)?{}:ae,U=A.CancellationToken.isCancellationToken(ae)?ae:Q,L=[],H=[],_=[],ee=[];let de=!0;for(const we of X){we.uuid?H.push(we.uuid):L.push(we.id);const Ie=!!(we.version||we.preRelease);_.push({id:we.id,uuid:we.uuid,includePreRelease:Ie}),we.version&&ee.push({id:we.id,uuid:we.uuid,version:we.version}),de=de&&!!we.hasPreRelease&&!Ie}if(!H.length&&!L.length)return[];let ie=new O().withPage(1,X.length);H.length&&(ie=ie.withFilter(s.ExtensionId,...H)),L.length&&(ie=ie.withFilter(s.ExtensionName,...L)),(J.queryAllVersions||de)&&(ie=ie.withFlags(ie.flags,o.IncludeVersions)),J.source&&(ie=ie.withSource(J.source));const{extensions:me}=await this.z(ie,{targetPlatform:J.targetPlatform??t,includePreRelease:_,versions:ee,compatible:!!J.compatible,productVersion:J.productVersion??{version:this.u.version,date:this.u.date}},U);return J.source&&me.forEach((we,Ie)=>ne(we,Ie,J.source)),me}async getCompatibleExtension(X,ae,Q,J={version:this.u.version,date:this.u.date}){if((0,y.$Oo)(X.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(X,ae,Q))return X;const U=new O().withFlags(o.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,X.identifier.uuid),{extensions:L}=await this.z(U,{targetPlatform:Q,compatible:!0,includePreRelease:ae,productVersion:J},A.CancellationToken.None);return L[0]||null}async isExtensionCompatible(X,ae,Q,J={version:this.u.version,date:this.u.date}){if(!(0,y.$Po)(X.properties.targetPlatform,X.allTargetPlatforms,Q)||!ae&&X.properties.isPreReleaseVersion)return!1;let U=X.properties.engine;if(!U){const L=await this.getManifest(X,A.CancellationToken.None);if(!L)throw new Error("Manifest was not found");U=L.engines.vscode}return(0,m.$yp)(U,J.version,J.date)}async y(X,ae,Q,J,U,L,H={version:this.u.version,date:this.u.date}){if(!(0,y.$Po)(G(ae),U,L)||Q!=="any"&&te(ae)!==(Q==="prerelease"))return!1;if(J)try{const _=await this.E(X,ae);if(!(0,m.$yp)(_,H.version,H.date))return!1}catch(_){return this.l.error(`Error while getting the engine for the version ${ae.version}.`,(0,S.$0)(_)),!1}return!0}async query(X,ae){let Q=X.text||"";const J=X.pageSize??50;let U=new O().withPage(1,J);Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ie,me)=>(U=U.withFilter(s.Category,me||ie),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ie,me)=>(U=U.withFilter(s.Tag,me||ie),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(U=U.withFilter(s.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),U=U.withFilter(s.SearchText,Q)),U=U.withSortBy(0)):X.ids?U=U.withFilter(s.ExtensionId,...X.ids):X.names?U=U.withFilter(s.ExtensionName,...X.names):U=U.withSortBy(4),typeof X.sortBy=="number"&&(U=U.withSortBy(X.sortBy)),typeof X.sortOrder=="number"&&(U=U.withSortOrder(X.sortOrder)),X.source&&(U=U.withSource(X.source));const L=async(de,ie)=>{const{extensions:me,total:we}=await this.z(de,{targetPlatform:t,compatible:!1,includePreRelease:!!X.includePreRelease,productVersion:X.productVersion??{version:this.u.version,date:this.u.date}},ie);return me.forEach((Ie,Oe)=>ne(Ie,(de.pageNumber-1)*de.pageSize+Oe,X.source)),{extensions:me,total:we}},{extensions:H,total:_}=await L(U,ae),ee=async(de,ie)=>{if(ie.isCancellationRequested)throw new S.$5;const{extensions:me}=await L(U.withPage(de+1),ie);return me};return{firstPage:H,total:_,pageSize:U.pageSize,getPage:ee}}async z(X,ae,Q){const J=X.flags;X.flags&o.IncludeLatestVersionOnly&&X.flags&o.IncludeVersions&&(X=X.withFlags(X.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(X.flags&o.IncludeLatestVersionOnly)&&!(X.flags&o.IncludeVersions)&&(X=X.withFlags(X.flags,o.IncludeLatestVersionOnly)),ae.versions?.length&&(X=X.withFlags(X.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),X=X.withFlags(X.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:U,total:L,context:H}=await this.B(X,Q);if(!(X.flags&o.IncludeLatestVersionOnly)){const ie=[];for(const me of U){const we=await this.A(me,ae,H);we&&ie.push(we)}return{extensions:ie,total:L}}const ee=[],de=new Map;for(let ie=0;ie<U.length;ie++){const me=U[ie],we={id:(0,w.$lp)(me.publisher.publisherName,me.extensionName),uuid:me.extensionId},Ie=(0,k.$2f)(ae.includePreRelease)?ae.includePreRelease:!!ae.includePreRelease.find(ge=>(0,w.$gp)(ge,we))?.includePreRelease;if(ae.compatible&&(0,y.$Oo)(se(me),ae.targetPlatform))continue;const Oe=await this.A(me,ae,H);!Oe||Oe.properties.isPreReleaseVersion&&(!Ie||!Oe.hasReleaseVersion)||!Oe.properties.isPreReleaseVersion&&Oe.properties.targetPlatform!==ae.targetPlatform&&Oe.hasPreReleaseVersion?de.set(me.extensionId,ie):ee.push([ie,Oe])}if(de.size){const ie=new l.$3d,me=new O().withFlags(J&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,de.size).withFilter(s.ExtensionId,...de.keys()),{extensions:we}=await this.z(me,ae,Q);this.o.publicLog2("galleryService:additionalQuery",{duration:ie.elapsed(),count:de.size});for(const Ie of we){const Oe=de.get(Ie.identifier.uuid);ee.push([Oe,Ie])}}return{extensions:ee.sort((ie,me)=>ie[0]-me[0]).map(([,ie])=>ie),total:L}}async A(X,ae,Q){const J={id:(0,w.$lp)(X.publisher.publisherName,X.extensionName),uuid:X.extensionId},U=ae.versions?.find(ee=>(0,w.$gp)(ee,J))?.version,L=(0,k.$2f)(ae.includePreRelease)?ae.includePreRelease:!!ae.includePreRelease.find(ee=>(0,w.$gp)(ee,J))?.includePreRelease,H=se(X),_=ce(X.versions,ae.targetPlatform);if(ae.compatible&&(0,y.$Oo)(H,ae.targetPlatform))return null;for(let ee=0;ee<_.length;ee++){const de=_[ee];if(!(U&&de.version!==U)){if(await this.y((0,w.$lp)(X.publisher.publisherName,X.extensionName),de,L?"any":"release",ae.compatible,H,ae.targetPlatform,ae.productVersion))return $e(X,de,H,Q);if(U&&de.version===U)return null}}return U||ae.compatible?null:$e(X,X.versions[0],H)}async B(X,ae){if(!this.isEnabled())throw new Error("No extension gallery service configured.");X=X.withFlags(X.flags,o.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,r(o.Unpublished));const Q=await this.j,J=JSON.stringify(X.raw),U={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},L=new l.$3d;let H,_,ee=0;try{if(H=await this.k.request({type:"POST",url:this.g&&X.criteria.some(ie=>ie.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:J,headers:U},ae),H.res.statusCode&&H.res.statusCode>=400&&H.res.statusCode<500)return{galleryExtensions:[],total:ee};const de=await(0,u.$Fp)(H);if(de){const ie=de.results[0],me=ie.extensions,we=ie.resultMetadata&&ie.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ee=we&&we.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:ee,context:{[a]:H.res.headers.activityid}}}return{galleryExtensions:[],total:ee}}catch(de){const ie=(0,S.$4)(de)?y.ExtensionGalleryErrorCode.Cancelled:(0,S.$0)(de).startsWith("XHR timeout")?y.ExtensionGalleryErrorCode.Timeout:y.ExtensionGalleryErrorCode.Failed;throw _=new y.$To((0,S.$0)(de),ie),_}finally{this.o.publicLog2("galleryService:query",{...X.telemetryData,requestBodySize:String(J.length),duration:L.elapsed(),success:!!H&&(0,u.$Bp)(H),responseBodySize:H?.res.headers["Content-Length"],statusCode:H?String(H.res.statusCode):void 0,errorCode:_?.code,count:String(ee)})}}async reportStatistic(X,ae,Q,J){if(!this.isEnabled())return;const U=D.$o?this.x(`/itemName/${X}.${ae}/version/${Q}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${X}/extensions/${ae}/${Q}/stats?statType=${J}`),L=D.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",_={...await this.j,Accept:L};try{await this.k.request({type:"POST",url:U,headers:_},A.CancellationToken.None)}catch{}}async download(X,ae,Q){this.l.trace("ExtensionGalleryService#download",X.identifier.id);const J=(0,w.$op)(X),U=new Date().getTime(),L=ie=>this.o.publicLog("galleryService:downloadVSIX",{...J,duration:ie}),H=Q===2?"install":Q===3?"update":"",_=H?{uri:`${X.assets.download.uri}${v.URI.parse(X.assets.download.uri).query?"&":"?"}${H}=true`,fallbackUri:`${X.assets.download.fallbackUri}${v.URI.parse(X.assets.download.fallbackUri).query?"&":"?"}${H}=true`}:X.assets.download,ee=X.queryContext?.[a]?{[a]:X.queryContext[a]}:void 0,de=await this.D(X.identifier.id,_,n.VSIX,ee?{headers:ee}:void 0);await this.q.writeFile(ae,de.stream),L(new Date().getTime()-U)}async downloadSignatureArchive(X,ae){if(!X.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",X.identifier.id);const Q=await this.D(X.identifier.id,X.assets.signature,n.Signature);await this.q.writeFile(ae,Q.stream)}async getReadme(X,ae){if(X.assets.readme){const Q=await this.D(X.identifier.id,X.assets.readme,n.Details,{},ae);return await(0,u.$Ep)(Q)||""}return""}async getManifest(X,ae){if(X.assets.manifest){const Q=await this.D(X.identifier.id,X.assets.manifest,n.Manifest,{},ae),J=await(0,u.$Ep)(Q);return J?JSON.parse(J):null}return null}async C(X,ae,Q){const J=fe(ae,n.Manifest);if(!J)throw new Error("Manifest was not found");const U={"Accept-Encoding":"gzip"},L=await this.D(X,J,n.Manifest,{headers:U});return await(0,u.$Fp)(L)}async getCoreTranslation(X,ae){const Q=X.assets.coreTranslations.filter(J=>J[0]===ae.toUpperCase())[0];if(Q){const J=await this.D(X.identifier.id,Q[1],Q[0]),U=await(0,u.$Ep)(J);return U?JSON.parse(U):null}return null}async getChangelog(X,ae){if(X.assets.changelog){const Q=await this.D(X.identifier.id,X.assets.changelog,n.Changelog,{},ae);return await(0,u.$Ep)(Q)||""}return""}async getAllCompatibleVersions(X,ae,Q){let J=new O().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);X.identifier.uuid?J=J.withFilter(s.ExtensionId,X.identifier.uuid):J=J.withFilter(s.ExtensionName,X.identifier.id);const{galleryExtensions:U}=await this.B(J,A.CancellationToken.None);if(!U.length)return[];const L=se(U[0]);if((0,y.$Oo)(L,Q))return[];const H=[];await Promise.all(U[0].versions.map(async de=>{try{await this.y(X.identifier.id,de,ae?"any":"release",!0,L,Q)&&H.push(de)}catch{}}));const _=[],ee=new Set;for(const de of ce(H,Q))ee.has(de.version)||(ee.add(de.version),_.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:te(de)}));return _}async D(X,ae,Q,J={},U=A.CancellationToken.None){const L=await this.j,H={type:"GET"},_={...L,...J.headers||{}};J={...J,...H,headers:_};const ee=ae.uri,de=ae.fallbackUri,ie={...J,url:ee};try{const me=await this.k.request(ie,U);if(me.res.statusCode===200)return me;const we=await(0,u.$Ep)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${we}`)}catch(me){if((0,S.$4)(me))throw me;const we=(0,S.$0)(me);this.o.publicLog2("galleryService:cdnFallback",{extension:X,assetType:Q,message:we});const Ie={...J,url:de};return this.k.request(Ie,U)}}async E(X,ae){let Q=re(ae);if(!Q){this.o.publicLog2("galleryService:engineFallback",{extension:X,version:ae.version});const J=await this.C(X,ae,A.CancellationToken.None);if(!J)throw new Error("Manifest was not found");Q=J.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const X=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(X.res.statusCode!==200)throw new Error("Could not get extensions report.");const ae=await(0,u.$Fp)(X),Q=[],J={},U=[];if(ae){for(const L of ae.malicious)Q.push({id:L});if(ae.migrateToPreRelease)for(const[L,H]of Object.entries(ae.migrateToPreRelease))(!H.engine||(0,m.$yp)(H.engine,this.u.version,this.u.date))&&(J[L.toLowerCase()]={disallowInstall:!0,extension:{id:H.id,displayName:H.displayName,autoMigrate:{storage:!!H.migrateStorage},preRelease:!0}});if(ae.deprecated)for(const[L,H]of Object.entries(ae.deprecated))H&&(J[L.toLowerCase()]=(0,k.$2f)(H)?{}:H);if(ae.search)for(const L of ae.search)U.push(L)}return{malicious:Q,deprecated:J,search:U}}};K=Le([Re(1,u.$zp),Re(2,c.$Oj),Re(3,E.$pi),Re(4,h.$Nl),Re(5,d.$Ok),Re(6,g.$8j),Re(7,$.$Oi)],K);let q=class extends K{constructor(X,ae,Q,J,U,L,H,_){super(X,ae,Q,J,U,L,H,_)}};e.$Vp=q,e.$Vp=q=Le([Re(0,f.$Mp),Re(1,u.$zp),Re(2,c.$Oj),Re(3,E.$pi),Re(4,h.$Nl),Re(5,d.$Ok),Re(6,g.$8j),Re(7,$.$Oi)],q);let N=class extends K{constructor(X,ae,Q,J,U,L,H){super(void 0,X,ae,Q,J,U,L,H)}};e.$Wp=N,e.$Wp=N=Le([Re(0,u.$zp),Re(1,c.$Oj),Re(2,E.$pi),Re(3,h.$Nl),Re(4,d.$Ok),Re(5,g.$8j),Re(6,$.$Oi)],N)}),define(Ee[269],ke([1,0,6,2,33,54]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=e.$fQ=void 0;class C{constructor($,E){this.a=$,this.b=E}listen($,E){const y=this.b($);switch(E){case"onDidChangeProfiles":return i.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(m=>(0,D.$mn)({...m},y)),added:w.added.map(m=>(0,D.$mn)({...m},y)),removed:w.removed.map(m=>(0,D.$mn)({...m},y)),updated:w.updated.map(m=>(0,D.$mn)({...m},y))}))}throw new Error(`Invalid listen ${E}`)}async call($,E,y){const w=this.b($);switch(E){case"createProfile":{const m=await this.a.createProfile(y[0],y[1],y[2]);return(0,D.$mn)({...m},w)}case"updateProfile":{let m=(0,S.$pl)((0,D.$nn)(y[0],w),this.a.profilesHome.scheme);return m=await this.a.updateProfile(m,y[1]),(0,D.$mn)({...m},w)}case"removeProfile":{const m=(0,S.$pl)((0,D.$nn)(y[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(m)}}throw new Error(`Invalid call ${E}`)}}e.$fQ=C;class k extends A.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor($,E,y){super(),this.profilesHome=E,this.f=y,this.a=[],this.b=this.B(new i.$7d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=$.map(w=>(0,S.$pl)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const m=w.added.map(g=>(0,S.$pl)(g,this.profilesHome.scheme)),d=w.removed.map(g=>(0,S.$pl)(g,this.profilesHome.scheme)),c=w.updated.map(g=>(0,S.$pl)(g,this.profilesHome.scheme));this.a=w.all.map(g=>(0,S.$pl)(g,this.profilesHome.scheme)),this.b.fire({added:m,removed:d,updated:c,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement($){this.c=$}isEnabled(){return this.c}async createNamedProfile($,E,y){const w=await this.f.call("createNamedProfile",[$,E,y]);return(0,S.$pl)(w,this.profilesHome.scheme)}async createProfile($,E,y,w){const m=await this.f.call("createProfile",[$,E,y,w]);return(0,S.$pl)(m,this.profilesHome.scheme)}async createTransientProfile($){const E=await this.f.call("createTransientProfile",[$]);return(0,S.$pl)(E,this.profilesHome.scheme)}async setProfileForWorkspace($,E){await this.f.call("setProfileForWorkspace",[$,E])}removeProfile($){return this.f.call("removeProfile",[$])}async updateProfile($,E){const y=await this.f.call("updateProfile",[$,E]);return(0,S.$pl)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$gQ=k}),define(Ee[130],ke([1,0,3,26,16,13,246,34,33,11,247]),function(le,e,i,A,S,D,C,k,v,$,E){"use strict";var y,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=e.$8P=void 0;let m=class extends v.$rl{static{y=this}static{this.a="profileAssociationsMigration"}constructor(u,p,f,h,l){super(f,h,p,l),this.U=u,this.W=f}O(){return this.U.getItem(y.b,[]).map(p=>({...p,location:(0,$.$Vf)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):i.URI.revive(p.location)}))}Q(){const u=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(i.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$8P=m,e.$8P=m=y=Le([Re(0,C.$3P),Re(1,k.$ml),Re(2,A.$qi),Re(3,S.$Ok),Re(4,D.$Oj)],m);let d=w=class extends m{constructor(u,p,f,h,l){super(u,p,f,h,l),this.$=u}P(u){u.length?this.$.setItem(w.b,u.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(w.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(w.c,u):this.$.removeItem(w.c)}Q(){const u="workspaceAndProfileInfo",p=this.$.getItem(u,void 0);if(p){this.$.removeItem(u);const h=p.reduce((l,{workspace:t,profile:a})=>(l[i.URI.revive(t).toString()]=i.URI.revive(a).toString(),l),{});this.$.setItem(w.c,{workspaces:h})}const f=super.Q();return this.$.getItem(w.a,!1)||(this.R(f),this.$.setItem(w.a,!0)),f}};e.$9P=d,e.$9P=d=w=Le([Re(0,C.$4P),Re(1,k.$ml),Re(2,A.$qi),Re(3,S.$Ok),Re(4,D.$Oj)],d);let c=class extends d{constructor(u,p,f,h){super(new E.$7P(0,p,h,f),u,p,f,h)}async init(){return await this.$.init(),super.init()}};e.$0P=c,e.$0P=c=Le([Re(0,k.$ml),Re(1,A.$qi),Re(2,S.$Ok),Re(3,D.$Oj)],c)}),define(Ee[131],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=void 0,e.$7m=(0,i.$ii)("extensionHostStatusService");class A{constructor(){this.a=new Map}setExitInfo(D,C){this.a.set(D,C)}getExitInfo(D){return this.a.get(D)||null}}e.$8m=A}),define(Ee[270],ke([1,0,6,15]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0;function S(C){let k=0,v=0,$=0;C>=1e3&&($=Math.floor(C/1e3),C-=$*1e3),$>=60&&(v=Math.floor($/60),$-=v*60),v>=60&&(k=Math.floor(v/60),v-=k*60);const E=k?`${k}h`:"",y=v?`${v}m`:"",w=$?`${$}s`:"",m=C?`${C}ms`:"";return`${E}${y}${w}${m}`}class D{constructor(k,v,$,E){this.i=k,this.j=v,this.a=new i.$7d,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=$,this.protocol=E,this.e=!1,this.f=new A.$vh(()=>{this.k(`The reconnection grace time of ${S(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new A.$vh(()=>{this.k(`The reconnection short grace time of ${S(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${S(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(k){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${k}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${S(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const k=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),k.end(),this.a.fire(void 0)}acceptReconnection(k,v,$){this.d=k,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(v,$),this.protocol.endAcceptReconnection()}}e.$dn=D}),define(Ee[132],ke([1,0,27,12,7,159,58]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=void 0,e.$Yl=E;const k=S.$kc(A.$Cg.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function $(w){return new Promise(m=>i.exists(w,m))}function E(w,m){return $(k).then(d=>{if(!d||!C.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const c=`${w}||${m}`;let g=v.get(c);return g||(g=D.getNLSConfiguration(C.default.commit,m,k,w,w).then(u=>(y.is(u)&&(u._languagePackSupport=!0),u)),v.set(c,g)),g})}var y;(function(w){function m(d){const c=d;return c&&typeof c._languagePackId=="string"}w.is=m})(y||(e.InternalNLSConfiguration=y={}))}),define(Ee[133],ke([1,0,19,3,26,49,59,16,5,13,32,34,33,132]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=void 0;let d=class extends C.$gq{constructor(g,u,p,f,h,l,t,a){super(A.URI.file(h.builtinExtensionsPath),A.URI.file(h.extensionsPath),(0,i.$Vg)(h.userHome,".vscode-oss-dev","extensions","control.json"),g.defaultProfile,g,u,p,f,h,l,t,a),this.S=h}async f(g){const u=await(0,m.$Yl)(g,this.S.userDataPath);if(m.InternalNLSConfiguration.is(u))try{const p=await this.w.readFile(A.URI.file(u._translationsConfigFile));return JSON.parse(p.value.toString())}catch{}return Object.create(null)}};e.$XP=d,e.$XP=d=Le([Re(0,w.$ol),Re(1,D.$bq),Re(2,k.$Ok),Re(3,$.$Oj),Re(4,S.$qi),Re(5,E.$8j),Re(6,y.$ml),Re(7,v.$hi)],d)}),define(Ee[271],ke([1,0,272,27,7,22,12,23]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.ServerConnectionTokenType=void 0,e.$hn=m,e.$in=d,e.$jn=c;const v=/^[0-9A-Za-z_-]+$/;var $;(function(g){g[g.None=0]="None",g[g.Optional=1]="Optional",g[g.Mandatory=2]="Mandatory"})($||(e.ServerConnectionTokenType=$={}));class E{constructor(){this.type=0}validate(u){return!0}}e.$en=E;class y{constructor(u){this.value=u,this.type=2}validate(u){return u===this.value}}e.$fn=y;class w{constructor(u){this.message=u}}e.$gn=w;async function m(g,u){const p=g["without-connection-token"],f=g["connection-token"],h=g["connection-token-file"];if(p)return typeof f<"u"||typeof h<"u"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new E;if(typeof h<"u"){if(typeof f<"u")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=A.readFileSync(h).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${h}'.`)}return v.test(l)?new y(l):new w(`The connection token defined in '${h} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof f<"u"?v.test(f)?new y(f):new w(`The connection token '${f} does not adhere to the characters 0-9, a-z, A-Z or -.`):new y(await u())}async function d(g){return m(g,async()=>{if(!g["user-data-dir"])return(0,D.$Eg)();const p=S.$kc(g["user-data-dir"],"token");try{const l=(await k.Promises.readFile(p)).toString().replace(/\r?\n$/,"");if(v.test(l))return l}catch{}const f=(0,D.$Eg)();try{await k.Promises.writeFile(p,f,{mode:384})}catch{}return f})}function c(g,u,p){if(g.validate(p.query[C.$ug]))return!0;const f=i.parse(u.headers.cookie||"");return g.validate(f[C.$tg])}}),define(Ee[50],ke([1,0,209,109,67,5,26,74]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=void 0,e.$Xm={host:{type:"string",cat:"o",args:"ip-address",description:i.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:i.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:i.localize(2,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:i.localize(3,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:i.localize(4,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:i.localize(5,null)},"without-connection-token":{type:"boolean",cat:"o",description:i.localize(6,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:i.localize(7,null)},"server-data-dir":{type:"string",cat:"o",description:i.localize(8,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:i.localize(9,null)},"user-data-dir":S.$em["user-data-dir"],"enable-smoke-test-driver":S.$em["enable-smoke-test-driver"],"disable-telemetry":S.$em["disable-telemetry"],"disable-workspace-trust":S.$em["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:S.$em.log,logsPath:S.$em.logsPath,"force-disable-user-env":S.$em["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:i.localize(10,null)},"default-workspace":{type:"string",description:i.localize(11,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":S.$em["extensions-dir"],"extensions-download-dir":S.$em["extensions-download-dir"],"builtin-extensions-dir":S.$em["builtin-extensions-dir"],"install-extension":S.$em["install-extension"],"install-builtin-extension":S.$em["install-builtin-extension"],"update-extensions":S.$em["update-extensions"],"uninstall-extension":S.$em["uninstall-extension"],"list-extensions":S.$em["list-extensions"],"locate-extension":S.$em["locate-extension"],"show-versions":S.$em["show-versions"],category:S.$em.category,force:S.$em.force,"do-not-sync":S.$em["do-not-sync"],"pre-release":S.$em["pre-release"],"start-server":{type:"boolean",cat:"e",description:i.localize(12,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:S.$em.help,version:S.$em.version,"locate-shell-integration-path":S.$em["locate-shell-integration-path"],compatibility:{type:"string"},_:S.$em._},e.$Ym=(0,D.$ji)(C.$pi);class v extends A.$Um{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$Zm=v,Le([k.$Mh],v.prototype,"userRoamingDataHome",null)}),define(Ee[273],ke([1,0,27,23,76,86,272,89,37,65,4,13,50,7,12,22,32,48,20,3,14,11]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=e.CacheControl=void 0,e.$kQ=a,e.$lQ=r;const t={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function a(b,P,I,O){P.writeHead(I,{"Content-Type":"text/plain"}),P.end(O)}var o;(function(b){b[b.NO_CACHING=0]="NO_CACHING",b[b.ETAG=1]="ETAG",b[b.NO_EXPIRY=2]="NO_EXPIRY"})(o||(e.CacheControl=o={}));async function r(b,P,I,O,R,j){try{const B=await A.Promises.stat(b);if(P===1){const Y=`W/"${[B.ino,B.size,B.mtime.getTime()].join("-")}"`;if(O.headers["if-none-match"]===Y)return R.writeHead(304),void R.end();j.Etag=Y}else P===2?j["Cache-Control"]="public, max-age=31536000":P===0&&(j["Cache-Control"]="no-store");j["Content-Type"]=t[(0,m.$pc)(b)]||(0,$.$Bs)(b)||"text/plain",R.writeHead(200,j),(0,i.createReadStream)(b).pipe(R)}catch(B){return B.code!=="ENOENT"?(I.error(B),console.error(B.toString())):console.error(`File not found: ${b}`),R.writeHead(404,{"Content-Type":"text/plain"}),void R.end("Not found")}}const s=(0,m.$nc)(d.$Cg.asFileUri("").fsPath);let n=class{constructor(P,I,O,R,j,B,Y){this.f=P,this.g=I,this.serverRootPath=O,this.h=R,this.i=j,this.j=B,this.k=Y,this.a=this.k.extensionsGallery?.resourceUrlTemplate?f.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${O}/static`,this.c=`${O}/callback`,this.d=`${O}/web-extension-resource`}async handle(P,I,O){try{const R=O.pathname;return R.startsWith(this.b)&&R.charCodeAt(this.b.length)===47?this.l(P,I,O):R===this.g?this.o(P,I,O):R===this.c?this.q(I):R.startsWith(this.d)&&R.charCodeAt(this.d.length)===47?this.n(P,I,O):a(P,I,404,"Not found.")}catch(R){return this.i.error(R),console.error(R.toString()),a(P,I,500,"Internal Server Error.")}}async l(P,I,O){const R=Object.create(null),B=decodeURIComponent(O.pathname).substring(this.b.length+1),Y=(0,m.$kc)(s,B);return(0,v.$ig)(Y,s,!E.$k)?r(Y,this.h.isBuilt?2:1,this.i,P,I,R):a(P,I,400,"Bad request.")}m(P){const I=P.authority.indexOf(".");return I!==-1?P.authority.substring(I+1):void 0}async n(P,I,O){if(!this.a)return a(P,I,500,"No extension gallery service configured.");const R=decodeURIComponent(O.pathname),j=(0,m.$ic)(R.substring(this.d.length+1)),B=f.URI.parse(j).with({scheme:this.a.scheme,authority:j.substring(0,j.indexOf("/")),path:j.substring(j.indexOf("/")+1)});if(this.m(this.a)!==this.m(B))return a(P,I,403,"Request Forbidden");const Y={},fe=x=>{const Z=P.headers[x];Z&&((0,l.$Vf)(Z)||Z[0])?Y[x]=(0,l.$Vf)(Z)?Z:Z[0]:x!==x.toLowerCase()&&fe(x.toLowerCase())};fe("X-Client-Name"),fe("X-Client-Version"),fe("X-Machine-Id"),fe("X-Client-Commit");const ue=await this.j.request({type:"GET",url:B.toString(!0),headers:Y},p.CancellationToken.None),re=ue.res.statusCode||500;if(re!==200){let x=null;try{x=await(0,u.$Ep)(ue)}catch{}return a(P,I,re,x||`Request failed with status ${re}`)}const te=Object.create(null),V=x=>{const Z=ue.res.headers[x];Z?te[x]=Z:x!==x.toLowerCase()&&V(x.toLowerCase())};V("Cache-Control"),V("Content-Type"),I.writeHead(200,te);const T=await(0,h.$Ge)(ue.stream);return void I.end(T.buffer)}async o(P,I,O){const R=O.query[d.$ug];if(typeof R=="string"){const K=Object.create(null);K["Set-Cookie"]=C.serialize(d.$tg,R,{sameSite:"lax",maxAge:60*60*24*7});const q=Object.create(null);for(const z in O.query)z!==d.$ug&&(q[z]=O.query[z]);const N=D.format({pathname:O.pathname,query:q});return K.Location=N,I.writeHead(302,K),void I.end()}const j=K=>{const q=P.headers[K];return Array.isArray(q)?q[0]:q},B=!this.h.isBuilt&&this.h.args["use-test-resolver"],Y=B?"test+test":j("x-original-host")||j("x-forwarded-host")||P.headers.host;if(!Y)return a(P,I,400,"Bad request.");function fe(K){return JSON.stringify(K).replace(/"/g,"&quot;")}let ue;this.h.args["enable-smoke-test-driver"]&&(ue=!1);const re=K=>K&&f.URI.file(S.resolve(K)).with({scheme:d.Schemas.vscodeRemote,authority:Y}),te=d.$Cg.asFileUri(this.h.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,V=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,c.$Eg)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,T={embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.k.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:Y,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.h.isBuilt)try{const K=JSON.parse((await A.Promises.readFile((0,m.$kc)(s,"product.overrides.json"))).toString());Object.assign(T,K)}catch{}const x={remoteAuthority:Y,serverBasePath:this.g,_wrapWebWorkerExtHostInIframe:ue,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:re(this.h.args["default-folder"]),workspaceUri:re(this.h.args["default-workspace"]),productConfiguration:T,callbackRoute:this.c},Z=this.k.extensionsGallery?.nlsBaseUrl,G={WORKBENCH_WEB_CONFIGURATION:fe(x),WORKBENCH_AUTH_SESSION:V?fe(V):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:Z?`${Z}${Z.endsWith("/")?"":"/"}${this.k.commit}/${this.k.version}/`:""};if(B){const K=[];for(const q of["vscode-test-resolver","github-authentication"]){const N=JSON.parse((await A.Promises.readFile(d.$Cg.asFileUri(`${d.$xg}/${q}/package.json`).fsPath)).toString());K.push({extensionPath:q,packageJSON:N})}G.WORKBENCH_BUILTIN_EXTENSIONS=fe(K)}let se;try{se=(await A.Promises.readFile(te)).toString().replace(/\{\{([^}]+)\}\}/g,(q,N)=>G[N]??"undefined")}catch{return I.writeHead(404,{"Content-Type":"text/plain"}),void I.end("Not found")}const $e={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.p(se).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ${B?"":`http://${Y}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&($e["Set-Cookie"]=C.serialize(d.$tg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),I.writeHead(200,$e),void I.end(se)}p(P){const I=/<script>([\s\S]+?)<\/script>/img,O=[];let R;for(;R=I.exec(P);){const j=k.createHash("sha256"),B=R[1].replace(/\r\n/g,`
`),Y=j.update(Buffer.from(B)).digest().toString("base64");O.push(`'sha256-${Y}'`)}return O}async q(P){const I=d.$Cg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,O=(await A.Promises.readFile(I)).toString(),R=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.p(O).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return P.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":R}),void P.end(O)}};e.$mQ=n,e.$mQ=n=Le([Re(3,w.$Ym),Re(4,y.$Oj),Re(5,u.$zp),Re(6,g.$8j)],n)}),define(Ee[274],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=void 0,e.$4O=(0,i.$ii)("IExtHostInitDataService")}),define(Ee[275],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=e.$NO=void 0,e.$NO=(0,i.$ii)("IExtHostRpcService");class A{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.dispose=D.dispose.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.$OO=A}),define(Ee[71],ke([1,0,54]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=S;function A(D){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:D,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function S(D){return new i.$kn(A(D))}}),define(Ee[276],ke([1,0,4,43,3,71,54,105,250,7,19]),function(le,e,i,A,S,D,C,k,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;class y{static{this.a=1}constructor(m,d,c,g){this.b=m,this.c=d,this.d=c,this.e=g}async call(m,d,c){switch(d){case"getEnvironmentData":{const g=c,u=(0,D.$ks)(g.remoteAuthority);let p=await this.f(g.profile);return p=(0,C.$mn)(p,u),p}case"getExtensionHostExitInfo":{const g=c;return this.e.getExitInfo(g.reconnectionToken)}case"getDiagnosticInfo":{const g=c,u={machineInfo:(0,v.$os)()},p=g.includeProcesses?(0,k.$ms)(process.pid):Promise.resolve();let f=[];const h={};if(g.folders){const l=(0,D.$ks)("");f=g.folders.map(a=>S.URI.revive(l.transformIncoming(a))).filter(a=>a.scheme==="file").map(a=>(0,v.$ns)(a.fsPath,["node_modules",".git"]).then(o=>{h[(0,$.$oc)(a.fsPath)]=o}))}return Promise.all([p,...f]).then(([l,t])=>(u.processes=l||void 0,u.workspaceMetadata=g.folders?h:void 0,u))}}throw new Error(`IPC Command ${d} not found`)}listen(m,d,c){throw new Error("Not supported")}async f(m){m&&!this.d.profiles.some(c=>c.id===m)&&await this.d.createProfile(m,m);let d=!1;if(process.platform==="linux"){const c=process.glibcVersion;d=(c?parseInt(c.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:S.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,E.$Vg)(this.c.logsHome,`exthost${y.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:i.OS,arch:process.arch,marks:A.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(c=>({...c}))},isUnsupportedGlibc:d}}}e.$rs=y}),define(Ee[277],ke([1,0,3,71,69,7,235]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;class k extends C.$ss{constructor(E,y){super(new S.$Vq(E),E),this.N=y,this.M=new Map,this.B(this.a)}c(E){let y=this.M.get(E.remoteAuthority);return y||(y=(0,A.$ks)(E.remoteAuthority),this.M.set(E.remoteAuthority,y)),y}f(E,y,w=!1){if(w&&y.path==="/vscode-resource"&&y.query){const m=JSON.parse(y.query).requestResourcePath;return i.URI.from({scheme:"file",path:m})}return i.URI.revive(E.transformIncoming(y))}L(E,y){return new v(E,y,this.b,this.N)}}e.$us=k;class v extends C.$ts{constructor(E,y,w,m){super(E,y,w,m)}j(E){const y=E.args["file-watcher-polling"];if(y){const w=y.split(D.$uc),m=Number(w[0]);if(m>0)return{usePolling:w.length>1?w.slice(1):!0,pollingInterval:m}}}m(E){if(E.extensionsPath)return[D.$hc.join(E.extensionsPath,"**")]}}}),define(Ee[93],ke([1,0,212,11,3,2,5,38,16,12,40,165,63]),function(le,e,i,A,S,D,C,k,v,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$tF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$kF=e.EditorInputCapabilities=e.$jF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=void 0,e.$aF=c,e.$bF=g,e.$cF=u,e.$dF=p,e.$eF=f,e.$fF=h,e.$gF=l,e.$hF=t,e.$iF=a,e.$lF=P,e.$mF=O,e.$nF=R,e.$oF=j,e.$pF=B,e.$qF=Y,e.$rF=fe,e.$sF=x,e.$uF=se,e.$vF=ne,e.$wF=$e,e.$xF=K,e.$8E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$9E={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.$0E="workbench.editor.sidebysideEditor",e.$$E="workbench.editors.textDiffEditor",e.$_E="workbench.editors.binaryResourceDiffEditor";var m;(function(q){q[q.PROGRAMMATIC=1]="PROGRAMMATIC",q[q.USER=2]="USER",q[q.EDIT=3]="EDIT",q[q.NAVIGATION=4]="NAVIGATION",q[q.JUMP=5]="JUMP"})(m||(e.EditorPaneSelectionChangeReason=m={}));var d;(function(q){q[q.IDENTICAL=1]="IDENTICAL",q[q.SIMILAR=2]="SIMILAR",q[q.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function c(q){const N=q;return!!N&&typeof N.getSelection=="function"&&!!N.onDidChangeSelection}function g(q){const N=q;return!!N&&typeof N.getScrollPosition=="function"&&typeof N.setScrollPosition=="function"&&!!N.onDidChangeScroll}function u(q,N,z){for(const X of z.visibleEditorPanes)if(X.group.id===N&&q.matches(X.input))return X.getViewState()}function p(q){if(P(q))return!1;const N=q;return S.URI.isUri(N?.resource)}function f(q){if(P(q))return!1;const N=q;return N?.original!==void 0&&N.modified!==void 0}function h(q){if(P(q))return!1;const N=q;return!N||N.resources&&!Array.isArray(N.resources)?!1:!!N.resources||!!N.multiDiffSource}function l(q){if(P(q)||f(q))return!1;const N=q;return N?.primary!==void 0&&N.secondary!==void 0}function t(q){if(P(q))return!1;const N=q;return N?N.resource===void 0||N.resource.scheme===$.Schemas.untitled||N.forceUntitled===!0:!1}function a(q){if(P(q))return!1;const N=q;return S.URI.isUri(N?.base?.resource)&&S.URI.isUri(N?.input1?.resource)&&S.URI.isUri(N?.input2?.resource)&&S.URI.isUri(N?.result?.resource)}var o;(function(q){q[q.SHORT=0]="SHORT",q[q.MEDIUM=1]="MEDIUM",q[q.LONG=2]="LONG"})(o||(e.Verbosity=o={}));var r;(function(q){q[q.EXPLICIT=1]="EXPLICIT",q[q.AUTO=2]="AUTO",q[q.FOCUS_CHANGE=3]="FOCUS_CHANGE",q[q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class s{constructor(){this.a=new Map}registerSource(N,z){let X=this.a.get(N);return X||(X={source:N,label:z},this.a.set(N,X)),X.source}getSourceLabel(N){return this.a.get(N)?.label??N}}e.$jF=new s;var n;(function(q){q[q.None=0]="None",q[q.Readonly=2]="Readonly",q[q.Untitled=4]="Untitled",q[q.Singleton=8]="Singleton",q[q.RequiresTrust=16]="RequiresTrust",q[q.CanSplitInGroup=32]="CanSplitInGroup",q[q.ForceDescription=64]="ForceDescription",q[q.CanDropIntoEditor=128]="CanDropIntoEditor",q[q.MultipleEditors=256]="MultipleEditors",q[q.Scratchpad=512]="Scratchpad"})(n||(e.EditorInputCapabilities=n={}));class b extends D.$Uc{}e.$kF=b;function P(q){return q instanceof b}function I(q){const N=q;return S.URI.isUri(N?.preferredResource)}function O(q){const N=q;return P(N?.primary)&&P(N?.secondary)}function R(q){const N=q;return P(N?.modified)&&P(N?.original)}function j(q,N,z,X,ae){return K(X,[(0,y.$5i)({id:"workbench.action.openLargeFile",label:(0,i.localize)(2,null),run:()=>{const Q={...z,limits:{size:Number.MAX_VALUE}};q.openEditor(N,Q)}}),(0,y.$5i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,i.localize)(3,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}function B(q){return P(q?.editor)}function Y(q){const N=q;return B(q)&&N?.group!==void 0}function fe(q){const N=q;return typeof N?.groupId=="number"&&P(N.editor)}var ue;(function(q){q[q.UNKNOWN=0]="UNKNOWN",q[q.REPLACE=1]="REPLACE",q[q.MOVE=2]="MOVE",q[q.UNPIN=3]="UNPIN"})(ue||(e.EditorCloseContext=ue={}));var re;(function(q){q[q.GROUP_ACTIVE=0]="GROUP_ACTIVE",q[q.GROUP_INDEX=1]="GROUP_INDEX",q[q.GROUP_LABEL=2]="GROUP_LABEL",q[q.GROUP_LOCKED=3]="GROUP_LOCKED",q[q.EDITOR_OPEN=4]="EDITOR_OPEN",q[q.EDITOR_CLOSE=5]="EDITOR_CLOSE",q[q.EDITOR_MOVE=6]="EDITOR_MOVE",q[q.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",q[q.EDITOR_LABEL=8]="EDITOR_LABEL",q[q.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",q[q.EDITOR_PIN=10]="EDITOR_PIN",q[q.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",q[q.EDITOR_STICKY=12]="EDITOR_STICKY",q[q.EDITOR_DIRTY=13]="EDITOR_DIRTY",q[q.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(re||(e.GroupModelChangeKind=re={}));var te;(function(q){q[q.PRIMARY=1]="PRIMARY",q[q.SECONDARY=2]="SECONDARY",q[q.BOTH=3]="BOTH",q[q.ANY=4]="ANY"})(te||(e.SideBySideEditor=te={}));class V{getOriginalUri(N,z){if(!N)return;if(a(N))return e.$tF.getOriginalUri(N.result,z);if(z?.supportSideBySide){const{primary:ae,secondary:Q}=this.a(N);if(ae&&Q){if(z?.supportSideBySide===te.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===te.ANY)return this.getOriginalUri(ae,{filterByScheme:z.filterByScheme})??this.getOriginalUri(Q,{filterByScheme:z.filterByScheme});N=z.supportSideBySide===te.PRIMARY?ae:Q}}if(f(N)||h(N)||l(N)||a(N))return;const X=I(N)?N.preferredResource:N.resource;return!X||!z||!z.filterByScheme?X:this.b(X,z.filterByScheme)}a(N){return O(N)||l(N)?{primary:N.primary,secondary:N.secondary}:R(N)||f(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,z){if(!N)return;if(a(N))return e.$tF.getCanonicalUri(N.result,z);if(z?.supportSideBySide){const{primary:ae,secondary:Q}=this.a(N);if(ae&&Q){if(z?.supportSideBySide===te.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===te.ANY)return this.getCanonicalUri(ae,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(Q,{filterByScheme:z.filterByScheme});N=z.supportSideBySide===te.PRIMARY?ae:Q}}if(f(N)||h(N)||l(N)||a(N))return;const X=N.resource;return!X||!z||!z.filterByScheme?X:this.b(X,z.filterByScheme)}b(N,z){if(Array.isArray(z)){if(z.some(X=>N.scheme===X))return N}else if(z===N.scheme)return N}}var T;(function(q){q[q.UNKNOWN=0]="UNKNOWN",q[q.KEYBOARD=1]="KEYBOARD",q[q.MOUSE=2]="MOUSE"})(T||(e.EditorCloseMethod=T={}));function x(q,N,z,X){if(!q.isSticky(N))return!1;switch(X.preventPinnedEditorClose){case"keyboardAndMouse":return z===T.MOUSE||z===T.KEYBOARD;case"mouse":return z===T.MOUSE;case"keyboard":return z===T.KEYBOARD}return!1}e.$tF=new V;var Z;(function(q){q[q.LEFT=0]="LEFT",q[q.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class G{constructor(){this.c=new Map,this.d=new Map}start(N){const z=this.a=N.get(C.$hi);for(const[X,ae]of this.c)this.e(X,ae,z);this.c.clear()}e(N,z,X){const ae=X.createInstance(z);this.d.set(N,ae)}registerFileEditorFactory(N){if(this.b)throw new Error("Can only register one file editor factory.");this.b=N}getFileEditorFactory(){return(0,A.$7f)(this.b)}registerEditorSerializer(N,z){if(this.c.has(N)||this.d.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.a?this.e(N,z,this.a):this.c.set(N,z),(0,D.$Sc)(()=>{this.c.delete(N),this.d.delete(N)})}getEditorSerializer(N){return this.d.get(typeof N=="string"?N:N.typeId)}}k.$1n.add(e.$8E.EditorFactory,new G);async function se(q,N,z){return!q||!q.length?[]:await Promise.all(q.map(async X=>{const ae=S.URI.revive(X.fileUri);if(!ae){z.info("Cannot resolve the path because it is not valid.",X);return}if(!await N.canHandleResource(ae)){z.info("Cannot resolve the path because it cannot be handled",X);return}let J=X.exists,U=X.type;if(typeof J!="boolean"||typeof U!="number")try{U=(await N.stat(ae)).isDirectory?v.FileType.Directory:v.FileType.Unknown,J=!0}catch(H){z.error(H),J=!1}if(!J&&X.openOnlyIfExists){z.info("Cannot resolve the path because it does not exist",X);return}if(U===v.FileType.Directory){z.info("Cannot resolve the path because it is a directory",X);return}const L={...X.options,pinned:!0};return J?{resource:ae,options:L}:{resource:ae,options:L,forceUntitled:!0}}))}var ce;(function(q){q[q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",q[q.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function ne(q){const N=q;if(!N)return!1;const z=N;if(z.modified)return ne(z.modified);const X=N;return!!(X.contributionsState&&X.viewState&&Array.isArray(X.cursorState))}function $e(q){return(0,E.$7i)(q)}function K(q,N,z){const X=(0,E.$8i)(q,N);return X.forceMessage=z?.forceMessage,X.forceSeverity=z?.forceSeverity,X.allowDialog=z?.allowDialog,X}}),define(Ee[278],ke([1,0,6,41,2,57,5]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.$GG=e.$FG=e.ChatAgentLocation=void 0;var k;(function(E){E.Panel="panel",E.Terminal="terminal",E.Notebook="notebook",E.Editor="editor"})(k||(e.ChatAgentLocation=k={})),function(E){function y(w){switch(w){case"panel":return E.Panel;case"terminal":return E.Terminal;case"notebook":return E.Notebook}return E.Panel}E.fromRaw=y}(k||(e.ChatAgentLocation=k={})),e.$FG=(0,C.$ii)("chatAgentService");let v=class{static{this.AGENT_LEADER="@"}constructor(y){this.e=y,this.b=[],this.d=new i.$7d,this.onDidChangeAgents=this.d.event}registerAgent(y,w){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const d=this,c=w.slashCommands;w={...w,get slashCommands(){return c.filter(u=>!u.when||d.e.contextMatchesRules(D.$gj.deserialize(u.when)))}};const g={data:w};return this.b.push(g),(0,S.$Sc)(()=>{this.b=this.b.filter(u=>u!==g),this.d.fire(void 0)})}registerAgentImplementation(y,w){const m=this.f(y);if(!m)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(m.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return m.impl=w,this.d.fire(new $(m.data,w)),(0,S.$Sc)(()=>{m.impl=void 0,this.d.fire(void 0)})}registerDynamicAgent(y,w){const m={data:y,impl:w};return this.b.push(m),this.d.fire(new $(y,w)),(0,S.$Sc)(()=>{this.b=this.b.filter(d=>d!==m),this.d.fire(void 0)})}updateAgent(y,w){const m=this.f(y);if(!m?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);m.data.metadata={...m.data.metadata,...w},this.d.fire(new $(m.data,m.impl))}getDefaultAgent(y){return this.getActivatedAgents().find(w=>!!w.isDefault&&w.locations.includes(y))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}f(y){return this.b.find(w=>w.data.id===y)}getAgent(y){return this.f(y)?.data}getAgents(){return this.b.map(y=>y.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).map(y=>new $(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(w=>w.name===y)}async invokeAgent(y,w,m,d,c){const g=this.f(y);if(!g?.impl)throw new Error(`No activated agent with id ${y}`);return await g.impl.invoke(w,m,d,c)}async getFollowups(y,w,m,d,c){const g=this.f(y);if(!g?.impl)throw new Error(`No activated agent with id ${y}`);return g.impl?.provideFollowups?g.impl.provideFollowups(w,m,d,c):[]}};e.$GG=v,e.$GG=v=Le([Re(0,D.$Aj)],v);class ${constructor(y,w){this.b=y,this.d=w}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(y,w,m,d){return this.d.invoke(y,w,m,d)}async provideFollowups(y,w,m,d){return this.d.provideFollowups?this.d.provideFollowups(y,w,m,d):[]}provideWelcomeMessage(y){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y)}provideSampleQuestions(y){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y)}}e.$HG=$}),define(Ee[279],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=void 0,e.$eP=(0,i.$ii)("environmentVariableService")}),define(Ee[280],ke([1,0,7,3,66,4,125,11]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=v,e.$HP=E,e.$IP=m,e.$JP=d,e.$KP=c,e.$LP=u,e.$MP=p,e.$NP=f,e.$OP=h;function v(l,t){if(t)if(D.$i)for(const a in t){let o=a;for(const s in l)if(a.toLowerCase()===s.toLowerCase()){o=s;break}const r=t[a];r!==void 0&&$(l,o,r)}else Object.keys(t).forEach(a=>{const o=t[a];o!==void 0&&$(l,a,o)})}function $(l,t,a){typeof a=="string"?l[t]=a:delete l[t]}function E(l,t,a,o){l.TERM_PROGRAM="vscode",t&&(l.TERM_PROGRAM_VERSION=t),m(l,o)&&(l.LANG=d(a)),l.COLORTERM="truecolor"}function y(l,t){if(t)for(const a of Object.keys(t)){const o=t[a];o!=null&&(l[a]=o)}}async function w(l,t){return await Promise.all(Object.entries(t).map(async([a,o])=>{if(typeof o=="string")try{t[a]=await l(o)}catch{t[a]=o}})),t}function m(l,t){if(t==="on")return!0;if(t==="auto"){const a=l.LANG;return!a||a.search(/\.UTF\-8$/)===-1&&a.search(/\.utf8$/)===-1&&a.search(/\.euc.+/)===-1}return!1}function d(l){const t=l?l.split("-"):[],a=t.length;if(a===0)return"en_US.UTF-8";if(a===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}async function c(l,t,a,o,r,s){if(l.cwd){const b=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,P=await g(b,a);return(0,C.$DP)(P||b)}let n;return!l.ignoreConfigurationCwd&&r&&(a&&(r=await g(r,a,s)),r&&(i.$jc(r)?n=r:o&&(n=i.$kc(o.fsPath,r)))),n||(n=o?o.fsPath:t||""),(0,C.$DP)(n)}async function g(l,t,a){if(t)try{return await t(l)}catch(o){a?.error("Could not resolve terminal cwd",o);return}return l}function u(l,t,a){if(a)return o=>a.resolveWithEnvironment(t,l,o)}async function p(l,t,a,o,r,s){const n={};if(l.strictEnv)y(n,l.env);else{y(n,s);const b={...t};a&&(b&&await w(a,b),l.env&&await w(a,l.env)),D.$j&&(n.VSCODE_NODE_OPTIONS&&(n.NODE_OPTIONS=n.VSCODE_NODE_OPTIONS,delete n.VSCODE_NODE_OPTIONS),n.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(n.NODE_REPL_EXTERNAL_MODULE=n.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete n.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,S.$$l)(n,"VSCODE_IPC_HOOK_CLI"),v(n,b),v(n,l.env),E(n,o,D.$w,r)}return n}async function f(l,t,a,o,r,s,n=D.$i){let b;if((0,k.$Vf)(l)?b=l:(b=l.fsPath,n&&s!==1?b=b.replace(/\\/g,"/"):!n&&s===1&&(b=b.replace(/\//g,"\\"))),!t)return b;const P=b.includes(" "),I=b.includes("(")||b.includes(")"),O=i.$oc(t,".exe"),R=O==="pwsh"||a==="pwsh"||O==="powershell"||a==="powershell";if(R&&(P||b.includes("'")))return`& '${b.replace(/'/g,"''")}'`;if(I&&R)return`& '${b}'`;if(s===1){if(o!==void 0)return o==="gitbash"?(0,C.$BP)(b.replace(/\\/g,"/")):o==="wsl"?r?.getWslPath(b,"win-to-unix")||b:P?`"${b}"`:b;const j=t.toLowerCase();return j.includes("wsl")||j.includes("bash.exe")&&!j.toLowerCase().includes("git")?r?.getWslPath(b,"win-to-unix")||b:P?`"${b}"`:b}return(0,C.$BP)(b)}function h(l,t,a){const o=typeof l=="string"?A.URI.parse(l):l;let r=o?t.getWorkspaceFolder(o)??void 0:void 0;if(!r){const s=a.getLastActiveWorkspaceRoot();r=s?t.getWorkspaceFolder(s)??void 0:void 0}return r}}),define(Ee[72],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(D){D.Delimiter="\0"})(i||(e.TestIdPathParts=i={}));var A;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(A||(e.TestPosition=A={}));class S{static fromExtHostTestItem(C,k,v=C.parent){if(C._isRoot)return new S([k]);const $=[C.id];for(let E=v;E&&E.id!==k;E=E.parent)$.push(E.id);return $.push(k),new S($.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const k=C.indexOf("\0");return k===-1?C:C.slice(0,k)}static fromString(C){return new S(C.split("\0"))}static join(C,k){return new S([...C.path,k])}static joinToString(C,k){return C.toString()+"\0"+k}static parentId(C){const k=C.lastIndexOf("\0");return k===-1?void 0:C.slice(0,k)}static localId(C){const k=C.lastIndexOf("\0");return k===-1?C:C.slice(k+1)}static isChild(C,k){return k.startsWith(C)&&k[C.length]==="\0"}static compare(C,k){return C===k?0:S.isChild(C,k)?2:S.isChild(k,C)?3:1}constructor(C,k=C.length){if(this.path=C,this.d=k,C.length===0||k<1)throw new Error("cannot create test with empty path")}get rootId(){return new S(this.path,1)}get parentId(){return this.d>1?new S(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new S(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new S(this.path,C)}compare(C){if(typeof C=="string")return S.compare(this.toString(),C);for(let k=0;k<C.d&&k<this.d;k++)if(C.path[k]!==this.path[k])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.$dL=S}),define(Ee[94],ke([1,0,3,78,44,72]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$lL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$kL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$jL=e.$iL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$hL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$gL=e.$fL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$eL=e.TestResultState=void 0;var C;(function(re){re[re.Unset=0]="Unset",re[re.Queued=1]="Queued",re[re.Running=2]="Running",re[re.Passed=3]="Passed",re[re.Failed=4]="Failed",re[re.Skipped=5]="Skipped",re[re.Errored=6]="Errored"})(C||(e.TestResultState=C={})),e.$eL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var k;(function(re){re[re.Run=1]="Run",re[re.Debug=2]="Debug",re[re.Coverage=3]="Coverage"})(k||(e.ExtTestRunProfileKind=k={}));var v;(function(re){re[re.Run=2]="Run",re[re.Debug=4]="Debug",re[re.Coverage=8]="Coverage",re[re.HasNonDefaultProfile=16]="HasNonDefaultProfile",re[re.HasConfigurable=32]="HasConfigurable",re[re.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.$fL=[2,4,8,16,32,64];const $=re=>"runId"in re;e.$gL=$;var E;(function(re){re.serialize=te=>({range:te.range.toJSON(),uri:te.uri.toJSON()}),re.deserialize=(te,V)=>({range:S.$ct.lift(V.range),uri:te.asCanonicalUri(i.URI.revive(V.uri))})})(E||(e.IRichLocation=E={}));var y;(function(re){re[re.Error=0]="Error",re[re.Output=1]="Output"})(y||(e.TestMessageType=y={}));var w;(function(re){re.serialize=te=>({message:te.message,type:0,expected:te.expected,actual:te.actual,contextValue:te.contextValue,location:te.location&&E.serialize(te.location)}),re.deserialize=(te,V)=>({message:V.message,type:0,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&E.deserialize(te,V.location)})})(w||(e.ITestErrorMessage=w={}));const m=(re,te)=>`${te?"s":"e"}${re}`;e.$hL=m;var d;(function(re){re.serialize=te=>({message:te.message,type:1,offset:te.offset,length:te.length,location:te.location&&E.serialize(te.location)}),re.deserialize=(te,V)=>({message:V.message,type:1,offset:V.offset,length:V.length,location:V.location&&E.deserialize(te,V.location)})})(d||(e.ITestOutputMessage=d={}));var c;(function(re){re.serialize=te=>te.type===0?w.serialize(te):d.serialize(te),re.deserialize=(te,V)=>V.type===0?w.deserialize(te,V):d.deserialize(te,V)})(c||(e.ITestMessage=c={}));var g;(function(re){re.serializeWithoutMessages=te=>({state:te.state,duration:te.duration,messages:[]}),re.serialize=te=>({state:te.state,duration:te.duration,messages:te.messages.map(c.serialize)}),re.deserialize=(te,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(T=>c.deserialize(te,T))})})(g||(e.ITestTaskState=g={}));const u="\0",p=(re,te)=>re+u+te;e.$iL=p;const f=re=>{const te=re.indexOf(u);return{ctrlId:re.slice(0,te),tagId:re.slice(te+1)}};e.$jL=f;var h;(function(re){re.serialize=te=>({extId:te.extId,label:te.label,tags:te.tags,busy:te.busy,children:void 0,uri:te.uri?.toJSON(),range:te.range?.toJSON()||null,description:te.description,error:te.error,sortText:te.sortText}),re.deserialize=(te,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?te.asCanonicalUri(i.URI.revive(V.uri)):void 0,range:V.range?S.$ct.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(h||(e.ITestItem=h={}));var l;(function(re){re[re.NotExpandable=0]="NotExpandable",re[re.Expandable=1]="Expandable",re[re.BusyExpanding=2]="BusyExpanding",re[re.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(re){re.serialize=te=>({expand:te.expand,item:h.serialize(te.item)}),re.deserialize=(te,V)=>({controllerId:D.$dL.root(V.item.extId),expand:V.expand,item:h.deserialize(te,V.item)})})(t||(e.InternalTestItem=t={}));var a;(function(re){re.serialize=te=>{let V;return te.item&&(V={},te.item.label!==void 0&&(V.label=te.item.label),te.item.tags!==void 0&&(V.tags=te.item.tags),te.item.busy!==void 0&&(V.busy=te.item.busy),te.item.uri!==void 0&&(V.uri=te.item.uri?.toJSON()),te.item.range!==void 0&&(V.range=te.item.range?.toJSON()),te.item.description!==void 0&&(V.description=te.item.description),te.item.error!==void 0&&(V.error=te.item.error),te.item.sortText!==void 0&&(V.sortText=te.item.sortText)),{extId:te.extId,expand:te.expand,item:V}},re.deserialize=te=>{let V;return te.item&&(V={},te.item.label!==void 0&&(V.label=te.item.label),te.item.tags!==void 0&&(V.tags=te.item.tags),te.item.busy!==void 0&&(V.busy=te.item.busy),te.item.range!==void 0&&(V.range=te.item.range?S.$ct.lift(te.item.range):null),te.item.description!==void 0&&(V.description=te.item.description),te.item.error!==void 0&&(V.error=te.item.error),te.item.sortText!==void 0&&(V.sortText=te.item.sortText)),{extId:te.extId,expand:te.expand,item:V}}})(a||(e.ITestItemUpdate=a={}));const o=(re,te)=>{te.expand!==void 0&&(re.expand=te.expand),te.item!==void 0&&(re.item=re.item?Object.assign(re.item,te.item):te.item)};e.$kL=o;var r;(function(re){re.serializeWithoutMessages=te=>({...t.serialize(te),ownComputedState:te.ownComputedState,computedState:te.computedState,tasks:te.tasks.map(g.serializeWithoutMessages)}),re.serialize=te=>({...t.serialize(te),ownComputedState:te.ownComputedState,computedState:te.computedState,tasks:te.tasks.map(g.serialize)}),re.deserialize=(te,V)=>({...t.deserialize(te,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(T=>g.deserialize(te,T)),retired:!0})})(r||(e.TestResultItem=r={}));var s;(function(re){re.empty=()=>({covered:0,total:0}),re.sum=(te,V)=>{te.covered+=V.covered,te.total+=V.total}})(s||(e.ICoverageCount=s={}));var n;(function(re){re.serialize=te=>({id:te.id,statement:te.statement,branch:te.branch,declaration:te.declaration,uri:te.uri.toJSON()}),re.deserialize=(te,V)=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,uri:te.asCanonicalUri(i.URI.revive(V.uri))})})(n||(e.IFileCoverage=n={}));function b(re){return{...re,location:re.location?.toJSON()}}function P(re){return re.location=re.location?A.$bt.isIPosition(re.location)?A.$bt.lift(re.location):S.$ct.lift(re.location):void 0,re}e.$lL=3;var I;(function(re){re[re.Declaration=0]="Declaration",re[re.Statement=1]="Statement",re[re.Branch=2]="Branch"})(I||(e.DetailType=I={}));var O;(function(re){re.serialize=te=>te.type===0?j.serialize(te):B.serialize(te),re.deserialize=te=>te.type===0?j.deserialize(te):B.deserialize(te)})(O||(e.CoverageDetails=O={}));var R;(function(re){re.serialize=b,re.deserialize=P})(R||(e.IBranchCoverage=R={}));var j;(function(re){re.serialize=b,re.deserialize=P})(j||(e.IDeclarationCoverage=j={}));var B;(function(re){re.serialize=te=>({...b(te),branches:te.branches?.map(R.serialize)}),re.deserialize=te=>({...P(te),branches:te.branches?.map(R.deserialize)})})(B||(e.IStatementCoverage=B={}));var Y;(function(re){re[re.Add=0]="Add",re[re.Update=1]="Update",re[re.DocumentSynced=2]="DocumentSynced",re[re.Remove=3]="Remove",re[re.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",re[re.Retire=5]="Retire",re[re.AddTag=6]="AddTag",re[re.RemoveTag=7]="RemoveTag"})(Y||(e.TestDiffOpType=Y={}));var fe;(function(re){re.deserialize=(te,V)=>V.op===0?{op:V.op,item:t.deserialize(te,V.item)}:V.op===1?{op:V.op,item:a.deserialize(V.item)}:V.op===2?{op:V.op,uri:te.asCanonicalUri(i.URI.revive(V.uri)),docv:V.docv}:V,re.serialize=te=>te.op===0?{op:te.op,item:t.serialize(te.item)}:te.op===1?{op:te.op,item:a.serialize(te.item)}:te})(fe||(e.TestsDiffOp=fe={}));class ue{constructor(te){this.l=te,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(te){const V=this.w();for(const T of te)switch(T.op){case 0:this.o(t.deserialize(this.l,T.item),V);break;case 1:this.p(a.deserialize(T.item),V);break;case 3:this.q(T.itemId,V);break;case 5:this.v(T.itemId);break;case 4:this.updatePendingRoots(T.amount);break;case 6:this.f.set(T.tag.id,T.tag);break;case 7:this.f.delete(T.id);break}V.complete?.()}o(te,V){const T=D.$dL.parentId(te.item.extId)?.toString();let x;if(!T)x=this.x(te),this.h.add(x),this.g.set(te.item.extId,x);else if(this.g.has(T)){const Z=this.g.get(T);Z.children.add(te.item.extId),x=this.x(te,Z),this.g.set(te.item.extId,x)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(te)}`);return}return V.add?.(x),te.expand===2&&this.j++,x}p(te,V){const T=this.g.get(te.extId);if(T)return te.expand!==void 0&&(T.expand===2&&this.j--,te.expand===2&&this.j++),(0,e.$kL)(T,te),V.update?.(T),T}q(te,V){const T=this.g.get(te);if(!T)return;const x=D.$dL.parentId(T.item.extId)?.toString();x?this.g.get(x).children.delete(T.item.extId):this.h.delete(T);const Z=[[te]];for(;Z.length;)for(const G of Z.pop()){const se=this.g.get(G);se&&(Z.push(se.children),this.g.delete(G),V.remove?.(se,se!==T),se.expand===2&&this.j--)}}v(te){}updatePendingRoots(te){this.k+=te}w(){return{}}}e.$mL=ue}),define(Ee[134],ke([1,0,15,6,2,96,94,72]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.TestItemEventOp=void 0;var v;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const $=(p,f)=>p===f,y=Object.entries({range:(p,f)=>p===f?!0:!p||!f?!1:p.equalsRange(f),busy:$,label:$,description:$,error:$,sortText:$,tags:(p,f)=>!(p.length!==f.length||p.some(h=>!f.includes(h)))}),w=(p,f)=>{let h;for(const[l,t]of y)t(p[l],f[l])||(h?h[l]=f[l]:h={[l]:f[l]});return h};class m extends S.$Uc{get root(){return this.s.root}constructor(f){super(),this.s=f,this.f=this.B(new i.$uh(()=>this.flushDiff(),200)),this.g=this.B(new A.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(f){this.h=f;for(const h of this.tree.values())this.J(h)}get resolveHandler(){return this.h}collectDiff(){const f=this.m;return this.m=[],f}pushDiff(f){switch(f.op){case 2:{for(const h of this.m)if(h.op===2&&h.uri===f.uri){h.docv=f.docv;return}break}case 1:{const h=this.m[this.m.length-1];if(h){if(h.op===1&&h.item.extId===f.item.extId){(0,C.$kL)(h.item,f.item);return}if(h.op===0&&h.item.item.extId===f.item.extId){(0,C.$kL)(h.item,f.item);return}}break}}this.m.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,h){const l=this.tree.get(f);if(l){if((l.expandLevels===void 0||h>l.expandLevels)&&(l.expandLevels=h),l.expand===1){const t=this.M(l);return t.isOpen()?this.L(l,h-1):t.wait().then(()=>this.L(l,h-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,h-1)):this.L(l,h-1)}}dispose(){for(const f of this.tree.values())this.s.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(f,h){switch(h.op){case 3:this.O(k.$dL.joinToString(f.fullId,h.id));break;case 0:this.z(h.item,f);break;case 5:for(const l of h.ops)this.w(f,l);break;case 1:this.C(h.new,h.old,f.fullId.toString());break;case 2:this.J(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:h.update}});break;case 6:this.y(f.actual.uri);break;default:(0,D.$0c)(h)}}y(f){f&&this.pushDiff({op:2,uri:f,docv:this.s.getDocumentVersion(f)})}z(f,h){const l=k.$dL.fromExtHostTestItem(f,this.root.id,h?.actual),t=this.s.getApiFor(f);t.parent&&t.parent!==h?.actual&&this.s.getChildren(t.parent).delete(f.id);let a=this.tree.get(l.toString());if(!a){a={fullId:l,actual:f,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},f.tags.forEach(this.D,this),this.tree.set(a.fullId.toString(),a),this.G(f,h),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:a.expand,item:this.s.toITestItem(f)}}),this.I(f,a,h);return}if(a.actual===f){this.H(f,a,h);return}if(a.actual.uri?.toString()!==f.uri?.toString())return this.O(l.toString()),this.z(f,h);const o=this.s.getChildren(a.actual),r=a.actual,s=w(this.s.toITestItem(r),this.s.toITestItem(f));this.s.getApiFor(r).listener=void 0,a.actual=f,a.expand=0,s&&(s.hasOwnProperty("tags")&&(this.C(f.tags,r.tags,l.toString()),delete s.tags),this.w(a,{op:4,update:s})),this.I(f,a,h);for(const[n,b]of o)this.s.getChildren(f).get(b.id)||this.O(k.$dL.joinToString(l,b.id));this.y(a.actual.uri)}C(f,h,l){const t=new Set(h.map(a=>a.id));for(const a of f)t.delete(a.id)||this.D(a);this.pushDiff({op:1,item:{extId:l,item:{tags:f.map(a=>(0,C.$iL)(this.s.controllerId,a.id))}}}),t.forEach(this.F,this)}D(f){const h=this.j.get(f.id);h?h.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.$iL)(this.s.controllerId,f.id)}}))}F(f){const h=this.j.get(f);h&&!--h.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,C.$iL)(this.s.controllerId,f)}))}G(f,h){this.s.getApiFor(f).parent=h&&h.actual!==this.root?h.actual:void 0}H(f,h,l){this.G(f,l);const t=this.s.getApiFor(f);t.parent=l?.actual,t.listener=a=>this.w(h,a),this.J(h)}I(f,h,l){this.H(f,h,l);for(const[t,a]of this.s.getChildren(f))this.z(a,h)}J(f){let h;this.h?f.resolveBarrier?h=f.resolveBarrier.isOpen()?3:2:h=f.actual.canResolveChildren?1:0:h=0,h!==f.expand&&(f.expand=h,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:h}}),h===1&&f.expandLevels!==void 0&&this.M(f))}L(f,h){if(h<0)return;const l=[];for(const[t,a]of this.s.getChildren(f.actual)){const o=this.expand(k.$dL.joinToString(f.fullId,a.id),h);(0,i.$7g)(o)&&l.push(o)}if(l.length)return Promise.all(l).then(()=>{})}M(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const a=new i.$hh;return a.open(),a}f.expand=2,this.N(f);const h=f.resolveBarrier=new i.$hh,l=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,a)};let t;try{t=this.h(f.actual===this.root?void 0:f.actual)}catch(a){l(a)}return(0,i.$7g)(t)?t.catch(l).then(()=>{h.open(),this.J(f)}):(h.open(),this.J(f)),f.resolveBarrier}N(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}O(f){const h=this.tree.get(f);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const l=[h];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const a of t.actual.tags)this.F(a.id);this.tree.delete(t.fullId.toString());for(const[a,o]of this.s.getChildren(t.actual))l.push(this.tree.get(k.$dL.joinToString(t.fullId,o.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.$DO=m;class d extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.$EO=d;class c extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$FO=c;class g extends Error{constructor(f,h,l){super(`TestItem with ID "${f}" is from controller "${h}" and cannot be added as a child of an item from controller "${l}".`)}}e.$GO=g;const u=(p,f,h)=>{let l=new Map;return{get size(){return l.size},forEach(t,a){for(const o of l.values())t.call(a,o,this)},[Symbol.iterator](){return l.entries()},replace(t){const a=new Map,o=new Set(l.keys()),r={op:5,ops:[]};for(const s of t){if(!(s instanceof h))throw new c(s.id);const n=f(s).controllerId;if(n!==p.controllerId)throw new g(s.id,n,p.controllerId);if(a.has(s.id))throw new d(s.id);a.set(s.id,s),o.delete(s.id),r.ops.push({op:0,item:s})}for(const s of o.keys())r.ops.push({op:3,id:s});p.listener?.(r),l=a},add(t){if(!(t instanceof h))throw new c(t.id);l.set(t.id,t),p.listener?.({op:0,item:t})},delete(t){l.delete(t)&&p.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$HO=u}),define(Ee[135],ke([1,0,134]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=void 0;const A=new WeakMap,S=(C,k)=>{const v={controllerId:k};return A.set(C,v),v};e.$IO=S;const D=C=>{const k=A.get(C);if(!k)throw new i.$FO(C?.id||"<unknown>");return k};e.$JO=D}),define(Ee[281],ke([1,0,25,5]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=void 0,e.$rE=".vscode",e.$sE="settings",e.$tE=`${e.$rE}/${e.$sE}.json`,e.$uE="vscode://schemas/settings/default",e.$vE="vscode://schemas/settings/user",e.$wE="vscode://schemas/settings/profile",e.$xE="vscode://schemas/settings/machine",e.$yE="vscode://schemas/settings/workspace",e.$zE="vscode://schemas/settings/folder",e.$AE="vscode://schemas/launch",e.$BE="vscode://schemas/tasks",e.$CE=[1],e.$DE=[2,3,4,5,6],e.$EE=[3,4,5],e.$FE=[1,...e.$EE],e.$GE=[2,3,4,5,6],e.$HE=[3,4,5,6],e.$IE=[4,5,6],e.$JE="tasks",e.$KE="launch",e.$LE=Object.create(null),e.$LE[e.$JE]=`${e.$rE}/${e.$JE}.json`,e.$LE[e.$KE]=`${e.$rE}/${e.$KE}.json`,e.$ME=Object.create(null),e.$ME[e.$JE]=`${e.$JE}.json`,e.$NE=(0,A.$ji)(i.$Oi),e.$OE=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$PE="workbench.settings.applyToAllProfiles"}),define(Ee[136],ke([1,0,5]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.VariableKind=e.$zP=void 0,e.$zP=(0,i.$ii)("configurationResolverService");var A;(function(D){D.Unknown="unknown",D.Env="env",D.Config="config",D.Command="command",D.Input="input",D.ExtensionInstallFolder="extensionInstallFolder",D.WorkspaceFolder="workspaceFolder",D.Cwd="cwd",D.WorkspaceFolderBasename="workspaceFolderBasename",D.UserHome="userHome",D.LineNumber="lineNumber",D.SelectedText="selectedText",D.File="file",D.FileWorkspaceFolder="fileWorkspaceFolder",D.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",D.RelativeFile="relativeFile",D.RelativeFileDirname="relativeFileDirname",D.FileDirname="fileDirname",D.FileExtname="fileExtname",D.FileBasename="fileBasename",D.FileBasenameNoExtension="fileBasenameNoExtension",D.FileDirnameBasename="fileDirnameBasename",D.ExecPath="execPath",D.ExecInstallFolder="execInstallFolder",D.PathSeparator="pathSeparator",D.PathSeparatorAlias="/"})(A||(e.VariableKind=A={}));class S extends Error{constructor(C,k){super(k),this.variable=C}}e.$AP=S}),define(Ee[282],ke([1,0,7,30,11,21,4,174,213,136,17]),function(le,e,i,A,S,D,C,k,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(m,d,c,g){this.h=new Map,this.a=m,this.b=d,this.g=c,g&&(this.c=g.then(u=>this.i(u)))}i(m){if(C.$i){const d=Object.create(null);return Object.keys(m).forEach(c=>{d[c.toLowerCase()]=m[c]}),d}return m}resolveWithEnvironment(m,d,c){return this.l({env:this.i(m),userHome:void 0},d?d.uri:void 0,c)}async resolveAsync(m,d){const c={env:await this.c,userHome:await this.g};return this.l(c,m?m.uri:void 0,d)}async j(m,d,c,g){const u=D.$On(d);C.$i&&u.windows?Object.keys(u.windows).forEach(f=>u[f]=u.windows[f]):C.$j&&u.osx?Object.keys(u.osx).forEach(f=>u[f]=u.osx[f]):C.$k&&u.linux&&Object.keys(u.linux).forEach(f=>u[f]=u.linux[f]),delete u.windows,delete u.osx,delete u.linux;const p={env:await this.c,userHome:await this.g};return this.l(p,m?m.uri:void 0,u,c,g)}async resolveAnyAsync(m,d,c){return this.j(m,d,c)}async resolveAnyMap(m,d,c){const g=new Map;return{newConfig:await this.j(m,d,c,g),resolvedVariables:g}}resolveWithInteractionReplace(m,d,c,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,d,c,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,d){if(this.h.has(m))throw new Error("Variable "+m+" is contributed twice.");this.h.set(m,d)}async l(m,d,c,g,u){if(S.$Vf(c))return this.m(m,d,c,g,u);if(Array.isArray(c))return Promise.all(c.map(p=>this.l(m,d,p,g,u)));if(S.$Xf(c)){const p=Object.create(null),f=await Promise.all(Object.keys(c).map(async h=>[await this.m(m,d,h,g,u),await this.l(m,d,c[h],g,u)]));for(const[h,l]of f)p[h]=l;return p}return c}m(m,d,c,g,u){return(0,E.$df)(c,y.VARIABLE_REGEXP,async(p,f)=>{if(f.includes(y.VARIABLE_LHS))return p;let h=await this.o(m,p,f,d,g);return u?.set(f,h),h!==p&&S.$Vf(h)&&h.match(y.VARIABLE_REGEXP)&&(h=await this.m(m,d,h,g,u)),h})}n(m){return this.b?this.b.getUriLabel(m,{noPrefix:!0}):m.fsPath}async o(m,d,c,g,u){let p;const f=c.split(":");f.length>1&&(c=f[0],p=f[1]);const h=a=>{const o=this.a.getFilePath();if(o)return(0,k.$hw)(o);throw new $.$AP(a,(0,v.localize)(0,null,d))},l=a=>{const o=h(a);if(this.a.getWorkspaceFolderPathForFile){const r=this.a.getWorkspaceFolderPathForFile();if(r)return(0,k.$hw)(r)}throw new $.$AP(a,(0,v.localize)(1,null,d,i.$oc(o)))},t=a=>{if(p){const o=this.a.getFolderUri(p);if(o)return o;throw new $.$AP(a,(0,v.localize)(2,null,d,p))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new $.$AP(a,(0,v.localize)(3,null,d)):new $.$AP(a,(0,v.localize)(4,null,d))};switch(c){case"env":if(p){if(m.env){const a=m.env[C.$i?p.toLowerCase():p];if(S.$Vf(a))return a}return""}throw new $.$AP($.VariableKind.Env,(0,v.localize)(5,null,d));case"config":if(p){const a=this.a.getConfigurationValue(g,p);if(S.$5f(a))throw new $.$AP($.VariableKind.Config,(0,v.localize)(6,null,d,p));if(S.$Xf(a))throw new $.$AP($.VariableKind.Config,(0,v.localize)(7,null,d,p));return a}throw new $.$AP($.VariableKind.Config,(0,v.localize)(8,null,d));case"command":return this.p($.VariableKind.Command,d,p,u,"command");case"input":return this.p($.VariableKind.Input,d,p,u,"input");case"extensionInstallFolder":if(p){const a=await this.a.getExtension(p);if(!a)throw new $.$AP($.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,d,p));return this.n(a.extensionLocation)}throw new $.$AP($.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,d));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,k.$hw)(this.n(t($.VariableKind.WorkspaceFolder)));case"cwd":return g||p?(0,k.$hw)(this.n(t($.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,k.$hw)(i.$oc(this.n(t($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(m.userHome)return m.userHome;throw new $.$AP($.VariableKind.UserHome,(0,v.localize)(11,null,d))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new $.$AP($.VariableKind.LineNumber,(0,v.localize)(12,null,d))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new $.$AP($.VariableKind.SelectedText,(0,v.localize)(13,null,d))}case"file":return h($.VariableKind.File);case"fileWorkspaceFolder":return l($.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return i.$oc(l($.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||p?i.$mc(this.n(t($.VariableKind.RelativeFile)),h($.VariableKind.RelativeFile)):h($.VariableKind.RelativeFile);case"relativeFileDirname":{const a=i.$nc(h($.VariableKind.RelativeFileDirname));if(g||p){const o=i.$mc(this.n(t($.VariableKind.RelativeFileDirname)),a);return o.length===0?".":o}return a}case"fileDirname":return i.$nc(h($.VariableKind.FileDirname));case"fileExtname":return i.$pc(h($.VariableKind.FileExtname));case"fileBasename":return i.$oc(h($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=i.$oc(h($.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-i.$pc(a).length)}case"fileDirnameBasename":return i.$oc(i.$nc(h($.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||d}case"execInstallFolder":{const a=this.a.getAppRoot();return a||d}case"pathSeparator":case"/":return i.sep;default:try{const a=p?`${c}:${p}`:c;return this.p($.VariableKind.Unknown,d,a,u,void 0)}catch{return d}}}}p(m,d,c,g,u){if(c&&g){const p=u===void 0?g[c]:g[u+":"+c];if(typeof p=="string")return p;throw new $.$AP(m,(0,v.localize)(14,null,d))}return d}}e.$PP=y}),define(Ee[283],ke([1,0,5,93]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$AD=void 0,e.$BD=$,e.$CD=w,e.$DD=m,e.$AD=(0,i.$ii)("editorGroupsService");var S;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(S||(e.GroupDirection=S={}));var D;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(D||(e.GroupOrientation=D={}));var C;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(C||(e.GroupLocation=C={}));var k;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(k||(e.GroupsArrangement=k={}));var v;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function $(d){const c=d;return(0,A.$lF)(c?.editor)&&(0,A.$lF)(c?.replacement)}var E;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(E||(e.GroupsOrder=E={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function w(d){const c=d;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function m(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ee[137],ke([1,0,5,283]),function(le,e,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HD=e.$GD=e.$FD=e.$ED=void 0,e.$ID=S,e.$ED=(0,i.$ii)("editorService"),e.$FD=-1,e.$GD=-2,e.$HD=-3;function S(D){const C=D;return typeof D=="number"||(0,A.$CD)(C)}}),define(Ee[284],ke([1,0,281,119,92,90,136,93,137,12,233,279,91]),function(le,e,i,A,S,D,C,k,v,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SP=e.$RP=void 0,e.$RP="remoteterminal";let m=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(c,g,u,p,f,h,l,t,a,o){this.a=c,this.b=g,this.c=u,this.d=p,this.e=f,this.f=h,this.g=l,this.h=t,this.i=a,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(c,g,u,p,f,h,l,t){await this.c.whenRemoteConfigurationLoaded();const a=Object.create(null),o=u?this.d.getWorkspaceFolder(u)??void 0:void 0;let r;try{r=(await this.e.resolveAnyMap(o,{shellLaunchConfig:c,configuration:g})).resolvedVariables}catch(B){this.h.error(B)}if(r)for(const[B,Y]of r.entries())(/^config:/.test(B)||B==="selectedText"||B==="lineNumber")&&(a[B]=Y);const s=[];for(const[B,Y]of this.f.collections.entries())s.push([B,(0,D.$7r)(Y.map),(0,D.$8r)(Y.descriptionMap)]);const n=await this.g.resolveAuthority(this.a),b=n.options&&n.options.extensionHostEnv,P=this.d.getWorkspace(),I=P.folders,O=u?this.d.getWorkspaceFolder(u):null,R=k.$tF.getOriginalUri(this.i.activeEditor,{supportSideBySide:k.SideBySideEditor.PRIMARY,filterByScheme:[$.Schemas.file,$.Schemas.vscodeUserData,$.Schemas.vscodeRemote]}),j={configuration:g,resolvedVariables:a,envVariableCollections:s,shellLaunchConfig:c,workspaceId:P.id,workspaceName:this.j.getWorkspaceLabel(P),workspaceFolders:I,activeWorkspaceFolder:O,activeFileResource:R,shouldPersistTerminal:f,options:p,cols:h,rows:l,unicodeVersion:t,resolverEnv:b};return await this.b.call("$createProcess",j)}requestDetachInstance(c,g){return this.b.call("$requestDetachInstance",[c,g])}acceptDetachInstanceReply(c,g){return this.b.call("$acceptDetachInstanceReply",[c,g])}attachToProcess(c){return this.b.call("$attachToProcess",[c])}detachFromProcess(c,g){return this.b.call("$detachFromProcess",[c,g])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(c,g){return this.b.call("$processBinary",[c,g])}start(c){return this.b.call("$start",[c])}input(c,g){return this.b.call("$input",[c,g])}acknowledgeDataEvent(c,g){return this.b.call("$acknowledgeDataEvent",[c,g])}setUnicodeVersion(c,g){return this.b.call("$setUnicodeVersion",[c,g])}shutdown(c,g){return this.b.call("$shutdown",[c,g])}resize(c,g,u){return this.b.call("$resize",[c,g,u])}clearBuffer(c){return this.b.call("$clearBuffer",[c])}getInitialCwd(c){return this.b.call("$getInitialCwd",[c])}getCwd(c){return this.b.call("$getCwd",[c])}orphanQuestionReply(c){return this.b.call("$orphanQuestionReply",[c])}sendCommandResult(c,g,u){return this.b.call("$sendCommandResult",[c,g,u])}freePortKillProcess(c){return this.b.call("$freePortKillProcess",[c])}installAutoReply(c,g){return this.b.call("$installAutoReply",[c,g])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(c){return this.b.call("$getDefaultSystemShell",[c])}getProfiles(c,g,u){return this.b.call("$getProfiles",[this.d.getWorkspace().id,c,g,u])}acceptPtyHostResolvedVariables(c,g){return this.b.call("$acceptPtyHostResolvedVariables",[c,g])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(c,g){return this.b.call("$getWslPath",[c,g])}setTerminalLayoutInfo(c){const u={workspaceId:this.d.getWorkspace().id,tabs:c?c.tabs:[]};return this.b.call("$setTerminalLayoutInfo",u)}updateTitle(c,g,u){return this.b.call("$updateTitle",[c,g,u])}updateIcon(c,g,u,p){return this.b.call("$updateIcon",[c,g,u,p])}refreshProperty(c,g){return this.b.call("$refreshProperty",[c,g])}updateProperty(c,g,u){return this.b.call("$updateProperty",[c,g,u])}getTerminalLayoutInfo(){const g={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",g)}reviveTerminalProcesses(c,g,u){return this.b.call("$reviveTerminalProcesses",[c,g,u])}getRevivedPtyNewId(c){return this.b.call("$getRevivedPtyNewId",[c])}serializeTerminalState(c){return this.b.call("$serializeTerminalState",[c])}};e.$SP=m,e.$SP=m=Le([Re(2,i.$NE),Re(3,S.$ri),Re(4,C.$zP),Re(5,y.$eP),Re(6,A.$tl),Re(7,w.$Tr),Re(8,v.$ED),Re(9,E.$Kv)],m)}),define(Ee[285],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.ExtHostConnectionType=void 0,e.$_m=k,e.$an=v;var i;(function(E){E[E.IPC=1]="IPC",E[E.Socket=2]="Socket",E[E.MessagePort=3]="MessagePort"})(i||(e.ExtHostConnectionType=i={}));class A{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(y){this.pipeName=y,this.type=1}serialize(y){y[A.ENV_KEY]=this.pipeName}}e.$9m=A;class S{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(y){y[S.ENV_KEY]="1"}}e.$0m=S;class D{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(y){y[D.ENV_KEY]="1"}}e.$$m=D;function C(E){delete E[A.ENV_KEY],delete E[S.ENV_KEY],delete E[D.ENV_KEY]}function k(E,y){C(y),E.serialize(y)}function v(E){if(E[A.ENV_KEY])return $(E,new A(E[A.ENV_KEY]));if(E[S.ENV_KEY])return $(E,new S);if(E[D.ENV_KEY])return $(E,new D);throw new Error("No connection information defined in environment!")}function $(E,y){return C(E),y}}),define(Ee[286],ke([1,0,14]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Lm=C,e.$Mm=k;var A;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(A||(e.UIKind=A={}));var S;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(S||(e.ExtensionHostExitCode=S={}));var D;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(D||(e.MessageType=D={}));function C($){const E=i.$ue.alloc(1);switch($){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}function k($,E){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}var v;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Ee[287],ke([1,0,5,6,13,274,286,85,39,21,3,2,211]),function(le,e,i,A,S,D,C,k,v,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8O=e.$6O=e.$5O=void 0,e.$7O=c;let m=class extends y.$Uc{constructor(u,p){super(),this.s=u,this.t=p,this.a=this.B(new A.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=p.createLogger(this.m,{id:v.$9o,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(p.onDidChangeLogLevel(f=>{(0,S.$Qj)(f)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===S.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,p,f){const h=this.getTelemetryDetails(),l=new d(p,f,u,this.n,this.j,this.getBuiltInCommonProperties(u),{isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}),t=this.r.get(u.identifier.value)??[];return this.r.set(u.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(u,p,f){this.f=u,this.g=p,this.c=f??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(u){const p=Object.create(null);switch(p["common.extname"]=`${u.publisher}.${u.name}`,p["common.extversion"]=u.version,p["common.vscodemachineid"]=this.s.telemetryInfo.machineId,p["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,p["common.sqmid"]=this.s.telemetryInfo.sqmId,p["common.vscodeversion"]=this.s.version,p["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),p["common.product"]=this.s.environment.appHost,this.s.uiKind){case C.UIKind.Web:p["common.uikind"]="web";break;case C.UIKind.Desktop:p["common.uikind"]="desktop";break;default:p["common.uikind"]="unknown"}return p["common.remotename"]=(0,k.$um)((0,v.$cp)(this.s.remote.authority)),p}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const p=this.getTelemetryDetails();this.r.forEach((f,h)=>{const l=f.filter(t=>!t.isDisposed);l.length===0?this.r.delete(h):this.r.set(h,l)}),this.r.forEach(f=>{for(const h of f)h.updateTelemetryEnablements(p.isUsageEnabled,p.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(u,p){const h=this.r.get(u.value)?.filter(t=>!t.isDisposed);if(!h)return this.r.delete(u.value),!1;let l=!1;for(const t of h)t.ignoreUnhandledExtHostErrors||(t.logError(p),l=!0);return l}};e.$5O=m,e.$5O=m=Le([Re(0,D.$4O),Re(1,S.$Pj)],m);class d{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,p,f,h,l,t,a){this.g=f,this.h=h,this.i=l,this.j=t,this.a=new A.$7d,this.ignoreUnhandledExtHostErrors=p?.ignoreUnhandledErrors??!1,this.b=p?.ignoreBuiltInCommonProperties??!1,this.c=p?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(u,p){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:p},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let p="properties"in u?u.properties??{}:u;return p=(0,v.$fp)(p,[]),this.c&&(p=(0,$.$Rn)(p,this.c)),this.b||(p=(0,$.$Rn)(p,this.j)),"properties"in u?u.properties=p:u=p,u}k(u,p){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,p=this.mixInCommonPropsAndCleanData(p||{}),this.i||this.f?.sendEventData(u,p),this.h.trace(u,p))}logUsage(u,p){this.d.isUsageEnabled&&this.k(u,p)}logError(u,p){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,p);else{const f={name:u.name,message:u.message,stack:u.stack,cause:u.cause},h=(0,v.$fp)(f,[]),l=new Error(h.message,{cause:h.cause});l.stack=h.stack,l.name=h.name,p=this.mixInCommonPropsAndCleanData(p||{}),this.i||this.f.sendErrorData(l,p),this.h.trace("exception",p)}}get apiTelemetryLogger(){if(!this.e){const u=this,p={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(p)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$6O=d;function c(g){const u=Date.now()-new Date(g).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$8O=(0,i.$ii)("IExtHostTelemetry")}),define(Ee[288],ke([1,0,6,3,36,241,35,5]),function(le,e,i,A,S,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hG=e.ActivationKind=e.$eG=e.$dG=e.$aG=e.ExtensionHostStartup=e.$_F=e.$$F=e.$0F=e.$9F=void 0,e.$bG=w,e.$cG=m,e.$fG=u,e.$gG=p,e.$9F=Object.freeze({identifier:new C.$Dm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$0F="extensions.webWorker",e.$$F=(0,k.$ii)("extensionService");class v{constructor(l){this.dependency=l}}e.$_F=v;var $;(function(h){h[h.EagerAutoStart=1]="EagerAutoStart",h[h.EagerManualStart=2]="EagerManualStart",h[h.Lazy=3]="Lazy"})($||(e.ExtensionHostStartup=$={}));class E{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,a){this.c=l,this.d=t.slice(0),this.e=a.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:D.$TF.createActivationEventsMap(this.d)}}set(l,t,a){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const o=[],r=[],s=[],n=[],b=y(this.d),P=y(t),I=(Y,fe)=>Y.extensionLocation.toString()===fe.extensionLocation.toString()||Y.isBuiltin===fe.isBuiltin||Y.isUserBuiltin===fe.isUserBuiltin||Y.isUnderDevelopment===fe.isUnderDevelopment;for(const Y of this.d){const fe=P.get(Y.identifier);if(!fe){o.push(Y.identifier),b.delete(Y.identifier);continue}if(!I(Y,fe)){o.push(Y.identifier),b.delete(Y.identifier);continue}}for(const Y of t){const fe=b.get(Y.identifier);if(!fe){r.push(Y);continue}if(!I(fe,Y)){o.push(fe.identifier),b.delete(fe.identifier);continue}}const O=new C.$Em(this.e),R=new C.$Em(a);for(const Y of this.e)R.has(Y)||s.push(Y);for(const Y of a)O.has(Y)||n.push(Y);const j=D.$TF.createActivationEventsMap(r),B={versionId:l,toRemove:o,toAdd:r,addActivationEvents:j,myToRemove:s,myToAdd:n};return this.delta(B),B}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:a,myToRemove:o,myToAdd:r}=l,s=new C.$Em(t),n=new C.$Em(o);for(let b=0;b<this.d.length;b++)s.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)n.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of a)this.d.push(b);for(const b of r)this.e.push(b);return this.f=null,l}containsExtension(l){for(const t of this.e)if(C.$Dm.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const a=D.$TF.readActivationEvents(t);for(const o of a)l.add(o)}return l}}e.$aG=E;function y(h){const l=new C.$Fm;for(const t of h)l.set(t.identifier,t);return l}function w(h,l){return h.enabledApiProposals?h.enabledApiProposals.includes(l):!1}function m(h,l){if(!w(h,l))throw new Error(`Extension '${h.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${h.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${h.identifier.value}`)}class d{constructor(l,t,a,o){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=a,this.activationReason=o}}e.$dG=d;class c{constructor(l,t){this.description=l,this.value=t}}e.$eG=c;var g;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function u(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,S.$lp)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation,targetPlatform:h.targetPlatform,validations:[],isValid:!0}}function p(h,l){return{identifier:new C.$Dm((0,S.$jp)(h.manifest.publisher,h.manifest.name)),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!!l,extensionLocation:h.location,...h.manifest,uuid:h.identifier.uuid,targetPlatform:h.targetPlatform}}class f{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.onWillStop=i.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$hG=f}),define(Ee[289],ke([1,0,35,214,56]),function(le,e,i,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=D;function D(C,k,v,$){const E=new i.$Fm;return C.forEach(y=>{const w=E.get(y.identifier);w&&$.warn((0,A.localize)(0,null,w.extensionLocation.fsPath,y.extensionLocation.fsPath)),E.set(y.identifier,y)}),k.forEach(y=>{const w=E.get(y.identifier);if(w)if(w.isBuiltin){if(S.gte(w.version,y.version)){$.warn(`Skipping extension ${y.extensionLocation.path} in favour of the builtin extension ${w.extensionLocation.path}.`);return}y.isBuiltin=!0}else $.warn((0,A.localize)(1,null,w.extensionLocation.fsPath,y.extensionLocation.fsPath));else if(y.isBuiltin){$.warn(`Skipping obsolete builtin extension ${y.extensionLocation.path}`);return}E.set(y.identifier,y)}),v.forEach(y=>{$.info((0,A.localize)(2,null,y.extensionLocation.fsPath));const w=E.get(y.identifier);w&&w.isBuiltin&&(y.isBuiltin=!0),E.set(y.identifier,y)}),Array.from(E.values())}}),define(Ee[290],ke([1,0,7,4,30,3,43,54,57,59,289,12]),function(le,e,i,A,S,D,C,k,v,$,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=void 0;class w{constructor(c,g,u,p,f,h,l){this.c=c,this.d=u,this.f=p,this.g=f,this.h=h,this.i=l,this.a=Promise.resolve(),this.b=Promise.resolve();const t=g.args["install-builtin-extension"];if(t){f.trace("Installing builtin extensions passed via args...");const o={isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]};C.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=c.installExtensions([],this.j(t),o,!!g.args.force).then(()=>{C.mark("code/server/didInstallBuiltinExtensions"),f.trace("Finished installing builtin extensions")},r=>{f.error(r)})}const a=g.args["install-extension"];a&&(f.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>c.installExtensions(this.j(a),[],{isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"],isApplicationScoped:!0},!!g.args.force)).then(()=>{f.trace("Finished installing extensions")},o=>{f.error(o)}))}j(c){return c.map(g=>/\.vsix$/i.test(g)?D.URI.file((0,i.$jc)(g)?g:(0,i.$kc)((0,S.cwd)(),g)):g)}whenExtensionsReady(){return this.b}async scanExtensions(c,g,u,p){C.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${c}`),await this.a;const f=u?u.filter(l=>l.scheme===y.Schemas.file).map(l=>l.fsPath):void 0;g=g??this.d.defaultProfile.extensionsResource;const h=await this.k(g,c??A.$w,f,p);return this.g.trace("Scanned Extensions",h),this.r(h),C.mark("code/server/didScanExtensions"),h}async scanSingleExtension(c,g,u){await this.a;const p=c.scheme===y.Schemas.file?c.fsPath:null;if(!p)return null;const f=await this.o(p,g,u??A.$w);return f?(this.r([f]),f):null}async k(c,g,u,p){await this.q(g,p);const[f,h,l]=await Promise.all([this.m(g),this.n(c,g),this.l(g,u)]);return(0,E.$aQ)(f,h,l,this.g)}async l(c,g){return g?(await Promise.all(g.map(u=>this.f.scanOneOrMultipleExtensions(D.URI.file((0,i.$lc)(u)),1,{language:c})))).flat().map(u=>(0,$.$iq)(u,!0)):[]}async m(c){return(await this.f.scanSystemExtensions({language:c,useCache:!0})).map(u=>(0,$.$iq)(u,!1))}async n(c,g){return(await this.f.scanUserExtensions({profileLocation:c,language:g,useCache:!0})).map(p=>(0,$.$iq)(p,!1))}async o(c,g,u){const p=D.URI.file((0,i.$lc)(c)),f=g?0:1,h=await this.f.scanExistingExtension(p,f,{language:u});return h?(0,$.$iq)(h,!1):null}async q(c,g){if(!(c===A.$g||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(p=>p.id===c)){this.g.trace(`Language Pack ${c} is already installed. Skipping language pack installation.`);return}}catch(u){this.g.error(u)}if(!g){this.g.trace(`No language pack id provided for language ${c}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${g} for language ${c} is not installed. It will be installed now.`);try{await this.c.installExtensions([g],[],{isMachineScoped:!0},!0)}catch(u){this.g.error(u)}}}r(c){const g=(t,a)=>t.replace(/file/g,"vscode-remote"),u=t=>{let a="";return a+=t.global?"g":"",a+=t.ignoreCase?"i":"",a+=t.multiline?"m":"",new RegExp(g(t.source,!0),a)},p=new class{mapDefined(t){return v.$lj.create(t)}mapNot(t){return v.$qj.create(t)}mapEquals(t,a){return t==="resourceScheme"&&typeof a=="string"?v.$mj.create(t,g(a,!1)):v.$mj.create(t,a)}mapNotEquals(t,a){return t==="resourceScheme"&&typeof a=="string"?v.$pj.create(t,g(a,!1)):v.$pj.create(t,a)}mapGreater(t,a){return v.$rj.create(t,a)}mapGreaterEquals(t,a){return v.$sj.create(t,a)}mapSmaller(t,a){return v.$tj.create(t,a)}mapSmallerEquals(t,a){return v.$uj.create(t,a)}mapRegex(t,a){return t==="resourceScheme"&&a?v.$vj.create(t,u(a)):v.$vj.create(t,a)}mapIn(t,a){return v.$nj.create(t,a)}mapNotIn(t,a){return v.$oj.create(t,a)}},f=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const a=v.$gj.deserialize(t.when);if(!a)return;const o=a.map(p);t.when=o.serialize()},h=t=>{if(Array.isArray(t))for(const a of t)f(a);else f(t)},l=t=>{for(const a in t)h(t[a])};c.forEach(t=>{t.contributes&&(t.contributes.menus&&l(t.contributes.menus),t.contributes.keybindings&&h(t.contributes.keybindings),t.contributes.views&&l(t.contributes.views))})}}e.$dQ=w;class m{constructor(c,g){this.a=c,this.b=g}listen(c,g){throw new Error("Invalid listen")}async call(c,g,u){const p=this.b(c);switch(g){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const f=u[0],h=u[1]?D.URI.revive(p.transformIncoming(u[1])):void 0,l=Array.isArray(u[2])?u[2].map(o=>D.URI.revive(p.transformIncoming(o))):void 0,t=u[3];return(await this.a.scanExtensions(f,h,l,t)).map(o=>(0,k.$mn)(o,p))}case"scanSingleExtension":{const f=await this.a.scanSingleExtension(D.URI.revive(p.transformIncoming(u[0])),u[1],u[2]);return f?(0,k.$mn)(f,p):null}}throw new Error("Invalid call")}}e.$eQ=m}),define(Ee[138],ke([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$bw=void 0,e.$cw=S,e.$dw=D;class i{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++i.count}}e.$bw=i;const A=[];function S(k){const v=new i(k);return A[v.nid]=v,v}function D(k){return A[k].sid}class C{constructor(v){this.value=v}}e.$ew=C}),define(Ee[291],ke([1,0,138]),function(le,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$qM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(A||(e.TextEditorRevealType=A={}));var S;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(S||(e.TabInputKind=S={}));var D;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(D||(e.TabModelOperationKind=D={}));var C;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(C||(e.WebviewEditorCapabilities=C={}));var k;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(k||(e.WebviewMessageArrayBufferViewType=k={}));var v;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var $;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var E;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(E||(e.CandidatePortSource=E={}));class y{static{this.a=0}static mixin(g){return g._id=y.a++,g}}e.$qM=y;var w;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var m;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(m||(e.ISuggestResultDtoField=m={}));var d;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$rM={MainThreadAuthentication:(0,i.$cw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.$cw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,i.$cw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,i.$cw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,i.$cw)("MainThreadChatVariables"),MainThreadClipboard:(0,i.$cw)("MainThreadClipboard"),MainThreadCommands:(0,i.$cw)("MainThreadCommands"),MainThreadComments:(0,i.$cw)("MainThreadComments"),MainThreadConfiguration:(0,i.$cw)("MainThreadConfiguration"),MainThreadConsole:(0,i.$cw)("MainThreadConsole"),MainThreadDebugService:(0,i.$cw)("MainThreadDebugService"),MainThreadDecorations:(0,i.$cw)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.$cw)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.$cw)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.$cw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.$cw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.$cw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.$cw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.$cw)("MainThreadEditorTabs"),MainThreadErrors:(0,i.$cw)("MainThreadErrors"),MainThreadTreeViews:(0,i.$cw)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.$cw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,i.$cw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.$cw)("MainThreadLanguages"),MainThreadLogger:(0,i.$cw)("MainThreadLogger"),MainThreadMessageService:(0,i.$cw)("MainThreadMessageService"),MainThreadOutputService:(0,i.$cw)("MainThreadOutputService"),MainThreadProgress:(0,i.$cw)("MainThreadProgress"),MainThreadQuickDiff:(0,i.$cw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,i.$cw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.$cw)("MainThreadStatusBar"),MainThreadSecretState:(0,i.$cw)("MainThreadSecretState"),MainThreadStorage:(0,i.$cw)("MainThreadStorage"),MainThreadSpeech:(0,i.$cw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,i.$cw)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.$cw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,i.$cw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,i.$cw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.$cw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.$cw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.$cw)("MainThreadCustomEditors"),MainThreadUrls:(0,i.$cw)("MainThreadUrls"),MainThreadUriOpeners:(0,i.$cw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.$cw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.$cw)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.$cw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,i.$cw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,i.$cw)("MainThreadExtensionService"),MainThreadSCM:(0,i.$cw)("MainThreadSCM"),MainThreadSearch:(0,i.$cw)("MainThreadSearch"),MainThreadShare:(0,i.$cw)("MainThreadShare"),MainThreadTask:(0,i.$cw)("MainThreadTask"),MainThreadWindow:(0,i.$cw)("MainThreadWindow"),MainThreadLabelService:(0,i.$cw)("MainThreadLabelService"),MainThreadNotebook:(0,i.$cw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.$cw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.$cw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.$cw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.$cw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.$cw)("MainThreadInteractive"),MainThreadChat:(0,i.$cw)("MainThreadChat"),MainThreadInlineChat:(0,i.$cw)("MainThreadInlineChatShape"),MainThreadTheming:(0,i.$cw)("MainThreadTheming"),MainThreadTunnelService:(0,i.$cw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,i.$cw)("MainThreadManagedSockets"),MainThreadTimeline:(0,i.$cw)("MainThreadTimeline"),MainThreadTesting:(0,i.$cw)("MainThreadTesting"),MainThreadLocalization:(0,i.$cw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,i.$cw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,i.$cw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,i.$cw)("MainThreadIssueReporter")},e.$sM={ExtHostCommands:(0,i.$cw)("ExtHostCommands"),ExtHostConfiguration:(0,i.$cw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.$cw)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.$cw)("ExtHostDebugService"),ExtHostDecorations:(0,i.$cw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.$cw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.$cw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.$cw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.$cw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.$cw)("ExtHostEditors"),ExtHostTreeViews:(0,i.$cw)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.$cw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.$cw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.$cw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.$cw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.$cw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.$cw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,i.$cw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,i.$cw)("ExtHostStatusBar"),ExtHostShare:(0,i.$cw)("ExtHostShare"),ExtHostExtensionService:(0,i.$cw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.$cw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.$cw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,i.$cw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,i.$cw)("ExtHostSCM"),ExtHostSearch:(0,i.$cw)("ExtHostSearch"),ExtHostTask:(0,i.$cw)("ExtHostTask"),ExtHostWorkspace:(0,i.$cw)("ExtHostWorkspace"),ExtHostWindow:(0,i.$cw)("ExtHostWindow"),ExtHostWebviews:(0,i.$cw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.$cw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.$cw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.$cw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.$cw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.$cw)("ExtHostEditorTabs"),ExtHostProgress:(0,i.$cw)("ExtHostProgress"),ExtHostComments:(0,i.$cw)("ExtHostComments"),ExtHostSecretState:(0,i.$cw)("ExtHostSecretState"),ExtHostStorage:(0,i.$cw)("ExtHostStorage"),ExtHostUrls:(0,i.$cw)("ExtHostUrls"),ExtHostUriOpeners:(0,i.$cw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.$cw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.$cw)("ExtHostOutputService"),ExtHostLabelService:(0,i.$cw)("ExtHostLabelService"),ExtHostNotebook:(0,i.$cw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.$cw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.$cw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.$cw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.$cw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,i.$cw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,i.$cw)("ExtHostInteractive"),ExtHostInlineChat:(0,i.$cw)("ExtHostInlineChatShape"),ExtHostChat:(0,i.$cw)("ExtHostChat"),ExtHostChatAgents2:(0,i.$cw)("ExtHostChatAgents"),ExtHostChatVariables:(0,i.$cw)("ExtHostChatVariables"),ExtHostChatProvider:(0,i.$cw)("ExtHostChatProvider"),ExtHostSpeech:(0,i.$cw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,i.$cw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,i.$cw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,i.$cw)("ExtHostTheming"),ExtHostTunnelService:(0,i.$cw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,i.$cw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,i.$cw)("ExtHostAuthentication"),ExtHostTimeline:(0,i.$cw)("ExtHostTimeline"),ExtHostTesting:(0,i.$cw)("ExtHostTesting"),ExtHostTelemetry:(0,i.$cw)("ExtHostTelemetry"),ExtHostLocalization:(0,i.$cw)("ExtHostLocalization"),ExtHostIssueReporter:(0,i.$cw)("ExtHostIssueReporter")}}),define(Ee[292],ke([1,0,14,24,12,110,5]),function(le,e,i,A,S,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.$6J=void 0,e.$7J=E,e.$8J=y,e.$6J=(0,C.$ii)("notebookDocumentService");const k=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${k.join("")}]+`),$=7;function E(m){if(m.scheme!==S.Schemas.vscodeNotebookCell)return;const d=m.fragment.indexOf("s");if(d<0)return;const c=parseInt(m.fragment.substring(0,d).replace(v,""),$),g=(0,i.$Ne)(m.fragment.substring(d+1)).toString();if(!isNaN(c))return{handle:c,notebook:m.with({scheme:g,fragment:null})}}function y(m,d){const c=d.toString($),u=`${c.length<k.length?k[c.length-1]:"z"}${c}s${(0,i.$Oe)(i.$ue.fromString(m.scheme),!0,!0)}`;return m.with({scheme:S.Schemas.vscodeNotebookCell,fragment:u})}class w{constructor(){this.a=new A.$Bc}getNotebook(d){if(d.scheme===S.Schemas.vscodeNotebookCell){const c=E(d);if(c){const g=this.a.get(c.notebook);if(g)return g}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$9J=w,(0,D.$gs)(e.$6J,w,1)}),define(Ee[139],ke([1,0,14,79,41,65,12,7,4,57,292]),function(le,e,i,A,S,D,C,k,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=e.$nK=e.CellStatusbarAlignment=e.$mK=e.NotebookEditorPriority=e.$jK=e.$iK=e.$gK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$fK=e.$eK=e.$dK=e.$cK=e.CellKind=e.$bK=e.$aK=e.$_J=void 0,e.$hK=a,e.$kK=r,e.$lK=s,e.$oK=P,e.$pK=O,e.$_J="workbench.editor.notebook",e.$aK="workbench.editor.notebookTextDiffEditor",e.$bK="workbench.editor.interactive";var y;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(y||(e.CellKind=y={})),e.$cK=["application/json","application/javascript","text/html","image/svg+xml",D.$zs.latex,D.$zs.markdown,"image/png","image/jpeg",D.$zs.text],e.$dK=[D.$zs.latex,D.$zs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",D.$zs.text],e.$eK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$fK="_notAvailable";var w;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var m;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var d;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var c;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var g;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var u;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var p;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(p||(e.SelectionStateType=p={}));var f;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(f||(e.CellEditType=f={}));var h;(function(V){V.scheme=C.Schemas.vscodeNotebookCell;function T(ne,$e){return(0,E.$8J)(ne,$e)}V.generate=T;function x(ne){return(0,E.$7J)(ne)}V.parse=x;function Z(ne,$e){return ne.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${ne.scheme!==C.Schemas.file?ne.scheme:""}`})}V.generateCellOutputUri=Z;function G(ne){if(ne.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!$e)return;const K=$e[1]&&$e[1]!==""?$e[1]:void 0,q=$e[2];return{outputId:K,notebook:ne.with({scheme:q||C.Schemas.file,fragment:null})}}V.parseCellOutputUri=G;function se(ne,$e,K){return V.generate(ne,$e).with({scheme:K})}V.generateCellPropertyUri=se;function ce(ne,$e){if(ne.scheme===$e)return V.parse(ne.with({scheme:V.scheme}))}V.parseCellPropertyUri=ce})(h||(e.CellUri=h={}));const l=V=>v.$i?V.replace(/\//g,"\\"):V;class t{constructor(T=[],x=e.$cK){this.e=x,this.d=[...new Set(T)].map(Z=>({pattern:Z,matches:A.$ck(l(Z))}))}sort(T){const x=new Map(S.Iterable.map(T,G=>[G,l(G)]));let Z=[];for(const{matches:G}of this.d)for(const[se,ce]of x)if(G(ce)){Z.push(se),x.delete(se);break}return x.size&&(Z=Z.concat([...x.keys()].sort((G,se)=>this.e.indexOf(G)-this.e.indexOf(se)))),Z}prioritize(T,x){const Z=this.f(T);if(Z===-1){this.d.unshift({pattern:T,matches:A.$ck(l(T))});return}const G=new Set(x.map(ce=>this.f(ce,Z)));G.delete(-1);const se=Array.from(G).sort();this.d.splice(Z+1,0,...se.map(ce=>this.d[ce]));for(let ce=se.length-1;ce>=0;ce--)this.d.splice(se[ce],1)}toArray(){return this.d.map(T=>T.pattern)}f(T,x=this.d.length){const Z=l(T);for(let G=0;G<x;G++)if(this.d[G].matches(Z))return G;return-1}}e.$gK=t;function a(V,T,x,Z=(G,se)=>G===se){const G=[];function se($e,K,q){if(K===0&&q.length===0)return;const N=G[G.length-1];N&&N.start+N.deleteCount===$e?(N.deleteCount+=K,N.toInsert.push(...q)):G.push({start:$e,deleteCount:K,toInsert:q})}let ce=0,ne=0;for(;;){if(ce===V.length){se(ce,0,T.slice(ne));break}if(ne===T.length){se(ce,V.length-ce,[]);break}const $e=V[ce],K=T[ne];if(Z($e,K)){ce+=1,ne+=1;continue}x(K)?(se(ce,1,[]),ce+=1):(se(ce,0,[K]),ne+=1)}return G}e.$iK=new $.$zj("notebookEditorCursorAtBoundary","none"),e.$jK=new $.$zj("notebookEditorCursorAtLineBoundary","none");var o;(function(V){V.default="default",V.option="option"})(o||(e.NotebookEditorPriority=o={}));function r(V){const T=V;return!!((typeof T.include=="string"||A.$dk(T.include))&&(typeof T.exclude=="string"||A.$dk(T.exclude)))}function s(V,T,x){if(Array.isArray(V.viewType)&&V.viewType.indexOf(T)>=0||V.viewType===T)return!0;if(V.filenamePattern){const Z=r(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,G=r(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(A.$bk(Z,(0,k.$oc)(x.fsPath).toLowerCase()))return!(G&&A.$bk(G,(0,k.$oc)(x.fsPath).toLowerCase()))}return!1}e.$mK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var n;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(n||(e.CellStatusbarAlignment=n={}));class b{static{this.d="notebook/"}static create(T){return`${b.d}${T}`}static parse(T){if(T.startsWith(b.d))return T.substring(b.d.length)}}e.$nK=b;function P(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}const I=new TextDecoder;function O(V){const T=[];let x=!1;for(const ce of V)(T.length===0||x)&&(T.push(ce),x=!0);let Z=B(T);const G=i.$ue.concat(T.map(ce=>i.$ue.wrap(ce))),se=te(G);return Z=Z||se.byteLength!==G.byteLength,{data:se,didCompression:Z}}e.$qK="\x1B[A";const R=e.$qK.split("").map(V=>V.charCodeAt(0)),j=10;function B(V){let T=!1;return V.forEach((x,Z)=>{if(Z===0||x.length<e.$qK.length)return;const G=V[Z-1],se=x.subarray(0,e.$qK.length);if(se[0]===R[0]&&se[1]===R[1]&&se[2]===R[2]){const ce=G.lastIndexOf(j);if(ce===-1)return;T=!0,V[Z-1]=G.subarray(0,ce),V[Z]=x.subarray(e.$qK.length)}}),T}function Y(V){let T=V;do V=T,T=V.replace(/[^\n]\x08/gm,"");while(T.length<V.length);return V}function fe(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const T=V.match(/^(.*)\r+/m)[1];let x=V.match(/\r+(.*)$/m)[1];x=x+T.slice(x.length,T.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,x)}return V}const ue=8,re=13;function te(V){return!V.buffer.includes(ue)&&!V.buffer.includes(re)?V:i.$ue.fromString(fe(Y(I.decode(V.buffer))))}}),define(Ee[140],ke([1,0,18,10,101,24,65,17,11,3,22,35,16,119,139]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d){"use strict";var c,g,u,p,f,h,l,t,a,o,r,s,n,b,P,I,O;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$BO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$AO=e.$zO=e.$yO=e.$xO=e.ChatLocation=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$oO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$bO=e.$aO=e.$_N=e.$$N=e.$9N=e.$8N=e.$7N=e.$6N=e.TestRunProfileKind=e.TestResultState=e.$5N=e.$4N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$3N=e.NotebookVariablesRequestKind=e.$2N=e.$1N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$ZN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.ColorThemeKind=e.$TN=e.$SN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$RN=e.$QN=e.DebugConsoleMode=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$KN=e.$JN=e.FileChangeType=e.$IN=e.NewSymbolNameTag=e.$HN=e.$GN=e.$FN=e.$EN=e.InlineCompletionTriggerKind=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$rN=e.ConfigurationTarget=e.$qN=e.$pN=e.$oN=e.$nN=e.DocumentPasteTriggerKind=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$gN=e.ViewBadge=e.ProgressLocation=e.$fN=e.$eN=e.TaskScope=e.ShellQuoting=e.$dN=e.$cN=e.$bN=e.TaskPanelKind=e.TaskRevealKind=e.$aN=e.TerminalLocation=e.$_M=e.$$M=e.$0M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$9M=e.$8M=e.$7M=e.$6M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$4M=e.$3M=e.$2M=e.$1M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$ZM=e.$YM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.LanguageStatusSeverity=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.CodeActionTriggerKind=e.$MM=e.$LM=e.SymbolTag=e.SymbolKind=e.$KM=e.$JM=e.DocumentHighlightKind=e.$IM=e.$HM=e.$GM=e.$FM=e.DiagnosticSeverity=e.DiagnosticTag=e.$EM=e.$DM=e.FileEditType=e.$CM=e.$BM=e.$AM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$5M=ot,e.$sN=W,e.$0N=ii;function R(M){return Object.assign(M,{apply:function(...oe){if(oe.length===0)return Reflect.construct(M,[]);{const ye=oe.length===1?[]:oe[1];return Reflect.construct(M,ye,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(M,[]);{const[ye,...ze]=oe;return Reflect.construct(M,ze,ye.constructor)}}})}var j;(function(M){M[M.Top=0]="Top",M[M.Bottom=1]="Bottom"})(j||(e.TerminalOutputAnchor=j={}));var B;(function(M){M[M.TerminalCommand=0]="TerminalCommand",M[M.Opener=1]="Opener",M[M.Command=3]="Command"})(B||(e.TerminalQuickFixType=B={}));let Y=c=class{static from(...F){let oe=F;return new c(function(){if(oe){for(const ye of oe)ye&&typeof ye.dispose=="function"&&ye.dispose();oe=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$tM=Y,e.$tM=Y=c=Le([R],Y);let fe=g=class{static Min(...F){if(F.length===0)throw new TypeError;let oe=F[0];for(let ye=1;ye<F.length;ye++){const ze=F[ye];ze.isBefore(oe)&&(oe=ze)}return oe}static Max(...F){if(F.length===0)throw new TypeError;let oe=F[0];for(let ye=1;ye<F.length;ye++){const ze=F[ye];ze.isAfter(oe)&&(oe=ze)}return oe}static isPosition(F){if(!F)return!1;if(F instanceof g)return!0;const{line:oe,character:ye}=F;return typeof oe=="number"&&typeof ye=="number"}static of(F){if(F instanceof g)return F;if(this.isPosition(F))return new g(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,oe){if(F<0)throw(0,A.$7)("line must be non-negative");if(oe<0)throw(0,A.$7)("character must be non-negative");this.c=F,this.e=oe}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,oe=0){if(F===null||oe===null)throw(0,A.$7)();let ye;return typeof F>"u"?ye=0:typeof F=="number"?ye=F:(ye=typeof F.lineDelta=="number"?F.lineDelta:0,oe=typeof F.characterDelta=="number"?F.characterDelta:0),ye===0&&oe===0?this:new g(this.line+ye,this.character+oe)}with(F,oe=this.character){if(F===null||oe===null)throw(0,A.$7)();let ye;return typeof F>"u"?ye=this.line:typeof F=="number"?ye=F:(ye=typeof F.line=="number"?F.line:this.line,oe=typeof F.character=="number"?F.character:this.character),ye===this.line&&oe===this.character?this:new g(ye,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$uM=fe,e.$uM=fe=g=Le([R],fe);let ue=u=class{static isRange(F){return F instanceof u?!0:F?fe.isPosition(F.start)&&fe.isPosition(F.end):!1}static of(F){if(F instanceof u)return F;if(this.isRange(F))return new u(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,oe,ye,ze){let Ge,Ke;if(typeof F=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof ze=="number"?(Ge=new fe(F,oe),Ke=new fe(ye,ze)):fe.isPosition(F)&&fe.isPosition(oe)&&(Ge=fe.of(F),Ke=fe.of(oe)),!Ge||!Ke)throw new Error("Invalid arguments");Ge.isBefore(Ke)?(this.c=Ge,this.e=Ke):(this.c=Ke,this.e=Ge)}contains(F){return u.isRange(F)?this.contains(F.start)&&this.contains(F.end):fe.isPosition(F)?!(fe.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const oe=fe.Max(F.start,this.c),ye=fe.Min(F.end,this.e);if(!oe.isAfter(ye))return new u(oe,ye)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const oe=fe.Min(F.start,this.c),ye=fe.Max(F.end,this.end);return new u(oe,ye)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,oe=this.end){if(F===null||oe===null)throw(0,A.$7)();let ye;return F?fe.isPosition(F)?ye=F:(ye=F.start||this.start,oe=F.end||this.end):ye=this.start,ye.isEqual(this.c)&&oe.isEqual(this.end)?this:new u(ye,oe)}toJSON(){return[this.start,this.end]}};e.$vM=ue,e.$vM=ue=u=Le([R],ue);let re=p=class extends ue{static isSelection(F){return F instanceof p?!0:F?ue.isRange(F)&&fe.isPosition(F.anchor)&&fe.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,oe,ye,ze){let Ge,Ke;if(typeof F=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof ze=="number"?(Ge=new fe(F,oe),Ke=new fe(ye,ze)):fe.isPosition(F)&&fe.isPosition(oe)&&(Ge=fe.of(F),Ke=fe.of(oe)),!Ge||!Ke)throw new Error("Invalid arguments");super(Ge,Ke),this.f=Ge,this.g=Ke}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$wM=re,e.$wM=re=p=Le([R],re);const te=M=>{if(typeof M!="string"||M.length===0||!/^[0-9A-Za-z_\-]+$/.test(M))throw(0,A.$7)("connectionToken")};class V{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,oe,ye){if(typeof F!="string"||F.length===0)throw(0,A.$7)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,A.$7)("port");typeof ye<"u"&&te(ye),this.host=F,this.port=Math.round(oe),this.connectionToken=ye}}e.$xM=V;class T{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,oe){this.makeConnection=F,this.connectionToken=oe,typeof oe<"u"&&te(oe)}}e.$yM=T;class x extends Error{static NotAvailable(F,oe){return new x(F,m.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(F){return new x(F,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,oe=m.RemoteAuthorityResolverErrorCode.Unknown,ye){super(F),this._message=F,this._code=oe,this._detail=ye,Object.setPrototypeOf(this,x.prototype)}}e.$zM=x;var Z;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var G;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let se=f=class{static isTextEdit(F){return F instanceof f?!0:F?ue.isRange(F)&&typeof F.newText=="string":!1}static replace(F,oe){return new f(F,oe)}static insert(F,oe){return f.replace(new ue(F,F),oe)}static delete(F){return f.replace(F,"")}static setEndOfLine(F){const oe=new f(new ue(new fe(0,0),new fe(0,0)),"");return oe.newEol=F,oe}get range(){return this.c}set range(F){if(F&&!ue.isRange(F))throw(0,A.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,A.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,A.$7)("newEol");this.f=F}constructor(F,oe){this.c=F,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$AM=se,e.$AM=se=f=Le([R],se);let ce=h=class{static isNotebookCellEdit(F){return F instanceof h?!0:F?Vt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,oe){return new h(F,oe)}static insertCells(F,oe){return new h(new Vt(F,F),oe)}static deleteCells(F){return new h(F,[])}static updateCellMetadata(F,oe){const ye=new h(new Vt(F,F),[]);return ye.newCellMetadata=oe,ye}static updateNotebookMetadata(F){const oe=new h(new Vt(0,0),[]);return oe.newNotebookMetadata=F,oe}constructor(F,oe){this.range=F,this.newCells=oe}};e.$BM=ce,e.$BM=ce=h=Le([R],ce);class ne{static isSnippetTextEdit(F){return F instanceof ne?!0:F?ue.isRange(F.range)&&q.isSnippetString(F.snippet):!1}static replace(F,oe){return new ne(F,oe)}static insert(F,oe){return ne.replace(new ue(F,F),oe)}constructor(F,oe){this.range=F,this.snippet=oe}}e.$CM=ne;var $e;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace",M[M.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let K=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,oe,ye,ze){this.c.push({_type:1,from:F,to:oe,options:ye,metadata:ze})}createFile(F,oe,ye){this.c.push({_type:1,from:void 0,to:F,options:oe,metadata:ye})}deleteFile(F,oe,ye){this.c.push({_type:1,from:F,to:void 0,options:oe,metadata:ye})}e(F,oe,ye){this.c.push({_type:3,metadata:ye,uri:F,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(F,oe,ye,ze){const Ge=oe.start,Ke=oe.end;(Ge!==Ke||ye.length>0)&&this.c.push({_type:5,uri:F,index:Ge,count:Ke-Ge,cells:ye,metadata:ze})}g(F,oe,ye,ze){this.c.push({_type:3,metadata:ze,uri:F,edit:{editType:3,index:oe,metadata:ye}})}replace(F,oe,ye,ze){this.c.push({_type:2,uri:F,edit:new se(oe,ye),metadata:ze})}insert(F,oe,ye,ze){this.replace(F,new ue(oe,oe),ye,ze)}delete(F,oe,ye){this.replace(F,oe,"",ye)}has(F){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===F.toString())}set(F,oe){if(oe)for(const ye of oe){if(!ye)continue;let ze,Ge;Array.isArray(ye)?(ze=ye[0],Ge=ye[1]):ze=ye,ce.isNotebookCellEdit(ze)?ze.newCellMetadata?this.g(F,ze.range.start,ze.newCellMetadata,Ge):ze.newNotebookMetadata?this.e(F,ze.newNotebookMetadata,Ge):this.f(F,ze.range,ze.newCells,Ge):ne.isSnippetTextEdit(ze)?this.c.push({_type:6,uri:F,range:ze.range,edit:ze.snippet,metadata:Ge}):this.c.push({_type:2,uri:F,edit:ze,metadata:Ge})}else{for(let ye=0;ye<this.c.length;ye++){const ze=this.c[ye];switch(ze._type){case 2:case 6:case 3:case 5:ze.uri.toString()===F.toString()&&(this.c[ye]=void 0);break}}(0,i.$Ib)(this.c)}}get(F){const oe=[];for(const ye of this.c)ye._type===2&&ye.uri.toString()===F.toString()&&oe.push(ye.edit);return oe}entries(){const F=new D.$Bc;for(const oe of this.c)if(oe._type===2){let ye=F.get(oe.uri);ye||(ye=[oe.uri,[]],F.set(oe.uri,ye)),ye[1].push(oe.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$DM=K,e.$DM=K=Le([R],K);let q=l=class{static isSnippetString(F){return F instanceof l?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=l.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,oe=this.e++){if(typeof F=="function"){const ye=new l;ye.e=this.e,F(ye),this.e=ye.e,F=ye.value}else F=l.c(F);return this.value+="${",this.value+=oe,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,oe=this.e++){const ye=F.map(ze=>ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(F,oe){if(typeof oe=="function"){const ye=new l;ye.e=this.e,oe(ye),this.e=ye.e,oe=ye.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$EM=q,e.$EM=q=l=Le([R],q);var N;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(N||(e.DiagnosticTag=N={}));var z;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(z||(e.DiagnosticSeverity=z={}));let X=t=class{static isLocation(F){return F instanceof t?!0:F?ue.isRange(F.range)&&$.URI.isUri(F.uri):!1}constructor(F,oe){if(this.uri=F,oe)if(ue.isRange(oe))this.range=ue.of(oe);else if(fe.isPosition(oe))this.range=new ue(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$FM=X,e.$FM=X=t=Le([R],X);let ae=class{static is(F){return F?typeof F.message=="string"&&F.location&&ue.isRange(F.location.range)&&$.URI.isUri(F.location.uri):!1}constructor(F,oe){this.location=F,this.message=oe}static isEqual(F,oe){return F===oe?!0:!F||!oe?!1:F.message===oe.message&&F.location.range.isEqual(oe.location.range)&&F.location.uri.toString()===oe.location.uri.toString()}};e.$GM=ae,e.$GM=ae=Le([R],ae);let Q=class{constructor(F,oe,ye=z.Error){if(!ue.isRange(F))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=F,this.message=oe,this.severity=ye}toJSON(){return{severity:z[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,oe){return F===oe?!0:!F||!oe?!1:F.message===oe.message&&F.severity===oe.severity&&F.code===oe.code&&F.severity===oe.severity&&F.source===oe.source&&F.range.isEqual(oe.range)&&(0,i.$ub)(F.tags,oe.tags)&&(0,i.$ub)(F.relatedInformation,oe.relatedInformation,ae.isEqual)}};e.$HM=Q,e.$HM=Q=Le([R],Q);let J=class{constructor(F,oe){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=oe}};e.$IM=J,e.$IM=J=Le([R],J);var U;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(U||(e.DocumentHighlightKind=U={}));let L=class{constructor(F,oe=U.Text){this.range=F,this.kind=oe}toJSON(){return{range:this.range,kind:U[this.kind]}}};e.$JM=L,e.$JM=L=Le([R],L);let H=class{constructor(F,oe){this.uri=F,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$KM=H,e.$KM=H=Le([R],H);var _;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(_||(e.SymbolKind=_={}));var ee;(function(M){M[M.Deprecated=1]="Deprecated"})(ee||(e.SymbolTag=ee={}));let de=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,oe,ye,ze,Ge){this.name=F,this.kind=oe,this.containerName=Ge,typeof ye=="string"&&(this.containerName=ye),ze instanceof X?this.location=ze:ye instanceof ue&&(this.location=new X(ze,ye)),a.validate(this)}toJSON(){return{name:this.name,kind:_[this.kind],location:this.location,containerName:this.containerName}}};e.$LM=de,e.$LM=de=a=Le([R],de);let ie=o=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(o.validate)}constructor(F,oe,ye,ze,Ge){this.name=F,this.detail=oe,this.kind=ye,this.range=ze,this.selectionRange=Ge,this.children=[],o.validate(this)}};e.$MM=ie,e.$MM=ie=o=Le([R],ie);var me;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(me||(e.CodeActionTriggerKind=me={}));let we=class{constructor(F,oe){this.title=F,this.kind=oe}};e.$NM=we,e.$NM=we=Le([R],we);let Ie=class{static{r=this}static{this.c="."}constructor(F){this.value=F}append(F){return new r(this.value?this.value+r.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+r.c)}};e.$OM=Ie,e.$OM=Ie=r=Le([R],Ie),Ie.Empty=new Ie(""),Ie.QuickFix=Ie.Empty.append("quickfix"),Ie.Refactor=Ie.Empty.append("refactor"),Ie.RefactorExtract=Ie.Refactor.append("extract"),Ie.RefactorInline=Ie.Refactor.append("inline"),Ie.RefactorMove=Ie.Refactor.append("move"),Ie.RefactorRewrite=Ie.Refactor.append("rewrite"),Ie.Source=Ie.Empty.append("source"),Ie.SourceOrganizeImports=Ie.Source.append("organizeImports"),Ie.SourceFixAll=Ie.Source.append("fixAll"),Ie.Notebook=Ie.Empty.append("notebook");let Oe=class{constructor(F,oe){if(this.range=F,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$PM=Oe,e.$PM=Oe=Le([R],Oe);class ge{constructor(F,oe,ye,ze,Ge,Ke){this.kind=F,this.name=oe,this.detail=ye,this.uri=ze,this.range=Ge,this.selectionRange=Ke}}e.$QM=ge;class Se{constructor(F,oe){this.fromRanges=oe,this.from=F}}e.$RM=Se;class Ce{constructor(F,oe){this.fromRanges=oe,this.to=F}}e.$SM=Ce;var Te;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Te||(e.LanguageStatusSeverity=Te={}));let Fe=class{constructor(F,oe){this.range=F,this.command=oe}get isResolved(){return!!this.command}};e.$TM=Fe,e.$TM=Fe=Le([R],Fe);let Ve=s=class{#e;static isMarkdownString(F){return F instanceof s?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,oe=!1){this.#e=new S.$Fk(F,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,oe){return this.#e.appendCodeblock(oe??"",F),this}};e.$UM=Ve,e.$UM=Ve=s=Le([R],Ve);let Ue=class{constructor(F,oe){this.label=F,this.documentation=oe}};e.$VM=Ue,e.$VM=Ue=Le([R],Ue);let xe=class{constructor(F,oe){this.label=F,this.documentation=oe,this.parameters=[]}};e.$WM=xe,e.$WM=xe=Le([R],xe);let Xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$XM=Xe,e.$XM=Xe=Le([R],Xe);var _e;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var et;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let Je=class{constructor(F){this.value=F}};e.$YM=Je,e.$YM=Je=Le([R],Je);let pe=class{constructor(F,oe,ye){this.position=F,this.label=oe,this.kind=ye}};e.$ZM=pe,e.$ZM=pe=Le([R],pe);var Pe;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Pe||(e.CompletionTriggerKind=Pe={}));var Ne;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(Ne||(e.CompletionItemKind=Ne={}));var Ae;(function(M){M[M.Deprecated=1]="Deprecated"})(Ae||(e.CompletionItemTag=Ae={}));let Me=class{constructor(F,oe){this.label=F,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$1M=Me,e.$1M=Me=Le([R],Me);let He=class{constructor(F=[],oe=!1){this.items=F,this.isIncomplete=oe}};e.$2M=He,e.$2M=He=Le([R],He);let We=class{constructor(F,oe,ye){this.insertText=F,this.range=oe,this.command=ye}};e.$3M=We,e.$3M=We=Le([R],We);let Qe=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$4M=Qe,e.$4M=Qe=Le([R],Qe);var it;(function(M){M[M.Unknown=0]="Unknown",M[M.Word=1]="Word",M[M.Line=2]="Line",M[M.Suggest=3]="Suggest"})(it||(e.PartialAcceptTriggerKind=it={}));var Ye;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(Ye||(e.ViewColumn=Ye={}));var nt;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function ot(M,F){return`${y.$Dm.toKey(M)}.${F}`}var at;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative",M[M.Interval=3]="Interval"})(at||(e.TextEditorLineNumbersStyle=at={}));var ct;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(ct||(e.TextDocumentSaveReason=ct={}));var ht;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(ht||(e.TextEditorRevealType=ht={}));var pt;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var Rt;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(Rt||(e.TextDocumentChangeReason=Rt={}));var Dt;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(Dt||(e.DecorationRangeBehavior=Dt={})),function(M){function F(oe){switch(oe){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=F}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Pt;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(Pt||(e.SyntaxTokenType=Pt={})),function(M){function F(oe){switch(oe){case M.Other:return"other";case M.Comment:return"comment";case M.String:return"string";case M.RegEx:return"regex"}return"other"}M.toString=F}(Pt||(e.SyntaxTokenType=Pt={}));let Et=class{constructor(F,oe){if(oe&&!$.URI.isUri(oe))throw(0,A.$7)("target");if(!ue.isRange(F)||F.isEmpty)throw(0,A.$7)("range");this.range=F,this.target=oe}};e.$6M=Et,e.$6M=Et=Le([R],Et);let St=class{constructor(F,oe,ye,ze){this.red=F,this.green=oe,this.blue=ye,this.alpha=ze}};e.$7M=St,e.$7M=St=Le([R],St);let Tt=class{constructor(F,oe){if(oe&&!(oe instanceof St))throw(0,A.$7)("color");if(!ue.isRange(F)||F.isEmpty)throw(0,A.$7)("range");this.range=F,this.color=oe}};e.$8M=Tt,e.$8M=Tt=Le([R],Tt);let dt=class{constructor(F){if(!F||typeof F!="string")throw(0,A.$7)("label");this.label=F}};e.$9M=dt,e.$9M=dt=Le([R],dt);var zt;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(zt||(e.ColorFormat=zt={}));var wt;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(wt||(e.SourceControlInputBoxValidationType=wt={}));var rt;(function(M){M[M.Unknown=0]="Unknown",M[M.Shutdown=1]="Shutdown",M[M.Process=2]="Process",M[M.User=3]="User",M[M.Extension=4]="Extension"})(rt||(e.TerminalExitReason=rt={}));class mt{constructor(F,oe,ye){if(this.startIndex=F,this.length=oe,this.tooltip=ye,typeof F!="number"||F<0)throw(0,A.$7)("startIndex");if(typeof oe!="number"||oe<1)throw(0,A.$7)("length");if(ye!==void 0&&typeof ye!="string")throw(0,A.$7)("tooltip")}}e.$0M=mt;class bt{constructor(F){this.uri=F}}e.$$M=bt;class Kt{constructor(F){this.terminalCommand=F}}e.$_M=Kt;var Wt;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(Wt||(e.TerminalLocation=Wt={}));class _t{constructor(F){if(this.options=F,typeof F!="object")throw(0,A.$7)("options")}}e.$aN=_t;var Nt;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Nt||(e.TaskRevealKind=Nt={}));var Bt;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(Bt||(e.TaskPanelKind=Bt={}));let Ft=class{static{n=this}static{this.Clean=new n("clean","Clean")}static{this.Build=new n("build","Build")}static{this.Rebuild=new n("rebuild","Rebuild")}static{this.Test=new n("test","Test")}static from(F){switch(F){case"clean":return n.Clean;case"build":return n.Build;case"rebuild":return n.Rebuild;case"test":return n.Test;default:return}}constructor(F,oe){if(this.label=oe,typeof F!="string"||typeof oe!="string")throw(0,A.$7)("name");this.c=F}get id(){return this.c}};e.$bN=Ft,e.$bN=Ft=n=Le([R],Ft);function Gt(M){let F="";for(let oe=0;oe<M.length;oe++)F+=M[oe].replace(/,/g,",,")+",";return F}let kt=class{constructor(F,oe,ye){if(typeof F!="string")throw(0,A.$7)("process");this.e=[],this.c=F,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=ye):this.f=oe)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,A.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)F.push(oe);return Gt(F)}};e.$cN=kt,e.$cN=kt=Le([R],kt);let Lt=class{constructor(F,oe,ye){if(this.f=[],Array.isArray(oe)){if(!F)throw(0,A.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,A.$7)("command");this.e=F,this.f=oe,this.g=ye}else{if(typeof F!="string")throw(0,A.$7)("commandLine");this.c=F,this.g=oe}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,A.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,A.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)F.push(typeof oe=="string"?oe:oe.value);return Gt(F)}};e.$dN=Lt,e.$dN=Lt=Le([R],Lt);var xt;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(xt||(e.ShellQuoting=xt={}));var Jt;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(Jt||(e.TaskScope=Jt={}));class Qt{constructor(F){this.c=F}computeId(){return"customExecution"+(0,E.$Eg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$eN=Qt;let qt=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,oe,ye,ze,Ge,Ke){this.k=!1,this.l=this.definition=F;let tt;typeof oe=="string"?(this.o=this.name=oe,this.w=this.source=ye,this.execution=ze,tt=Ge,this.k=!0):oe===Jt.Global||oe===Jt.Workspace?(this.target=oe,this.o=this.name=ye,this.w=this.source=ze,this.execution=Ge,tt=Ke):(this.target=oe,this.o=this.name=ye,this.w=this.source=ze,this.execution=Ge,tt=Ke),typeof tt=="string"?(this.r=[tt],this.t=!0):Array.isArray(tt)?(this.r=tt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof kt?this.l={type:b.e,id:this.q.computeId()}:this.q instanceof Lt?this.l={type:b.f,id:this.q.computeId()}:this.q instanceof Qt?this.l={type:b.c,id:this.q.computeId()}:this.l={type:b.g,id:(0,E.$Eg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,A.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,A.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const oe=this.l.type;(b.g===oe||b.e===oe||b.f===oe||b.c===oe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,A.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$fN=qt,e.$fN=qt=b=Le([R],qt);var Xt;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(Xt||(e.ProgressLocation=Xt={}));var en;(function(M){function F(oe){const ye=oe;return(0,v.$Zf)(ye.value)?ye.tooltip&&!(0,v.$Vf)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}M.isViewBadge=F})(en||(e.ViewBadge=en={}));let Ht=P=class{static isTreeItem(F,oe){const ye=F;if(ye.checkboxState!==void 0){const ze=(0,v.$Zf)(ye.checkboxState)?ye.checkboxState:(0,v.$Xf)(ye.checkboxState)&&(0,v.$Zf)(ye.checkboxState.state)?ye.checkboxState.state:void 0,Ge=!(0,v.$Zf)(ye.checkboxState)&&(0,v.$Xf)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(ze===void 0||ze!==Zt.Checked&&ze!==Zt.Unchecked||Ge!==void 0&&!(0,v.$Vf)(Ge))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(F instanceof P)return!0;if(ye.label!==void 0&&!(0,v.$Vf)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,v.$Vf)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,v.$Vf)(ye.iconPath)&&!$.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,v.$Vf)(ye.iconPath.id))){const ze=ye.iconPath;if(!ze||!(0,v.$Vf)(ze.light)&&!$.URI.isUri(ze.light)&&!(0,v.$Vf)(ze.dark)&&!$.URI.isUri(ze.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,v.$Vf)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!$.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,v.$Vf)(ye.tooltip)&&!(ye.tooltip instanceof Ve)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<It.None&&ye.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,v.$Vf)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(F,oe=It.None){this.collapsibleState=oe,$.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$gN=Ht,e.$gN=Ht=P=Le([R],Ht);var It;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var Zt;(function(M){M[M.Unchecked=0]="Unchecked",M[M.Checked=1]="Checked"})(Zt||(e.TreeItemCheckboxState=Zt={}));let Ut=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$hN=Ut,e.$hN=Ut=Le([R],Ut);class on extends Ut{}e.$iN=on;class an extends on{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$jN=an;class cn{constructor(F,oe,ye,ze){this.name=F,this.uri=oe,this._itemId=ye,this.c=ze}data(){return this.c()}}e.$kN=cn;let tn=class{#e=new Map;constructor(F){for(const[oe,ye]of F??[]){const ze=this.#e.get(this.#t(oe));ze?ze.push(ye):this.#e.set(this.#t(oe),[ye])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,oe){this.#e.set(this.#t(F),[oe])}forEach(F,oe){for(const[ye,ze]of this.#e)for(const Ge of ze)F.call(oe,Ge,ye,this)}*[Symbol.iterator](){for(const[F,oe]of this.#e)for(const ye of oe)yield[F,ye]}#t(F){return F.toLowerCase()}};e.$lN=tn,e.$lN=tn=Le([R],tn);let Yt=class{constructor(F,oe,ye){this.insertText=F,this.title=oe,this.kind=ye}};e.$mN=Yt,e.$mN=Yt=Le([R],Yt);var ln;(function(M){M[M.Automatic=0]="Automatic",M[M.PasteAs=1]="PasteAs"})(ln||(e.DocumentPasteTriggerKind=ln={}));class At{static{this.c="."}constructor(F){this.value=F}append(...F){return new At((this.value?[this.value,...F]:F).join(At.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+At.c)}}e.$nN=At,At.Empty=new At("");let nn=class{constructor(F,oe,ye){this.title=oe,this.insertText=F,this.kind=ye}};e.$oN=nn,e.$oN=nn=Le([R],nn);let gt=class{constructor(F,oe){this.id=F,this.color=oe}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$pN=gt,e.$pN=gt=Le([R],gt),gt.File=new gt("file"),gt.Folder=new gt("folder");let rn=class{constructor(F){this.id=F}};e.$qN=rn,e.$qN=rn=Le([R],rn);var be;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(be||(e.ConfigurationTarget=be={}));let De=class{get base(){return this.c}set base(F){this.c=F,this.e=$.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,oe){if(typeof F!="string"&&(!F||!$.URI.isUri(F)&&!$.URI.isUri(F.uri)))throw(0,A.$7)("base");if(typeof oe!="string")throw(0,A.$7)("pattern");typeof F=="string"?this.baseUri=$.URI.file(F):$.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$rN=De,e.$rN=De=Le([R],De);const he=new WeakMap;function W(M,F){he.set(M,F)}let ve=class{constructor(F,oe,ye,ze,Ge){this.enabled=typeof F=="boolean"?F:!0,typeof oe=="string"&&(this.condition=oe),typeof ye=="string"&&(this.hitCondition=ye),typeof ze=="string"&&(this.logMessage=ze),typeof Ge=="string"&&(this.mode=Ge)}get id(){return this.c||(this.c=he.get(this)??(0,E.$Eg)()),this.c}};e.$tN=ve,e.$tN=ve=Le([R],ve);let je=class extends ve{constructor(F,oe,ye,ze,Ge,Ke){if(super(oe,ye,ze,Ge,Ke),F===null)throw(0,A.$7)("location");this.location=F}};e.$uN=je,e.$uN=je=Le([R],je);let qe=class extends ve{constructor(F,oe,ye,ze,Ge,Ke){super(oe,ye,ze,Ge,Ke),this.functionName=F}};e.$vN=qe,e.$vN=qe=Le([R],qe);let Be=class extends ve{constructor(F,oe,ye,ze,Ge,Ke,tt,ut){if(super(ze,Ge,Ke,tt,ut),!oe)throw(0,A.$7)("dataId");this.label=F,this.dataId=oe,this.canPersist=ye}};e.$wN=Be,e.$wN=Be=Le([R],Be);let Ze=class{constructor(F,oe,ye){this.command=F,this.args=oe||[],this.options=ye}};e.$xN=Ze,e.$xN=Ze=Le([R],Ze);let st=class{constructor(F,oe){this.port=F,this.host=oe}};e.$yN=st,e.$yN=st=Le([R],st);let ft=class{constructor(F){this.path=F}};e.$zN=ft,e.$zN=ft=Le([R],ft);let $t=class{constructor(F){this.implementation=F}};e.$AN=$t,e.$AN=$t=Le([R],$t);class lt{constructor(F,oe,ye){this.session=F,this.threadId=oe,this.frameId=ye}}e.$BN=lt;class vt{constructor(F,oe){this.session=F,this.threadId=oe}}e.$CN=vt;let gn=class{constructor(F,oe){this.range=F,this.expression=oe}};e.$DN=gn,e.$DN=gn=Le([R],gn);var On;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(On||(e.InlineCompletionTriggerKind=On={}));let $n=class{constructor(F,oe){this.range=F,this.text=oe}};e.$EN=$n,e.$EN=$n=Le([R],$n);let pn=class{constructor(F,oe,ye=!0){this.range=F,this.variableName=oe,this.caseSensitiveLookup=ye}};e.$FN=pn,e.$FN=pn=Le([R],pn);let wn=class{constructor(F,oe){this.range=F,this.expression=oe}};e.$GN=wn,e.$GN=wn=Le([R],wn);let bn=class{constructor(F,oe){this.frameId=F,this.stoppedLocation=oe}};e.$HN=bn,e.$HN=bn=Le([R],bn);var Rn;(function(M){M[M.AIGenerated=1]="AIGenerated"})(Rn||(e.NewSymbolNameTag=Rn={}));class wi{constructor(F,oe){this.newSymbolName=F,this.tags=oe}}e.$IN=wi;var Nn;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(Nn||(e.FileChangeType=Nn={}));let vn=I=class extends Error{static FileExists(F){return new I(F,w.FileSystemProviderErrorCode.FileExists,I.FileExists)}static FileNotFound(F){return new I(F,w.FileSystemProviderErrorCode.FileNotFound,I.FileNotFound)}static FileNotADirectory(F){return new I(F,w.FileSystemProviderErrorCode.FileNotADirectory,I.FileNotADirectory)}static FileIsADirectory(F){return new I(F,w.FileSystemProviderErrorCode.FileIsADirectory,I.FileIsADirectory)}static NoPermissions(F){return new I(F,w.FileSystemProviderErrorCode.NoPermissions,I.NoPermissions)}static Unavailable(F){return new I(F,w.FileSystemProviderErrorCode.Unavailable,I.Unavailable)}constructor(F,oe=w.FileSystemProviderErrorCode.Unknown,ye){super($.URI.isUri(F)?F.toString(!0):F),this.code=ye?.name??"Unknown",(0,w.$4k)(this,oe),Object.setPrototypeOf(this,I.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};e.$JN=vn,e.$JN=vn=I=Le([R],vn);let yn=class{constructor(F,oe,ye){this.start=F,this.end=oe,this.kind=ye}};e.$KN=yn,e.$KN=yn=Le([R],yn);var Fn;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(Fn||(e.FoldingRangeKind=Fn={}));var Ln;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(Ln||(e.CommentThreadCollapsibleState=Ln={}));var Mn;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(Mn||(e.CommentMode=Mn={}));var Tn;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(Tn||(e.CommentState=Tn={}));var zn;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(zn||(e.CommentThreadState=zn={}));var Bn;(function(M){M[M.Current=0]="Current",M[M.Outdated=1]="Outdated"})(Bn||(e.CommentThreadApplicability=Bn={}));class bi{constructor(F,oe=[]){this.tokenTypes=F,this.tokenModifiers=oe}}e.$LN=bi;function vi(M){return typeof M>"u"||(0,v.$Wf)(M)}class En{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let oe=0,ye=F.tokenTypes.length;oe<ye;oe++)this.k.set(F.tokenTypes[oe],oe);for(let oe=0,ye=F.tokenModifiers.length;oe<ye;oe++)this.l.set(F.tokenModifiers[oe],oe)}}push(F,oe,ye,ze,Ge){if(typeof F=="number"&&typeof oe=="number"&&typeof ye=="number"&&typeof ze=="number"&&(typeof Ge=="number"||typeof Ge>"u"))return typeof Ge>"u"&&(Ge=0),this.q(F,oe,ye,ze,Ge);if(ue.isRange(F)&&typeof oe=="string"&&vi(ye))return this.o(F,oe,ye);throw(0,A.$7)()}o(F,oe,ye){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const ze=F.start.line,Ge=F.start.character,Ke=F.end.character-F.start.character,tt=this.k.get(oe);let ut=0;if(ye)for(const yt of ye){if(!this.l.has(yt))throw new Error("`tokenModifier` is not in the provided legend");const Ct=this.l.get(yt);ut|=1<<Ct>>>0}this.q(ze,Ge,Ke,tt,ut)}q(F,oe,ye,ze,Ge){if(this.f&&(F<this.c||F===this.c&&oe<this.e)){this.f=!1;const ut=this.g.length/5|0;let yt=0,Ct=0;for(let Ot=0;Ot<ut;Ot++){let Mt=this.g[5*Ot],un=this.g[5*Ot+1];Mt===0?(Mt=yt,un+=Ct):Mt+=yt,this.g[5*Ot]=Mt,this.g[5*Ot+1]=un,yt=Mt,Ct=un}}let Ke=F,tt=oe;this.f&&this.j>0&&(Ke-=this.c,Ke===0&&(tt-=this.e)),this.g[this.j++]=Ke,this.g[this.j++]=tt,this.g[this.j++]=ye,this.g[this.j++]=ze,this.g[this.j++]=Ge,this.c=F,this.e=oe}static r(F){const oe=[],ye=F.length/5|0;for(let tt=0;tt<ye;tt++)oe[tt]=tt;oe.sort((tt,ut)=>{const yt=F[5*tt],Ct=F[5*ut];if(yt===Ct){const Ot=F[5*tt+1],Mt=F[5*ut+1];return Ot-Mt}return yt-Ct});const ze=new Uint32Array(F.length);let Ge=0,Ke=0;for(let tt=0;tt<ye;tt++){const ut=5*oe[tt],yt=F[ut+0],Ct=F[ut+1],Ot=F[ut+2],Mt=F[ut+3],un=F[ut+4],pi=yt-Ge,sr=pi===0?Ct-Ke:Ct,hn=5*tt;ze[hn+0]=pi,ze[hn+1]=sr,ze[hn+2]=Ot,ze[hn+3]=Mt,ze[hn+4]=un,Ge=yt,Ke=Ct}return ze}build(F){return this.f?new kn(new Uint32Array(this.g),F):new kn(En.r(this.g),F)}}e.$MN=En;class kn{constructor(F,oe){this.resultId=oe,this.data=F}}e.$NN=kn;class yi{constructor(F,oe,ye){this.start=F,this.deleteCount=oe,this.data=ye}}e.$ON=yi;class Ei{constructor(F,oe){this.resultId=oe,this.edits=F}}e.$PN=Ei;var qn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(qn||(e.DebugConsoleMode=qn={}));class ki{constructor(F){this.name=F}}e.$QN=ki;let Cn=class{static{this.Back={iconPath:new gt("arrow-left")}}constructor(){}};e.$RN=Cn,e.$RN=Cn=Le([R],Cn);var Hn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Hn||(e.QuickPickItemKind=Hn={}));var Un;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(Un||(e.InputBoxValidationSeverity=Un={}));var Vn;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(Vn||(e.ExtensionKind=Vn={}));class Ci{static validate(F){if(typeof F.badge=="string"){let oe=(0,k.$vf)(F.badge,0);if(oe<F.badge.length&&(oe+=(0,k.$vf)(F.badge,oe)),F.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!gt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,oe,ye){this.badge=F,this.tooltip=oe,this.color=ye}}e.$SN=Ci;let Dn=class{constructor(F){this.kind=F}};e.$TN=Dn,e.$TN=Dn=Le([R],Dn);var Wn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Wn||(e.ColorThemeKind=Wn={}));class Vt{static isNotebookRange(F){return F instanceof Vt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,oe){if(F<0)throw(0,A.$7)("start must be positive");if(oe<0)throw(0,A.$7)("end must be positive");F<=oe?(this.c=F,this.e=oe):(this.c=oe,this.e=F)}with(F){let oe=this.c,ye=this.e;return F.start!==void 0&&(oe=F.start),F.end!==void 0&&(ye=F.end),oe===this.c&&ye===this.e?this:new Vt(oe,ye)}}e.$UN=Vt;class fn{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(oe=>fn.isNotebookCellData(oe))}static isNotebookCellData(F){return!0}constructor(F,oe,ye,ze,Ge,Ke,tt){this.kind=F,this.value=oe,this.languageId=ye,this.mime=ze,this.outputs=Ge??[],this.metadata=Ke,this.executionSummary=tt,fn.validate(this)}}e.$VN=fn;class Di{constructor(F){this.cells=F}}e.$WN=Di;class jt{static isNotebookCellOutputItem(F){return F instanceof jt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const oe={name:F.name,message:F.message,stack:F.stack};return jt.json(oe,"application/vnd.code.notebook.error")}static stdout(F){return jt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return jt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,oe="application/octet-stream"){return new jt(F,oe)}static#e=new TextEncoder;static text(F,oe=C.$zs.text){const ye=jt.#e.encode(String(F));return new jt(ye,oe)}static json(F,oe="text/x-json"){const ye=JSON.stringify(F,void 0,"	");return jt.text(ye,oe)}constructor(F,oe){this.data=F,this.mime=oe;const ye=(0,C.$Ds)(oe,!0);if(!ye)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}e.$XN=jt;class dn{static isNotebookCellOutput(F){return F instanceof dn?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,oe=!1){const ye=new Set,ze=new Set;for(let Ge=0;Ge<F.length;Ge++){const Ke=F[Ge],tt=(0,C.$Ds)(Ke.mime);if(!ye.has(tt)||(0,d.$oK)(tt)){ye.add(tt);continue}ze.add(Ge),oe&&console.warn(`DUPLICATED mime type '${Ke.mime}' will be dropped`)}return ze.size===0?F:F.filter((Ge,Ke)=>!ze.has(Ke))}constructor(F,oe,ye){this.items=dn.ensureUniqueMimeTypes(F,!0),typeof oe=="string"?(this.id=oe,this.metadata=ye):(this.id=(0,E.$Eg)(),this.metadata=oe??ye)}}e.$YN=dn;var Gn;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(Gn||(e.NotebookCellKind=Gn={}));var xn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(xn||(e.NotebookCellExecutionState=xn={}));var Jn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Jn||(e.NotebookCellStatusBarAlignment=Jn={}));var Qn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(Qn||(e.NotebookEditorRevealType=Qn={}));class Pi{constructor(F,oe){this.text=F,this.alignment=oe}}e.$ZN=Pi;var Xn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(Xn||(e.NotebookControllerAffinity=Xn={}));var Zn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred",M[M.Hidden=-1]="Hidden"})(Zn||(e.NotebookControllerAffinity2=Zn={}));class Si{constructor(F,oe=[]){this.uri=F,this.provides=(0,i.$3b)(oe)}}e.$1N=Si;class Ii{constructor(F){this.label=F}}e.$2N=Ii;var Yn;(function(M){M[M.Named=1]="Named",M[M.Indexed=2]="Indexed"})(Yn||(e.NotebookVariablesRequestKind=Yn={}));let Pn=class{constructor(F,oe){this.label=F,this.timestamp=oe}};e.$3N=Pn,e.$3N=Pn=Le([R],Pn);var Kn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(Kn||(e.ExtensionMode=Kn={}));var _n;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(_n||(e.ExtensionRuntime=_n={}));var ei;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(ei||(e.StandardTokenType=ei={}));class Ai{constructor(F,oe){this.ranges=F,this.wordPattern=oe}}e.$4N=Ai;class ji{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$5N=ji;var ti;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(ti||(e.TestResultState=ti={}));var ni;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(ni||(e.TestRunProfileKind=ni={}));let Sn=class{constructor(F=void 0,oe=void 0,ye=void 0,ze=!1){this.include=F,this.exclude=oe,this.profile=ye,this.continuous=ze}};e.$6N=Sn,e.$6N=Sn=Le([R],Sn);let In=O=class{static diff(F,oe,ye){const ze=new O(F);return ze.expectedOutput=oe,ze.actualOutput=ye,ze}constructor(F){this.message=F}};e.$7N=In,e.$7N=In=O=Le([R],In);let An=class{constructor(F){this.id=F}};e.$8N=An,e.$8N=An=Le([R],An);class mn{constructor(F,oe){this.covered=F,this.total=oe,ii(this)}}e.$9N=mn;function ii(M){if(M){if(M.covered>M.total)throw new Error(`The total number of covered items (${M.covered}) cannot be greater than the total (${M.total})`);if(M.total<0)throw new Error(`The number of covered items (${M.total}) cannot be negative`)}}class jn{static fromDetails(F,oe){const ye=new mn(0,0),ze=new mn(0,0),Ge=new mn(0,0);for(const tt of oe)if("branches"in tt){ye.total+=1,ye.covered+=tt.executed?1:0;for(const ut of tt.branches)ze.total+=1,ze.covered+=ut.executed?1:0}else Ge.total+=1,Ge.covered+=tt.executed?1:0;const Ke=new jn(F,ye,ze.total>0?ze:void 0,Ge.total>0?Ge:void 0);return Ke.detailedCoverage=oe,Ke}constructor(F,oe,ye,ze){this.uri=F,this.statementCoverage=oe,this.branchCoverage=ye,this.declarationCoverage=ze}}e.$$N=jn;class Oi{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,oe,ye=[]){this.executed=F,this.location=oe,this.branches=ye}}e.$_N=Oi;class Ri{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,oe,ye){this.executed=F,this.location=oe,this.label=ye}}e.$aO=Ri;class Ni{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,oe,ye){this.name=F,this.executed=oe,this.location=ye}}e.$bO=Ni;var ri;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(ri||(e.ExternalUriOpenerPriority=ri={}));var si;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(si||(e.WorkspaceTrustState=si={}));var oi;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(oi||(e.PortAutoForwardAction=oi={}));class Fi{constructor(F,oe,ye,ze,Ge,Ke){this.kind=F,this.name=oe,this.detail=ye,this.uri=ze,this.range=Ge,this.selectionRange=Ke}}e.$cO=Fi;class Li{constructor(F){this.uri=F}}e.$dO=Li;class Mi{constructor(F,oe){this.original=F,this.modified=oe}}e.$eO=Mi;class Ti{constructor(F,oe,ye,ze){this.base=F,this.input1=oe,this.input2=ye,this.result=ze}}e.$fO=Ti;class zi{constructor(F,oe){this.uri=F,this.viewType=oe}}e.$gO=zi;class Bi{constructor(F){this.viewType=F}}e.$hO=Bi;class qi{constructor(F,oe){this.uri=F,this.notebookType=oe}}e.$iO=qi;class Hi{constructor(F,oe,ye){this.original=F,this.modified=oe,this.notebookType=ye}}e.$jO=Hi;class Ui{constructor(){}}e.$kO=Ui;class Vi{constructor(F,oe){this.uri=F,this.inputBoxUri=oe}}e.$lO=Vi;class Wi{constructor(F){this.providerId=F}}e.$mO=Wi;class Gi{constructor(F){this.textDiffs=F}}e.$nO=Gi;var ai;(function(M){M[M.Down=0]="Down",M[M.Up=1]="Up"})(ai||(e.InteractiveSessionVoteDirection=ai={}));var ci;(function(M){M[M.Action=1]="Action",M[M.Toolbar=2]="Toolbar"})(ci||(e.ChatCopyKind=ci={}));var li;(function(M){M[M.Short=1]="Short",M[M.Medium=2]="Medium",M[M.Full=3]="Full"})(li||(e.ChatVariableLevel=li={}));class xi{constructor(F,oe){this.label=F,this.values=oe}}e.$oO=xi;var ui;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful",M[M.Undone=2]="Undone",M[M.Accepted=3]="Accepted",M[M.Bug=4]="Bug"})(ui||(e.InteractiveEditorResponseFeedbackKind=ui={}));var hi;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful"})(hi||(e.ChatResultFeedbackKind=hi={}));class Ji{constructor(F){this.value=typeof F=="string"?new Ve(F):F}}e.$pO=Ji;class Qi{constructor(F,oe){this.value=F,this.baseUri=oe}}e.$qO=Qi;class Xi{constructor(F,oe){this.value=F,this.title=oe}}e.$rO=Xi;class Zi{constructor(F){this.value=F}}e.$sO=Zi;class Yi{constructor(F){this.value=F}}e.$tO=Yi;class Ki{constructor(F){this.value=F}}e.$uO=Ki;class _i{constructor(F,oe,ye,ze){this.prompt=F,this.command=oe,this.variables=ye,this.participant=ze}}e.$vO=_i;class er{constructor(F,oe,ye,ze){this.response=F,this.result=oe,this.participant=ye,this.command=ze}}e.$wO=er;var fi;(function(M){M[M.Panel=1]="Panel",M[M.Terminal=2]="Terminal",M[M.Notebook=3]="Notebook",M[M.Editor=4]="Editor"})(fi||(e.ChatLocation=fi={}));class tr{constructor(F){this.content=F}}e.$xO=tr;class nr{constructor(F,oe){this.content=F,this.name=oe}}e.$yO=nr;class ir{constructor(F,oe){this.content=F,this.name=oe}}e.$zO=ir;class sn extends Error{static NotFound(F){return new sn(F,sn.NotFound.name)}static NoPermissions(F){return new sn(F,sn.NoPermissions.name)}constructor(F,oe,ye){super(F,{cause:ye}),this.name="LanguageModelError",this.code=oe??""}}e.$AO=sn;var di;(function(M){M[M.SymbolInformation=1]="SymbolInformation",M[M.CommandInformation=2]="CommandInformation",M[M.SearchInformation=3]="SearchInformation",M[M.SettingInformation=4]="SettingInformation"})(di||(e.RelatedInformationType=di={}));var mi;(function(M){M[M.Started=1]="Started",M[M.Recognizing=2]="Recognizing",M[M.Recognized=3]="Recognized",M[M.Stopped=4]="Stopped"})(mi||(e.SpeechToTextStatus=mi={}));var gi;(function(M){M[M.Recognized=1]="Recognized",M[M.Stopped=2]="Stopped"})(gi||(e.KeywordRecognitionStatus=gi={}));class rr{constructor(F,oe){this.text=F,this.range=oe}}e.$BO=rr;var $i;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})($i||(e.InlineEditTriggerKind=$i={}))}),define(Ee[141],ke([1,0,18,14,158,75,101,24,148,53,65,21,151,19,11,3,44,180,237,135,93,278,139,72,94,137,288,140]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f,h,l,t,a,o,r,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$KO=V,e.$LO=x,e.$MO=Z;var b;(function(be){function De(W){const{selectionStartLineNumber:ve,selectionStartColumn:je,positionLineNumber:qe,positionColumn:Be}=W,Ze=new n.$uM(ve-1,je-1),st=new n.$uM(qe-1,Be-1);return new n.$wM(Ze,st)}be.to=De;function he(W){const{anchor:ve,active:je}=W;return{selectionStartLineNumber:ve.line+1,selectionStartColumn:ve.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}be.from=he})(b||(e.Selection=b={}));var P;(function(be){function De(W){if(!W)return;const{start:ve,end:je}=W;return{startLineNumber:ve.line+1,startColumn:ve.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}be.from=De;function he(W){if(!W)return;const{startLineNumber:ve,startColumn:je,endLineNumber:qe,endColumn:Be}=W;return new n.$vM(ve-1,je-1,qe-1,Be-1)}be.to=he})(P||(e.Range=P={}));var I;(function(be){function De(W){return{uri:W.uri,range:P.from(W.range)}}be.from=De;function he(W){return new n.$FM(c.URI.revive(W.uri),P.to(W.range))}be.to=he})(I||(e.Location=I={}));var O;(function(be){function De(he){switch(he){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}be.to=De})(O||(e.TokenType=O={}));var R;(function(be){function De(W){return new n.$uM(W.lineNumber-1,W.column-1)}be.to=De;function he(W){return{lineNumber:W.line+1,column:W.character+1}}be.from=he})(R||(e.Position=R={}));var j;(function(be){function De(ve,je,qe){return(0,i.$Hb)((0,i.$3b)(ve).map(Be=>he(Be,je,qe)))}be.from=De;function he(ve,je,qe){if(typeof ve=="string")return{$serialized:!0,language:ve,isBuiltin:qe?.isBuiltin};if(ve)return{$serialized:!0,language:ve.language,scheme:W(ve.scheme,je),pattern:Qe.from(ve.pattern)??void 0,exclusive:ve.exclusive,notebookType:ve.notebookType,isBuiltin:qe?.isBuiltin}}function W(ve,je){return je&&typeof ve=="string"?je.transformOutgoingScheme(ve):ve}})(j||(e.DocumentSelector=j={}));var B;(function(be){function De(W){switch(W){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}be.from=De;function he(W){switch(W){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}be.to=he})(B||(e.DiagnosticTag=B={}));var Y;(function(be){function De(W){let ve;return W.code&&((0,d.$Vf)(W.code)||(0,d.$Zf)(W.code)?ve=String(W.code):ve={value:String(W.code.value),target:W.code.target}),{...P.from(W.range),message:W.message,source:W.source,code:ve,severity:ue.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(fe.from),tags:Array.isArray(W.tags)?(0,i.$Hb)(W.tags.map(B.from)):void 0}}be.from=De;function he(W){const ve=new n.$HM(P.to(W),W.message,ue.to(W.severity));return ve.source=W.source,ve.code=(0,d.$Vf)(W.code)?W.code:W.code?.value,ve.relatedInformation=W.relatedInformation&&W.relatedInformation.map(fe.to),ve.tags=W.tags&&(0,i.$Hb)(W.tags.map(B.to)),ve}be.to=he})(Y||(e.Diagnostic=Y={}));var fe;(function(be){function De(W){return{...P.from(W.location.range),message:W.message,resource:W.location.uri}}be.from=De;function he(W){return new n.$GM(new n.$FM(W.resource,P.to(W)),W.message)}be.to=he})(fe||(e.DiagnosticRelatedInformation=fe={}));var ue;(function(be){function De(W){switch(W){case n.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}be.from=De;function he(W){switch(W){case p.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}be.to=he})(ue||(e.DiagnosticSeverity=ue={}));var re;(function(be){function De(W){return typeof W=="number"&&W>=n.ViewColumn.One?W-1:W===n.ViewColumn.Beside?r.$GD:r.$FD}be.from=De;function he(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=he})(re||(e.ViewColumn=re={}));function te(be){return typeof be.range<"u"}function V(be){return be.length===0?!0:!!te(be[0])}var T;(function(be){function De(Be){return Be.map(be.from)}be.fromMany=De;function he(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function W(Be){let Ze;if(he(Be)){const{language:lt,value:vt}=Be;Ze={value:"```"+lt+`
`+vt+"\n```\n"}}else n.$UM.isMarkdownString(Be)?Ze={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ze={value:Be}:Ze={value:""};const st=Object.create(null);Ze.uris=st;const ft=lt=>{try{let vt=c.URI.parse(lt,!0);vt=vt.with({query:ve(vt.query,st)}),st[lt]=vt}catch{}return""},$t=new v.marked.Renderer;return $t.link=ft,$t.image=lt=>typeof lt=="string"?ft(C.$Nk(lt).href):"",(0,v.marked)(Ze.value,{renderer:$t}),Ze}be.from=W;function ve(Be,Ze){if(!Be)return Be;let st;try{st=(0,$.$Qh)(Be)}catch{}if(!st)return Be;let ft=!1;return st=(0,y.$Qn)(st,$t=>{if(c.URI.isUri($t)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[lt]=$t,ft=!0,lt}else return}),ft?JSON.stringify(st):Be}function je(Be){const Ze=new n.$UM(Be.value,Be.supportThemeIcons);return Ze.isTrusted=Be.isTrusted,Ze.supportHtml=Be.supportHtml,Ze.baseUri=Be.baseUri?c.URI.from(Be.baseUri):void 0,Ze}be.to=je;function qe(Be){if(Be)return typeof Be=="string"?Be:be.from(Be)}be.fromStrict=qe})(T||(e.MarkdownString=T={}));function x(be){return V(be)?be.map(De=>({range:P.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?T.fromMany(De.hoverMessage):De.hoverMessage?T.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):be.map(De=>({range:P.from(De)}))}function Z(be){return typeof be>"u"?be:typeof be=="string"?c.URI.file(be):be}var G;(function(be){function De(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?Z(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}be.from=De})(G||(e.ThemableDecorationAttachmentRenderOptions=G={}));var se;(function(be){function De(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?Z(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?G.from(he.before):void 0,after:he.after?G.from(he.after):void 0}}be.from=De})(se||(e.ThemableDecorationRenderOptions=se={}));var ce;(function(be){function De(he){if(typeof he>"u")return he;switch(he){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=De})(ce||(e.DecorationRangeBehavior=ce={}));var ne;(function(be){function De(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?ce.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?se.from(he.light):void 0,dark:he.dark?se.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?Z(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?G.from(he.before):void 0,after:he.after?G.from(he.after):void 0}}be.from=De})(ne||(e.DecorationRenderOptions=ne={}));var $e;(function(be){function De(W){return{text:W.newText,eol:W.newEol&&Ne.from(W.newEol),range:P.from(W.range)}}be.from=De;function he(W){const ve=new n.$AM(P.to(W.range),W.text);return ve.newEol=typeof W.eol>"u"?void 0:Ne.to(W.eol),ve}be.to=he})($e||(e.TextEdit=$e={}));var K;(function(be){function De(W,ve){const je={edits:[]};if(W instanceof n.$DM){const qe=new k.$Cc;for(const Be of W._allEntries())Be._type===1&&c.URI.isUri(Be.to)&&Be.from===void 0&&qe.add(Be.to);for(const Be of W._allEntries())if(Be._type===1){let Ze;Be.options?.contents&&(ArrayBuffer.isView(Be.options.contents)?Ze={type:"base64",value:(0,A.$Oe)(A.$ue.wrap(Be.options.contents))}:Ze={type:"dataTransferItem",id:Be.options.contents._itemId}),je.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contents:Ze},metadata:Be.metadata})}else Be._type===2?je.edits.push({resource:Be.uri,textEdit:$e.from(Be.edit),versionId:qe.has(Be.uri)?void 0:ve?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?je.edits.push({resource:Be.uri,textEdit:{range:P.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:qe.has(Be.uri)?void 0:ve?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?je.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:ve?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&je.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:ve?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(pt.from)}})}return je}be.from=De;function he(W){const ve=new n.$DM,je=new k.$Bc;for(const qe of W.edits)if(qe.textEdit){const Be=qe,Ze=c.URI.revive(Be.resource),st=P.to(Be.textEdit.range),ft=Be.textEdit.text,$t=Be.textEdit.insertAsSnippet;let lt;$t?lt=n.$CM.replace(st,new n.$EM(ft)):lt=n.$AM.replace(st,ft);const vt=je.get(Ze);vt?vt.push(lt):je.set(Ze,[lt])}else ve.renameFile(c.URI.revive(qe.oldResource),c.URI.revive(qe.newResource),qe.options);for(const[qe,Be]of je)ve.set(qe,Be);return ve}be.to=he})(K||(e.WorkspaceEdit=K={}));var q;(function(be){const De=Object.create(null);De[n.SymbolKind.File]=0,De[n.SymbolKind.Module]=1,De[n.SymbolKind.Namespace]=2,De[n.SymbolKind.Package]=3,De[n.SymbolKind.Class]=4,De[n.SymbolKind.Method]=5,De[n.SymbolKind.Property]=6,De[n.SymbolKind.Field]=7,De[n.SymbolKind.Constructor]=8,De[n.SymbolKind.Enum]=9,De[n.SymbolKind.Interface]=10,De[n.SymbolKind.Function]=11,De[n.SymbolKind.Variable]=12,De[n.SymbolKind.Constant]=13,De[n.SymbolKind.String]=14,De[n.SymbolKind.Number]=15,De[n.SymbolKind.Boolean]=16,De[n.SymbolKind.Array]=17,De[n.SymbolKind.Object]=18,De[n.SymbolKind.Key]=19,De[n.SymbolKind.Null]=20,De[n.SymbolKind.EnumMember]=21,De[n.SymbolKind.Struct]=22,De[n.SymbolKind.Event]=23,De[n.SymbolKind.Operator]=24,De[n.SymbolKind.TypeParameter]=25;function he(ve){return typeof De[ve]=="number"?De[ve]:6}be.from=he;function W(ve){for(const je in De)if(De[je]===ve)return Number(je);return n.SymbolKind.Property}be.to=W})(q||(e.SymbolKind=q={}));var N;(function(be){function De(W){switch(W){case n.SymbolTag.Deprecated:return 1}}be.from=De;function he(W){switch(W){case 1:return n.SymbolTag.Deprecated}}be.to=he})(N||(e.SymbolTag=N={}));var z;(function(be){function De(W){return{name:W.name,kind:q.from(W.kind),tags:W.tags&&W.tags.map(N.from),containerName:W.containerName,location:U.from(W.location)}}be.from=De;function he(W){const ve=new n.$LM(W.name,q.to(W.kind),W.containerName,U.to(W.location));return ve.tags=W.tags&&W.tags.map(N.to),ve}be.to=he})(z||(e.WorkspaceSymbol=z={}));var X;(function(be){function De(W){const ve={name:W.name||"!!MISSING: name!!",detail:W.detail,range:P.from(W.range),selectionRange:P.from(W.selectionRange),kind:q.from(W.kind),tags:W.tags?.map(N.from)??[]};return W.children&&(ve.children=W.children.map(De)),ve}be.from=De;function he(W){const ve=new n.$MM(W.name,W.detail,q.to(W.kind),P.to(W.range),P.to(W.selectionRange));return(0,i.$Lb)(W.tags)&&(ve.tags=W.tags.map(N.to)),W.children&&(ve.children=W.children.map(he)),ve}be.to=he})(X||(e.DocumentSymbol=X={}));var ae;(function(be){function De(W){const ve=new n.$QM(q.to(W.kind),W.name,W.detail||"",c.URI.revive(W.uri),P.to(W.range),P.to(W.selectionRange));return ve._sessionId=W._sessionId,ve._itemId=W._itemId,ve}be.to=De;function he(W,ve,je){if(ve=ve??W._sessionId,je=je??W._itemId,ve===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:je,name:W.name,detail:W.detail,kind:q.from(W.kind),uri:W.uri,range:P.from(W.range),selectionRange:P.from(W.selectionRange),tags:W.tags?.map(N.from)}}be.from=he})(ae||(e.CallHierarchyItem=ae={}));var Q;(function(be){function De(he){return new n.$RM(ae.to(he.from),he.fromRanges.map(W=>P.to(W)))}be.to=De})(Q||(e.CallHierarchyIncomingCall=Q={}));var J;(function(be){function De(he){return new n.$SM(ae.to(he.to),he.fromRanges.map(W=>P.to(W)))}be.to=De})(J||(e.CallHierarchyOutgoingCall=J={}));var U;(function(be){function De(W){return{range:W.range&&P.from(W.range),uri:W.uri}}be.from=De;function he(W){return new n.$FM(c.URI.revive(W.uri),P.to(W.range))}be.to=he})(U||(e.location=U={}));var L;(function(be){function De(W){const ve=W,je=W;return{originSelectionRange:ve.originSelectionRange?P.from(ve.originSelectionRange):void 0,uri:ve.targetUri?ve.targetUri:je.uri,range:P.from(ve.targetRange?ve.targetRange:je.range),targetSelectionRange:ve.targetSelectionRange?P.from(ve.targetSelectionRange):void 0}}be.from=De;function he(W){return{targetUri:c.URI.revive(W.uri),targetRange:P.to(W.range),targetSelectionRange:W.targetSelectionRange?P.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?P.to(W.originSelectionRange):void 0}}be.to=he})(L||(e.DefinitionLink=L={}));var H;(function(be){function De(W){return{range:P.from(W.range),contents:T.fromMany(W.contents)}}be.from=De;function he(W){return new n.$IM(W.contents.map(T.to),P.to(W.range))}be.to=he})(H||(e.Hover=H={}));var _;(function(be){function De(W){return{range:P.from(W.range),expression:W.expression}}be.from=De;function he(W){return new n.$DN(P.to(W.range),W.expression)}be.to=he})(_||(e.EvaluatableExpression=_={}));var ee;(function(be){function De(W){if(W instanceof n.$EN)return{type:"text",range:P.from(W.range),text:W.text};if(W instanceof n.$FN)return{type:"variable",range:P.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof n.$GN)return{type:"expression",range:P.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}be.from=De;function he(W){switch(W.type){case"text":return{range:P.to(W.range),text:W.text};case"variable":return{range:P.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:P.to(W.range),expression:W.expression}}}be.to=he})(ee||(e.InlineValue=ee={}));var de;(function(be){function De(W){return{frameId:W.frameId,stoppedLocation:P.from(W.stoppedLocation)}}be.from=De;function he(W){return new n.$HN(W.frameId,P.to(W.stoppedLocation))}be.to=he})(de||(e.InlineValueContext=de={}));var ie;(function(be){function De(W){return{range:P.from(W.range),kind:W.kind}}be.from=De;function he(W){return new n.$JM(P.to(W.range),W.kind)}be.to=he})(ie||(e.DocumentHighlight=ie={}));var me;(function(be){function De(W){return{uri:W.uri,highlights:W.highlights.map(ie.from)}}be.from=De;function he(W){return new n.$KM(c.URI.revive(W.uri),W.highlights.map(ie.to))}be.to=he})(me||(e.MultiDocumentHighlight=me={}));var we;(function(be){function De(he){switch(he){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}be.to=De})(we||(e.CompletionTriggerKind=we={}));var Ie;(function(be){function De(he){return{triggerKind:we.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}be.to=De})(Ie||(e.CompletionContext=Ie={}));var Oe;(function(be){function De(W){switch(W){case n.CompletionItemTag.Deprecated:return 1}}be.from=De;function he(W){switch(W){case 1:return n.CompletionItemTag.Deprecated}}be.to=he})(Oe||(e.CompletionItemTag=Oe={}));var ge;(function(be){const De=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function he(je){return De.get(je)??9}be.from=he;const W=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function ve(je){return W.get(je)??n.CompletionItemKind.Property}be.to=ve})(ge||(e.CompletionItemKind=ge={}));var Se;(function(be){function De(he,W){const ve=new n.$1M(he.label);return ve.insertText=he.insertText,ve.kind=ge.to(he.kind),ve.tags=he.tags?.map(Oe.to),ve.detail=he.detail,ve.documentation=C.$Hk(he.documentation)?T.to(he.documentation):he.documentation,ve.sortText=he.sortText,ve.filterText=he.filterText,ve.preselect=he.preselect,ve.commitCharacters=he.commitCharacters,g.$ct.isIRange(he.range)?ve.range=P.to(he.range):typeof he.range=="object"&&(ve.range={inserting:P.to(he.range.insert),replacing:P.to(he.range.replace)}),ve.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?ve.insertText=new n.$EM(he.insertText):(ve.insertText=he.insertText,ve.textEdit=ve.range instanceof n.$vM?new n.$AM(ve.range,ve.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(ve.additionalTextEdits=he.additionalTextEdits.map(je=>$e.to(je))),ve.command=W&&he.command?W.fromInternal(he.command):void 0,ve}be.to=De})(Se||(e.CompletionItem=Se={}));var Ce;(function(be){function De(W){if(typeof W.label!="string"&&!Array.isArray(W.label))throw new TypeError("Invalid label");return{label:W.label,documentation:T.fromStrict(W.documentation)}}be.from=De;function he(W){return{label:W.label,documentation:C.$Hk(W.documentation)?T.to(W.documentation):W.documentation}}be.to=he})(Ce||(e.ParameterInformation=Ce={}));var Te;(function(be){function De(W){return{label:W.label,documentation:T.fromStrict(W.documentation),parameters:Array.isArray(W.parameters)?W.parameters.map(Ce.from):[],activeParameter:W.activeParameter}}be.from=De;function he(W){return{label:W.label,documentation:C.$Hk(W.documentation)?T.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(Ce.to):[],activeParameter:W.activeParameter}}be.to=he})(Te||(e.SignatureInformation=Te={}));var Fe;(function(be){function De(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(Te.from):[]}}be.from=De;function he(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(Te.to):[]}}be.to=he})(Fe||(e.SignatureHelp=Fe={}));var Ve;(function(be){function De(he,W){const ve=new n.$ZM(R.to(W.position),typeof W.label=="string"?W.label:W.label.map(Ue.to.bind(void 0,he)),W.kind&&xe.to(W.kind));return ve.textEdits=W.textEdits&&W.textEdits.map($e.to),ve.tooltip=C.$Hk(W.tooltip)?T.to(W.tooltip):W.tooltip,ve.paddingLeft=W.paddingLeft,ve.paddingRight=W.paddingRight,ve}be.to=De})(Ve||(e.InlayHint=Ve={}));var Ue;(function(be){function De(he,W){const ve=new n.$YM(W.label);return ve.tooltip=C.$Hk(W.tooltip)?T.to(W.tooltip):W.tooltip,u.Command.is(W.command)&&(ve.command=he.fromInternal(W.command)),W.location&&(ve.location=U.to(W.location)),ve}be.to=De})(Ue||(e.InlayHintLabelPart=Ue={}));var xe;(function(be){function De(W){return W}be.from=De;function he(W){return W}be.to=he})(xe||(e.InlayHintKind=xe={}));var Xe;(function(be){function De(W){return{range:P.from(W.range),url:W.target,tooltip:W.tooltip}}be.from=De;function he(W){let ve;if(W.url)try{ve=typeof W.url=="string"?c.URI.parse(W.url,!0):c.URI.revive(W.url)}catch{}return new n.$6M(P.to(W.range),ve)}be.to=he})(Xe||(e.DocumentLink=Xe={}));var _e;(function(be){function De(W){const ve=new n.$9M(W.label);return W.textEdit&&(ve.textEdit=$e.to(W.textEdit)),W.additionalTextEdits&&(ve.additionalTextEdits=W.additionalTextEdits.map(je=>$e.to(je))),ve}be.to=De;function he(W){return{label:W.label,textEdit:W.textEdit?$e.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(ve=>$e.from(ve)):void 0}}be.from=he})(_e||(e.ColorPresentation=_e={}));var et;(function(be){function De(W){return new n.$7M(W[0],W[1],W[2],W[3])}be.to=De;function he(W){return[W.red,W.green,W.blue,W.alpha]}be.from=he})(et||(e.Color=et={}));var Je;(function(be){function De(W){return{range:P.from(W.range)}}be.from=De;function he(W){return new n.$PM(P.to(W.range))}be.to=he})(Je||(e.SelectionRange=Je={}));var pe;(function(be){function De(he){switch(he){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}be.to=De})(pe||(e.TextDocumentSaveReason=pe={}));var Pe;(function(be){function De(W){switch(W){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.Interval:return 3;case n.TextEditorLineNumbersStyle.On:default:return 1}}be.from=De;function he(W){switch(W){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 3:return n.TextEditorLineNumbersStyle.Interval;case 1:default:return n.TextEditorLineNumbersStyle.On}}be.to=he})(Pe||(e.TextEditorLineNumbersStyle=Pe={}));var Ne;(function(be){function De(W){if(W===n.EndOfLine.CRLF)return 1;if(W===n.EndOfLine.LF)return 0}be.from=De;function he(W){if(W===1)return n.EndOfLine.CRLF;if(W===0)return n.EndOfLine.LF}be.to=he})(Ne||(e.EndOfLine=Ne={}));var Ae;(function(be){function De(he){if(typeof he=="object")return he.viewId;switch(he){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=De})(Ae||(e.ProgressLocation=Ae={}));var Me;(function(be){function De(W){const ve={start:W.start+1,end:W.end+1};return W.kind&&(ve.kind=He.from(W.kind)),ve}be.from=De;function he(W){const ve={start:W.start-1,end:W.end-1};return W.kind&&(ve.kind=He.to(W.kind)),ve}be.to=he})(Me||(e.FoldingRange=Me={}));var He;(function(be){function De(W){if(W)switch(W){case n.FoldingRangeKind.Comment:return u.$7t.Comment;case n.FoldingRangeKind.Imports:return u.$7t.Imports;case n.FoldingRangeKind.Region:return u.$7t.Region}}be.from=De;function he(W){if(W)switch(W.value){case u.$7t.Comment.value:return n.FoldingRangeKind.Comment;case u.$7t.Imports.value:return n.FoldingRangeKind.Imports;case u.$7t.Region.value:return n.FoldingRangeKind.Region}}be.to=he})(He||(e.FoldingRangeKind=He={}));var We;(function(be){function De(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?P.from(he.selection):void 0,override:typeof he.override=="boolean"?h.$9E.id:void 0}}be.from=De})(We||(e.TextEditorOpenOptions=We={}));var Qe;(function(be){function De(je){return je instanceof n.$rN?je.toJSON():typeof je=="string"?je:he(je)||W(je)?new n.$rN(je.baseUri??je.base,je.pattern).toJSON():je}be.from=De;function he(je){const qe=je;return qe?c.URI.isUri(qe.baseUri)&&typeof qe.pattern=="string":!1}function W(je){const qe=je;return qe?typeof qe.base=="string"&&typeof qe.pattern=="string":!1}function ve(je){return typeof je=="string"?je:new n.$rN(c.URI.revive(je.baseUri),je.pattern)}be.to=ve})(Qe||(e.GlobPattern=Qe={}));var it;(function(be){function De(he){if(he){if(Array.isArray(he))return he.map(De);if(typeof he=="string")return he;{const W=he;return{language:W.language,scheme:W.scheme,pattern:Qe.from(W.pattern),exclusive:W.exclusive,notebookType:W.notebookType}}}else return}be.from=De})(it||(e.LanguageSelector=it={}));var Ye;(function(be){function De(W){return!!W&&typeof W=="object"&&"documents"in W&&Array.isArray(W.documents)&&W.documents.every(ve=>Array.isArray(ve)&&ve.every(je=>je&&typeof je=="object"&&"uri"in je&&c.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(qe=>qe instanceof n.$vM)))}be.is=De;function he(W){return{documents:W.documents.map(ve=>ve.map(je=>({uri:c.URI.from(je.uri),version:je.version,ranges:je.ranges.map(qe=>P.from(qe))})))}}be.from=he})(Ye||(e.MappedEditsContext=Ye={}));var nt;(function(be){function De(W){return{start:W.start,end:W.end}}be.from=De;function he(W){return new n.$UN(W.start,W.end)}be.to=he})(nt||(e.NotebookRange=nt={}));var ot;(function(be){function De(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}be.to=De;function he(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}be.from=he})(ot||(e.NotebookCellExecutionSummary=ot={}));var at;(function(be){function De(he){if(he===t.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(he===t.NotebookCellExecutionState.Pending)return;if(he===t.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}be.to=De})(at||(e.NotebookCellExecutionState=at={}));var ct;(function(be){function De(W){switch(W){case n.NotebookCellKind.Markup:return t.CellKind.Markup;case n.NotebookCellKind.Code:default:return t.CellKind.Code}}be.from=De;function he(W){switch(W){case t.CellKind.Markup:return n.NotebookCellKind.Markup;case t.CellKind.Code:default:return n.NotebookCellKind.Code}}be.to=he})(ct||(e.NotebookCellKind=ct={}));var ht;(function(be){function De(W){const ve={metadata:W.metadata??Object.create(null),cells:[]};for(const je of W.cells)n.$VN.validate(je),ve.cells.push(pt.from(je));return ve}be.from=De;function he(W){const ve=new n.$WN(W.cells.map(pt.to));return(0,d.$9f)(W.metadata)||(ve.metadata=W.metadata),ve}be.to=he})(ht||(e.NotebookData=ht={}));var pt;(function(be){function De(W){return{cellKind:ct.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:ot.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Dt.from):[]}}be.from=De;function he(W){return new n.$VN(ct.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Dt.to):void 0,W.metadata,W.internalMetadata?ot.to(W.internalMetadata):void 0)}be.to=he})(pt||(e.NotebookCellData=pt={}));var Rt;(function(be){function De(W){return{mime:W.mime,valueBytes:A.$ue.wrap(W.data)}}be.from=De;function he(W){return new n.$XN(W.valueBytes.buffer,W.mime)}be.to=he})(Rt||(e.NotebookCellOutputItem=Rt={}));var Dt;(function(be){function De(W){return{outputId:W.id,items:W.items.map(Rt.from),metadata:W.metadata}}be.from=De;function he(W){const ve=W.items.map(Rt.to);return new n.$YN(ve,W.outputId,W.metadata)}be.to=he})(Dt||(e.NotebookCellOutput=Dt={}));var Pt;(function(be){function De(ve){return W(ve)?{include:Qe.from(ve.include)??void 0,exclude:Qe.from(ve.exclude)??void 0}:Qe.from(ve)??void 0}be.from=De;function he(ve){return W(ve)?{include:Qe.to(ve.include),exclude:Qe.to(ve.exclude)}:Qe.to(ve)}be.to=he;function W(ve){const je=ve;return je?!(0,d.$5f)(je.include)&&!(0,d.$5f)(je.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var Et;(function(be){function De(he,W,ve){const je=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(je,ve),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}be.from=De})(Et||(e.NotebookStatusBarItem=Et={}));var St;(function(be){function De(he,W,ve){const je=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:W.toInternal(je,ve),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}be.from=De})(St||(e.NotebookKernelSourceAction=St={}));var Tt;(function(be){function De(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}be.from=De})(Tt||(e.NotebookDocumentContentOptions=Tt={}));var dt;(function(be){function De(W){return{uri:W.uri,provides:W.provides}}be.from=De;function he(W){return new n.$1N(c.URI.revive(W.uri),W.provides)}be.to=he})(dt||(e.NotebookRendererScript=dt={}));var zt;(function(be){function De(W){return{message:T.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,contextValue:W.contextValue,location:W.location&&{range:P.from(W.location.range),uri:W.location.uri}}}be.from=De;function he(W){const ve=new n.$7N(typeof W.message=="string"?W.message:T.to(W.message));return ve.actualOutput=W.actual,ve.expectedOutput=W.expected,ve.contextValue=W.contextValue,ve.location=W.location?U.to(W.location):void 0,ve}be.to=he})(zt||(e.TestMessage=zt={}));var wt;(function(be){be.namespace=o.$iL,be.denamespace=o.$jL})(wt||(e.TestTag=wt={}));var rt;(function(be){function De(W){const ve=(0,f.$JO)(W).controllerId;return{extId:a.$dL.fromExtHostTestItem(W,ve).toString(),label:W.label,uri:c.URI.revive(W.uri),busy:W.busy,tags:W.tags.map(je=>wt.namespace(ve,je.id)),range:g.$ct.lift(P.from(W.range)),description:W.description||null,sortText:W.sortText||null,error:W.error&&T.fromStrict(W.error)||null}}be.from=De;function he(W){return{parent:void 0,error:void 0,id:a.$dL.fromString(W.extId).localId,label:W.label,uri:c.URI.revive(W.uri),tags:(W.tags||[]).map(ve=>{const{tagId:je}=wt.denamespace(ve);return new n.$8N(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:P.to(W.range||void 0),canResolveChildren:!1,busy:W.busy,description:W.description||void 0,sortText:W.sortText||void 0}}be.toPlain=he})(rt||(e.TestItem=rt={})),function(be){function De(W){return{id:W.id}}be.from=De;function he(W){return new n.$8N(W.id)}be.to=he}(wt||(e.TestTag=wt={}));var mt;(function(be){const De=(W,ve)=>{const je=W.value;if(!je)return;const qe={...rt.toPlain(je.item),parent:ve,taskStates:je.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ze=>Ze.type===0).map(zt.to)})),children:[]};if(W.children)for(const Be of W.children.values()){const Ze=De(Be,qe);Ze&&qe.children.push(Ze)}return qe};function he(W){const ve=new w.$CO;for(const Be of W.items)ve.insert(a.$dL.fromString(Be.item.extId).path,Be);const je=[ve.nodes],qe=[];for(;je.length;)for(const Be of je.pop())Be.value?qe.push(Be):Be.children&&je.push(Be.children.values());return{completedAt:W.completedAt,results:qe.map(Be=>De(Be)).filter(d.$4f)}}be.to=he})(mt||(e.TestResults=mt={}));var bt;(function(be){function De(je){return{covered:je.covered,total:je.total}}function he(je){return"line"in je?R.from(je):P.from(je)}function W(je){if(typeof je.executed=="number"&&je.executed<0)throw new Error(`Invalid coverage count ${je.executed}`);return"branches"in je?{count:je.executed,location:he(je.location),type:1,branches:je.branches.length?je.branches.map(qe=>({count:qe.executed,location:qe.location&&he(qe.location),label:qe.label})):void 0}:{type:0,name:je.name,count:je.executed,location:he(je.location)}}be.fromDetails=W;function ve(je,qe){return n.$0N(qe.statementCoverage),n.$0N(qe.branchCoverage),n.$0N(qe.declarationCoverage),{id:je,uri:qe.uri,statement:De(qe.statementCoverage),branch:qe.branchCoverage&&De(qe.branchCoverage),declaration:qe.declarationCoverage&&De(qe.declarationCoverage)}}be.fromFile=ve})(bt||(e.TestCoverage=bt={}));var Kt;(function(be){function De(he){switch(he){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}be.to=De})(Kt||(e.CodeActionTriggerKind=Kt={}));var Wt;(function(be){function De(W){const ve=new n.$cO(q.to(W.kind),W.name,W.detail||"",c.URI.revive(W.uri),P.to(W.range),P.to(W.selectionRange));return ve._sessionId=W._sessionId,ve._itemId=W._itemId,ve}be.to=De;function he(W,ve,je){if(ve=ve??W._sessionId,je=je??W._itemId,ve===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:je,kind:q.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:P.from(W.range),selectionRange:P.from(W.selectionRange),tags:W.tags?.map(N.from)}}be.from=he})(Wt||(e.TypeHierarchyItem=Wt={}));var _t;(function(be){function De(he){if(he)return{value:he.value,tooltip:he.tooltip}}be.from=De})(_t||(e.ViewBadge=_t={}));var Nt;(function(be){function De(je,qe,Be){const Ze=qe.fileData;return Ze?new n.$jN(new n.$kN(Ze.name,c.URI.revive(Ze.uri),Ze.id,(0,D.$db)(()=>Be(Ze.id)))):je===E.$zs.uriList&&qe.uriListData?new n.$iN(ve(qe.uriListData)):new n.$iN(qe.asString)}be.to=De;async function he(je,qe){const Be=await qe.asString();if(je===E.$zs.uriList)return{asString:Be,fileData:void 0,uriListData:W(Be)};const Ze=qe.asFile();return{asString:Be,fileData:Ze?{name:Ze.name,uri:Ze.uri,id:Ze._itemId??Ze.id}:void 0}}be.from=he;function W(je){return S.$Lt.split(je).map(qe=>{if(qe.startsWith("#"))return qe;try{return c.URI.parse(qe)}catch{}return qe})}function ve(je){return S.$Lt.create(je.map(qe=>typeof qe=="string"?qe:c.URI.revive(qe)))}})(Nt||(e.DataTransferItem=Nt={}));var Bt;(function(be){function De(W,ve){const je=W.items.map(([qe,Be])=>[qe,Nt.to(qe,Be,ve)]);return new n.$lN(je)}be.toDataTransfer=De;async function he(W){const ve={items:[]},je=[];for(const[qe,Be]of W)je.push((async()=>{ve.items.push([qe,await Nt.from(qe,Be)])})());return await Promise.all(je),ve}be.from=he})(Bt||(e.DataTransfer=Bt={}));var Ft;(function(be){function De(W,ve){return{kind:"reply",agentId:W.participant??ve?.agentId??"",subCommand:W.command??ve?.command,message:W.prompt,title:W.label}}be.from=De;function he(W){return{prompt:W.message,label:W.title,participant:W.agentId,command:W.subCommand}}be.to=he})(Ft||(e.ChatFollowup=Ft={}));var Gt;(function(be){function De(he){return"commandId"in he?{kind:"command",title:he.title??"",commandId:he.commandId??"",when:he.when??"",args:he.args}:{kind:"reply",message:he.message,title:he.title,tooltip:he.tooltip}}be.from=De})(Gt||(e.ChatInlineFollowup=Gt={}));var kt;(function(be){function De(W){switch(W.role){case 0:return new n.$xO(W.content);case 1:return new n.$yO(W.content);case 2:return new n.$zO(W.content)}}be.to=De;function he(W){if(W instanceof n.$xO)return{role:0,content:W.content};if(W instanceof n.$yO)return{role:1,content:W.content};if(W instanceof n.$zO)return{role:2,content:W.content};throw new Error("Invalid LanguageModelMessage")}be.from=he})(kt||(e.LanguageModelMessage=kt={}));var Lt;(function(be){function De(ve){const je={};for(const qe of Object.keys(ve))je[qe]=ve[qe].map(be.to);return je}be.objectTo=De;function he(ve){return{level:xt.to(ve.level),kind:ve.kind,value:(0,c.$wc)(ve.value)?c.URI.revive(ve.value):ve.value,description:ve.description}}be.to=he;function W(ve){return{level:xt.from(ve.level),kind:ve.kind,value:ve.value,description:ve.description}}be.from=W})(Lt||(e.ChatVariable=Lt={}));var xt;(function(be){function De(W){switch(W){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}be.to=De;function he(W){switch(W){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}be.from=he})(xt||(e.ChatVariableLevel=xt={}));var Jt;(function(be){function De(he){switch(he){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return n.InteractiveEditorResponseFeedbackKind.Bug}}be.to=De})(Jt||(e.InteractiveEditorResponseFeedbackKind=Jt={}));var Qt;(function(be){function De(W){return{kind:"markdownContent",content:T.from(W.value)}}be.to=De;function he(W){return new n.$pO(T.to(W.content))}be.from=he})(Qt||(e.ChatResponseMarkdownPart=Qt={}));var qt;(function(be){function De(W){const{value:ve,baseUri:je}=W;function qe(Be,Ze){return Be.map(st=>{const ft=c.URI.joinPath(Ze,st.name);return{label:st.name,uri:ft,children:st.children&&qe(st.children,ft)}})}return{kind:"treeData",treeData:{label:(0,m.$Sg)(je),uri:je,children:qe(ve,je)}}}be.to=De;function he(W){const ve=(0,$.$Rh)(W.treeData);function je(Ze){return Ze.map(st=>({name:st.label,children:st.children&&je(st.children)}))}const qe=ve.uri,Be=ve.children?je(ve.children):[];return new n.$qO(Be,qe)}be.from=he})(qt||(e.ChatResponseFilesPart=qt={}));var Xt;(function(be){function De(W){return{kind:"inlineReference",name:W.title,inlineReference:c.URI.isUri(W.value)?W.value:I.from(W.value)}}be.to=De;function he(W){const ve=(0,$.$Rh)(W);return new n.$rO(c.URI.isUri(ve.inlineReference)?ve.inlineReference:I.to(ve.inlineReference),W.name)}be.from=he})(Xt||(e.ChatResponseAnchorPart=Xt={}));var en;(function(be){function De(W){return{kind:"progressMessage",content:T.from(W.value)}}be.to=De;function he(W){return new n.$sO(W.content.value)}be.from=he})(en||(e.ChatResponseProgressPart=en={}));var Ht;(function(be){function De(W,ve,je){return{kind:"command",command:ve.toInternal(W.value,je)??{command:W.value.command,title:W.value.title}}}be.to=De;function he(W,ve){return new n.$tO(ve.fromInternal(W.command)??{command:W.command.id,title:W.command.title})}be.from=he})(Ht||(e.ChatResponseCommandButtonPart=Ht={}));var It;(function(be){function De(W){return"variableName"in W.value?{kind:"reference",reference:{variableName:W.value.variableName,value:c.URI.isUri(W.value.value)||!W.value.value?W.value.value:I.from(W.value.value)}}:{kind:"reference",reference:c.URI.isUri(W.value)?W.value:I.from(W.value)}}be.to=De;function he(W){const ve=(0,$.$Rh)(W),je=qe=>c.URI.isUri(qe)?qe:I.to(qe);return new n.$uO("variableName"in ve.reference?{variableName:ve.reference.variableName,value:ve.reference.value&&je(ve.reference.value)}:je(ve.reference))}be.from=he})(It||(e.ChatResponseReferencePart=It={}));var Zt;(function(be){function De(ve,je,qe){return ve instanceof n.$pO?Qt.to(ve):ve instanceof n.$rO?Xt.to(ve):ve instanceof n.$uO?It.to(ve):ve instanceof n.$sO?en.to(ve):ve instanceof n.$qO?qt.to(ve):ve instanceof n.$tO?Ht.to(ve,je,qe):{kind:"content",content:""}}be.to=De;function he(ve,je){switch(ve.kind){case"reference":return It.from(ve);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return W(ve,je)}}be.from=he;function W(ve,je){switch(ve.kind){case"markdownContent":return Qt.from(ve);case"inlineReference":return Xt.from(ve);case"progressMessage":return;case"treeData":return qt.from(ve);case"command":return Ht.from(ve,je)}}be.fromContent=W})(Zt||(e.ChatResponsePart=Zt={}));var Ut;(function(be){function De(W,ve){return"markdownContent"in ve?((0,s.$cG)(W,"chatParticipantAdditions"),{content:T.from(ve.markdownContent),kind:"markdownContent"}):"content"in ve?"vulnerabilities"in ve&&ve.vulnerabilities?((0,s.$cG)(W,"chatParticipantAdditions"),{content:ve.content,vulnerabilities:ve.vulnerabilities,kind:"vulnerability"}):typeof ve.content=="string"?{content:ve.content,kind:"content"}:((0,s.$cG)(W,"chatParticipantAdditions"),{content:T.from(ve.content),kind:"markdownContent"}):"documents"in ve?{documents:ve.documents.map(je=>({uri:je.uri,version:je.version,ranges:je.ranges.map(qe=>P.from(qe))})),kind:"usedContext"}:"reference"in ve?{reference:"uri"in ve.reference?{uri:ve.reference.uri,range:P.from(ve.reference.range)}:ve.reference,kind:"reference"}:"inlineReference"in ve?{inlineReference:"uri"in ve.inlineReference?{uri:ve.inlineReference.uri,range:P.from(ve.inlineReference.range)}:ve.inlineReference,name:ve.title,kind:"inlineReference"}:"participant"in ve?((0,s.$cG)(W,"chatParticipantAdditions"),{agentId:ve.participant,command:ve.command,kind:"agentDetection"}):"message"in ve?{content:T.from(ve.message),kind:"progressMessage"}:void 0}be.from=De;function he(W,ve){switch(W.kind){case"markdownContent":return{content:W.content.value};case"inlineReference":return{inlineReference:(0,c.$wc)(W.inlineReference)?c.URI.revive(W.inlineReference):I.to(W.inlineReference),title:W.name};case"command":return{command:ve.fromInternal(W.command)??{command:W.command.id,title:W.command.title}};default:return}}be.toProgressContent=he})(Ut||(e.ChatResponseProgress=Ut={}));var on;(function(be){function De(he){return{prompt:he.message,command:he.command,variables:he.variables.variables.map(cn.to),location:an.to(he.location)}}be.to=De})(on||(e.ChatAgentRequest=on={}));var an;(function(be){function De(he){switch(he){case l.ChatAgentLocation.Notebook:return n.ChatLocation.Notebook;case l.ChatAgentLocation.Terminal:return n.ChatLocation.Terminal;case l.ChatAgentLocation.Panel:return n.ChatLocation.Panel;case l.ChatAgentLocation.Editor:return n.ChatLocation.Editor}}be.to=De})(an||(e.ChatLocation=an={}));var cn;(function(be){function De(he){return{name:he.name,range:he.range&&[he.range.start,he.range.endExclusive],values:he.values.map(Lt.to)}}be.to=De})(cn||(e.ChatAgentResolvedVariable=cn={}));var tn;(function(be){function De(he){return{label:he.label,values:he.values.map(Lt.from),insertText:he.insertText,detail:he.detail,documentation:he.documentation}}be.from=De})(tn||(e.ChatAgentCompletionItem=tn={}));var Yt;(function(be){function De(he){return{errorDetails:he.errorDetails,metadata:he.metadata}}be.to=De})(Yt||(e.ChatAgentResult=Yt={}));var ln;(function(be){function De(he,W,ve){if(W.action.kind==="vote")return;const je=Yt.to(he);return W.action.kind==="command"?{action:{kind:"command",commandButton:Ut.toProgressContent(W.action.commandButton,ve)},result:je}:W.action.kind==="followUp"?{action:{kind:"followUp",followup:Ft.to(W.action.followup)},result:je}:{action:W.action,result:je}}be.to=De})(ln||(e.ChatAgentUserActionEvent=ln={}));var At;(function(be){function De(he,W,ve){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:W.toInternal(he,ve)}be.from=De})(At||(e.TerminalQuickFix=At={}));var nn;(function(be){function De(he){return{kind:gt.to(he.kind)}}be.to=De})(nn||(e.PartialAcceptInfo=nn={}));var gt;(function(be){function De(he){switch(he){case 0:return n.PartialAcceptTriggerKind.Word;case 1:return n.PartialAcceptTriggerKind.Line;case 2:return n.PartialAcceptTriggerKind.Suggest;default:return n.PartialAcceptTriggerKind.Unknown}}be.to=De})(gt||(e.PartialAcceptTriggerKind=gt={}));var rn;(function(be){function De(he,W){return{id:W,label:he.label,description:he.description,canEdit:he.canEdit,collapsibleState:he.collapsibleState||0,contextValue:he.contextValue}}be.from=De})(rn||(e.DebugTreeItem=rn={}))}),define(Ee[293],ke([1,0,44,135,72,134,94,141,3]),function(le,e,i,A,S,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.$2O=e.$1O=e.$ZO=void 0;const $=(f,h,l,t)=>{let a=h;return{enumerable:!0,configurable:!1,get(){return a},set(o){if(!l(a,o)){const r=a;a=o,f.listener?.(t(o,r))}}}},E=(f,h)=>f===h,y={range:(f,h)=>f===h?!0:!f||!h?!1:f.isEqual(h),label:E,description:E,sortText:E,busy:E,error:E,canResolveChildren:E,tags:(f,h)=>!(f.length!==h.length||f.some(l=>!h.find(t=>l.id===t.id)))},w=f=>h=>({op:4,update:f(h)}),m=(f,h)=>({range:(()=>{let l;const t=w(a=>({range:i.$ct.lift(k.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return l},set(a){f.listener?.({op:6}),y.range(l,a)||(l=a,f.listener?.(t(a)))}}})(),label:$(f,h,y.label,w(l=>({label:l}))),description:$(f,void 0,y.description,w(l=>({description:l}))),sortText:$(f,void 0,y.sortText,w(l=>({sortText:l}))),canResolveChildren:$(f,!1,y.canResolveChildren,l=>({op:2,state:l})),busy:$(f,!1,y.busy,w(l=>({busy:l}))),error:$(f,void 0,y.error,w(l=>({error:k.MarkdownString.fromStrict(l)||null}))),tags:$(f,[],y.tags,(l,t)=>({op:1,new:l.map(k.TestTag.from),old:t.map(k.TestTag.from)}))}),d=f=>{const h=S.$dL.fromString(f.extId),l=new g(h.controllerId,h.localId,f.label,v.URI.revive(f.uri)||void 0);return l.range=k.Range.to(f.range||void 0),l.description=f.description||void 0,l.sortText=f.sortText||void 0,l.tags=f.tags.map(t=>k.TestTag.to({id:(0,C.$jL)(t).tagId})),l},c=f=>{let h;for(const l of f.tests){const t=d(l.item);(0,A.$JO)(t).parent=h,h=t}return h};e.$ZO=c;class g{constructor(h,l,t,a){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const o=(0,A.$IO)(this,h);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof u?void 0:o.parent}},children:{value:(0,D.$HO)(o,A.$JO,g),enumerable:!0,writable:!1},...m(o,t)})}}e.$1O=g;class u extends g{constructor(h,l){super(h,h,l,void 0),this._isRoot=!0}}e.$2O=u;class p extends D.$DO{constructor(h,l,t){super({controllerId:h,getDocumentVersion:a=>a&&t.getDocument(a)?.version,getApiFor:A.$JO,getChildren:a=>a.children,root:new u(h,l),toITestItem:k.TestItem.from})}}e.$3O=p}),define(Ee[294],ke([1,0,11,140,141,21,291,18,13,53,44,78,3,2,5,275,293,14,138,40,61,39,287,22]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f,h,l,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=void 0;let o=class{#e;#t;#n;constructor(I,O,R){this.b=new Map,this.c=new Map,this.#e=I.getProxy(C.$rM.MainThreadCommands),this.d=O,this.#n=R,this.#t=I.getProxy(C.$rM.MainThreadTelemetry),this.converter=new r(this,j=>{const B=this.c.get(j);return B?.result===n.Void?B:void 0},O),this.f=[{processArgument(j){return(0,$.$Rh)(j)}},{processArgument(j){return(0,D.$Qn)(j,function(B){if(E.$ct.isIRange(B))return S.Range.to(B);if(y.$bt.isIPosition(B))return S.Position.to(B);if(E.$ct.isIRange(B.range)&&w.URI.isUri(B.uri))return S.location.to(B);if(B instanceof u.$ue)return B.buffer.buffer;if(!Array.isArray(B))return B})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const O=this.registerCommand(!1,I.id,async(...R)=>{const j=I.args.map((Y,fe)=>{if(!Y.validate(R[fe]))throw new Error(`Invalid argument '${Y.name}' when running '${I.id}', received: ${typeof R[fe]=="object"?JSON.stringify(R[fe],null,"	"):R[fe]} `);return Y.convert(R[fe])}),B=await this.executeCommand(I.internalId,...j);return I.result.convert(B,R,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new A.$tM(()=>{O.dispose(),this.c.delete(I.id)})}registerCommand(I,O,R,j,B,Y){if(this.d.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this.b.has(O))throw new Error(`command '${O}' already exists`);return this.b.set(O,{callback:R,thisArg:j,metadata:B,extension:Y}),I&&this.#e.$registerCommand(O),new A.$tM(()=>{this.b.delete(O)&&I&&this.#e.$unregisterCommand(O)})}executeCommand(I,...O){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,O,!0)}async g(I,O,R){if(this.b.has(I))return this.#e.$fireCommandActivationEvent(I),this.h(I,O,!1);{let j=!1;const B=(0,D.$Qn)(O,function(Y){if(Y instanceof A.$uM)return S.Position.from(Y);if(Y instanceof A.$vM)return S.Range.from(Y);if(Y instanceof A.$FM)return S.location.from(Y);if(A.$UN.isNotebookRange(Y))return S.NotebookRange.from(Y);if(Y instanceof ArrayBuffer)return j=!0,u.$ue.wrap(new Uint8Array(Y));if(Y instanceof Uint8Array)return j=!0,u.$ue.wrap(Y);if(Y instanceof u.$ue)return j=!0,Y;if(!Array.isArray(Y))return Y});try{const Y=await this.#e.$executeCommand(I,j?new p.$ew(B):B,R);return(0,$.$Rh)(Y)}catch(Y){if(Y instanceof Error&&Y.message==="$executeCommand:retry")return this.g(I,O,!1);throw Y}}}async h(I,O,R){const j=this.b.get(I);if(!j)throw new Error("Unknown command");const{callback:B,thisArg:Y,metadata:fe}=j;if(fe?.args)for(let re=0;re<fe.args.length;re++)try{(0,i.$ag)(O[re],fe.args[re].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${fe.args[re].name}' - ${fe.args[re].description}`)}const ue=h.$3d.create();try{return await B.apply(Y,O)}catch(re){if(I===this.converter.delegatingCommandId){const te=this.converter.getActualCommand(...O);te&&(I=te.command)}if(this.d.error(re,I,j.extension?.identifier),!R)throw re;if(j.extension?.identifier){const te=this.#n.onExtensionError(j.extension.identifier,re);this.d.trace("forwarded error to extension?",te,j.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.$6i)(re)),this.id=I,this.source=j.extension?.displayName??j.extension?.name}}}finally{this.j(j,I,ue.elapsed())}}j(I,O,R){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new l.$4o(O),duration:R})}$executeContributedCommand(I,...O){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const R=this.b.get(I);return R?(O=O.map(j=>this.f.reduce((B,Y)=>Y.processArgument(B,R.extension?.identifier),j)),this.h(I,O,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(O=>(I&&(O=O.filter(R=>R[0]!=="_")),O))}$getContributedCommandMetadata(){const I=Object.create(null);for(const[O,R]of this.b){const{metadata:j}=R;j&&(I[O]=j)}return Promise.resolve(I)}};e.$9O=o,e.$9O=o=Le([Re(0,c.$NO),Re(1,v.$Oj),Re(2,t.$8O)],o),e.$0O=(0,d.$ii)("IExtHostCommands");class r{constructor(I,O,R){this.d=I,this.f=O,this.g=R,this.delegatingCommandId=`__vsc${(0,a.$Eg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,O){if(!I)return;const R={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return R;const j=this.f(I.command);if(j)R.id=j.internalId,R.arguments=j.args.map((B,Y)=>B.convert(I.arguments&&I.arguments[Y]));else if((0,k.$Lb)(I.arguments)){const B=`${I.command} /${++this.c}`;this.b.set(B,I),O.add((0,m.$Sc)(()=>{this.b.delete(B),this.g.trace("CommandsConverter#DISPOSE",B)})),R.$ident=B,R.id=this.delegatingCommandId,R.arguments=[B],this.g.trace("CommandsConverter#CREATE",I.command,B)}return R}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const O=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],O?O.command:"MISSING"),O?this.d.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$$O=r;class s{static{this.Uri=new s("uri","Uri of a text document",I=>w.URI.isUri(I),I=>I)}static{this.Position=new s("position","A position in a text document",I=>A.$uM.isPosition(I),S.Position.from)}static{this.Range=new s("range","A range in a text document",I=>A.$vM.isRange(I),S.Range.from)}static{this.Selection=new s("selection","A selection in a text document",I=>A.$wM.isSelection(I),S.Selection.from)}static{this.Number=new s("number","",I=>typeof I=="number",I=>I)}static{this.String=new s("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=s.Arr(s.String)}static Arr(I){return new s(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,O=>Array.isArray(O)&&O.every(R=>I.validate(R)),O=>O.map(R=>I.convert(R)))}static{this.CallHierarchyItem=new s("item","A call hierarchy item",I=>I instanceof A.$QM,S.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",I=>I instanceof A.$cO,S.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VS Code TestItem",I=>I instanceof g.$1O,S.TestItem.from)}constructor(I,O,R,j){this.name=I,this.description=O,this.validate=R,this.convert=j}optional(){return new s(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,O){return new s(I??this.name,O??this.description,this.validate,this.convert)}}e.$_O=s;class n{static{this.Void=new n("no result",I=>I)}constructor(I,O){this.description=I,this.convert=O}}e.$aP=n;class b{constructor(I,O,R,j,B){this.id=I,this.internalId=O,this.description=R,this.args=j,this.result=B}}e.$bP=b}),define(Ee[295],ke([1,0,10,2,12,227]),function(le,e,i,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0,e.$VP="remoteFilesystem";class C extends D.$UP{static register(v,$,E){const y=v.getConnection();if(!y)return A.$Uc.None;const w=new A.$Tc,m=(async()=>{try{const d=await v.getRawEnvironment();d?$.registerProvider(S.Schemas.vscodeRemote,w.add(new C(d,y))):E.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(d){E.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,i.$0)(d))}})();return w.add($.onWillActivateFileSystemProvider(d=>{d.scheme===S.Schemas.vscodeRemote&&d.join(m)})),w}constructor(v,$){super($.getChannel(e.$VP),{pathCaseSensitive:v.os===3})}}e.$WP=C}),define(Ee[73],ke([1,0,89,77,29,296,14,10,6,2,7,4,22,45,107]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$_h=e.$$h=e.$0h=void 0,e.$ai=o,e.$bi=r,e.$di=b,e.$ei=P;class c{traceSocketEvent(O,R){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,O,R)}constructor(O,R=""){this.f=!0,this.debugLabel=R,this.socket=O,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,k.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(O){const R=j=>{this.traceSocketEvent("read",j),O(C.$ue.wrap(j))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(O){const R=j=>{O({type:0,hadError:j,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(O){const R=()=>{O()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(O){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",O),this.socket.write(O.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,k.$1)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,k.$1)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((O,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),O();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),O()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$0h=c;var g;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var u;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(u||(u={}));class p extends $.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(O,R){this.socket.traceSocketEvent(O,R)}constructor(O,R,j,B){super(),this.f=this.B(new v.$7d),this.g=this.B(new v.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=O,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:j?.byteLength||0,recordInflateBytes:B}),this.a=this.B(new f(this,R,j,B,this.f,(Y,fe)=>this.m(Y,fe))),this.B(this.a.onError(Y=>{console.error(Y),(0,k.$1)(Y),this.g.fire({type:0,hadError:!0,error:Y})})),this.b=new d.$5h,this.B(this.socket.onData(Y=>this.n(Y))),this.B(this.socket.onClose(async Y=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(Y)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(O){return this.f.event(O)}onClose(O){return this.g.event(O)}onEnd(O){return this.socket.onEnd(O)}write(O){let R=0;for(;R<O.byteLength;)this.a.writeMessage(O.slice(R,Math.min(R+262144,O.byteLength)),{compressed:!0,opcode:2}),R+=262144}m(O,{compressed:R,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",O);let B=2;O.byteLength<126?B+=0:O.byteLength<2**16?B+=2:B+=8;const Y=C.$ue.alloc(B),fe=R?64:0,ue=j&15;if(Y.writeUInt8(128|fe|ue,0),O.byteLength<126)Y.writeUInt8(O.byteLength,1);else if(O.byteLength<2**16){Y.writeUInt8(126,1);let re=1;Y.writeUInt8(O.byteLength>>>8&255,++re),Y.writeUInt8(O.byteLength>>>0&255,++re)}else{Y.writeUInt8(127,1);let re=1;Y.writeUInt8(0,++re),Y.writeUInt8(0,++re),Y.writeUInt8(0,++re),Y.writeUInt8(0,++re),Y.writeUInt8(O.byteLength>>>24&255,++re),Y.writeUInt8(O.byteLength>>>16&255,++re),Y.writeUInt8(O.byteLength>>>8&255,++re),Y.writeUInt8(O.byteLength>>>0&255,++re)}this.socket.write(C.$ue.concat([Y,O]))}end(){this.h=!0,this.socket.end()}n(O){if(O.byteLength!==0){for(this.b.acceptChunk(O);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const R=this.b.peek(this.j.readLen),j=R.readUInt8(0),B=(j&128)>>>7,Y=(j&64)>>>6,fe=j&15,ue=R.readUInt8(1),re=(ue&128)>>>7,te=ue&127;this.j.state=2,this.j.readLen=2+(re?4:0)+(te===126?2:0)+(te===127?8:0),this.j.fin=B,this.j.firstFrameOfMessage&&(this.j.compressed=!!Y),this.j.firstFrameOfMessage=!!B,this.j.mask=0,this.j.opcode=fe,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const R=this.b.read(this.j.readLen),j=R.readUInt8(1),B=(j&128)>>>7;let Y=j&127,fe=1;Y===126?Y=R.readUInt8(++fe)*2**8+R.readUInt8(++fe):Y===127&&(Y=R.readUInt8(++fe)*0+R.readUInt8(++fe)*0+R.readUInt8(++fe)*0+R.readUInt8(++fe)*0+R.readUInt8(++fe)*2**24+R.readUInt8(++fe)*2**16+R.readUInt8(++fe)*2**8+R.readUInt8(++fe));let ue=0;B&&(ue=R.readUInt8(++fe)*2**24+R.readUInt8(++fe)*2**16+R.readUInt8(++fe)*2**8+R.readUInt8(++fe)),this.j.state=3,this.j.readLen=Y,this.j.mask=ue,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const R=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),t(R,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$$h=p;class f extends $.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$ue.alloc(0)}constructor(O,R,j,B,Y,fe){super(),this.n=O,this.r=Y,this.s=fe,this.a=this.B(new v.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new h(this.n,B,j,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(ue=>this.a.fire(ue))),this.B(this.f.onError(ue=>this.a.fire(ue)))):(this.b=null,this.f=null)}writeMessage(O,R){this.g.push({data:O,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:O,options:R}=this.g.shift();if(this.f&&R.compressed){const j=await this.w(this.f,O);this.s(j,R)}else this.s(O,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(O,R){return new Promise((j,B)=>{O.write(R),O.flush(Y=>j(Y))})}acceptFrame(O,R,j){this.h.push({data:O,isCompressed:R,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const O=this.h.shift();if(this.b&&O.isCompressed){const R=await this.C(this.b,O.data,O.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(O.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(O,R,j){return new Promise((B,Y)=>{O.write(R),j&&O.write(C.$ue.fromByteArray([0,0,255,255])),O.flush(fe=>B(fe))})}}class h extends $.$Uc{get recordedInflateBytes(){return this.j?C.$ue.concat(this.f):C.$ue.alloc(0)}constructor(O,R,j,B){super(),this.h=O,this.j=R,this.a=this.B(new v.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(B),this.b.on("error",Y=>{this.h.traceSocketEvent("zlibInflateError",{message:Y?.message,code:Y?.code}),this.a.fire(Y)}),this.b.on("data",Y=>{this.h.traceSocketEvent("zlibInflateData",Y),this.g.push(C.$ue.wrap(Y))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(O){this.j&&this.f.push(O.clone()),this.h.traceSocketEvent("zlibInflateWrite",O),this.b.write(O.buffer)}flush(O){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const R=C.$ue.concat(this.g);this.g.length=0,O(R)})}}class l extends $.$Uc{constructor(O,R){super(),this.g=O,this.a=this.B(new v.$7d),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(C.$ue.wrap(j))})}write(O){this.g.traceSocketEvent("zlibDeflateWrite",O.buffer),this.b.write(O.buffer)}flush(O){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let R=C.$ue.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),O(R)})}}function t(I,O){if(O===0)return;const R=I.byteLength>>>2;for(let re=0;re<R;re++){const te=I.readUInt32BE(re*4);I.writeUInt32BE(te^O,re*4)}const j=R*4,B=I.byteLength-j,Y=O>>>24&255,fe=O>>>16&255,ue=O>>>8&255;B>=1&&I.writeUInt8(I.readUInt8(j)^Y,j),B>=2&&I.writeUInt8(I.readUInt8(j+1)^fe,j+1),B>=3&&I.writeUInt8(I.readUInt8(j+2)^ue,j+2)}e.$_h=process.env.XDG_RUNTIME_DIR;const a={2:107,1:103};function o(){const I=(0,w.$Eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const O=process.platform!=="darwin"&&e.$_h?e.$_h:(0,S.tmpdir)(),R=(0,E.$kc)(O,`vscode-ipc-${I}.sock`);return s(R),R}function r(I,O,R){const B=(0,i.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${B}-${R}-${O}-sock`;const Y=R.substr(0,4),fe=O.substr(0,6);let ue;return process.platform!=="darwin"&&e.$_h&&!process.env.VSCODE_PORTABLE?ue=(0,E.$kc)(e.$_h,`vscode-${B}-${Y}-${fe}.sock`):ue=(0,E.$kc)(I,`${Y}-${fe}.sock`),s(ue),ue}function s(I){const O=a[y.$u];typeof O=="number"&&I.length>=O&&console.warn(`WARNING: IPC handle "${I}" is longer than ${O} chars, try a shorter --user-data-dir`)}class n extends m.$Yh{static b(O){const R=v.Event.fromNodeEventEmitter(O,"connection");return v.Event.map(R,j=>({protocol:new d.$6h(new c(j,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(j,"close"))}))}constructor(O){super(n.b(O)),this.d=O}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ci=n;function b(I){return new Promise((O,R)=>{const j=(0,A.createServer)();j.on("error",R),j.listen(I,()=>{j.removeListener("error",R),O(new n(j))})})}function P(I,O){return new Promise((R,j)=>{const B=(0,A.createConnection)(I,()=>{B.removeListener("error",j),R(d.$7h.fromSocket(new c(B,`ipc-client${O}`),O))});B.once("error",j)})}}),define(Ee[142],ke([1,0,86,15,14,10,11,25,26,87,13,48,245,296]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0,e.$Ir=g;let d=class extends y.$Ap{constructor(p,f,h,l){super(l),this.m=p,this.n=f,this.r=h,this.s(),this.B(p.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,f){const{f:h,g:l}=this;let t;try{t=await(0,$.$sm)(this.m,this.r,this.n.args,process.env)}catch(r){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$0)(r)))}const a={...process.env,...t},o=p.agent?p.agent:await(0,w.$Gr)(p.url||"",a,{proxyUrl:h,strictSSL:l});return p.agent=o,p.strictSSL=l,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>g(p,f))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((f,h)=>{le(["@vscode/proxy-agent"],f,h)})).loadSystemCertificates({log:this.r})}};e.$Hr=d,e.$Hr=d=Le([Re(0,k.$Oi),Re(1,v.$qi),Re(2,E.$Oj),Re(3,E.$Pj)],d);async function c(u){return((0,i.parse)(u.url).protocol==="https:"?await new Promise((h,l)=>{le(["https"],h,l)}):await new Promise((h,l)=>{le(["http"],h,l)})).request}async function g(u,p){return A.Promises.withAsyncBody(async(f,h)=>{const l=(0,i.parse)(u.url),t=u.getRawRequest?u.getRawRequest(u):await c(u),a={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,C.$2f)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(a.auth=u.user+":"+u.password);const o=t(a,r=>{const s=(0,C.$Zf)(u.followRedirects)?u.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)g({...u,url:r.headers.location,followRedirects:s-1},p).then(f,h);else{let n=r;!u.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(n=r.pipe((0,m.createGunzip)())),f({res:r,stream:(0,S.$Je)(n)})}});o.on("error",h),u.timeout&&o.setTimeout(u.timeout),u.isChromiumNetwork&&o.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&o.write(u.data),o.end(),p.onCancellationRequested(()=>{o.abort(),h(new D.$5)})})}}),define(Ee[143],ke([1,0,55,77,132,12,7,14,6,73,87,13,50,4,66,131,2,285,25]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$bn=f;async function f(r={},s,n,b,P,I){const O=await(0,S.$Yl)(n,b.userDataPath);let R={};if(s)try{R=await(0,E.$sm)(I,P,b.args,process.env)}catch(re){P.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",re)}const B={...process.env,...R,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(O,void 0,0),...r},Y=b.isBuilt?(0,C.$kc)(b.appRoot,"bin"):(0,C.$kc)(b.appRoot,"resources","server","bin-dev"),fe=(0,C.$kc)(Y,"remote-cli");let ue=t(B,"PATH");return ue?ue=fe+C.$uc+ue:ue=fe,a(B,"PATH",ue),b.args["without-browser-env-var"]||(B.BROWSER=(0,C.$kc)(Y,"helpers",m.$i?"browser.cmd":"browser.sh")),o(B),B}class h{constructor(s,n){this.socket=s,this.initialDataChunk=n}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let s,n,b;return this.socket instanceof $.$0h?(s=!0,n=!1,b=k.$ue.alloc(0)):(s=!1,n=this.socket.permessageDeflate,b=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:s,permessageDeflate:n,inflateBytes:b.buffer.toString("base64")}}}let l=class{constructor(s,n,b,P,I,O,R,j){this.i=s,this.j=I,this.l=O,this.m=R,this.n=j,this.b=new v.$7d,this.onClose=this.b.event,this.c=!m.$i||!this.j.args["socket-path"],this.d=!1,this.f=n,this.g=null,this.h=new h(b,P),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(s){this.l.info(`${this.o}${s}`)}q(s){this.l.error(`${this.o}${s}`)}async r(s,n){const b=new g.$Tc;b.add(n.socket),b.add((0,g.$Sc)(()=>{s.destroy()}));const P=()=>{b.dispose()};b.add(n.socket.onEnd(P)),b.add(n.socket.onClose(P)),b.add(v.Event.fromNodeEventEmitter(s,"end")(P)),b.add(v.Event.fromNodeEventEmitter(s,"close")(P)),b.add(v.Event.fromNodeEventEmitter(s,"error")(P)),b.add(n.socket.onData(I=>s.write(I.buffer))),b.add(v.Event.fromNodeEventEmitter(s,"data")(I=>{n.socket.write(k.$ue.wrap(I))})),n.initialDataChunk.byteLength>0&&s.write(n.initialDataChunk.buffer)}async s(s,n){await n.socketDrain();const b=n.toIExtHostSocketMessage();let P;n.socket instanceof $.$0h?P=n.socket.socket:P=n.socket.socket.socket,s.send(b,P)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const s={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(s)}acceptReconnection(s,n,b){this.f=s,this.p("The client has reconnected.");const P=new h(n,b);if(!this.g){this.h=P;return}this.s(this.g,P)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(s){try{let n=process.execArgv?process.execArgv.filter(fe=>!/^--inspect(-brk)?=/.test(fe)):[];s.port&&!process.pkg&&(n=[`--inspect${s.break?"-brk":""}=${s.port}`]);const b=await f(s.env,!0,s.language,this.j,this.l,this.n);(0,d.$_l)(b);let P;if(this.c)(0,u.$_m)(new u.$0m,b),P=null;else{const{namedPipeServer:fe,pipeName:ue}=await this.u();(0,u.$_m)(new u.$9m(ue),b),P=fe}const I={env:b,execArgv:n,silent:!0};I.execArgv.unshift("--dns-result-order=ipv4first");const O=["--type=extensionHost","--transformURIs"],R=this.j.args["use-host-proxy"];O.push(`--useHostProxy=${R?"true":"false"}`),this.g=i.fork(D.$Cg.asFileUri("bootstrap-fork").fsPath,O,I);const j=this.g.pid;this.p(`<${j}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const B=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),Y=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(B(fe=>this.p(`<${j}> ${fe}`)),Y(fe=>this.p(`<${j}><stderr> ${fe}`)),this.g.on("error",fe=>{this.q(`<${j}> Extension Host Process had an error`),this.l.error(fe),this.t()}),this.g.on("exit",(fe,ue)=>{this.m.setExitInfo(this.i,{code:fe,signal:ue}),this.p(`<${j}> Extension Host Process exited with code: ${fe}, signal: ${ue}.`),this.t()}),P)P.on("connection",fe=>{P.close(),this.r(fe,this.h)});else{const fe=ue=>{ue.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",fe),this.s(this.g,this.h),this.h=null)};this.g.on("message",fe)}}catch(n){console.error("ExtensionHostConnection errored"),n&&console.error(n)}}u(){return new Promise((s,n)=>{const b=(0,$.$ai)(),P=A.createServer();P.on("error",n),P.listen(b,()=>{P?.removeListener("error",n),s({pipeName:b,namedPipeServer:P})})})}};e.$cn=l,e.$cn=l=Le([Re(4,w.$Ym),Re(5,y.$Oj),Re(6,c.$7m),Re(7,p.$Oi)],l);function t(r,s){const n=Object.keys(r).filter(P=>P.toLowerCase()===s.toLowerCase()),b=n.length>0?n[0]:s;return r[b]}function a(r,s,n){const b=Object.keys(r).filter(I=>I.toLowerCase()===s.toLowerCase()),P=b.length>0?b[0]:s;r[P]=n}function o(r){for(const s of Object.keys(r))r[s]===null&&delete r[s]}}),define(Ee[297],ke([1,0,83,13,68,118,25,48,142,39,28,31,129,127,88,112,58,2,113,69,12,16,32,50,121,84,122,10,3,7,30,243,82,34,126,67,4,59,133,33,49,70,130,128,115,116,208,298]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f,h,l,t,a,o,r,s,n,b,P,I,O,R,j,B,Y,fe,ue,re,te,V,T,x,Z,G,se,ce,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=q;class $e extends u.$Uc{constructor(z,X){super(),this.a=z,this.b=X,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const z=await this.f();await z.invokeFunction(async X=>{const ae=X.get(C.$Oi),Q=X.get(A.$Oj);fe.$i&&(ae.getValue("security.restrictUNCAccess")===!1?(0,ne.disableUNCAccessRestrictions)():(0,ne.addUNCHostToAllowlist)(ae.getValue("security.allowedUNCHosts")));try{await this.g(z.createInstance(o.$Zp,new A.$Wj(Q.getLevel(),!1)))}catch(J){throw Q.error(J),console.error((0,n.$0)(J)),J}})}async f(){const z=new i.$gi,X={_serviceBrand:void 0,...g.default};z.set(t.$8j,X);const ae=new a.$Zm(this.a,X);z.set(a.$Ym,ae);const Q=new se.$2P((0,A.$3j)(ae),ae.logsHome);z.set(A.$Pj,Q);const J=new G.$_P(this.B(Q.createLogger("remoteCLI",{name:(0,ce.localize)(0,null)})));z.set(A.$Oj,J),J.trace(`Remote configuration data at ${this.b}`),J.trace("process arguments:",this.a);const U=this.B(new p.$uq(J));z.set(l.$Ok,U),U.registerProvider(h.Schemas.file,this.B(new f.$Vq(J)));const L=new B.$js(U);z.set(j.$ml,L);const H=this.B(new x.$0P(L,ae,U,J));z.set(te.$ol,H);const _=this.B(new D.$so(H.defaultProfile.settingsResource,U,new T.$5n,J));return z.set(C.$Oi,_),await Promise.all([_.initialize(),H.init()]),z.set(k.$zp,new S.$fi(v.$Hr)),z.set(R.$wo,new S.$fi(O.$oQ)),z.set(E.$Nl,$.$6o),z.set(y.$Ro,new S.$fi(w.$Wp)),z.set(V.$bq,new S.$fi(Z.$$P)),z.set(ue.$fq,new S.$fi(re.$XP)),z.set(d.$Xp,new S.$fi(d.$Yp)),z.set(m.$pq,new S.$fi(m.$qq)),z.set(r.$Br,new S.$fi(s.$Dr)),new c.$Yq(z)}async g(z){if(this.a["list-extensions"])return z.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const X={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return z.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),X,!!this.a.force)}else{if(this.a["uninstall-extension"])return z.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return z.updateExtensions();if(this.a["locate-extension"])return z.locateExtension(this.a["locate-extension"])}}h(z){return z.map(X=>/\.vsix$/i.test(X)?b.URI.file((0,P.$jc)(X)?X:(0,P.$kc)((0,I.cwd)(),X)):X)}}function K(N){setTimeout(()=>process.exit(N),0)}async function q(N,z,X){if(N.help){const Q=g.default.serverApplicationName+(fe.$i?".cmd":"");console.log((0,Y.$hm)(g.default.nameLong,Q,g.default.version,X,{noInputFiles:!0,noPipe:!0}));return}if(N.version){console.log((0,Y.$im)(g.default.version,g.default.commit));return}const ae=new $e(N,z);try{await ae.run(),K(0)}catch{K(1)}finally{ae.dispose()}}}),define(Ee[299],ke([1,0,73,311,27,294,3,13,92]),function(le,e,i,A,S,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=void 0;class ${constructor(w,m,d){this.b=w,this.c=m,this.f=d,this.a=A.createServer((c,g)=>this.h(c,g)),this.g().catch(c=>(m.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,m){const d=(g,u)=>{m.writeHead(g,{"content-type":"application/json"}),m.end(JSON.stringify(u||null),p=>p&&this.c.error(p))},c=[];w.setEncoding("utf8"),w.on("data",g=>c.push(g)),w.on("end",async()=>{try{const g=JSON.parse(c.join(""));let u;switch(g.type){case"open":u=await this.i(g);break;case"openExternal":u=await this.j(g);break;case"status":u=await this.l(g);break;case"extensionManagement":u=await this.k(g);break;default:d(404,`Unknown message type: ${g.type}`);break}d(200,u)}catch(g){const u=g instanceof Error?g.message:JSON.stringify(g);d(500,u),this.c.error("Error while processing pipe request",g)}})}async i(w){const{fileURIs:m,folderURIs:d,forceNewWindow:c,diffMode:g,mergeMode:u,addMode:p,forceReuseWindow:f,gotoLineMode:h,waitMarkerFilePath:l,remoteAuthority:t}=w,a=[];if(Array.isArray(d))for(const n of d)try{a.push({folderUri:C.URI.parse(n)})}catch{}if(Array.isArray(m))for(const n of m)try{(0,v.$Ni)(n)?a.push({workspaceUri:C.URI.parse(n)}):a.push({fileUri:C.URI.parse(n)})}catch{}const o=l?C.URI.file(l):void 0,s={forceNewWindow:c,diffMode:g,mergeMode:u,addMode:p,gotoLineMode:h,forceReuseWindow:f,preferNewWindow:!f&&!o&&!p,waitMarkerFileURI:o,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",a,s)}async j(w){for(const m of w.uris){const d=C.URI.parse(m),c=d.scheme==="file"?d:m;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(w){const m=c=>c?.map(g=>/\.vsix$/i.test(g)?C.URI.parse(g):g),d={list:w.list,install:m(w.install),uninstall:m(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",d)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&S.existsSync(this.f)&&S.unlinkSync(this.f)}}e.$cP=$;let E=class extends ${constructor(w,m){super(w,m,(0,i.$ai)())}};e.$dP=E,e.$dP=E=Le([Re(0,D.$0O),Re(1,k.$Oj)],E)}),define(Ee[300],ke([1,0,29,6,21,2,7,4,3,73,71,299,124,90,280,282,143,15,125]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=void 0;class f extends c.$PP{constructor(t,a,o,r,s){super({getFolderUri:n=>{const b=a.filter(P=>P.name===n);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(n,b)=>r[`config:${b}`],getExecPath:()=>t.VSCODE_EXEC_PATH,getAppRoot:()=>t.VSCODE_CWD,getFilePath:()=>{if(o)return C.$ic(o.fsPath)},getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber,getExtension:async n=>{const P=(await s.getInstalled()).find(I=>I.identifier.id===n);return P&&{extensionLocation:P.location}}},void 0,Promise.resolve(i.homedir()),Promise.resolve(t))}}class h extends D.$Uc{constructor(t,a,o,r,s,n){super(),this.g=t,this.h=a,this.j=o,this.m=r,this.n=s,this.r=n,this.a=0,this.b=new Map,this.c=this.B(new A.$7d),this.onExecuteCommand=this.c.event}async call(t,a,o){switch(a){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,o);case"$createProcess":{const r=(0,E.$ks)(t.remoteAuthority);return this.s(r,o)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,o);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,o);case"$listProcesses":return this.j.listProcesses.apply(this.j,o);case"$getLatency":return this.j.getLatency.apply(this.j,o);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,o);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,o);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,o);case"$start":return this.j.start.apply(this.j,o);case"$input":return this.j.input.apply(this.j,o);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,o);case"$shutdown":return this.j.shutdown.apply(this.j,o);case"$resize":return this.j.resize.apply(this.j,o);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,o);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,o);case"$getCwd":return this.j.getCwd.apply(this.j,o);case"$processBinary":return this.j.processBinary.apply(this.j,o);case"$sendCommandResult":return this.u(o[0],o[1],o[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,o);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,o);case"$getDefaultSystemShell":return this.w.apply(this,o);case"$getProfiles":return this.y.apply(this,o);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(o[0],o[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(o);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(o);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,o);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,o);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,o);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,o);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,o);case"$updateTitle":return this.j.updateTitle.apply(this.j,o);case"$updateProperty":return this.j.updateProperty.apply(this.j,o);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,o);case"$requestDetachInstance":return this.j.requestDetachInstance(o[0],o[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(o[0],o[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,o);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,o)}throw new Error(`IPC Command ${a} not found`)}listen(t,a,o){switch(a){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||A.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||A.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||A.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||A.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||A.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||A.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${a} not found`)}async s(t,a){const o={name:a.shellLaunchConfig.name,executable:a.shellLaunchConfig.executable,args:a.shellLaunchConfig.args,cwd:typeof a.shellLaunchConfig.cwd=="string"||typeof a.shellLaunchConfig.cwd>"u"?a.shellLaunchConfig.cwd:v.URI.revive(t.transformIncoming(a.shellLaunchConfig.cwd)),env:a.shellLaunchConfig.env,useShellEnvironment:a.shellLaunchConfig.useShellEnvironment,reconnectionProperties:a.shellLaunchConfig.reconnectionProperties,type:a.shellLaunchConfig.type,isFeatureTerminal:a.shellLaunchConfig.isFeatureTerminal},r=await(0,g.$bn)(a.resolverEnv,!!a.shellLaunchConfig.useShellEnvironment,k.$w,this.g,this.h,this.r);this.h.trace("baseEnv",r);const s=V=>({uri:v.URI.revive(t.transformIncoming(V.uri)),name:V.name,index:V.index,toResource:()=>{throw new Error("Not implemented")}}),n=a.workspaceFolders.map(s),b=a.activeWorkspaceFolder?s(a.activeWorkspaceFolder):void 0,P=a.activeFileResource?v.URI.revive(t.transformIncoming(a.activeFileResource)):void 0,I=new f(r,n,P,a.resolvedVariables,this.n),O=d.$LP(b,process.env,I),R=await d.$KP(o,i.homedir(),O,b?.uri,a.configuration["terminal.integrated.cwd"],this.h);o.cwd=R;const j=k.$i?"terminal.integrated.env.windows":k.$j?"terminal.integrated.env.osx":"terminal.integrated.env.linux",B=a.configuration[j],Y=await d.$MP(o,B,O,this.m.version,a.configuration["terminal.integrated.detectLocale"],r);if((0,p.$EP)(o)){const V=[];for(const[G,se,ce]of a.envVariableCollections)V.push([G,{map:(0,m.$9r)(se),descriptionMap:(0,m.$0r)(ce)}]);const T=new Map(V),x=new w.$as(T),Z=b?b??void 0:void 0;await x.applyToProcessEnvironment(Y,{workspaceFolder:Z},O)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:o,initialCwd:R,cols:a.cols,rows:a.rows,env:Y});const fe=(0,$.$ai)();Y.VSCODE_IPC_HOOK_CLI=fe;const ue=await this.j.createProcess(o,R,a.cols,a.rows,a.unicodeVersion,Y,r,a.options,a.shouldPersistTerminal,a.workspaceId,a.workspaceName),re={executeCommand:(V,...T)=>this.t(ue,V,T,t)},te=new y.$cP(re,this.h,fe);return this.j.onProcessExit(V=>V.id===ue&&te.dispose()),{persistentTerminalId:ue,resolvedShellLaunchConfig:o}}t(t,a,o,r){const{resolve:s,reject:n,promise:b}=(0,u.$bh)(),P=++this.a;this.b.set(P,{resolve:s,reject:n,uriTransformer:r});const I=(0,S.$Qn)(o,O=>{if(O&&O.$mid===1)return r.transformOutgoing(O);if(O&&O instanceof v.URI)return r.transformOutgoingURI(O)});return this.c.fire({reqId:P,persistentProcessId:t,commandId:a,commandArgs:I}),b}u(t,a,o){const r=this.b.get(t);if(!r)return;this.b.delete(t);const s=(0,S.$Qn)(o,n=>{if(n&&n.$mid===1)return r.uriTransformer.transformIncoming(n)});a?r.reject(s):r.resolve(s)}w(t){return this.j.getDefaultSystemShell(t)}async y(t,a,o,r){return this.j.getProfiles(t,a,o,r)||[]}z(){return{...process.env}}C(t,a){return this.j.getWslPath(t,a)}D(){return this.j.reduceConnectionGraceTime()}}e.$QP=h}),define(Ee[301],ke([1,0,29,6,2,12,7,102,23,45,25,118,216,82,217,26,129,31,88,121,226,127,16,113,69,68,112,83,84,122,13,58,32,48,244,142,120,28,39,258,91,265,34,126,276,277,249,256,300,71,50,284,295,131,59,133,49,33,70,257,116,130,128,115,114,210,290,240,269,262]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f,h,l,t,a,o,r,s,n,b,P,I,O,R,j,B,Y,fe,ue,re,te,V,T,x,Z,G,se,ce,ne,$e,K,q,N,z,X,ae,Q,J,U,L,H,_,ee,de,ie,me,we,Ie,Oe,ge,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=void 0,e.$iQ=Te;const Ce="monacoworkbench";async function Te(Je,pe,Pe,Ne){const Ae=new n.$gi,Me=new Ue,He={_serviceBrand:void 0,...O.default};Ae.set(R.$8j,He);const We=new q.$Zm(pe,He);Ae.set(c.$pi,We),Ae.set(c.$qi,We);const Qe=new _.$2P((0,I.$3j)(We),We.logsHome);Ae.set(I.$Pj,Qe),Me.registerChannel("logger",new me.$Vr(Qe,rt=>Ve(rt.remoteAuthority)));const it=Qe.createLogger("remoteagent",{name:(0,we.localize)(0,null)}),Ye=new ie.$_P(it,[new xe((0,I.$3j)(We))]);Ae.set(I.$Oj,Ye),setTimeout(()=>et(We.logsHome.with({scheme:D.Schemas.file}).fsPath).then(null,rt=>Ye.error(rt)),1e4),Ye.onDidChangeLogLevel(rt=>(0,I.log)(Ye,rt,`Log level changed to ${(0,I.$4j)(Ye.getLevel())}`)),Ye.trace(`Remote configuration data at ${Pe}`),Ye.trace("process arguments:",We.args),Array.isArray(He.serverGreeting)&&Ye.info(`

${He.serverGreeting.join(`
`)}

`),Me.registerChannel(w.$uo.ChannelName,new w.$uo);const nt=new $.$3h(rt=>rt.clientId==="renderer"),ot=Ne.add(new a.$uq(Ye));Ae.set(t.$Ok,ot),ot.registerProvider(D.Schemas.file,Ne.add(new o.$Vq(Ye)));const at=new Z.$js(ot);Ae.set(x.$ml,at);const ct=new y.$so(We.machineSettingsResource,ot,new L.$5n,Ye);Ae.set(E.$Oi,ct);const ht=new ee.$0P(at,We,ot,Ye);Ae.set(U.$ol,ht),Me.registerChannel("userDataProfiles",new ge.$fQ(ht,rt=>Ve(rt.remoteAuthority)));const[,,pt,Rt]=await Promise.all([ct.initialize(),ht.init(),(0,k.$rn)(Ye.error.bind(Ye)),(0,k.$sn)(Ye.error.bind(Ye))]),Dt=new X.$8m;Ae.set(X.$7m,Dt);const Pt=new Y.$Hr(ct,We,Ye,Qe);Ae.set(j.$zp,Pt);let Et=re.$0o;const St=(0,re.$dp)(He,ct);if((0,re.$$o)(He,We)){!(0,re.$_o)(He,We)&&He.aiConfig?.ariaKey&&(Et=new H.$ZP(Pt,St,Ce,null,He.aiConfig.ariaKey),Ne.add((0,S.$Sc)(()=>Et?.flush())));const rt={appenders:[Et],commonProperties:(0,fe.$2o)((0,i.release)(),(0,i.hostname)(),process.arch,He.commit,He.version+"-remote",pt,Rt,St,"remoteAgent"),piiPaths:(0,re.$ep)(We)},mt=We.args["telemetry-level"];let bt=3;mt==="all"?bt=3:mt==="error"?bt=2:mt==="crash"?bt=1:mt!==void 0&&(bt=0),Ae.set(ne.$xs,new r.$fi(ne.$vs,[rt,bt]))}else Ae.set(ne.$xs,ne.$ws);Ae.set(u.$Ro,new r.$fi(g.$Wp));const Tt=Me.getChannel("download",nt);Ae.set(m.$wo,new d.$yo(Tt,()=>Ve("renderer"))),Ae.set(J.$bq,new r.$fi(de.$$P)),Ae.set(ae.$fq,new r.$fi(Q.$XP)),Ae.set(p.$Xp,new r.$fi(p.$Yp)),Ae.set(l.$pq,new r.$fi(l.$qq));const dt=new s.$Yq(Ae);Ae.set(b.$Br,dt.createInstance(P.$Dr));const zt=dt.createInstance(Se.$hQ,{graceTime:108e5,shortGraceTime:3e5,scrollback:ct.getValue("terminal.integrated.persistentSessionScrollback")??100}),wt=dt.createInstance(T.$fs,zt);return Ae.set(V.$Qr,wt),dt.invokeFunction(rt=>{const mt=rt.get(l.$pq),bt=rt.get(ae.$fq),Kt=rt.get(u.$Ro),Wt=rt.get(b.$Br),_t=new G.$rs(Je,We,ht,Dt);Me.registerChannel("remoteextensionsenvironment",_t);const Nt=new ce.$ys(rt.get(ne.$xs),Et);Me.registerChannel("telemetry",Nt),Me.registerChannel(N.$RP,new $e.$QP(We,Ye,wt,He,mt,ct));const Bt=new Ie.$dQ(dt.createInstance(f.$Zp,Ye),We,ht,bt,Ye,Kt,Wt);Me.registerChannel(Oe.$cQ,new Ie.$eQ(Bt,kt=>Ve(kt.remoteAuthority)));const Ft=new se.$us(Ye,We);Me.registerChannel(z.$VP,Ft),Me.registerChannel("request",new B.$Er(rt.get(j.$zp)));const Gt=new h.$1p(mt,kt=>Ve(kt.remoteAuthority));return Me.registerChannel("extensions",Gt),Bt.whenExtensionsReady().then(()=>mt.cleanUp()),Ne.add(new te.default(rt.get(ue.$Nl))),{telemetryService:rt.get(ue.$Nl)}}),{socketServer:Me,instantiationService:dt}}const Fe=Object.create(null);function Ve(Je){return Fe[Je]||(Fe[Je]=(0,K.$ks)(Je)),Fe[Je]}class Ue extends $.$Yh{constructor(){const pe=new A.$7d;super(pe.event),this.b=pe}acceptConnection(pe,Pe){this.b.fire({protocol:pe,onDidClientDisconnect:Pe})}}e.$jQ=Ue;class xe extends I.$Tj{constructor(pe=I.$Rj){super(),this.setLevel(pe),this.g=!!process.stdout.isTTY}trace(pe,...Pe){this.f(I.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Xe()}]\x1B[0m`,pe,...Pe):console.log(`[${Xe()}]`,pe,...Pe))}debug(pe,...Pe){this.f(I.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Xe()}]\x1B[0m`,pe,...Pe):console.log(`[${Xe()}]`,pe,...Pe))}info(pe,...Pe){this.f(I.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Xe()}]\x1B[0m`,pe,...Pe):console.log(`[${Xe()}]`,pe,...Pe))}warn(pe,...Pe){this.f(I.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Xe()}]\x1B[0m`,pe,...Pe):console.warn(`[${Xe()}]`,pe,...Pe))}error(pe,...Pe){this.f(I.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Xe()}]\x1B[0m`,pe,...Pe):console.error(`[${Xe()}]`,pe,...Pe))}flush(){}}function Xe(){const Je=new Date;return`${_e(Je.getHours())}:${_e(Je.getMinutes())}:${_e(Je.getSeconds())}`}function _e(Je){return Je<10?`0${Je}`:String(Je)}async function et(Je){const pe=C.$oc(Je),Pe=C.$nc(Je),Me=(await v.Promises.readdir(Pe)).filter(We=>/^\d{8}T\d{6}$/.test(We)).sort().filter(We=>We!==pe),He=Me.slice(0,Math.max(0,Me.length-9));await Promise.all(He.map(We=>v.Promises.rm(C.$kc(Pe,We))))}}),define(Ee[302],ke([1,0,89,27,77,303,86,95,14,10,37,2,12,7,43,4,17,3,22,175,161,298,107,73,25,5,13,32,28,143,270,271,50,301,273]),function(le,e,i,A,S,D,C,k,v,$,E,y,w,m,d,c,g,u,p,f,h,l,t,a,o,r,s,n,b,P,I,O,R,j,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=ue;const Y=5*60*1e3;let fe=class extends y.$Uc{constructor(V,T,x,Z,G,se,ce,ne,$e){super(),this.n=V,this.r=T,this.s=x,this.t=se,this.u=ce,this.w=ne,this.y=$e,this.h=re.create(this.u),this.j=(0,w.$wg)(ce,G),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=Z?this.y.createInstance(B.$mQ,this.r,G??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(V,T){if(V.method!=="GET")return(0,B.$kQ)(V,T,405,`Unsupported method ${V.method}`);if(!V.url)return(0,B.$kQ)(V,T,400,"Bad request.");const x=C.parse(V.url,!0);let Z=x.pathname;if(!Z)return(0,B.$kQ)(V,T,400,"Bad request.");if(Z.startsWith(this.j)&&Z.charCodeAt(this.j.length)===47&&(Z=Z.substring(this.j.length)),Z==="/version")return T.writeHead(200,{"Content-Type":"text/plain"}),void T.end(this.u.commit||"");if(Z==="/delay-shutdown")return this.N(),T.writeHead(200),void T.end("OK");if(!(0,O.$jn)(this.r,V,x))return(0,B.$kQ)(V,T,403,"Forbidden.");if(Z==="/vscode-remote-resource"){const G=x.query.path;if(typeof G!="string")return(0,B.$kQ)(V,T,400,"Bad request.");let se;try{se=u.URI.from({scheme:w.Schemas.file,path:G}).fsPath}catch{return(0,B.$kQ)(V,T,400,"Bad request.")}const ce=Object.create(null);this.t.isBuilt&&((0,E.$ig)(se,this.t.builtinExtensionsPath,!c.$k)||(0,E.$ig)(se,this.t.extensionsPath,!c.$k))&&(ce["Cache-Control"]="public, max-age=31536000"),ce.Vary="Origin";const ne=V.headers.origin;return ne&&this.h.matches(ne)&&(ce["Access-Control-Allow-Origin"]=ne),(0,B.$lQ)(se,1,this.w,V,T,ce)}if(this.g){this.g.handle(V,T,x);return}return T.writeHead(404,{"Content-Type":"text/plain"}),void T.end("Not found")}handleUpgrade(V,T){let x=(0,p.$Eg)(),Z=!1,G=!1;if(V.url){const q=C.parse(V.url,!0).query;typeof q.reconnectionToken=="string"&&(x=q.reconnectionToken),q.reconnection==="true"&&(Z=!0),q.skipWebSocketFrames==="true"&&(G=!0)}if(V.headers.upgrade===void 0||V.headers.upgrade.toLowerCase()!=="websocket"){T.end("HTTP/1.1 400 Bad Request");return}const se=V.headers["sec-websocket-key"],ce=i.createHash("sha1");ce.update(se+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const $e=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ce.digest("base64")}`];let K=!1;if(!G&&!this.t.args["disable-websocket-compression"]&&V.headers["sec-websocket-extensions"]){const q=Array.isArray(V.headers["sec-websocket-extensions"])?V.headers["sec-websocket-extensions"]:[V.headers["sec-websocket-extensions"]];for(const N of q)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(N)){if(/\b(permessage-deflate)\b/.test(N)){K=!0,$e.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(N)){K=!0,$e.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}T.write($e.join(`\r
`)+`\r
\r
`),T.setTimeout(0),T.setNoDelay(!0),G?this.D(new a.$0h(T,`server-connection-${x}`),Z,x):this.D(new a.$$h(new a.$0h(T,`server-connection-${x}`),K,null,!0),Z,x)}handleServerError(V){this.w.error("Error occurred in server"),this.w.error(V)}z(V){let T;return V instanceof a.$0h?T=V.socket:T=V.socket.socket,T.remoteAddress||"<unknown>"}async C(V,T,x){const Z=T.getSocket();this.w.error(`${V} ${x}.`);const G={type:"error",reason:x};T.sendControl(v.$ue.fromString(JSON.stringify(G))),T.dispose(),await Z.drain(),Z.dispose()}D(V,T,x){const Z=this.z(V),G=`[${Z}][${x.substr(0,8)}]`,se=new t.$9h({socket:V}),ce=this.s?new this.s.validator:null,ne=this.s?new this.s.signer:null;let $e;(function(z){z[z.WaitingForAuth=0]="WaitingForAuth",z[z.WaitingForConnectionType=1]="WaitingForConnectionType",z[z.Done=2]="Done",z[z.Error=3]="Error"})($e||($e={}));let K=0;const q=z=>{K=3,N.dispose(),this.C(G,se,z)},N=se.onControlMessage(z=>{if(K===0){let X;try{X=JSON.parse(z.toString())}catch{return q("Malformed first message")}if(X.type!=="auth")return q("Invalid first message");if(this.r.type===2&&!this.r.validate(X.auth))return q("Unauthorized client refused: auth mismatch");let ae=(0,p.$Eg)();if(ne)try{ae=ne.sign(X.data)}catch{}let Q=(0,p.$Eg)();if(ce)try{Q=ce.createNewMessage(Q)}catch{}const J={type:"sign",data:Q,signedData:ae};se.sendControl(v.$ue.fromString(JSON.stringify(J))),K=1}else if(K===1){let X;try{X=JSON.parse(z.toString())}catch{return q("Malformed second message")}if(X.type!=="connectionType")return q("Invalid second message");if(typeof X.signedData!="string")return q("Invalid second message field type");const ae=X.commit,Q=this.u.commit;if(ae&&Q&&ae!==Q)return q("Client refused: version mismatch");let J=!1;if(!ce)J=!0;else if(this.r.validate(X.signedData))J=!0;else try{J=ce.validate(X.signedData)==="ok"}catch{}if(!J){if(this.t.isBuilt)return q("Unauthorized client refused");this.w.error(`${G} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const U in this.b)this.b[U].shortenReconnectionGraceTimeIfNecessary();for(const U in this.a)this.a[U].shortenReconnectionGraceTimeIfNecessary();K=2,N.dispose(),this.F(Z,G,se,V,T,x,X)}})}async F(V,T,x,Z,G,se,ce){const ne=ce.desiredConnectionType===1?`${T}[ManagementConnection]`:ce.desiredConnectionType===2?`${T}[ExtensionHostConnection]`:T;if(ce.desiredConnectionType===1)if(G){if(!this.b[se])return this.f.has(se)?this.C(ne,x,"Unknown reconnection token (seen before)"):this.C(ne,x,"Unknown reconnection token (never seen)");x.sendControl(v.$ue.fromString(JSON.stringify({type:"ok"})));const $e=x.readEntireBuffer();x.dispose(),this.b[se].acceptReconnection(V,Z,$e)}else{if(this.b[se])return this.C(ne,x,"Duplicate reconnection token");x.sendControl(v.$ue.fromString(JSON.stringify({type:"ok"})));const $e=new I.$dn(this.w,se,V,x);this.n.acceptConnection($e.protocol,$e.onClose),this.b[se]=$e,this.f.add(se),$e.onClose(()=>{delete this.b[se]})}else if(ce.desiredConnectionType===2){const $e=ce.args||{language:"en"},K=await this.I($e);if(K.port&&this.w.trace(`${ne} - startParams debug port ${K.port}`),this.w.trace(`${ne} - startParams language: ${K.language}`),this.w.trace(`${ne} - startParams env: ${JSON.stringify(K.env)}`),G){if(!this.a[se])return this.f.has(se)?this.C(ne,x,"Unknown reconnection token (seen before)"):this.C(ne,x,"Unknown reconnection token (never seen)");x.sendPause(),x.sendControl(v.$ue.fromString(JSON.stringify(K.port?{debugPort:K.port}:{})));const q=x.readEntireBuffer();x.dispose(),this.a[se].acceptReconnection(V,Z,q)}else{if(this.a[se])return this.C(ne,x,"Duplicate reconnection token");x.sendPause(),x.sendControl(v.$ue.fromString(JSON.stringify(K.port?{debugPort:K.port}:{})));const q=x.readEntireBuffer();x.dispose();const N=this.y.createInstance(P.$cn,se,V,Z,q);this.a[se]=N,this.f.add(se),N.onClose(()=>{delete this.a[se],this.J()}),N.start(K)}}else if(ce.desiredConnectionType===3){const $e=ce.args;this.G(x,$e)}else return this.C(ne,x,"Unknown initial data received")}async G(V,T){const x=V.getSocket().socket,Z=V.readEntireBuffer();V.dispose(),x.pause();const G=await this.H(T.host,T.port);Z.byteLength>0&&G.write(Z.buffer),G.on("end",()=>x.end()),G.on("close",()=>x.end()),G.on("error",()=>x.destroy()),x.on("end",()=>G.end()),x.on("close",()=>G.end()),x.on("error",()=>G.destroy()),G.pipe(x),x.pipe(G)}H(V,T){return new Promise((x,Z)=>{const G=S.createConnection({host:V,port:T,autoSelectFamily:!0},()=>{G.removeListener("error",Z),G.pause(),x(G)});G.once("error",Z)})}I(V){return typeof V.port=="number"?(0,h.$Gg)(V.port,10,5e3).then(T=>(V.port=T,V)):(V.debugId=void 0,V.port=void 0,V.break=void 0,Promise.resolve(V))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(V=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!V?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},Y))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};fe=Le([Re(5,R.$Ym),Re(6,n.$8j),Re(7,s.$Oj),Re(8,r.$hi)],fe);async function ue(te,V,T){const x=await(0,O.$in)(V);x instanceof O.$gn&&(console.warn(x.message),process.exit(1));function Z(U){(0,$.setUnexpectedErrorHandler)(L=>{(0,$.$Z)(L)&&L.stack&&/unexpectedErrorHandler/.test(L.stack)||U(L)})}const G=[];Z(U=>{G.push(U),console.error(U)});let se=!1;process.on("SIGPIPE",()=>{se||(se=!0,(0,$.$1)(new Error("Unexpected SIGPIPE")))});const ce=new y.$Tc,{socketServer:ne,instantiationService:$e}=await(0,j.$iQ)(x,V,T,ce);$e.invokeFunction(U=>{const L=U.get(s.$Oj);G.forEach(H=>L.error(H)),G.length=0,Z(H=>L.error(H))}),$e.invokeFunction(U=>{const L=U.get(o.$Oi);c.$i&&(L.getValue("security.restrictUNCAccess")===!1?(0,l.disableUNCAccessRestrictions)():(0,l.addUNCHostToAllowlist)(L.getValue("security.allowedUNCHosts")))}),$e.invokeFunction(U=>{const L=U.get(s.$Oj);if(c.$i&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const H=(0,m.$kc)(process.env.HOMEDRIVE,"node_modules"),_=(0,m.$nc)((0,m.$kc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),ee=(0,m.$kc)(_,"node_modules");if(A.existsSync(H)||A.existsSync(ee)){const de=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${H}
* ${ee}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;L.warn(de),console.warn(de),process.exit(0)}}});const K=$e.invokeFunction(U=>{const L=U.get(s.$Oj);if(A.existsSync((0,m.$kc)(w.$Cg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(_){L.error(_)}return null});let q=V["server-base-path"];q&&!q.startsWith("/")&&(q=`/${q}`);const N=A.existsSync(w.$Cg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(N&&te&&typeof te!="string"){const U=x.type!==0?`?${w.$ug}=${x.value}`:"";console.log(`Web UI available at http://localhost${te.port===80?"":`:${te.port}`}${q??""}${U}`)}const z=$e.createInstance(fe,ne,x,K,N,q);d.mark("code/server/ready");const X=D.performance.now(),ae=global.vscodeServerStartTime,Q=global.vscodeServerListenTime,J=global.vscodeServerCodeLoadedTime;if($e.invokeFunction(async U=>{const L=U.get(b.$Nl);if(L.publicLog2("serverStart",{startTime:ae,startedTime:Q,codeLoadedTime:J,readyTime:X}),c.$k){const H=U.get(s.$Oj),_=await(0,f.$Fg)(H.error.bind(H));_&&L.publicLog2("serverPlatformInfo",{platformId:_.id,platformVersionId:_.version_id,platformIdLike:_.id_like})}}),V["print-startup-performance"]){const U=k.$U.get();let L="";L+=`

### Load AMD-module
`,L+=k.$U.toMarkdownTable(["Module","Duration"],U.amdLoad),L+=`

### Load commonjs-module
`,L+=k.$U.toMarkdownTable(["Module","Duration"],U.nodeRequire),L+=`

### Invoke AMD-module factory
`,L+=k.$U.toMarkdownTable(["Module","Duration"],U.amdInvoke),L+=`

### Invoke commonjs-module
`,L+=k.$U.toMarkdownTable(["Module","Duration"],U.nodeEval),L+=`Start-up time: ${Q-ae}
`,L+=`Code loading time: ${J-ae}
`,L+=`Initialized time: ${X-ae}
`,L+=`
`,console.log(L)}return z}class re{static create(V){const T=V.webEndpointUrlTemplate,x=V.commit,Z=V.quality;if(!T||!x||!Z)return new re(null);const G=(0,p.$Eg)(),ce=new URL(T.replace("{{uuid}}",G).replace("{{commit}}",x).replace("{{quality}}",Z)).origin,ne=(0,g.$Ze)(ce).replace(G,"[a-zA-Z0-9\\-]+");try{const $e=(0,g.$9e)(`^${ne}$`,!0,{matchCase:!1});return new re($e)}catch{return new re(null)}}constructor(V){this.a=V}matches(V){return this.a?this.a.test(V):!1}}}),define(Ee[312],ke([1,0,29,27,12,297,302,67,7,303,50,58,43]),function(le,e,i,A,S,D,C,k,v,$,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=a,e.createServer=o,w.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=$.performance.now();const m={onMultipleValues:(r,s)=>{console.error(`Option '${r}' can only be defined once. Using value ${s}.`)},onEmptyValue:r=>{console.error(`Ignoring option '${r}': Value must not be empty.`)},onUnknownOption:r=>{console.error(`Ignoring option '${r}': not supported for server.`)},onDeprecatedOption:(r,s)=>{console.warn(`Option '${r}' is deprecated: ${s}`)}},d=(0,k.$fm)(process.argv.slice(2),E.$Xm,m),c=d["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.$kc)(i.homedir(),y.default.serverDataFolderName||".vscode-remote"),g=(0,v.$kc)(c,"data"),u=(0,v.$kc)(g,"User"),p=(0,v.$kc)(u,"globalStorage"),f=(0,v.$kc)(u,"History"),h=(0,v.$kc)(g,"Machine");d["user-data-dir"]=g;const l=(0,v.$nc)(S.$Cg.asFileUri("").fsPath),t=(0,v.$kc)(l,"extensions");d["builtin-extensions-dir"]=t,d["extensions-dir"]=d["extensions-dir"]||(0,v.$kc)(c,"extensions"),[c,d["extensions-dir"],g,u,h,p,f].forEach(r=>{try{A.existsSync(r)||A.mkdirSync(r,{mode:448})}catch(s){console.error(s)}});function a(){(0,D.run)(d,c,E.$Xm)}function o(r){return(0,C.$nQ)(r,d,c)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e170252f762678dec6ca2cc69aba1570769a5d39/core/vs/server/node/server.main.js.map
